campaign "translateCampaignIRQ_1"
{
	consts
	{
		raceUSA = 1;
		raceRUS = 2;
		raceIRQ = 3;

		mis1 = 0;
		mis2 = 1;
		mis3 = 2;
		mis4 = 3;
		mis5 = 4;
	}
	
	state Initialize;
    state LoadFirstMission;
    state ShowOutro;
    state EndCampaign;
	state Nothing;
	
	state Initialize
	{
		CreateGamePlayer(3, raceIRQ, playerLocal, null);

		SetTime(100);

		RegisterMission(mis1, "!MissionIRQ_1","IRQ\\Missions\\MissionIRQ_1","translateBriefingShortMissionIRQ_1", 0, 0, 0, 0, 0, 0, mis2);
		RegisterMission(mis2, "!MissionIRQ_2","IRQ\\Missions\\MissionIRQ_2","translateBriefingShortMissionIRQ_2", 0, 0, 0, 0, 0, 0, mis3);
		RegisterMission(mis3, "!MissionIRQ_3","IRQ\\Missions\\MissionIRQ_3","translateBriefingShortMissionIRQ_3", 0, 0, 0, 0, 0, 0, mis4);
		RegisterMission(mis4, "!MissionIRQ_4","IRQ\\Missions\\MissionIRQ_4","translateBriefingShortMissionIRQ_4", 0, 0, 0, 0, 0, 0, mis5);
		RegisterMission(mis5, "!MissionIRQ_5","IRQ\\Missions\\MissionIRQ_5","translateBriefingShortMissionIRQ_5", 0, 0, 0, 0, 0, 0);

		ForceKeepBitmapAfterStatistic();

        ShowMissionVideoDialog("IRQ1_Intro", null, true);
		SetLoadBitmap("Interface\\Bkg0325.tex");

		EnableGameFeature
			(
			lockResearchDialog |
			lockConstructionDialog |
			lockUpgradeWeaponDialog |
			lockAllianceDialog |
			lockGiveMoneyDialog |
			lockGiveUnitsDialog |
//			lockShowToolbar |
//			lockToolbarMap |
//			lockToolbarPanel |
			lockToolbarNextWorld |
			lockToolbarLevelName |
//			lockToolbarTunnels |
//			lockToolbarSwitchMode |
			lockToolbarResearching |
			lockToolbarConstruction |
			lockToolbarAlliance |
			lockToolbarGiveMoney |
//			lockToolbarObjectives |
//			lockToolbarMenu |
			lockToolbarMoney |
			lockToolbarEnergy |
			lockDisplayToolbarLevelName |
			lockDisplayToolbarMoney |
			lockDisplayToolbarEnergy |
			lockCreateBuildPanel |
//			lockCreatePanel |
//			lockCreateMap |
			0, true);

        return LoadFirstMission, 1;
	}

    state LoadFirstMission
    {
		LoadMission(0, mis1);

		SetAvailableWorlds(1);
		SetActivePlayerAndWorld(3,0);

        return Nothing,0;
    }

	state Nothing
	{
        return Nothing,0;
	}

    state ShowOutro
    {
        ShowMissionVideoDialog("IRQ1_Outro", null, true);

        return EndCampaign, 0;
    }

    state EndCampaign
	{
		EnableCampaign("USA\\CampaignUSA_2Disabled");
		EnableCampaign("IRQ\\CampaignIRQ_2Disabled");

		EndGame("");

        return Nothing,0;
    }

	int m_nNextMission;

	state LoadNextMission
	{
		LoadMission(0, m_nNextMission);

		return Nothing;
	}

    //wersja gdy po ostatniej misji sa statystyki
	event EndMission(int iMission, int nResult)
	{
		ForceKeepBitmapAfterStatistic();

		if (nResult == true)
		{
			if ( iMission == mis5 )
			{
                state ShowOutro;
			}
            else
            {
			    m_nNextMission = GetNextMission(iMission, 0);

		        state LoadNextMission;
            }
		}
		else
		{
	        EndGame("");

		    state Nothing;
		}
	}


	enum difficultyLevel
    {
        "translateSelectCampaignDifficultyEasy",
		"translateSelectCampaignDifficultyMedium",
		"translateSelectCampaignDifficultyHard",
        multi:
        ""
    }

    command Initialize()
    {
        difficultyLevel = 1;
    }

    command DifficultyLevel(int nLevel) button difficultyLevel
    {
    }
}
