mission "translateLessonIRQ_1"
{
	consts
	{
		goalDestroyRafinery = 0;
		goalMoveEast = 1;

		markerRafinery = 36;
		markerHero = 21;
		markerEndOfTunell = 7;
		markerTank1 = 22;
		markerTank2 = 23;

		markerPatrolPointFirst = 24;
		markerPatrolPointLast = 30;

		markerProtectedArea = 10;
	}

	state Initialize;
	state Start;
	state StartMessage;
	state ShowedEnemyBase;
	state ShowedHero;
	state ShowedHeroMessage;
	state MoveEast;
	state MovedEast;
	state MovedEastMessage;
	state DestroyRafinery;
	state DestroyedRafinery;
	state ShowedExplosion;
	state MissionComplete;

	player m_pPlayer;
	player m_pEnemyA;
	player m_pEnemyB;

	unitex m_uHero;
	unitex m_uRafinery;

	unitex m_uTank1;
	unitex m_uTank2;

	int m_nTank1MoveToPoint;
	int m_nTank2MoveToPoint;

	int m_nHeroLastHP;
	int m_bPatrolArea;

	int m_bShowedTunelsInfo;

	function int UpdateMoveToPoint(int nMoveToPoint, unitex uUnit)
	{
		if ( Distance(uUnit.GetLocationX(), uUnit.GetLocationY(), GetPointX(nMoveToPoint), GetPointY(nMoveToPoint)) <= 3 )
		{
			nMoveToPoint = nMoveToPoint + 1;

			if ( nMoveToPoint > markerPatrolPointLast )
			{
				nMoveToPoint = markerPatrolPointFirst;
			}

			uUnit.CommandMove(GetPointX(nMoveToPoint), GetPointY(nMoveToPoint), 0);

			return nMoveToPoint;
		}
		else
		{
			if ( ! uUnit.IsMoving() )
			{
				uUnit.CommandMove(GetPointX(nMoveToPoint), GetPointY(nMoveToPoint), 0);
			}

			return nMoveToPoint;
		}
	}

	event Timer0()
	{
		if ( m_bPatrolArea )
		{
			m_nTank1MoveToPoint = UpdateMoveToPoint(m_nTank1MoveToPoint, m_uTank1);
			m_nTank2MoveToPoint = UpdateMoveToPoint(m_nTank2MoveToPoint, m_uTank2);
		}
	}

	state Initialize
	{
		RegisterGoal(goalDestroyRafinery, "translateGoalLessonIRQ_1_DestroyRafinery");
		RegisterGoal(goalMoveEast, "translateGoalLessonIRQ_1_MoveEast");

		m_bPatrolArea = true;

		m_pPlayer = GetPlayer(3);
		m_pEnemyA = GetPlayer(0);
		m_pEnemyB = GetPlayer(1);

		m_pPlayer.EnableStatistics(false);
		m_pEnemyA.EnableStatistics(false);
		m_pEnemyB.EnableStatistics(false);

		m_pEnemyA.EnableAI(false);
		m_pEnemyB.EnableAI(false);

		m_uHero = GetUnit(GetPointX(markerHero), GetPointY(markerHero));
		m_uRafinery = GetUnit(GetPointX(markerRafinery), GetPointY(markerRafinery));

		m_uTank1 = GetUnit(GetPointX(markerTank1), GetPointY(markerTank1));
		m_uTank2 = GetUnit(GetPointX(markerTank2), GetPointY(markerTank2));

		m_nTank1MoveToPoint = 30;
		m_nTank2MoveToPoint = 27;

		SetTimer(0, 20); // Poruszanie czolgami

		m_pPlayer.LookAt(m_pPlayer.GetStartingPointX(), m_pPlayer.GetStartingPointY(), 6, 0, 0, 0);

		AddConsoleTextDisplay(0, 0, 100, SS_CENTER);
		AddConsoleTextDisplay(1, 0, 100, SS_CENTER);
		AddConsoleTextDisplay(2, 0, 100, SS_CENTER);
		AddConsoleTextDisplay(3, 0, 100, SS_CENTER);
		AddConsoleTextDisplay(4, 0, 100, SS_CENTER);
		AddConsoleTextDisplay(5, 0, 100, SS_CENTER);

		return Start;
	}

	state Start
	{
		EnableGoal(goalDestroyRafinery, true);
		AddBriefing("translateBriefingLessonIRQ_1_DestroyRafinery");

		CreateArtefact("ARTIFACT_GREENARROW_E" , GetPointX( 0), GetPointY( 0), GetPointZ( 0), 0);
		CreateArtefact("ARTIFACT_GREENARROW_SE", GetPointX( 1), GetPointY( 1), GetPointZ( 1), 0);
		CreateArtefact("ARTIFACT_GREENARROW_SE", GetPointX( 2), GetPointY( 2), GetPointZ( 2), 0);
		CreateArtefact("ARTIFACT_GREENARROW_E" , GetPointX( 3), GetPointY( 3), GetPointZ( 3), 0);
		CreateArtefact("ARTIFACT_GREENARROW_E" , GetPointX( 4), GetPointY( 4), GetPointZ( 4), 0);
		CreateArtefact("ARTIFACT_GREENARROW_E" , GetPointX( 5), GetPointY( 5), GetPointZ( 5), 0);
		CreateArtefact("ARTIFACT_GREENARROW_E" , GetPointX( 6), GetPointY( 6), GetPointZ( 6), 0);
		CreateArtefact("ARTIFACT_GREENARROW_N" , GetPointX( 7), GetPointY( 7), GetPointZ( 7), 0);
		CreateArtefact("ARTIFACT_GREENARROW_N" , GetPointX( 8), GetPointY( 8), GetPointZ( 8), 0);
		CreateArtefact("ARTIFACT_GREENARROW_N" , GetPointX( 9), GetPointY( 9), GetPointZ( 9), 0);
		CreateArtefact("ARTIFACT_GREENARROW_N" , GetPointX(10), GetPointY(10), GetPointZ(10), 0);
		CreateArtefact("ARTIFACT_GREENARROW_NW", GetPointX(11), GetPointY(11), GetPointZ(11), 0);
		CreateArtefact("ARTIFACT_GREENARROW_W" , GetPointX(12), GetPointY(12), GetPointZ(12), 0);
		CreateArtefact("ARTIFACT_GREENARROW_W" , GetPointX(13), GetPointY(13), GetPointZ(13), 0);
		CreateArtefact("ARTIFACT_GREENARROW_W" , GetPointX(14), GetPointY(14), GetPointZ(14), 0);
		CreateArtefact("ARTIFACT_GREENARROW_W" , GetPointX(15), GetPointY(15), GetPointZ(15), 0);
		CreateArtefact("ARTIFACT_GREENARROW_N" , GetPointX(16), GetPointY(16), GetPointZ(16), 0);
		CreateArtefact("ARTIFACT_GREENARROW_NE", GetPointX(17), GetPointY(17), GetPointZ(17), 0);
		CreateArtefact("ARTIFACT_GREENARROW_E" , GetPointX(18), GetPointY(18), GetPointZ(18), 0);
		CreateArtefact("ARTIFACT_GREENARROW_N" , GetPointX(19), GetPointY(19), GetPointZ(19), 0);
		CreateArtefact("ARTIFACT_REDARROW_W"   , GetPointX(20), GetPointY(20), GetPointZ(20), 0);

		CreateArtefact("ARTIFACT_CLICK_ME", GetPointX(37), GetPointY(37), 0, 0);
		CreateArtefact("ARTIFACT_CLICK_ME", GetPointX(38), GetPointY(38), 0, 0);
		CreateArtefact("ARTIFACT_CLICK_ME", GetPointX(39), GetPointY(39), 0, 0);
		CreateArtefact("ARTIFACT_CLICK_ME", GetPointX(40), GetPointY(40), 0, 0);
		CreateArtefact("ARTIFACT_CLICK_ME", GetPointX(41), GetPointY(41), 0, 0);
		CreateArtefact("ARTIFACT_CLICK_ME", GetPointX(42), GetPointY(42), 0, 0);

		ShowArea(m_pPlayer.GetIFF(), GetPointX(markerRafinery), GetPointY(markerRafinery), 0, 15, showAreaPassives|showAreaBuildings|showAreaUnits);
        m_pPlayer.DelayedLookAt(GetPointX(markerRafinery), GetPointY(markerRafinery), 20, -1, 0, 0, 100, 1);

		return StartMessage,1;
	}

	state StartMessage
	{
		EnableInterface(false);

		SetConsoleText(0, "translateMessageLessonIRQ_1_Info_Line1");
		SetConsoleText(1, "translateMessageLessonIRQ_1_Info_Line2");
		SetConsoleText(2, "translateMessageLessonIRQ_1_Info_Line3");
		SetConsoleText(3, "translateMessageLessonIRQ_1_Info_Line4");
		SetConsoleText(4, "translateMessageLessonIRQ_1_Info_Line5");
		SetConsoleText(5, "translateMessageLessonIRQ_1_Info_Line6");

		PlayWave("Tutorials\\IRQ_Tutorial01_01.wav");

		return ShowedEnemyBase, 340;
	}

	state ShowedEnemyBase
	{
        m_pPlayer.DelayedLookAt(m_uHero.GetLocationX(), m_uHero.GetLocationY(), 6, -1, 0, 0, 100, 1);

		SetConsoleText(0, "translateMessageLessonIRQ_1_CamouflageInfo_Line1");
		SetConsoleText(1, "translateMessageLessonIRQ_1_CamouflageInfo_Line2");
		SetConsoleText(2, "translateMessageLessonIRQ_1_CamouflageInfo_Line3");
		SetConsoleText(3, "translateMessageLessonIRQ_1_CamouflageInfo_Line4");
		SetConsoleText(4, "translateMessageLessonIRQ_1_CamouflageInfo_Line5");
		SetConsoleText(5, "translateMessageLessonIRQ_1_CamouflageInfo_Line6");

		PlayWave("Tutorials\\IRQ_Tutorial01_02.wav");

		return ShowedHero, 200;
	}

	state ShowedHero
	{
		EnableInterface(true);

		EnableGoal(goalMoveEast, true);
		SetConsoleText(0, "translateMessageLessonIRQ_1_GoEast_Line1");
		SetConsoleText(1, "translateMessageLessonIRQ_1_GoEast_Line2");
		SetConsoleText(2, "translateMessageLessonIRQ_1_GoEast_Line3");
		SetConsoleText(3, "translateMessageLessonIRQ_1_GoEast_Line4");
		SetConsoleText(4, "translateMessageLessonIRQ_1_GoEast_Line5");
		SetConsoleText(5, "translateMessageLessonIRQ_1_GoEast_Line6");

		PlayWave("Tutorials\\IRQ_Tutorial01_03.wav");

		m_bShowedTunelsInfo = false;

		return ShowedHeroMessage, 160;
	}

	state ShowedHeroMessage
	{
		AddBriefing("translateBriefingLessonIRQ_1_MoveEast");

		return MoveEast;
	}

	state MoveEast
	{
		if ( !m_bShowedTunelsInfo && m_uHero.GetLocationZ() == 1 )
		{
			m_bShowedTunelsInfo = true;

			AddBriefing("translateBriefingLessonIRQ_1_TunelsInfo");
		}

		if ( Distance(m_uHero.GetLocationX(), m_uHero.GetLocationY(), GetPointX(markerEndOfTunell), GetPointY(markerEndOfTunell)) <= 1 )
		{
			return MovedEast;
		}
		else
		{
			return MoveEast;
		}
	}

	state MovedEast
	{
		SetGoalState(goalMoveEast, goalAchieved);

		SetConsoleText(0, "translateMessageLessonIRQ_1_UseCamouflage_Line1");
		SetConsoleText(1, "translateMessageLessonIRQ_1_UseCamouflage_Line2");
		SetConsoleText(2, "translateMessageLessonIRQ_1_UseCamouflage_Line3");
		SetConsoleText(3, "translateMessageLessonIRQ_1_UseCamouflage_Line4");
		SetConsoleText(4, "translateMessageLessonIRQ_1_UseCamouflage_Line5");
		SetConsoleText(5, "translateMessageLessonIRQ_1_UseCamouflage_Line6");

		PlayWave("Tutorials\\IRQ_Tutorial01_04.wav");

		m_nHeroLastHP = m_uHero.GetHP();

		return MovedEastMessage, 200;
	}

	state MovedEastMessage
	{
		AddBriefing("translateBriefingLessonIRQ_1_SiegeInfo");

		return DestroyRafinery;
	}

	state DestroyRafinery
	{
		if ( m_uHero.GetHP() < m_nHeroLastHP )
		{
			m_nHeroLastHP = m_uHero.GetHP();

			if ( m_uHero.GetLocationY() <= GetPointY(markerProtectedArea) )
			{
				m_bPatrolArea = false;

				m_uTank1.CommandAttack(m_uHero);
				m_uTank2.CommandAttack(m_uHero);
			}
		}

		if ( ! m_uRafinery.IsLive() )
		{
			return DestroyedRafinery;
		}
		else
		{
			return DestroyRafinery;
		}

	}

	state DestroyedRafinery
	{
//		m_bPatrolArea = false;

//		m_uTank1.CommandStop();
//		m_uTank2.CommandStop();

        m_pPlayer.DelayedLookAt(GetPointX(markerRafinery), GetPointY(markerRafinery), 40, -1, 0, 0, 10, 1);

		SetGoalState(goalDestroyRafinery, goalAchieved);

		return ShowedExplosion, 400;
	}

	state ShowedExplosion
	{
		AddBriefing("translateBriefingLessonIRQ_1_MissionComplete");

		return MissionComplete;
	}

	state MissionComplete
	{
		EndMission(true);
	}

	event UnitDestroyed(unit uUnit)
	{
		if ( uUnit == m_uHero )
		{
			AddBriefing("translateBriefingLessonIRQ_1_MissionFail");

			state MissionComplete;
		}
	}

	event SetupInterface()
	{
		EnableGameFeature
			(
			lockResearchDialog |
			lockConstructionDialog |
			lockUpgradeWeaponDialog |
			lockAllianceDialog |
			lockGiveMoneyDialog |
			lockGiveUnitsDialog |
//			lockShowToolbar |
			lockToolbarMap |
			lockToolbarPanel |
			lockToolbarNextWorld |
			lockToolbarLevelName |
//			lockToolbarTunnels |
//			lockToolbarSwitchMode |
			lockToolbarResearching |
			lockToolbarConstruction |
			lockToolbarAlliance |
			lockToolbarGiveMoney |
//			lockToolbarObjectives |
//			lockToolbarMenu |
			lockToolbarMoney |
			lockToolbarEnergy |
			lockDisplayToolbarLevelName |
			lockDisplayToolbarMoney |
			lockDisplayToolbarEnergy |
			lockCreateBuildPanel |
//			lockCreatePanel |
//			lockCreateMap |
			0, true);
	}
}
