mission "translateMissionIRQ_6"
{
	consts
	{
		goalEscortTruck = 0;

		markerTruck = 0;

		markerFriendlyUnitA1 = 1;
		markerFriendlyUnitA2 = 2;
		markerFriendlyUnitA3 = 3;

		markerFriendlyUnitB1 = 4;
		markerFriendlyUnitB2 = 5;
		markerFriendlyUnitB3 = 6;
		markerFriendlyUnitB4 = 7;

/*
		markerFriendlyUnitC1 = 8;
		markerFriendlyUnitC2 = 9;
		markerFriendlyUnitC3 = 10;
		markerFriendlyUnitC4 = 11;
		markerFriendlyUnitC5 = 12;
		markerFriendlyUnitC6 = 13;
		markerFriendlyUnitC7 = 14;
		markerFriendlyUnitC8 = 15;
*/
	}

	include "Research.ech"

	player m_pPlayer;
	player m_pFriend;

	player m_pEnemyA;
	player m_pEnemyB;
	player m_pEnemyC;

	unitex m_uFriendlyUnitA1;
	unitex m_uFriendlyUnitA2;
	unitex m_uFriendlyUnitA3;

	unitex m_uFriendlyUnitB1;
	unitex m_uFriendlyUnitB2;
	unitex m_uFriendlyUnitB3;
	unitex m_uFriendlyUnitB4;

	unitex m_uFriendlyUnitC1;
	unitex m_uFriendlyUnitC2;
	unitex m_uFriendlyUnitC3;
	unitex m_uFriendlyUnitC4;
	unitex m_uFriendlyUnitC5;
	unitex m_uFriendlyUnitC6;
	unitex m_uFriendlyUnitC7;
	unitex m_uFriendlyUnitC8;

	unitex m_uTruck;

	int m_bCheckNumberOfUnits;
	int m_bCheckNumberOfBuildings;

	state Initialize;
	state Start;
	state BeforeStart;
	state EscortTruck;
	state EscortedTruck;
	state DestroyedTruck;
	state MissionFail;
	state MissionComplete;

	function int CheckFriendlyUnits(int nStartPoint, int nEndPoint)
	{
		int i;
		int nGx, nGy, nLz;
		unitex uTmp;

		i=nStartPoint;
		for (i=nStartPoint; i<=nEndPoint; i=i+1)
		{
			nGx = GetPointX(i);
			nGy = GetPointY(i);
			nLz = GetPointZ(i);

			if ( m_pPlayer.IsPointLocated(nGx, nGy, nLz) )
			{
				uTmp = GetUnit(nGx, nGy, nLz);

				if ( uTmp != null && uTmp.GetIFF() == m_pFriend.GetIFF() )
				{
					uTmp.ChangePlayer(m_pPlayer);
				}
			}
		}

		return true;
	}

	int m_nFullTime;

	function int UpdateTime()
	{
		int nMin, nSec;

		nMin = (((10000*m_nFullTime - GetMissionTime())%m_nFullTime) / 20) / 60;
		nSec = (((10000*m_nFullTime - GetMissionTime())%m_nFullTime) / 20) % 60;

		if ( nSec < 10 )
		{
			SetConsoleText(0, "<%0>:0<%1>", nMin, nSec);
		}
		else
		{
			SetConsoleText(0, "<%0>:<%1>", nMin, nSec);
		}

		if ( nMin == 0 && nSec == 0 )
		{
			if ( state != MissionComplete && m_uTruck.GetLocationZ() != 1 )
			{
				KillArea(65535, m_uTruck.GetLocationX(), m_uTruck.GetLocationY(), m_uTruck.GetLocationZ(), 10);
			}
		}
	}

	function int SetMovementMode(int nPoint, int nMode)
	{
		unitex uTmp;

		uTmp = GetUnit(GetPointX(nPoint), GetPointY(nPoint));

		uTmp.CommandSetMovementMode(nMode);
	}

	function int ClearMarkers(int nStartPoint, int nEndPoint)
	{
		int i;

		for ( i=nStartPoint; i<=nEndPoint; i=i+1 )
		{
			ClearArea (65535, GetPointX(i), GetPointY(i), GetPointZ(i), 0);
		}
	}

	function int ModifyDifficulty()
	{
		if ( GetDifficultyLevel() == 0 )
		{
			ClearMarkers(19, 19);
			ClearMarkers(21, 21);
			SetMovementMode(22, 2); // hold position
			ClearMarkers(23, 34);
			ClearMarkers(37, 41);
			ClearMarkers(44, 47);
		}
		else if ( GetDifficultyLevel() == 1 )
		{
			ClearMarkers(20, 21);
			SetMovementMode(22, 2); // hold position
			SetMovementMode(23, 2); // hold position
			ClearMarkers(24, 26);
			ClearMarkers(28, 29);
			ClearMarkers(31, 31);
			ClearMarkers(34, 36);
			ClearMarkers(38, 38);
			ClearMarkers(44, 44);
			ClearMarkers(46, 46);
		}
		else if ( GetDifficultyLevel() == 2 )
		{
			SetMovementMode(19, 1); // follow enemy
			SetMovementMode(20, 1); // follow enemy
			ClearMarkers(22, 23);
			SetMovementMode(24, 2); // hold position
			SetMovementMode(25, 2); // hold position
			ClearMarkers(27, 27);
			ClearArea	(65535, GetPointX(30), GetPointY(30), GetPointZ(30), 1);
			ClearMarkers(32, 33);
			ClearMarkers(36, 36);
			ClearMarkers(39, 39);
			ClearMarkers(40, 41);
			ClearArea	(65535, GetPointX(42), GetPointY(42), GetPointZ(42), 1);
			ClearMarkers(43, 43);
			ClearMarkers(47, 47);
		}
	}

	state Initialize
	{
		ModifyDifficulty();

		m_nFullTime = 3*20*60 - (30*20*GetDifficultyLevel());

		RegisterGoal(goalEscortTruck, "translateGoalMissionIRQ_6_EscortTruck");

		m_pPlayer = GetPlayer(3);
		m_pPlayer.EnableStatistics(false);
		m_pFriend = GetPlayer(4);
		m_pFriend.EnableStatistics(false);

		m_pEnemyA = GetPlayer(0);
		m_pEnemyA.EnableStatistics(false);
		m_pEnemyB = GetPlayer(1);
		m_pEnemyB.EnableStatistics(false);
		m_pEnemyC = GetPlayer(2);
		m_pEnemyC.EnableStatistics(false);

		m_pEnemyA.EnableAI(false);
		m_pEnemyB.EnableAI(false);
		m_pEnemyC.EnableAI(false);

		m_pFriend.EnableAI(false);
		m_pFriend.EnableAIFeatures2(ai2ChooseEnemy, false);

		m_pFriend.SetNeutral(m_pPlayer);
		m_pPlayer.SetNeutral(m_pFriend);

		m_uTruck = GetUnit(GetPointX(markerTruck), GetPointY(markerTruck));

		m_pPlayer.SetMoney(0);

		m_pPlayer.LookAt(m_pPlayer.GetStartingPointX(), m_pPlayer.GetStartingPointY(), 6, 0, 0, 0);

		EnableAllResearchIRQ( m_pPlayer, false);
		m_pPlayer.EnableResearch("RES_IRQ_TANK1", true);			// M1
		m_pPlayer.EnableResearch("RES_IRQ_HELICOPTER1", true);		// M2
		m_pPlayer.EnableResearch("RES_IRQ_AMMO_MG1", true);			// M3
		m_pPlayer.EnableResearch("RES_IRQ_PILLBOX", true);			// M3
		m_pPlayer.EnableResearch("RES_IRQ_TANK2", true);			// M3
		m_pPlayer.EnableResearch("RES_IRQ_SAPER", true);			// M3
		m_pPlayer.EnableResearch("RES_IRQ_MIM", true);				// M3
		m_pPlayer.EnableResearch("RES_IRQ_AMMO_MG2", true);			// M4
		m_pPlayer.EnableResearch("RES_IRQ_RART", true);				// M4
		m_pPlayer.EnableResearch("RES_IRQ_HRART", true);			// M4
		m_pPlayer.EnableResearch("RES_IRQ_AMMO_MIM1", true);		// M4
		m_pPlayer.EnableResearch("RES_IRQ_SPECIAL_FILTER2", true);	// M4
		m_pPlayer.EnableResearch("RES_IRQ_AMMO_CANNON1", true);		// M5
		m_pPlayer.EnableResearch("RES_IRQ_BIGART", true);			// M5
		m_pPlayer.EnableResearch("RES_IRQ_AMMO_ROCKET1", true);		// M5
		m_pPlayer.EnableResearch("RES_IRQ_AMMO_HROCKET1", true);	// M5
		m_pPlayer.EnableResearch("RES_IRQ_MGM", true);				// M5
		m_pPlayer.EnableResearch("RES_IRQ_EXPLODER", true);			// M5
		m_pPlayer.EnableResearch("RES_IRQ_AMMO_CANNON2", true);
		m_pPlayer.EnableResearch("RES_IRQ_AMMO_ROCKET2", true);
		m_pPlayer.EnableResearch("RES_IRQ_AMMO_HROCKET2", true);
		m_pPlayer.EnableResearch("RES_IRQ_AMMO_MIM2", true);
		m_pPlayer.EnableResearch("RES_IRQ_JEEP_MGM", true);
		m_pPlayer.EnableResearch("RES_IRQ_SPECIAL_FILTER2", true);

		SetTimer(0, 80); // CheckFriendlyUnits
		SetTimer(1, 10); // UpdateTime

		AddConsoleTextDisplay(1, 0, 100, SS_CENTER);

		m_pPlayer.EnableCommand(commandRecycleUnit, false);
		m_pPlayer.EnableCommand(commandSoldBuilding, false);

		return BeforeStart, 1;
	}

	state BeforeStart
	{
		PlayTrack("Music\\Briefing.tws");

		return Start;
	}

	state Start
	{
		EnableGoal(goalEscortTruck, true);
		AddBriefing("translateBriefingMissionIRQ_6_EscortTruck");
		PlayWave("Briefings\\IRQ_Briefing06.wav");

		AddWorldMapSign(m_pFriend.GetStartingPointX(), m_pFriend.GetStartingPointY(), 0, 0, 65000);

		return EscortTruck;
	}

	state EscortTruck
	{
//		CheckFriendlyUnits(markerFriendlyUnitA1, markerFriendlyUnitC8);

		if ( Distance(m_uTruck.GetLocationX(), m_uTruck.GetLocationY(), m_pFriend.GetStartingPointX(), m_pFriend.GetStartingPointY()) <= 10 )
		{
			return EscortedTruck;
		}
		else
		{
			return EscortTruck;
		}
	}

	state EscortedTruck
	{
		SetGoalState(goalEscortTruck, goalAchieved);

		SetConsoleText(0, "");

		AddBriefing("translateBriefingMissionIRQ_6_MissionComplete");

		RemoveWorldMapSign(m_pFriend.GetStartingPointX(), m_pFriend.GetStartingPointY(), 0);

		EnableEndMissionButton(true, true);

		return MissionComplete;
	}

	state DestroyedTruck
	{
		return MissionFail, 40;
	}

	state MissionFail
	{
		SetConsoleText(0, "");

		SetGoalState(goalEscortTruck, goalFailed);

		AddBriefing("translateBriefingMissionIRQ_6_MissionFail");

		EnableEndMissionButton(true, false);

		return MissionComplete;
	}

	state MissionComplete
	{
		return MissionComplete;
	}

	event UnitDestroyed(unit uUnit)
	{
		m_bCheckNumberOfUnits = true;

		if ( uUnit == m_uTruck )
		{
			state DestroyedTruck;
		}
	}

	event BuildingDestroyed(unit uBuilding)
	{
		m_bCheckNumberOfBuildings = true;
	}

	event Timer0()
	{
		CheckFriendlyUnits(markerFriendlyUnitA1, markerFriendlyUnitB4);
	}

	event Timer1()
	{
		if ( state == EscortTruck )
		{
			UpdateTime();
		}
	}

	event EndMission()
	{
		m_pPlayer.EnableCommand(commandRecycleUnit, true);
		m_pPlayer.EnableCommand(commandSoldBuilding, true);
	}

	event SetupInterface()
	{
		EnableGameFeature
			(
			lockResearchDialog |
			lockToolbarResearching |
			lockToolbarMoney |
			lockDisplayToolbarMoney |
			lockCreateBuildPanel |
			0, true);
	}
}
