mission "translateMissionIRQ_1"
{
	consts
	{
		goalCaptureCars = 0;
		goalFindMexican = 1;
		goalCaptureHummers = 2;
		goalEvacuateUnits = 3;

		markerHero = 0;
		markerTruck = 1;

		markerCivilCarA1 = 2;
		markerCivilCarA2 = 3;
		markerCivilCarB1 = 4;
		markerCivilCarB2 = 5;

		markerHummer1 = 6;
		markerHummer2 = 7;
		markerHummer3 = 8;
		markerHummer4 = 9;

		markerPoliceCar1 = 13;
		markerPoliceCar2 = 20;
		markerPoliceCar3 = 25;
		markerPoliceCar4 = 30;
		markerPoliceCar5 = 36;
		markerPoliceCar6 = 42;
		markerPoliceCar7 = 47;
		markerPoliceCar8 = 54;
		markerPoliceCar9 = 65;
		markerPoliceCar10 = 72;

		markerMexican = 10;

		markerFactoryAreaFrom = 11;
		markerFactoryAreaTo = 12;

		markerParkingAreaFrom = 45;
		markerParkingAreaTo = 46;

		idMexican = 12345;

        timeEndNight = 70;
        timeStartNight = 210;
	}

	include "Research.ech"
	include "Varia.ech"

	player m_pPlayer;

	player m_pEnemy;
	player m_pCivilUnits;
	player m_pEnemyUnits;

	unitex m_uHero;
	unitex m_uTruck;

	unitex m_uCivilCarA1;
	unitex m_uCivilCarA2;
	unitex m_uCivilCarB1;
	unitex m_uCivilCarB2;

	unitex m_uHummer1;
	unitex m_uHummer2;
	unitex m_uHummer3;
	unitex m_uHummer4;

	unitex m_uPoliceCar1;
	unitex m_uPoliceCar2;
	unitex m_uPoliceCar3;
	unitex m_uPoliceCar4;
	unitex m_uPoliceCar5;
	unitex m_uPoliceCar6;
	unitex m_uPoliceCar7;
	unitex m_uPoliceCar8;
	unitex m_uPoliceCar9;
	unitex m_uPoliceCar10;

	int m_bCheckNumberOfUnits;
	int m_bCheckNumberOfBuildings;

	int m_bCapturedCarsA;
	int m_bCapturedCarsB;

	int m_bCheckTruck;

	state Initialize;
	state Start;
	state BeforeStart;
	state CaptureCars;
	state CapturedCars;
	state FindMexican;
	state FoundMexican;
	state CaptureHummers;
	state CapturedHummers;
	state DetectedByHummers;
	state EvacuateUnits;
	state EvacuatedUnits;
	state MissionComplete;

	function int ModifyDifficulty()
	{
		if ( GetDifficultyLevel() == 0 )
		{
			ClearArea	(65535, GetPointX(47), GetPointY(47), GetPointZ(47), 0);
			ClearArea	(65535, GetPointX(54), GetPointY(54), GetPointZ(54), 0);
			ClearArea	(65535, GetPointX(65), GetPointY(65), GetPointZ(65), 0);
			ClearArea	(65535, GetPointX(72), GetPointY(72), GetPointZ(72), 0);
		}
		else if ( GetDifficultyLevel() == 1 )
		{
			ClearArea	(65535, GetPointX(47), GetPointY(47), GetPointZ(47), 0);
			ClearArea	(65535, GetPointX(72), GetPointY(72), GetPointZ(72), 0);
		}
		else if ( GetDifficultyLevel() == 2 )
		{
		}
	}

	state Initialize
	{
		ModifyDifficulty();

		RegisterGoal(goalCaptureCars, "translateGoalMissionIRQ_1_CaptureCars");
		RegisterGoal(goalFindMexican, "translateGoalMissionIRQ_1_FindMexican");
		RegisterGoal(goalCaptureHummers, "translateGoalMissionIRQ_1_CaptureHummers");
		RegisterGoal(goalEvacuateUnits, "translateGoalMissionIRQ_1_EvacuateUnits");

		SetTime(150);

		m_pPlayer = GetPlayer(3);
		m_pPlayer.EnableStatistics(false);

		m_pEnemy = GetPlayer(0);
		m_pEnemy.EnableStatistics(false);

		m_pCivilUnits = GetPlayer(1);
		m_pCivilUnits.EnableStatistics(false);

		m_pEnemyUnits = GetPlayer(4);
		m_pEnemyUnits.EnableStatistics(false);

		m_pEnemy.EnableAI(false);
		m_pCivilUnits.EnableAI(false);
		m_pEnemyUnits.EnableAI(false);

		m_uHero = GetUnit(GetPointX(markerHero), GetPointY(markerHero));
		m_uTruck = GetUnit(GetPointX(markerTruck), GetPointY(markerTruck));

		m_bCheckTruck = true;

		m_uCivilCarA1 = GetUnit(GetPointX(markerCivilCarA1), GetPointY(markerCivilCarA1));
		m_uCivilCarA2 = GetUnit(GetPointX(markerCivilCarA2), GetPointY(markerCivilCarA2));
		m_uCivilCarB1 = GetUnit(GetPointX(markerCivilCarB1), GetPointY(markerCivilCarB1));
		m_uCivilCarB2 = GetUnit(GetPointX(markerCivilCarB2), GetPointY(markerCivilCarB2));

		m_uHummer1 = GetUnit(GetPointX(markerHummer1), GetPointY(markerHummer1));
		m_uHummer2 = GetUnit(GetPointX(markerHummer2), GetPointY(markerHummer2));
		m_uHummer3 = GetUnit(GetPointX(markerHummer3), GetPointY(markerHummer3));
		m_uHummer4 = GetUnit(GetPointX(markerHummer4), GetPointY(markerHummer4));

		m_uPoliceCar1 = GetUnit(GetPointX(markerPoliceCar1), GetPointY(markerPoliceCar1));
		m_uPoliceCar2 = GetUnit(GetPointX(markerPoliceCar2), GetPointY(markerPoliceCar2));
		m_uPoliceCar3 = GetUnit(GetPointX(markerPoliceCar3), GetPointY(markerPoliceCar3));
		m_uPoliceCar4 = GetUnit(GetPointX(markerPoliceCar4), GetPointY(markerPoliceCar4));
		m_uPoliceCar5 = GetUnit(GetPointX(markerPoliceCar5), GetPointY(markerPoliceCar5));
		m_uPoliceCar6 = GetUnit(GetPointX(markerPoliceCar6), GetPointY(markerPoliceCar6));
		m_uPoliceCar7 = GetUnit(GetPointX(markerPoliceCar7), GetPointY(markerPoliceCar7));
		m_uPoliceCar8 = GetUnit(GetPointX(markerPoliceCar8), GetPointY(markerPoliceCar8));
		m_uPoliceCar9 = GetUnit(GetPointX(markerPoliceCar9), GetPointY(markerPoliceCar9));
		m_uPoliceCar10 = GetUnit(GetPointX(markerPoliceCar10), GetPointY(markerPoliceCar10));

		m_pPlayer.LookAt(m_pPlayer.GetStartingPointX(), m_pPlayer.GetStartingPointY(), 6, 0, 0, 0);

		EnableAllResearchIRQ( m_pPlayer, false);
		m_pPlayer.EnableResearch("RES_IRQ_TANK1", true);

		m_pPlayer.EnableCommand(commandRecycleUnit, false);
		m_pPlayer.EnableCommand(commandSoldBuilding, false);

		return BeforeStart, 1;
	}

	state BeforeStart
	{
		PlayTrack("Music\\Briefing.tws");

		return Start;
	}

	state Start
	{
		m_pCivilUnits.SetNeutral(m_pPlayer);
		m_pPlayer.SetNeutral(m_pCivilUnits);

		m_pEnemyUnits.SetNeutral(m_pPlayer);
		m_pPlayer.SetNeutral(m_pEnemyUnits);

		EnableGoal(goalCaptureCars, true);
		AddBriefing("translateBriefingMissionIRQ_1_CaptureCars");
		PlayWave("Briefings\\IRQ_Briefing01.wav");

		Patrol(m_uPoliceCar1, 14, 19);
		Patrol(m_uPoliceCar2, 21, 24);
		Patrol(m_uPoliceCar3, 26, 29);
		Patrol(m_uPoliceCar4, 31, 35);
		Patrol(m_uPoliceCar5, 37, 41);
		Patrol(m_uPoliceCar6, 43, 44);

		if ( GetDifficultyLevel() > 0 )
		{
			Patrol(m_uPoliceCar8, 55, 64);
			Patrol(m_uPoliceCar9, 66, 71);
		}

		if ( GetDifficultyLevel() > 1 )
		{
			Patrol(m_uPoliceCar7 , 48, 53);
			Patrol(m_uPoliceCar10, 73, 82);
		}

		m_bCapturedCarsA = false;
		m_bCapturedCarsB = false;

		AddWorldMapSign((GetPointX(markerParkingAreaFrom)+GetPointX(markerParkingAreaTo))/2, (GetPointY(markerParkingAreaFrom)+GetPointY(markerParkingAreaTo))/2, 0, 0, 65000);

		return CaptureCars;
	}

	state CaptureCars
	{
		if ( !m_bCapturedCarsA && IsUnitInArea(m_uHero, markerParkingAreaFrom, markerParkingAreaTo) )
		{
			m_bCapturedCarsA = true;

			m_uCivilCarA1.ChangePlayer(m_pPlayer);
			m_uCivilCarA2.ChangePlayer(m_pPlayer);

			if ( !m_bCapturedCarsB )
			{
				AddBriefing("translateBriefingMissionIRQ_1_CaptureMoreCars");
			}
		}

		if ( !m_bCapturedCarsB && IsUnitInArea(m_uTruck, markerParkingAreaFrom, markerParkingAreaTo) )
		{
			m_bCapturedCarsB = true;

			m_uCivilCarB1.ChangePlayer(m_pPlayer);
			m_uCivilCarB2.ChangePlayer(m_pPlayer);

			m_bCheckTruck = false;

			m_uTruck.ChangePlayer(m_pCivilUnits);

			if ( !m_bCapturedCarsA )
			{
				AddBriefing("translateBriefingMissionIRQ_1_CaptureMoreCars");
			}
		}

		if ( m_bCapturedCarsA && m_bCapturedCarsB )
		{
			return CapturedCars;
		}
		else
		{
			return CaptureCars;
		}
	}

	state CapturedCars
	{
		SetGoalState(goalCaptureCars, goalAchieved);

		RemoveWorldMapSign((GetPointX(markerParkingAreaFrom)+GetPointX(markerParkingAreaTo))/2, (GetPointY(markerParkingAreaFrom)+GetPointY(markerParkingAreaTo))/2, 0);

		EnableGoal(goalFindMexican, true);
		AddBriefing("translateBriefingMissionIRQ_1_FindMexican");

		CreateArtefact("ARTIFACT_MEXICAN", GetPointX(markerMexican), GetPointY(markerMexican), 0, idMexican);

		AddWorldMapSign(GetPointX(markerMexican), GetPointY(markerMexican), 0, 0, 65000);

		return FindMexican;
	}

	state FindMexican
	{
		return FindMexican;
	}

	state FoundMexican
	{
		RemoveWorldMapSign(GetPointX(markerMexican), GetPointY(markerMexican), 0);

		SetGoalState(goalFindMexican, goalAchieved);

		EnableGoal(goalCaptureHummers, true);
		AddBriefing("translateBriefingMissionIRQ_1_CaptureHummers");

		AddWorldMapSign(m_pEnemyUnits.GetStartingPointX(), m_pEnemyUnits.GetStartingPointY(), 0, 0, 65000);

		return CaptureHummers;
	}

	state CaptureHummers
	{
		if ( GetTime() < timeEndNight || GetTime() > timeStartNight )
		{
			if ( Distance(m_uHero.GetLocationX(), m_uHero.GetLocationY(), m_pEnemyUnits.GetStartingPointX(), m_pEnemyUnits.GetStartingPointY()) <= 5)
			{
				return CapturedHummers;
			}
		}
		else
		{
			if ( m_pPlayer.IsPointLocated(m_pEnemyUnits.GetStartingPointX(), m_pEnemyUnits.GetStartingPointY()) )
			{
				return DetectedByHummers;
			}
		}
	}

	state CapturedHummers
	{
		RemoveWorldMapSign(m_pEnemyUnits.GetStartingPointX(), m_pEnemyUnits.GetStartingPointY(), 0);

		m_uHummer1.ChangePlayer(m_pPlayer);
		m_uHummer2.ChangePlayer(m_pPlayer);
		m_uHummer3.ChangePlayer(m_pPlayer);
		m_uHummer4.ChangePlayer(m_pPlayer);

		SetGoalState(goalCaptureHummers, goalAchieved);

		EnableGoal(goalEvacuateUnits, true);
		AddBriefing("translateBriefingMissionIRQ_1_EvacuateUnits");

		AddWorldMapSign((GetPointX(markerFactoryAreaFrom)+GetPointX(markerFactoryAreaTo))/2, (GetPointY(markerFactoryAreaFrom)+GetPointY(markerFactoryAreaTo))/2, 0, 0, 65000);

		return EvacuateUnits;
	}

	state DetectedByHummers
	{
		m_pEnemyUnits.SetEnemy(m_pPlayer);

		m_uHummer1.CommandAttack(m_uHero);
		m_uHummer2.CommandAttack(m_uHero);
		m_uHummer3.CommandAttack(m_uHero);
		m_uHummer4.CommandAttack(m_uHero);

		return DetectedByHummers;
	}

	state EvacuateUnits
	{
		if	(
			IsUnitInArea(m_uHero, markerFactoryAreaFrom, markerFactoryAreaTo) &&
			(!m_uHummer1.IsLive() || IsUnitInArea(m_uHummer1, markerFactoryAreaFrom, markerFactoryAreaTo)) &&
			(!m_uHummer2.IsLive() || IsUnitInArea(m_uHummer2, markerFactoryAreaFrom, markerFactoryAreaTo)) &&
			(!m_uHummer3.IsLive() || IsUnitInArea(m_uHummer3, markerFactoryAreaFrom, markerFactoryAreaTo)) &&
			(!m_uHummer4.IsLive() || IsUnitInArea(m_uHummer4, markerFactoryAreaFrom, markerFactoryAreaTo))
			)
		{
			return EvacuatedUnits;
		}
		else
		{
			return EvacuateUnits;
		}
	}

	state EvacuatedUnits
	{
		RemoveWorldMapSign((GetPointX(markerFactoryAreaFrom)+GetPointX(markerFactoryAreaTo))/2, (GetPointY(markerFactoryAreaFrom)+GetPointY(markerFactoryAreaTo))/2, 0);

		SetGoalState(goalEvacuateUnits, goalAchieved);

		AddBriefing("translateBriefingMissionIRQ_1_MissionComplete");

		EnableEndMissionButton(true, true);

		return MissionComplete;
	}

	state MissionComplete
	{
		return MissionComplete;
	}

	event Artefact(int nArtefactNum, player pPlayerOnArtefact)
	{
		if ( nArtefactNum == idMexican )
		{
			state FoundMexican;
		}

		true;
	}

	function int MissionFail()
	{
		if ( state == CaptureCars )
		{
			SetGoalState(goalCaptureCars, goalFailed);
		}
		else if ( state == FindMexican )
		{
			SetGoalState(goalFindMexican, goalFailed);
		}
		else if ( state == CaptureHummers )
		{
			SetGoalState(goalCaptureHummers, goalFailed);
		}
		else if ( state == EvacuateUnits )
		{
			SetGoalState(goalEvacuateUnits, goalFailed);
		}

		AddBriefing("translateBriefingMissionIRQ_1_MissionFail");

		EnableEndMissionButton(true, false);

		state MissionComplete;
	}

	event UnitDestroyed(unit uUnit)
	{
		m_bCheckNumberOfUnits = true;

		if ( uUnit == m_uHero )
		{
			MissionFail();
		}
		else if ( m_bCheckTruck && uUnit == m_uTruck )
		{
			MissionFail();
		}

	}

	event BuildingDestroyed(unit uBuilding)
	{
		m_bCheckNumberOfBuildings = true;
	}

	event SetupInterface()
	{
	}
}
