mission "translateMissionIRQ_10"
{
	consts
	{
		goalCaptureRocketControl = 0;
		goalKeepRocketControl = 1;

		markerRocketControl = 0;
		markerVisibleArea = 2;

		markerAmphibias = 29;
		markerLeclercs = 34;
		markerApachesMGM = 39;
		markerApachesMGR = 42;
	}

	include "UnitTemplates.ech"
	include "Research.ech"

	player m_pPlayer;

	player m_pEnemyA;
	player m_pEnemyB;

	unitex m_uRocketControl;

	int m_bCheckNumberOfUnits;
	int m_bCheckNumberOfBuildings;

	int m_bCheckDestroyedUnitsAndBuildings;

	int m_nTimeOfKeptRocketControl;

	state Initialize;
	state Start;
	state BeforeStart;
	state CaptureRocketControl;
	state CapturedRocketControl;
	state KeepRocketControl;
	state KeptRocketControl;
	state MissionComplete;

	function int ClearMarkers(int nStartPoint, int nEndPoint)
	{
		int i;

		for ( i=nStartPoint; i<=nEndPoint; i=i+1 )
		{
			ClearArea (65535, GetPointX(i), GetPointY(i), GetPointZ(i), 0);
		}
	}

	function int ModifyDifficulty()
	{
		if ( GetDifficultyLevel() == 0 )
		{
			ClearMarkers( 3, 28);
		}
		else if ( GetDifficultyLevel() == 1 )
		{
			ClearMarkers( 3,  4);
			ClearMarkers( 7,  8);
			ClearMarkers(10, 11);
			ClearMarkers(14, 14);
			ClearMarkers(16, 17);
			ClearMarkers(20, 20);
			ClearMarkers(22, 22);
			ClearMarkers(24, 25);
			ClearMarkers(28, 28);
		}
		else if ( GetDifficultyLevel() == 2 )
		{
		}
	}

	state Initialize
	{
		ModifyDifficulty();

		RegisterGoal(goalCaptureRocketControl, "translateGoalMissionIRQ_10_CaptureRocketControl");
		RegisterGoal(goalKeepRocketControl, "translateGoalMissionIRQ_10_KeepRocketControl");

		m_pPlayer = GetPlayer(3);
		m_pPlayer.EnableStatistics(true);

		m_pPlayer.SetMilitaryUnitsLimit(60000);
		m_pPlayer.SetMilitaryBuildingsLimit(60000);

		m_pEnemyA = GetPlayer(0);
		m_pEnemyA.EnableStatistics(true);
		m_pEnemyB = GetPlayer(1);
		m_pEnemyB.EnableStatistics(true);

//		if ( GetDifficultyLevel() == 0 )
//		{
//			m_pEnemyA.LoadScript("single\\singleEasy");			
//			m_pEnemyB.LoadScript("single\\singleEasy");			
//		}
//		else if ( GetDifficultyLevel() == 1 )
//		{
//			m_pEnemyA.LoadScript("single\\singleMedium");			
//			m_pEnemyB.LoadScript("single\\singleMedium");			
//		}
//		else if ( GetDifficultyLevel() == 2 )
//		{
			m_pEnemyA.LoadScript("single\\singleHard");
			m_pEnemyB.LoadScript("single\\singleHard");			
//		}

		m_pEnemyA.EnableAI(true);
		m_pEnemyB.EnableAI(true);

		m_pPlayer.SetMoney(5000);

		m_pEnemyA.SetMoney(500000);
		m_pEnemyB.SetMoney(500000);

		AddUnitTemplatesIRQ( m_pPlayer );

		m_pPlayer.LookAt(m_pPlayer.GetStartingPointX(), m_pPlayer.GetStartingPointY(), 6, 0, 0, 0);

		m_uRocketControl = GetUnit(GetPointX(markerRocketControl), GetPointY(markerRocketControl));

		ShowArea(m_pPlayer.GetIFF(), GetPointX(markerVisibleArea), GetPointY(markerVisibleArea), 0, 10, showAreaPassives|showAreaBuildings|showAreaUnits);

		EnableAllResearchIRQ( m_pPlayer, false);
		m_pPlayer.EnableResearch("RES_IRQ_TANK1", true);			// M1
		m_pPlayer.EnableResearch("RES_IRQ_HELICOPTER1", true);		// M2
		m_pPlayer.EnableResearch("RES_IRQ_AMMO_MG1", true);			// M3
		m_pPlayer.EnableResearch("RES_IRQ_PILLBOX", true);			// M3
		m_pPlayer.EnableResearch("RES_IRQ_TANK2", true);			// M3
		m_pPlayer.EnableResearch("RES_IRQ_SAPER", true);			// M3
		m_pPlayer.EnableResearch("RES_IRQ_MIM", true);				// M3
		m_pPlayer.EnableResearch("RES_IRQ_AMMO_MG2", true);			// M4
		m_pPlayer.EnableResearch("RES_IRQ_RART", true);				// M4
		m_pPlayer.EnableResearch("RES_IRQ_HRART", true);			// M4
		m_pPlayer.EnableResearch("RES_IRQ_AMMO_MIM1", true);		// M4
		m_pPlayer.EnableResearch("RES_IRQ_SPECIAL_FILTER2", true);	// M4
		m_pPlayer.EnableResearch("RES_IRQ_AMMO_CANNON1", true);		// M5
		m_pPlayer.EnableResearch("RES_IRQ_BIGART", true);			// M5
		m_pPlayer.EnableResearch("RES_IRQ_AMMO_ROCKET1", true);		// M5
		m_pPlayer.EnableResearch("RES_IRQ_AMMO_HROCKET1", true);	// M5
		m_pPlayer.EnableResearch("RES_IRQ_MGM", true);				// M5
		m_pPlayer.EnableResearch("RES_IRQ_EXPLODER", true);			// M5
		m_pPlayer.EnableResearch("RES_IRQ_AMMO_CANNON2", true);		// M6
		m_pPlayer.EnableResearch("RES_IRQ_AMMO_ROCKET2", true);		// M6
		m_pPlayer.EnableResearch("RES_IRQ_AMMO_HROCKET2", true);	// M6
		m_pPlayer.EnableResearch("RES_IRQ_AMMO_MIM2", true);		// M6
		m_pPlayer.EnableResearch("RES_IRQ_JEEP_MGM", true);			// M6
		m_pPlayer.EnableResearch("RES_IRQ_SPECIAL_FILTER3", true);	// M6
		m_pPlayer.EnableResearch("RES_IRQ_AMMO_MGM1", true);		// M7
		m_pPlayer.EnableResearch("RES_IRQ_EXPLODER_BIG", true);		// M7
		m_pPlayer.EnableResearch("RES_IRQ_SCUD", true);				// M8
		m_pPlayer.EnableResearch("RES_IRQ_SPYFLIGHTCENTER", true);	// M8
		m_pPlayer.EnableResearch("RES_IRQ_AMMO_MGM2", true);		// M8
		m_pPlayer.EnableResearch("RES_IRQ_SDI", true);				// M8
//		m_pPlayer.EnableResearch("RES_IRQ_AMMO_CHEMICAL1", true);	// M9
		m_pPlayer.EnableResearch("RES_IRQ_SPYCENTER", true);		// M9
		m_pPlayer.EnableResearch("RES_IRQ_SPECIAL_PTC", true);		// M9
//		m_pPlayer.EnableResearch("RES_IRQ_AMMO_CHEMICAL2", true);

		EnableAllResearchUSA( m_pEnemyA, true);
		EnableAllResearchUSA( m_pEnemyB, true);

		m_pEnemyA.EnableResearch("RES_USA_ROCKETCONTROL", false);
		m_pEnemyB.EnableResearch("RES_USA_ROCKETCONTROL", false);

		m_pEnemyA.AddResearch("RES_USA_AMPHIBIA1");
		m_pEnemyA.AddResearch("RES_USA_AMMO_MG1");
		m_pEnemyA.AddResearch("RES_USA_SPY");
		m_pEnemyA.AddResearch("RES_USA_HELICOPTER1");
		m_pEnemyA.AddResearch("RES_USA_AMMO_MG2");
		m_pEnemyA.AddResearch("RES_USA_HELICOPTER2");
		m_pEnemyA.AddResearch("RES_USA_TANK1");
		m_pEnemyA.AddResearch("RES_USA_SAPER");
		m_pEnemyA.AddResearch("RES_USA_MORTAR");
		m_pEnemyA.AddResearch("RES_USA_AMMO_CANNON1");
		m_pEnemyA.AddResearch("RES_USA_MIM");
		m_pEnemyA.AddResearch("RES_USA_SPECIAL_FILTER2");
		m_pEnemyA.AddResearch("RES_USA_ART");
		m_pEnemyA.AddResearch("RES_USA_AMMO_GRENADE1");
		m_pEnemyA.AddResearch("RES_USA_COMANCHE");
		m_pEnemyA.AddResearch("RES_USA_AMMO_MIM1");
		m_pEnemyA.AddResearch("RES_USA_MGM");
		m_pEnemyA.AddResearch("RES_USA_SDI");
		m_pEnemyA.AddResearch("RES_USA_SPECIAL_FILTER3");
		m_pEnemyA.AddResearch("RES_USA_AMMO_GRENADE2");
		m_pEnemyA.AddResearch("RES_USA_AMMO_CANNON2");
		m_pEnemyA.AddResearch("RES_USA_SPECIAL_PTC");
		m_pEnemyA.AddResearch("RES_USA_SPECIAL_FLARE");
		m_pEnemyA.AddResearch("RES_USA_LECLERC");
		m_pEnemyA.AddResearch("RES_USA_AMMO_MGM1");
		m_pEnemyA.AddResearch("RES_USA_AIRCONTROL");
		m_pEnemyA.AddResearch("RES_USA_AMMO_MIM2");
		m_pEnemyA.AddResearch("RES_USA_JEEP_JAMMER");
		m_pEnemyA.AddResearch("RES_USA_BOMBCONTROL");
		m_pEnemyA.AddResearch("RES_USA_AMMO_MGM2");

		m_pEnemyB.AddResearch("RES_USA_AMPHIBIA1");
		m_pEnemyB.AddResearch("RES_USA_AMMO_MG1");
		m_pEnemyB.AddResearch("RES_USA_SPY");
		m_pEnemyB.AddResearch("RES_USA_HELICOPTER1");
		m_pEnemyB.AddResearch("RES_USA_AMMO_MG2");
		m_pEnemyB.AddResearch("RES_USA_HELICOPTER2");
		m_pEnemyB.AddResearch("RES_USA_TANK1");
		m_pEnemyB.AddResearch("RES_USA_SAPER");
		m_pEnemyB.AddResearch("RES_USA_MORTAR");
		m_pEnemyB.AddResearch("RES_USA_AMMO_CANNON1");
		m_pEnemyB.AddResearch("RES_USA_MIM");
		m_pEnemyB.AddResearch("RES_USA_SPECIAL_FILTER2");
		m_pEnemyB.AddResearch("RES_USA_ART");
		m_pEnemyB.AddResearch("RES_USA_AMMO_GRENADE1");
		m_pEnemyB.AddResearch("RES_USA_COMANCHE");
		m_pEnemyB.AddResearch("RES_USA_AMMO_MIM1");
		m_pEnemyB.AddResearch("RES_USA_MGM");
		m_pEnemyB.AddResearch("RES_USA_SDI");
		m_pEnemyB.AddResearch("RES_USA_SPECIAL_FILTER3");
		m_pEnemyB.AddResearch("RES_USA_AMMO_GRENADE2");
		m_pEnemyB.AddResearch("RES_USA_AMMO_CANNON2");
		m_pEnemyB.AddResearch("RES_USA_SPECIAL_PTC");
		m_pEnemyB.AddResearch("RES_USA_SPECIAL_FLARE");
		m_pEnemyB.AddResearch("RES_USA_LECLERC");
		m_pEnemyB.AddResearch("RES_USA_AMMO_MGM1");
		m_pEnemyB.AddResearch("RES_USA_AIRCONTROL");
		m_pEnemyB.AddResearch("RES_USA_AMMO_MIM2");
		m_pEnemyB.AddResearch("RES_USA_JEEP_JAMMER");
		m_pEnemyB.AddResearch("RES_USA_BOMBCONTROL");
		m_pEnemyB.AddResearch("RES_USA_AMMO_MGM2");

		AddUnitTemplatesUSA( m_pEnemyA );
		AddUnitTemplatesUSA( m_pEnemyB );

		SetTimer(0, 100); // CheckDestroyedUnitsAndBuildings

		return BeforeStart, 1;
	}

	state BeforeStart
	{
		PlayTrack("Music\\Briefing.tws");

		return Start;
	}

	state Start
	{
		EnableGoal(goalCaptureRocketControl, true);
		AddBriefing("translateBriefingMissionIRQ_10_CaptureRocketControl");
		PlayWave("Briefings\\IRQ_Briefing10.wav");

		m_pEnemyA.EnableAIFeatures2(ai2RebuildBaseOnly, true);
		m_pEnemyB.EnableAIFeatures2(ai2RebuildBaseOnly, true);

		return CaptureRocketControl;
	}

	state CaptureRocketControl
	{
		if ( m_uRocketControl.GetIFF() == m_pPlayer.GetIFF() )
		{
			return CapturedRocketControl;
		}
		else
		{
			return CaptureRocketControl;
		}
	}

	function int AttackRocketControl()
	{
		int nAmphibias, nLeclercs, nApachesMGM, nApachesMGR;
		unitex uTmp;

		int i;

		m_pEnemyB.EnableAI(false);

		if ( GetDifficultyLevel() == 0 )
		{
			nAmphibias = 3;
			nLeclercs = 0;
			nApachesMGM = 2;
			nApachesMGR = 1;
		}
		else if ( GetDifficultyLevel() == 1 )
		{
			nAmphibias = 4;
			nLeclercs = 4;
			nApachesMGM = 2;
			nApachesMGR = 2;
		}
		else if ( GetDifficultyLevel() == 2 )
		{
			nAmphibias = 5;
			nLeclercs = 5;
			nApachesMGM = 3;
			nApachesMGR = 2;
		}

		for ( i=markerAmphibias; i<markerAmphibias+nAmphibias; ++i )
		{
			uTmp = m_pEnemyB.CreateUnit(GetPointX(i), GetPointY(i), 0, null, "USA_AMPHIBIA", "USA_AMPHIBIA_CANNON", null, "USA_AMPHIBIA_MIM", null);
			uTmp.CommandAttack(m_uRocketControl);
		}

		for ( i=markerLeclercs; i<markerLeclercs+nLeclercs; ++i )
		{
			uTmp = m_pEnemyB.CreateUnit(GetPointX(i), GetPointY(i), 0, null, "USA_LECLERC", "USA_LECLERC_CANNON", null, "USA_LECLERC_SPECIAL_FLARE", null);
			uTmp.CommandAttack(m_uRocketControl);
		}

		for ( i=markerApachesMGM; i<markerApachesMGM+nApachesMGM; ++i )
		{
			uTmp = m_pEnemyB.CreateUnitEx(GetPointX(i), GetPointY(i), 0, null, "USA_APACHE", "USA_HELICOPTER_MGM1", "USA_HELICOPTER_MIM2", "USA_HELICOPTER_SPECIAL_FLARE", null, null, null, null, null, -1);
			uTmp.CommandAttack(m_uRocketControl);
		}

		for ( i=markerApachesMGR; i<markerApachesMGR+nApachesMGR; ++i )
		{
			uTmp = m_pEnemyB.CreateUnitEx(GetPointX(i), GetPointY(i), 0, null, "USA_APACHE", "USA_HELICOPTER_MGR1", "USA_HELICOPTER_MGR2", "USA_HELICOPTER_SPECIAL_FLARE", null, null, null, null, null, -1);
			uTmp.CommandAttack(m_uRocketControl);
		}
	}

	state CapturedRocketControl
	{
		SetGoalState(goalCaptureRocketControl, goalAchieved);

		EnableGoal(goalKeepRocketControl, true);
		AddBriefing("translateBriefingMissionIRQ_10_KeepRocketControl");

		m_nTimeOfKeptRocketControl = GetMissionTime() + 3*60*20;

		AttackRocketControl();

		return KeepRocketControl;
	}

	state KeepRocketControl
	{
		if ( GetMissionTime() >= m_nTimeOfKeptRocketControl )
		{
			return KeptRocketControl;
		}
		else
		{
			return KeepRocketControl;
		}
	}

	state KeptRocketControl
	{
		SetGoalState(goalKeepRocketControl, goalAchieved);

		AddBriefing("translateBriefingMissionIRQ_10_MissionComplete");

		EndMission(true);

		return MissionComplete;
	}

	state MissionComplete
	{
		return MissionComplete;
	}

	function int MissionFail()
	{
		if ( GetGoalState(goalCaptureRocketControl) != goalAchieved )
		{
			SetGoalState(goalCaptureRocketControl, goalFailed);
		}

		if ( GetGoalState(goalKeepRocketControl) != goalAchieved )
		{
			SetGoalState(goalKeepRocketControl, goalFailed);
		}

		AddBriefing("translateBriefingMissionIRQ_10_MissionFail");

		EnableEndMissionButton(true, false);

		state MissionComplete;
	}

	function int CheckDestroyedUnitsAndBuildings()
	{
		if ( state == MissionComplete ) return;

		if ( m_pPlayer.GetNumberOfUnits() == 0 && m_pPlayer.GetNumberOfBuildings() == 0 )
		{
			MissionFail();
		}
		else if ( !m_uRocketControl.IsLive() )
		{
			MissionFail();
		}
	}

	event Timer0()
	{
		if ( m_bCheckDestroyedUnitsAndBuildings )
		{
			m_bCheckDestroyedUnitsAndBuildings = false;

			CheckDestroyedUnitsAndBuildings();
		}
	}

	event UnitDestroyed(unit uUnit)
	{
		m_bCheckNumberOfUnits = true;
		m_bCheckDestroyedUnitsAndBuildings = true;
	}

	event BuildingDestroyed(unit uBuilding)
	{
		m_bCheckNumberOfBuildings = true;
		m_bCheckDestroyedUnitsAndBuildings = true;
	}

	event SetupInterface()
	{
		EnableGameFeature
			(
			lockResearchDialog |
			lockToolbarResearching |
			lockToolbarMoney |
			lockDisplayToolbarMoney |
			lockCreateBuildPanel |
			0, false);
	}
}
