mission "translateMissionIRQ_2"
{
	consts
	{
		goalFindTNT = 0;
		goalMineTrain = 1;
		goalFindIwan = 2;
		goalEscortIwan = 3;

		markerTNT = 5;
		markerIwan = 6;
		markerTrainDetonation = 7;
		markerTrainStop = 8;
		markerTrainCreateLocation = 30;

		markerJeep1 = 1;
		markerJeep2 = 2;
		markerJeep3 = 3;
		markerJeep4 = 4;
		markerJeep5 = 0;

		idTNT = 12345;
		idIwan = 1234;
	}

	include "Varia.ech"
	include "Research.ech"

	player m_pPlayer;

	player m_pFriendlyBuildings;

	player m_pEnemyUnits;
	player m_pEnemy;

	unitex m_uJeep1;
	unitex m_uJeep2;
	unitex m_uJeep3;
	unitex m_uJeep4;
	unitex m_uJeep5;

	unitex m_uTrain;

	unitex m_uIwan;

	int m_bCheckNumberOfUnits;
	int m_bCheckNumberOfBuildings;

	int m_bCheckDestroyedUnits;

	int m_nStartTrain;

	state Initialize;
	state Start;
	state BeforeStart;
	state FindTNT;
	state FoundTNT;
	state MineTrain;
	state MinedTrain;
	state WaitForTrainDetonation;
	state TrainDetonation;
	state FindIwan;
	state FoundIwan;
	state EscortIwan;
	state EscortedIwan;
	state MissionComplete;

	function int ModifyDifficulty()
	{
		if ( GetDifficultyLevel() == 0 )
		{
			ClearArea	(65535, GetPointX(32), GetPointY(32), GetPointZ(32), 0);
			ClearArea	(65535, GetPointX(33), GetPointY(33), GetPointZ(33), 0);
		}
		else if ( GetDifficultyLevel() == 1 )
		{
			ClearArea	(65535, GetPointX(31), GetPointY(31), GetPointZ(31), 0);
			ClearArea	(65535, GetPointX(32), GetPointY(32), GetPointZ(32), 0);
			ClearArea	(65535, GetPointX(33), GetPointY(33), GetPointZ(33), 0);
		}
		else if ( GetDifficultyLevel() == 2 )
		{
			ClearArea	(65535, GetPointX(31), GetPointY(31), GetPointZ(31), 0);
		}
	}

	function int CreateTrain()
	{
		int nGx, nGy;

		nGx = GetPointX(markerTrainCreateLocation);
		nGy = GetPointY(markerTrainCreateLocation);

		m_uTrain = CreatePassive(nGx, nGy, 0, 64, "NE_ELEKTIRK");

		CreatePassive(nGx-2, nGy, 0, 64, "NE_CYSIRK");
		CreatePassive(nGx-4, nGy, 0, 64, "NE_CYSIRK");
		if ( Rand(2) )
		{
			CreatePassive(nGx-6, nGy, 0, 64, "NE_CYSIRK");
		}
		else
		{
			CreatePassive(nGx-6, nGy, 0, 64, "NE_TOWIRK");
		}
		CreatePassive(nGx-8, nGy, 0, 64, "NE_TOWIRK");
	}

	state Initialize
	{
		ModifyDifficulty();

		CreateTrain();

		RegisterGoal(goalFindTNT, "translateGoalMissionIRQ_2_FindTNT");
		RegisterGoal(goalMineTrain, "translateGoalMissionIRQ_2_MineTrain");
		RegisterGoal(goalFindIwan, "translateGoalMissionIRQ_2_FindIwan");
		RegisterGoal(goalEscortIwan, "translateGoalMissionIRQ_2_EscortIwan");

		m_pPlayer = GetPlayer(3);
		m_pPlayer.EnableStatistics(false);

		m_pFriendlyBuildings = GetPlayer(5);
		m_pFriendlyBuildings.EnableStatistics(false);

		m_pEnemyUnits = GetPlayer(4);
		m_pEnemyUnits.EnableStatistics(false);

		m_pEnemy = GetPlayer(9);
		m_pEnemy.EnableStatistics(false);

		m_nStartTrain = 1;

		m_pEnemy.LoadScript("single\\singleUniversal");

		m_pFriendlyBuildings.EnableAI(false);
		m_pFriendlyBuildings.EnableAIFeatures2(ai2ChooseEnemy, false);

		m_pFriendlyBuildings.SetNeutral(m_pPlayer);
		m_pPlayer.SetNeutral(m_pFriendlyBuildings);

		m_pEnemyUnits.EnableAI(false);

		m_uJeep1 = GetUnit(GetPointX(markerJeep1), GetPointY(markerJeep1));
		m_uJeep2 = GetUnit(GetPointX(markerJeep2), GetPointY(markerJeep2));
		m_uJeep3 = GetUnit(GetPointX(markerJeep3), GetPointY(markerJeep3));
		m_uJeep4 = GetUnit(GetPointX(markerJeep4), GetPointY(markerJeep4));
		m_uJeep5 = GetUnit(GetPointX(markerJeep5), GetPointY(markerJeep5));

		m_pPlayer.LookAt(m_pPlayer.GetStartingPointX(), m_pPlayer.GetStartingPointY(), 6, 0, 0, 0);

		EnableAllResearchIRQ( m_pPlayer, false);
		m_pPlayer.EnableResearch("RES_IRQ_TANK1", true);			// M1
		m_pPlayer.EnableResearch("RES_IRQ_HELICOPTER1", true);

		SetTimer(0, 100); // CheckDestroyedUnits
		SetTimer(2, 7*20);

		m_pPlayer.EnableCommand(commandRecycleUnit, false);
		m_pPlayer.EnableCommand(commandSoldBuilding, false);

		return BeforeStart, 1;
	}

	state BeforeStart
	{
		PlayTrack("Music\\Briefing.tws");

		return Start;
	}

	event Timer2()
	{
		if ( m_uTrain.IsTrainMoving() )
		{
			return;
		}

		if ( m_nStartTrain == 1 )
		{
			m_uTrain.StartTrain(GetPointX(markerTrainStop), GetPointY(markerTrainStop), trainModeMoveNormal, 20);

			m_nStartTrain = 2;
		}
		else if ( m_nStartTrain == 2 )
		{
			if ( state == MinedTrain || state == WaitForTrainDetonation )
			{
				m_uTrain.StartTrain(GetPointX(markerTrainDetonation), GetPointY(markerTrainDetonation), trainModeMoveNormal, 20);
			}
			else
			{
				m_uTrain.StartTrain(-1, -1, trainModeMoveToEndOfWorld, 20);
			}

			m_nStartTrain = 1;
		}
	}

    state Start
	{
		EnableGoal(goalFindTNT, true);
		AddBriefing("translateBriefingMissionIRQ_2_FindTNT");
		PlayWave("Briefings\\IRQ_Briefing02.wav");

		Patrol(m_uJeep1, 13, 17);
		Patrol(m_uJeep2, 18, 23);
		Patrol(m_uJeep3, 24, 27);
		Patrol(m_uJeep4, 28, 29);
		Patrol(m_uJeep5,  9, 12);

		CreateArtefact("ARTIFACT_CLICK_ME", GetPointX(markerTNT), GetPointY(markerTNT), 0, idTNT);

		AddWorldMapSign(GetPointX(markerTNT), GetPointY(markerTNT), 0, 0, 65000);

		return FindTNT;
	}

	state FindTNT
	{
		return FindTNT;
	}

	state FoundTNT
	{
		RemoveWorldMapSign(GetPointX(markerTNT), GetPointY(markerTNT), 0);

		SetGoalState(goalFindTNT, goalAchieved);

		EnableGoal(goalMineTrain, true);
		AddBriefing("translateBriefingMissionIRQ_2_MineTrain");

		AddWorldMapSign(GetPointX(markerTrainStop), GetPointY(markerTrainStop), 0, 0, 65000);

		CreateArtefact("ARTIFACT_CLICK_ME", GetPointX(markerTrainStop), GetPointY(markerTrainStop), 0, 0);

		return MineTrain;
	}

	state MineTrain
	{
		int nGx, nGy;

		int nTrainx, nTrainy;

		unitex uTmp;

		nTrainx = GetPointX(markerTrainStop);
		nTrainy = GetPointY(markerTrainStop);

		if ( Distance(m_uTrain.GetLocationX(), m_uTrain.GetLocationY(), nTrainx, nTrainy) >= 3 )
		{
			return MineTrain;
		}

		for ( nGy = nTrainy - 1; nGy <= nTrainy + 1; nGy = nGy + 1 )
		{
			for ( nGx = nTrainx - 3; nGx <= nTrainx; nGx = nGx + 1 )
			{
				uTmp = GetUnit(nGx, nGy);

				if ( uTmp.GetIFF() == m_pPlayer.GetIFF() )
				{
					return MinedTrain;
				}
			}
		}

		return MineTrain;
	}

	state MinedTrain
	{
		int i;

		SetGoalState(goalMineTrain, goalAchieved);

		AddBriefing("translateBriefingMissionIRQ_2_MinedTrain");

		RemoveWorldMapSign(GetPointX(markerTrainStop), GetPointY(markerTrainStop), 0);

		RemoveArtefact(GetPointX(markerTrainStop), GetPointY(markerTrainStop), 0);

		return WaitForTrainDetonation;
	}

	state WaitForTrainDetonation
	{
		ShowArea(m_pPlayer.GetIFF(), m_uTrain.GetLocationX(), m_uTrain.GetLocationY(), 0, 8, showAreaPassives|showAreaBuildings|showAreaUnits);

		if ( Distance(m_uTrain.GetLocationX(), m_uTrain.GetLocationY(), GetPointX(markerTrainDetonation), GetPointY(markerTrainDetonation)) <= 2 )
		{
			return TrainDetonation;
		}
		else
		{
			return WaitForTrainDetonation;
		}
	}

	state TrainDetonation
	{
		ShowArea(m_pPlayer.GetIFF(), GetPointX(markerTrainDetonation), GetPointY(markerTrainDetonation), 0, 10, showAreaPassives|showAreaBuildings|showAreaUnits);
		KillArea(65535, GetPointX(markerTrainDetonation), GetPointY(markerTrainDetonation), 0, 7);

		EnableGoal(goalFindIwan, true);
		AddBriefing("translateBriefingMissionIRQ_2_FindIwan");

		CreateArtefact("ARTIFACT_PRISONER", GetPointX(markerIwan), GetPointY(markerIwan), 0, idIwan);

		m_nStartTrain = 0;

		AddWorldMapSign(GetPointX(markerIwan), GetPointY(markerIwan), 0, 0, 65000);

		return FindIwan;
	}

	state FindIwan
	{
		return FindIwan;
	}

	state FoundIwan
	{
		SetGoalState(goalFindIwan, goalAchieved);

		EnableGoal(goalEscortIwan, true);
		AddBriefing("translateBriefingMissionIRQ_2_EscortIwan");

		RemoveWorldMapSign(GetPointX(markerIwan), GetPointY(markerIwan), 0);

		AddWorldMapSign(m_pFriendlyBuildings.GetStartingPointX(), m_pFriendlyBuildings.GetStartingPointY(), 0, 0, 65000);

		return EscortIwan;
	}

	state EscortIwan
	{
		if ( Distance(m_uIwan.GetLocationX(), m_uIwan.GetLocationY(), m_pFriendlyBuildings.GetStartingPointX(), m_pFriendlyBuildings.GetStartingPointY()) <= 2 )
		{
			return EscortedIwan;
		}
		else
		{
			return EscortIwan;
		}
	}

	state EscortedIwan
	{
		RemoveWorldMapSign(m_pFriendlyBuildings.GetStartingPointX(), m_pFriendlyBuildings.GetStartingPointY(), 0);

		SetGoalState(goalEscortIwan, goalAchieved);

		AddBriefing("translateBriefingMissionIRQ_2_MissionComplete");

		EnableEndMissionButton(true, true);

		return MissionComplete;
	}

	state MissionComplete
	{
		return MissionComplete;
	}

	event UnitDestroyed(unit uUnit)
	{
		m_bCheckNumberOfUnits = true;
		m_bCheckDestroyedUnits = true;

		if ( uUnit == m_uIwan )
		{
			SetGoalState(goalEscortIwan, goalFailed);

			AddBriefing("translateBriefingMissionIRQ_2_MissionFail");

			EnableEndMissionButton(true, false);

			state MissionComplete;
		}
	}

	event BuildingDestroyed(unit uBuilding)
	{
		m_bCheckNumberOfBuildings = true;
		m_bCheckDestroyedUnits = true;
	}

	event Artefact(int nArtefactNum, player pPlayerOnArtefact)
	{
		if ( nArtefactNum == idTNT )
		{
			state FoundTNT;

			return true;
		}
		else if ( nArtefactNum == idIwan )
		{
			m_uIwan = GetUnit(GetPointX(markerIwan), GetPointY(markerIwan));

			state FoundIwan;

			return true;
		}
		else
		{
			return false;
		}
	}

	function int CheckDestroyedUnits()
	{
		if ( state == MissionComplete ) return;

		if ( m_pPlayer.GetNumberOfUnits() == 0 )
		{
			if ( state == FindTNT )
			{
				SetGoalState(goalFindTNT, goalFailed);
			}
			else if ( state == MineTrain )
			{
				SetGoalState(goalMineTrain, goalFailed);
			}
			else if ( state == FindIwan )
			{
				SetGoalState(goalFindIwan, goalFailed);
			}
			else if ( state == EscortIwan )
			{
				SetGoalState(goalEscortIwan, goalFailed);
			}

			AddBriefing("translateBriefingMissionIRQ_2_MissionFail");

			EnableEndMissionButton(true, false);

			state MissionComplete;
		}

	}

	event Timer0()
	{
		if ( m_bCheckDestroyedUnits )
		{
			m_bCheckDestroyedUnits = false;

			CheckDestroyedUnits();
		}
	}

	event SetupInterface()
	{
	}
}
