mission "translateMissionIRQ_3"
{
	consts
	{
		goalCapturePoliceCar = 0;
		goalCaptureBoat	= 1;
		goalCaptureJeep	= 2;
		goalCaptureHelicopter = 3;
		goalFindPrizoner = 4;
		goalEvacuatePrizoner = 5;

		markerHero = 0;
		markerPoliceCar = 1;
		markerBoat = 2;
		markerJeep = 3;
		markerHelicopter = 4;
		markerPrizoner = 5;
		markerEvacuationArea = 9;

		markerRafineryArea = 10;

		markerPoliceCarA1 = 11;
		markerPoliceCarA2 = 12;
		markerPoliceCarA3 = 13;

		markerPoliceCarMedium1 = 39;
		markerPoliceCarMedium2 = 40;
		markerPoliceCarMedium3 = 41;
		markerPoliceCarHard1 = 36;
		markerPoliceCarHard2 = 37;
		markerPoliceCarHard3 = 38;

		markerPoliceCarB1 = 14;
		markerPoliceCarB2 = 15;
		markerPoliceCarB3 = 16;

		markerPoliceCarC1 = 17;
		markerPoliceCarC2 = 18;
		markerPoliceCarC3 = 19;
		markerPoliceCarC4 = 20;
		markerPoliceCarC5 = 21;
		markerPoliceCarC6 = 22;

		markerPoliceBoat1 = 24;
		markerPoliceBoat2 = 25;
		markerPoliceBoat3 = 26;

		markerCivilCar1 = 30;
		markerCivilCar2 = 31;
		markerCivilCar3 = 32;
		markerCivilCar4 = 33;
		markerCivilCar5 = 34;
		markerCivilCar6 = 35;

		idPrizoner = 12345;
	}

	include "Varia.ech"
	include "Research.ech"

	player m_pPlayer;

	player m_pEnemy;
	player m_pNeutralUnits;

	unitex m_uHero;
	unitex m_uPoliceCar;
	unitex m_uBoat;
	unitex m_uJeep;
	unitex m_uHelicopter;

	int m_bCheckHero;
	int m_bCheckPoliceCar;
	int m_bCheckBoat;
	int m_bCheckJeep;
	int m_bCheckHelicopter;

	unitex m_uPoliceCarA1;
	unitex m_uPoliceCarA2;
	unitex m_uPoliceCarA3;

	unitex m_uPoliceCarMedium1;
	unitex m_uPoliceCarMedium2;
	unitex m_uPoliceCarMedium3;
	unitex m_uPoliceCarHard1;
	unitex m_uPoliceCarHard2;
	unitex m_uPoliceCarHard3;

	unitex m_uPoliceCarB1;
	unitex m_uPoliceCarB2;
	unitex m_uPoliceCarB3;

	unitex m_uPoliceCarC1;
	unitex m_uPoliceCarC2;
	unitex m_uPoliceCarC3;
	unitex m_uPoliceCarC4;
	unitex m_uPoliceCarC5;
	unitex m_uPoliceCarC6;

	unitex m_uPoliceBoat1;
	unitex m_uPoliceBoat2;
	unitex m_uPoliceBoat3;

	unitex m_uCivilCar1;
	unitex m_uCivilCar2;
	unitex m_uCivilCar3;
	unitex m_uCivilCar4;
	unitex m_uCivilCar5;
	unitex m_uCivilCar6;

	int m_nDetonatedUnit;

	int m_bCheckNumberOfUnits;
	int m_bCheckNumberOfBuildings;

	int m_bCheckDestroyedUnits;

	state Initialize;
	state Start;
	state BeforeStart;
	state CapturePoliceCar;
	state CapturedPoliceCar;
	state CaptureBoat;
	state CapturedBoat;
	state CaptureJeep;
	state CapturedJeep;
	state CaptureHelicopter;
	state CapturedHelicopter;
	state FindPrizoner;
	state FoundPrizoner;
	state EvacuatePrizoner;
	state EvacuatedPrizoner;
	state MissionComplete;

	function int PoliceAttackUnit(unitex uUnit)
	{
		m_uPoliceCarA1.CommandAttack(uUnit);
		m_uPoliceCarA2.CommandAttack(uUnit);
		m_uPoliceCarA3.CommandAttack(uUnit);

		if ( GetDifficultyLevel() > 0 )
		{
			m_uPoliceCarMedium1.CommandAttack(uUnit);
			m_uPoliceCarMedium2.CommandAttack(uUnit);
			m_uPoliceCarMedium3.CommandAttack(uUnit);
		}

		if ( GetDifficultyLevel() > 1 )
		{
			m_uPoliceCarHard1.CommandAttack(uUnit);
			m_uPoliceCarHard2.CommandAttack(uUnit);
			m_uPoliceCarHard3.CommandAttack(uUnit);
		}

		m_uPoliceCarC1.CommandAttack(uUnit);
		m_uPoliceCarC2.CommandAttack(uUnit);
		m_uPoliceCarC3.CommandAttack(uUnit);
		m_uPoliceCarC4.CommandAttack(uUnit);
		m_uPoliceCarC5.CommandAttack(uUnit);
		m_uPoliceCarC6.CommandAttack(uUnit);
	}

	function int ModifyDifficulty()
	{
		if ( GetDifficultyLevel() == 0 )
		{
			ClearArea	(65535, GetPointX(36), GetPointY(36), GetPointZ(36), 0);
			ClearArea	(65535, GetPointX(37), GetPointY(37), GetPointZ(37), 0);
			ClearArea	(65535, GetPointX(38), GetPointY(38), GetPointZ(38), 0);
			ClearArea	(65535, GetPointX(39), GetPointY(39), GetPointZ(39), 0);
			ClearArea	(65535, GetPointX(40), GetPointY(40), GetPointZ(40), 0);
			ClearArea	(65535, GetPointX(41), GetPointY(41), GetPointZ(41), 0);
		}
		else if ( GetDifficultyLevel() == 1 )
		{
			ClearArea	(65535, GetPointX(36), GetPointY(36), GetPointZ(36), 0);
			ClearArea	(65535, GetPointX(37), GetPointY(37), GetPointZ(37), 0);
			ClearArea	(65535, GetPointX(38), GetPointY(38), GetPointZ(38), 0);
		}
		else if ( GetDifficultyLevel() == 2 )
		{
		}
	}

	state Initialize
	{
		ModifyDifficulty();

		RegisterGoal(goalCapturePoliceCar, "translateGoalMissionIRQ_3_CapturePoliceCar");
		RegisterGoal(goalCaptureBoat, "translateGoalMissionIRQ_3_CaptureBoat");
		RegisterGoal(goalCaptureJeep, "translateGoalMissionIRQ_3_CaptureJeep");
		RegisterGoal(goalCaptureHelicopter, "translateGoalMissionIRQ_3_CaptureHelicopter");
		RegisterGoal(goalFindPrizoner, "translateGoalMissionIRQ_3_FindPrizoner");
		RegisterGoal(goalEvacuatePrizoner, "translateGoalMissionIRQ_3_EvacuatePrizoner");

		m_nDetonatedUnit = 0;

		m_pPlayer = GetPlayer(3);
		m_pPlayer.EnableStatistics(false);

		m_pEnemy = GetPlayer(1);
		m_pEnemy.EnableStatistics(false);

		m_pNeutralUnits = GetPlayer(0);
		m_pNeutralUnits.EnableStatistics(false);

		m_pEnemy.EnableAI(false);
		m_pNeutralUnits.EnableAI(false);

		m_pNeutralUnits.EnableAIFeatures2(ai2ChooseEnemy, false);

		m_pNeutralUnits.SetNeutral(m_pPlayer);
		m_pPlayer.SetNeutral(m_pNeutralUnits);

		m_pNeutralUnits.SetNeutral(m_pEnemy);
		m_pEnemy.SetNeutral(m_pNeutralUnits);

		m_pPlayer.SpyPlayer(m_pEnemy, true, 1000000);
		m_pPlayer.SpyPlayer(m_pNeutralUnits, true, 1000000);

		m_uHero = GetUnit(GetPointX(markerHero), GetPointY(markerHero));
		m_uPoliceCar = GetUnit(GetPointX(markerPoliceCar), GetPointY(markerPoliceCar));
		m_uPoliceCar.SetUnitName("translateIRQHeroName_Empty");
		m_uBoat = GetUnit(GetPointX(markerBoat), GetPointY(markerBoat));
		m_uBoat.SetUnitName("translateIRQHeroName_Empty");
		m_uJeep = GetUnit(GetPointX(markerJeep), GetPointY(markerJeep));
		m_uJeep.SetUnitName("translateIRQHeroName_Empty");
		m_uHelicopter = GetUnit(GetPointX(markerHelicopter), GetPointY(markerHelicopter));
		m_uHelicopter.SetUnitName("translateIRQHeroName_Empty");

		m_uPoliceCarA1 = GetUnit(GetPointX(markerPoliceCarA1), GetPointY(markerPoliceCarA1));
		m_uPoliceCarA2 = GetUnit(GetPointX(markerPoliceCarA2), GetPointY(markerPoliceCarA2));
		m_uPoliceCarA3 = GetUnit(GetPointX(markerPoliceCarA3), GetPointY(markerPoliceCarA3));

		m_uPoliceCarMedium1 = GetUnit(GetPointX(markerPoliceCarMedium1), GetPointY(markerPoliceCarMedium1));
		m_uPoliceCarMedium2 = GetUnit(GetPointX(markerPoliceCarMedium2), GetPointY(markerPoliceCarMedium2));
		m_uPoliceCarMedium3 = GetUnit(GetPointX(markerPoliceCarMedium3), GetPointY(markerPoliceCarMedium3));
		m_uPoliceCarHard1 = GetUnit(GetPointX(markerPoliceCarHard1), GetPointY(markerPoliceCarHard1));
		m_uPoliceCarHard2 = GetUnit(GetPointX(markerPoliceCarHard2), GetPointY(markerPoliceCarHard2));
		m_uPoliceCarHard3 = GetUnit(GetPointX(markerPoliceCarHard3), GetPointY(markerPoliceCarHard3));

		m_uPoliceCarB1 = GetUnit(GetPointX(markerPoliceCarB1), GetPointY(markerPoliceCarB1));
		m_uPoliceCarB2 = GetUnit(GetPointX(markerPoliceCarB2), GetPointY(markerPoliceCarB2));
		m_uPoliceCarB3 = GetUnit(GetPointX(markerPoliceCarB3), GetPointY(markerPoliceCarB3));

		m_uPoliceCarC1 = GetUnit(GetPointX(markerPoliceCarC1), GetPointY(markerPoliceCarC1));
		m_uPoliceCarC2 = GetUnit(GetPointX(markerPoliceCarC2), GetPointY(markerPoliceCarC2));
		m_uPoliceCarC3 = GetUnit(GetPointX(markerPoliceCarC3), GetPointY(markerPoliceCarC3));
		m_uPoliceCarC4 = GetUnit(GetPointX(markerPoliceCarC4), GetPointY(markerPoliceCarC4));
		m_uPoliceCarC5 = GetUnit(GetPointX(markerPoliceCarC5), GetPointY(markerPoliceCarC5));
		m_uPoliceCarC6 = GetUnit(GetPointX(markerPoliceCarC6), GetPointY(markerPoliceCarC6));

		m_uPoliceBoat1 = GetUnit(GetPointX(markerPoliceBoat1), GetPointY(markerPoliceBoat1));
		m_uPoliceBoat2 = GetUnit(GetPointX(markerPoliceBoat2), GetPointY(markerPoliceBoat2));
		m_uPoliceBoat3 = GetUnit(GetPointX(markerPoliceBoat3), GetPointY(markerPoliceBoat3));

		m_uCivilCar1 = GetUnit(GetPointX(markerCivilCar1), GetPointY(markerCivilCar1));
		m_uCivilCar2 = GetUnit(GetPointX(markerCivilCar2), GetPointY(markerCivilCar2));
		m_uCivilCar3 = GetUnit(GetPointX(markerCivilCar3), GetPointY(markerCivilCar3));
		m_uCivilCar4 = GetUnit(GetPointX(markerCivilCar4), GetPointY(markerCivilCar4));
		m_uCivilCar5 = GetUnit(GetPointX(markerCivilCar5), GetPointY(markerCivilCar5));
		m_uCivilCar6 = GetUnit(GetPointX(markerCivilCar6), GetPointY(markerCivilCar6));

		m_pPlayer.LookAt(m_pPlayer.GetStartingPointX(), m_pPlayer.GetStartingPointY(), 6, 0, 0, 0);

		m_bCheckHero = true;
		m_bCheckPoliceCar = true;
		m_bCheckBoat = true;
		m_bCheckJeep = true;
		m_bCheckHelicopter = true;

		EnableAllResearchIRQ( m_pPlayer, false);
		m_pPlayer.EnableResearch("RES_IRQ_TANK1", true);			// M1
		m_pPlayer.EnableResearch("RES_IRQ_HELICOPTER1", true);		// M2
		m_pPlayer.EnableResearch("RES_IRQ_AMMO_MG1", true);
		m_pPlayer.EnableResearch("RES_IRQ_PILLBOX", true);
		m_pPlayer.EnableResearch("RES_IRQ_TANK2", true);
		m_pPlayer.EnableResearch("RES_IRQ_SAPER", true);
		m_pPlayer.EnableResearch("RES_IRQ_MIM", true);

		SetTimer(0, 100); // CheckDestroyedUnits

		m_pPlayer.EnableCommand(commandRecycleUnit, false);
		m_pPlayer.EnableCommand(commandSoldBuilding, false);

		return BeforeStart, 1;
	}

	state BeforeStart
	{
		PlayTrack("Music\\Briefing.tws");

		return Start;
	}

	state Start
	{
		EnableGoal(goalCapturePoliceCar, true);
		AddBriefing("translateBriefingMissionIRQ_3_CapturePoliceCar");
		PlayWave("Briefings\\IRQ_Briefing03.wav");

		AddWorldMapSign(GetPointX(markerPoliceCar), GetPointY(markerPoliceCar), 0, 0, 65000);

		Patrol(m_uCivilCar1, 30, 35);
		Patrol(m_uCivilCar2, 30, 35);
		Patrol(m_uCivilCar3, 30, 35);
		Patrol(m_uCivilCar4, 30, 35);
		Patrol(m_uCivilCar5, 30, 35);
		Patrol(m_uCivilCar6, 30, 35);

		return CapturePoliceCar;
	}

	state CapturePoliceCar
	{
		if ( Distance(m_uPoliceCar.GetLocationX(), m_uPoliceCar.GetLocationY(), m_uHero.GetLocationX(), m_uHero.GetLocationY()) <= 1 )
		{
			return CapturedPoliceCar;
		}
		else
		{
			return CapturePoliceCar;
		}
	}

	state CapturedPoliceCar
	{
		RemoveWorldMapSign(GetPointX(markerPoliceCar), GetPointY(markerPoliceCar), 0);

		m_uHero.ChangePlayer(m_pNeutralUnits);
		m_uHero.SetUnitName("translateUSAHeroName_Empty");
		m_uPoliceCar.ChangePlayer(m_pPlayer);
		m_uPoliceCar.SetUnitName(null);

		m_bCheckHero = false;

		PoliceAttackUnit(m_uPoliceCar);

		SetGoalState(goalCapturePoliceCar, goalAchieved);

		EnableGoal(goalCaptureBoat, true);
		AddBriefing("translateBriefingMissionIRQ_3_CaptureBoat");

		AddWorldMapSign(GetPointX(markerBoat), GetPointY(markerBoat), 0, 0, 65000);

		return CaptureBoat;
	}

	state CaptureBoat
	{
		if ( Distance(m_uBoat.GetLocationX(), m_uBoat.GetLocationY(), m_uPoliceCar.GetLocationX(), m_uPoliceCar.GetLocationY()) <= 2 )
		{
			return CapturedBoat;
		}
		else
		{
			return CaptureBoat;
		}
	}

	state CapturedBoat
	{
		RemoveWorldMapSign(GetPointX(markerBoat), GetPointY(markerBoat), 0);

		m_uPoliceCar.ChangePlayer(m_pNeutralUnits);
		m_uPoliceCar.SetUnitName("translateUSAHeroName_Empty");
		m_uBoat.ChangePlayer(m_pPlayer);
		m_uBoat.SetUnitName(null);

		m_bCheckPoliceCar = false;

		PoliceAttackUnit(m_uBoat);

		m_uPoliceBoat1.CommandAttack(m_uBoat);
		m_uPoliceBoat2.CommandAttack(m_uBoat);
		m_uPoliceBoat3.CommandAttack(m_uBoat);

		SetGoalState(goalCaptureBoat, goalAchieved);

		EnableGoal(goalCaptureJeep, true);
		AddBriefing("translateBriefingMissionIRQ_3_CaptureJeep");

		AddWorldMapSign(GetPointX(markerJeep), GetPointY(markerJeep), 0, 0, 65000);

		return CaptureJeep;
	}

	state CaptureJeep
	{
		if ( Distance(m_uJeep.GetLocationX(), m_uJeep.GetLocationY(), m_uBoat.GetLocationX(), m_uBoat.GetLocationY()) <= 2 )
		{
			return CapturedJeep;
		}
		else
		{
			return CaptureJeep;
		}
	}

	state CapturedJeep
	{
		RemoveWorldMapSign(GetPointX(markerJeep), GetPointY(markerJeep), 0);

		m_uBoat.ChangePlayer(m_pNeutralUnits);
		m_uBoat.SetUnitName("translateUSAHeroName_Empty");
		m_uJeep.ChangePlayer(m_pPlayer);
		m_uJeep.SetUnitName(null);

		m_bCheckBoat = false;

		PoliceAttackUnit(m_uJeep);

		SetGoalState(goalCaptureJeep, goalAchieved);

		EnableGoal(goalCaptureHelicopter, true);
		AddBriefing("translateBriefingMissionIRQ_3_CaptureHelicopter");

		AddWorldMapSign(GetPointX(markerHelicopter), GetPointY(markerHelicopter), 0, 0, 65000);

		return CaptureHelicopter;
	}

	state CaptureHelicopter
	{
		if ( Distance(m_uHelicopter.GetLocationX(), m_uHelicopter.GetLocationY(), m_uJeep.GetLocationX(), m_uJeep.GetLocationY()) <= 1 )
		{
			return CapturedHelicopter;
		}
		else
		{
			return CaptureHelicopter;
		}
	}

	state CapturedHelicopter
	{
		RemoveWorldMapSign(GetPointX(markerHelicopter), GetPointY(markerHelicopter), 0);

		m_uJeep.ChangePlayer(m_pNeutralUnits);
		m_uJeep.SetUnitName("translateUSAHeroName_Empty");
		m_uHelicopter.ChangePlayer(m_pPlayer);
		m_uHelicopter.SetUnitName(null);

		m_bCheckJeep = false;

		PoliceAttackUnit(m_uHelicopter);

		SetGoalState(goalCaptureHelicopter, goalAchieved);

		EnableGoal(goalFindPrizoner, true);
		AddBriefing("translateBriefingMissionIRQ_3_FindPrizoner");

		CreateArtefact("ARTIFACT_PRISONER", GetPointX(markerPrizoner), GetPointY(markerPrizoner), 0, idPrizoner);

		AddWorldMapSign(GetPointX(markerPrizoner), GetPointY(markerPrizoner), 0, 0, 65000);

		return FindPrizoner;
	}

	state FindPrizoner
	{
		return FindPrizoner;
	}

	state FoundPrizoner
	{
		RemoveWorldMapSign(GetPointX(markerPrizoner), GetPointY(markerPrizoner), 0);

		SetGoalState(goalFindPrizoner, goalAchieved);

		EnableGoal(goalEvacuatePrizoner, true);
		AddBriefing("translateBriefingMissionIRQ_3_EvacuatePrizoner");

		AddWorldMapSign(GetPointX(markerEvacuationArea), GetPointY(markerEvacuationArea), 0, 0, 65000);

		return EvacuatePrizoner;
	}

	state EvacuatePrizoner
	{
		if ( Distance(m_uHelicopter.GetLocationX(), m_uHelicopter.GetLocationY(), GetPointX(markerEvacuationArea), GetPointY(markerEvacuationArea)) <= 4 )
		{
			return EvacuatedPrizoner;
		}
		else
		{
			return EvacuatePrizoner;
		}
	}

	state EvacuatedPrizoner
	{
		SetGoalState(goalEvacuatePrizoner, goalAchieved);

		AddBriefing("translateBriefingMissionIRQ_3_MissionComplete");

		EnableEndMissionButton(true, true);

		return MissionComplete;
	}

	state MissionComplete
	{
		return MissionComplete;
	}

	event UnitDestroyed(unit uUnit)
	{
		m_bCheckNumberOfUnits = true;

		m_bCheckDestroyedUnits = true;

		if ( state == CapturePoliceCar )
		{
			if ( Distance(uUnit.GetLocationX(), uUnit.GetLocationY(), GetPointX(markerRafineryArea), GetPointY(markerRafineryArea)) <= 8 )
			{
				m_uPoliceCarC1.CommandMove(GetPointX(markerRafineryArea), GetPointY(markerRafineryArea), 0);
				m_uPoliceCarC2.CommandMove(GetPointX(markerRafineryArea), GetPointY(markerRafineryArea), 0);
				m_uPoliceCarC3.CommandMove(GetPointX(markerRafineryArea), GetPointY(markerRafineryArea), 0);
				m_uPoliceCarC4.CommandMove(GetPointX(markerRafineryArea), GetPointY(markerRafineryArea), 0);
				m_uPoliceCarC5.CommandMove(GetPointX(markerRafineryArea), GetPointY(markerRafineryArea), 0);
				m_uPoliceCarC6.CommandMove(GetPointX(markerRafineryArea), GetPointY(markerRafineryArea), 0);
			}
			else
			{
				m_nDetonatedUnit = m_nDetonatedUnit + 1;

				if ( m_nDetonatedUnit % 2 )
				{
					m_uPoliceCarA1.CommandMove(uUnit.GetLocationX(), uUnit.GetLocationY(), 0);
					m_uPoliceCarA2.CommandMove(uUnit.GetLocationX(), uUnit.GetLocationY(), 0);
					m_uPoliceCarA3.CommandMove(uUnit.GetLocationX(), uUnit.GetLocationY(), 0);

					if ( GetDifficultyLevel() > 0 )
					{
						m_uPoliceCarMedium1.CommandMove(uUnit.GetLocationX(), uUnit.GetLocationY(), 0);
						m_uPoliceCarMedium2.CommandMove(uUnit.GetLocationX(), uUnit.GetLocationY(), 0);
						m_uPoliceCarMedium3.CommandMove(uUnit.GetLocationX(), uUnit.GetLocationY(), 0);
					}

					if ( GetDifficultyLevel() > 1 )
					{
						m_uPoliceCarHard1.CommandMove(uUnit.GetLocationX(), uUnit.GetLocationY(), 0);
						m_uPoliceCarHard2.CommandMove(uUnit.GetLocationX(), uUnit.GetLocationY(), 0);
						m_uPoliceCarHard3.CommandMove(uUnit.GetLocationX(), uUnit.GetLocationY(), 0);
					}
				}
				else
				{
					m_uPoliceCarB1.CommandMove(uUnit.GetLocationX(), uUnit.GetLocationY(), 0);
					m_uPoliceCarB2.CommandMove(uUnit.GetLocationX(), uUnit.GetLocationY(), 0);
					m_uPoliceCarB3.CommandMove(uUnit.GetLocationX(), uUnit.GetLocationY(), 0);
				}
			}
		}
		else if ( state != Initialize )
		{
			m_uPoliceCarB1.CommandMove(uUnit.GetLocationX(), uUnit.GetLocationY(), 0);
			m_uPoliceCarB2.CommandMove(uUnit.GetLocationX(), uUnit.GetLocationY(), 0);
			m_uPoliceCarB3.CommandMove(uUnit.GetLocationX(), uUnit.GetLocationY(), 0);
		}
	}

	event BuildingDestroyed(unit uBuilding)
	{
		m_bCheckNumberOfBuildings = true;
	}

	event Artefact(int nArtefactNum, player pPlayerOnArtefact)
	{
		if ( nArtefactNum == idPrizoner )
		{
			state FoundPrizoner;
		}

		true;
	}

	function int MissionFail()
	{
		if ( state == CapturePoliceCar )
		{
			SetGoalState(goalCapturePoliceCar, goalFailed);
		}
		else if ( state == CaptureBoat )
		{
			SetGoalState(goalCaptureBoat, goalFailed);
		}
		else if ( state == CaptureJeep )
		{
			SetGoalState(goalCaptureJeep, goalFailed);
		}
		else if ( state == CaptureHelicopter )
		{
			SetGoalState(goalCaptureHelicopter, goalFailed);
		}
		else if ( state == FindPrizoner )
		{
			SetGoalState(goalFindPrizoner, goalFailed);
		}
		else if ( state == EvacuatePrizoner )
		{
			SetGoalState(goalEvacuatePrizoner, goalFailed);
		}

		AddBriefing("translateBriefingMissionIRQ_3_MissionFail");

		EnableEndMissionButton(true, false);

		state MissionComplete;
	}

	function int CheckDestroyedUnits()
	{
		if ( state == MissionComplete ) return;

		if ( m_bCheckHero && !m_uHero.IsLive() )
		{
			MissionFail();
		}
		else if ( m_bCheckPoliceCar && !m_uPoliceCar.IsLive() )
		{
			MissionFail();
		}
		else if ( m_bCheckBoat && !m_uBoat.IsLive() )
		{
			MissionFail();
		}
		else if ( m_bCheckJeep && !m_uJeep.IsLive() )
		{
			MissionFail();
		}
		else if ( m_bCheckHelicopter && !m_uHelicopter.IsLive() )
		{
			MissionFail();
		}
	}

	event Timer0()
	{
		if ( m_bCheckDestroyedUnits )
		{
			m_bCheckDestroyedUnits = false;

			CheckDestroyedUnits();
		}
	}

	event SetupInterface()
	{
	}
}
