mission "translateMissionIRQ_4"
{
	consts
	{
		goalFindFactory = 0;
		goalBombInGasStation = 1;
		goalBombInAirport = 2;
		goalStartTrain = 3;
		goalEvacuateHero = 4;

		markerHero = 0;
		markerGasStation = 1; // 2 (?)
		markerAirport = 3;

		markerTrainStarter = 36;
		markerTrainA = 44;
		markerTrainB = 45;

		markerEvacuationArea = 37;
		markerMiner = 38;
		markerTank1 = 39;
		markerTank2 = 40;

		markerSupplyer = 41;
		markerGenerator = 42;
		markerSupplyDepot = 43;

		markerPoliceCarAFirst = 4;
		markerPoliceCarBFirst = 13;
		markerPoliceCarAFirst2 = 50;

		markerFactoryAreaFrom = 34;
		markerFactoryAreaTo = 35;

		idTrainStarter = 12345;
		idAirportBomb = 12346;
		idGasStationBomb = 12347;
	}

	include "Research.ech"
	include "Varia.ech"

	player m_pPlayer;

	player m_pEnemyUnits;
	player m_pPoliceUnits;

	player m_pFactory;

	unitex m_uHero;

	unitex m_uTrain;

	unitex m_uMiner;
	unitex m_uTank1;
	unitex m_uTank2;

	unitex m_uSupplyer;
	unitex m_uGenerator;
	unitex m_uSupplyDepot;

	unitex m_uPoliceCarA1;
	unitex m_uPoliceCarA2;
	unitex m_uPoliceCarA3;
	unitex m_uPoliceCarA4;
	unitex m_uPoliceCarA5;
	unitex m_uPoliceCarA6;
	unitex m_uPoliceCarA7;
	unitex m_uPoliceCarA8;
	unitex m_uPoliceCarA9;
	unitex m_uPoliceCarA10;
	unitex m_uPoliceCarA11;
	unitex m_uPoliceCarA12;
	unitex m_uPoliceCarA13;

	unitex m_uPoliceCarB1;
	unitex m_uPoliceCarB2;
	unitex m_uPoliceCarB3;
	unitex m_uPoliceCarB4;
	unitex m_uPoliceCarB5;
	unitex m_uPoliceCarB6;
	unitex m_uPoliceCarB7;
	unitex m_uPoliceCarB8;
	unitex m_uPoliceCarB9;
	unitex m_uPoliceCarB10;
	unitex m_uPoliceCarB11;
	unitex m_uPoliceCarB12;
	unitex m_uPoliceCarB13;
	unitex m_uPoliceCarB14;
	unitex m_uPoliceCarB15;
	unitex m_uPoliceCarB16;
	unitex m_uPoliceCarB17;
	unitex m_uPoliceCarB18;
	unitex m_uPoliceCarB19;
	unitex m_uPoliceCarB20;
	unitex m_uPoliceCarB21;

	int m_nTimeOfAirportBombDetonation;
	int m_nTimeOfGasStationBombDetonation;

	int m_nTimeOfPoliceAttack;

	int m_bPoliceABusy;
	int m_bPoliceBBusy;

	int m_bCheckNumberOfUnits;
	int m_bCheckNumberOfBuildings;

	state Initialize;
	state Start;
	state BeforeStart;
	state FindFactory;
	state FoundFactory;
	state StartTrain;
	state StartedTrain;
	state EvacuateHero;
	state EvacuatedHero;
	state MissionComplete;

	function int PoliceAAttack(unitex uUnit)
	{
		m_uPoliceCarA1.CommandAttack(uUnit);
		m_uPoliceCarA2.CommandAttack(uUnit);
		m_uPoliceCarA3.CommandAttack(uUnit);
		m_uPoliceCarA4.CommandAttack(uUnit);
		m_uPoliceCarA5.CommandAttack(uUnit);
		m_uPoliceCarA6.CommandAttack(uUnit);
		m_uPoliceCarA7.CommandAttack(uUnit);
		m_uPoliceCarA8.CommandAttack(uUnit);
		m_uPoliceCarA9.CommandAttack(uUnit);
		m_uPoliceCarA10.CommandAttack(uUnit);
		m_uPoliceCarA11.CommandAttack(uUnit);
		m_uPoliceCarA12.CommandAttack(uUnit);
		m_uPoliceCarA13.CommandAttack(uUnit);
	}

	function int PoliceBAttack(unitex uUnit)
	{
		m_uPoliceCarB1.CommandAttack(uUnit);
		m_uPoliceCarB2.CommandAttack(uUnit);
		m_uPoliceCarB3.CommandAttack(uUnit);
		m_uPoliceCarB4.CommandAttack(uUnit);
		m_uPoliceCarB5.CommandAttack(uUnit);
		m_uPoliceCarB6.CommandAttack(uUnit);
		m_uPoliceCarB7.CommandAttack(uUnit);
		m_uPoliceCarB8.CommandAttack(uUnit);
		m_uPoliceCarB9.CommandAttack(uUnit);
		m_uPoliceCarB10.CommandAttack(uUnit);
		m_uPoliceCarB11.CommandAttack(uUnit);
		m_uPoliceCarB12.CommandAttack(uUnit);
		m_uPoliceCarB13.CommandAttack(uUnit);
		m_uPoliceCarB14.CommandAttack(uUnit);
		m_uPoliceCarB15.CommandAttack(uUnit);
		m_uPoliceCarB16.CommandAttack(uUnit);
		m_uPoliceCarB17.CommandAttack(uUnit);
		m_uPoliceCarB18.CommandAttack(uUnit);
		m_uPoliceCarB19.CommandAttack(uUnit);
		m_uPoliceCarB20.CommandAttack(uUnit);
		m_uPoliceCarB21.CommandAttack(uUnit);
	}

	function int PoliceAMove(int nGx, int nGy, int nGz)
	{
		m_uPoliceCarA1.CommandMove(nGx, nGy, nGz);
		m_uPoliceCarA2.CommandMove(nGx, nGy, nGz);
		m_uPoliceCarA3.CommandMove(nGx, nGy, nGz);
		m_uPoliceCarA4.CommandMove(nGx, nGy, nGz);
		m_uPoliceCarA5.CommandMove(nGx, nGy, nGz);
		m_uPoliceCarA6.CommandMove(nGx, nGy, nGz);
		m_uPoliceCarA7.CommandMove(nGx, nGy, nGz);
		m_uPoliceCarA8.CommandMove(nGx, nGy, nGz);
		m_uPoliceCarA9.CommandMove(nGx, nGy, nGz);
		m_uPoliceCarA10.CommandMove(nGx, nGy, nGz);
		m_uPoliceCarA11.CommandMove(nGx, nGy, nGz);
		m_uPoliceCarA12.CommandMove(nGx, nGy, nGz);
		m_uPoliceCarA13.CommandMove(nGx, nGy, nGz);
	}

	function int PoliceBMove(int nGx, int nGy, int nGz)
	{
		m_uPoliceCarB1.CommandMove(nGx, nGy, nGz);
		m_uPoliceCarB2.CommandMove(nGx, nGy, nGz);
		m_uPoliceCarB3.CommandMove(nGx, nGy, nGz);
		m_uPoliceCarB4.CommandMove(nGx, nGy, nGz);
		m_uPoliceCarB5.CommandMove(nGx, nGy, nGz);
		m_uPoliceCarB6.CommandMove(nGx, nGy, nGz);
		m_uPoliceCarB7.CommandMove(nGx, nGy, nGz);
		m_uPoliceCarB8.CommandMove(nGx, nGy, nGz);
		m_uPoliceCarB9.CommandMove(nGx, nGy, nGz);
		m_uPoliceCarB10.CommandMove(nGx, nGy, nGz);
		m_uPoliceCarB11.CommandMove(nGx, nGy, nGz);
		m_uPoliceCarB12.CommandMove(nGx, nGy, nGz);
		m_uPoliceCarB13.CommandMove(nGx, nGy, nGz);
		m_uPoliceCarB14.CommandMove(nGx, nGy, nGz);
		m_uPoliceCarB15.CommandMove(nGx, nGy, nGz);
		m_uPoliceCarB16.CommandMove(nGx, nGy, nGz);
		m_uPoliceCarB17.CommandMove(nGx, nGy, nGz);
		m_uPoliceCarB18.CommandMove(nGx, nGy, nGz);
		m_uPoliceCarB19.CommandMove(nGx, nGy, nGz);
		m_uPoliceCarB20.CommandMove(nGx, nGy, nGz);
		m_uPoliceCarB21.CommandMove(nGx, nGy, nGz);
	}

	function int CreateTrain(int nPoint)
	{
		int nGx, nGy, nGz;

		unitex uTrain;

		nGx = GetPointX(nPoint);
		nGy = GetPointY(nPoint);
		nGz = GetPointZ(nPoint);

		m_uTrain = CreatePassive(nGx, nGy, nGz, 3*64, "NE_ELEKT");

		CreatePassive(nGx+ 2, nGy, nGz, 3*64, "NE_TOW1");
		CreatePassive(nGx+ 4, nGy, nGz, 3*64, "NE_TOW1");
		CreatePassive(nGx+ 6, nGy, nGz, 3*64, "NE_TOW1");
		CreatePassive(nGx+ 8, nGy, nGz, 3*64, "NE_TOW3");
		CreatePassive(nGx+10, nGy, nGz, 3*64, "NE_TOW3");
		CreatePassive(nGx+12, nGy, nGz, 3*64, "NE_TOW3");
	}

	function int ModifyDifficulty()
	{
		if ( GetDifficultyLevel() == 0 )
		{
			ClearArea	(65535, GetPointX(47), GetPointY(47), GetPointZ(47), 0);
			ClearArea	(65535, GetPointX(48), GetPointY(48), GetPointZ(48), 0);
			ClearArea	(65535, GetPointX(49), GetPointY(49), GetPointZ(49), 0);
		}
		else if ( GetDifficultyLevel() == 1 )
		{
			ClearArea	(65535, GetPointX(46), GetPointY(46), GetPointZ(46), 0);
			ClearArea	(65535, GetPointX(48), GetPointY(48), GetPointZ(48), 0);
			ClearArea	(65535, GetPointX(49), GetPointY(49), GetPointZ(49), 0);
		}
		else if ( GetDifficultyLevel() == 2 )
		{
			ClearArea	(65535, GetPointX(46), GetPointY(46), GetPointZ(46), 0);
		}
	}

	state Initialize
	{
		int i;
		unitex uTmp;

		ModifyDifficulty();

		RegisterGoal(goalFindFactory, "translateGoalMissionIRQ_4_FindFactory");
		RegisterGoal(goalBombInGasStation, "translateGoalMissionIRQ_4_BombInGasStation");
		RegisterGoal(goalBombInAirport, "translateGoalMissionIRQ_4_BombInAirport");
		RegisterGoal(goalStartTrain, "translateGoalMissionIRQ_4_StartTrain");
		RegisterGoal(goalEvacuateHero, "translateGoalMissionIRQ_4_EvacuateHero");

		m_bPoliceABusy = false;
		m_bPoliceBBusy = false;

		m_nTimeOfGasStationBombDetonation = 0;
		m_nTimeOfAirportBombDetonation = 0;

		m_pPlayer = GetPlayer(3);
		m_pPlayer.EnableStatistics(false);

		m_pEnemyUnits = GetPlayer(0);
		m_pEnemyUnits.EnableStatistics(false);

		m_pPoliceUnits = GetPlayer(1);
		m_pPoliceUnits.EnableStatistics(false);

		m_pFactory = GetPlayer(2);
		m_pFactory.EnableStatistics(false);

		m_pEnemyUnits.EnableAI(false);
		m_pPoliceUnits.EnableAI(false);
		m_pFactory.EnableAI(false);

		m_uHero = GetUnit(GetPointX(markerHero), GetPointY(markerHero));

		m_uSupplyer = GetUnit(GetPointX(markerSupplyer), GetPointY(markerSupplyer));
		m_uGenerator = GetUnit(GetPointX(markerGenerator), GetPointY(markerGenerator));
		m_uSupplyDepot = GetUnit(GetPointX(markerSupplyDepot), GetPointY(markerSupplyDepot));

		CreateTrain(markerTrainA);

		m_uMiner = GetUnit(GetPointX(markerMiner), GetPointY(markerMiner));
		m_uTank1 = GetUnit(GetPointX(markerTank1), GetPointY(markerTank1));
		m_uTank2 = GetUnit(GetPointX(markerTank2), GetPointY(markerTank2));

		m_uPoliceCarA1 = GetUnit(GetPointX(markerPoliceCarAFirst+0), GetPointY(markerPoliceCarAFirst+0));
		m_uPoliceCarA2 = GetUnit(GetPointX(markerPoliceCarAFirst+1), GetPointY(markerPoliceCarAFirst+1));
		m_uPoliceCarA3 = GetUnit(GetPointX(markerPoliceCarAFirst+2), GetPointY(markerPoliceCarAFirst+2));
		m_uPoliceCarA4 = GetUnit(GetPointX(markerPoliceCarAFirst+3), GetPointY(markerPoliceCarAFirst+3));
		m_uPoliceCarA5 = GetUnit(GetPointX(markerPoliceCarAFirst+4), GetPointY(markerPoliceCarAFirst+4));
		m_uPoliceCarA6 = GetUnit(GetPointX(markerPoliceCarAFirst+5), GetPointY(markerPoliceCarAFirst+5));
		m_uPoliceCarA7 = GetUnit(GetPointX(markerPoliceCarAFirst+6), GetPointY(markerPoliceCarAFirst+6));
		m_uPoliceCarA8 = GetUnit(GetPointX(markerPoliceCarAFirst+7), GetPointY(markerPoliceCarAFirst+7));
		m_uPoliceCarA9 = GetUnit(GetPointX(markerPoliceCarAFirst+8), GetPointY(markerPoliceCarAFirst+8));

		m_uPoliceCarA10 = GetUnit(GetPointX(markerPoliceCarAFirst2+0), GetPointY(markerPoliceCarAFirst2+0));
		m_uPoliceCarA11 = GetUnit(GetPointX(markerPoliceCarAFirst2+1), GetPointY(markerPoliceCarAFirst2+1));
		m_uPoliceCarA12 = GetUnit(GetPointX(markerPoliceCarAFirst2+2), GetPointY(markerPoliceCarAFirst2+2));
		m_uPoliceCarA13 = GetUnit(GetPointX(markerPoliceCarAFirst2+3), GetPointY(markerPoliceCarAFirst2+3));

		m_uPoliceCarB1 = GetUnit(GetPointX(markerPoliceCarBFirst+0), GetPointY(markerPoliceCarBFirst+0));
		m_uPoliceCarB2 = GetUnit(GetPointX(markerPoliceCarBFirst+1), GetPointY(markerPoliceCarBFirst+1));
		m_uPoliceCarB3 = GetUnit(GetPointX(markerPoliceCarBFirst+2), GetPointY(markerPoliceCarBFirst+2));
		m_uPoliceCarB4 = GetUnit(GetPointX(markerPoliceCarBFirst+3), GetPointY(markerPoliceCarBFirst+3));
		m_uPoliceCarB5 = GetUnit(GetPointX(markerPoliceCarBFirst+4), GetPointY(markerPoliceCarBFirst+4));
		m_uPoliceCarB6 = GetUnit(GetPointX(markerPoliceCarBFirst+5), GetPointY(markerPoliceCarBFirst+5));
		m_uPoliceCarB7 = GetUnit(GetPointX(markerPoliceCarBFirst+6), GetPointY(markerPoliceCarBFirst+6));
		m_uPoliceCarB8 = GetUnit(GetPointX(markerPoliceCarBFirst+7), GetPointY(markerPoliceCarBFirst+7));
		m_uPoliceCarB9 = GetUnit(GetPointX(markerPoliceCarBFirst+8), GetPointY(markerPoliceCarBFirst+8));
		m_uPoliceCarB10 = GetUnit(GetPointX(markerPoliceCarBFirst+9), GetPointY(markerPoliceCarBFirst+9));
		m_uPoliceCarB11 = GetUnit(GetPointX(markerPoliceCarBFirst+10), GetPointY(markerPoliceCarBFirst+10));
		m_uPoliceCarB12 = GetUnit(GetPointX(markerPoliceCarBFirst+11), GetPointY(markerPoliceCarBFirst+11));
		m_uPoliceCarB13 = GetUnit(GetPointX(markerPoliceCarBFirst+12), GetPointY(markerPoliceCarBFirst+12));
		m_uPoliceCarB14 = GetUnit(GetPointX(markerPoliceCarBFirst+13), GetPointY(markerPoliceCarBFirst+13));
		m_uPoliceCarB15 = GetUnit(GetPointX(markerPoliceCarBFirst+14), GetPointY(markerPoliceCarBFirst+14));
		m_uPoliceCarB16 = GetUnit(GetPointX(markerPoliceCarBFirst+15), GetPointY(markerPoliceCarBFirst+15));
		m_uPoliceCarB17 = GetUnit(GetPointX(markerPoliceCarBFirst+16), GetPointY(markerPoliceCarBFirst+16));
		m_uPoliceCarB18 = GetUnit(GetPointX(markerPoliceCarBFirst+17), GetPointY(markerPoliceCarBFirst+17));
		m_uPoliceCarB19 = GetUnit(GetPointX(markerPoliceCarBFirst+18), GetPointY(markerPoliceCarBFirst+18));
		m_uPoliceCarB20 = GetUnit(GetPointX(markerPoliceCarBFirst+19), GetPointY(markerPoliceCarBFirst+19));
		m_uPoliceCarB21 = GetUnit(GetPointX(markerPoliceCarBFirst+20), GetPointY(markerPoliceCarBFirst+20));

		for (i=markerPoliceCarAFirst; i<=markerPoliceCarAFirst+8; i=i+1)
		{
			uTmp = GetUnit(GetPointX(i), GetPointY(i));
			if ( uTmp )
			{
				uTmp.CommandSetMovementMode(1); // follow enemy
				uTmp.CommandSetAttackMode(0); // fire at will
			}
		}
		for (i=markerPoliceCarAFirst2; i<=markerPoliceCarAFirst2+3; i=i+1)
		{
			uTmp = GetUnit(GetPointX(i), GetPointY(i));
			if ( uTmp )
			{
				uTmp.CommandSetMovementMode(1); // follow enemy
				uTmp.CommandSetAttackMode(0); // fire at will
			}
		}
		for (i=markerPoliceCarBFirst; i<=markerPoliceCarBFirst+20; i=i+1)
		{
			uTmp = GetUnit(GetPointX(i), GetPointY(i));
			if ( uTmp )
			{
				uTmp.CommandSetMovementMode(1); // follow enemy
				uTmp.CommandSetAttackMode(0); // fire at will
			}
		}

		m_pPlayer.LookAt(m_pPlayer.GetStartingPointX(), m_pPlayer.GetStartingPointY(), 6, 0, 0, 0);

		EnableAllResearchIRQ( m_pPlayer, false);
		m_pPlayer.EnableResearch("RES_IRQ_TANK1", true);			// M1
		m_pPlayer.EnableResearch("RES_IRQ_HELICOPTER1", true);		// M2
		m_pPlayer.EnableResearch("RES_IRQ_AMMO_MG1", true);			// M3
		m_pPlayer.EnableResearch("RES_IRQ_PILLBOX", true);			// M3
		m_pPlayer.EnableResearch("RES_IRQ_TANK2", true);			// M3
		m_pPlayer.EnableResearch("RES_IRQ_SAPER", true);			// M3
		m_pPlayer.EnableResearch("RES_IRQ_MIM", true);				// M3
		m_pPlayer.EnableResearch("RES_IRQ_AMMO_MG2", true);
		m_pPlayer.EnableResearch("RES_IRQ_RART", true);
		m_pPlayer.EnableResearch("RES_IRQ_HRART", true);
		m_pPlayer.EnableResearch("RES_IRQ_AMMO_MIM1", true);
		m_pPlayer.EnableResearch("RES_IRQ_SPECIAL_FILTER2", true);

		m_pPlayer.EnableCommand(commandRecycleUnit, false);
		m_pPlayer.EnableCommand(commandSoldBuilding, false);

		return BeforeStart, 1;
	}

	state BeforeStart
	{
		PlayTrack("Music\\Briefing.tws");

		return Start;
	}

	state Start
	{
		EnableGoal(goalFindFactory, true);
		EnableGoal(goalBombInGasStation, true);
		EnableGoal(goalBombInAirport, true);
		AddBriefing("translateBriefingMissionIRQ_4_FindFactory");
		PlayWave("Briefings\\IRQ_Briefing04.wav");

		AddWorldMapSign(GetPointX(markerAirport), GetPointY(markerAirport), 0, 1, 65000);
		AddWorldMapSign(GetPointX(markerGasStation), GetPointY(markerGasStation), 0, 1, 65000);

		CreateArtefact("ARTIFACT_CLICK_ME", GetPointX(markerAirport), GetPointY(markerAirport), 0, idAirportBomb);
		CreateArtefact("ARTIFACT_CLICK_ME", GetPointX(markerGasStation), GetPointY(markerGasStation), 0, idGasStationBomb);

		m_pFactory.EnableAIFeatures2(ai2ChooseEnemy, false);

		m_pFactory.SetNeutral(m_pPlayer);
		m_pPlayer.SetNeutral(m_pFactory);

		return FindFactory;
	}

	state FindFactory
	{
		if ( m_nTimeOfGasStationBombDetonation && GetMissionTime() >= m_nTimeOfGasStationBombDetonation )
		{
			KillArea(65535, GetPointX(markerGasStation), GetPointY(markerGasStation), 0, 7);

			PoliceAMove(GetPointX(markerGasStation), GetPointY(markerGasStation), 0);

			m_bPoliceABusy = true;

			m_nTimeOfGasStationBombDetonation = 0;
		}

		if ( m_nTimeOfAirportBombDetonation && GetMissionTime() >= m_nTimeOfAirportBombDetonation )
		{
			KillArea(65535, GetPointX(markerAirport), GetPointY(markerAirport), 0, 7);

			PoliceBMove(GetPointX(markerAirport), GetPointY(markerAirport), 0);

			m_bPoliceBBusy = true;

			m_nTimeOfAirportBombDetonation = 0;
		}

		if ( IsUnitInArea(m_uHero, markerFactoryAreaFrom, markerFactoryAreaTo) )
		{
			return FoundFactory;
		}
		else
		{
			return FindFactory;
		}
	}

	state FoundFactory
	{
		RemoveWorldMapSign((GetPointX(markerFactoryAreaFrom)+GetPointX(markerFactoryAreaTo))/2, (GetPointY(markerFactoryAreaFrom)+GetPointY(markerFactoryAreaTo))/2, 0);

		if ( !m_bPoliceABusy )
		{
			PoliceAAttack(m_uHero);
		}

		if ( !m_bPoliceBBusy )
		{
			PoliceBAttack(m_uHero);
		}

		m_nTimeOfPoliceAttack = GetMissionTime() + 2*60*20;

		m_uMiner.ChangePlayer(m_pPlayer);
		m_uTank1.ChangePlayer(m_pPlayer);
		m_uTank2.ChangePlayer(m_pPlayer);
		m_uSupplyer.ChangePlayer(m_pPlayer);
		m_uGenerator.ChangePlayer(m_pPlayer);
		m_uSupplyDepot.ChangePlayer(m_pPlayer);

		SetGoalState(goalFindFactory, goalAchieved);

		EnableGoal(goalStartTrain, true);
		AddBriefing("translateBriefingMissionIRQ_4_StartTrain");

		CreateArtefact("ARTIFACT_CLICK_ME", GetPointX(markerTrainStarter), GetPointY(markerTrainStarter), GetPointZ(markerTrainStarter), idTrainStarter);

		return StartTrain;
	}

	state StartTrain
	{
		if ( GetMissionTime() >= m_nTimeOfPoliceAttack )
		{
			PoliceAAttack(m_uHero);
			PoliceBAttack(m_uHero);
		}

		return StartTrain;
	}

	state StartedTrain
	{
		PoliceAAttack(m_uHero);
		PoliceBAttack(m_uHero);

		m_uTrain.StartTrain(-1, -1, trainModeMoveToEndOfWorld, 20);

		CreateTrain(markerTrainB);
		m_uTrain.StartTrain(-1, -1, trainModeMoveToEndOfWorld, 20);

		SetGoalState(goalStartTrain, goalAchieved);

		EnableGoal(goalEvacuateHero, true);
		AddBriefing("translateBriefingMissionIRQ_4_EvacuateHero");

		AddWorldMapSign(GetPointX(markerEvacuationArea), GetPointY(markerEvacuationArea), 0, 0, 65000);

		return EvacuateHero;
	}

	state EvacuateHero
	{
		if ( Distance(m_uHero.GetLocationX(), m_uHero.GetLocationY(), GetPointX(markerEvacuationArea), GetPointY(markerEvacuationArea)) <= 10 )
		{
			return EvacuatedHero;
		}
		else
		{
			return EvacuateHero;
		}
	}

	state EvacuatedHero
	{
		SetGoalState(goalEvacuateHero, goalAchieved);

		RemoveWorldMapSign(GetPointX(markerEvacuationArea), GetPointY(markerEvacuationArea), 0);

		AddBriefing("translateBriefingMissionIRQ_4_MissionComplete");

		EnableEndMissionButton(true, true);

		return MissionComplete;
	}

	state MissionComplete
	{
		return MissionComplete;
	}

	event UnitDestroyed(unit uUnit)
	{
		m_bCheckNumberOfUnits = true;

		if ( uUnit == m_uHero )
		{
			if ( GetGoalState(goalBombInGasStation) != goalAchieved )
			{
				SetGoalState(goalBombInGasStation, goalFailed);
			}

			if ( GetGoalState(goalBombInAirport) != goalAchieved )
			{
				SetGoalState(goalBombInAirport, goalFailed);
			}

			if ( state == FindFactory )
			{
				SetGoalState(goalFindFactory, goalFailed);
			}
			else if ( state == StartTrain )
			{
				SetGoalState(goalStartTrain, goalFailed);
			}
			else if ( state == EvacuateHero )
			{
				SetGoalState(goalEvacuateHero, goalFailed);
			}

			AddBriefing("translateBriefingMissionIRQ_4_MissionFail");

			EnableEndMissionButton(true, false);

			state MissionComplete;
		}
	}

	event BuildingDestroyed(unit uBuilding)
	{
		m_bCheckNumberOfBuildings = true;
	}

	event Artefact(int nArtefactNum, player pPlayerOnArtefact)
	{
		if ( pPlayerOnArtefact != m_pPlayer )
		{
			false;
		}
		else if ( nArtefactNum == idTrainStarter )
		{
			state StartedTrain;

			true;
		}
		else if ( nArtefactNum == idGasStationBomb )
		{
			if ( GetUnit(GetPointX(markerGasStation), GetPointY(markerGasStation)) == m_uHero )
			{
				SetGoalState(goalBombInGasStation, goalAchieved);
				AddBriefing("translateBriefingMissionIRQ_4_BombInGasStation");

				RemoveWorldMapSign(GetPointX(markerGasStation), GetPointY(markerGasStation), 0);

				if ( m_bPoliceBBusy )
				{
					AddWorldMapSign((GetPointX(markerFactoryAreaFrom)+GetPointX(markerFactoryAreaTo))/2, (GetPointY(markerFactoryAreaFrom)+GetPointY(markerFactoryAreaTo))/2, 0, 0, 65000);
				}

				m_nTimeOfGasStationBombDetonation = GetMissionTime() + (60-(15*GetDifficultyLevel()))*20;

				true;
			}
			else
			{
				false;
			}
		}
		else if ( nArtefactNum == idAirportBomb )
		{
			if ( GetUnit(GetPointX(markerAirport), GetPointY(markerAirport)) == m_uHero )
			{
				SetGoalState(goalBombInAirport, goalAchieved);
				AddBriefing("translateBriefingMissionIRQ_4_BombInAirport");

				RemoveWorldMapSign(GetPointX(markerAirport), GetPointY(markerAirport), 0);

				if ( m_bPoliceABusy )
				{
					AddWorldMapSign((GetPointX(markerFactoryAreaFrom)+GetPointX(markerFactoryAreaTo))/2, (GetPointY(markerFactoryAreaFrom)+GetPointY(markerFactoryAreaTo))/2, 0, 0, 65000);
				}

				m_nTimeOfAirportBombDetonation = GetMissionTime() + (60-(15*GetDifficultyLevel()))*20;

				true;
			}
			else
			{
				false;
			}
		}
		else
		{
			false;
		}
	}


	event SetupInterface()
	{
	}
}
