mission "translateMissionIRQ_5"
{
	consts
	{
		goalAttackEnemyA = 0;
		goalMoveToNuclearBaseArea = 1;

		markerNuclearBaseAreaFrom = 31;
		markerNuclearBaseAreaTo = 32;
	}

	include "Research.ech"

	player m_pPlayer;

	player m_pEnemyA;
	player m_pEnemyB;

	player m_pFriendlyUnits;

	int m_bCheckNumberOfUnits;
	int m_bCheckNumberOfBuildings;

	int m_bCheckDestroyedUnits;

	state Initialize;
	state Start;
	state BeforeStart;
	state AttackEnemyA;
	state AttackedEnemyA;
	state MoveToNuclearBaseArea;
	state MovedToNuclearBaseArea;
	state MissionComplete;

	function int GroupMove(int nStartPoint, int nEndPoint, int nGx, int nGy, int nGz)
	{
		int i;
		unitex uTmp;

		for ( i = nStartPoint; i <= nEndPoint; i = i + 1 )
		{
			uTmp = GetUnit(GetPointX(i), GetPointY(i));

			if ( uTmp )
			{
				uTmp.CommandMove(nGx, nGy, nGz);
			}
		}
	}

	function int ModifyDifficulty()
	{
		if ( GetDifficultyLevel() == 0 )
		{
			ClearArea	(65535, GetPointX(35), GetPointY(35), GetPointZ(35), 0);
			ClearArea	(65535, GetPointX(36), GetPointY(36), GetPointZ(36), 0);
			ClearArea	(65535, GetPointX(37), GetPointY(37), GetPointZ(37), 0);
			ClearArea	(65535, GetPointX(38), GetPointY(38), GetPointZ(38), 0);
			ClearArea	(65535, GetPointX(39), GetPointY(39), GetPointZ(39), 0);
			ClearArea	(65535, GetPointX(40), GetPointY(40), GetPointZ(40), 0);
		}
		else if ( GetDifficultyLevel() == 1 )
		{
			ClearArea	(65535, GetPointX(33), GetPointY(33), GetPointZ(33), 0);
			ClearArea	(65535, GetPointX(34), GetPointY(34), GetPointZ(34), 0);
			ClearArea	(65535, GetPointX(38), GetPointY(38), GetPointZ(38), 0);
			ClearArea	(65535, GetPointX(39), GetPointY(39), GetPointZ(39), 0);
			ClearArea	(65535, GetPointX(40), GetPointY(40), GetPointZ(40), 0);
			ClearArea	(65535, GetPointX(41), GetPointY(41), GetPointZ(41), 0);
			ClearArea	(65535, GetPointX(43), GetPointY(43), GetPointZ(43), 0);
		}
		else if ( GetDifficultyLevel() == 2 )
		{
			ClearArea	(65535, GetPointX(33), GetPointY(33), GetPointZ(33), 0);
			ClearArea	(65535, GetPointX(34), GetPointY(34), GetPointZ(34), 0);
			ClearArea	(65535, GetPointX(41), GetPointY(41), GetPointZ(41), 0);
			ClearArea	(65535, GetPointX(42), GetPointY(42), GetPointZ(42), 0);
			ClearArea	(65535, GetPointX(43), GetPointY(43), GetPointZ(43), 0);
			ClearArea	(65535, GetPointX(44), GetPointY(44), GetPointZ(44), 0);
		}
	}

	state Initialize
	{
		ModifyDifficulty();

		RegisterGoal(goalAttackEnemyA, "translateGoalMissionIRQ_5_AttackEnemyA");
		RegisterGoal(goalMoveToNuclearBaseArea, "translateGoalMissionIRQ_5_MoveToNuclearBaseArea");

		m_pPlayer = GetPlayer(3);
		m_pPlayer.EnableStatistics(false);

		m_pEnemyA = GetPlayer(0);
		m_pEnemyA.EnableStatistics(false);

		m_pEnemyB = GetPlayer(1);
		m_pEnemyB.EnableStatistics(false);

		m_pFriendlyUnits = GetPlayer(4);
		m_pFriendlyUnits.EnableStatistics(false);

		m_pEnemyA.LoadScript("single\\singleHard");
		m_pEnemyB.LoadScript("single\\singleHard");

		m_pEnemyA.EnableAI(false);
		m_pEnemyB.EnableAI(false);

		m_pFriendlyUnits.EnableAI(false);
		m_pFriendlyUnits.EnableAIFeatures2(ai2ChooseEnemy, false);

		m_pFriendlyUnits.SetNeutral(m_pPlayer);
		m_pPlayer.SetNeutral(m_pFriendlyUnits);

		m_pPlayer.SpyPlayer(m_pEnemyA, true, 1000000);

		m_pPlayer.SetMoney(0);

		m_pEnemyA.SetMoney(0);
		m_pEnemyB.SetMoney(0);

		m_pPlayer.LookAt(m_pPlayer.GetStartingPointX(), m_pPlayer.GetStartingPointY(), 6, 0, 0, 0);

		EnableAllResearchIRQ( m_pPlayer, false);
		m_pPlayer.EnableResearch("RES_IRQ_TANK1", true);			// M1
		m_pPlayer.EnableResearch("RES_IRQ_HELICOPTER1", true);		// M2
		m_pPlayer.EnableResearch("RES_IRQ_AMMO_MG1", true);			// M3
		m_pPlayer.EnableResearch("RES_IRQ_PILLBOX", true);			// M3
		m_pPlayer.EnableResearch("RES_IRQ_TANK2", true);			// M3
		m_pPlayer.EnableResearch("RES_IRQ_SAPER", true);			// M3
		m_pPlayer.EnableResearch("RES_IRQ_MIM", true);				// M3
		m_pPlayer.EnableResearch("RES_IRQ_AMMO_MG2", true);			// M4
		m_pPlayer.EnableResearch("RES_IRQ_RART", true);				// M4
		m_pPlayer.EnableResearch("RES_IRQ_HRART", true);			// M4
		m_pPlayer.EnableResearch("RES_IRQ_AMMO_MIM1", true);		// M4
		m_pPlayer.EnableResearch("RES_IRQ_SPECIAL_FILTER2", true);	// M4
		m_pPlayer.EnableResearch("RES_IRQ_AMMO_CANNON1", true);
		m_pPlayer.EnableResearch("RES_IRQ_BIGART", true);
		m_pPlayer.EnableResearch("RES_IRQ_AMMO_ROCKET1", true);
		m_pPlayer.EnableResearch("RES_IRQ_AMMO_HROCKET1", true);
		m_pPlayer.EnableResearch("RES_IRQ_MGM", true);
		m_pPlayer.EnableResearch("RES_IRQ_EXPLODER", true);

		SetTimer(0, 100); // CheckDestroyedUnits

		m_pPlayer.EnableCommand(commandRecycleUnit, false);
		m_pPlayer.EnableCommand(commandSoldBuilding, false);

		return BeforeStart, 1;
	}

	state BeforeStart
	{
		PlayTrack("Music\\Briefing.tws");

		return Start;
	}

	state Start
	{
		EnableGoal(goalAttackEnemyA, true);
		AddBriefing("translateBriefingMissionIRQ_5_AttackEnemyA");
		PlayWave("Briefings\\IRQ_Briefing05.wav");

		return AttackEnemyA;
	}

	state AttackEnemyA
	{
		return AttackEnemyA;
	}

	state AttackedEnemyA
	{
		SetGoalState(goalAttackEnemyA, goalAchieved);

		EnableGoal(goalMoveToNuclearBaseArea, true);
		AddBriefing("translateBriefingMissionIRQ_5_MoveToNuclearBaseArea");

		m_pFriendlyUnits.GiveAllUnitsTo(m_pPlayer);

		GroupMove(6, 30, m_pEnemyA.GetStartingPointX(), m_pEnemyA.GetStartingPointY(), 0);

		return MoveToNuclearBaseArea;
	}

	state MoveToNuclearBaseArea
	{
		int nGx, nGy;

		int nFromGx, nFromGy, nToGx, nToGy;

		unitex uUnit;

		nFromGx = GetPointX(markerNuclearBaseAreaFrom);
		nFromGy = GetPointY(markerNuclearBaseAreaFrom);
		nToGx = GetPointX(markerNuclearBaseAreaTo);
		nToGy = GetPointY(markerNuclearBaseAreaTo);

		for ( nGy = nFromGy; nGy <= nToGy; nGy = nGy + 1)
		{
			for ( nGx = nFromGx; nGx <= nToGx; nGx = nGx + 1)
			{
				uUnit = GetUnit(nGx, nGy);

				if ( uUnit.GetIFF() == m_pPlayer.GetIFF() && ! uUnit.IsHelicopter() )
				{
					return MovedToNuclearBaseArea;
				}
			}
		}

		return MoveToNuclearBaseArea;
	}

	state MovedToNuclearBaseArea
	{
		SetGoalState(goalMoveToNuclearBaseArea, goalAchieved);

		AddBriefing("translateBriefingMissionIRQ_5_MissionComplete");

		EndMission(true);

		return MissionComplete;
	}

	state MissionComplete
	{
		return MissionComplete;
	}

	function int CheckDestroyedUnits()
	{
		if ( state == MissionComplete ) return;

		if ( m_pPlayer.GetNumberOfUnits() == 0 )
		{
			if ( GetGoalState(goalAttackEnemyA) != goalAchieved )
			{
				SetGoalState(goalAttackEnemyA, goalFailed);
			}

			if ( GetGoalState(goalMoveToNuclearBaseArea) != goalAchieved )
			{
				SetGoalState(goalMoveToNuclearBaseArea, goalFailed);
			}

			AddBriefing("translateBriefingMissionIRQ_5_MissionFail");

			EnableEndMissionButton(true, false);

			state MissionComplete;
		}
	}

	event Timer0()
	{
		if ( m_bCheckDestroyedUnits )
		{
			m_bCheckDestroyedUnits = false;

			CheckDestroyedUnits();
		}
	}

	event UnitDestroyed(unit uUnit)
	{
		m_bCheckNumberOfUnits = true;
		m_bCheckDestroyedUnits = true;

		if ( state == AttackEnemyA && uUnit.GetIFF() == m_pEnemyA.GetIFF() )
		{
			return AttackedEnemyA;
		}

		if ( state != Initialize && uUnit.GetIFF() == m_pEnemyB.GetIFF() )
		{
			m_pEnemyA.EnableAI(true);
			m_pEnemyB.EnableAI(true);
		}
	}

	event BuildingDestroyed(unit uBuilding)
	{
		m_bCheckNumberOfBuildings = true;

		if ( state == AttackEnemyA && uBuilding.GetIFF() == m_pEnemyA.GetIFF() )
		{
			state AttackedEnemyA;
		}

		if ( state != Initialize && uBuilding.GetIFF() == m_pEnemyB.GetIFF() )
		{
			m_pEnemyA.EnableAI(true);
			m_pEnemyB.EnableAI(true);
		}
	}

	event SetupInterface()
	{
	}
}
