mission "translateMissionIRQ_7"
{
	consts
	{
		goalDestroyEnemy = 0;
	}

	include "UnitTemplates.ech"
	include "Research.ech"

	player m_pPlayer;

	player m_pEnemyA;
	player m_pEnemyB;
	player m_pEnemyC;

	int m_bCheckNumberOfUnits;
	int m_bCheckNumberOfBuildings;

	state Initialize;
	state Start;
	state BeforeStart;
	state DestroyEnemy;
	state DestroyedEnemy;
	state MissionComplete;

	function int ModifyDifficulty()
	{
		if ( GetDifficultyLevel() == 0 )
		{
			ClearArea	(65535, GetPointX( 0), GetPointY( 0), GetPointZ( 0), 0);
			ClearArea	(65535, GetPointX( 3), GetPointY( 3), GetPointZ( 3), 1);
			ClearArea	(65535, GetPointX( 4), GetPointY( 4), GetPointZ( 4), 0);
			ClearArea	(65535, GetPointX( 5), GetPointY( 5), GetPointZ( 5), 0);
		}
		else if ( GetDifficultyLevel() == 1 )
		{
			ClearArea	(65535, GetPointX( 0), GetPointY( 0), GetPointZ( 0), 0);
			ClearArea	(65535, GetPointX( 1), GetPointY( 1), GetPointZ( 1), 0);
			ClearArea	(65535, GetPointX( 4), GetPointY( 4), GetPointZ( 4), 0);
		}
		else if ( GetDifficultyLevel() == 2 )
		{
			ClearArea	(65535, GetPointX( 1), GetPointY( 1), GetPointZ( 1), 0);
			ClearArea	(65535, GetPointX( 2), GetPointY( 2), GetPointZ( 2), 0);
		}
	}

	state Initialize
	{
		ModifyDifficulty();

		RegisterGoal(goalDestroyEnemy, "translateGoalMissionIRQ_7_DestroyEnemy");

		m_pPlayer = GetPlayer(3);
		m_pPlayer.EnableStatistics(true);

		m_pPlayer.SetMilitaryUnitsLimit(50000);

		m_pEnemyA = GetPlayer(0);
		m_pEnemyA.EnableStatistics(true);
		m_pEnemyB = GetPlayer(1);
		m_pEnemyB.EnableStatistics(true);
		m_pEnemyC = GetPlayer(2);
		m_pEnemyC.EnableStatistics(true);

		if ( GetDifficultyLevel() == 0 )
		{
			m_pEnemyA.LoadScript("single\\singleMedium");
			m_pEnemyB.LoadScript("single\\singleMedium");
			m_pEnemyC.LoadScript("single\\singleMedium");

			m_pEnemyA.SetMilitaryUnitsLimit(20000);
			m_pEnemyB.SetMilitaryUnitsLimit(20000);
			m_pEnemyC.SetMilitaryUnitsLimit(20000);
		}
		else if ( GetDifficultyLevel() == 1 )
		{
			m_pEnemyA.LoadScript("single\\singleHard");
			m_pEnemyB.LoadScript("single\\singleHard");
			m_pEnemyC.LoadScript("single\\singleHard");

			m_pEnemyA.SetMilitaryUnitsLimit(50000);
			m_pEnemyB.SetMilitaryUnitsLimit(50000);
			m_pEnemyC.SetMilitaryUnitsLimit(50000);
		}
		else if ( GetDifficultyLevel() == 2 )
		{
			m_pEnemyA.LoadScript("single\\singleHard");
			m_pEnemyB.LoadScript("single\\singleHard");
			m_pEnemyC.LoadScript("single\\singleHard");

			m_pEnemyA.SetMilitaryUnitsLimit(75000);
			m_pEnemyB.SetMilitaryUnitsLimit(75000);
			m_pEnemyC.SetMilitaryUnitsLimit(75000);
		}

		m_pEnemyA.EnableMilitaryUnitsLimit(true);
		m_pEnemyB.EnableMilitaryUnitsLimit(true);
		m_pEnemyC.EnableMilitaryUnitsLimit(true);

		m_pEnemyA.EnableAI(true);
		m_pEnemyB.EnableAI(true);
		m_pEnemyC.EnableAI(true);

		m_pEnemyA.SetMaxDistance(30);
		m_pEnemyB.SetMaxDistance(30);
		m_pEnemyC.SetMaxDistance(30);

		AddUnitTemplatesIRQ( m_pPlayer );

		m_pPlayer.SetMoney(5000);

		m_pEnemyA.SetMoney(5000);
		m_pEnemyB.SetMoney(5000);
		m_pEnemyC.SetMoney(5000);

		m_pPlayer.LookAt(m_pPlayer.GetStartingPointX(), m_pPlayer.GetStartingPointY(), 6, 0, 0, 0);

		EnableAllResearchIRQ( m_pPlayer, false);
		m_pPlayer.EnableResearch("RES_IRQ_TANK1", true);			// M1
		m_pPlayer.EnableResearch("RES_IRQ_HELICOPTER1", true);		// M2
		m_pPlayer.EnableResearch("RES_IRQ_AMMO_MG1", true);			// M3
		m_pPlayer.EnableResearch("RES_IRQ_PILLBOX", true);			// M3
		m_pPlayer.EnableResearch("RES_IRQ_TANK2", true);			// M3
		m_pPlayer.EnableResearch("RES_IRQ_SAPER", true);			// M3
		m_pPlayer.EnableResearch("RES_IRQ_MIM", true);				// M3
		m_pPlayer.EnableResearch("RES_IRQ_AMMO_MG2", true);			// M4
		m_pPlayer.EnableResearch("RES_IRQ_RART", true);				// M4
//		m_pPlayer.EnableResearch("RES_IRQ_HRART", true);			// M4
		m_pPlayer.EnableResearch("RES_IRQ_AMMO_MIM1", true);		// M4
		m_pPlayer.EnableResearch("RES_IRQ_SPECIAL_FILTER2", true);	// M4
		m_pPlayer.EnableResearch("RES_IRQ_AMMO_CANNON1", true);		// M5
		m_pPlayer.EnableResearch("RES_IRQ_BIGART", true);			// M5
		m_pPlayer.EnableResearch("RES_IRQ_AMMO_ROCKET1", true);		// M5
//		m_pPlayer.EnableResearch("RES_IRQ_AMMO_HROCKET1", true);	// M5
		m_pPlayer.EnableResearch("RES_IRQ_MGM", true);				// M5
		m_pPlayer.EnableResearch("RES_IRQ_EXPLODER", true);			// M5
		m_pPlayer.EnableResearch("RES_IRQ_AMMO_CANNON2", true);		// M6
		m_pPlayer.EnableResearch("RES_IRQ_AMMO_ROCKET2", true);		// M6
//		m_pPlayer.EnableResearch("RES_IRQ_AMMO_HROCKET2", true);	// M6
		m_pPlayer.EnableResearch("RES_IRQ_AMMO_MIM2", true);		// M6
		m_pPlayer.EnableResearch("RES_IRQ_JEEP_MGM", true);			// M6
		m_pPlayer.EnableResearch("RES_IRQ_SPECIAL_FILTER3", true);	// M6
		m_pPlayer.EnableResearch("RES_IRQ_AMMO_MGM1", true);
		m_pPlayer.EnableResearch("RES_IRQ_EXPLODER_BIG", true);

		m_pPlayer.AddResearch("RES_IRQ_TANK1");
		m_pPlayer.AddResearch("RES_IRQ_HELICOPTER1");
		m_pPlayer.AddResearch("RES_IRQ_AMMO_MG1");
		m_pPlayer.AddResearch("RES_IRQ_PILLBOX");
		m_pPlayer.AddResearch("RES_IRQ_TANK2");
		m_pPlayer.AddResearch("RES_IRQ_SAPER");
		m_pPlayer.AddResearch("RES_IRQ_MIM");
		m_pPlayer.AddResearch("RES_IRQ_AMMO_MG2");
		m_pPlayer.AddResearch("RES_IRQ_RART");
		m_pPlayer.AddResearch("RES_IRQ_AMMO_MIM1");
		m_pPlayer.AddResearch("RES_IRQ_SPECIAL_FILTER2");
		m_pPlayer.AddResearch("RES_IRQ_AMMO_CANNON1");
		m_pPlayer.AddResearch("RES_IRQ_AMMO_ROCKET1");
		m_pPlayer.AddResearch("RES_IRQ_MGM");
		m_pPlayer.AddResearch("RES_IRQ_EXPLODER");
		m_pPlayer.AddResearch("RES_IRQ_AMMO_ROCKET2");
		m_pPlayer.AddResearch("RES_IRQ_JEEP_MGM");
		m_pPlayer.AddResearch("RES_IRQ_EXPLODER_BIG");

		EnableAllResearchUSA( m_pEnemyA, false);
		m_pEnemyA.EnableResearch("RES_USA_AMPHIBIA1", true);		// M1
		m_pEnemyA.EnableResearch("RES_USA_AMMO_MG1", true);			// M1
		m_pEnemyA.EnableResearch("RES_USA_SPY", true);				// M2
		m_pEnemyA.EnableResearch("RES_USA_HELICOPTER1", true);		// M2
		m_pEnemyA.EnableResearch("RES_USA_AMMO_MG2", true);			// M3
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyA.EnableResearch("RES_USA_HELICOPTER2", true);	// M3
		}
		m_pEnemyA.EnableResearch("RES_USA_TANK1", true);			// M3
		m_pEnemyA.EnableResearch("RES_USA_SAPER", true);			// M3
		m_pEnemyA.EnableResearch("RES_USA_MORTAR", true);			// M4
		m_pEnemyA.EnableResearch("RES_USA_AMMO_CANNON1", true);		// M4
		m_pEnemyA.EnableResearch("RES_USA_MIM", true);				// M4
		m_pEnemyA.EnableResearch("RES_USA_SPECIAL_FILTER2", true);	// M4
		m_pEnemyA.EnableResearch("RES_USA_ART", true);				// M5
		m_pEnemyA.EnableResearch("RES_USA_AMMO_GRENADE1", true);	// M5
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyA.EnableResearch("RES_USA_COMANCHE", true);		// M5
		}
		m_pEnemyA.EnableResearch("RES_USA_AMMO_MIM1", true);		// M5
		m_pEnemyA.EnableResearch("RES_USA_MGM", true);				// M5
		m_pEnemyA.EnableResearch("RES_USA_SDI", true);				// M5
		m_pEnemyA.EnableResearch("RES_USA_SPECIAL_FILTER3", true);	// M5
		m_pEnemyA.EnableResearch("RES_USA_AMMO_GRENADE2", true);	// M6
		m_pEnemyA.EnableResearch("RES_USA_AMMO_CANNON2", true);		// M6
		m_pEnemyA.EnableResearch("RES_USA_SPECIAL_PTC", true);		// M6
		m_pEnemyA.EnableResearch("RES_USA_SPECIAL_FLARE", true);	// M6
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyA.EnableResearch("RES_USA_LECLERC", true);
		}
		m_pEnemyA.EnableResearch("RES_USA_AMMO_MGM1", true);

		EnableAllResearchUSA( m_pEnemyB, false);
		m_pEnemyB.EnableResearch("RES_USA_AMPHIBIA1", true);		// M1
		m_pEnemyB.EnableResearch("RES_USA_AMMO_MG1", true);			// M1
		m_pEnemyB.EnableResearch("RES_USA_SPY", true);				// M2
		m_pEnemyB.EnableResearch("RES_USA_HELICOPTER1", true);		// M2
		m_pEnemyB.EnableResearch("RES_USA_AMMO_MG2", true);			// M3
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyB.EnableResearch("RES_USA_HELICOPTER2", true);	// M3
		}
		m_pEnemyB.EnableResearch("RES_USA_TANK1", true);			// M3
		m_pEnemyB.EnableResearch("RES_USA_SAPER", true);			// M3
		m_pEnemyB.EnableResearch("RES_USA_MORTAR", true);			// M4
		m_pEnemyB.EnableResearch("RES_USA_AMMO_CANNON1", true);		// M4
		m_pEnemyB.EnableResearch("RES_USA_MIM", true);				// M4
		m_pEnemyB.EnableResearch("RES_USA_SPECIAL_FILTER2", true);	// M4
		m_pEnemyB.EnableResearch("RES_USA_ART", true);				// M5
		m_pEnemyB.EnableResearch("RES_USA_AMMO_GRENADE1", true);	// M5
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyB.EnableResearch("RES_USA_COMANCHE", true);		// M5
		}
		m_pEnemyB.EnableResearch("RES_USA_AMMO_MIM1", true);		// M5
		m_pEnemyB.EnableResearch("RES_USA_MGM", true);				// M5
		m_pEnemyB.EnableResearch("RES_USA_SDI", true);				// M5
		m_pEnemyB.EnableResearch("RES_USA_SPECIAL_FILTER3", true);	// M5
		m_pEnemyB.EnableResearch("RES_USA_AMMO_GRENADE2", true);	// M6
		m_pEnemyB.EnableResearch("RES_USA_AMMO_CANNON2", true);		// M6
		m_pEnemyB.EnableResearch("RES_USA_SPECIAL_PTC", true);		// M6
		m_pEnemyB.EnableResearch("RES_USA_SPECIAL_FLARE", true);	// M6
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyB.EnableResearch("RES_USA_LECLERC", true);
		}
		m_pEnemyB.EnableResearch("RES_USA_AMMO_MGM1", true);

		EnableAllResearchUSA( m_pEnemyC, false);
		m_pEnemyC.EnableResearch("RES_USA_AMPHIBIA1", true);		// M1
		m_pEnemyC.EnableResearch("RES_USA_AMMO_MG1", true);			// M1
		m_pEnemyC.EnableResearch("RES_USA_SPY", true);				// M2
		m_pEnemyC.EnableResearch("RES_USA_HELICOPTER1", true);		// M2
		m_pEnemyC.EnableResearch("RES_USA_AMMO_MG2", true);			// M3
		m_pEnemyC.EnableResearch("RES_USA_HELICOPTER2", true);		// M3
		m_pEnemyC.EnableResearch("RES_USA_TANK1", true);			// M3
		m_pEnemyC.EnableResearch("RES_USA_SAPER", true);			// M3
		m_pEnemyC.EnableResearch("RES_USA_MORTAR", true);			// M4
		m_pEnemyC.EnableResearch("RES_USA_AMMO_CANNON1", true);		// M4
		m_pEnemyC.EnableResearch("RES_USA_MIM", true);				// M4
		m_pEnemyC.EnableResearch("RES_USA_SPECIAL_FILTER2", true);	// M4
		m_pEnemyC.EnableResearch("RES_USA_ART", true);				// M5
		m_pEnemyC.EnableResearch("RES_USA_AMMO_GRENADE1", true);	// M5
		m_pEnemyC.EnableResearch("RES_USA_COMANCHE", true);			// M5
		m_pEnemyC.EnableResearch("RES_USA_AMMO_MIM1", true);		// M5
		m_pEnemyC.EnableResearch("RES_USA_MGM", true);				// M5
		m_pEnemyC.EnableResearch("RES_USA_SDI", true);				// M5
		m_pEnemyC.EnableResearch("RES_USA_SPECIAL_FILTER3", true);	// M5
		m_pEnemyC.EnableResearch("RES_USA_AMMO_GRENADE2", true);	// M6
		m_pEnemyC.EnableResearch("RES_USA_AMMO_CANNON2", true);		// M6
		m_pEnemyC.EnableResearch("RES_USA_SPECIAL_PTC", true);		// M6
		m_pEnemyC.EnableResearch("RES_USA_SPECIAL_FLARE", true);	// M6
		m_pEnemyC.EnableResearch("RES_USA_LECLERC", true);
		m_pEnemyC.EnableResearch("RES_USA_AMMO_MGM1", true);

		m_pEnemyA.AddResearch("RES_USA_AMPHIBIA1");
		m_pEnemyA.AddResearch("RES_USA_AMMO_MG1");
		m_pEnemyA.AddResearch("RES_USA_SPY");
		m_pEnemyA.AddResearch("RES_USA_HELICOPTER1");
		m_pEnemyA.AddResearch("RES_USA_AMMO_MG2");
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyA.AddResearch("RES_USA_HELICOPTER2");
		}
		m_pEnemyA.AddResearch("RES_USA_TANK1");
		m_pEnemyA.AddResearch("RES_USA_SAPER");
		m_pEnemyA.AddResearch("RES_USA_MORTAR");
		m_pEnemyA.AddResearch("RES_USA_AMMO_CANNON1");
		m_pEnemyA.AddResearch("RES_USA_MIM");
		m_pEnemyA.AddResearch("RES_USA_SPECIAL_FILTER2");
		m_pEnemyA.AddResearch("RES_USA_ART");
		m_pEnemyA.AddResearch("RES_USA_AMMO_GRENADE1");
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyA.AddResearch("RES_USA_COMANCHE");
		}
		m_pEnemyA.AddResearch("RES_USA_AMMO_MIM1");
		m_pEnemyA.AddResearch("RES_USA_MGM");
		m_pEnemyA.AddResearch("RES_USA_SDI");
		m_pEnemyA.AddResearch("RES_USA_SPECIAL_FILTER3");
		m_pEnemyA.AddResearch("RES_USA_AMMO_GRENADE2");
		m_pEnemyA.AddResearch("RES_USA_AMMO_CANNON2");
		m_pEnemyA.AddResearch("RES_USA_SPECIAL_PTC");
		m_pEnemyA.AddResearch("RES_USA_SPECIAL_FLARE");

		m_pEnemyB.AddResearch("RES_USA_AMPHIBIA1");
		m_pEnemyB.AddResearch("RES_USA_AMMO_MG1");
		m_pEnemyB.AddResearch("RES_USA_SPY");
		m_pEnemyB.AddResearch("RES_USA_HELICOPTER1");
		m_pEnemyB.AddResearch("RES_USA_AMMO_MG2");
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyB.AddResearch("RES_USA_HELICOPTER2");
		}
		m_pEnemyB.AddResearch("RES_USA_TANK1");
		m_pEnemyB.AddResearch("RES_USA_SAPER");
		m_pEnemyB.AddResearch("RES_USA_MORTAR");
		m_pEnemyB.AddResearch("RES_USA_AMMO_CANNON1");
		m_pEnemyB.AddResearch("RES_USA_MIM");
		m_pEnemyB.AddResearch("RES_USA_SPECIAL_FILTER2");
		m_pEnemyB.AddResearch("RES_USA_ART");
		m_pEnemyB.AddResearch("RES_USA_AMMO_GRENADE1");
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyB.AddResearch("RES_USA_COMANCHE");
		}
		m_pEnemyB.AddResearch("RES_USA_AMMO_MIM1");
		m_pEnemyB.AddResearch("RES_USA_MGM");
		m_pEnemyB.AddResearch("RES_USA_SDI");
		m_pEnemyB.AddResearch("RES_USA_SPECIAL_FILTER3");
		m_pEnemyB.AddResearch("RES_USA_AMMO_GRENADE2");
		m_pEnemyB.AddResearch("RES_USA_AMMO_CANNON2");
		m_pEnemyB.AddResearch("RES_USA_SPECIAL_PTC");
		m_pEnemyB.AddResearch("RES_USA_SPECIAL_FLARE");

		m_pEnemyC.AddResearch("RES_USA_AMPHIBIA1");
		m_pEnemyC.AddResearch("RES_USA_AMMO_MG1");
		m_pEnemyC.AddResearch("RES_USA_SPY");
		m_pEnemyC.AddResearch("RES_USA_HELICOPTER1");
		m_pEnemyC.AddResearch("RES_USA_AMMO_MG2");
		m_pEnemyC.AddResearch("RES_USA_HELICOPTER2");
		m_pEnemyC.AddResearch("RES_USA_TANK1");
		m_pEnemyC.AddResearch("RES_USA_SAPER");
		m_pEnemyC.AddResearch("RES_USA_MORTAR");
		m_pEnemyC.AddResearch("RES_USA_AMMO_CANNON1");
		m_pEnemyC.AddResearch("RES_USA_MIM");
		m_pEnemyC.AddResearch("RES_USA_SPECIAL_FILTER2");
		m_pEnemyC.AddResearch("RES_USA_ART");
		m_pEnemyC.AddResearch("RES_USA_AMMO_GRENADE1");
		m_pEnemyC.AddResearch("RES_USA_COMANCHE");
		m_pEnemyC.AddResearch("RES_USA_AMMO_MIM1");
		m_pEnemyC.AddResearch("RES_USA_MGM");
		m_pEnemyC.AddResearch("RES_USA_SDI");
		m_pEnemyC.AddResearch("RES_USA_SPECIAL_FILTER3");
		m_pEnemyC.AddResearch("RES_USA_AMMO_GRENADE2");
		m_pEnemyC.AddResearch("RES_USA_AMMO_CANNON2");
		m_pEnemyC.AddResearch("RES_USA_SPECIAL_PTC");
		m_pEnemyC.AddResearch("RES_USA_SPECIAL_FLARE");

		AddUnitTemplatesUSA( m_pEnemyA );
		AddUnitTemplatesUSA( m_pEnemyB );
		AddUnitTemplatesUSA( m_pEnemyC );

		return BeforeStart, 1;
	}

	state BeforeStart
	{
		PlayTrack("Music\\Briefing.tws");

		return Start;
	}

	state Start
	{
		EnableGoal(goalDestroyEnemy, true);
		AddBriefing("translateBriefingMissionIRQ_7_DestroyEnemy");
		PlayWave("Briefings\\IRQ_Briefing07.wav");

		return DestroyEnemy;
	}

	state DestroyEnemy
	{
		if ( !m_bCheckNumberOfUnits && !m_bCheckNumberOfBuildings )
		{
			return DestroyEnemy;
		}

		m_bCheckNumberOfUnits = false;
		m_bCheckNumberOfBuildings = false;

		if ( m_pPlayer.GetNumberOfBuildings() == 0 && m_pPlayer.GetNumberOfUnits() == 0 )
		{
			SetGoalState(goalDestroyEnemy, goalFailed);

			AddBriefing("translateBriefingMissionIRQ_7_MissionFail");

			EnableEndMissionButton(true, false);

			return MissionComplete;
		}

		if	( 
//			m_pEnemyA.GetNumberOfUnits() == 0 &&
			m_pEnemyA.GetNumberOfBuildings() == 0 &&
//			m_pEnemyB.GetNumberOfUnits() == 0 &&
			m_pEnemyB.GetNumberOfBuildings() == 0 &&
//			m_pEnemyC.GetNumberOfUnits() == 0 &&
			m_pEnemyC.GetNumberOfBuildings() == 0
			)
		{
			return DestroyedEnemy;
		}
		else
		{
			return DestroyEnemy;
		}
	}

	state DestroyedEnemy
	{
		SetGoalState(goalDestroyEnemy, goalAchieved);

		AddBriefing("translateBriefingMissionIRQ_7_MissionComplete");

		EnableEndMissionButton(true, true);

		return MissionComplete;
	}

	state MissionComplete
	{
		return MissionComplete;
	}

	event UnitDestroyed(unit uUnit)
	{
		m_bCheckNumberOfUnits = true;
	}

	event BuildingDestroyed(unit uBuilding)
	{
		m_bCheckNumberOfBuildings = true;
	}

	event SetupInterface()
	{
		EnableGameFeature
			(
			lockResearchDialog |
			lockToolbarResearching |
			lockToolbarMoney |
			lockDisplayToolbarMoney |
			lockCreateBuildPanel |
			0, false);
	}
}
