mission "translateMissionIRQ_8"
{
	consts
	{
		goalCaptureRadar = 0;
		goalDestroyEnemyB = 1;
		goalCaptureRafinery = 2;

		markerRadar = 0;
		markerRafinery = 22;

		markerPatrolA1 = 1;
		markerPatrolA2 = 2;
		markerPatrolA3 = 3;

		markerPatrolAFrom = 4;
		markerPatrolATo = 8;

		markerPatrolB1 = 9;
		markerPatrolB2 = 10;
		markerPatrolB3 = 11;

		markerPatrolBFrom = 12;
		markerPatrolBTo = 21;

		markerAssault = 45;
	}

	include "UnitTemplates.ech"
	include "Varia.ech"
	include "Research.ech"

	player m_pPlayer;
	player m_pEnemyA;
	player m_pEnemyB;
	player m_pEnemyC;
	player m_pEnemyUnits;

	unitex m_uAssault;

	unitex m_uRadar;
	unitex m_uRafinery;

	unitex m_uPatrolA1;
	unitex m_uPatrolA2;
	unitex m_uPatrolA3;

	unitex m_uPatrolB1;
	unitex m_uPatrolB2;
	unitex m_uPatrolB3;

	int m_bCheckNumberOfUnits;
	int m_bCheckNumberOfBuildings;

	int m_bCheckDestroyedUnits;

	state Initialize;
	state Start;
	state BeforeStart;
	state CaptureRadar;
	state CapturedRadar;
	state DestroyedRadar;
	state DestroyEnemyB;
	state DestroyedEnemyB;
	state CaptureRafinery;
	state CapturedRafinery;
	state DestroyedRafinery;
	state MissionComplete;

	function int ClearMarkers(int nStartPoint, int nEndPoint)
	{
		int i;

		for ( i=nStartPoint; i<=nEndPoint; i=i+1 )
		{
			ClearArea (65535, GetPointX(i), GetPointY(i), GetPointZ(i), 0);
		}
	}

	function int ModifyDifficulty()
	{
		if ( GetDifficultyLevel() == 0 )
		{
			ClearMarkers(31, 40);
			ClearArea	(65535, GetPointX(38), GetPointY(38), GetPointZ(38), 1);
			ClearMarkers(46, 49);
		}
		else if ( GetDifficultyLevel() == 1 )
		{
			ClearMarkers(35, 35);
			ClearMarkers(37, 40);
			ClearArea	(65535, GetPointX(38), GetPointY(38), GetPointZ(38), 1);
			ClearMarkers(42, 43);
			ClearMarkers(46, 47);
		}
		else if ( GetDifficultyLevel() == 2 )
		{
			ClearMarkers(41, 44);
		}
	}

	state Initialize
	{
		ModifyDifficulty();

		RegisterGoal(goalCaptureRadar, "translateGoalMissionIRQ_8_CaptureRadar");
		RegisterGoal(goalDestroyEnemyB, "translateGoalMissionIRQ_8_DestroyEnemyB");
		RegisterGoal(goalCaptureRafinery, "translateGoalMissionIRQ_8_CaptureRafinery");

		m_pPlayer = GetPlayer(3);
		m_pPlayer.EnableStatistics(true);

		m_pEnemyA = GetPlayer(1);
		m_pEnemyA.EnableStatistics(false);
		m_pEnemyB = GetPlayer(2);
		m_pEnemyB.EnableStatistics(true);
		m_pEnemyC = GetPlayer(0);
		m_pEnemyC.EnableStatistics(true);
		m_pEnemyUnits = GetPlayer(4);
		m_pEnemyUnits.EnableStatistics(false);

//		if ( GetDifficultyLevel() == 0 )
//		{
//			m_pEnemyB.LoadScript("single\\singleEasy");			
//			m_pEnemyC.LoadScript("single\\singleEasy");
//		}
//		else if ( GetDifficultyLevel() == 1 )
//		{
//			m_pEnemyB.LoadScript("single\\singleMedium");			
//			m_pEnemyC.LoadScript("single\\singleMedium");
//		}
//		else if ( GetDifficultyLevel() == 2 )
//		{
			m_pEnemyB.LoadScript("single\\singleHard");			
			m_pEnemyC.LoadScript("single\\singleHard");
//		}

		m_pEnemyA.EnableAI(false);
		m_pEnemyUnits.EnableAI(false);

		m_pPlayer.SetMoney(2000);

		m_pEnemyB.SetMoney(5000);
		m_pEnemyB.EnableAI(true);
		m_pEnemyB.EnableAIFeatures2(ai2RebuildBaseOnly, true);

		m_pEnemyC.SetMoney(5000);
		m_pEnemyC.EnableAI(true);

		m_uAssault = GetUnit(GetPointX(markerAssault), GetPointY(markerAssault));

		m_uRadar = GetUnit(GetPointX(markerRadar), GetPointY(markerRadar));
		m_uRafinery = GetUnit(GetPointX(markerRafinery), GetPointY(markerRafinery));

		m_uPatrolA1 = GetUnit(GetPointX(markerPatrolA1), GetPointY(markerPatrolA1));
		m_uPatrolA2 = GetUnit(GetPointX(markerPatrolA2), GetPointY(markerPatrolA2));
		m_uPatrolA3 = GetUnit(GetPointX(markerPatrolA3), GetPointY(markerPatrolA3));

		m_uPatrolB1 = GetUnit(GetPointX(markerPatrolB1), GetPointY(markerPatrolB1));
		m_uPatrolB2 = GetUnit(GetPointX(markerPatrolB2), GetPointY(markerPatrolB2));
		m_uPatrolB3 = GetUnit(GetPointX(markerPatrolB3), GetPointY(markerPatrolB3));

		AddUnitTemplatesIRQ( m_pPlayer );

		m_pPlayer.LookAt(m_pPlayer.GetStartingPointX(), m_pPlayer.GetStartingPointY(), 6, 0, 0, 0);

		EnableAllResearchIRQ( m_pPlayer, false);
		m_pPlayer.EnableResearch("RES_IRQ_TANK1", true);			// M1
		m_pPlayer.EnableResearch("RES_IRQ_HELICOPTER1", true);		// M2
		m_pPlayer.EnableResearch("RES_IRQ_AMMO_MG1", true);			// M3
		m_pPlayer.EnableResearch("RES_IRQ_PILLBOX", true);			// M3
		m_pPlayer.EnableResearch("RES_IRQ_TANK2", true);			// M3
		m_pPlayer.EnableResearch("RES_IRQ_SAPER", true);			// M3
		m_pPlayer.EnableResearch("RES_IRQ_MIM", true);				// M3
		m_pPlayer.EnableResearch("RES_IRQ_AMMO_MG2", true);			// M4
		m_pPlayer.EnableResearch("RES_IRQ_RART", true);				// M4
		m_pPlayer.EnableResearch("RES_IRQ_HRART", true);			// M4
		m_pPlayer.EnableResearch("RES_IRQ_AMMO_MIM1", true);		// M4
		m_pPlayer.EnableResearch("RES_IRQ_SPECIAL_FILTER2", true);	// M4
		m_pPlayer.EnableResearch("RES_IRQ_AMMO_CANNON1", true);		// M5
		m_pPlayer.EnableResearch("RES_IRQ_BIGART", true);			// M5
		m_pPlayer.EnableResearch("RES_IRQ_AMMO_ROCKET1", true);		// M5
		m_pPlayer.EnableResearch("RES_IRQ_AMMO_HROCKET1", true);	// M5
		m_pPlayer.EnableResearch("RES_IRQ_MGM", true);				// M5
		m_pPlayer.EnableResearch("RES_IRQ_EXPLODER", true);			// M5
		m_pPlayer.EnableResearch("RES_IRQ_AMMO_CANNON2", true);		// M6
		m_pPlayer.EnableResearch("RES_IRQ_AMMO_ROCKET2", true);		// M6
		m_pPlayer.EnableResearch("RES_IRQ_AMMO_HROCKET2", true);	// M6
		m_pPlayer.EnableResearch("RES_IRQ_AMMO_MIM2", true);		// M6
		m_pPlayer.EnableResearch("RES_IRQ_JEEP_MGM", true);			// M6
		m_pPlayer.EnableResearch("RES_IRQ_SPECIAL_FILTER3", true);	// M6
		m_pPlayer.EnableResearch("RES_IRQ_AMMO_MGM1", true);		// M7
		m_pPlayer.EnableResearch("RES_IRQ_EXPLODER_BIG", true);		// M7
//		m_pPlayer.EnableResearch("RES_IRQ_SCUD", true);
		m_pPlayer.EnableResearch("RES_IRQ_SPYFLIGHTCENTER", true);
		m_pPlayer.EnableResearch("RES_IRQ_AMMO_MGM2", true);
		m_pPlayer.EnableResearch("RES_IRQ_SDI", true);

		EnableAllResearchUSA( m_pEnemyB, false);
		m_pEnemyB.EnableResearch("RES_USA_AMPHIBIA1", true);		// M1
		m_pEnemyB.EnableResearch("RES_USA_AMMO_MG1", true);			// M1
		m_pEnemyB.EnableResearch("RES_USA_SPY", true);				// M2
		m_pEnemyB.EnableResearch("RES_USA_HELICOPTER1", true);		// M2
		m_pEnemyB.EnableResearch("RES_USA_AMMO_MG2", true);			// M3
		m_pEnemyB.EnableResearch("RES_USA_HELICOPTER2", true);		// M3
		m_pEnemyB.EnableResearch("RES_USA_TANK1", true);			// M3
		m_pEnemyB.EnableResearch("RES_USA_SAPER", true);			// M3
		m_pEnemyB.EnableResearch("RES_USA_MORTAR", true);			// M4
		m_pEnemyB.EnableResearch("RES_USA_AMMO_CANNON1", true);		// M4
		m_pEnemyB.EnableResearch("RES_USA_MIM", true);				// M4
		m_pEnemyB.EnableResearch("RES_USA_SPECIAL_FILTER2", true);	// M4
		m_pEnemyB.EnableResearch("RES_USA_ART", true);				// M5
		m_pEnemyB.EnableResearch("RES_USA_AMMO_GRENADE1", true);	// M5
		m_pEnemyB.EnableResearch("RES_USA_COMANCHE", true);			// M5
		m_pEnemyB.EnableResearch("RES_USA_AMMO_MIM1", true);		// M5
		m_pEnemyB.EnableResearch("RES_USA_MGM", true);				// M5
		m_pEnemyB.EnableResearch("RES_USA_SDI", true);				// M5
		m_pEnemyB.EnableResearch("RES_USA_SPECIAL_FILTER3", true);	// M5
		m_pEnemyB.EnableResearch("RES_USA_AMMO_GRENADE2", true);	// M6
		m_pEnemyB.EnableResearch("RES_USA_AMMO_CANNON2", true);		// M6
		m_pEnemyB.EnableResearch("RES_USA_SPECIAL_PTC", true);		// M6
		m_pEnemyB.EnableResearch("RES_USA_SPECIAL_FLARE", true);	// M6
		m_pEnemyB.EnableResearch("RES_USA_LECLERC", true);			// M7
		m_pEnemyB.EnableResearch("RES_USA_AMMO_MGM1", true);		// M7
//		m_pEnemyB.EnableResearch("RES_USA_AIRCONTROL", true);
		m_pEnemyB.EnableResearch("RES_USA_AMMO_MIM2", true);
		m_pEnemyB.EnableResearch("RES_USA_JEEP_JAMMER", true);

		EnableAllResearchUSA( m_pEnemyC, false);
		m_pEnemyC.EnableResearch("RES_USA_AMPHIBIA1", true);		// M1
		m_pEnemyC.EnableResearch("RES_USA_AMMO_MG1", true);			// M1
		m_pEnemyC.EnableResearch("RES_USA_SPY", true);				// M2
		m_pEnemyC.EnableResearch("RES_USA_HELICOPTER1", true);		// M2
		m_pEnemyC.EnableResearch("RES_USA_AMMO_MG2", true);			// M3
		m_pEnemyC.EnableResearch("RES_USA_HELICOPTER2", true);		// M3
		m_pEnemyC.EnableResearch("RES_USA_TANK1", true);			// M3
		m_pEnemyC.EnableResearch("RES_USA_SAPER", true);			// M3
		m_pEnemyC.EnableResearch("RES_USA_MORTAR", true);			// M4
		m_pEnemyC.EnableResearch("RES_USA_AMMO_CANNON1", true);		// M4
		m_pEnemyC.EnableResearch("RES_USA_MIM", true);				// M4
		m_pEnemyC.EnableResearch("RES_USA_SPECIAL_FILTER2", true);	// M4
		m_pEnemyC.EnableResearch("RES_USA_ART", true);				// M5
		m_pEnemyC.EnableResearch("RES_USA_AMMO_GRENADE1", true);	// M5
		m_pEnemyC.EnableResearch("RES_USA_COMANCHE", true);			// M5
		m_pEnemyC.EnableResearch("RES_USA_AMMO_MIM1", true);		// M5
		m_pEnemyC.EnableResearch("RES_USA_MGM", true);				// M5
		m_pEnemyC.EnableResearch("RES_USA_SDI", true);				// M5
		m_pEnemyC.EnableResearch("RES_USA_SPECIAL_FILTER3", true);	// M5
		m_pEnemyC.EnableResearch("RES_USA_AMMO_GRENADE2", true);	// M6
		m_pEnemyC.EnableResearch("RES_USA_AMMO_CANNON2", true);		// M6
		m_pEnemyC.EnableResearch("RES_USA_SPECIAL_PTC", true);		// M6
		m_pEnemyC.EnableResearch("RES_USA_SPECIAL_FLARE", true);	// M6
		m_pEnemyC.EnableResearch("RES_USA_LECLERC", true);			// M7
		m_pEnemyC.EnableResearch("RES_USA_AMMO_MGM1", true);		// M7
//		m_pEnemyC.EnableResearch("RES_USA_AIRCONTROL", true);
		m_pEnemyC.EnableResearch("RES_USA_AMMO_MIM2", true);
		m_pEnemyC.EnableResearch("RES_USA_JEEP_JAMMER", true);

		m_pEnemyB.AddResearch("RES_USA_AMPHIBIA1");
		m_pEnemyB.AddResearch("RES_USA_AMMO_MG1");
		m_pEnemyB.AddResearch("RES_USA_SPY");
		m_pEnemyB.AddResearch("RES_USA_HELICOPTER1");
		m_pEnemyB.AddResearch("RES_USA_AMMO_MG2");
		m_pEnemyB.AddResearch("RES_USA_HELICOPTER2");
		m_pEnemyB.AddResearch("RES_USA_TANK1");
		m_pEnemyB.AddResearch("RES_USA_SAPER");
		m_pEnemyB.AddResearch("RES_USA_MORTAR");
		m_pEnemyB.AddResearch("RES_USA_AMMO_CANNON1");
		m_pEnemyB.AddResearch("RES_USA_MIM");
		m_pEnemyB.AddResearch("RES_USA_SPECIAL_FILTER2");
		m_pEnemyB.AddResearch("RES_USA_ART");
		m_pEnemyB.AddResearch("RES_USA_AMMO_GRENADE1");
		m_pEnemyB.AddResearch("RES_USA_COMANCHE");
		m_pEnemyB.AddResearch("RES_USA_AMMO_MIM1");
		m_pEnemyB.AddResearch("RES_USA_MGM");
		m_pEnemyB.AddResearch("RES_USA_SDI");
		m_pEnemyB.AddResearch("RES_USA_SPECIAL_FILTER3");
		m_pEnemyB.AddResearch("RES_USA_AMMO_GRENADE2");
		m_pEnemyB.AddResearch("RES_USA_AMMO_CANNON2");
		m_pEnemyB.AddResearch("RES_USA_SPECIAL_PTC");
		m_pEnemyB.AddResearch("RES_USA_SPECIAL_FLARE");
		m_pEnemyB.AddResearch("RES_USA_LECLERC");
		m_pEnemyB.AddResearch("RES_USA_AMMO_MGM1");

		m_pEnemyC.AddResearch("RES_USA_AMPHIBIA1");
		m_pEnemyC.AddResearch("RES_USA_AMMO_MG1");
		m_pEnemyC.AddResearch("RES_USA_SPY");
		m_pEnemyC.AddResearch("RES_USA_HELICOPTER1");
		m_pEnemyC.AddResearch("RES_USA_AMMO_MG2");
		m_pEnemyC.AddResearch("RES_USA_HELICOPTER2");
		m_pEnemyC.AddResearch("RES_USA_TANK1");
		m_pEnemyC.AddResearch("RES_USA_SAPER");
		m_pEnemyC.AddResearch("RES_USA_MORTAR");
		m_pEnemyC.AddResearch("RES_USA_AMMO_CANNON1");
		m_pEnemyC.AddResearch("RES_USA_MIM");
		m_pEnemyC.AddResearch("RES_USA_SPECIAL_FILTER2");
		m_pEnemyC.AddResearch("RES_USA_ART");
		m_pEnemyC.AddResearch("RES_USA_AMMO_GRENADE1");
		m_pEnemyC.AddResearch("RES_USA_COMANCHE");
		m_pEnemyC.AddResearch("RES_USA_AMMO_MIM1");
		m_pEnemyC.AddResearch("RES_USA_MGM");
		m_pEnemyC.AddResearch("RES_USA_SDI");
		m_pEnemyC.AddResearch("RES_USA_SPECIAL_FILTER3");
		m_pEnemyC.AddResearch("RES_USA_AMMO_GRENADE2");
		m_pEnemyC.AddResearch("RES_USA_AMMO_CANNON2");
		m_pEnemyC.AddResearch("RES_USA_SPECIAL_PTC");
		m_pEnemyC.AddResearch("RES_USA_SPECIAL_FLARE");
		m_pEnemyC.AddResearch("RES_USA_LECLERC");
		m_pEnemyC.AddResearch("RES_USA_AMMO_MGM1");

		AddUnitTemplatesUSA( m_pEnemyB );
		AddUnitTemplatesUSA( m_pEnemyC );

		SetTimer(0, 100); // CheckDestroyedUnits

		return BeforeStart, 1;
	}

	state BeforeStart
	{
		PlayTrack("Music\\Briefing.tws");

		return Start;
	}

	state Start
	{
		EnableGoal(goalCaptureRadar, true);
		AddBriefing("translateBriefingMissionIRQ_8_CaptureRadar");
		PlayWave("Briefings\\IRQ_Briefing08.wav");

		Patrol(m_uPatrolA1, markerPatrolAFrom, markerPatrolATo);
		Patrol(m_uPatrolA2, markerPatrolAFrom, markerPatrolATo);
		Patrol(m_uPatrolA3, markerPatrolAFrom, markerPatrolATo);

		Patrol(m_uPatrolB1, markerPatrolBFrom, markerPatrolBTo);
		Patrol(m_uPatrolB2, markerPatrolBFrom, markerPatrolBTo);
		Patrol(m_uPatrolB3, markerPatrolBFrom, markerPatrolBTo);

		return CaptureRadar;
	}

	state CaptureRadar
	{
		if ( !m_uRadar.IsLive() )
		{
			return DestroyedRadar;
		}

		if ( m_uRadar.GetIFF() == m_pPlayer.GetIFF() )
		{
			return CapturedRadar;
		}

		return CaptureRadar;
	}

	state CapturedRadar
	{
		SetGoalState(goalCaptureRadar, goalAchieved);

		EnableGoal(goalDestroyEnemyB, true);
		AddBriefing("translateBriefingMissionIRQ_8_DestroyEnemyB");

		if ( GetDifficultyLevel() == 0 )
		{
			m_pPlayer.AddMoney(5000);
		}
		else if ( GetDifficultyLevel() == 1 )
		{
			m_pPlayer.AddMoney(3000);
		}
		else if ( GetDifficultyLevel() == 2 )
		{
			m_pPlayer.AddMoney(2000);
		}

		return DestroyEnemyB;
	}

	state DestroyedRadar
	{
		SetGoalState(goalCaptureRadar, goalFailed);

		AddBriefing("translateBriefingMissionIRQ_8_MissionFail");

		EnableEndMissionButton(true, false);

		return MissionComplete;
	}

	state DestroyEnemyB
	{
		if ( !m_bCheckNumberOfBuildings )
		{
			return DestroyEnemyB;
		}

		m_bCheckNumberOfBuildings = false;

		if	( m_pEnemyB.GetNumberOfBuildings() == 0 )
		{
			return DestroyedEnemyB;
		}
		else
		{
			return DestroyEnemyB;
		}
	}

	state DestroyedEnemyB
	{
		SetGoalState(goalDestroyEnemyB, goalAchieved);

		EnableGoal(goalCaptureRafinery, true);
		AddBriefing("translateBriefingMissionIRQ_8_CaptureRafinery");

		return CaptureRafinery;
	}

	state CaptureRafinery
	{
		if ( !m_uRafinery.IsLive() )
		{
			return DestroyedRafinery;
		}

		if ( m_uRafinery.GetIFF() == m_pPlayer.GetIFF() )
		{
			return CapturedRafinery;
		}

		return CaptureRafinery;
	}

	state CapturedRafinery
	{
		SetGoalState(goalCaptureRafinery, goalAchieved);

		AddBriefing("translateBriefingMissionIRQ_8_MissionComplete");

		EnableEndMissionButton(true, true);

		return MissionComplete;
	}

	state DestroyedRafinery
	{
		SetGoalState(goalCaptureRafinery, goalFailed);

		AddBriefing("translateBriefingMissionIRQ_8_MissionFail");

		EnableEndMissionButton(true, false);

		return MissionComplete;
	}

	state MissionComplete
	{
		return MissionComplete;
	}

	event UnitDestroyed(unit uUnit)
	{
		m_bCheckNumberOfUnits = true;

		m_bCheckDestroyedUnits = true;

		if ( state == CaptureRadar && uUnit == m_uAssault )
		{
			SetGoalState(goalCaptureRadar, goalFailed);

			AddBriefing("translateBriefingMissionIRQ_8_MissionFail");

			EnableEndMissionButton(true, false);

			state MissionComplete;
		}
	}

	event BuildingDestroyed(unit uBuilding)
	{
		m_bCheckNumberOfBuildings = true;

		m_bCheckDestroyedUnits = true;
	}

	function int CheckDestroyedUnits()
	{
		if ( state == MissionComplete ) return;

		if ( m_pPlayer.GetNumberOfUnits() == 0 )
		{
			if ( GetGoalState(goalCaptureRadar) != goalAchieved )
			{
				SetGoalState(goalCaptureRadar, goalFailed);
			}

			if ( GetGoalState(goalDestroyEnemyB) != goalAchieved )
			{
				SetGoalState(goalDestroyEnemyB, goalFailed);
			}

			if ( GetGoalState(goalCaptureRafinery) != goalAchieved )
			{
				SetGoalState(goalCaptureRafinery, goalFailed);
			}

			AddBriefing("translateBriefingMissionIRQ_8_MissionFail");

			EnableEndMissionButton(true, false);

			state MissionComplete;
		}

	}

	event Timer0()
	{
		if ( m_bCheckDestroyedUnits )
		{
			m_bCheckDestroyedUnits = false;

			CheckDestroyedUnits();
		}
	}

	event SetupInterface()
	{
	}
}
