mission "translateMissionIRQ_9"
{
	consts
	{
		goalDestroyEnemyA = 0;
		goalEscortTanks = 1;
		goalCaptureTrucks = 2;

		markerTankFirst = 4;
		markerTankLast = 14;

		markerTruck1 = 0;
		markerTruck2 = 1;
		markerTruck3 = 2;
		markerTruck4 = 3;

		markerConvoyTank1 = 34;
		markerConvoyTank2 = 35;
		markerConvoyTank3 = 36;
		markerConvoyTank4 = 37;
	}

	include "Research.ech"

	player m_pPlayer;
	player m_pEnemy;
	player m_pFriend;
	player m_pEnemyConvoy;

	unitex m_uTank1;
	unitex m_uTank2;
	unitex m_uTank3;
	unitex m_uTank4;
	unitex m_uTank5;
	unitex m_uTank6;
	unitex m_uTank7;
	unitex m_uTank8;
	unitex m_uTank9;
	unitex m_uTank10;
	unitex m_uTank11;

	unitex m_uTruck1;
	unitex m_uTruck2;
	unitex m_uTruck3;
	unitex m_uTruck4;

	unitex m_uConvoyTank1;
	unitex m_uConvoyTank2;
	unitex m_uConvoyTank3;
	unitex m_uConvoyTank4;

	int m_bCheckNumberOfUnits;
	int m_bCheckNumberOfBuildings;

	int m_bCheckDestroyedUnits;

	int m_nTimeOfConvoyMove;

	state Initialize;
	state Start;
	state BeforeStart;
	state DestroyEnemyA;
	state DestroyedEnemyA;
	state EscortTanks;
	state EscortedTanks;
	state CaptureTrucks;
	state CapturedTrucks;
	state MissionComplete;

	function int CountTanks()
	{
		int nTanks;

		nTanks = 0;

		if ( m_uTank1.IsLive() ) nTanks = nTanks + 1;
		if ( m_uTank2.IsLive() ) nTanks = nTanks + 1;
		if ( m_uTank3.IsLive() ) nTanks = nTanks + 1;
		if ( m_uTank4.IsLive() ) nTanks = nTanks + 1;
		if ( m_uTank5.IsLive() ) nTanks = nTanks + 1;
		if ( m_uTank6.IsLive() ) nTanks = nTanks + 1;
		if ( m_uTank7.IsLive() ) nTanks = nTanks + 1;
		if ( m_uTank8.IsLive() ) nTanks = nTanks + 1;
		if ( m_uTank9.IsLive() ) nTanks = nTanks + 1;
		if ( m_uTank10.IsLive() ) nTanks = nTanks + 1;
		if ( m_uTank11.IsLive() ) nTanks = nTanks + 1;

		return nTanks;
	}

	function int CountTrucks()
	{
		int nTrucks;

		nTrucks = 0;

		if ( m_uTruck1.IsLive() ) nTrucks = nTrucks + 1;
		if ( m_uTruck2.IsLive() ) nTrucks = nTrucks + 1;
		if ( m_uTruck3.IsLive() ) nTrucks = nTrucks + 1;
		if ( m_uTruck4.IsLive() ) nTrucks = nTrucks + 1;

		return nTrucks;
	}

	function int CountTanksInBase()
	{
		int nTanks;
		int nGx, nGy;

		nTanks = 0;

		nGx = m_pFriend.GetStartingPointX();
		nGy = m_pFriend.GetStartingPointY();

		if ( m_uTank1.IsLive() && Distance(m_uTank1.GetLocationX(), m_uTank1.GetLocationY(), nGx, nGy) <= 8 ) nTanks = nTanks + 1;
		if ( m_uTank2.IsLive() && Distance(m_uTank2.GetLocationX(), m_uTank2.GetLocationY(), nGx, nGy) <= 8 ) nTanks = nTanks + 1;
		if ( m_uTank3.IsLive() && Distance(m_uTank3.GetLocationX(), m_uTank3.GetLocationY(), nGx, nGy) <= 8 ) nTanks = nTanks + 1;
		if ( m_uTank4.IsLive() && Distance(m_uTank4.GetLocationX(), m_uTank4.GetLocationY(), nGx, nGy) <= 8 ) nTanks = nTanks + 1;
		if ( m_uTank5.IsLive() && Distance(m_uTank5.GetLocationX(), m_uTank5.GetLocationY(), nGx, nGy) <= 8 ) nTanks = nTanks + 1;
		if ( m_uTank6.IsLive() && Distance(m_uTank6.GetLocationX(), m_uTank6.GetLocationY(), nGx, nGy) <= 8 ) nTanks = nTanks + 1;
		if ( m_uTank7.IsLive() && Distance(m_uTank7.GetLocationX(), m_uTank7.GetLocationY(), nGx, nGy) <= 8 ) nTanks = nTanks + 1;
		if ( m_uTank8.IsLive() && Distance(m_uTank8.GetLocationX(), m_uTank8.GetLocationY(), nGx, nGy) <= 8 ) nTanks = nTanks + 1;
		if ( m_uTank9.IsLive() && Distance(m_uTank9.GetLocationX(), m_uTank9.GetLocationY(), nGx, nGy) <= 8 ) nTanks = nTanks + 1;
		if ( m_uTank10.IsLive() && Distance(m_uTank10.GetLocationX(), m_uTank10.GetLocationY(), nGx, nGy) <= 8 ) nTanks = nTanks + 1;
		if ( m_uTank11.IsLive() && Distance(m_uTank11.GetLocationX(), m_uTank11.GetLocationY(), nGx, nGy) <= 8 ) nTanks = nTanks + 1;

		return nTanks;
	}

	function int CheckTruck(unitex uTruck)
	{
		int nGx, nGy;
		int nTruckx, nTrucky;
		unitex uTmp;

		if ( !uTruck.IsLive() )
		{
			return false;
		}

		if ( uTruck.GetIFF() == m_pPlayer.GetIFF() )
		{
			return true;
		}

		nTruckx = uTruck.GetLocationX();
		nTrucky = uTruck.GetLocationY();

		for ( nGy = nTrucky - 1; nGy <= nTrucky + 1; ++nGy )
		{
			for ( nGx = nTruckx - 1; nGx <= nTruckx + 1; ++nGx )
			{
				uTmp = GetUnit(nGx, nGy);

				if ( uTmp.GetIFF() == m_pPlayer.GetIFF() )
				{
					uTruck.ChangePlayer(m_pPlayer);

					return true;
				}
			}
		}

		if ( uTruck.GetHP()*2 <= uTruck.GetMaxHP() )
		{
			uTruck.CommandStop();
		}

		return false;
	}

	function int InitializeConvoyUnit(int nPoint, unitex uMaster)
	{
		unitex uTmp;

		uTmp = GetUnit(GetPointX(nPoint), GetPointY(nPoint));

		if ( uTmp )
		{
			uTmp.CommandEscort(uMaster);
			uTmp.RegenerateAmmo();
		}
	}

	function int InitializeConvoy()
	{
		m_nTimeOfConvoyMove = 3*60*20;

		m_uTruck1 = GetUnit(GetPointX(markerTruck1), GetPointY(markerTruck1));
		m_uTruck2 = GetUnit(GetPointX(markerTruck2), GetPointY(markerTruck2));
		m_uTruck3 = GetUnit(GetPointX(markerTruck3), GetPointY(markerTruck3));
		m_uTruck4 = GetUnit(GetPointX(markerTruck4), GetPointY(markerTruck4));

		m_uConvoyTank1 = GetUnit(GetPointX(markerConvoyTank1), GetPointY(markerConvoyTank1));
		m_uConvoyTank2 = GetUnit(GetPointX(markerConvoyTank2), GetPointY(markerConvoyTank2));
		m_uConvoyTank3 = GetUnit(GetPointX(markerConvoyTank3), GetPointY(markerConvoyTank3));
		m_uConvoyTank4 = GetUnit(GetPointX(markerConvoyTank4), GetPointY(markerConvoyTank4));

		m_uConvoyTank1.RegenerateAmmo();
		m_uConvoyTank2.RegenerateAmmo();
		m_uConvoyTank3.RegenerateAmmo();
		m_uConvoyTank4.RegenerateAmmo();

		m_uTruck1.CommandEscort(m_uConvoyTank1);
		m_uTruck2.CommandEscort(m_uConvoyTank2);
		m_uTruck3.CommandEscort(m_uConvoyTank3);
		m_uTruck4.CommandEscort(m_uConvoyTank4);

		InitializeConvoyUnit(30, m_uConvoyTank1);
		InitializeConvoyUnit(31, m_uConvoyTank2);
		InitializeConvoyUnit(32, m_uConvoyTank3);
		InitializeConvoyUnit(33, m_uConvoyTank4);

		InitializeConvoyUnit(38, m_uConvoyTank1);
		InitializeConvoyUnit(39, m_uConvoyTank2);
		InitializeConvoyUnit(40, m_uConvoyTank3);

		InitializeConvoyUnit(41, m_uTruck1);
		InitializeConvoyUnit(42, m_uTruck2);
		InitializeConvoyUnit(43, m_uTruck3);
		InitializeConvoyUnit(44, m_uTruck4);

		InitializeConvoyUnit(45, m_uTruck1);
		InitializeConvoyUnit(46, m_uTruck2);
		InitializeConvoyUnit(47, m_uTruck3);
		InitializeConvoyUnit(48, m_uTruck4);
		InitializeConvoyUnit(49, m_uTruck1);

		InitializeConvoyUnit(50, m_uTruck2);
		InitializeConvoyUnit(51, m_uTruck3);

		InitializeConvoyUnit(52, m_uTruck4);
	}

	function int ConvoyTruckArrived()
	{
		int nGx, nGy;

		nGx = m_pEnemy.GetStartingPointX();
		nGy = m_pEnemy.GetStartingPointY();

		if	(
			Distance(m_uTruck1.GetLocationX(), m_uTruck1.GetLocationY(), nGx, nGy) <= 6 ||
			Distance(m_uTruck2.GetLocationX(), m_uTruck2.GetLocationY(), nGx, nGy) <= 6 ||
			Distance(m_uTruck3.GetLocationX(), m_uTruck3.GetLocationY(), nGx, nGy) <= 6 ||
			Distance(m_uTruck4.GetLocationX(), m_uTruck4.GetLocationY(), nGx, nGy) <= 6
			)
		{
			return true;
		}
		else
		{
			return false;
		}
	}

	function int ClearMarkers(int nStartPoint, int nEndPoint)
	{
		int i;

		for ( i=nStartPoint; i<=nEndPoint; i=i+1 )
		{
			ClearArea (65535, GetPointX(i), GetPointY(i), GetPointZ(i), 0);
		}
	}

	function int ModifyDifficulty()
	{
		if ( GetDifficultyLevel() == 0 )
		{
			ClearMarkers(51, 51);
			ClearMarkers(18, 20);
			ClearMarkers(21, 23);
			ClearMarkers(25, 25);
		}
		else if ( GetDifficultyLevel() == 1 )
		{
			ClearMarkers(41, 42);
			ClearMarkers(18, 18);
			ClearMarkers(23, 24);
			ClearMarkers(53, 53);
		}
		else if ( GetDifficultyLevel() == 2 )
		{
			ClearMarkers(21, 22);
			ClearMarkers(24, 25);
			ClearMarkers(53, 53);
		}
	}

	state Initialize
	{
		int i;
		unitex uTmp;

		RegisterGoal(goalDestroyEnemyA, "translateGoalMissionIRQ_9_DestroyEnemyA");
		RegisterGoal(goalEscortTanks, "translateGoalMissionIRQ_9_EscortTanks");
		RegisterGoal(goalCaptureTrucks, "translateGoalMissionIRQ_9_CaptureTrucks");

		m_pPlayer = GetPlayer(3);
		m_pPlayer.EnableStatistics(false);

		m_pEnemy = GetPlayer(0);
		m_pEnemy.EnableStatistics(false);

		m_pFriend = GetPlayer(2);
		m_pFriend.EnableStatistics(false);

		m_pEnemyConvoy = GetPlayer(1);
		m_pEnemyConvoy.EnableStatistics(false);

		EnableAllResearchUSA(m_pEnemyConvoy, true);

		m_pEnemy.EnableAI(false);
		m_pFriend.EnableAI(false);
		m_pEnemyConvoy.EnableAI(false);

		m_pFriend.EnableAIFeatures2(ai2ChooseEnemy, false);
		m_pFriend.SetNeutral(m_pPlayer);
		m_pPlayer.SetNeutral(m_pFriend);

		ModifyDifficulty();

		m_pPlayer.SetMoney(0);

		m_uTank1 = GetUnit(GetPointX(markerTankFirst+0), GetPointY(markerTankFirst+0));
		m_uTank2 = GetUnit(GetPointX(markerTankFirst+1), GetPointY(markerTankFirst+1));
		m_uTank3 = GetUnit(GetPointX(markerTankFirst+2), GetPointY(markerTankFirst+2));
		m_uTank4 = GetUnit(GetPointX(markerTankFirst+3), GetPointY(markerTankFirst+3));
		m_uTank5 = GetUnit(GetPointX(markerTankFirst+4), GetPointY(markerTankFirst+4));
		m_uTank6 = GetUnit(GetPointX(markerTankFirst+5), GetPointY(markerTankFirst+5));
		m_uTank7 = GetUnit(GetPointX(markerTankFirst+6), GetPointY(markerTankFirst+6));
		m_uTank8 = GetUnit(GetPointX(markerTankFirst+7), GetPointY(markerTankFirst+7));
		m_uTank9 = GetUnit(GetPointX(markerTankFirst+8), GetPointY(markerTankFirst+8));
		m_uTank10 = GetUnit(GetPointX(markerTankFirst+9), GetPointY(markerTankFirst+9));
		m_uTank11 = GetUnit(GetPointX(markerTankFirst+10), GetPointY(markerTankFirst+10));

		InitializeConvoy();

		for (i=markerTankFirst; i<=markerTankLast; i=i+1)
		{
			uTmp = GetUnit(GetPointX(i), GetPointY(i));

			uTmp.CommandSetMovementMode(2); // hold position
			uTmp.CommandSetAttackMode(2); // hold fire
		}

		m_pPlayer.LookAt(m_pPlayer.GetStartingPointX(), m_pPlayer.GetStartingPointY(), 6, 0, 0, 0);

		EnableAllResearchIRQ( m_pPlayer, false);
		m_pPlayer.EnableResearch("RES_IRQ_TANK1", true);			// M1
		m_pPlayer.EnableResearch("RES_IRQ_HELICOPTER1", true);		// M2
		m_pPlayer.EnableResearch("RES_IRQ_AMMO_MG1", true);			// M3
		m_pPlayer.EnableResearch("RES_IRQ_PILLBOX", true);			// M3
		m_pPlayer.EnableResearch("RES_IRQ_TANK2", true);			// M3
		m_pPlayer.EnableResearch("RES_IRQ_SAPER", true);			// M3
		m_pPlayer.EnableResearch("RES_IRQ_MIM", true);				// M3
		m_pPlayer.EnableResearch("RES_IRQ_AMMO_MG2", true);			// M4
		m_pPlayer.EnableResearch("RES_IRQ_RART", true);				// M4
		m_pPlayer.EnableResearch("RES_IRQ_HRART", true);			// M4
		m_pPlayer.EnableResearch("RES_IRQ_AMMO_MIM1", true);		// M4
		m_pPlayer.EnableResearch("RES_IRQ_SPECIAL_FILTER2", true);	// M4
		m_pPlayer.EnableResearch("RES_IRQ_AMMO_CANNON1", true);		// M5
		m_pPlayer.EnableResearch("RES_IRQ_BIGART", true);			// M5
		m_pPlayer.EnableResearch("RES_IRQ_AMMO_ROCKET1", true);		// M5
		m_pPlayer.EnableResearch("RES_IRQ_AMMO_HROCKET1", true);	// M5
		m_pPlayer.EnableResearch("RES_IRQ_MGM", true);				// M5
		m_pPlayer.EnableResearch("RES_IRQ_EXPLODER", true);			// M5
		m_pPlayer.EnableResearch("RES_IRQ_AMMO_CANNON2", true);		// M6
		m_pPlayer.EnableResearch("RES_IRQ_AMMO_ROCKET2", true);		// M6
		m_pPlayer.EnableResearch("RES_IRQ_AMMO_HROCKET2", true);	// M6
		m_pPlayer.EnableResearch("RES_IRQ_AMMO_MIM2", true);		// M6
		m_pPlayer.EnableResearch("RES_IRQ_JEEP_MGM", true);			// M6
		m_pPlayer.EnableResearch("RES_IRQ_SPECIAL_FILTER3", true);	// M6
		m_pPlayer.EnableResearch("RES_IRQ_AMMO_MGM1", true);		// M7
		m_pPlayer.EnableResearch("RES_IRQ_EXPLODER_BIG", true);		// M7
//		m_pPlayer.EnableResearch("RES_IRQ_SCUD", true);				// M8
		m_pPlayer.EnableResearch("RES_IRQ_SPYFLIGHTCENTER", true);	// M8
		m_pPlayer.EnableResearch("RES_IRQ_AMMO_MGM2", true);		// M8
		m_pPlayer.EnableResearch("RES_IRQ_SDI", true);				// M8
//		m_pPlayer.EnableResearch("RES_IRQ_AMMO_CHEMICAL1", true);
		m_pPlayer.EnableResearch("RES_IRQ_SPYCENTER", true);
		m_pPlayer.EnableResearch("RES_IRQ_SPECIAL_PTC", true);

		SetTimer(0, 100); // CheckDestroyedUnits

		m_pPlayer.EnableCommand(commandRecycleUnit, false);
		m_pPlayer.EnableCommand(commandSoldBuilding, false);

		return BeforeStart, 1;
	}

	state BeforeStart
	{
		PlayTrack("Music\\Briefing.tws");

		return Start;
	}

	state Start
	{
		EnableGoal(goalDestroyEnemyA, true);
		AddBriefing("translateBriefingMissionIRQ_9_DestroyEnemyA");
		PlayWave("Briefings\\IRQ_Briefing09.wav");

		return DestroyEnemyA;
	}

	state DestroyEnemyA
	{
		int i;
		unitex uTmp;

		if ( m_nTimeOfConvoyMove && GetMissionTime() >= m_nTimeOfConvoyMove )
		{
			m_uConvoyTank1.CommandMove(m_pEnemy.GetStartingPointX(), m_pEnemy.GetStartingPointY(), 0);
			m_uConvoyTank2.CommandMove(m_pEnemy.GetStartingPointX(), m_pEnemy.GetStartingPointY(), 0);
			m_uConvoyTank3.CommandMove(m_pEnemy.GetStartingPointX(), m_pEnemy.GetStartingPointY(), 0);
			m_uConvoyTank4.CommandMove(m_pEnemy.GetStartingPointX(), m_pEnemy.GetStartingPointY(), 0);

			m_nTimeOfConvoyMove = 0;
		}

		if ( ConvoyTruckArrived() )
		{
			for (i=markerTankFirst; i<=markerTankLast; i=i+1)
			{
				uTmp = GetUnit(GetPointX(i), GetPointY(i));

				if ( uTmp )
				{
					uTmp.CommandSetMovementMode(1); // follow enemy
					uTmp.CommandSetAttackMode(0); // fire at will
				}
			}

			SetGoalState(goalDestroyEnemyA, goalFailed);

			AddBriefing("translateBriefingMissionIRQ_9_MissionFail");

			EnableEndMissionButton(true, false);

			return MissionComplete;
		}

		if ( !m_bCheckNumberOfBuildings )
		{
			return DestroyEnemyA;
		}

		m_bCheckNumberOfBuildings = false;

		if ( m_pEnemy.GetNumberOfBuildings() == 0 )
		{
			return DestroyedEnemyA;
		}
		else
		{
			return DestroyEnemyA;
		}
	}

	state DestroyedEnemyA
	{
		SetGoalState(goalDestroyEnemyA, goalAchieved);

		EnableGoal(goalEscortTanks, true);
		AddBriefing("translateBriefingMissionIRQ_9_EscortTanks");

		m_uConvoyTank1.CommandMove(m_pEnemyConvoy.GetStartingPointX(), m_pEnemyConvoy.GetStartingPointY(), 0);
		m_uConvoyTank2.CommandMove(m_pEnemyConvoy.GetStartingPointX(), m_pEnemyConvoy.GetStartingPointY(), 0);
		m_uConvoyTank3.CommandMove(m_pEnemyConvoy.GetStartingPointX(), m_pEnemyConvoy.GetStartingPointY(), 0);
		m_uConvoyTank4.CommandMove(m_pEnemyConvoy.GetStartingPointX(), m_pEnemyConvoy.GetStartingPointY(), 0);

		m_uTruck1.CommandMove(m_pEnemyConvoy.GetStartingPointX(), m_pEnemyConvoy.GetStartingPointY(), 0);
		m_uTruck2.CommandMove(m_pEnemyConvoy.GetStartingPointX(), m_pEnemyConvoy.GetStartingPointY(), 0);
		m_uTruck3.CommandMove(m_pEnemyConvoy.GetStartingPointX(), m_pEnemyConvoy.GetStartingPointY(), 0);
		m_uTruck4.CommandMove(m_pEnemyConvoy.GetStartingPointX(), m_pEnemyConvoy.GetStartingPointY(), 0);

		m_uTank1.ChangePlayer(m_pPlayer);
		m_uTank2.ChangePlayer(m_pPlayer);
		m_uTank3.ChangePlayer(m_pPlayer);
		m_uTank4.ChangePlayer(m_pPlayer);
		m_uTank5.ChangePlayer(m_pPlayer);
		m_uTank6.ChangePlayer(m_pPlayer);
		m_uTank7.ChangePlayer(m_pPlayer);
		m_uTank8.ChangePlayer(m_pPlayer);
		m_uTank9.ChangePlayer(m_pPlayer);
		m_uTank10.ChangePlayer(m_pPlayer);
		m_uTank11.ChangePlayer(m_pPlayer);

		AddWorldMapSign(m_pFriend.GetStartingPointX(), m_pFriend.GetStartingPointY(), 0, 0, 65000);

		return EscortTanks;
	}

	state EscortTanks
	{
		if ( CountTanks() == CountTanksInBase() )
		{
			return EscortedTanks;
		}
		else
		{
			return EscortTanks;
		}
	}

	state EscortedTanks
	{
		RemoveWorldMapSign(m_pFriend.GetStartingPointX(), m_pFriend.GetStartingPointY(), 0);

		SetGoalState(goalEscortTanks, goalAchieved);

		EnableGoal(goalCaptureTrucks, true);
		AddBriefing("translateBriefingMissionIRQ_9_CaptureTrucks");

		return CaptureTrucks;
		
	}

	state CaptureTrucks
	{
		if ( CountTrucks() < 4 )
		{
			SetGoalState(goalCaptureTrucks, goalFailed);

			AddBriefing("translateBriefingMissionIRQ_9_MissionFail");

			EnableEndMissionButton(true, false);

			return MissionComplete;
		}

		if	(
			CheckTruck(m_uTruck1) && 
			CheckTruck(m_uTruck2) &&
			CheckTruck(m_uTruck3) &&
			CheckTruck(m_uTruck4)
			)
		{
			return CapturedTrucks;
		}
		else
		{
			return CaptureTrucks;
		}
	}

	state CapturedTrucks
	{
		SetGoalState(goalCaptureTrucks, goalAchieved);

		AddBriefing("translateBriefingMissionIRQ_9_MissionComplete");

		EnableEndMissionButton(true, true);

		return MissionComplete;
	}

	state MissionComplete
	{
		return MissionComplete;
	}

	function int CheckDestroyedUnits()
	{
		if ( state == MissionComplete ) return;

		if ( state != CaptureTrucks && state != CapturedTrucks && CountTanks() < 8 )
		{
			if ( GetGoalState(goalDestroyEnemyA) != goalAchieved )
			{
				SetGoalState(goalDestroyEnemyA, goalFailed);
			}

			if ( GetGoalState(goalEscortTanks) != goalAchieved )
			{
				SetGoalState(goalEscortTanks, goalFailed);
			}

			AddBriefing("translateBriefingMissionIRQ_9_MissionFail");

			EnableEndMissionButton(true, false);

			state MissionComplete;
		}

		if ( m_pPlayer.GetNumberOfUnits() == 0 )
		{
			if ( GetGoalState(goalDestroyEnemyA) != goalAchieved )
			{
				SetGoalState(goalDestroyEnemyA, goalFailed);
			}

			if ( GetGoalState(goalEscortTanks) != goalAchieved )
			{
				SetGoalState(goalEscortTanks, goalFailed);
			}

			if ( GetGoalState(goalCaptureTrucks) != goalAchieved )
			{
				SetGoalState(goalCaptureTrucks, goalFailed);
			}

			AddBriefing("translateBriefingMissionIRQ_9_MissionFail");

			EnableEndMissionButton(true, false);

			state MissionComplete;
		}
	}

	event Timer0()
	{
		if ( m_bCheckDestroyedUnits )
		{
			m_bCheckDestroyedUnits = false;

			CheckDestroyedUnits();
		}
	}

	event UnitDestroyed(unit uUnit)
	{
		m_bCheckNumberOfUnits = true;
		m_bCheckDestroyedUnits = true;
	}

	event BuildingDestroyed(unit uBuilding)
	{
		m_bCheckNumberOfBuildings = true;
	}

	event EndMission()
	{
		m_pPlayer.EnableCommand(commandRecycleUnit, true);
		m_pPlayer.EnableCommand(commandSoldBuilding, true);
	}

	event SetupInterface()
	{
		EnableGameFeature
			(
			lockResearchDialog |
			lockToolbarResearching |
			lockToolbarMoney |
			lockDisplayToolbarMoney |
			lockCreateBuildPanel |
			0, true);
	}
}
