campaign "translateCampaignUCSMP01"
{
    consts
    {
        raceUCS=1;
        raceLC=3;        

        mis411 = 30;
        mis412 = 31;
        mis413 = 32;
        mis414 = 33;
        mis415 = 34;
        mis416 = 35;
        mis417 = 36;
        mis418 = 37;
        mis419 = 38;
        mis420 = 39;

        baseUCS = 40;
        baseLC = 41;

        timeFlagWinter = 1;
        baseFlag = 255;
        
        // pieniadze przewidywane do budowy statku na poczatku okresu
        cashEarlySpring = 50000; 
        cashSpring = 100000;
        cashSummer = 150000;
        cashDesert = 200000;
        cashVolcano = 250000;
        spaceShipPrice = 300000;

        // czas zmiany por roku
        timeEarlySpring =     150000; //2h 5min
        timeSpring =          300000;
        timeSummer =          450000;
        timeDesert =          600000;
        timeVolcano =         750000;
        timeHeavyVolcano =    900000;
        timeEarthDestroyed=  1050000;
    }

    int n_TimeFlag;


    state Initialize;
    state Start;
    state Nothing;
    
    state Initialize
    {
        int i;
        
        RegisterMission(baseUCS,"!UCSbaseUCSMP01","UCS\\Missions\\UCSbaseUCSscriptMP01","", baseFlag,   -84, 41,0,0,0);
        RegisterMission(baseLC, "!UCSbaseLCMP01","UCS\\Missions\\UCSbaseLCscriptMP01","",    baseFlag,   120, 8,0,0,0);

        //              nr       lnd        script                    preBriefing                 timeFlags          x  y   d1  d2  d3  next1 next2 next3 next4
				//RegisterMission(mis411, "xxx", "UCS\\Missions\\xxx", "translateBriefingShort411", timeFlagWinter,    60, 60, 60, 60, 60, mis413);	//mis412 //@@@

				RegisterMission(mis411, "!411", "UCS\\Missions\\Mission411", "translateBriefingShort411", timeFlagWinter,    60, 60, 60, 60, 60, mis412);
				RegisterMission(mis412, "!412", "UCS\\Missions\\Mission412", "translateBriefingShort412", timeFlagWinter,    60, 78, 90, 90, 90, mis413);
				RegisterMission(mis413, "!413", "UCS\\Missions\\Mission413", "translateBriefingShort413", timeFlagWinter,   -100, 40, 90, 90, 90, mis414);
				RegisterMission(mis414, "!414", "UCS\\Missions\\Mission414", "translateBriefingShort414", timeFlagWinter,    120, 85,120,120,120, mis415);				
				RegisterMission(mis415, "!415", "UCS\\Missions\\Mission415", "translateBriefingShort415", timeFlagWinter,    120, 85,120,120,120, mis416);

				RegisterMission(mis416, "!416", "UCS\\Missions\\Mission416", "translateBriefingShort416", timeFlagWinter,    120, 85,120,120,120, mis417);
				RegisterMission(mis417, "!417", "UCS\\Missions\\Mission417", "translateBriefingShort417", timeFlagWinter,    120, 85,120,120,120, mis418);
				RegisterMission(mis418, "!418", "UCS\\Missions\\Mission418", "translateBriefingShort418", timeFlagWinter,    120, 85,120,120,120, mis419);
				RegisterMission(mis419, "!419", "UCS\\Missions\\Mission419", "translateBriefingShort419", timeFlagWinter,    120, 85,120,120,120, mis420);
				RegisterMission(mis420, "!420", "UCS\\Missions\\Mission420", "translateBriefingShort420", timeFlagWinter,    120, 85,120,120,120);

        n_TimeFlag = timeFlagWinter;

        CreateGamePlayer(1,raceUCS,playerLocal,null);
        CreateGamePlayer(3,raceLC,playerAI,null);

        LoadBase(1,baseUCS,1);
        LoadBase(3,baseLC,3);

        SetActivePlayerAndWorld(1,1);//player, world
        SetAvailableWorlds(1|2);//misja i baza UCS(swiat nr 1)

				EnableMission(mis411,true);
				//EnableMission(mis412,true);
				//EnableMission(mis413,true);
				//EnableMission(mis414,true);
				//EnableMission(mis415,true);
				//EnableMission(mis416,true);
				//EnableMission(mis417,true);
				//EnableMission(mis418,true);
				//EnableMission(mis419,true);
				//EnableMission(mis420,true);

        ActivateMissions(timeFlagWinter,true);
        SetSeason(8);

        return Start,10;
    }
    //-----------------------------------------------------------------------------------------
    state Start
    {
        EnableChooseMissionButton(true);
        return Nothing,50;
    }
    //-----------------------------------------------------------------------------------------
    state Nothing
    {
			
    }
    //-----------------------------------------------------------------------------------------
    event StartMission(int iMission)
    {
			EnableChooseMissionButton(false);

			TraceD(iMission);

			LoadMission(0,iMission);

			EnableMission(iMission,false);
    }

    //-----------------------------------------------------------------------------------------
    event EnableNextMission(int iMission,int iNextNr,int bEnable)
    {
        if(bEnable<2)
					EnableMission(GetNextMission(iMission,iNextNr),bEnable);

        if(bEnable==2)
					EndGame(null);
    }

    //-----------------------------------------------------------------------------------------
    event EndMission(int iMission, int nResult) // 
    {
        if(nResult==true)
				{
            SetMissionState(iMission,stateAccomplished);
				}
        else
				{
						SetMissionState(iMission,stateFailed);
				}				

        EnableChooseMissionButton(true);
    }
}

//************************************
