mission "translateMission414"
{

    consts
    {
        DestroyEnemy = 0;
    	Collect20000 = 1;
    	NeededMoney = 20000;
    }

   	player p_TmpPlayer;
	player p_Player;
	player p_Enemy1;
	player p_Enemy2;
	player p_Enemy3;
	
	int nMoney;
    int bCheckEndMission;

	state Initialize;
	state ShowBriefing;
	state Working;
    state MissionFailed;
    state Nothing;

    //----------------------------------------------------------------------------------------- 
    state Initialize
    {
        //----------- Goals ------------------
        RegisterGoal(DestroyEnemy, "translateGoal414DestroyEnemy");
        RegisterGoal(Collect20000, "translateGoal414Collect20000");

		//---Show goals on list---
        EnableGoal(DestroyEnemy, true);
        EnableGoal(Collect20000, true);
        
        //----------- Players ----------------
        p_Player = GetPlayer(1);	//UCS
        p_Enemy1 = GetPlayer(3);	//LC
        p_Enemy2 = GetPlayer(4);	//LC
        p_Enemy3 = GetPlayer(5);	//LC

    	p_TmpPlayer = GetPlayer(2);
    	p_TmpPlayer.EnableStatistics(false);
        
        //----------- AI ---------------------
        
        if(GetDifficultyLevel()==0)
        {
            p_Enemy1.LoadScript("single\\singleEasy");
            p_Enemy2.LoadScript("single\\singleEasy");
            p_Enemy3.LoadScript("single\\singleEasy");
        }
        if(GetDifficultyLevel()==1)
        {
            p_Enemy1.LoadScript("single\\singleMedium");
            p_Enemy2.LoadScript("single\\singleMedium");
            p_Enemy3.LoadScript("single\\singleMedium");
        }
        if(GetDifficultyLevel()==2)
        {
            p_Enemy1.LoadScript("single\\singleHard");
            p_Enemy2.LoadScript("single\\singleHard");
            p_Enemy3.LoadScript("single\\singleHard");
        }

        p_Enemy1.SetMilitaryUnitsLimit(5000);
        p_Enemy2.SetMilitaryUnitsLimit(10000);
        p_Enemy3.SetMilitaryUnitsLimit(15000);


        //wylacz inteligencje graczy
        p_Enemy1.EnableAIFeatures(aiControlOffense,false);
        p_Enemy1.EnableAIFeatures(aiControlDefense,false);
        p_Enemy1.EnableAIFeatures(aiBuildBuildings,false);
        
        p_Enemy2.EnableAIFeatures(aiControlOffense,false);
        p_Enemy2.EnableAIFeatures(aiControlDefense,false);
        p_Enemy2.EnableAIFeatures(aiBuildBuildings,false);
        
        p_Enemy3.EnableAIFeatures(aiControlOffense,false);
        p_Enemy3.EnableAIFeatures(aiControlDefense,false);
        p_Enemy3.EnableAIFeatures(aiBuildBuildings,false);
        
        
        p_Enemy1.SetAlly(p_Enemy2);
        p_Enemy1.SetAlly(p_Enemy3);
        p_Enemy2.SetAlly(p_Enemy3);

				p_Enemy1.EnableResearch("RES_LC_WMR1",true);	//Wyrzutnia cikich rakiet R12
        p_Enemy1.EnableResearch("RES_LC_AMR1",true);	//Wyrzutnia cikich rakiet R1a
        p_Enemy1.EnableResearch("RES_LC_WHL1",true);	//Dziao elektryczne E3
				p_Enemy1.EnableResearch("RES_LC_UCR1",true);	//Crater m1

        
        //----------- Money ------------------
        p_Player.SetMoney(7000);
        p_Enemy1.SetMoney(3000);
        p_Enemy2.SetMoney(5000);
        p_Enemy3.SetMoney(10000);
        
        //----------- Timers -----------------
        //----------- Variables --------------
        bCheckEndMission=false;
	    
        //---- Creating additional units -----
        if(GetDifficultyLevel()==1)
        {
			p_Enemy1.CreateUnitEx(GetPointX(0), GetPointY(0), 0, null, "LCUCU3", "LCWMR3", "LCWMR3", null, null); // Crusher m3 + hR

			p_Enemy2.CreateUnitEx(GetPointX(2), GetPointY(2), 0, null, "LCUCU3", "LCWMR3", "LCWMR3", null, null); // Crusher m3 + hR
			p_Enemy2.CreateUnitEx(GetPointX(3), GetPointY(3), 0, null, "LCUCU3", "LCWMR3", "LCWMR3", null, null); // Crusher m3 + hR

			p_Enemy3.CreateUnitEx(GetPointX(6), GetPointY(6), 0, null, "LCUCU3", "LCWMR3", "LCWMR3", null, null); // Crusher m3 + hR
			p_Enemy3.CreateUnitEx(GetPointX(7), GetPointY(7), 0, null, "LCUCU3", "LCWMR3", "LCWMR3", null, null); // Crusher m3 + hR
        }
        if(GetDifficultyLevel()==2)
        {
			p_Enemy1.CreateUnitEx(GetPointX(0), GetPointY(0), 0, null, "LCUCU3", "LCWMR3", "LCWMR3", null, null); // Crusher m3 + hR
			p_Enemy1.CreateUnitEx(GetPointX(1), GetPointY(1), 0, null, "LCUCR3", "LCWMR3", null, null, null); // Crater m3 + R

			p_Enemy2.CreateUnitEx(GetPointX(2), GetPointY(2), 0, null, "LCUCU3", "LCWMR3", "LCWMR3", null, null); // Crusher m3 + hR
			p_Enemy2.CreateUnitEx(GetPointX(3), GetPointY(3), 0, null, "LCUCU3", "LCWMR3", "LCWMR3", null, null); // Crusher m3 + hR
			p_Enemy2.CreateUnitEx(GetPointX(4), GetPointY(4), 0, null, "LCUCR3", "LCWMR3", null, null, null); // Crater m3 + R
			p_Enemy2.CreateUnitEx(GetPointX(5), GetPointY(5), 0, null, "LCUCR3", "LCWMR3", null, null, null); // Crater m3 + R

			p_Enemy3.CreateUnitEx(GetPointX(6), GetPointY(6), 0, null, "LCUCU3", "LCWMR3", "LCWMR3", null, null); // Crusher m3 + hR
			p_Enemy3.CreateUnitEx(GetPointX(7), GetPointY(7), 0, null, "LCUCU3", "LCWMR3", "LCWMR3", null, null); // Crusher m3 + hR
			p_Enemy3.CreateUnitEx(GetPointX(9), GetPointY(9), 0, null, "LCUCR3", "LCWMR3", null, null, null); // Crater m3 + R
			p_Enemy3.CreateUnitEx(GetPointX(10), GetPointY(10), 0, null, "LCUCR3", "LCWMR3", null, null, null); // Crater m3 + R
        }
        
		p_Player.EnableBuilding("UCSBWB", false);	//Stocznia
		p_Player.EnableBuilding("UCSBTB", false);	//Centrum transportu rudy
		p_Player.EnableBuilding("UCSCSD", false);	//Laser antyrakietowy

        //----------- Camera -----------------
        CallCamera();
        p_Player.LookAt(p_Player.GetStartingPointX(),p_Player.GetStartingPointY(),6,0,20,0);
        return ShowBriefing, 100;
    }

    //-----------------------------------------------------------------------------------------
    state ShowBriefing
    {
        AddBriefing("translateBriefing414", p_Player.GetName());
        return Working, 100;
    }

	//-----------------------------------------------------------------------------------------
	state Working
	{
        if(bCheckEndMission)
        {
            bCheckEndMission=false;
			if(!p_Player.GetNumberOfUnits() && !p_Player.GetNumberOfBuildings())
			{
				SetGoalState(DestroyEnemy, goalFailed);
				SetGoalState(Collect20000, goalFailed);
				AddBriefing("translateFailed414", p_Player.GetName());
			 	return MissionFailed, 20;
			}

			if(!p_Enemy1.GetNumberOfBuildings() && !p_Enemy2.GetNumberOfBuildings() && !p_Enemy3.GetNumberOfBuildings())
			{
				SetGoalState(DestroyEnemy, goalAchieved);
			}
		}


		if(GetGoalState(DestroyEnemy) == goalAchieved)
		{
			nMoney = p_Player.GetMoney();
			
			if(nMoney >= NeededMoney)
			{
				nMoney = nMoney - NeededMoney;
				p_Player.SetMoney(nMoney);
				SetGoalState(Collect20000, goalAchieved);
				AddBriefing("translateAccomplished414", p_Player.GetName());
				EnableNextMission(0, true);
				EnableEndMissionButton(true);
				return Nothing;
			}
		}

		return Working, 100;
	}

    //-----------------------------------------------------------------------------------------
    state MissionFailed
    {
	 	EnableNextMission(0,2);
	 	return Nothing;
    }

    //-----------------------------------------------------------------------------------------
    state Nothing
    {
        return Nothing, 500;
    }

    //-----------------------------------------------------------------------------------------
    event UnitDestroyed(unit u_Unit)
    {
        bCheckEndMission=true;
    }

    //-----------------------------------------------------------------------------------------
    event BuildingDestroyed(unit u_Unit)
    { 
        bCheckEndMission=true;
    }

}
