mission "translateMission411"
{
	consts
	{
		RescueGrizzli1 = 0;
		RescueGrizzli2 = 1;
		DestroyLC = 2;
		CaptureCPU = 3;
	}

    player p_Enemy;
		player p_Escort1;
		player p_Escort2;
    player p_Player;
		player p_Grizzli1;
		player p_Grizzli2;
		player p_Teleport;
  
		int DestroyLCAchieved;
		int RescueGrizzliAchieved1;
		int RescueGrizzliAchieved2;
    int CaptureCPUAchieved;
		int LCBaseLocated;

		int xLCBase;
		int yLCBase;

		int i;
    
    state Initialize;
    state ShowBriefing;
		state Working;
    state Nothing;
		state EndMissionFailed;
    //----------------------------------------------------------------------------------------- 
    state Initialize
    {
				DestroyLCAchieved = false;
				RescueGrizzliAchieved1 = false;
				RescueGrizzliAchieved2 = false;
				CaptureCPUAchieved = false;
				LCBaseLocated = false;


        //----------- Goals ------------------
        RegisterGoal(RescueGrizzli1, "translateGoalRescueGrizzli1");
				RegisterGoal(RescueGrizzli2, "translateGoalRescueGrizzli2");
				RegisterGoal(DestroyLC,     "translateGoalDestroyLC");				
				RegisterGoal(CaptureCPU,    "translateGoalCaptureCPU");

				//---show goals on list---
        EnableGoal(DestroyLC,false);
				EnableGoal(RescueGrizzli1,true);
				EnableGoal(RescueGrizzli2,true);
				EnableGoal(CaptureCPU,false);
				

        
        //----------- Players ----------------
        p_Player = GetPlayer(1);	//ja czyli UCS
        p_Enemy = GetPlayer(3);	//LC
				p_Grizzli1 = GetPlayer(4);	//gracz do przejecia
				p_Grizzli2 = GetPlayer(5);	//gracz do przejecia
				p_Teleport = GetPlayer(6);
				p_Escort1 = GetPlayer(7);
				p_Escort2 = GetPlayer(8);

				p_Grizzli1.EnableStatistics(false);
				p_Grizzli2.EnableStatistics(false);
				p_Escort1.EnableStatistics(false);
				p_Escort2.EnableStatistics(false);
				p_Teleport.EnableStatistics(false);


        //----------- AI ---------------------
        
        if(GetDifficultyLevel()==0)
				{
					p_Enemy.LoadScript("single\\singleEasy");
					p_Escort1.LoadScript("single\\singleEasy");
					p_Escort2.LoadScript("single\\singleEasy");
				}

        if(GetDifficultyLevel()==1)
				{
					p_Enemy.LoadScript("single\\singleMedium");
					p_Escort1.LoadScript("single\\singleMedium");
					p_Escort2.LoadScript("single\\singleMedium");
				}

        if(GetDifficultyLevel()==2)
				{
					p_Enemy.LoadScript("single\\singleHard");
					p_Escort1.LoadScript("single\\singleHard");
					p_Escort2.LoadScript("single\\singleHard");
				}


				//---Grizzli as neutral----------------
				p_Grizzli1.EnableAIFeatures(aiControlOffense, false);

				p_Grizzli1.SetNeutral(p_Player);
				p_Player.SetNeutral(p_Grizzli1);

				p_Grizzli1.SetNeutral(p_Escort1);
				p_Escort1.SetNeutral(p_Grizzli1);


				p_Grizzli2.EnableAIFeatures(aiControlOffense, false);
				p_Player.SetNeutral(p_Grizzli2);
				p_Grizzli2.SetNeutral(p_Player);

				p_Grizzli2.SetNeutral(p_Escort2);
				p_Escort2.SetNeutral(p_Grizzli2);


				//--- don't attack Teleport please ---
				p_Enemy.SetNeutral(p_Teleport);
				p_Player.SetNeutral(p_Teleport);


				//----------- Variables --------------
				xLCBase = GetPointX(0);
				yLCBase = GetPointY(0);


        //----AI off-------------
        p_Enemy.EnableAIFeatures(aiControlOffense,false);
        p_Enemy.EnableAIFeatures(aiControlDefense,false);
				p_Enemy.EnableAIFeatures(aiBuildBuildings,false);

        p_Escort1.EnableAIFeatures(aiControlOffense,false);
        p_Escort1.EnableAIFeatures(aiControlDefense,false);

        p_Escort2.EnableAIFeatures(aiControlOffense,false);
        p_Escort2.EnableAIFeatures(aiControlDefense,false);

        
        //----------- Money ------------------
        p_Enemy.SetMoney(5000);


				//-----Easy------------
				if(GetDifficultyLevel()==0)
				{
					//kill needless buildings
					KillArea(p_Enemy.GetIFF(), GetPointX(0), GetPointY(0), 0, 1);
					KillArea(p_Enemy.GetIFF(), GetPointX(1), GetPointY(1), 0, 1);
					p_Enemy.SetMilitaryUnitsLimit(16000);
				}

				//-----Normal----------
				if(GetDifficultyLevel()==1)
				{
					//kill needless buildings
					KillArea(p_Enemy.GetIFF(), GetPointX(1), GetPointY(1), 0, 1);

					//add units	meteor : LCUME1
					p_Enemy.CreateUnitEx(GetPointX(14), GetPointY(14), 0,null,"LCUME1","LCWAC2",null,null,null);

					//lunar: LCULU1 + LCWCH1 - eskorta grizzlieo 1
					p_Escort1.CreateUnitEx(GetPointX(2), GetPointY(2), 0,null,"LCULU1","LCWCH1",null,null,null);

					//lunar: LCULU1 + LCWCH1 - eskorta grizzlieo 2
					p_Escort2.CreateUnitEx(GetPointX(5), GetPointY(5), 0,null,"LCULU1","LCWCH1",null,null,null);

					//lunar: LCULU1 + LCWCH1
					p_Enemy.CreateUnitEx(GetPointX(3), GetPointY(3), 0,null,"LCULU1","LCWCH1",null,null,null);
					p_Enemy.CreateUnitEx(GetPointX(4), GetPointY(4), 0,null,"LCULU1","LCWCH1",null,null,null);
					p_Enemy.CreateUnitEx(GetPointX(6), GetPointY(6), 0,null,"LCULU1","LCWCH1",null,null,null);
					p_Enemy.CreateUnitEx(GetPointX(7), GetPointY(7), 0,null,"LCULU1","LCWCH1",null,null,null);

					//moon : LCUMO1 - under ground
					p_Enemy.CreateUnitEx(GetPointX(16), GetPointY(16), GetPointZ(16),null,"LCUMO1","LCWCH1",null,null,null);					

					p_Enemy.SetMilitaryUnitsLimit(24000);
				}

				//-----Hard----------
				if(GetDifficultyLevel()==2)
				{
					//add units	meteor : LCUME1
					p_Enemy.CreateUnitEx(GetPointX(14), GetPointY(14), 0,null,"LCUME1","LCWAC2",null,null,null);


					//lunar: LCULU1 + LCWCH1 - eskorta grizzlieo 1
					p_Escort1.CreateUnitEx(GetPointX(2), GetPointY(2), 0,null,"LCULU1","LCWCH1",null,null,null);

					//lunar: LCULU1 + LCWCH1 - eskorta grizzlieo 2
					p_Escort2.CreateUnitEx(GetPointX(5), GetPointY(5), 0,null,"LCULU1","LCWCH1",null,null,null);

					//lunar: LCULU1 + LCWCH1
					p_Enemy.CreateUnitEx(GetPointX(3), GetPointY(3), 0,null,"LCULU1","LCWCH1",null,null,null);
					p_Enemy.CreateUnitEx(GetPointX(4), GetPointY(4), 0,null,"LCULU1","LCWCH1",null,null,null);
					p_Enemy.CreateUnitEx(GetPointX(6), GetPointY(6), 0,null,"LCULU1","LCWCH1",null,null,null);
					p_Enemy.CreateUnitEx(GetPointX(7), GetPointY(7), 0,null,"LCULU1","LCWCH1",null,null,null);

					//moon: 8-13
					p_Escort1.CreateUnitEx(GetPointX(8), GetPointY(8), 0,null,"LCUMO1","LCWCH1",null,null,null);
					p_Escort2.CreateUnitEx(GetPointX(11), GetPointY(11), 0,null,"LCUMO1","LCWCH1",null,null,null);

					p_Enemy.CreateUnitEx(GetPointX(9), GetPointY(9), 0,null,"LCUMO1","LCWCH1",null,null,null);
					p_Enemy.CreateUnitEx(GetPointX(10), GetPointY(10), 0,null,"LCUMO1","LCWCH1",null,null,null);
					p_Enemy.CreateUnitEx(GetPointX(12), GetPointY(12), 0,null,"LCUMO1","LCWCH1",null,null,null);
					p_Enemy.CreateUnitEx(GetPointX(13), GetPointY(13), 0,null,"LCUMO1","LCWCH1",null,null,null);


					//moon : LCUMO1 - under ground
					p_Enemy.CreateUnitEx(GetPointX(16), GetPointY(16), GetPointZ(16),null,"LCUMO1","LCWCH1",null,null,null);
					p_Enemy.CreateUnitEx(GetPointX(17), GetPointY(17), GetPointZ(17),null,"LCUMO1","LCWCH1",null,null,null);
					p_Enemy.CreateUnitEx(GetPointX(18), GetPointY(18), GetPointZ(18),null,"LCUMO1","LCWCH1",null,null,null);

					//crusher : LCUCU1
					p_Enemy.CreateUnitEx(GetPointX(19), GetPointY(19),0,null,"LCUCU1","LCWMR2","LCWMR2",null,null);

					p_Enemy.SetMilitaryUnitsLimit(31000);
				}

				p_Player.SetMilitaryUnitsLimit(30000);

				//---Artefacts : computers to capture ----
			//	CreateArtefact("NEASPECIAL5", GetPointX(22), GetPointY(22)-3,GetPointZ(22),3,artefactSpecialAIOther);
			//	CreateArtefact("NEASPECIAL5", GetPointX(22), GetPointY(22)-2,GetPointZ(22),1,artefactSpecialAIOther);
			//	CreateArtefact("NEASPECIAL5", GetPointX(22), GetPointY(22)-1,GetPointZ(22),2,artefactSpecialAIOther);
				CreateArtefact("NEASPECIAL5", GetPointX(22), GetPointY(22),  GetPointZ(22),0,artefactSpecialAIOther);
			//	CreateArtefact("NEASPECIAL5", GetPointX(22), GetPointY(22)+1,GetPointZ(22),4,artefactSpecialAIOther);
			//	CreateArtefact("NEASPECIAL5", GetPointX(22), GetPointY(22)+2,GetPointZ(22),5,artefactSpecialAIOther);
			//	CreateArtefact("NEASPECIAL5", GetPointX(22), GetPointY(22)+3,GetPointZ(22),6,artefactSpecialAIOther);

				p_Escort1.SetAlly(p_Enemy);
				p_Escort2.SetAlly(p_Enemy);

				SetTimer(0, 100);

        //----------- Camera -----------------
        CallCamera();
        p_Player.LookAt(p_Player.GetStartingPointX(), p_Player.GetStartingPointY(), 6, 0, 20, 0);
        return ShowBriefing;
    }

    //-----------------------------------------------------------------------------------------
    state ShowBriefing
    {
				ShowArea(p_Player.GetIFF(), GetPointX(19), GetPointY(19), 0, 2);
				ShowArea(p_Player.GetIFF(), GetPointX(20), GetPointY(20), 0, 2);
				AddBriefing("translateBriefing411a", p_Player.GetName());	//D:+name
        return Working;
    }


		//-----------------------------------------------------------------------------------------
		state Working
		{
			if(!p_Player.GetNumberOfUnits())
			{
				AddBriefing("translateFailed411", p_Player.GetName());
				return EndMissionFailed;
			}

			//--------- check goals --------------------------------

			//----capture LC base---

			if(GetGoalState(DestroyLC)!=goalAchieved && !p_Enemy.GetNumberOfBuildings())
			{
				SetGoalState(DestroyLC, goalAchieved);
				AddBriefing("translateBriefing411e", p_Player.GetName());//LC base has been destroyed
				DestroyLCAchieved = true;
			}

			//---free Grizzli1---
			if(GetGoalState(RescueGrizzli1)!= goalAchieved && !p_Escort1.GetNumberOfUnits())
			{
				p_Grizzli1.GiveAllUnitsTo(p_Player);
				EnableGoal(DestroyLC,true);
				SetGoalState(RescueGrizzli1, goalAchieved);
				AddBriefing("translateBriefing411c", p_Player.GetName());//grizzli 1 recovered
			}

			//---free Grizzli2---
			if(GetGoalState(RescueGrizzli2)!=goalAchieved && !p_Escort2.GetNumberOfUnits())
			{
				p_Grizzli2.GiveAllUnitsTo(p_Player);
				EnableGoal(DestroyLC,true);
				SetGoalState(RescueGrizzli2, goalAchieved);
				AddBriefing("translateBriefing411d", p_Player.GetName());	//grizzli 2 recovered
			}
		
			//---LC base located---
			if(!LCBaseLocated && p_Player.IsPointLocated(xLCBase, yLCBase))
			{			
				EnableGoal(CaptureCPU,true);
				EnableGoal(DestroyLC,true);
				AddBriefing("translateBriefing411b", p_Player.GetName());	//D+name
				LCBaseLocated=true;
			}
		

			//-----check the goal----------
			
			//--- misja wykonana calkowicie ---
			if(DestroyLCAchieved && CaptureCPUAchieved)
			{
				EnableNextMission(0,true);
				AddBriefing("translateAccomplished411", p_Player.GetName());//D+name
				EnableEndMissionButton(true);
				return Nothing;
			}

			return Working;
		}
		//-----------------------------------------------------------------------------------------
		state EndMissionFailed
		{
			EnableNextMission(0,2);
			return Nothing;
		}


    //-----------------------------------------------------------------------------------------
    state Nothing
    {
        return Nothing, 500;
    }
    //-----------------------------------------------------------------------------------------

		event Timer0()
		{
		//	TraceD(p_Enemy.GetMoney());
		//	TraceD("           \n");
		}

		//---capture CPU---------------------------------------------------------------------------
    event Artefact(int aID,player piPlayer)
    {
        if(piPlayer!=p_Player) return false;
				CaptureCPUAchieved = true;
				SetGoalState(CaptureCPU, goalAchieved);
				ShowArea(p_Player.GetIFF(), GetPointX(22), GetPointY(22), 1, 200);
				AddBriefing("translateBriefing411f", p_Player.GetName());	
        return true; //usuwa sie
    }
}
