campaign "translateCampaignRUS"
{
	consts
	{
		raceUSA = 1;
		raceRUS = 2;
		raceIRQ = 3;

		base = 100;

		mis1 = 0;
		mis2 = 1;
		mis3 = 2;
		mis4 = 3;
		mis5 = 4;
	}
	
	state Initialize;
	state Nothing;
	
	state Initialize
	{
		CreateGamePlayer(9, raceRUS, playerLocal, null);

		SetTime(100);

		RegisterMission(base, "!MissionRUS_Base","RUS\\Missions\\MissionRUS_Base","", 0, 0, 0, 0, 0, 0);

		RegisterMission(mis1, "!MissionRUS_1","RUS\\Missions\\MissionRUS_1","translateBriefingShortMissionRUS_1", 0, 0, 0, 0, 0, 0, mis2);
		RegisterMission(mis2, "!MissionRUS_2","RUS\\Missions\\MissionRUS_2","translateBriefingShortMissionRUS_2", 0, 0, 0, 0, 0, 0, mis3);
		RegisterMission(mis3, "!MissionRUS_3","RUS\\Missions\\MissionRUS_3","translateBriefingShortMissionRUS_3", 0, 0, 0, 0, 0, 0, mis4);

		LoadBase(1, base);

		EnableMission(mis1, true);
		ActivateMission(mis1, true);

		SetAvailableWorlds(1|2);
		SetActivePlayerAndWorld(9,1);

		EnableChooseMissionButton(true);

		return Nothing;
	}

	state Nothing
	{
		return Nothing;
	}

	int m_nNextMission;
	
	event StartMission(int iMission)
	{
		EnableChooseMissionButton(false);
		LoadMission(0,iMission);
		EnableMission(iMission,false);
	}
	
	event EndMission(int iMission, int nResult)
	{
		if (nResult == true)
		{
			SetMissionState(iMission, stateAccomplished);

			if ( iMission == mis3 )
			{
				EndGame("");
			}
			m_nNextMission = GetNextMission(iMission, 0);
		}
		else
		{
			SetMissionState(iMission, stateFailed);

			m_nNextMission = iMission;
		}

		EnableMission(m_nNextMission, true);
		ActivateMission(m_nNextMission, true);
		//ForceKeepBitmapAfterStatistic();
		EnableChooseMissionButton(true);
	}
}
