campaign "translateCampaignRUS_1"
{
	consts
	{
		raceUSA = 1;
		raceRUS = 2;
		raceIRQ = 3;

		base = 100;

		mis1 = 0;
		mis2 = 1;
		mis3 = 2;
		mis4 = 3;
		mis5 = 4;
	}
	
	state Initialize;
	state LoadBase;
    state LoadFirstMission;
    state ShowOutro;
    state EndCampaign;
	state Nothing;
	
	state Initialize
	{
		CreateGamePlayer(9, raceRUS, playerLocal, null);

		SetTime(100);

		RegisterMission(base, "!MissionRUS_Base","RUS\\Missions\\MissionRUS_Base","", 0, 0, 0, 0, 0, 0);

		RegisterMission(mis1, "!MissionRUS_1","RUS\\Missions\\MissionRUS_1","translateBriefingShortMissionRUS_1", 0, 0, 0, 0, 0, 0, mis2);
		RegisterMission(mis2, "!MissionRUS_2","RUS\\Missions\\MissionRUS_2","translateBriefingShortMissionRUS_2", 0, 0, 0, 0, 0, 0, mis3);
		RegisterMission(mis3, "!MissionRUS_3","RUS\\Missions\\MissionRUS_3","translateBriefingShortMissionRUS_3", 0, 0, 0, 0, 0, 0, mis4);
		RegisterMission(mis4, "!MissionRUS_4","RUS\\Missions\\MissionRUS_4","translateBriefingShortMissionRUS_4", 0, 0, 0, 0, 0, 0, mis5);
		RegisterMission(mis5, "!MissionRUS_5","RUS\\Missions\\MissionRUS_5","translateBriefingShortMissionRUS_5", 0, 0, 0, 0, 0, 0);

		ForceKeepBitmapAfterStatistic();
		
		ShowMissionVideoDialog("RUS1_Intro", null, true);
		SetLoadBitmap("Interface\\Bkg0225.tex");

		EnableGameFeature
			(
//			lockResearchDialog |
			lockConstructionDialog |
			lockUpgradeWeaponDialog |
			lockAllianceDialog |
			lockGiveMoneyDialog |
			lockGiveUnitsDialog |
//			lockShowToolbar |
//			lockToolbarMap |
//			lockToolbarPanel |
//			lockToolbarNextWorld |
//			lockToolbarLevelName |
//			lockToolbarTunnels |
//			lockToolbarSwitchMode |
//			lockToolbarResearching |
			lockToolbarConstruction |
			lockToolbarAlliance |
			lockToolbarGiveMoney |
//			lockToolbarObjectives |
//			lockToolbarMenu |
//			lockToolbarMoney |
			lockToolbarEnergy |
//			lockDisplayToolbarLevelName |
//			lockDisplayToolbarMoney |
			lockDisplayToolbarEnergy |
//			lockCreateBuildPanel |
//			lockCreatePanel |
//			lockCreateMap |
			0, true);

        return LoadBase, 1;
	}

	state LoadBase
	{
		LoadBase(1, base);

		SetAvailableWorlds(1|2);
		SetActivePlayerAndWorld(9,1);

		return LoadFirstMission, 200;
	}

    state LoadFirstMission
    {
		LoadMission(0, mis1);

        return Nothing,0;
    }

	state Nothing
	{
        return Nothing,0;
	}

    state ShowOutro
    {
        ShowMissionVideoDialog("RUS1_Outro", null, true);

        return EndCampaign, 0;
    }

    state EndCampaign
	{
		EnableCampaign("RUS\\CampaignRUS_2Disabled");

        EndGame("");

        return Nothing,0;
    }

	int m_nNextMission;

	state LoadNextMission
	{
		LoadMission(0, m_nNextMission);

		return Nothing;
	}

    //wersja gdy po ostatniej misji sa statystyki
	event EndMission(int iMission, int nResult)
	{
		ForceKeepBitmapAfterStatistic();

		if (nResult == true)
		{
			if ( iMission == mis5 )
			{
                state ShowOutro;
			}
            else
            {
				SendCustomEvent(0, iMission, 0, 0, 0);
			    m_nNextMission = GetNextMission(iMission, 0);

		        state LoadNextMission;
            }
		}
		else
		{
	        EndGame("");

		    state Nothing;
		}
	}


	enum difficultyLevel
    {
        "translateSelectCampaignDifficultyEasy",
		"translateSelectCampaignDifficultyMedium",
		"translateSelectCampaignDifficultyHard",
        multi:
        ""
    }

    command Initialize()
    {
        difficultyLevel = 1;
    }

    command DifficultyLevel(int nLevel) button difficultyLevel
    {
    }
}
