campaign "translateCampaignRUS_2"
{
	consts
	{
		raceUSA = 1;
		raceRUS = 2;
		raceIRQ = 3;

		mis1 = 5;
		mis2 = 6;
		mis3 = 7;
		mis4 = 8;
		mis5 = 9;
	}
	
	state Initialize;
	state LoadFirstMission;
	state ShowOutro;
	state ShowCredits;
	state EndCampaign;
	state Nothing;
	
	state Initialize
	{
		CreateGamePlayer(9, raceRUS, playerLocal, null);

		SetTime(100);

		RegisterMission(mis1, "!MissionRUS_6","RUS\\Missions\\MissionRUS_6","translateBriefingShortMissionRUS_6", 0, 0, 0, 0, 0, 0, mis2);
		RegisterMission(mis2, "!MissionRUS_7","RUS\\Missions\\MissionRUS_7","translateBriefingShortMissionRUS_7", 0, 0, 0, 0, 0, 0, mis3);
		RegisterMission(mis3, "!MissionRUS_8","RUS\\Missions\\MissionRUS_8","translateBriefingShortMissionRUS_8", 0, 0, 0, 0, 0, 0, mis4);
		RegisterMission(mis4, "!MissionRUS_9","RUS\\Missions\\MissionRUS_9","translateBriefingShortMissionRUS_9", 0, 0, 0, 0, 0, 0, mis5);
		RegisterMission(mis5, "!MissionRUS_10","RUS\\Missions\\MissionRUS_10","translateBriefingShortMissionRUS_10", 0, 0, 0, 0, 0, 0);

        ForceKeepBitmapAfterStatistic();

        ShowMissionVideoDialog("RUS2_Intro", null, true);
		SetLoadBitmap("Interface\\Bkg0225.tex");

		EnableGameFeature
			(
//			lockResearchDialog |
			lockConstructionDialog |
			lockUpgradeWeaponDialog |
			lockAllianceDialog |
			lockGiveMoneyDialog |
			lockGiveUnitsDialog |
//			lockShowToolbar |
//			lockToolbarMap |
//			lockToolbarPanel |
			lockToolbarNextWorld |
			lockToolbarLevelName |
//			lockToolbarTunnels |
//			lockToolbarSwitchMode |
//			lockToolbarResearching |
			lockToolbarConstruction |
			lockToolbarAlliance |
			lockToolbarGiveMoney |
//			lockToolbarObjectives |
//			lockToolbarMenu |
//			lockToolbarMoney |
			lockToolbarEnergy |
			lockDisplayToolbarLevelName |
//			lockDisplayToolbarMoney |
			lockDisplayToolbarEnergy |
//			lockCreateBuildPanel |
//			lockCreatePanel |
//			lockCreateMap |
			0, true);

        return LoadFirstMission, 1;
	}

    state LoadFirstMission
    {
		LoadMission(0, mis1);

		SetAvailableWorlds(1);
		SetActivePlayerAndWorld(9,0);

        return Nothing,0;
    }

	state Nothing
	{
        return Nothing,0;
	}

    state ShowOutro
    {
        ShowMissionVideoDialog("RUS2_Outro", null, true);

        return ShowCredits, 0;
    }

	state ShowCredits
	{
		ShowMissionVideoDialog("credits", null, true);

        return EndCampaign, 0;
	}

    state EndCampaign
	{
        EndGame("");

        return Nothing,0;
    }

	int m_nNextMission;

	state LoadNextMission
	{
		LoadMission(0, m_nNextMission);

		return Nothing;
	}

    //wersja gdy po ostatniej misji sa statystyki
	event EndMission(int iMission, int nResult)
	{
		ForceKeepBitmapAfterStatistic();

		if (nResult == true)
		{
			if ( iMission == mis5 )
			{
                state ShowOutro;
			}
            else
            {
			    m_nNextMission = GetNextMission(iMission, 0);

		        state LoadNextMission;
            }
		}
		else
		{
	        EndGame("");

		    state Nothing;
		}
	}


	enum difficultyLevel
    {
        "translateSelectCampaignDifficultyEasy",
		"translateSelectCampaignDifficultyMedium",
		"translateSelectCampaignDifficultyHard",
        multi:
        ""
    }

    command Initialize()
    {
        difficultyLevel = 1;
    }

    command DifficultyLevel(int nLevel) button difficultyLevel
    {
    }
}
