mission "translateLessonRUS_1"
{
	consts
	{
		goalCaptureEnemyShafts = 0;
		goalCaptureEnemyUnits = 1;
		goalCaptureEnemyBase = 2;

		markerUnitsA = 0;
		markerUnitsB = 1;

		markerEnemyUnits = 16;

		markerEnemyUnit1 = 6;
		markerEnemyUnit2 = 7;
		markerEnemyUnit3 = 8;
		markerEnemyUnit4 = 9;
		markerEnemyUnit5 = 10;
		markerEnemyUnit6 = 11;
		markerEnemyUnit7 = 12;

		markerMapLimiter = 19;
	}

	player m_pPlayer;
	player m_pEnemy;
	player m_pEnemyShafts;

	unitex m_uEnemyUnit1;
	unitex m_uEnemyUnit2;
	unitex m_uEnemyUnit3;
	unitex m_uEnemyUnit4;
	unitex m_uEnemyUnit5;
	unitex m_uEnemyUnit6;
	unitex m_uEnemyUnit7;

	int m_bCheckNumberOfUnits;
	int m_bCheckNumberOfBuildings;

	int m_nCounter;

	state Initialize;
	state Start;
	state StartMessage;
	state ShowedUnitsA;
	state ShowedUnitsB;
	state CaptureEnemyShafts;
	state CapturedEnemyShafts;
	state ShowEnemyUnits;
	state ShowedEnemyUnits;
	state ShowedEnemyUnitsMessage;
	state CaptureEnemyUnits;
	state CapturedEnemyUnits;
	state CaptureEnemyBase;
	state CapturedEnemyBase;
	state MissionComplete;

	state Initialize
	{
		RegisterGoal(goalCaptureEnemyShafts, "translateGoalLessonRUS_1_CaptureEnemyShafts");
		RegisterGoal(goalCaptureEnemyUnits, "translateGoalLessonRUS_1_CaptureEnemyUnits");
		RegisterGoal(goalCaptureEnemyBase, "translateGoalLessonRUS_1_CaptureEnemyBase");

		m_pPlayer = GetPlayer(9);
		m_pEnemy = GetPlayer(3);
		m_pEnemyShafts = GetPlayer(1);

		m_pPlayer.EnableStatistics(false);
		m_pEnemy.EnableStatistics(false);
		m_pEnemyShafts.EnableStatistics(false);

		m_pEnemy.EnableAI(false);
		m_pEnemyShafts.EnableAI(false);

		m_uEnemyUnit1 = GetUnit(GetPointX(markerEnemyUnit1), GetPointY(markerEnemyUnit1));
		m_uEnemyUnit2 = GetUnit(GetPointX(markerEnemyUnit2), GetPointY(markerEnemyUnit2));
		m_uEnemyUnit3 = GetUnit(GetPointX(markerEnemyUnit3), GetPointY(markerEnemyUnit3));
		m_uEnemyUnit4 = GetUnit(GetPointX(markerEnemyUnit4), GetPointY(markerEnemyUnit4));
		m_uEnemyUnit5 = GetUnit(GetPointX(markerEnemyUnit5), GetPointY(markerEnemyUnit5));
		m_uEnemyUnit6 = GetUnit(GetPointX(markerEnemyUnit6), GetPointY(markerEnemyUnit6));
		m_uEnemyUnit7 = GetUnit(GetPointX(markerEnemyUnit7), GetPointY(markerEnemyUnit7));

//		m_pPlayer.SetMoney(5000);
/*
		m_pPlayer.EnableBuilding("USA_AIRPORT1", false);
		m_pPlayer.EnableBuilding("USA_AIRPORT2", false);
		m_pPlayer.EnableBuilding("USA_LANDINGZONE", false);
		m_pPlayer.EnableBuilding("USA_NEST", false);
		m_pPlayer.EnableBuilding("USA_TURRET", false);
		m_pPlayer.EnableBuilding("USA_PILLBOX", false);
		m_pPlayer.EnableBuilding("USA_GENERATOR", false);
		m_pPlayer.EnableBuilding("USA_SUPPLYCENTER", false);
		m_pPlayer.EnableBuilding("USA_SUPPLYCENTERBIG", false);
		m_pPlayer.EnableBuilding("USA_SHAFT", false);
		m_pPlayer.EnableBuilding("USA_JAMMER", false);
		m_pPlayer.EnableBuilding("USA_ROCKETCONTROL", false);
		m_pPlayer.EnableBuilding("USA_ROCKETCONTROL_V", false);
		m_pPlayer.EnableBuilding("USA_BOMBCONTROL", false);
		m_pPlayer.EnableBuilding("USA_BOMBCONTROL_V", false);
		m_pPlayer.EnableBuilding("USA_ATTACKCONTROL", false);
		m_pPlayer.EnableBuilding("USA_ATTACKCONTROL_V", false);
		m_pPlayer.EnableBuilding("USA_RADAR", false);
		m_pPlayer.EnableBuilding("USA_GATE", false);
		m_pPlayer.EnableBuilding("USA_PATRIOT", false);
		m_pPlayer.EnableBuilding("USA_PATRIOT_B", false);
*/
		m_pPlayer.LookAt(m_pPlayer.GetStartingPointX(), m_pPlayer.GetStartingPointY(), 6, 0, 0, 0);

		AddConsoleTextDisplay(0, 0, 100, SS_CENTER);
		AddConsoleTextDisplay(1, 0, 100, SS_CENTER);
		AddConsoleTextDisplay(2, 0, 100, SS_CENTER);
		AddConsoleTextDisplay(3, 0, 100, SS_CENTER);
		AddConsoleTextDisplay(4, 0, 100, SS_CENTER);
		AddConsoleTextDisplay(5, 0, 100, SS_CENTER);

		SetGameRect(GetLeft()+17, GetPointY(markerMapLimiter), GetRight()-17, GetBottom()-17);

		return Start;
	}

	state Start
	{
		AddWorldMapSign(m_pEnemyShafts.GetStartingPointX(), m_pEnemyShafts.GetStartingPointY(), 0, 1, 65000);

		EnableGoal(goalCaptureEnemyShafts, true);
		SetConsoleText(0, "translateMessageLessonRUS_1_UnitsAInfo_Line1");
		SetConsoleText(1, "translateMessageLessonRUS_1_UnitsAInfo_Line2");
		SetConsoleText(2, "translateMessageLessonRUS_1_UnitsAInfo_Line3");
		SetConsoleText(3, "translateMessageLessonRUS_1_UnitsAInfo_Line4");
		SetConsoleText(4, "translateMessageLessonRUS_1_UnitsAInfo_Line5");
		SetConsoleText(5, "translateMessageLessonRUS_1_UnitsAInfo_Line6");

		PlayWave("Tutorials\\RUS_Tutorial01_01.wav");

		CreateArtefact("ARTIFACT_GREENARROW_W" , GetPointX(2), GetPointY(2), 0, 0);
		CreateArtefact("ARTIFACT_GREENARROW_W" , GetPointX(3), GetPointY(3), 0, 0);
		CreateArtefact("ARTIFACT_GREENARROW_W" , GetPointX(4), GetPointY(4), 0, 0);
		CreateArtefact("ARTIFACT_REDARROW_W"   , GetPointX(5), GetPointY(5), 0, 0);

		m_pPlayer.DelayedLookAt(GetPointX(markerUnitsA), GetPointY(markerUnitsA), -1, -1, 0, 0, 20, 1);

		return ShowedUnitsA, 360;
	}

	state StartMessage
	{
		AddBriefing("translateBriefingLessonRUS_1_CaptureEnemyShafts");

		return ShowedUnitsB, 1;
	}

	state ShowedUnitsA
	{
		SetConsoleText(0, "translateMessageLessonRUS_1_UnitsBInfo_Line1");
		SetConsoleText(1, "translateMessageLessonRUS_1_UnitsBInfo_Line2");
		SetConsoleText(2, "translateMessageLessonRUS_1_UnitsBInfo_Line3");
		SetConsoleText(3, "translateMessageLessonRUS_1_UnitsBInfo_Line4");
		SetConsoleText(4, "translateMessageLessonRUS_1_UnitsBInfo_Line5");
		SetConsoleText(5, "translateMessageLessonRUS_1_UnitsBInfo_Line6");

		PlayWave("Tutorials\\RUS_Tutorial01_02.wav");

		m_pPlayer.DelayedLookAt(GetPointX(markerUnitsB), GetPointY(markerUnitsB), -1, -1, 0, 0, 20, 1);

		return StartMessage, 240;
	}

	state ShowedUnitsB
	{
		SetConsoleText(0, "translateMessageLessonRUS_1_CaptureBuildings_Line1");
		SetConsoleText(1, "translateMessageLessonRUS_1_CaptureBuildings_Line2");
		SetConsoleText(2, "translateMessageLessonRUS_1_CaptureBuildings_Line3");
		SetConsoleText(3, "translateMessageLessonRUS_1_CaptureBuildings_Line4");
		SetConsoleText(4, "translateMessageLessonRUS_1_CaptureBuildings_Line5");
		SetConsoleText(5, "translateMessageLessonRUS_1_CaptureBuildings_Line6");

		PlayWave("Tutorials\\RUS_Tutorial01_03.wav");

		m_bCheckNumberOfBuildings = true;

		return CaptureEnemyShafts;
	}

	state CaptureEnemyShafts
	{
		if ( !m_bCheckNumberOfBuildings )
		{
			return CaptureEnemyShafts;
		}

		m_bCheckNumberOfBuildings = false;

		if	( m_pEnemyShafts.GetNumberOfBuildings() == 0 )
		{
			return CapturedEnemyShafts;
		}
		else
		{
			return CaptureEnemyShafts;
		}
	}

	state CapturedEnemyShafts
	{
		int i;

		for ( i=2; i<=5; i=i+1 ) RemoveArtefact(GetPointX(i), GetPointY(i), 0);

		SetGameRect(0, 0, 0, 0);

		RemoveWorldMapSign(m_pEnemyShafts.GetStartingPointX(), m_pEnemyShafts.GetStartingPointY(), 0);

		ShowArea(m_pPlayer.GetIFF(), GetPointX(markerEnemyUnits), GetPointY(markerEnemyUnits), 0, 5, showAreaPassives|showAreaBuildings|showAreaUnits);

		m_pPlayer.DelayedLookAt(GetPointX(markerEnemyUnits), GetPointY(markerEnemyUnits), -1, -1, 0, 0, 60, 1);

		m_uEnemyUnit1.CommandMove(GetPointX(markerEnemyUnits), GetPointY(markerEnemyUnits), 0);
		m_uEnemyUnit2.CommandMove(GetPointX(markerEnemyUnits), GetPointY(markerEnemyUnits), 0);
		m_uEnemyUnit3.CommandMove(GetPointX(markerEnemyUnits), GetPointY(markerEnemyUnits), 0);
		m_uEnemyUnit4.CommandMove(GetPointX(markerEnemyUnits), GetPointY(markerEnemyUnits), 0);
		m_uEnemyUnit5.CommandMove(GetPointX(markerEnemyUnits), GetPointY(markerEnemyUnits), 0);
		m_uEnemyUnit6.CommandMove(GetPointX(markerEnemyUnits), GetPointY(markerEnemyUnits), 0);
		m_uEnemyUnit7.CommandMove(GetPointX(markerEnemyUnits), GetPointY(markerEnemyUnits), 0);

		m_nCounter = 10;

		SetGoalState(goalCaptureEnemyShafts, goalAchieved);

		return ShowEnemyUnits;
	}

	state ShowEnemyUnits
	{
		ShowArea(m_pPlayer.GetIFF(), GetPointX(markerEnemyUnits), GetPointY(markerEnemyUnits), 0, 5, showAreaPassives|showAreaBuildings|showAreaUnits);

		m_nCounter = m_nCounter - 1;

		if ( m_nCounter > 0 )
		{
			return ShowEnemyUnits;
		}
		else
		{
			return ShowedEnemyUnits;
		}
	}

	state ShowedEnemyUnits
	{
		EnableGoal(goalCaptureEnemyUnits, true);
		SetConsoleText(0, "translateMessageLessonRUS_1_CaptureUnits_Line1");
		SetConsoleText(1, "translateMessageLessonRUS_1_CaptureUnits_Line2");
		SetConsoleText(2, "translateMessageLessonRUS_1_CaptureUnits_Line3");
		SetConsoleText(3, "translateMessageLessonRUS_1_CaptureUnits_Line4");
		SetConsoleText(4, "translateMessageLessonRUS_1_CaptureUnits_Line5");
		SetConsoleText(5, "translateMessageLessonRUS_1_CaptureUnits_Line6");

		PlayWave("Tutorials\\RUS_Tutorial01_04.wav");

		CreateArtefact("ARTIFACT_GREENARROW_W" , GetPointX(13), GetPointY(13), 0, 0);
		CreateArtefact("ARTIFACT_GREENARROW_NW", GetPointX(14), GetPointY(14), 0, 0);
		CreateArtefact("ARTIFACT_REDARROW_N"   , GetPointX(15), GetPointY(15), 0, 0);

		m_bCheckNumberOfUnits = true;

		return ShowedEnemyUnitsMessage, 300;
	}

	state ShowedEnemyUnitsMessage
	{
		AddBriefing("translateBriefingLessonRUS_1_CaptureEnemyUnits");

		return CaptureEnemyUnits;
	}

	state CaptureEnemyUnits
	{
		if ( !m_bCheckNumberOfUnits )
		{
			return CaptureEnemyUnits;
		}

		m_bCheckNumberOfUnits = false;

		if	(
			( m_uEnemyUnit1.GetIFF() == m_pPlayer.GetIFF() || !m_uEnemyUnit1.IsLive() ) &&
			( m_uEnemyUnit2.GetIFF() == m_pPlayer.GetIFF() || !m_uEnemyUnit2.IsLive() ) &&
			( m_uEnemyUnit3.GetIFF() == m_pPlayer.GetIFF() || !m_uEnemyUnit3.IsLive() ) &&
			( m_uEnemyUnit4.GetIFF() == m_pPlayer.GetIFF() || !m_uEnemyUnit4.IsLive() ) &&
			( m_uEnemyUnit5.GetIFF() == m_pPlayer.GetIFF() || !m_uEnemyUnit5.IsLive() ) &&
			( m_uEnemyUnit6.GetIFF() == m_pPlayer.GetIFF() || !m_uEnemyUnit6.IsLive() ) &&
			( m_uEnemyUnit7.GetIFF() == m_pPlayer.GetIFF() || !m_uEnemyUnit7.IsLive() )
			)
		{
			return CapturedEnemyUnits;
		}
		else
		{
			return CaptureEnemyUnits;
		}
	}

	state CapturedEnemyUnits
	{
		int i;

		for ( i=13; i<=15; i=i+1 ) RemoveArtefact(GetPointX(i), GetPointY(i), 0);

		AddWorldMapSign(m_pEnemy.GetStartingPointX(), m_pEnemy.GetStartingPointY(), 0, 1, 65000);

		SetGoalState(goalCaptureEnemyUnits, goalAchieved);

		EnableGoal(goalCaptureEnemyBase, true);
		AddBriefing("translateBriefingLessonRUS_1_CaptureEnemyBase");

		CreateArtefact("ARTIFACT_GREENARROW_NW", GetPointX(16), GetPointY(16), 0, 0);
		CreateArtefact("ARTIFACT_GREENARROW_NW", GetPointX(17), GetPointY(17), 0, 0);
		CreateArtefact("ARTIFACT_REDARROW_NW"  , GetPointX(18), GetPointY(18), 0, 0);

		return CaptureEnemyBase;
	}

	state CaptureEnemyBase
	{
		if ( !m_bCheckNumberOfUnits && !m_bCheckNumberOfBuildings )
		{
			return CaptureEnemyBase;
		}

		m_bCheckNumberOfUnits = false;
		m_bCheckNumberOfBuildings = false;

		if (m_pEnemy.GetNumberOfUnits() == 0 && m_pEnemy.GetNumberOfBuildings() == 0 )
		{
			return CapturedEnemyBase;
		}
		else
		{
			return CaptureEnemyBase;
		}
	}

	state CapturedEnemyBase
	{
		RemoveWorldMapSign(m_pEnemy.GetStartingPointX(), m_pEnemy.GetStartingPointY(), 0);

		SetGoalState(goalCaptureEnemyBase, goalAchieved);

		AddBriefing("translateBriefingLessonRUS_1_MissionComplete");

		return MissionComplete;
	}

	state MissionComplete
	{
		EndMission(true);
	}

	event UnitDestroyed(unit uUnit)
	{
		m_bCheckNumberOfUnits = true;
	}

	event BuildingDestroyed(unit uBuilding)
	{
		m_bCheckNumberOfBuildings = true;
	}

	event SetupInterface()
	{
		EnableGameFeature
			(
			lockResearchDialog |
			lockConstructionDialog |
			lockUpgradeWeaponDialog |
			lockAllianceDialog |
			lockGiveMoneyDialog |
			lockGiveUnitsDialog |
//			lockShowToolbar |
			lockToolbarMap |
			lockToolbarPanel |
//			lockToolbarNextWorld |
			lockToolbarLevelName |
//			lockToolbarTunnels |
//			lockToolbarSwitchMode |
			lockToolbarResearching |
			lockToolbarConstruction |
			lockToolbarAlliance |
			lockToolbarGiveMoney |
//			lockToolbarObjectives |
//			lockToolbarMenu |
//			lockToolbarMoney |
			lockToolbarEnergy |
			lockDisplayToolbarLevelName |
//			lockDisplayToolbarMoney |
			lockDisplayToolbarEnergy |
			lockCreateBuildPanel |
//			lockCreatePanel |
//			lockCreateMap |
			0, true);
	}
}
