mission "translateMissionRUS_10"
{
	consts
	{
		goalDestroyEnemyA = 0;
		goalDestroyEnemies = 1;

		markerHero = 2;

		markerAkacja1 = 3;
		markerAkacja2 = 4;
		markerAkacja3 = 5;
		markerAkacja4 = 6;

		markerEndOfBridge1 = 7;
		markerEndOfBridge2 = 8;

		markerEndOfBridge3 = 14;
		markerEndOfBridge4 = 15;

		idDetonationActivator = 777;
	}

	include "UnitTemplates.ech"
	include "Research.ech"

	player m_pPlayer;
	player m_pEnemyA;
	player m_pEnemyB;
	player m_pEnemyC;
	player m_pEnemyD;
	player m_pEnemyE;

	unitex m_uHero;

	unitex m_uAkacja1;
	unitex m_uAkacja2;
	unitex m_uAkacja3;
	unitex m_uAkacja4;

	int m_bCheckNumberOfUnits;
	int m_bCheckNumberOfBuildings;

	int m_nTimeOfAkacjasDetonation;
	int m_bAkacjasArmed;

	int m_nTimeOfEnemyOffense;

	state Initialize;
	state Start;
	state BeforeStart;
	state DestroyEnemyA;
	state DestroyedEnemyA;
	state DestroyEnemies;
	state DestroyedEnemies;
	state MissionComplete;

	function int ModifyDifficulty()
	{
		if ( GetDifficultyLevel() == 0 )
		{
			ClearArea (65535, GetPointX(12), GetPointY(12), GetPointZ(12), 0);
			ClearArea (65535, GetPointX(13), GetPointY(13), GetPointZ(13), 0);
		}
		else if ( GetDifficultyLevel() == 1 )
		{
		}
		else if ( GetDifficultyLevel() == 2 )
		{
		}
	}

	state Initialize
	{
		ModifyDifficulty();

		RegisterGoal(goalDestroyEnemyA, "translateGoalMissionRUS_10_DestroyEnemyA");
		RegisterGoal(goalDestroyEnemies, "translateGoalMissionRUS_10_DestroyEnemies");

		m_nTimeOfAkacjasDetonation = 0;
		m_nTimeOfEnemyOffense = 0;
		m_bAkacjasArmed = false;

		m_pPlayer = GetPlayer(9);
		m_pEnemyA = GetPlayer(8);
		m_pEnemyB = GetPlayer(5);
		m_pEnemyC = GetPlayer(6);
		m_pEnemyD = GetPlayer(7);
		m_pEnemyE = GetPlayer(4);

		m_pPlayer.SetMoney(3000);
		m_pEnemyA.SetMoney(0);
		m_pEnemyB.SetMoney(0);
		m_pEnemyC.SetMoney(0);
		if ( GetDifficultyLevel() == 0 )
		{
			m_pEnemyD.SetMoney(250000);
		}
		else
		{
			m_pEnemyD.SetMoney(500000);
		}
		m_pEnemyE.SetMoney(10000);

		m_pEnemyA.EnableAI(false);
		m_pEnemyA.EnableStatistics(false);
		m_pEnemyB.EnableAI(false);
		m_pEnemyB.EnableStatistics(false);
		m_pEnemyC.EnableAI(false);
		m_pEnemyC.EnableStatistics(false);

		m_pPlayer.SetMilitaryUnitsLimit(70000);

		if ( GetDifficultyLevel() == 0 )
		{
			m_pEnemyD.LoadScript("single\\singleMedium");
			m_pEnemyE.LoadScript("single\\singleMedium");

			m_pEnemyD.SetMilitaryUnitsLimit(30000);
			m_pEnemyD.EnableMilitaryUnitsLimit(true);

			m_pEnemyE.SetMilitaryUnitsLimit(40000);
			m_pEnemyE.EnableMilitaryUnitsLimit(true);
		}
		else if ( GetDifficultyLevel() == 1 )
		{
			m_pEnemyD.LoadScript("single\\singleHard");
			m_pEnemyE.LoadScript("single\\singleHard");
	
			m_pEnemyD.SetMilitaryUnitsLimit(50000);
			m_pEnemyD.EnableMilitaryUnitsLimit(true);

			m_pEnemyE.SetMilitaryUnitsLimit(50000);
			m_pEnemyE.EnableMilitaryUnitsLimit(true);
		}
		else if ( GetDifficultyLevel() == 2 )
		{
			m_pEnemyD.LoadScript("single\\singleHard");
			m_pEnemyE.LoadScript("single\\singleHard");
		}

		m_pEnemyD.EnableAI(true);
		m_pEnemyD.EnableAIFeatures(aiControlOffense, false);
		m_pEnemyD.EnableAIFeatures(aiControlDefense, false);
		m_pEnemyD.EnableAIFeatures(aiBuildBuildings|aiBuildTanks|aiBuildHelicopters, false);
		m_pEnemyD.EnableAIFeatures(aiBuildMiningBuildings, false);

		m_pEnemyE.EnableAI(true);
		m_pEnemyE.EnableAIFeatures(aiControlOffense, false);

		m_uHero = GetUnit(GetPointX(markerHero), GetPointY(markerHero));

		m_uAkacja1 = GetUnit(GetPointX(markerAkacja1), GetPointY(markerAkacja1));
		m_uAkacja2 = GetUnit(GetPointX(markerAkacja2), GetPointY(markerAkacja2));
		m_uAkacja3 = GetUnit(GetPointX(markerAkacja3), GetPointY(markerAkacja3));
		m_uAkacja4 = GetUnit(GetPointX(markerAkacja4), GetPointY(markerAkacja4));

		AddUnitTemplatesRUS( m_pPlayer );

		m_pPlayer.LookAt(m_pPlayer.GetStartingPointX(), m_pPlayer.GetStartingPointY(), 6, 0, 0, 0);

		EnableAllResearchRUS( m_pPlayer, false);
		m_pPlayer.EnableResearch("RES_RUS_AMPHIBIA1", true);			// M1
		m_pPlayer.EnableResearch("RES_RUS_ZSU", true);					// M2
		m_pPlayer.EnableResearch("RES_RUS_ASSAULT", true);				// M2
		m_pPlayer.EnableResearch("RES_RUS_PILLBOX", true);				// M3
		m_pPlayer.EnableResearch("RES_RUS_TANK", true);					// M3
		m_pPlayer.EnableResearch("RES_RUS_MIM", true);					// M3
		m_pPlayer.EnableResearch("RES_RUS_HELICOPTER1", true);			// M3
		m_pPlayer.EnableResearch("RES_RUS_AMMO_MG1", true);				// M4
		m_pPlayer.EnableResearch("RES_RUS_AMMO_CANNON1", true);			// M4
		m_pPlayer.EnableResearch("RES_RUS_SAPER", true);				// M4
		m_pPlayer.EnableResearch("RES_RUS_BM21", true);					// M4
		m_pPlayer.EnableResearch("RES_RUS_HELICOPTER2", true);			// M4
		m_pPlayer.EnableResearch("RES_RUS_AMMO_MG2", true);				// M5
		m_pPlayer.EnableResearch("RES_RUS_ART", true);					// M5
		m_pPlayer.EnableResearch("RES_RUS_AMMO_MGM1", true);			// M5
		m_pPlayer.EnableResearch("RES_RUS_SPECIAL_FILTER2", true);		// M5
		m_pPlayer.EnableResearch("RES_RUS_AMMO_CANNON2", true);			// M6
		m_pPlayer.EnableResearch("RES_RUS_AMMO_ART1", true);			// M6
		m_pPlayer.EnableResearch("RES_RUS_CHEMICAL1", true);			// M6
		m_pPlayer.EnableResearch("RES_RUS_AMMO_MGM2", true);			// M6
		m_pPlayer.EnableResearch("RES_RUS_SDI", true);					// M6
		m_pPlayer.EnableResearch("RES_RUS_SPECIAL_FILTER3", true);		// M6
		m_pPlayer.EnableResearch("RES_RUS_AMMO_ART2", true);			// M7
		m_pPlayer.EnableResearch("RES_RUS_AMMO_ROCKET1", true);			// M7
		m_pPlayer.EnableResearch("RES_RUS_AMMO_CHEMICAL1", true);		// M7
		m_pPlayer.EnableResearch("RES_RUS_ROCKETCONTROL", true);		// M7
		m_pPlayer.EnableResearch("RES_RUS_ROMB", true);					// M7
		m_pPlayer.EnableResearch("RES_RUS_AIRCONTROL", true);			// M7
		m_pPlayer.EnableResearch("RES_RUS_SPECIAL_PTC", true);			// M7
		m_pPlayer.EnableResearch("RES_RUS_AMMO_ROCKET2", true);			// M8
		m_pPlayer.EnableResearch("RES_RUS_AMMO_MIM1", true);			// M8
		m_pPlayer.EnableResearch("RES_RUS_AMMO_CHEMICAL2", true);		// M9
		m_pPlayer.EnableResearch("RES_RUS_BOMBCONTROL", true);			// M9
		m_pPlayer.EnableResearch("RES_RUS_SPECIAL_FLARE", true);		// M9
		m_pPlayer.EnableResearch("RES_RUS_AMMO_MIM2", true);
		m_pPlayer.EnableResearch("RES_RUS_SPYCENTER", true);

		EnableAllResearchRUS( m_pEnemyD, false);
		m_pEnemyD.EnableResearch("RES_RUS_AMPHIBIA1", true);			// M1
		m_pEnemyD.EnableResearch("RES_RUS_ZSU", true);					// M2
		m_pEnemyD.EnableResearch("RES_RUS_ASSAULT", true);				// M2
		m_pEnemyD.EnableResearch("RES_RUS_PILLBOX", true);				// M3
		m_pEnemyD.EnableResearch("RES_RUS_TANK", true);					// M3
		m_pEnemyD.EnableResearch("RES_RUS_MIM", true);					// M3
		m_pEnemyD.EnableResearch("RES_RUS_HELICOPTER1", true);			// M3
		m_pEnemyD.EnableResearch("RES_RUS_AMMO_MG1", true);				// M4
		m_pEnemyD.EnableResearch("RES_RUS_AMMO_CANNON1", true);			// M4
		m_pEnemyD.EnableResearch("RES_RUS_SAPER", true);				// M4
		m_pEnemyD.EnableResearch("RES_RUS_BM21", true);					// M4
		m_pEnemyD.EnableResearch("RES_RUS_HELICOPTER2", true);			// M4
		m_pEnemyD.EnableResearch("RES_RUS_AMMO_MG2", true);				// M5
		m_pEnemyD.EnableResearch("RES_RUS_ART", true);					// M5
		m_pEnemyD.EnableResearch("RES_RUS_AMMO_MGM1", true);			// M5
		m_pEnemyD.EnableResearch("RES_RUS_SPECIAL_FILTER2", true);		// M5
		m_pEnemyD.EnableResearch("RES_RUS_AMMO_CANNON2", true);			// M6
		m_pEnemyD.EnableResearch("RES_RUS_AMMO_ART1", true);			// M6
		m_pEnemyD.EnableResearch("RES_RUS_CHEMICAL1", true);			// M6
		m_pEnemyD.EnableResearch("RES_RUS_AMMO_MGM2", true);			// M6
		m_pEnemyD.EnableResearch("RES_RUS_SDI", true);					// M6
		m_pEnemyD.EnableResearch("RES_RUS_SPECIAL_FILTER3", true);		// M6
		m_pEnemyD.EnableResearch("RES_RUS_AMMO_ART2", true);			// M7
		m_pEnemyD.EnableResearch("RES_RUS_AMMO_ROCKET1", true);			// M7
		m_pEnemyD.EnableResearch("RES_RUS_AMMO_CHEMICAL1", true);		// M7

		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyD.EnableResearch("RES_RUS_ROCKETCONTROL", true);	// M7
		}
		if ( GetDifficultyLevel() > 1 )
		{
			m_pEnemyD.EnableResearch("RES_RUS_BOMBCONTROL", true);		// M9
		}

		m_pEnemyD.EnableResearch("RES_RUS_ROMB", true);					// M7

		if ( GetDifficultyLevel() > 1 )
		{
			m_pEnemyD.EnableResearch("RES_RUS_AIRCONTROL", true);		// M7
		}

		m_pEnemyD.EnableResearch("RES_RUS_SPECIAL_PTC", true);			// M7
		m_pEnemyD.EnableResearch("RES_RUS_AMMO_ROCKET2", true);			// M8
		m_pEnemyD.EnableResearch("RES_RUS_AMMO_MIM1", true);			// M8
		m_pEnemyD.EnableResearch("RES_RUS_AMMO_CHEMICAL2", true);		// M9
		m_pEnemyD.EnableResearch("RES_RUS_SPECIAL_FLARE", true);		// M9
		m_pEnemyD.EnableResearch("RES_RUS_AMMO_MIM2", true);
		m_pEnemyD.EnableResearch("RES_RUS_SPYCENTER", true);

		EnableAllResearchRUS( m_pEnemyE, false);
		m_pEnemyE.EnableResearch("RES_RUS_AMPHIBIA1", true);			// M1
		m_pEnemyE.EnableResearch("RES_RUS_ZSU", true);					// M2
		m_pEnemyE.EnableResearch("RES_RUS_ASSAULT", true);				// M2
		m_pEnemyE.EnableResearch("RES_RUS_PILLBOX", true);				// M3
		m_pEnemyE.EnableResearch("RES_RUS_TANK", true);					// M3
		m_pEnemyE.EnableResearch("RES_RUS_MIM", true);					// M3
		m_pEnemyE.EnableResearch("RES_RUS_HELICOPTER1", true);			// M3
		m_pEnemyE.EnableResearch("RES_RUS_AMMO_MG1", true);				// M4
		m_pEnemyE.EnableResearch("RES_RUS_AMMO_CANNON1", true);			// M4
		m_pEnemyE.EnableResearch("RES_RUS_SAPER", true);				// M4
		m_pEnemyE.EnableResearch("RES_RUS_BM21", true);					// M4
		m_pEnemyE.EnableResearch("RES_RUS_HELICOPTER2", true);			// M4
		m_pEnemyE.EnableResearch("RES_RUS_AMMO_MG2", true);				// M5
		m_pEnemyE.EnableResearch("RES_RUS_ART", true);					// M5
		m_pEnemyE.EnableResearch("RES_RUS_AMMO_MGM1", true);			// M5
		m_pEnemyE.EnableResearch("RES_RUS_SPECIAL_FILTER2", true);		// M5
		m_pEnemyE.EnableResearch("RES_RUS_AMMO_CANNON2", true);			// M6
		m_pEnemyE.EnableResearch("RES_RUS_AMMO_ART1", true);			// M6
		m_pEnemyE.EnableResearch("RES_RUS_CHEMICAL1", true);			// M6
		m_pEnemyE.EnableResearch("RES_RUS_AMMO_MGM2", true);			// M6
		m_pEnemyE.EnableResearch("RES_RUS_SDI", true);					// M6
		m_pEnemyE.EnableResearch("RES_RUS_SPECIAL_FILTER3", true);		// M6
		m_pEnemyE.EnableResearch("RES_RUS_AMMO_ART2", true);			// M7
		m_pEnemyE.EnableResearch("RES_RUS_AMMO_ROCKET1", true);			// M7
		m_pEnemyE.EnableResearch("RES_RUS_AMMO_CHEMICAL1", true);		// M7

		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyE.EnableResearch("RES_RUS_ROCKETCONTROL", true);	// M7
		}
		if ( GetDifficultyLevel() > 1 )
		{
			m_pEnemyE.EnableResearch("RES_RUS_BOMBCONTROL", true);		// M9
		}

		m_pEnemyE.EnableResearch("RES_RUS_ROMB", true);					// M7

		if ( GetDifficultyLevel() > 1 )
		{
			m_pEnemyE.EnableResearch("RES_RUS_AIRCONTROL", true);		// M7
		}

		m_pEnemyE.EnableResearch("RES_RUS_SPECIAL_PTC", true);			// M7
		m_pEnemyE.EnableResearch("RES_RUS_AMMO_ROCKET2", true);			// M8
		m_pEnemyE.EnableResearch("RES_RUS_AMMO_MIM1", true);			// M8
		m_pEnemyE.EnableResearch("RES_RUS_AMMO_CHEMICAL2", true);		// M9
		m_pEnemyE.EnableResearch("RES_RUS_SPECIAL_FLARE", true);		// M9
		m_pEnemyE.EnableResearch("RES_RUS_AMMO_MIM2", true);
		m_pEnemyE.EnableResearch("RES_RUS_SPYCENTER", true);

		m_pEnemyD.AddResearch("RES_RUS_AMPHIBIA1");
		m_pEnemyD.AddResearch("RES_RUS_ZSU");
		m_pEnemyD.AddResearch("RES_RUS_ASSAULT");
		m_pEnemyD.AddResearch("RES_RUS_PILLBOX");
		m_pEnemyD.AddResearch("RES_RUS_TANK");
		m_pEnemyD.AddResearch("RES_RUS_MIM");
		m_pEnemyD.AddResearch("RES_RUS_HELICOPTER1");
		m_pEnemyD.AddResearch("RES_RUS_AMMO_MG1");
		m_pEnemyD.AddResearch("RES_RUS_AMMO_CANNON1");
		m_pEnemyD.AddResearch("RES_RUS_SAPER");
		m_pEnemyD.AddResearch("RES_RUS_BM21");
		m_pEnemyD.AddResearch("RES_RUS_HELICOPTER2");
		m_pEnemyD.AddResearch("RES_RUS_AMMO_MG2");
		m_pEnemyD.AddResearch("RES_RUS_ART");
		m_pEnemyD.AddResearch("RES_RUS_AMMO_MGM1");
		m_pEnemyD.AddResearch("RES_RUS_SPECIAL_FILTER2");
		m_pEnemyD.AddResearch("RES_RUS_AMMO_CANNON2");
		m_pEnemyD.AddResearch("RES_RUS_AMMO_ART1");
		m_pEnemyD.AddResearch("RES_RUS_CHEMICAL1");
		m_pEnemyD.AddResearch("RES_RUS_AMMO_MGM2");
		m_pEnemyD.AddResearch("RES_RUS_SDI");
		m_pEnemyD.AddResearch("RES_RUS_SPECIAL_FILTER3");
		m_pEnemyD.AddResearch("RES_RUS_AMMO_ART2");
		m_pEnemyD.AddResearch("RES_RUS_AMMO_ROCKET1");
		m_pEnemyD.AddResearch("RES_RUS_AMMO_CHEMICAL1");

		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyD.AddResearch("RES_RUS_ROCKETCONTROL");
		}
		if ( GetDifficultyLevel() > 1 )
		{
			m_pEnemyD.AddResearch("RES_RUS_BOMBCONTROL");
		}

		m_pEnemyD.AddResearch("RES_RUS_ROMB");

		if ( GetDifficultyLevel() > 1 )
		{
			m_pEnemyD.AddResearch("RES_RUS_AIRCONTROL");
		}

		m_pEnemyD.AddResearch("RES_RUS_SPECIAL_PTC");
		m_pEnemyD.AddResearch("RES_RUS_AMMO_ROCKET2");
		m_pEnemyD.AddResearch("RES_RUS_AMMO_MIM1");
		m_pEnemyD.AddResearch("RES_RUS_AMMO_CHEMICAL2");
		m_pEnemyD.AddResearch("RES_RUS_SPECIAL_FLARE");

		m_pEnemyE.AddResearch("RES_RUS_AMPHIBIA1");
		m_pEnemyE.AddResearch("RES_RUS_ZSU");
		m_pEnemyE.AddResearch("RES_RUS_ASSAULT");
		m_pEnemyE.AddResearch("RES_RUS_PILLBOX");
		m_pEnemyE.AddResearch("RES_RUS_TANK");
		m_pEnemyE.AddResearch("RES_RUS_MIM");
		m_pEnemyE.AddResearch("RES_RUS_HELICOPTER1");
		m_pEnemyE.AddResearch("RES_RUS_AMMO_MG1");
		m_pEnemyE.AddResearch("RES_RUS_AMMO_CANNON1");
		m_pEnemyE.AddResearch("RES_RUS_SAPER");
		m_pEnemyE.AddResearch("RES_RUS_BM21");
		m_pEnemyE.AddResearch("RES_RUS_HELICOPTER2");
		m_pEnemyE.AddResearch("RES_RUS_AMMO_MG2");
		m_pEnemyE.AddResearch("RES_RUS_ART");
		m_pEnemyE.AddResearch("RES_RUS_AMMO_MGM1");
		m_pEnemyE.AddResearch("RES_RUS_SPECIAL_FILTER2");
		m_pEnemyE.AddResearch("RES_RUS_AMMO_CANNON2");
		m_pEnemyE.AddResearch("RES_RUS_AMMO_ART1");
		m_pEnemyE.AddResearch("RES_RUS_CHEMICAL1");
		m_pEnemyE.AddResearch("RES_RUS_AMMO_MGM2");
		m_pEnemyE.AddResearch("RES_RUS_SDI");
		m_pEnemyE.AddResearch("RES_RUS_SPECIAL_FILTER3");
		m_pEnemyE.AddResearch("RES_RUS_AMMO_ART2");
		m_pEnemyE.AddResearch("RES_RUS_AMMO_ROCKET1");
		m_pEnemyE.AddResearch("RES_RUS_AMMO_CHEMICAL1");

		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyE.AddResearch("RES_RUS_ROCKETCONTROL");
		}
		if ( GetDifficultyLevel() > 1 )
		{
			m_pEnemyE.AddResearch("RES_RUS_BOMBCONTROL");
		}

		m_pEnemyE.AddResearch("RES_RUS_ROMB");

		if ( GetDifficultyLevel() > 1 )
		{
			m_pEnemyE.AddResearch("RES_RUS_AIRCONTROL");
		}

		m_pEnemyE.AddResearch("RES_RUS_SPECIAL_PTC");
		m_pEnemyE.AddResearch("RES_RUS_AMMO_ROCKET2");
		m_pEnemyE.AddResearch("RES_RUS_AMMO_MIM1");
		m_pEnemyE.AddResearch("RES_RUS_AMMO_CHEMICAL2");
		m_pEnemyE.AddResearch("RES_RUS_SPECIAL_FLARE");

		AddUnitTemplatesRUS( m_pEnemyD );
		AddUnitTemplatesRUS( m_pEnemyE );

		return BeforeStart, 1;
	}

	state BeforeStart
	{
		PlayTrack("Music\\Briefing.tws");

		return Start;
	}

    state Start
	{
		EnableGoal(goalDestroyEnemyA, true);
		AddBriefing("translateBriefingMissionRUS_10_DestroyEnemyA");
		PlayWave("Briefings\\RUS_Briefing10.wav");

		CreateArtefact("ARTIFACT_INVISIBLE", GetPointX(markerEndOfBridge1), GetPointY(markerEndOfBridge1), 0, idDetonationActivator);
		CreateArtefact("ARTIFACT_INVISIBLE", GetPointX(markerEndOfBridge2), GetPointY(markerEndOfBridge2), 0, idDetonationActivator);

		CreateArtefact("ARTIFACT_INVISIBLE", GetPointX(markerEndOfBridge3), GetPointY(markerEndOfBridge3), 0, idDetonationActivator);
		CreateArtefact("ARTIFACT_INVISIBLE", GetPointX(markerEndOfBridge4), GetPointY(markerEndOfBridge4), 0, idDetonationActivator);

		return DestroyEnemyA;
	}

	state DestroyEnemyA
	{
		if ( !m_bCheckNumberOfBuildings )
		{
			return DestroyEnemyA;
		}

		m_bCheckNumberOfBuildings = false;

		if ( m_pEnemyA.GetNumberOfBuildings() == 0 )
		{
			return DestroyedEnemyA;
		}
		else
		{
			return DestroyEnemyA;
		}
	}

	state DestroyedEnemyA
	{
		m_uAkacja1.ChangePlayer(m_pPlayer);
		m_uAkacja2.ChangePlayer(m_pPlayer);
		m_uAkacja3.ChangePlayer(m_pPlayer);
		m_uAkacja4.ChangePlayer(m_pPlayer);

		SetGoalState(goalDestroyEnemyA, goalAchieved);

		EnableGoal(goalDestroyEnemies, true);
		AddBriefing("translateBriefingMissionRUS_10_DestroyEnemies");

		return DestroyEnemies;
	}

	state DestroyEnemies
	{
		if ( m_nTimeOfEnemyOffense && GetMissionTime() >= m_nTimeOfEnemyOffense )
		{
			m_pEnemyD.EnableAIFeatures(aiControlOffense, true);
			m_pEnemyE.EnableAIFeatures(aiControlOffense, true);
		}

		if ( m_nTimeOfAkacjasDetonation && GetMissionTime() >= m_nTimeOfAkacjasDetonation )
		{
			m_nTimeOfAkacjasDetonation = 0;

			if ( m_uAkacja1.IsLive() || m_uAkacja2.IsLive() || m_uAkacja3.IsLive() || m_uAkacja4.IsLive() )
			{
				AddBriefing("translateBriefingMissionRUS_10_LostUnits");
			}

			if ( m_uAkacja1.IsLive() )
			{
				KillArea(65535, m_uAkacja1.GetLocationX(), m_uAkacja1.GetLocationY(), m_uAkacja1.GetLocationZ(), 1);
			}
			if ( m_uAkacja2.IsLive() )
			{
				KillArea(65535, m_uAkacja2.GetLocationX(), m_uAkacja2.GetLocationY(), m_uAkacja2.GetLocationZ(), 1);
			}
			if ( m_uAkacja3.IsLive() )
			{
				KillArea(65535, m_uAkacja3.GetLocationX(), m_uAkacja3.GetLocationY(), m_uAkacja3.GetLocationZ(), 1);
			}
			if ( m_uAkacja4.IsLive() )
			{
				KillArea(65535, m_uAkacja4.GetLocationX(), m_uAkacja4.GetLocationY(), m_uAkacja4.GetLocationZ(), 1);
			}
		}

		if ( !m_bCheckNumberOfUnits && !m_bCheckNumberOfBuildings )
		{
			return DestroyEnemies;
		}

		m_bCheckNumberOfUnits = false;
		m_bCheckNumberOfBuildings = false;

		if	(
			m_pEnemyB.GetNumberOfBuildings() == 0 &&
			m_pEnemyC.GetNumberOfBuildings() == 0 &&
			m_pEnemyD.GetNumberOfBuildings() == 0 &&
			m_pEnemyE.GetNumberOfBuildings() == 0 &&
			m_pEnemyB.GetNumberOfUnits() == 0 &&
			m_pEnemyC.GetNumberOfUnits() == 0 &&
			m_pEnemyD.GetNumberOfUnits() == 0 &&
			m_pEnemyE.GetNumberOfUnits() == 0
			)
		{
			return DestroyedEnemies;
		}
		else
		{
			return DestroyEnemies;
		}
	}

	state DestroyedEnemies
	{
		SetGoalState(goalDestroyEnemies, goalAchieved);

		AddBriefing("translateBriefingMissionRUS_10_MissionComplete");

		EndMission(true);

		return MissionComplete;
	}

	state MissionComplete
	{
		return MissionComplete;
	}

	event Artefact(int nArtefactNum, player pPlayerOnArtefact)
	{
		if ( pPlayerOnArtefact != m_pPlayer )
		{
			return false;
		}

		if ( nArtefactNum == idDetonationActivator && !m_bAkacjasArmed )
		{
			m_bAkacjasArmed = true;

			m_nTimeOfAkacjasDetonation = GetMissionTime() + 60*20;
		}

		true;
	}

	event UnitDestroyed(unit uUnit)
	{
		m_bCheckNumberOfUnits = true;

		if ( uUnit == m_uHero )
		{
			if ( state == DestroyEnemyA )
			{
				SetGoalState(goalDestroyEnemyA, goalFailed);
			}
			else if ( state == DestroyEnemies )
			{
				SetGoalState(goalDestroyEnemies, goalFailed);
			}

			AddBriefing("translateBriefingMissionRUS_10_MissionFail");

			EnableEndMissionButton(true, false);

			state MissionComplete;
		}
	}

	event BuildingDestroyed(unit uBuilding)
	{
		m_bCheckNumberOfBuildings = true;
	}

	event BuildingCreated(unit uBuilding)
	{
		if ( !m_nTimeOfEnemyOffense && uBuilding.GetBuildingType() == buildingMine && uBuilding.GetIFF() == m_pPlayer.GetIFF())
		{
			m_pEnemyD.EnableAIFeatures(aiControlDefense, true);
			m_pEnemyD.EnableAIFeatures(aiBuildBuildings|aiBuildTanks|aiBuildHelicopters, true);

			if ( GetDifficultyLevel() == 0 )
			{
				m_nTimeOfEnemyOffense = GetMissionTime() + 5*60*20;
			}
			else
			{
				m_nTimeOfEnemyOffense = GetMissionTime();
			}
		}
	}

	event SetupInterface()
	{
	}
}
