mission "translateMissionRUS_1"
{
	consts
	{
		goalBuildBase = 0;
		goalDestroyEnemy = 1;

		markerMapLimiterFrom = 1;
		markerMapLimiterTo = 2;
	}

	include "UnitTemplates.ech"
	include "Research.ech"

	player m_pPlayer;

	player m_pEnemyA;
	player m_pEnemyB;
	player m_pEnemyC;
	player m_pEnemyD;

	int m_bCheckNumberOfUnits;
	int m_bCheckNumberOfBuildings;

	int m_bCheckDestroyedUnitsAndBuildings;

	state Initialize;
	state Start;
	state BeforeStart;
	state BuildBase;
	state BuildedBase;
	state DestroyEnemy;
	state DestroyedEnemy;
	state MissionComplete;

	function int ClearMarkers(int nStartPoint, int nEndPoint)
	{
		int i;

		for ( i=nStartPoint; i<=nEndPoint; i=i+1 )
		{
			ClearArea (65535, GetPointX(i), GetPointY(i), GetPointZ(i), 0);
		}
	}

	function int ModifyDifficulty()
	{
		if ( GetDifficultyLevel() == 0 )
		{
			ClearMarkers (3, 13);
		}
		else if ( GetDifficultyLevel() == 1 )
		{
		}
		else if ( GetDifficultyLevel() == 2 )
		{
		}
	}

	state Initialize
	{
		ModifyDifficulty();

		RegisterGoal(goalBuildBase, "translateGoalMissionRUS_1_BuildBase");
		RegisterGoal(goalDestroyEnemy, "translateGoalMissionRUS_1_DestroyEnemy");

		m_pPlayer = GetPlayer(9);
		m_pPlayer.EnableStatistics(true);

		m_pEnemyA = GetPlayer(1);
		m_pEnemyA.EnableStatistics(true);
		m_pEnemyB = GetPlayer(2);
		m_pEnemyB.EnableStatistics(true);
		m_pEnemyC = GetPlayer(3);
		m_pEnemyC.EnableStatistics(true);
		m_pEnemyD = GetPlayer(4);
		m_pEnemyD.EnableStatistics(true);

		if ( GetDifficultyLevel() == 0 )
		{
			m_pEnemyA.LoadScript("single\\singleEasy");
			m_pEnemyB.LoadScript("single\\singleEasy");
			m_pEnemyC.LoadScript("single\\singleEasy");
			m_pEnemyD.LoadScript("single\\singleEasy");

			m_pEnemyA.SetMilitaryUnitsLimit(20000);
			m_pEnemyB.SetMilitaryUnitsLimit(20000);
			m_pEnemyC.SetMilitaryUnitsLimit(20000);
			m_pEnemyD.SetMilitaryUnitsLimit(20000);
		}
		else if ( GetDifficultyLevel() == 1 )
		{
			m_pEnemyA.LoadScript("single\\singleMedium");
			m_pEnemyB.LoadScript("single\\singleMedium");
			m_pEnemyC.LoadScript("single\\singleMedium");
			m_pEnemyD.LoadScript("single\\singleMedium");

			m_pEnemyA.SetMilitaryUnitsLimit(30000);
			m_pEnemyB.SetMilitaryUnitsLimit(30000);
			m_pEnemyC.SetMilitaryUnitsLimit(30000);
			m_pEnemyD.SetMilitaryUnitsLimit(30000);
		}
		else if ( GetDifficultyLevel() == 2 )
		{
			m_pEnemyA.LoadScript("single\\singleHard");
			m_pEnemyB.LoadScript("single\\singleHard");
			m_pEnemyC.LoadScript("single\\singleHard");
			m_pEnemyD.LoadScript("single\\singleHard");

			m_pEnemyA.SetMilitaryUnitsLimit(40000);
			m_pEnemyB.SetMilitaryUnitsLimit(40000);
			m_pEnemyC.SetMilitaryUnitsLimit(40000);
			m_pEnemyD.SetMilitaryUnitsLimit(40000);
		}

		m_pEnemyA.EnableMilitaryUnitsLimit(true);
		m_pEnemyB.EnableMilitaryUnitsLimit(true);
		m_pEnemyC.EnableMilitaryUnitsLimit(true);
		m_pEnemyD.EnableMilitaryUnitsLimit(true);

		m_pEnemyA.EnableAI(true);
		m_pEnemyA.EnableAIFeatures(aiBuildAirport|aiBuildMiningBuildings, false);

		m_pEnemyB.EnableAI(true);
		m_pEnemyB.EnableAIFeatures(aiBuildAirport|aiBuildMiningBuildings|aiControlOffense, false);

		m_pEnemyC.EnableAI(true);
		m_pEnemyC.EnableAIFeatures(aiBuildAirport|aiBuildMiningBuildings, false);

		m_pEnemyD.EnableAI(true);
		m_pEnemyD.EnableAIFeatures(aiBuildAirport|aiBuildMiningBuildings, false);

		AddUnitTemplatesRUS( m_pPlayer );

		m_pPlayer.SetMoney(70000);

		m_pEnemyA.SetMoney(20000);
		m_pEnemyB.SetMoney(50000);
		m_pEnemyC.SetMoney(20000);
		m_pEnemyD.SetMoney(50000);

		SetGameRect(GetPointX(markerMapLimiterFrom), GetPointY(markerMapLimiterFrom), GetPointX(markerMapLimiterTo), GetPointY(markerMapLimiterTo));

		/*m_pPlayer.*/LookAt(m_pPlayer.GetStartingPointX(), m_pPlayer.GetStartingPointY(), 6, 0, 0, 0, 0);

		EnableAllResearchRUS( m_pPlayer, false);
		m_pPlayer.EnableResearch("RES_RUS_AMPHIBIA1", true);

		EnableAllResearchIRQ( m_pEnemyA, false);
		m_pEnemyA.EnableResearch("RES_IRQ_TANK1", true);

		EnableAllResearchIRQ( m_pEnemyB, false);
		m_pEnemyB.EnableResearch("RES_IRQ_TANK1", true);

		EnableAllResearchIRQ( m_pEnemyC, false);
		m_pEnemyC.EnableResearch("RES_IRQ_TANK1", true);

		EnableAllResearchIRQ( m_pEnemyD, false);
		m_pEnemyD.EnableResearch("RES_IRQ_TANK1", true);

		SetTimer(0, 100); // CheckDestroyedUnitsAndBuildings

		AddUnitTemplatesIRQ( m_pEnemyA );
		AddUnitTemplatesIRQ( m_pEnemyB );
		AddUnitTemplatesIRQ( m_pEnemyC );
		AddUnitTemplatesIRQ( m_pEnemyD );

		return BeforeStart, 1;
	}

	state BeforeStart
	{
		PlayTrack("Music\\Briefing.tws");

		return Start;
	}

	state Start
	{
		EnableGoal(goalBuildBase, true);

		AddBriefing("translateBriefingMissionRUS_1_BuildBase");
		PlayWave("Briefings\\RUS_Briefing01.wav");

		return BuildBase;
	}

	state BuildBase
	{
		if ( !m_bCheckNumberOfUnits && !m_bCheckNumberOfBuildings )
		{
			return BuildBase;
		}

		m_bCheckNumberOfUnits = false;
		m_bCheckNumberOfBuildings = false;

		if	( m_pPlayer.GetNumberOfUnits() + m_pPlayer.GetNumberOfBuildings() >= 12 )
		{
			return BuildedBase;
		}
		else
		{
			return BuildBase;
		}
	}

	state BuildedBase
	{
		SetGoalState(goalBuildBase, goalAchieved);

		EnableGoal(goalDestroyEnemy, true);

		AddBriefing("translateBriefingMissionRUS_1_DestroyEnemy");

		SetGameRect(0, 0, 0, 0);

		return DestroyEnemy;
	}

	state DestroyEnemy
	{
		if ( !m_bCheckNumberOfUnits && !m_bCheckNumberOfBuildings )
		{
			return DestroyEnemy;
		}

		m_bCheckNumberOfUnits = false;
		m_bCheckNumberOfBuildings = false;

		if ( m_pEnemyA.GetNumberOfBuildings() < 10 )
		{
			m_pEnemyA.EnableAIFeatures(aiBuildBuildings, false);
		}

		if ( m_pEnemyB.GetNumberOfBuildings() < 10 )
		{
			m_pEnemyB.EnableAIFeatures(aiBuildBuildings, false);
		}

		if ( m_pEnemyC.GetNumberOfBuildings() < 10 )
		{
			m_pEnemyC.EnableAIFeatures(aiBuildBuildings, false);
		}

		if ( m_pEnemyD.GetNumberOfBuildings() < 10 )
		{
			m_pEnemyD.EnableAIFeatures(aiBuildBuildings, false);
		}

		if	(
//			m_pEnemyA.GetNumberOfUnits() == m_pEnemyA.GetNumberOfUnits(unitSupplier|chassisAny) &&
			m_pEnemyA.GetNumberOfBuildings() == 0 &&
//			m_pEnemyB.GetNumberOfUnits() == m_pEnemyB.GetNumberOfUnits(unitSupplier|chassisAny) &&
			m_pEnemyB.GetNumberOfBuildings() == 0 &&
//			m_pEnemyC.GetNumberOfUnits() == m_pEnemyC.GetNumberOfUnits(unitSupplier|chassisAny) &&
			m_pEnemyC.GetNumberOfBuildings() == 0 &&
//			m_pEnemyD.GetNumberOfUnits() == m_pEnemyD.GetNumberOfUnits(unitSupplier|chassisAny) &&
			m_pEnemyD.GetNumberOfBuildings() == 0
			)
		{
			return DestroyedEnemy;
		}
		else
		{
			return DestroyEnemy;
		}
	}

	state DestroyedEnemy
	{
		SetGoalState(goalDestroyEnemy, goalAchieved);

		AddBriefing("translateBriefingMissionRUS_1_MissionComplete");

		EnableEndMissionButton(true, true);

		return MissionComplete;
	}

	state MissionComplete
	{
		return MissionComplete;
	}

	function int CheckDestroyedUnitsAndBuildings()
	{
		if ( state == MissionComplete ) return;

		if ( m_pPlayer.GetNumberOfUnits() == 0 && m_pPlayer.GetNumberOfBuildings() == 0 )
		{
			if ( state == BuildBase )
			{
				SetGoalState(goalBuildBase, goalFailed);
			}
			else if ( state == DestroyEnemy )
			{
				SetGoalState(goalDestroyEnemy, goalFailed);
			}

			AddBriefing("translateBriefingMissionRUS_1_MissionFail");

			EnableEndMissionButton(true, false);

			state MissionComplete;
		}
	}

	event Timer0()
	{
		if ( m_bCheckDestroyedUnitsAndBuildings )
		{
			m_bCheckDestroyedUnitsAndBuildings = false;

			CheckDestroyedUnitsAndBuildings();
		}
	}

	event UnitDestroyed(unit uUnit)
	{
		if ( state == Initialize )
		{
			return;
		}

		m_bCheckNumberOfUnits = true;
		m_bCheckDestroyedUnitsAndBuildings = true;

		if ( uUnit.GetIFF() == m_pEnemyB.GetIFF() )
		{
			m_pEnemyB.EnableAIFeatures(aiControlOffense, true);
		}

	}

	event BuildingDestroyed(unit uBuilding)
	{
		m_bCheckNumberOfBuildings = true;
		m_bCheckDestroyedUnitsAndBuildings = true;
	}

	event UnitCreated(unit uUnit)
	{
		if ( state == BuildBase )
		{
			m_bCheckNumberOfUnits = true;
		}
	}

	event BuildingCreated(unit uBuilding)
	{
		if ( state == BuildBase )
		{
			m_bCheckNumberOfBuildings = true;
		}
	}

	event SetupInterface()
	{
	}
}
