mission "translateMissionRUS_2"
{
	consts
	{
		goalFindEnemyA = 0;
		goalFindVIP = 1;
		goalDestroyEnemyB = 2;
		goalEscortVIP = 3;

		markerVIP = 1;

		markerEnemyUnitA1 = 2;
		markerEnemyUnitA2 = 3;
		markerEnemyUnitA3 = 6;
		markerEnemyUnitA4 = 7;

   		markerEnemyUnitB1 = 4;
		markerEnemyUnitB2 = 5;
		markerEnemyUnitB3 = 8;
		markerEnemyUnitB4 = 9;

		markerJeep1 = 10;
		markerJeep2 = 11;
		markerJeep3 = 12;

		markerEnemyJeep = 20;

		markerVIPDestination = 13;

		markerLandingZone = 25;
		markerBackupLandingZone = 30;
	}

	include "UnitTemplates.ech"
	include "Research.ech"

	player m_pPlayer;

	player m_pFriendlyUnits;
	player m_pFriendlyBuildings;

	player m_pSpecialUnits;

	player m_pEnemyA;
	player m_pEnemyB;
	player m_pEnemyC;

	player m_pVIP;

	unitex m_uVIP;

	unitex m_uJeep1;
	unitex m_uJeep2;
	unitex m_uJeep3;

	unitex m_uEnemyUnitA1;
	unitex m_uEnemyUnitA2;
	unitex m_uEnemyUnitA3;
	unitex m_uEnemyUnitA4;

	unitex m_uEnemyUnitB1;
	unitex m_uEnemyUnitB2;
	unitex m_uEnemyUnitB3;
	unitex m_uEnemyUnitB4;

	unitex m_uEnemyJeep;

	unitex m_uBackupLandingZone;

	int m_bCheckDestroyedUnitsAndBuildings;

	int m_bCheckNumberOfUnits;
	int m_bCheckNumberOfBuildings;

	state Initialize;
	state Start;
	state BeforeStart;
	state FindEnemyA;
	state FoundEnemyA;
	state WaitForEnemyJeep;
	state BreakPeace;
	state FindVIP;
	state FoundVIP;
	state DestroyEnemyB;
	state DestroyedEnemyB;
	state StartEnemyOffense;
	state EscortVIP;
	state EscortedVIP;
	state MissionComplete;

	state Initialize
	{
		RegisterGoal(goalFindEnemyA, "translateGoalMissionRUS_2_FindEnemyA");
		RegisterGoal(goalFindVIP, "translateGoalMissionRUS_2_FindVIP");
		RegisterGoal(goalDestroyEnemyB, "translateGoalMissionRUS_2_DestroyEnemyB");
		RegisterGoal(goalEscortVIP, "translateGoalMissionRUS_2_EscortVIP");

		m_pPlayer = GetPlayer(9);
		m_pPlayer.EnableStatistics(false);

		m_pFriendlyUnits = GetPlayer(7);
		m_pFriendlyUnits.EnableStatistics(false);
		m_pFriendlyBuildings = GetPlayer(8);
		m_pFriendlyBuildings.EnableStatistics(false);

		m_pSpecialUnits = GetPlayer(11);
		m_pSpecialUnits.EnableStatistics(false);

		m_pEnemyA = GetPlayer(3);
		m_pEnemyA.EnableStatistics(false);
		m_pEnemyB = GetPlayer(1);
		m_pEnemyB.EnableStatistics(false);
		m_pEnemyC = GetPlayer(2);
		m_pEnemyC.EnableStatistics(false);

		m_pVIP = GetPlayer(10);
		m_pVIP.EnableStatistics(false);

		if ( GetDifficultyLevel() <= 1 )
		{
//			m_pEnemyA.LoadScript("single\\singleEasy");
//			m_pEnemyB.LoadScript("single\\singleEasy");
//			m_pEnemyC.LoadScript("single\\singleEasy");
//		}
//		else if ( GetDifficultyLevel() == 1 )
//		{
//			m_pEnemyA.LoadScript("single\\singleMedium");
			m_pEnemyB.LoadScript("single\\singleMedium");
//			m_pEnemyC.LoadScript("single\\singleMedium");
		}
		else if ( GetDifficultyLevel() == 2 )
		{
//			m_pEnemyA.LoadScript("single\\singleHard");
			m_pEnemyB.LoadScript("single\\singleHard");
//			m_pEnemyC.LoadScript("single\\singleHard");
		}

		m_uVIP = GetUnit(GetPointX(markerVIP), GetPointY(markerVIP));

		m_uJeep1 = GetUnit(GetPointX(markerJeep1), GetPointY(markerJeep1));
		m_uJeep2 = GetUnit(GetPointX(markerJeep2), GetPointY(markerJeep2));
		m_uJeep3 = GetUnit(GetPointX(markerJeep3), GetPointY(markerJeep3));

		m_uEnemyUnitA1 = GetUnit(GetPointX(markerEnemyUnitA1), GetPointY(markerEnemyUnitA1));
		m_uEnemyUnitA2 = GetUnit(GetPointX(markerEnemyUnitA2), GetPointY(markerEnemyUnitA2));
		m_uEnemyUnitA3 = GetUnit(GetPointX(markerEnemyUnitA3), GetPointY(markerEnemyUnitA3));
		m_uEnemyUnitA4 = GetUnit(GetPointX(markerEnemyUnitA4), GetPointY(markerEnemyUnitA4));

		m_uEnemyUnitB1 = GetUnit(GetPointX(markerEnemyUnitB1), GetPointY(markerEnemyUnitB1));
		m_uEnemyUnitB2 = GetUnit(GetPointX(markerEnemyUnitB2), GetPointY(markerEnemyUnitB2));
		m_uEnemyUnitB3 = GetUnit(GetPointX(markerEnemyUnitB3), GetPointY(markerEnemyUnitB3));
		m_uEnemyUnitB4 = GetUnit(GetPointX(markerEnemyUnitB4), GetPointY(markerEnemyUnitB4));

		m_uEnemyJeep = GetUnit(GetPointX(markerEnemyJeep), GetPointY(markerEnemyJeep));

		m_uBackupLandingZone = GetUnit(GetPointX(markerBackupLandingZone), GetPointY(markerBackupLandingZone) );

		m_pFriendlyUnits.EnableAIFeatures(aiRejectAlliance, false);
		m_pFriendlyUnits.EnableAIFeatures2(ai2ChooseEnemy, false);
		m_pPlayer.SetAlly(m_pFriendlyUnits);
		m_pFriendlyUnits.EnableAI(false);

		m_pSpecialUnits.EnableAI(false);

		m_pVIP.EnableAI(false);

		m_pEnemyA.EnableAI(false);

		m_pEnemyB.EnableAI(true);
		m_pEnemyB.EnableAIFeatures(aiEverything, true);
		m_pEnemyB.EnableAIFeatures(aiControlOffense, false);

		m_pEnemyC.EnableAI(false);
//		m_pEnemyC.EnableAIFeatures(aiEverything, true);
//		m_pEnemyC.EnableAIFeatures(aiControlOffense, false);

		AddUnitTemplatesRUS( m_pPlayer );

		/*m_pPlayer.*/LookAt(m_pPlayer.GetStartingPointX(), m_pPlayer.GetStartingPointY(), 6, 0, 0, 0, 0);

		EnableAllResearchRUS( m_pPlayer, false);
		m_pPlayer.EnableResearch("RES_RUS_AMPHIBIA1", true);			// M1
		m_pPlayer.EnableResearch("RES_RUS_ZSU", true);
		m_pPlayer.EnableResearch("RES_RUS_ASSAULT", true);

		EnableAllResearchIRQ( m_pEnemyB, false);
		m_pEnemyB.EnableResearch("RES_IRQ_TANK1", true);			// M1
		m_pEnemyB.EnableResearch("RES_IRQ_HELICOPTER1", true);

		m_pEnemyB.AddResearch("RES_IRQ_TANK1");

		EnableAllResearchIRQ( m_pEnemyC, false);
		m_pEnemyC.EnableResearch("RES_IRQ_TANK1", true);			// M1
		m_pEnemyC.EnableResearch("RES_IRQ_HELICOPTER1", true);

		m_pEnemyC.AddResearch("RES_IRQ_TANK1");

		m_bCheckDestroyedUnitsAndBuildings = false;

		SetTimer(0, 100); // CheckDestroyedUnitsAndBuildings

		AddUnitTemplatesIRQ( m_pEnemyB );
		AddUnitTemplatesIRQ( m_pEnemyC );

		m_pPlayer.EnableCommand(commandRecycleUnit, false);
		m_pPlayer.EnableCommand(commandSoldBuilding, false);

		return BeforeStart, 1;
	}

	state BeforeStart
	{
		PlayTrack("Music\\Briefing.tws");

		return Start;
	}

    state Start
	{
		EnableGoal(goalFindEnemyA, true);
		AddBriefing("translateBriefingMissionRUS_2_FindEnemyA");
		PlayWave("Briefings\\RUS_Briefing02.wav");

		m_pPlayer.SetNeutral(m_pEnemyA);
		m_pEnemyA.SetNeutral(m_pPlayer);

		m_pPlayer.SetNeutral(m_pVIP);
		m_pVIP.SetNeutral(m_pPlayer);

		return FindEnemyA;
	}

	state FindEnemyA
	{
		if ( m_pPlayer.IsPointLocated( m_pEnemyA.GetStartingPointX(), m_pEnemyA.GetStartingPointY() ) )
		{
			return FoundEnemyA;
		}
		else
		{
			return FindEnemyA;
		}
	}

	state FoundEnemyA
	{
		unitex uNearestJeep;
		int nGx, nGy;

		uNearestJeep = m_uJeep1;

		nGx = m_uEnemyJeep.GetLocationX();
		nGy = m_uEnemyJeep.GetLocationY();

		if ( m_uJeep2.DistanceTo(nGx, nGy) < uNearestJeep.DistanceTo(nGx, nGy) )
		{
			uNearestJeep = m_uJeep2;
		}

		if ( m_uJeep3.DistanceTo(nGx, nGy) < uNearestJeep.DistanceTo(nGx, nGy) )
		{
			uNearestJeep = m_uJeep3;
		}

		EnableInterface(false);

		uNearestJeep.CommandStop();

		m_uEnemyJeep.CommandMove( uNearestJeep.GetLocationX(), uNearestJeep.GetLocationY(), 0 );

		return WaitForEnemyJeep;
	}

	state WaitForEnemyJeep
	{
		if ( m_uEnemyJeep.IsMoving() )
		{
			return WaitForEnemyJeep;
		}
		else
		{
			return BreakPeace, 60;
		}
	}

	state BreakPeace
	{
		SetGoalState(goalFindEnemyA, goalAchieved);

		EnableGoal(goalFindVIP, true);
		AddBriefing("translateBriefingMissionRUS_2_FindVIP");

		EnableInterface(true);

		m_pPlayer.SetEnemy(m_pEnemyA);
		m_pEnemyA.SetEnemy(m_pPlayer);

		m_pFriendlyUnits.GiveAllUnitsTo(m_pPlayer);

		return FindVIP;
	}

	state FindVIP
	{
		int nGx, nGy;

		int nVIPx, nVIPy;

		unitex uTmp;

		nVIPx = m_uVIP.GetLocationX();
		nVIPy = m_uVIP.GetLocationY();

		for ( nGy = nVIPy - 3; nGy <= nVIPy + 3; nGy = nGy + 1 )
		{
			for ( nGx = nVIPx - 3; nGx <= nVIPx + 3; nGx = nGx + 1 )
			{
				uTmp = GetUnit(nGx, nGy);

				if ( uTmp.GetIFF() == m_pPlayer.GetIFF() )
				{
					return FoundVIP;
				}
			}
		}

		return FindVIP;
	}

	state FoundVIP
	{
		EnableGoal(goalFindVIP, false);

		EnableGoal(goalDestroyEnemyB, true);
		AddBriefing("translateBriefingMissionRUS_2_DestroyEnemyB");

		m_uVIP.CommandMove( GetPointX(markerVIPDestination), GetPointY(markerVIPDestination), 0 );

		m_bCheckNumberOfUnits = true;
		m_bCheckNumberOfBuildings = true;

		return DestroyEnemyB;
	}

	state DestroyEnemyB
	{
		if ( !m_bCheckNumberOfUnits && !m_bCheckNumberOfBuildings )
		{
			return DestroyEnemyB;
		}

		m_bCheckNumberOfUnits = false;
		m_bCheckNumberOfBuildings = false;

		if ( m_pEnemyB.GetNumberOfBuildings() == 0 && m_pEnemyB.GetNumberOfUnits() == 0 )
		{
			return DestroyedEnemyB;
		}
		else
		{
			return DestroyEnemyB;
		}
	}

	state DestroyedEnemyB
	{
		int nGx, nGy;

		nGx = GetPointX(markerLandingZone);
		nGy = GetPointY(markerLandingZone);

		m_pPlayer.LookAt(nGx, nGy, 6, 0, 0, 0);
		
		KillArea(65535, nGx, nGy, 0, 1);

		SetGoalState(goalDestroyEnemyB, goalAchieved);

		EnableGoal(goalEscortVIP, true);
		AddBriefing("translateBriefingMissionRUS_2_EscortVIP");

		m_pFriendlyBuildings.GiveAllBuildingsTo(m_pPlayer);
		m_uVIP.ChangePlayer(m_pPlayer);

		return StartEnemyOffense, 100;
	}

	state StartEnemyOffense
	{
//		int nGx, nGy;

//		nGx = m_pFriendlyBuildings.GetStartingPointX();
//		nGy = m_pFriendlyBuildings.GetStartingPointY();

		m_uEnemyUnitA1.CommandAttack(m_uVIP);
		m_uEnemyUnitA2.CommandAttack(m_uVIP);
		m_uEnemyUnitA3.CommandAttack(m_uVIP);
		m_uEnemyUnitA4.CommandAttack(m_uVIP);

//		m_uEnemyUnitB1.CommandMove(nGx, nGy, 0);
//		m_uEnemyUnitB2.CommandMove(nGx, nGy, 0);
//		m_uEnemyUnitB3.CommandMove(nGx, nGy, 0);
//		m_uEnemyUnitB4.CommandMove(nGx, nGy, 0);

		m_uEnemyUnitB1.CommandAttack(m_uBackupLandingZone);
		m_uEnemyUnitB2.CommandAttack(m_uBackupLandingZone);
		m_uEnemyUnitB3.CommandAttack(m_uBackupLandingZone);
		m_uEnemyUnitB4.CommandAttack(m_uBackupLandingZone);

		return EscortVIP;
	}

	state EscortVIP
	{
		if ( Distance(m_uVIP.GetLocationX(), m_uVIP.GetLocationY(), m_uBackupLandingZone.GetLocationX(), m_uBackupLandingZone.GetLocationY()) <= 2 )
		{
			return EscortedVIP;
		}
		else
		{
			return EscortVIP;
		}
	}

	state EscortedVIP
	{
		SetGoalState(goalEscortVIP, goalAchieved);
		AddBriefing("translateBriefingMissionRUS_2_MissionComplete");

		EndMission(true);

		return MissionComplete;
	}

	state MissionComplete
	{
		return MissionComplete;
	}

	function int MissionFail()
	{
		if ( state == FindEnemyA )
		{
			SetGoalState(goalFindEnemyA, goalFailed);
		}
		else if ( state == FindVIP )
		{
			SetGoalState(goalFindVIP, goalFailed);
		}
		else if ( state == DestroyEnemyB )
		{
			SetGoalState(goalDestroyEnemyB, goalFailed);
		}
		else if ( state == EscortVIP )
		{
			SetGoalState(goalEscortVIP, goalFailed);
		}

		AddBriefing("translateBriefingMissionRUS_2_MissionFail");

		EnableEndMissionButton(true, false);

		state MissionComplete;
	}

	function int CheckDestroyedUnitsAndBuildings()
	{
		if ( state == MissionComplete ) return;

		if ( !m_uVIP.IsLive() )
		{
			MissionFail();
		}
		else if ( !m_uBackupLandingZone.IsLive() )
		{
			MissionFail();
		}
		else if ( m_pPlayer.GetNumberOfUnits() == 0 )
		{
			MissionFail();
		}
	}

	event Timer0()
	{
		if ( m_bCheckDestroyedUnitsAndBuildings )
		{
			m_bCheckDestroyedUnitsAndBuildings = false;

			CheckDestroyedUnitsAndBuildings();
		}
	}

	event UnitDestroyed(unit uUnit)
	{
		m_bCheckDestroyedUnitsAndBuildings = true;
		m_bCheckNumberOfUnits = true;
	}

	event BuildingDestroyed(unit uBuilding)
	{
		m_bCheckDestroyedUnitsAndBuildings = true;
		m_bCheckNumberOfBuildings = true;
	}

	event EndMission()
	{
		m_pPlayer.EnableCommand(commandRecycleUnit, true);
		m_pPlayer.EnableCommand(commandSoldBuilding, true);
	}

	event SetupInterface()
	{
		EnableGameFeature
			(
			lockToolbarMoney |
			lockDisplayToolbarMoney |
			lockCreateBuildPanel |
			0, true);
	}
}
