mission "translateMissionRUS_3"
{
	consts
	{
        goalCaptureBuildings = 0;

        markerBridge1Mine1 = 1;
        markerBridge1Mine2 = 2;
        markerBridge1      = 3;
        markerBridge2Mine1 = 5;
        markerBridge2Mine2 = 6;
        markerBridge2      = 5;
        markerFirstEnemyBuilding = 7;
        markerLastEnemyBuilding  = 28;
        markerBridge3      = 29;
        markerBuilding1ToCapture = 31;
        markerBuilding2ToCapture = 32;
    }

	include "UnitTemplates.ech"
	include "Research.ech"
    include "Varia.ech"

    unitex m_uBuilding1ToCapture, m_uBuilding2ToCapture;

    player m_pPlayer;
    player m_pEnemy1;
    player m_pEnemy2;
	player m_pRafinery;

    int m_nDestroyedBridge1;
    int m_nDestroyedBridge2;
    int m_nDestroyedBridge3;

	int m_bCheckNumberOfUnits;
	int m_bCheckNumberOfBuildings;

	state Initialize;
	state Start;
	state BeforeStart;
    state CaptureBuildings;
    state MissionComplete;

	function int ClearMarkers(int nStartPoint, int nEndPoint)
	{
		int i;

		for ( i=nStartPoint; i<=nEndPoint; i=i+1 )
		{
			ClearArea (65535, GetPointX(i), GetPointY(i), GetPointZ(i), 0);
		}
	}

	function int ModifyDifficulty()
	{
		if ( GetDifficultyLevel() == 0 )
		{
			ClearMarkers (33, 44);
			ClearMarkers (20, 20);
			ClearMarkers (25, 25);
			ClearMarkers (47, 58);
		}
		else if ( GetDifficultyLevel() == 1 )
		{
			ClearMarkers (33, 33);
			ClearMarkers (36, 37);
			ClearMarkers (41, 42);
			ClearMarkers (45, 48);
			ClearMarkers (51, 52);
			ClearMarkers (56, 58);
		}
		else if ( GetDifficultyLevel() == 2 )
		{
			ClearMarkers (45, 46);
		}
	}

	state Initialize
	{
		ModifyDifficulty();

        m_pPlayer = GetPlayer(9);
		m_pPlayer.EnableStatistics(true);

        m_pEnemy1 = GetPlayer(2);
		m_pEnemy1.EnableStatistics(true);

        m_pEnemy2 = GetPlayer(3);
		m_pEnemy2.EnableStatistics(true);

		m_pRafinery = GetPlayer(0);
		m_pRafinery.EnableStatistics(false);

		m_pRafinery.EnableAI(false);
		m_pRafinery.SetNeutral(m_pPlayer);
		m_pPlayer.SetNeutral(m_pRafinery);

		if ( GetDifficultyLevel() <= 1 )
		{
//			m_pEnemy1.LoadScript("single\\singleEasy");
//			m_pEnemy2.LoadScript("single\\singleEasy");
//		}
//		else if ( GetDifficultyLevel() == 1 )
//		{
			m_pEnemy1.LoadScript("single\\singleMedium");
			m_pEnemy2.LoadScript("single\\singleMedium");
		}
		else if ( GetDifficultyLevel() == 2 )
		{
			m_pEnemy1.LoadScript("single\\singleHard");
			m_pEnemy2.LoadScript("single\\singleHard");
		}

		m_pPlayer.AddMoney(5000);
        AddUnitTemplatesRUS(m_pPlayer);

        m_pEnemy1.EnableAI(true);
        m_pEnemy1.EnableAIFeatures(aiEverything, true);
        m_pEnemy1.SetMaxDistance(30);//zeby nie budowaly shaftow w naszej bazie

        m_pEnemy2.EnableAI(true);
        m_pEnemy2.EnableAIFeatures(aiEverything, true);
        m_pEnemy2.SetMaxDistance(30);//zeby nie budowaly shaftow w naszej bazie

        m_uBuilding1ToCapture = GetUnit(GetPointX(markerBuilding1ToCapture), GetPointY(markerBuilding1ToCapture), GetPointZ(markerBuilding1ToCapture));
        m_uBuilding2ToCapture = GetUnit(GetPointX(markerBuilding2ToCapture), GetPointY(markerBuilding2ToCapture), GetPointZ(markerBuilding2ToCapture));

        m_nDestroyedBridge1 = false;
        m_nDestroyedBridge2 = false;
        m_nDestroyedBridge3 = false;

        CreateArtefacts(markerBridge1Mine1, markerBridge1Mine2, "ARTIFACT_INVISIBLE", true);
        CreateArtefacts(markerBridge2Mine1, markerBridge2Mine2, "ARTIFACT_INVISIBLE", true);

		/*m_pPlayer.*/LookAt(m_pPlayer.GetStartingPointX(), m_pPlayer.GetStartingPointY(), 6, 0, 0, 0, 0);

		EnableAllResearchRUS( m_pPlayer, false);
		m_pPlayer.EnableResearch("RES_RUS_AMPHIBIA1", true);			// M1
		m_pPlayer.EnableResearch("RES_RUS_ZSU", true);					// M2
		m_pPlayer.EnableResearch("RES_RUS_ASSAULT", true);				// M2
		m_pPlayer.EnableResearch("RES_RUS_PILLBOX", true);
		m_pPlayer.EnableResearch("RES_RUS_TANK", true);
		m_pPlayer.EnableResearch("RES_RUS_MIM", true);
		m_pPlayer.EnableResearch("RES_RUS_HELICOPTER1", true);

		EnableAllResearchIRQ( m_pEnemy1, false);
		m_pEnemy1.EnableResearch("RES_IRQ_TANK1", true);			// M1
		m_pEnemy1.EnableResearch("RES_IRQ_HELICOPTER1", true);		// M2
		m_pEnemy1.EnableResearch("RES_IRQ_AMMO_MG1", true);
		m_pEnemy1.EnableResearch("RES_IRQ_PILLBOX", true);
		m_pEnemy1.EnableResearch("RES_IRQ_TANK2", true);
		m_pEnemy1.EnableResearch("RES_IRQ_SAPER", true);
		m_pEnemy1.EnableResearch("RES_IRQ_MIM", true);

		m_pEnemy1.AddResearch("RES_IRQ_TANK1");
		m_pEnemy1.AddResearch("RES_IRQ_HELICOPTER1");

		EnableAllResearchIRQ( m_pEnemy2, false);
		m_pEnemy2.EnableResearch("RES_IRQ_TANK1", true);			// M1
		m_pEnemy2.EnableResearch("RES_IRQ_HELICOPTER1", true);		// M2
		m_pEnemy2.EnableResearch("RES_IRQ_AMMO_MG1", true);
		m_pEnemy2.EnableResearch("RES_IRQ_PILLBOX", true);
		m_pEnemy2.EnableResearch("RES_IRQ_TANK2", true);
		m_pEnemy2.EnableResearch("RES_IRQ_SAPER", true);
		m_pEnemy2.EnableResearch("RES_IRQ_MIM", true);

		m_pEnemy2.AddResearch("RES_IRQ_TANK1");
		m_pEnemy2.AddResearch("RES_IRQ_HELICOPTER1");
		
		AddUnitTemplatesIRQ( m_pEnemy1 );
		AddUnitTemplatesIRQ( m_pEnemy2 );

		return BeforeStart, 1;
	}

	state BeforeStart
	{
		PlayTrack("Music\\Briefing.tws");

		return Start;
	}

    state Start
    {
        RegisterGoal(goalCaptureBuildings, "translateGoalMissionRUS_3_CaptureBuildings");
        EnableGoal(goalCaptureBuildings, true);
        
        AddBriefing("translateBriefingMissionRUS_3_CaptureBuildings");
		PlayWave("Briefings\\RUS_Briefing03.wav");

        return CaptureBuildings;
    }

	state CaptureBuildings
	{
        //sprawdzenie budynkow 7-28 (naleza do playera 2) - jesli zostanie zniszczonych 10 budynkow to rozwalamy bridge3
        if (!m_nDestroyedBridge3 && (CountPlayerBuildings(markerFirstEnemyBuilding, markerLastEnemyBuilding, 2) <= (markerLastEnemyBuilding - markerFirstEnemyBuilding + 1 - 10)))
        {
            m_nDestroyedBridge3 = true;
            KillArea(65535, GetPointX(markerBridge3), GetPointY(markerBridge3), GetPointZ(markerBridge3), 3);
            AddBriefing("translateBriefingMissionRUS_3_InfoBridgeDestroyed2");
        }

        if (!m_uBuilding1ToCapture.IsLive() || !m_uBuilding2ToCapture.IsLive())
        {
            if (GetGoalState(goalCaptureBuildings) != goalAchieved)
            {
                SetGoalState(goalCaptureBuildings, goalFailed);
            }
            AddBriefing("translateBriefingMissionRUS_3_MissionFail");
            EnableEndMissionButton(true, false);
            return MissionComplete;
        }

        if ((m_uBuilding1ToCapture.GetIFFNumber() == m_pPlayer.GetIFFNumber()) && (m_uBuilding2ToCapture.GetIFFNumber() == m_pPlayer.GetIFFNumber()))
        {
            SetGoalState(goalCaptureBuildings, goalAchieved);
            AddBriefing("translateBriefingMissionRUS_3_MissionComplete");
            EnableEndMissionButton(true, true);
            return MissionComplete;
        }

		if ( m_bCheckNumberOfUnits || m_bCheckNumberOfBuildings )
		{
			m_bCheckNumberOfUnits = false;
			m_bCheckNumberOfBuildings = false;

			if ( m_pPlayer.GetNumberOfUnits() == 0 && m_pPlayer.GetNumberOfBuildings() == 0 )
			{
				SetGoalState(goalCaptureBuildings, goalFailed);

				AddBriefing("translateBriefingMissionRUS_3_MissionFail");

				EnableEndMissionButton(true, false);

				return MissionComplete;
			}
		}

        return CaptureBuildings, 80;
	}

    state MissionComplete
    {
        return MissionComplete;
    }

    event Artefact(int nArtefactNum, player pPlayerOnArtefact)
    {
		if ( pPlayerOnArtefact != m_pPlayer )
		{
			return false;
		}

        if ((nArtefactNum == markerBridge1Mine1) || (nArtefactNum == markerBridge1Mine2))
        {
            if (!m_nDestroyedBridge1)
            {
                m_nDestroyedBridge1 = true;
                KillArea(65535, GetPointX(markerBridge1), GetPointY(markerBridge1), GetPointZ(markerBridge1), 2);
	            AddBriefing("translateBriefingMissionRUS_3_InfoBridgeDestroyed1");
            }
            return true;
        }
        else if ((nArtefactNum == markerBridge2Mine1) || (nArtefactNum == markerBridge2Mine2))
        {
            if (!m_nDestroyedBridge2)
            {
                m_nDestroyedBridge2 = true;
                KillArea(65535, GetPointX(markerBridge2), GetPointY(markerBridge2), GetPointZ(markerBridge2), 2);
	            AddBriefing("translateBriefingMissionRUS_3_InfoBridgeDestroyed1");
            }
            return true;
        }
        return false;
    }

	/*
	event UnitDestroyed(unit uUnit)
	{
		if ( uUnit == m_uHero )
		{
			AddBriefing("translateBriefingMissionRUS_3_MissionFail");
            if (GetGoalState(goalCaptureBuildings) != goalAchieved)
            {
                SetGoalState(goalCaptureBuildings, goalFailed);
            }
            EnableEndMissionButton(true, false);
			state MissionComplete;
		}
	}
	*/

	event UnitDestroyed(unit uUnit)
	{
		m_bCheckNumberOfUnits = true;
	}

	event BuildingDestroyed(unit uBuilding)
	{
		m_bCheckNumberOfBuildings = true;
	}

	event SetupInterface()
	{
		EnableGameFeature
			(
			lockToolbarMoney |
			lockDisplayToolbarMoney |
			lockCreateBuildPanel |
			0, false);
	}
}
