mission "translateMissionRUS_4"
{
	consts
	{
		goalKillGeneral = 0;

		markerGeneral = 7;
		markerGeneralDestinationA = 0;
		markerGeneralDestinationB = 1;
		markerGeneralDestinationC1 = 2;
		markerGeneralDestinationC2 = 3;
		markerGeneralDestinationC3 = 4;

		markerBridge = 6;

		markerMapLimiter = 5;
	}

	include "UnitTemplates.ech"
	include "Research.ech"

	player m_pPlayer;

	player m_pEnemyA;
	player m_pEnemyB;
	player m_pEnemyC;
	player m_pEnemy1;
	player m_pEnemy2;

	unitex m_uGeneral;

	int m_bCheckNumberOfUnits;
	int m_bCheckNumberOfBuildings;

	int m_bCheckDestroyedPlayerUnits;

	state Initialize;
	state Start;
	state BeforeStart;
	state FindGeneralA;
	state DetonateBrigde;
	state FoundGeneralA;
	state FindGeneralB;
	state FoundGeneralB;
	state FindGeneralC;
	state FoundGeneralC;
	state Nothing;
	state MissionComplete;

	function int ClearMarkers(int nStartPoint, int nEndPoint)
	{
		int i;

		for ( i=nStartPoint; i<=nEndPoint; i=i+1 )
		{
			ClearArea (65535, GetPointX(i), GetPointY(i), GetPointZ(i), 0);
		}
	}

	function int ModifyDifficulty()
	{
		if ( GetDifficultyLevel() == 0 )
		{
			ClearMarkers ( 8, 24);
			ClearArea (65535, GetPointX(25), GetPointY(25), GetPointZ(25), 1);
			ClearMarkers (26, 35);
		}
		else if ( GetDifficultyLevel() == 1 )
		{
			ClearMarkers (13, 18);
			ClearMarkers (23, 23);
			ClearMarkers (28, 28);
			ClearMarkers (30, 30);
			ClearMarkers (32, 32);
			ClearMarkers (34, 34);
		}
		else if ( GetDifficultyLevel() == 2 )
		{
		}
	}

	state Initialize
	{
		RegisterGoal(goalKillGeneral, "translateGoalMissionRUS_4_KillGeneral");

		m_pPlayer = GetPlayer(9);
		m_pPlayer.EnableStatistics(false);

		m_pEnemyA = GetPlayer(1);
		m_pEnemyA.EnableStatistics(false);
		m_pEnemyB = GetPlayer(3);
		m_pEnemyB.EnableStatistics(false);
		m_pEnemyC = GetPlayer(4);
		m_pEnemyC.EnableStatistics(false);

		m_pEnemy1 = GetPlayer(2);
		m_pEnemy1.EnableStatistics(false);
		m_pEnemy2 = GetPlayer(5);
		m_pEnemy2.EnableStatistics(false);

        //moved by JS
		ModifyDifficulty();

		m_pEnemyA.EnableAI(false);
		m_pEnemyB.EnableAI(false);
		m_pEnemyC.EnableAI(false);
		m_pEnemy1.EnableAI(false);
		m_pEnemy2.EnableAI(false);

//		m_pPlayer.SetMoney(0);

		m_pEnemyA.SetMoney(0);
		m_pEnemyB.SetMoney(0);
		m_pEnemyC.SetMoney(0);
		m_pEnemy1.SetMoney(0);
		m_pEnemy2.SetMoney(0);

		m_uGeneral = GetUnit(GetPointX(markerGeneral), GetPointY(markerGeneral));

		SetGameRect(GetLeft()+17, GetPointY(markerMapLimiter), GetPointX(markerMapLimiter), GetBottom()-17);

		/*m_pPlayer.*/LookAt(m_pPlayer.GetStartingPointX(), m_pPlayer.GetStartingPointY(), 6, 0, 0, 0, 0);

		EnableAllResearchRUS( m_pPlayer, false);
		m_pPlayer.EnableResearch("RES_RUS_AMPHIBIA1", true);			// M1
		m_pPlayer.EnableResearch("RES_RUS_ZSU", true);					// M2
		m_pPlayer.EnableResearch("RES_RUS_ASSAULT", true);				// M2
		m_pPlayer.EnableResearch("RES_RUS_PILLBOX", true);				// M3
		m_pPlayer.EnableResearch("RES_RUS_TANK", true);					// M3
		m_pPlayer.EnableResearch("RES_RUS_MIM", true);					// M3
		m_pPlayer.EnableResearch("RES_RUS_HELICOPTER1", true);			// M3
		m_pPlayer.EnableResearch("RES_RUS_AMMO_MG1", true);
		m_pPlayer.EnableResearch("RES_RUS_AMMO_CANNON1", true);
		m_pPlayer.EnableResearch("RES_RUS_SAPER", true);
		m_pPlayer.EnableResearch("RES_RUS_BM21", true);
		m_pPlayer.EnableResearch("RES_RUS_HELICOPTER2", true);

		SetTimer(0, 100); // CheckDestroyedPlayerUnits
		SetTimer(1, 60); // uaktualnianie znacznika na mapie

		m_pPlayer.EnableCommand(commandRecycleUnit, false);
		m_pPlayer.EnableCommand(commandSoldBuilding, false);

		return BeforeStart, 1;
	}

	state BeforeStart
	{
		PlayTrack("Music\\Briefing.tws");

		return Start;
	}

	event Timer1()
	{
		AddWorldMapSign(m_uGeneral.GetLocationX(), m_uGeneral.GetLocationY(), 0, 1, 65);
	}

	state Start
	{
		EnableGoal(goalKillGeneral, true);
		AddBriefing("translateBriefingMissionRUS_4_KillGeneral");
		PlayWave("Briefings\\RUS_Briefing04.wav");

		return FindGeneralA;
	}

	state FindGeneralA
	{
		if ( m_pPlayer.IsPointLocated( m_uGeneral.GetLocationX(), m_uGeneral.GetLocationY() ) )
		{
			return FoundGeneralA;
		}
		else
		{
			return FindGeneralA;
		}
	}

	state FoundGeneralA
	{
		m_uGeneral.CommandMove( GetPointX(markerGeneralDestinationA), GetPointY(markerGeneralDestinationA), 0 );

		return DetonateBrigde, 100;
	}

	state DetonateBrigde
	{
		KillArea(65535, GetPointX(markerBridge), GetPointY(markerBridge), 0, 2);

		SetGameRect(GetLeft()+17, GetTop()+17, GetPointX(markerMapLimiter), GetBottom()-17);

		return FindGeneralB, 200;
	}

	state FindGeneralB
	{
		if ( m_pPlayer.IsPointLocated( m_uGeneral.GetLocationX(), m_uGeneral.GetLocationY() ) )
		{
			return FoundGeneralB;
		}
		else
		{
			return FindGeneralB;
		}
	}

	state FoundGeneralB
	{
		m_uGeneral.CommandMove( GetPointX(markerGeneralDestinationB), GetPointY(markerGeneralDestinationB), 0 );

		SetGameRect(0, 0, 0, 0);

		return FindGeneralC, 200;
	}

	state FindGeneralC
	{
		if ( m_pPlayer.IsPointLocated( m_uGeneral.GetLocationX(), m_uGeneral.GetLocationY() ) )
		{
			return FoundGeneralC;
		}
		else
		{
			return FindGeneralC;
		}
	}

	state FoundGeneralC
	{
		m_uGeneral.CommandMove( GetPointX(markerGeneralDestinationC3), GetPointY(markerGeneralDestinationC3), 0 );

		return Nothing;
	}

	state Nothing
	{
		return Nothing;
	}

	state MissionComplete
	{
		return MissionComplete;
	}

	event UnitDestroyed(unit uUnit)
	{
		m_bCheckNumberOfUnits = true;

		if ( uUnit == m_uGeneral )
		{
			SetGoalState(goalKillGeneral, goalAchieved);
			AddBriefing("translateBriefingMissionRUS_4_MissionComplete");

			EnableEndMissionButton(true, true);

			state MissionComplete;
		}

		if ( uUnit.GetIFF() == m_pPlayer.GetIFF() )
		{
			m_bCheckDestroyedPlayerUnits = true;
		}
	}

	event BuildingDestroyed(unit uBuilding)
	{
		m_bCheckNumberOfBuildings = true;

		if ( state == FindGeneralA && uBuilding.GetIFF() == m_pEnemyA.GetIFF() )
		{
			state FoundGeneralA;
		}
		else if ( state == FindGeneralB && uBuilding.GetIFF() == m_pEnemyB.GetIFF() )
		{
			state FoundGeneralB;
		}
		else if ( state == FindGeneralC && uBuilding.GetIFF() == m_pEnemyC.GetIFF() )
		{
			state FoundGeneralC;
		}
	}

	function int CheckDestroyedPlayerUnits()
	{
		if ( state == MissionComplete ) return;

		if ( m_pPlayer.GetNumberOfUnits() == 0 )
		{
			SetGoalState(goalKillGeneral, goalFailed);

			AddBriefing("translateBriefingMissionRUS_4_MissionFail");

			EnableEndMissionButton(true, false);

			state MissionComplete;
		}
	}

	event Timer0()
	{
		if ( m_bCheckDestroyedPlayerUnits )
		{
			m_bCheckDestroyedPlayerUnits = false;

			CheckDestroyedPlayerUnits();
		}
	}

	event EndMission()
	{
		m_pPlayer.EnableCommand(commandRecycleUnit, true);
		m_pPlayer.EnableCommand(commandSoldBuilding, true);
	}

	event SetupInterface()
	{
		EnableGameFeature
			(
			lockToolbarMoney |
			lockDisplayToolbarMoney |
			lockCreateBuildPanel |
			0, true);
	}
}
