mission "translateMissionRUS_5"
{
	consts
	{
		goalBuildBase = 0;
		goalDestroyEnemyA = 1;
		goalDestroyEnemies = 2;

		markerMapLimiter = 0;
	}

	include "UnitTemplates.ech"
	include "Research.ech"

	player m_pPlayer;

	player m_pEnemyA;
	player m_pEnemyB;
	player m_pEnemyC;

	int m_bCheckNumberOfUnits;
	int m_bCheckNumberOfBuildings;

	int m_bCheckDestroyedUnitsAndBuildings;

	int m_nTimeOfEnemyEnable;

	state Initialize;
	state Start;
	state BeforeStart;
	state BuildBase;
	state BuildedBase;
	state DestroyEnemyA;
	state DestroyedEnemyA;
	state DestroyEnemies;
	state DestroyedEnemies;
	state MissionComplete;

	function int ClearMarkers(int nStartPoint, int nEndPoint)
	{
		int i;

		for ( i=nStartPoint; i<=nEndPoint; i=i+1 )
		{
			ClearArea (65535, GetPointX(i), GetPointY(i), GetPointZ(i), 0);
		}
	}

	function int ModifyDifficulty()
	{
		if ( GetDifficultyLevel() == 0 )
		{
			ClearMarkers ( 1,  2);
			ClearMarkers ( 4,  8);
			ClearArea (65535, GetPointX( 9), GetPointY( 9), GetPointZ( 9), 1);
			ClearArea (65535, GetPointX(10), GetPointY(10), GetPointZ(10), 1);
			ClearArea (65535, GetPointX(11), GetPointY(11), GetPointZ(11), 1);
			ClearMarkers (12, 17);
		}
		else if ( GetDifficultyLevel() == 1 )
		{
			ClearMarkers ( 3,  3);
			ClearMarkers ( 6,  6);
			ClearMarkers (14, 15);
		}
		else if ( GetDifficultyLevel() == 2 )
		{
		}
	}

	state Initialize
	{
		ModifyDifficulty();

		RegisterGoal(goalBuildBase, "translateGoalMissionRUS_5_BuildBase");
		RegisterGoal(goalDestroyEnemyA, "translateGoalMissionRUS_5_DestroyEnemyA");
		RegisterGoal(goalDestroyEnemies, "translateGoalMissionRUS_5_DestroyEnemies");

		m_pPlayer = GetPlayer(9);
		m_pPlayer.EnableStatistics(true);

		m_pPlayer.SetMilitaryUnitsLimit(60000);

		m_pEnemyA = GetPlayer(1);
		m_pEnemyA.EnableStatistics(true);
		m_pEnemyB = GetPlayer(2);
		m_pEnemyB.EnableStatistics(true);
		m_pEnemyC = GetPlayer(3);
		m_pEnemyC.EnableStatistics(true);

		if ( GetDifficultyLevel() == 0 )
		{
			m_pEnemyA.LoadScript("single\\singleMedium");
			m_pEnemyB.LoadScript("single\\singleEasy");
			m_pEnemyC.LoadScript("single\\singleEasy");

			m_pEnemyA.SetMilitaryUnitsLimit(15000);
			m_pEnemyB.SetMilitaryUnitsLimit(15000);
			m_pEnemyC.SetMilitaryUnitsLimit(15000);

			m_pEnemyA.EnableMilitaryUnitsLimit(true);
			m_pEnemyB.EnableMilitaryUnitsLimit(true);
			m_pEnemyC.EnableMilitaryUnitsLimit(true);

			m_nTimeOfEnemyEnable = 5*60*20;
		}
		else if ( GetDifficultyLevel() == 1 )
		{
			m_pEnemyA.LoadScript("single\\singleMedium");
			m_pEnemyB.LoadScript("single\\singleMedium");
			m_pEnemyC.LoadScript("single\\singleMedium");

			m_pEnemyA.SetMilitaryUnitsLimit(30000);
			m_pEnemyB.SetMilitaryUnitsLimit(30000);
			m_pEnemyC.SetMilitaryUnitsLimit(30000);

			m_pEnemyA.EnableMilitaryUnitsLimit(true);
			m_pEnemyB.EnableMilitaryUnitsLimit(true);
			m_pEnemyC.EnableMilitaryUnitsLimit(true);

			m_nTimeOfEnemyEnable = 0;
		}
		else if ( GetDifficultyLevel() == 2 )
		{
			m_pEnemyA.LoadScript("single\\singleHard");
			m_pEnemyB.LoadScript("single\\singleHard");
			m_pEnemyC.LoadScript("single\\singleHard");

			m_nTimeOfEnemyEnable = 0;
		}

		m_pEnemyA.EnableAI(false);
		m_pEnemyB.EnableAI(false);
		m_pEnemyC.EnableAI(false);

		AddUnitTemplatesRUS( m_pPlayer );

		m_pPlayer.AddMoney(5000);

		if ( GetDifficultyLevel() == 0 )
		{
			m_pEnemyA.SetMoney(10000);
		}
		else
		{
			m_pEnemyA.SetMoney(50000);
		}

		m_pEnemyB.SetMoney(10000);
		m_pEnemyC.SetMoney(10000);

		m_pEnemyA.SetMaxDistance(m_pEnemyA.GetStartingPointY() - GetPointY(markerMapLimiter) - 5);

		SetGameRect(GetLeft()+17, GetPointY(markerMapLimiter), GetPointX(markerMapLimiter), GetBottom()-17);

		/*m_pPlayer.*/LookAt(m_pPlayer.GetStartingPointX(), m_pPlayer.GetStartingPointY(), 6, 0, 0, 0, 0);

		EnableAllResearchRUS( m_pPlayer, false);
		m_pPlayer.EnableResearch("RES_RUS_AMPHIBIA1", true);			// M1
		m_pPlayer.EnableResearch("RES_RUS_ZSU", true);					// M2
		m_pPlayer.EnableResearch("RES_RUS_ASSAULT", true);				// M2
		m_pPlayer.EnableResearch("RES_RUS_PILLBOX", true);				// M3
		m_pPlayer.EnableResearch("RES_RUS_TANK", true);					// M3
		m_pPlayer.EnableResearch("RES_RUS_MIM", true);					// M3
		m_pPlayer.EnableResearch("RES_RUS_HELICOPTER1", true);			// M3
		m_pPlayer.EnableResearch("RES_RUS_AMMO_MG1", true);				// M4
		m_pPlayer.EnableResearch("RES_RUS_AMMO_CANNON1", true);			// M4
		m_pPlayer.EnableResearch("RES_RUS_SAPER", true);				// M4
		m_pPlayer.EnableResearch("RES_RUS_BM21", true);					// M4
		m_pPlayer.EnableResearch("RES_RUS_HELICOPTER2", true);			// M4
		m_pPlayer.EnableResearch("RES_RUS_AMMO_MG2", true);
		m_pPlayer.EnableResearch("RES_RUS_ART", true);
		m_pPlayer.EnableResearch("RES_RUS_AMMO_MGM1", true);
		m_pPlayer.EnableResearch("RES_RUS_SPECIAL_FILTER2", true);

		EnableAllResearchRUS( m_pEnemyA, false);
		m_pEnemyA.EnableResearch("RES_RUS_AMPHIBIA1", true);			// M1
		m_pEnemyA.EnableResearch("RES_RUS_ZSU", true);					// M2
		m_pEnemyA.EnableResearch("RES_RUS_ASSAULT", true);				// M2
		m_pEnemyA.EnableResearch("RES_RUS_PILLBOX", true);				// M3
		m_pEnemyA.EnableResearch("RES_RUS_TANK", true);					// M3
		m_pEnemyA.EnableResearch("RES_RUS_MIM", true);					// M3
		m_pEnemyA.EnableResearch("RES_RUS_HELICOPTER1", true);			// M3
		m_pEnemyA.EnableResearch("RES_RUS_AMMO_MG1", true);				// M4
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyA.EnableResearch("RES_RUS_AMMO_CANNON1", true);		// M4
			m_pEnemyA.EnableResearch("RES_RUS_SAPER", true);			// M4
		}
		m_pEnemyA.EnableResearch("RES_RUS_BM21", true);					// M4
		m_pEnemyA.EnableResearch("RES_RUS_HELICOPTER2", true);			// M4
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyA.EnableResearch("RES_RUS_AMMO_MG2", true);
		}
		m_pEnemyA.EnableResearch("RES_RUS_ART", true);
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyA.EnableResearch("RES_RUS_AMMO_MGM1", true);
		}
		m_pEnemyA.EnableResearch("RES_RUS_SPECIAL_FILTER2", true);

		m_pEnemyA.AddResearch("RES_RUS_AMPHIBIA1");
		m_pEnemyA.AddResearch("RES_RUS_ZSU");
		m_pEnemyA.AddResearch("RES_RUS_ASSAULT");
		m_pEnemyA.AddResearch("RES_RUS_PILLBOX");
		m_pEnemyA.AddResearch("RES_RUS_TANK");
		m_pEnemyA.AddResearch("RES_RUS_MIM");
		m_pEnemyA.AddResearch("RES_RUS_HELICOPTER1");
		m_pEnemyA.AddResearch("RES_RUS_AMMO_MG1");
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyA.AddResearch("RES_RUS_AMMO_CANNON1");
			m_pEnemyA.AddResearch("RES_RUS_SAPER");
		}
		m_pEnemyA.AddResearch("RES_RUS_BM21");
		m_pEnemyA.AddResearch("RES_RUS_HELICOPTER2");

		EnableAllResearchRUS( m_pEnemyB, false);
		m_pEnemyB.EnableResearch("RES_RUS_AMPHIBIA1", true);			// M1
		m_pEnemyB.EnableResearch("RES_RUS_ZSU", true);					// M2
		m_pEnemyB.EnableResearch("RES_RUS_ASSAULT", true);				// M2
		m_pEnemyB.EnableResearch("RES_RUS_PILLBOX", true);				// M3
		m_pEnemyB.EnableResearch("RES_RUS_TANK", true);					// M3
		m_pEnemyB.EnableResearch("RES_RUS_MIM", true);					// M3
		m_pEnemyB.EnableResearch("RES_RUS_HELICOPTER1", true);			// M3
		m_pEnemyB.EnableResearch("RES_RUS_AMMO_MG1", true);				// M4
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyB.EnableResearch("RES_RUS_AMMO_CANNON1", true);		// M4
			m_pEnemyB.EnableResearch("RES_RUS_SAPER", true);			// M4
		}
		m_pEnemyB.EnableResearch("RES_RUS_BM21", true);					// M4
		m_pEnemyB.EnableResearch("RES_RUS_HELICOPTER2", true);			// M4
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyB.EnableResearch("RES_RUS_AMMO_MG2", true);
		}
		m_pEnemyB.EnableResearch("RES_RUS_ART", true);
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyB.EnableResearch("RES_RUS_AMMO_MGM1", true);
		}
		m_pEnemyB.EnableResearch("RES_RUS_SPECIAL_FILTER2", true);

		m_pEnemyB.AddResearch("RES_RUS_AMPHIBIA1");
		m_pEnemyB.AddResearch("RES_RUS_ZSU");
		m_pEnemyB.AddResearch("RES_RUS_ASSAULT");
		m_pEnemyB.AddResearch("RES_RUS_PILLBOX");
		m_pEnemyB.AddResearch("RES_RUS_TANK");
		m_pEnemyB.AddResearch("RES_RUS_MIM");
		m_pEnemyB.AddResearch("RES_RUS_HELICOPTER1");
		m_pEnemyB.AddResearch("RES_RUS_AMMO_MG1");
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyB.AddResearch("RES_RUS_AMMO_CANNON1");
			m_pEnemyB.AddResearch("RES_RUS_SAPER");
		}
		m_pEnemyB.AddResearch("RES_RUS_BM21");
		m_pEnemyB.AddResearch("RES_RUS_HELICOPTER2");

		EnableAllResearchRUS( m_pEnemyC, false);
		m_pEnemyC.EnableResearch("RES_RUS_AMPHIBIA1", true);			// M1
		m_pEnemyC.EnableResearch("RES_RUS_ZSU", true);					// M2
		m_pEnemyC.EnableResearch("RES_RUS_ASSAULT", true);				// M2
		m_pEnemyC.EnableResearch("RES_RUS_PILLBOX", true);				// M3
		m_pEnemyC.EnableResearch("RES_RUS_TANK", true);					// M3
		m_pEnemyC.EnableResearch("RES_RUS_MIM", true);					// M3
		m_pEnemyC.EnableResearch("RES_RUS_HELICOPTER1", true);			// M3
		m_pEnemyC.EnableResearch("RES_RUS_AMMO_MG1", true);				// M4
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyC.EnableResearch("RES_RUS_AMMO_CANNON1", true);		// M4
			m_pEnemyC.EnableResearch("RES_RUS_SAPER", true);			// M4
		}
		m_pEnemyC.EnableResearch("RES_RUS_BM21", true);					// M4
		m_pEnemyC.EnableResearch("RES_RUS_HELICOPTER2", true);			// M4
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyC.EnableResearch("RES_RUS_AMMO_MG2", true);
		}
		m_pEnemyC.EnableResearch("RES_RUS_ART", true);
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyC.EnableResearch("RES_RUS_AMMO_MGM1", true);
		}
		m_pEnemyC.EnableResearch("RES_RUS_SPECIAL_FILTER2", true);

		m_pEnemyC.AddResearch("RES_RUS_AMPHIBIA1");
		m_pEnemyC.AddResearch("RES_RUS_ZSU");
		m_pEnemyC.AddResearch("RES_RUS_ASSAULT");
		m_pEnemyC.AddResearch("RES_RUS_PILLBOX");
		m_pEnemyC.AddResearch("RES_RUS_TANK");
		m_pEnemyC.AddResearch("RES_RUS_MIM");
		m_pEnemyC.AddResearch("RES_RUS_HELICOPTER1");
		m_pEnemyC.AddResearch("RES_RUS_AMMO_MG1");
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyC.AddResearch("RES_RUS_AMMO_CANNON1");
			m_pEnemyC.AddResearch("RES_RUS_SAPER");
		}
		m_pEnemyC.AddResearch("RES_RUS_BM21");
		m_pEnemyC.AddResearch("RES_RUS_HELICOPTER2");

		SetTimer(0, 100); // CheckDestroyedUnitsAndBuildings

		AddUnitTemplatesRUS( m_pEnemyA );
		AddUnitTemplatesRUS( m_pEnemyB );
		AddUnitTemplatesRUS( m_pEnemyC );

		return BeforeStart, 1;
	}

	state BeforeStart
	{
		PlayTrack("Music\\Briefing.tws");

		return Start;
	}

	state Start
	{
		EnableGoal(goalBuildBase, true);
		AddBriefing("translateBriefingMissionRUS_5_BuildBase");
		PlayWave("Briefings\\RUS_Briefing05.wav");

		return BuildBase;
	}

	state BuildBase
	{
		if ( GetMissionTime() >= m_nTimeOfEnemyEnable )
		{
			m_pEnemyA.EnableAI(true);
			m_pEnemyB.EnableAI(true);
			m_pEnemyC.EnableAI(true);
		}

		if ( GetMissionTime() >= 10*60*20 )
		{
			return BuildedBase;
		}
		else
		{
			return BuildBase;
		}
	}

	state BuildedBase
	{
		SetGoalState(goalBuildBase, goalAchieved);

		EnableGoal(goalDestroyEnemyA, true);
		AddBriefing("translateBriefingMissionRUS_5_DestroyEnemyA");

		SetGameRect(GetLeft()+17, GetPointY(markerMapLimiter), GetRight()-17, GetBottom()-17);

		return DestroyEnemyA;
	}

	state DestroyEnemyA
	{
		if ( !m_bCheckNumberOfBuildings )
		{
			return DestroyEnemyA;
		}

		if ( m_pEnemyA.GetNumberOfBuildings() < 10 )
		{
			m_pEnemyA.EnableAIFeatures(aiBuildBuildings, false);
		}

		m_bCheckNumberOfBuildings = false;

		if ( m_pEnemyA.GetNumberOfBuildings() == 0 )
		{
			return DestroyedEnemyA;
		}
		else
		{
			return DestroyEnemyA;
		}
	}

	state DestroyedEnemyA
	{
		SetGoalState(goalDestroyEnemyA, goalAchieved);

		EnableGoal(goalDestroyEnemies, true);
		AddBriefing("translateBriefingMissionRUS_5_DestroyEnemies");

		SetGameRect(0, 0, 0, 0);

		return DestroyEnemies;
	}

	state DestroyEnemies
	{
		if ( !m_bCheckNumberOfUnits && !m_bCheckNumberOfBuildings )
		{
			return DestroyEnemies;
		}

		if ( m_pEnemyA.GetNumberOfBuildings() < 10 )
		{
			m_pEnemyA.EnableAIFeatures(aiBuildBuildings, false);
		}

		if ( m_pEnemyB.GetNumberOfBuildings() < 10 )
		{
			m_pEnemyB.EnableAIFeatures(aiBuildBuildings, false);
		}

		if ( m_pEnemyC.GetNumberOfBuildings() < 10 )
		{
			m_pEnemyC.EnableAIFeatures(aiBuildBuildings, false);
		}

		m_bCheckNumberOfUnits = false;
		m_bCheckNumberOfBuildings = false;

		if	(
			m_pEnemyA.GetNumberOfBuildings() == 0 &&
			m_pEnemyB.GetNumberOfBuildings() == 0 &&
			m_pEnemyC.GetNumberOfBuildings() == 0 &&
			m_pEnemyA.GetNumberOfUnits() == 0 &&
			m_pEnemyB.GetNumberOfUnits() == 0 &&
			m_pEnemyC.GetNumberOfUnits() == 0
			)
		{
			return DestroyedEnemies;
		}
		else
		{
			return DestroyEnemies;
		}
	}

	state DestroyedEnemies
	{
		SetGoalState(goalDestroyEnemies, goalAchieved);
		AddBriefing("translateBriefingMissionRUS_5_MissionComplete");

		EndMission(true);

		return MissionComplete;
	}

	state MissionComplete
	{
		return MissionComplete;
	}

	function int CheckDestroyedUnitsAndBuildings()
	{
		if ( state == MissionComplete ) return;

		if ( m_pPlayer.GetNumberOfUnits() == 0 && m_pPlayer.GetNumberOfBuildings() == 0 )
		{
			if ( state == BuildBase )
			{
				SetGoalState(goalBuildBase, goalFailed);
			}
			else if ( state == DestroyEnemyA )
			{
				SetGoalState(goalDestroyEnemyA, goalFailed);
			}
			else if ( state == DestroyEnemies )
			{
				SetGoalState(goalDestroyEnemies, goalFailed);
			}

			AddBriefing("translateBriefingMissionRUS_5_MissionFail");

			EnableEndMissionButton(true, false);

			state MissionComplete;
		}
	}

	event Timer0()
	{
		if ( m_bCheckDestroyedUnitsAndBuildings )
		{
			m_bCheckDestroyedUnitsAndBuildings = false;

			CheckDestroyedUnitsAndBuildings();
		}
	}

	event UnitDestroyed(unit uUnit)
	{
		m_bCheckNumberOfUnits = true;
		m_bCheckDestroyedUnitsAndBuildings = true;
	}

	event BuildingDestroyed(unit uBuilding)
	{
		m_bCheckNumberOfBuildings = true;
		m_bCheckDestroyedUnitsAndBuildings = true;
	}

	event SetupInterface()
	{
		EnableGameFeature
			(
			lockToolbarMoney |
			lockDisplayToolbarMoney |
			lockCreateBuildPanel |
			0, false);
	}
}
