mission "translateMissionRUS_6"
{
	consts
	{
		goalFindGeneralB = 0;
		goalWaitForGeneralsReady = 1;
		goalEvacuateGeneralA = 2;
		goalEvacuateGeneralB = 3;

		markerHero = 5;
		markerGeneralA = 1;
		markerGeneralADestination = 6;
		markerEnemyHelicopters = 0;
		markerGeneralB = 2;
		markerGeneralBEvacuationPoint = 4;
		markerHelicopter = 3;
		markerGeneralAEvacuationPoint = 7;
		markerBridge1 = 8;
		markerDetonator1 = 9;
		markerBridge2 = 10;
		markerDetonator2 = 12;
		markerEnemyUnits1 = 13;
		markerEnemyUnits2 = 14;
		markerEnemyUnits3 = 15;

		maskDetonator = 512;
	}

	include "Research.ech"

	player m_pPlayer;
	player m_pEnemy;
	player m_pFriendlyUnits;
	player m_pAllyUnits;

	player m_pSupportUnits;

	unitex m_uHero;
	unitex m_uGeneralA;
	unitex m_uGeneralB;
	unitex m_uHelicopter;

	int m_nTimeOfGeneralsReady;

	int m_bEvacuatedGeneralA;
	int m_bEvacuatedGeneralB;

	int m_bCheckNumberOfUnits;
	int m_bCheckNumberOfBuildings;

	int m_nHelicoptersAttack;
	int m_nUnitsAttack;

	int m_bCheckSupportUnits;

	function int EnemyAttack()
	{
		unitex uTmp;
		int nGx, nGy;

		int nMarker;

		if ( m_nHelicoptersAttack > 6 )
		{
			m_nHelicoptersAttack = 0;
		}

		if ( m_nHelicoptersAttack )
		{
			nGy = GetPointY(markerEnemyHelicopters) - ( m_nHelicoptersAttack - 1 );

			for ( nGx = GetPointX(markerEnemyHelicopters) - 1; nGx <= GetPointX(markerEnemyHelicopters) + 1; ++nGx )
			{
				uTmp = GetUnit(nGx, nGy);

				if ( uTmp )
				{
//					if ( m_nHelicoptersAttack % 2 )
//					{
						uTmp.CommandAttack(m_uGeneralA);
//					}
//					else
//					{
//						uTmp.CommandAttack(m_uGeneralB);
//					}
				}
			}

			++m_nHelicoptersAttack;
		}

		if ( m_nUnitsAttack > 3 )
		{
			m_nUnitsAttack = 0;
		}

		if ( m_nUnitsAttack )
		{
			nMarker = markerEnemyUnits1 + (m_nUnitsAttack - 1);

			for ( nGy = GetPointY(nMarker); nGy <= GetPointY(nMarker) + 2; ++nGy )
			{
				for ( nGx = GetPointX(nMarker); nGx <= GetPointX(nMarker) + 1; ++nGx )
				{
					uTmp = GetUnit(nGx, nGy);

					if ( uTmp )
					{
//						if ( m_nUnitsAttack % 2 )
//						{
							uTmp.CommandAttack(m_uGeneralA);
//						}
//						else
//						{
//							uTmp.CommandAttack(m_uGeneralB);
//						}
					}
				}
			}

			++m_nUnitsAttack;
		}
	}

	state Initialize;
	state Start;
	state BeforeStart;
	state FindGeneralB;
	state FoundGeneralB;
	state WaitForGeneralsReady;
	state GeneralsReady;
	state EvacuateGenerals;
	state EvacuatedGeneralA;
	state EvacuatedGeneralB;
	state EvacuatedGenerals;
	state MissionComplete;

	function int ClearMarkers(int nStartPoint, int nEndPoint)
	{
		int i;

		for ( i=nStartPoint; i<=nEndPoint; i=i+1 )
		{
			ClearArea (65535, GetPointX(i), GetPointY(i), GetPointZ(i), 0);
		}
	}

	function int ModifyDifficulty()
	{
		if ( GetDifficultyLevel() == 0 )
		{
			ClearMarkers (15, 15);
			ClearMarkers (20, 25);
			ClearArea (65535, GetPointX(26), GetPointY(26), GetPointZ(26), 1);
			ClearArea (65535, GetPointX(27), GetPointY(27), GetPointZ(27), 1);
		}
		else if ( GetDifficultyLevel() == 1 )
		{
			ClearMarkers (20, 21);
			ClearMarkers (23, 24);
			ClearArea (65535, GetPointX(26), GetPointY(26), GetPointZ(26), 1);
		}
		else if ( GetDifficultyLevel() == 2 )
		{
		}
	}

	state Initialize
	{
		ModifyDifficulty();

		RegisterGoal(goalFindGeneralB, "translateGoalMissionRUS_6_FindGeneralB");
		RegisterGoal(goalWaitForGeneralsReady, "translateGoalMissionRUS_6_WaitForGeneralsReady");
		RegisterGoal(goalEvacuateGeneralA, "translateGoalMissionRUS_6_EvacuateGeneralA");
		RegisterGoal(goalEvacuateGeneralB, "translateGoalMissionRUS_6_EvacuateGeneralB");

		m_nHelicoptersAttack = 0;
		m_nUnitsAttack = 0;

		m_bEvacuatedGeneralA = false;
		m_bEvacuatedGeneralB = false;

		m_pPlayer = GetPlayer(9);
		m_pPlayer.EnableStatistics(false);

		m_pEnemy = GetPlayer(1);
		m_pEnemy.EnableStatistics(false);

		m_pFriendlyUnits = GetPlayer(7);
		m_pFriendlyUnits.EnableStatistics(false);

		m_pAllyUnits = GetPlayer(8);
		m_pAllyUnits.EnableStatistics(false);

		m_pSupportUnits = GetPlayer(6);
		m_pSupportUnits.EnableStatistics(false);

		m_pFriendlyUnits.EnableAI(false);

		m_pAllyUnits.EnableAIFeatures(aiRejectAlliance, false);
		m_pAllyUnits.EnableAIFeatures2(ai2ChooseEnemy, false);
		m_pPlayer.SetAlly(m_pAllyUnits);
		m_pAllyUnits.EnableAI(false);

		m_pEnemy.EnableAI(false);

		m_uHero = GetUnit(GetPointX(markerHero), GetPointY(markerHero));
		m_uGeneralA = GetUnit(GetPointX(markerGeneralA), GetPointY(markerGeneralA));
		m_uGeneralB = GetUnit(GetPointX(markerGeneralB), GetPointY(markerGeneralB));
		m_uHelicopter = GetUnit(GetPointX(markerHelicopter), GetPointY(markerHelicopter));

		m_pPlayer.LookAt(m_pPlayer.GetStartingPointX(), m_pPlayer.GetStartingPointY(), 6, 0, 0, 0);

		EnableAllResearchRUS( m_pPlayer, false);
		m_pPlayer.EnableResearch("RES_RUS_AMPHIBIA1", true);			// M1
		m_pPlayer.EnableResearch("RES_RUS_ZSU", true);					// M2
		m_pPlayer.EnableResearch("RES_RUS_ASSAULT", true);				// M2
		m_pPlayer.EnableResearch("RES_RUS_PILLBOX", true);				// M3
		m_pPlayer.EnableResearch("RES_RUS_TANK", true);					// M3
		m_pPlayer.EnableResearch("RES_RUS_MIM", true);					// M3
		m_pPlayer.EnableResearch("RES_RUS_HELICOPTER1", true);			// M3
		m_pPlayer.EnableResearch("RES_RUS_AMMO_MG1", true);				// M4
		m_pPlayer.EnableResearch("RES_RUS_AMMO_CANNON1", true);			// M4
		m_pPlayer.EnableResearch("RES_RUS_SAPER", true);				// M4
		m_pPlayer.EnableResearch("RES_RUS_BM21", true);					// M4
		m_pPlayer.EnableResearch("RES_RUS_HELICOPTER2", true);			// M4
		m_pPlayer.EnableResearch("RES_RUS_AMMO_MG2", true);				// M5
		m_pPlayer.EnableResearch("RES_RUS_ART", true);					// M5
		m_pPlayer.EnableResearch("RES_RUS_AMMO_MGM1", true);			// M5
		m_pPlayer.EnableResearch("RES_RUS_SPECIAL_FILTER2", true);		// M5
		m_pPlayer.EnableResearch("RES_RUS_AMMO_CANNON2", true);
		m_pPlayer.EnableResearch("RES_RUS_AMMO_ART1", true);
		m_pPlayer.EnableResearch("RES_RUS_CHEMICAL1", true);
		m_pPlayer.EnableResearch("RES_RUS_AMMO_MGM2", true);
		m_pPlayer.EnableResearch("RES_RUS_SDI", true);
		m_pPlayer.EnableResearch("RES_RUS_SPECIAL_FILTER3", true);

		SetTimer(0, 20*20); // EnemyAttack

		m_pPlayer.EnableCommand(commandRecycleUnit, false);
		m_pPlayer.EnableCommand(commandSoldBuilding, false);

		return BeforeStart, 1;
	}

	state BeforeStart
	{
		PlayTrack("Music\\Briefing.tws");

		return Start;
	}

	event Timer0()
	{
		EnemyAttack();
	}

    state Start
	{
		EnableGoal(goalFindGeneralB, true);
		AddBriefing("translateBriefingMissionRUS_6_FindGeneralB");
		PlayWave("Briefings\\RUS_Briefing06.wav");

		m_uGeneralA.CommandEscort(m_uHero);

		m_pFriendlyUnits.EnableAIFeatures2(ai2ChooseEnemy, false);
		m_pAllyUnits.EnableAIFeatures2(ai2ChooseEnemy, false);
		m_pSupportUnits.EnableAIFeatures2(ai2ChooseEnemy, false);
		m_pEnemy.EnableAIFeatures2(ai2ChooseEnemy, false);

		m_pPlayer.SetNeutral(m_pFriendlyUnits);
		m_pFriendlyUnits.SetNeutral(m_pPlayer);

		m_pEnemy.SetEnemy(m_pFriendlyUnits);
		m_pEnemy.SetEnemy(m_pAllyUnits);
		m_pFriendlyUnits.SetEnemy(m_pEnemy);
		m_pAllyUnits.SetEnemy(m_pEnemy);

		m_pFriendlyUnits.SetNeutral(m_pAllyUnits);
		m_pAllyUnits.SetNeutral(m_pFriendlyUnits);

		m_pPlayer.SetNeutral(m_pSupportUnits);
		m_pSupportUnits.SetNeutral(m_pPlayer);

		m_bCheckSupportUnits = true;

		return FindGeneralB;
	}

	state FindGeneralB
	{
		if ( m_bCheckSupportUnits && m_pPlayer.IsPointLocated(m_pSupportUnits.GetStartingPointX(), m_pSupportUnits.GetStartingPointY()) )
		{
			m_pSupportUnits.GiveAllUnitsTo(m_pPlayer);

			m_bCheckSupportUnits = false;
		}

		if ( Distance(m_uGeneralA.GetLocationX(), m_uGeneralA.GetLocationY(), m_uGeneralB.GetLocationX(), m_uGeneralB.GetLocationY()) <= 3 )
		{
			return FoundGeneralB;
		}
		else
		{
			return FindGeneralB;
		}
	}

	state FoundGeneralB
	{
		if ( m_bCheckSupportUnits )
		{
			m_pSupportUnits.GiveAllUnitsTo(m_pPlayer);

			m_bCheckSupportUnits = false;
		}

		m_nHelicoptersAttack = 1;
		m_nUnitsAttack = 1;

		SetGoalState(goalFindGeneralB, goalAchieved);

		EnableGoal(goalWaitForGeneralsReady, true);
		AddBriefing("translateBriefingMissionRUS_6_WaitForGeneralsReady");

		m_uGeneralA.CommandMove(GetPointX(markerGeneralADestination), GetPointY(markerGeneralADestination), 0);
		m_uGeneralB.CommandMove(GetPointX(markerGeneralB), GetPointY(markerGeneralB), 0); // dla pewnosci

		m_nTimeOfGeneralsReady = GetMissionTime() + 60*20;

		CreateArtefact("ARTIFACT_DETONATOR", GetPointX(markerDetonator1), GetPointY(markerDetonator1), 0, maskDetonator|markerBridge1);
		CreateArtefact("ARTIFACT_DETONATOR", GetPointX(markerDetonator2), GetPointY(markerDetonator2), 0, maskDetonator|markerBridge2);

		AddWorldMapSign(GetPointX(markerDetonator1), GetPointY(markerDetonator1), 0, 1, 65000);
		AddWorldMapSign(GetPointX(markerDetonator2), GetPointY(markerDetonator2), 0, 1, 65000);

		return WaitForGeneralsReady;
	}

	state WaitForGeneralsReady
	{
		if ( GetMissionTime() >= m_nTimeOfGeneralsReady )
		{
			return GeneralsReady;
		}
		else
		{
			return WaitForGeneralsReady;
		}
	}

	state GeneralsReady
	{
		SetGoalState(goalWaitForGeneralsReady, goalAchieved);

		EnableGoal(goalEvacuateGeneralA, true);
		EnableGoal(goalEvacuateGeneralB, true);
		AddBriefing("translateBriefingMissionRUS_6_EvacuateGenerals");

//		m_uGeneralB.CommandMove(GetPointX(markerGeneralBEvacuationPoint), GetPointY(markerGeneralBEvacuationPoint), 0);
		m_uGeneralA.CommandEscort(m_uHero);

		AddWorldMapSign(GetPointX(markerGeneralAEvacuationPoint), GetPointY(markerGeneralAEvacuationPoint), 0, 0, 65000);
		AddWorldMapSign(GetPointX(markerGeneralBEvacuationPoint), GetPointY(markerGeneralBEvacuationPoint), 0, 0, 65000);

		return EvacuateGenerals;
	}

	state EvacuateGenerals
	{
		if ( m_bEvacuatedGeneralA && m_bEvacuatedGeneralB )
		{
			return EvacuatedGenerals;
		}

		if ( !m_bEvacuatedGeneralA && Distance(m_uGeneralA.GetLocationX(), m_uGeneralA.GetLocationY(), GetPointX(markerGeneralAEvacuationPoint), GetPointY(markerGeneralAEvacuationPoint)) <= 4 )
		{
			m_uGeneralA.BeginQuickRecord();
			m_uGeneralA.CommandMove(GetPointX(markerGeneralAEvacuationPoint), GetPointY(markerGeneralAEvacuationPoint), 0);
			m_uGeneralA.CommandEscort(m_uHero);
			m_uGeneralA.EndQuickRecord();

			return EvacuatedGeneralA, 60;
		}

		if ( !m_bEvacuatedGeneralB && Distance(m_uGeneralA.GetLocationX(), m_uGeneralA.GetLocationY(), GetPointX(markerGeneralBEvacuationPoint), GetPointY(markerGeneralBEvacuationPoint)) <= 4 )
		{
			m_uGeneralA.BeginQuickRecord();
			m_uGeneralA.CommandMove(GetPointX(markerGeneralBEvacuationPoint), GetPointY(markerGeneralBEvacuationPoint), 0);
			m_uGeneralA.CommandEscort(m_uHero);
			m_uGeneralA.EndQuickRecord();

			return EvacuatedGeneralB, 60;
		}

		return EvacuateGenerals;
	}

	state EvacuatedGeneralA
	{
		SetGoalState(goalEvacuateGeneralA, goalAchieved);

		if ( !m_bEvacuatedGeneralB )
		{
			AddBriefing("translateBriefingMissionRUS_6_EvacuatedGeneralA");
		}

		RemoveWorldMapSign(GetPointX(markerGeneralAEvacuationPoint), GetPointY(markerGeneralAEvacuationPoint), 0);

		m_bEvacuatedGeneralA = true;

		return EvacuateGenerals;
	}

	state EvacuatedGeneralB
	{
		SetGoalState(goalEvacuateGeneralB, goalAchieved);

		if ( !m_bEvacuatedGeneralA )
		{
			AddBriefing("translateBriefingMissionRUS_6_EvacuatedGeneralB");
		}

		RemoveWorldMapSign(GetPointX(markerGeneralBEvacuationPoint), GetPointY(markerGeneralBEvacuationPoint), 0);

		m_uHelicopter.CommandRecycleUnit();

		m_bEvacuatedGeneralB = true;

		return EvacuateGenerals;
	}

	state EvacuatedGenerals
	{
		AddBriefing("translateBriefingMissionRUS_6_MissionComplete");

		EndMission(true);

		return MissionComplete;
	}

	state MissionComplete
	{
		return MissionComplete;
	}

	function int MissionFail()
	{
		if ( state == FindGeneralB )
		{
			SetGoalState(goalFindGeneralB, goalFailed);
		}
		else if ( state == WaitForGeneralsReady )
		{
			SetGoalState(goalWaitForGeneralsReady, goalFailed);
		}
		else
		{
			if ( !m_bEvacuatedGeneralA )
			{
				SetGoalState(goalEvacuateGeneralA, goalFailed);
			}

			if ( !m_bEvacuatedGeneralB )
			{
				SetGoalState(goalEvacuateGeneralB, goalFailed);
			}
		}

		AddBriefing("translateBriefingMissionRUS_6_MissionFail");

		EnableEndMissionButton(true, false);

		state MissionComplete;
	}

	event UnitDestroyed(unit uUnit)
	{
		m_bCheckNumberOfUnits = true;

		if ( uUnit == m_uHero )
		{
			MissionFail();
		}
		else if ( state != MissionComplete && uUnit == m_uGeneralA )
		{
			MissionFail();
		}
/*
		else if ( uUnit == m_uGeneralB && !m_bEvacuatedGeneralB )
		{
			AddBriefing("translateBriefingMissionRUS_6_MissionFail");

			EnableEndMissionButton(true, false);

			state MissionComplete;
		}
*/
	}

	event BuildingDestroyed(unit uBuilding)
	{
		m_bCheckNumberOfBuildings = true;
	}

	event Artefact(int nArtefactNum, player pPlayerOnArtefact)
	{
		int nMarker;

		if ( pPlayerOnArtefact != m_pPlayer )
		{
			return false;
		}

		if ( nArtefactNum & maskDetonator )
		{
			nMarker = ~maskDetonator & nArtefactNum;

			if ( nMarker == markerBridge1 )
			{
				RemoveWorldMapSign(GetPointX(markerDetonator1), GetPointY(markerDetonator1), 0);
			}
			else if ( nMarker == markerBridge2 )
			{
				RemoveWorldMapSign(GetPointX(markerDetonator2), GetPointY(markerDetonator2), 0);
			}

			KillArea(65535, GetPointX(nMarker), GetPointY(nMarker), GetPointZ(nMarker), 3);
		}

		true; // kasujemy ten do ktorego dojechal.
	}

	event SetupInterface()
	{
		EnableGameFeature
			(
			lockResearchDialog |
			lockToolbarResearching |
			lockToolbarMoney |
			lockDisplayToolbarMoney |
			lockCreateBuildPanel |
			0, true);
	}
}
