mission "translateMissionRUS_7"
{
	consts
	{
		goalCaptureCivilCar = 0;
		goalCaptureBoat = 1;
		goalCaptureJeep = 2;
		goalFindFriend = 3;
		goalFindCommandCenter = 4;
		goalFindSafeArea = 5;

		markerBTR = 0;
		markerCivilCar = 1;
		markerBoat = 3;
		markerJeep = 5;
		markerFriend = 6;

		markerMineAFirst = 7;
		markerMineALast = 9;
		markerMineBFirst = 10;
		markerMineBLast = 11;

		marker4FriendlyUnitsA = 12;
		marker4FriendlyUnitsB = 13;

		markerCommandCenter = 14;

		markerMineCFirst = 15;
		markerMineCLast = 17;

		markerBrigdeArea = 18;
		markerSafeArea = 19;

		maskDetonator = 512;
	}

	include "Research.ech"

	player m_pPlayer;

	player m_pFriend;

	player m_pEnemyA;
	player m_pEnemyB;

	unitex m_uBTR;
	unitex m_uCivilCar;
	unitex m_uBoat;
	unitex m_uJeep;
	unitex m_uFriend;

	int m_bCheckBTR;
	int m_bCheckCivilCar;
	int m_bCheckBoat;
	int m_bCheckJeep;
	int m_bCheckFriend;

	unitex m_uFriendlyUnitA1;
	unitex m_uFriendlyUnitA2;
	unitex m_uFriendlyUnitA3;
	unitex m_uFriendlyUnitA4;

	unitex m_uFriendlyUnitB1;
	unitex m_uFriendlyUnitB2;
	unitex m_uFriendlyUnitB3;
	unitex m_uFriendlyUnitB4;

	int m_bCheckNumberOfUnits;
	int m_bCheckNumberOfBuildings;

	int m_bCheckDestroyedUnits;

	state Initialize;
	state Start;
	state BeforeStart;
	state CaptureCivilCar;
	state CapturedCivilCar;
	state CaptureBoat;
	state CapturedBoat;
	state CaptureJeep;
	state CapturedJeep;
	state FindFriend;
	state FoundFriend;
	state FindCommandCenter;
	state FoundCommandCenter;
	state FindBridgeArea;
	state FoundBridgeArea;
	state FindSafeArea;
	state FoundSafeArea;
	state MissionComplete;

	function int CreateMines()
	{
		int i;

		for ( i=markerMineAFirst; i<=markerMineALast; ++i )
		{
			CreateArtefact("ARTIFACT_INVISIBLE", GetPointX(i), GetPointY(i), 0, maskDetonator|i);
		}

		for ( i=markerMineBFirst; i<=markerMineBLast; ++i )
		{
			CreateArtefact("ARTIFACT_INVISIBLE", GetPointX(i), GetPointY(i), 0, maskDetonator|i);
		}

		for ( i=markerMineCFirst; i<=markerMineCLast; ++i )
		{
			CreateArtefact("ARTIFACT_INVISIBLE", GetPointX(i), GetPointY(i), 0, maskDetonator|i);
		}
	}

	function int ModifyDifficulty()
	{
		if ( GetDifficultyLevel() == 0 )
		{
			ClearArea (65535, GetPointX(20), GetPointY(20), GetPointZ(20), 0);
			ClearArea (65535, GetPointX(21), GetPointY(21), GetPointZ(21), 0);
			ClearArea (65535, GetPointX(22), GetPointY(22), GetPointZ(22), 1);
			ClearArea (65535, GetPointX(23), GetPointY(23), GetPointZ(23), 0);
			ClearArea (65535, GetPointX(24), GetPointY(24), GetPointZ(24), 0);
			ClearArea (65535, GetPointX(25), GetPointY(25), GetPointZ(25), 0);
			ClearArea (65535, GetPointX(26), GetPointY(26), GetPointZ(26), 0);
		}
		else if ( GetDifficultyLevel() == 1 )
		{
			ClearArea (65535, GetPointX(21), GetPointY(21), GetPointZ(21), 0);
			ClearArea (65535, GetPointX(22), GetPointY(22), GetPointZ(22), 1);
			ClearArea (65535, GetPointX(23), GetPointY(23), GetPointZ(23), 0);
			ClearArea (65535, GetPointX(24), GetPointY(24), GetPointZ(24), 0);
			ClearArea (65535, GetPointX(25), GetPointY(25), GetPointZ(25), 0);
		}
		else if ( GetDifficultyLevel() == 2 )
		{
		}
	}

	state Initialize
	{
		ModifyDifficulty();

		CreateMines();

		RegisterGoal(goalCaptureCivilCar, "translateGoalMissionRUS_7_CaptureCivilCar");
		RegisterGoal(goalCaptureBoat, "translateGoalMissionRUS_7_CaptureBoat");
		RegisterGoal(goalCaptureJeep, "translateGoalMissionRUS_7_CaptureJeep");
		RegisterGoal(goalFindFriend, "translateGoalMissionRUS_7_FindFriend");
		RegisterGoal(goalFindCommandCenter, "translateGoalMissionRUS_7_FindCommandCenter");
		RegisterGoal(goalFindSafeArea, "translateGoalMissionRUS_7_FindSafeArea");

		m_pPlayer = GetPlayer(9);
		m_pPlayer.EnableStatistics(false);

		m_pFriend = GetPlayer(0);
		m_pFriend.EnableStatistics(false);

		m_pEnemyA = GetPlayer(1);
		m_pEnemyA.EnableStatistics(false);
		m_pEnemyB = GetPlayer(2);
		m_pEnemyB.EnableStatistics(false);

		m_pFriend.EnableAI(false);

		m_pEnemyA.EnableAI(false);
		m_pEnemyB.EnableAI(false);

		m_uBTR = GetUnit(GetPointX(markerBTR), GetPointY(markerBTR));
		m_uCivilCar = GetUnit(GetPointX(markerCivilCar), GetPointY(markerCivilCar));
		m_uCivilCar.SetUnitName("translateRUSHeroName_Empty");
		m_uBoat = GetUnit(GetPointX(markerBoat), GetPointY(markerBoat));
		m_uBoat.SetUnitName("translateRUSHeroName_Empty");
		m_uJeep = GetUnit(GetPointX(markerJeep), GetPointY(markerJeep));
		m_uJeep.SetUnitName("translateRUSHeroName_Empty");
		m_uFriend = GetUnit(GetPointX(markerFriend), GetPointY(markerFriend));

		m_uFriendlyUnitA1 = GetUnit(GetPointX(marker4FriendlyUnitsA), GetPointY(marker4FriendlyUnitsA)+0);
		m_uFriendlyUnitA2 = GetUnit(GetPointX(marker4FriendlyUnitsA), GetPointY(marker4FriendlyUnitsA)+1);
		m_uFriendlyUnitA3 = GetUnit(GetPointX(marker4FriendlyUnitsA), GetPointY(marker4FriendlyUnitsA)+2);
		m_uFriendlyUnitA4 = GetUnit(GetPointX(marker4FriendlyUnitsA), GetPointY(marker4FriendlyUnitsA)+3);

		m_uFriendlyUnitB1 = GetUnit(GetPointX(marker4FriendlyUnitsB), GetPointY(marker4FriendlyUnitsB)+0);
		m_uFriendlyUnitB2 = GetUnit(GetPointX(marker4FriendlyUnitsB), GetPointY(marker4FriendlyUnitsB)+1);
		m_uFriendlyUnitB3 = GetUnit(GetPointX(marker4FriendlyUnitsB), GetPointY(marker4FriendlyUnitsB)+2);
		m_uFriendlyUnitB4 = GetUnit(GetPointX(marker4FriendlyUnitsB), GetPointY(marker4FriendlyUnitsB)+3);

		m_pPlayer.LookAt(m_pPlayer.GetStartingPointX(), m_pPlayer.GetStartingPointY(), 6, 0, 0, 0);

		m_bCheckBTR = true;
		m_bCheckCivilCar = true;
		m_bCheckBoat = true;
		m_bCheckJeep = true;
		m_bCheckFriend = true;

		EnableAllResearchRUS( m_pPlayer, false);
		m_pPlayer.EnableResearch("RES_RUS_AMPHIBIA1", true);			// M1
		m_pPlayer.EnableResearch("RES_RUS_ZSU", true);					// M2
		m_pPlayer.EnableResearch("RES_RUS_ASSAULT", true);				// M2
		m_pPlayer.EnableResearch("RES_RUS_PILLBOX", true);				// M3
		m_pPlayer.EnableResearch("RES_RUS_TANK", true);					// M3
		m_pPlayer.EnableResearch("RES_RUS_MIM", true);					// M3
		m_pPlayer.EnableResearch("RES_RUS_HELICOPTER1", true);			// M3
		m_pPlayer.EnableResearch("RES_RUS_AMMO_MG1", true);				// M4
		m_pPlayer.EnableResearch("RES_RUS_AMMO_CANNON1", true);			// M4
		m_pPlayer.EnableResearch("RES_RUS_SAPER", true);				// M4
		m_pPlayer.EnableResearch("RES_RUS_BM21", true);					// M4
		m_pPlayer.EnableResearch("RES_RUS_HELICOPTER2", true);			// M4
		m_pPlayer.EnableResearch("RES_RUS_AMMO_MG2", true);				// M5
		m_pPlayer.EnableResearch("RES_RUS_ART", true);					// M5
		m_pPlayer.EnableResearch("RES_RUS_AMMO_MGM1", true);			// M5
		m_pPlayer.EnableResearch("RES_RUS_SPECIAL_FILTER2", true);		// M5
		m_pPlayer.EnableResearch("RES_RUS_AMMO_CANNON2", true);			// M6
		m_pPlayer.EnableResearch("RES_RUS_AMMO_ART1", true);			// M6
		m_pPlayer.EnableResearch("RES_RUS_CHEMICAL1", true);			// M6
		m_pPlayer.EnableResearch("RES_RUS_AMMO_MGM2", true);			// M6
		m_pPlayer.EnableResearch("RES_RUS_SDI", true);					// M6
		m_pPlayer.EnableResearch("RES_RUS_SPECIAL_FILTER3", true);		// M6
		m_pPlayer.EnableResearch("RES_RUS_AMMO_ART2", true);
		m_pPlayer.EnableResearch("RES_RUS_AMMO_ROCKET1", true);
		m_pPlayer.EnableResearch("RES_RUS_AMMO_CHEMICAL1", true);
		m_pPlayer.EnableResearch("RES_RUS_ROCKETCONTROL", true);
		m_pPlayer.EnableResearch("RES_RUS_ROMB", true);
		m_pPlayer.EnableResearch("RES_RUS_AIRCONTROL", true);
		m_pPlayer.EnableResearch("RES_RUS_SPECIAL_PTC", true);

		SetTimer(0, 100); // CheckDestroyedUnits

		m_pPlayer.EnableCommand(commandRecycleUnit, false);
		m_pPlayer.EnableCommand(commandSoldBuilding, false);

		return BeforeStart, 1;
	}

	state BeforeStart
	{
		PlayTrack("Music\\Briefing.tws");

		return Start;
	}

    state Start
	{
		m_pFriend.SetNeutral(m_pPlayer);
		m_pPlayer.SetNeutral(m_pFriend);

		m_pEnemyA.SetNeutral(m_pFriend);
		m_pEnemyB.SetNeutral(m_pFriend);
		m_pFriend.SetNeutral(m_pEnemyA);
		m_pFriend.SetNeutral(m_pEnemyB);

		EnableGoal(goalCaptureCivilCar, true);
		AddBriefing("translateBriefingMissionRUS_7_CaptureCivilCar");
		PlayWave("Briefings\\RUS_Briefing07.wav");

		AddWorldMapSign(GetPointX(markerCivilCar), GetPointY(markerCivilCar), 0, 0, 65000);

		return CaptureCivilCar;
	}

	state CaptureCivilCar
	{
		if ( Distance(m_uCivilCar.GetLocationX(), m_uCivilCar.GetLocationY(), m_uBTR.GetLocationX(), m_uBTR.GetLocationY()) <= 1 )
		{
			return CapturedCivilCar;
		}
		else
		{
			return CaptureCivilCar;
		}
	}

	state CapturedCivilCar
	{
		RemoveWorldMapSign(GetPointX(markerCivilCar), GetPointY(markerCivilCar), 0);

		m_uBTR.ChangePlayer(m_pFriend);
		m_uBTR.SetUnitName("translateRUSHeroName_Empty");

		m_uCivilCar.ChangePlayer(m_pPlayer);
		m_uCivilCar.SetUnitName(null);

		m_bCheckBTR = false;

		m_pEnemyB.SetNeutral(m_pPlayer);

		SetGoalState(goalCaptureCivilCar, goalAchieved);

		EnableGoal(goalCaptureBoat, true);
		AddBriefing("translateBriefingMissionRUS_7_CaptureBoat");

		AddWorldMapSign(GetPointX(markerBoat), GetPointY(markerBoat), 0, 0, 65000);

		return CaptureBoat;
	}

	state CaptureBoat
	{
		if ( Distance(m_uBoat.GetLocationX(), m_uBoat.GetLocationY(), m_uCivilCar.GetLocationX(), m_uCivilCar.GetLocationY()) <= 2 )
		{
			return CapturedBoat;
		}
		else
		{
			return CaptureBoat;
		}
	}

	state CapturedBoat
	{
		RemoveWorldMapSign(GetPointX(markerBoat), GetPointY(markerBoat), 0);

		m_uCivilCar.ChangePlayer(m_pFriend);
		m_uCivilCar.SetUnitName("translateRUSHeroName_Empty");

		m_uBoat.ChangePlayer(m_pPlayer);
		m_uBoat.SetUnitName(null);

		m_bCheckCivilCar = false;

		SetGoalState(goalCaptureBoat, goalAchieved);

		EnableGoal(goalCaptureJeep, true);
		AddBriefing("translateBriefingMissionRUS_7_CaptureJeep");

		AddWorldMapSign(GetPointX(markerJeep), GetPointY(markerJeep), 0, 0, 65000);

		return CaptureJeep;
	}

	state CaptureJeep
	{
		if ( Distance(m_uJeep.GetLocationX(), m_uJeep.GetLocationY(), m_uBoat.GetLocationX(), m_uBoat.GetLocationY()) <= 2 )
		{
			return CapturedJeep;
		}
		else
		{
			return CaptureJeep;
		}
	}

	state CapturedJeep
	{
		RemoveWorldMapSign(GetPointX(markerJeep), GetPointY(markerJeep), 0);

		m_uBoat.ChangePlayer(m_pFriend);
		m_uBoat.SetUnitName("translateRUSHeroName_Empty");

		m_uJeep.ChangePlayer(m_pPlayer);
		m_uJeep.SetUnitName(null);

		m_bCheckBoat = false;

		m_pEnemyB.SetEnemy(m_pPlayer);

		SetGoalState(goalCaptureJeep, goalAchieved);

		EnableGoal(goalFindFriend, true);
		AddBriefing("translateBriefingMissionRUS_7_FindFriend");

		AddWorldMapSign(GetPointX(markerFriend), GetPointY(markerFriend), 0, 0, 65000);

		return FindFriend;
	}

	state FindFriend
	{
		if ( Distance(m_uFriend.GetLocationX(), m_uFriend.GetLocationY(), m_uJeep.GetLocationX(), m_uJeep.GetLocationY()) <= 1 )
		{
			return FoundFriend;
		}
		else
		{
			return FindFriend;
		}
	}

	state FoundFriend
	{
		int nSafePassageA, nSafePassageB;

		RemoveWorldMapSign(GetPointX(markerFriend), GetPointY(markerFriend), 0);

		SetGoalState(goalFindFriend, goalAchieved);

		EnableGoal(goalFindCommandCenter, true);
		AddBriefing("translateBriefingMissionRUS_7_FindCommandCenter");

		AddWorldMapSign(GetPointX(markerCommandCenter), GetPointY(markerCommandCenter), 0, 0, 65000);

		nSafePassageA = markerMineAFirst + Rand(markerMineALast - markerMineAFirst + 1);
		nSafePassageB = markerMineBFirst + Rand(markerMineBLast - markerMineBFirst + 1);

		RemoveArtefact(GetPointX(nSafePassageA), GetPointY(nSafePassageA), 0);
		RemoveArtefact(GetPointX(nSafePassageB), GetPointY(nSafePassageB), 0);

		m_uFriend.BeginQuickRecord();
		m_uFriend.CommandMove(GetPointX(nSafePassageA+20), GetPointY(nSafePassageA+20), 0);
		m_uFriend.CommandMove(GetPointX(nSafePassageA), GetPointY(nSafePassageA), 0);
		m_uFriend.CommandMove(GetPointX(nSafePassageB+20), GetPointY(nSafePassageB+20), 0);
		m_uFriend.CommandMove(GetPointX(nSafePassageB), GetPointY(nSafePassageB), 0);
		m_uFriend.CommandMove(GetPointX(markerCommandCenter), GetPointY(markerCommandCenter), 0);
		m_uFriend.EndQuickRecord();

		return FindCommandCenter;
	}

	state FindCommandCenter
	{
		if ( Distance(m_uJeep.GetLocationX(), m_uJeep.GetLocationY(), GetPointX(markerCommandCenter), GetPointY(markerCommandCenter)) <= 1 )
		{
			return FoundCommandCenter;
		}
		else
		{
			return FindCommandCenter;
		}
	}

	state FoundCommandCenter
	{
		m_bCheckFriend = false;

		RemoveWorldMapSign(GetPointX(markerCommandCenter), GetPointY(markerCommandCenter), 0);

		m_pPlayer.SetAlly(m_pFriend);

		m_uFriendlyUnitA1.ChangePlayer(m_pPlayer);
		m_uFriendlyUnitA2.ChangePlayer(m_pPlayer);
		m_uFriendlyUnitA3.ChangePlayer(m_pPlayer);
		m_uFriendlyUnitA4.ChangePlayer(m_pPlayer);

		m_uFriendlyUnitB1.ChangePlayer(m_pPlayer);
		m_uFriendlyUnitB2.ChangePlayer(m_pPlayer);
		m_uFriendlyUnitB3.ChangePlayer(m_pPlayer);
		m_uFriendlyUnitB4.ChangePlayer(m_pPlayer);

		SetGoalState(goalFindCommandCenter, goalAchieved);

		EnableGoal(goalFindSafeArea, true);
		AddBriefing("translateBriefingMissionRUS_7_FindBridgeArea");

		AddWorldMapSign(GetPointX(markerBTR), GetPointY(markerBTR), 0, 0, 65000);

		return FindBridgeArea;
	}

	state FindBridgeArea
	{
		if ( m_uJeep.GetLocationX() < GetPointX(markerBrigdeArea) )
		{
			return FoundBridgeArea;
		}
		else
		{
			return FindBridgeArea;
		}
	}

	state FoundBridgeArea
	{
		m_uFriendlyUnitA1.ChangePlayer(m_pFriend);
		m_uFriendlyUnitA2.ChangePlayer(m_pFriend);
		m_uFriendlyUnitA3.ChangePlayer(m_pFriend);
		m_uFriendlyUnitA4.ChangePlayer(m_pFriend);

		m_uFriendlyUnitB1.ChangePlayer(m_pFriend);
		m_uFriendlyUnitB2.ChangePlayer(m_pFriend);
		m_uFriendlyUnitB3.ChangePlayer(m_pFriend);
		m_uFriendlyUnitB4.ChangePlayer(m_pFriend);

		m_uFriendlyUnitA1.CommandMove(GetPointX(marker4FriendlyUnitsA), GetPointY(marker4FriendlyUnitsA)+0, 0);
		m_uFriendlyUnitA2.CommandMove(GetPointX(marker4FriendlyUnitsA), GetPointY(marker4FriendlyUnitsA)+1, 0);
		m_uFriendlyUnitA3.CommandMove(GetPointX(marker4FriendlyUnitsA), GetPointY(marker4FriendlyUnitsA)+2, 0);
		m_uFriendlyUnitA4.CommandMove(GetPointX(marker4FriendlyUnitsA), GetPointY(marker4FriendlyUnitsA)+3, 0);

		m_uFriendlyUnitB1.CommandMove(GetPointX(marker4FriendlyUnitsB), GetPointY(marker4FriendlyUnitsB)+0, 0);
		m_uFriendlyUnitB2.CommandMove(GetPointX(marker4FriendlyUnitsB), GetPointY(marker4FriendlyUnitsB)+1, 0);
		m_uFriendlyUnitB3.CommandMove(GetPointX(marker4FriendlyUnitsB), GetPointY(marker4FriendlyUnitsB)+2, 0);
		m_uFriendlyUnitB4.CommandMove(GetPointX(marker4FriendlyUnitsB), GetPointY(marker4FriendlyUnitsB)+3, 0);

		AddBriefing("translateBriefingMissionRUS_7_FindSafeArea");

		return FindSafeArea;
	}

	state FindSafeArea
	{
		if ( m_uJeep.GetLocationX() < GetPointX(markerSafeArea) && m_uJeep.GetLocationY() < GetPointY(markerSafeArea))
		{
			return FoundSafeArea;
		}
		else
		{
			return FindSafeArea;
		}
	}

	state FoundSafeArea
	{
		RemoveWorldMapSign(GetPointX(markerBTR), GetPointY(markerBTR), 0);

		SetGoalState(goalFindSafeArea, goalAchieved);

		AddBriefing("translateBriefingMissionRUS_7_MissionComplete");

		EnableEndMissionButton(true, true);

		return MissionComplete;
	}

	state MissionComplete
	{
		return MissionComplete;
	}

	function int MissionFail()
	{
		if ( state == CaptureCivilCar )
		{
			SetGoalState(goalCaptureCivilCar, goalFailed);
		}
		else if ( state == CaptureBoat )
		{
			SetGoalState(goalCaptureBoat, goalFailed);
		}
		else if ( state == CaptureJeep )
		{
			SetGoalState(goalCaptureJeep, goalFailed);
		}
		else if ( state == FindFriend )
		{
			SetGoalState(goalFindFriend, goalFailed);
		}
		else if ( state == FindCommandCenter )
		{
			SetGoalState(goalFindCommandCenter, goalFailed);
		}
		else if ( state == FindBridgeArea || state == FindSafeArea )
		{
			SetGoalState(goalFindSafeArea, goalFailed);
		}

		AddBriefing("translateBriefingMissionRUS_7_MissionFail");

		EnableEndMissionButton(true, false);

		state MissionComplete;
	}

	function int CheckDestroyedUnits()
	{
		if ( state == MissionComplete ) return;

		if ( m_bCheckBTR && !m_uBTR.IsLive() )
		{
			MissionFail();
		}
		else if ( m_bCheckCivilCar && !m_uCivilCar.IsLive() )
		{
			MissionFail();
		}
		else if ( m_bCheckBoat && !m_uBoat.IsLive() )
		{
			MissionFail();
		}
		else if ( m_bCheckJeep && !m_uJeep.IsLive() )
		{
			MissionFail();
		}
		else if ( m_bCheckFriend && !m_uFriend.IsLive() )
		{
			MissionFail();
		}
	}

	event Timer0()
	{
		if ( m_bCheckDestroyedUnits )
		{
			m_bCheckDestroyedUnits = false;

			CheckDestroyedUnits();
		}
	}

	event UnitDestroyed(unit uUnit)
	{
		m_bCheckNumberOfUnits = true;
		m_bCheckDestroyedUnits = true;
	}

	event BuildingDestroyed(unit uBuilding)
	{
		m_bCheckNumberOfBuildings = true;
//		m_bCheckDestroyedUnits = true;
	}

	event Artefact(int nArtefactNum, player pPlayerOnArtefact)
	{
		int nMarker;

		if ( nArtefactNum & maskDetonator )
		{
			nMarker = ~maskDetonator & nArtefactNum;

			KillArea(65535, GetPointX(nMarker), GetPointY(nMarker), 0, 2);
		}

		true; // kasujemy ten do ktorego dojechal.
	}

	event EndMission()
	{
		m_pPlayer.EnableCommand(commandRecycleUnit, true);
		m_pPlayer.EnableCommand(commandSoldBuilding, true);
	}

	event SetupInterface()
	{
	}
}
