mission "translateMissionRUS_8"
{
	consts
	{
		goalCaptureRafinery = 0;
		goalDestroyBombControl = 1;

		markerHero = 0;
		markerRafineryControl = 1;
		markerCriticalBuilding1 = 2;
		markerCriticalBuilding2 = 3;
		markerBuildingFirst = 4;
		markerBuildingLast = 17;
		markerAirControlBuildingFirst = 22;
		markerAirControlBuildingLast = 22;
	}

	include "Varia.ech"
	include "Buildings.ech"
	include "Research.ech"
	include "UnitTemplates.ech"

	player m_pPlayer;
	player m_pEnemy;
	player m_pAirControl;
	player m_pRafinery;
	player m_pRafinerySupport;
	player m_pRafineryControl;

	unitex m_uRafineryControl;
	unitex m_uCriticalBuilding1;
	unitex m_uCriticalBuilding2;

	unitex m_uHero;

	int m_bCheckNumberOfUnits;
	int m_bCheckNumberOfBuildings;

	int m_bCheckDestroyedUnitsAndBuildings;

	int m_bMissionFail;

	int m_nTimeOfBombingAttack;

	state Initialize;
	state Start;
	state BeforeStart;
	state CaptureRafinery;
	state CapturedRafinery;
	state DestroyAirControl;
	state DestroyedAirControl;
	state MissionComplete;

	function int ClearMarkers(int nStartPoint, int nEndPoint)
	{
		int i;

		for ( i=nStartPoint; i<=nEndPoint; i=i+1 )
		{
			ClearArea (65535, GetPointX(i), GetPointY(i), GetPointZ(i), 0);
		}
	}

	function int ModifyDifficulty()
	{
		if ( GetDifficultyLevel() == 0 )
		{
			ClearMarkers (14, 14);
			ClearMarkers (16, 16);
			ClearMarkers (24, 49);
			ClearMarkers (51, 100);
			ClearArea (65535, GetPointX(35), GetPointY(35), GetPointZ(35), 1);
		}
		else if ( GetDifficultyLevel() == 1 )
		{
			ClearMarkers (24, 24);
			ClearMarkers (28, 29);
			ClearMarkers (33, 34);
			ClearMarkers (38, 39);
			ClearMarkers (44, 47);
			ClearMarkers (52, 53);
			ClearMarkers (54, 54);
			ClearMarkers (101, 104);
		}
		else if ( GetDifficultyLevel() == 2 )
		{
			ClearMarkers (50, 51);
			ClearMarkers (55, 55);
			ClearMarkers (101, 111);
		}
	}

	state Initialize
	{
		ModifyDifficulty();

		RegisterGoal(goalCaptureRafinery, "translateGoalMissionRUS_8_CaptureRafinery");
		RegisterGoal(goalDestroyBombControl, "translateGoalMissionRUS_8_DestroyBombControl");

		m_pPlayer = GetPlayer(9);
		m_pPlayer.EnableStatistics(true);

		m_pEnemy = GetPlayer(0);
		m_pEnemy.EnableStatistics(true);

		m_pAirControl = GetPlayer(1);
		m_pAirControl.EnableStatistics(false);

		m_pRafinery = GetPlayer(3);
		m_pRafinery.EnableStatistics(false);

		m_pRafinerySupport = GetPlayer(2);
		m_pRafinerySupport.EnableStatistics(false);

		m_pRafineryControl = GetPlayer(4);
		m_pRafineryControl.EnableStatistics(false);

//		if ( GetDifficultyLevel() == 0 )
//		{
//			m_pEnemy.LoadScript("single\\singleEasy");
//		}
//		else if ( GetDifficultyLevel() == 1 )
//		{
//			m_pEnemy.LoadScript("single\\singleMedium");
//		}
//		else if ( GetDifficultyLevel() == 2 )
//		{
			m_pEnemy.LoadScript("single\\singleHard");
//		}

		m_pAirControl.EnableAI(false);
		m_pRafinery.EnableAI(false);
		m_pRafinerySupport.EnableAI(false);
		m_pRafineryControl.EnableAI(false);

		m_pPlayer.SetNeutral(m_pRafineryControl);

		m_uHero = GetUnit(GetPointX(markerHero), GetPointY(markerHero));

		m_uRafineryControl = GetUnit(GetPointX(markerRafineryControl), GetPointY(markerRafineryControl));
		m_uCriticalBuilding1 = GetUnit(GetPointX(markerCriticalBuilding1), GetPointY(markerCriticalBuilding1));
		m_uCriticalBuilding2 = GetUnit(GetPointX(markerCriticalBuilding2), GetPointY(markerCriticalBuilding2));

		if ( GetDifficultyLevel() == 0 )
		{
			m_pPlayer.SetMoney(5000);
		}
		else if ( GetDifficultyLevel() == 1 )
		{
			m_pPlayer.SetMoney(3500);
		}
		else if ( GetDifficultyLevel() == 2 )
		{
			m_pPlayer.SetMoney(2500);
		}

		EnableAllBuildingsRUS(m_pPlayer, false);
	    m_pPlayer.EnableBuilding("RUS_GENERATOR", true);
	    m_pPlayer.EnableBuilding("RUS_SUPPLYCENTER", true);

		m_pPlayer.LookAt(m_pPlayer.GetStartingPointX(), m_pPlayer.GetStartingPointY(), 6, 0, 0, 0);

		EnableAllResearchRUS( m_pPlayer, false);
		m_pPlayer.EnableResearch("RES_RUS_AMPHIBIA1", true);			// M1
		m_pPlayer.EnableResearch("RES_RUS_ZSU", true);					// M2
		m_pPlayer.EnableResearch("RES_RUS_ASSAULT", true);				// M2
		m_pPlayer.EnableResearch("RES_RUS_PILLBOX", true);				// M3
		m_pPlayer.EnableResearch("RES_RUS_TANK", true);					// M3
		m_pPlayer.EnableResearch("RES_RUS_MIM", true);					// M3
		m_pPlayer.EnableResearch("RES_RUS_HELICOPTER1", true);			// M3
		m_pPlayer.EnableResearch("RES_RUS_AMMO_MG1", true);				// M4
		m_pPlayer.EnableResearch("RES_RUS_AMMO_CANNON1", true);			// M4
		m_pPlayer.EnableResearch("RES_RUS_SAPER", true);				// M4
		m_pPlayer.EnableResearch("RES_RUS_BM21", true);					// M4
		m_pPlayer.EnableResearch("RES_RUS_HELICOPTER2", true);			// M4
		m_pPlayer.EnableResearch("RES_RUS_AMMO_MG2", true);				// M5
		m_pPlayer.EnableResearch("RES_RUS_ART", true);					// M5
		m_pPlayer.EnableResearch("RES_RUS_AMMO_MGM1", true);			// M5
		m_pPlayer.EnableResearch("RES_RUS_SPECIAL_FILTER2", true);		// M5
		m_pPlayer.EnableResearch("RES_RUS_AMMO_CANNON2", true);			// M6
		m_pPlayer.EnableResearch("RES_RUS_AMMO_ART1", true);			// M6
		m_pPlayer.EnableResearch("RES_RUS_CHEMICAL1", true);			// M6
		m_pPlayer.EnableResearch("RES_RUS_AMMO_MGM2", true);			// M6
		m_pPlayer.EnableResearch("RES_RUS_SDI", true);					// M6
		m_pPlayer.EnableResearch("RES_RUS_SPECIAL_FILTER3", true);		// M6
		m_pPlayer.EnableResearch("RES_RUS_AMMO_ART2", true);			// M7
		m_pPlayer.EnableResearch("RES_RUS_AMMO_ROCKET1", true);			// M7
		m_pPlayer.EnableResearch("RES_RUS_AMMO_CHEMICAL1", true);		// M7
		m_pPlayer.EnableResearch("RES_RUS_ROCKETCONTROL", true);		// M7
		m_pPlayer.EnableResearch("RES_RUS_ROMB", true);					// M7
		m_pPlayer.EnableResearch("RES_RUS_AIRCONTROL", true);			// M7
		m_pPlayer.EnableResearch("RES_RUS_SPECIAL_PTC", true);			// M7
		m_pPlayer.EnableResearch("RES_RUS_AMMO_ROCKET2", true);
		m_pPlayer.EnableResearch("RES_RUS_AMMO_MIM1", true);

		EnableAllResearchRUS( m_pEnemy, false);
		m_pEnemy.EnableResearch("RES_RUS_AMPHIBIA1", true);				// M1
		m_pEnemy.EnableResearch("RES_RUS_ZSU", true);					// M2
		m_pEnemy.EnableResearch("RES_RUS_ASSAULT", true);				// M2
		m_pEnemy.EnableResearch("RES_RUS_PILLBOX", true);				// M3
		m_pEnemy.EnableResearch("RES_RUS_TANK", true);					// M3
		m_pEnemy.EnableResearch("RES_RUS_MIM", true);					// M3
		m_pEnemy.EnableResearch("RES_RUS_HELICOPTER1", true);			// M3
		m_pEnemy.EnableResearch("RES_RUS_AMMO_MG1", true);				// M4
		m_pEnemy.EnableResearch("RES_RUS_AMMO_CANNON1", true);			// M4
		m_pEnemy.EnableResearch("RES_RUS_SAPER", true);					// M4
		m_pEnemy.EnableResearch("RES_RUS_BM21", true);					// M4
		m_pEnemy.EnableResearch("RES_RUS_HELICOPTER2", true);			// M4
		m_pEnemy.EnableResearch("RES_RUS_AMMO_MG2", true);				// M5
		m_pEnemy.EnableResearch("RES_RUS_ART", true);					// M5
		m_pEnemy.EnableResearch("RES_RUS_AMMO_MGM1", true);				// M5
		m_pEnemy.EnableResearch("RES_RUS_SPECIAL_FILTER2", true);		// M5
		m_pEnemy.EnableResearch("RES_RUS_AMMO_CANNON2", true);			// M6
		m_pEnemy.EnableResearch("RES_RUS_AMMO_ART1", true);				// M6
		m_pEnemy.EnableResearch("RES_RUS_CHEMICAL1", true);				// M6
		m_pEnemy.EnableResearch("RES_RUS_AMMO_MGM2", true);				// M6
		m_pEnemy.EnableResearch("RES_RUS_SDI", true);					// M6
		m_pEnemy.EnableResearch("RES_RUS_SPECIAL_FILTER3", true);		// M6
		m_pEnemy.EnableResearch("RES_RUS_AMMO_ART2", true);				// M7
		m_pEnemy.EnableResearch("RES_RUS_AMMO_ROCKET1", true);			// M7
		m_pEnemy.EnableResearch("RES_RUS_AMMO_CHEMICAL1", true);		// M7
		m_pEnemy.EnableResearch("RES_RUS_ROCKETCONTROL", true);			// M7
		m_pEnemy.EnableResearch("RES_RUS_ROMB", true);					// M7
		m_pEnemy.EnableResearch("RES_RUS_AIRCONTROL", true);			// M7
		m_pEnemy.EnableResearch("RES_RUS_SPECIAL_PTC", true);			// M7
		m_pEnemy.EnableResearch("RES_RUS_AMMO_ROCKET2", true);
		m_pEnemy.EnableResearch("RES_RUS_AMMO_MIM1", true);

		m_pEnemy.AddResearch("RES_RUS_AMPHIBIA1");
		m_pEnemy.AddResearch("RES_RUS_ZSU");
		m_pEnemy.AddResearch("RES_RUS_ASSAULT");
		m_pEnemy.AddResearch("RES_RUS_PILLBOX");
		m_pEnemy.AddResearch("RES_RUS_TANK");
		m_pEnemy.AddResearch("RES_RUS_MIM");
		m_pEnemy.AddResearch("RES_RUS_HELICOPTER1");
		m_pEnemy.AddResearch("RES_RUS_AMMO_MG1");
		m_pEnemy.AddResearch("RES_RUS_AMMO_CANNON1");
		m_pEnemy.AddResearch("RES_RUS_SAPER");
		m_pEnemy.AddResearch("RES_RUS_BM21");
		m_pEnemy.AddResearch("RES_RUS_HELICOPTER2");
		m_pEnemy.AddResearch("RES_RUS_AMMO_MG2");
		m_pEnemy.AddResearch("RES_RUS_ART");
		m_pEnemy.AddResearch("RES_RUS_AMMO_MGM1");
		m_pEnemy.AddResearch("RES_RUS_SPECIAL_FILTER2");
		m_pEnemy.AddResearch("RES_RUS_AMMO_CANNON2");
		m_pEnemy.AddResearch("RES_RUS_AMMO_ART1");
		m_pEnemy.AddResearch("RES_RUS_CHEMICAL1");
		m_pEnemy.AddResearch("RES_RUS_AMMO_MGM2");
		m_pEnemy.AddResearch("RES_RUS_SDI");
		m_pEnemy.AddResearch("RES_RUS_SPECIAL_FILTER3");
		m_pEnemy.AddResearch("RES_RUS_AMMO_ART2");
		m_pEnemy.AddResearch("RES_RUS_AMMO_ROCKET1");
		m_pEnemy.AddResearch("RES_RUS_AMMO_CHEMICAL1");
		m_pEnemy.AddResearch("RES_RUS_ROCKETCONTROL");
		m_pEnemy.AddResearch("RES_RUS_ROMB");
		m_pEnemy.AddResearch("RES_RUS_AIRCONTROL");
		m_pEnemy.AddResearch("RES_RUS_SPECIAL_PTC");

		SetTimer(0, 100); // CheckDestroyedUnitsAndBuildings
		SetTimer(1, 10); // UpdateTime

		AddConsoleTextDisplay(1, 0, 100, SS_CENTER);

		AddUnitTemplatesRUS( m_pEnemy );

		m_bMissionFail = false;

		return BeforeStart, 1;
	}

	state BeforeStart
	{
		PlayTrack("Music\\Briefing.tws");

		return Start;
	}

    state Start
	{
		EnableGoal(goalCaptureRafinery, true);
		AddBriefing("translateBriefingMissionRUS_8_CaptureRafinery");
		PlayWave("Briefings\\RUS_Briefing08.wav");

		AddWorldMapSign(GetPointX(markerRafineryControl), GetPointY(markerRafineryControl), 0, 0, 65000);

		return CaptureRafinery;
	}

	state CaptureRafinery
	{
		if ( m_uRafineryControl.GetIFF() == m_pPlayer.GetIFF() )
		{
			return CapturedRafinery;
		}
		else
		{
			return CaptureRafinery;
		}
	}

	state CapturedRafinery
	{
		RemoveWorldMapSign(GetPointX(markerRafineryControl), GetPointY(markerRafineryControl), 0);

		SetGoalState(goalCaptureRafinery, goalAchieved);

		EnableGoal(goalDestroyBombControl, true);
		AddBriefing("translateBriefingMissionRUS_8_DestroyBombControl");

		AddWorldMapSign(GetPointX(markerAirControlBuildingFirst), GetPointY(markerAirControlBuildingFirst), 0, 0, 65000);

		m_nTimeOfBombingAttack = GetMissionTime() + 15*60*20 - 3*60*20*GetDifficultyLevel();

		return DestroyAirControl;
	}

	state DestroyAirControl
	{
		if ( CountPlayerBuildings(markerAirControlBuildingFirst, markerAirControlBuildingLast, m_pAirControl.GetIFFNumber()) == 0 )
		{
			return DestroyedAirControl;
		}
		else
		{
			return DestroyAirControl;
		}
	}

	state DestroyedAirControl
	{
		RemoveWorldMapSign(GetPointX(markerAirControlBuildingFirst), GetPointY(markerAirControlBuildingFirst), 0);

		SetGoalState(goalDestroyBombControl, goalAchieved);

		AddBriefing("translateBriefingMissionRUS_8_MissionComplete");

		EndMission(true);

		return MissionComplete;
	}

	state MissionComplete
	{
		return MissionComplete;
	}

	function int MissionFail()
	{
		if ( m_bMissionFail )
		{
			return false;
		}

		m_bMissionFail = true;

		if ( state == CaptureRafinery )
		{
			SetGoalState(goalCaptureRafinery, goalFailed);
		}
		else if ( state == DestroyAirControl )
		{
			SetGoalState(goalDestroyBombControl, goalFailed);
		}

		AddBriefing("translateBriefingMissionRUS_8_MissionFail");

		EnableEndMissionButton(true, false);

		state MissionComplete;
	}

	function int CheckDestroyedUnitsAndBuildings()
	{
		if ( state == MissionComplete ) return;

		if ( m_pPlayer.GetNumberOfUnits() == 0 && m_pPlayer.GetNumberOfBuildings() == 0 )
		{
			MissionFail();
		}

		if ( ! m_uRafineryControl.IsLive() )
		{
			MissionFail();
		}
	}

	function int UpdateTime()
	{
		int nMin, nSec;

		nMin = ((m_nTimeOfBombingAttack - GetMissionTime()) / 20) / 60;
		nSec = ((m_nTimeOfBombingAttack - GetMissionTime()) / 20) % 60;

		if ( nSec < 10 )
		{
			SetConsoleText(0, "<%0>:0<%1>", nMin, nSec);
		}
		else
		{
			SetConsoleText(0, "<%0>:<%1>", nMin, nSec);
		}

		if ( nMin == 0 && nSec == 0 )
		{
			m_pAirControl.MakeBombingAttack(GetPointX(markerRafineryControl), GetPointY(markerRafineryControl), "RUS_BOMBER", "MIS_RUS_BOMB1", 56, 3, 0, false);

			SetGoalState(goalDestroyBombControl, goalFailed);

			AddBriefing("translateBriefingMissionRUS_8_MissionFail");

			m_pPlayer.DelayedLookAt( GetPointX(markerRafineryControl), GetPointY(markerRafineryControl), -1, -1, 0, 0, 100, 1);

			EnableEndMissionButton(true, false);

			state MissionComplete;
		}
	}

	event Timer0()
	{
		if ( m_bCheckDestroyedUnitsAndBuildings )
		{
			m_bCheckDestroyedUnitsAndBuildings = false;

			CheckDestroyedUnitsAndBuildings();
		}
	}

	event Timer1()
	{
		if ( state == DestroyAirControl )
		{
			UpdateTime();
		}
	}

	event UnitDestroyed(unit uUnit)
	{
		m_bCheckNumberOfUnits = true;
		m_bCheckDestroyedUnitsAndBuildings = true;

		if ( uUnit == m_uHero )
		{
			MissionFail();
		}
	}

	event BuildingDestroyed(unit uBuilding)
	{
		m_bCheckNumberOfBuildings = true;
		m_bCheckDestroyedUnitsAndBuildings = true;
	}

	event SetupInterface()
	{
		EnableGameFeature
			(
			lockToolbarMoney |
			lockDisplayToolbarMoney |
			lockCreateBuildPanel |
			0, false);
	}
}
