mission "translateMissionRUS_9"
{
	consts
	{
		goalCaptureAirport1 = 0;
		goalCaptureAirport2 = 1;
		goalDestroyEnemies = 2;

		markerCapturer = 0; // hero
		markerAirport1 = 1;
		markerAirport2 = 2;
		markerTrainStation = 3;

		markerAirport2Killer1 = 5;
		markerAirport2Killer2 = 6;
		markerAirport2Killer3 = 7;

		markerTrainStationKiller1 = 8;
		markerTrainStationKiller2 = 9;
		markerTrainStationKiller3 = 10;
	}

	include "UnitTemplates.ech"
	include "Research.ech"

	player m_pPlayer;
	player m_pFriendlyUnits;
	player m_pEnemyA;
	player m_pEnemyMain;
	player m_pEnemyKillers;
	player m_pEnemyB;

	unitex m_uAirport2Killer1;
	unitex m_uAirport2Killer2;
	unitex m_uAirport2Killer3;

	unitex m_uTrainStationKiller1;
	unitex m_uTrainStationKiller2;
	unitex m_uTrainStationKiller3;

	unitex m_uAirport1;
	unitex m_uAirport2;

	unitex m_uCapturer;

	int m_nTimeOfKillersAttack;
	int m_bKillersAttacked;

	int m_bCheckNumberOfUnits;
	int m_bCheckNumberOfBuildings;

	int m_bCheckDestroyedUnitsAndBuildings;

	int m_nTimeOfEnableAI;

	state Initialize;
	state Start;
	state BeforeStart;
	state CaptureAirport1;
	state CapturedAirport1;
	state DestroyedAirport1;
	state CaptureAirport2;
	state CapturedAirport2;
	state DestroyedAirport2;
	state DestroyEnemies;
	state DestroyedEnemies;
	state MissionComplete;

	function int ModifyDifficulty()
	{
		if ( GetDifficultyLevel() == 0 )
		{
			ClearArea (65535, GetPointX(13), GetPointY(13), GetPointZ(13), 0);
			ClearArea (65535, GetPointX(14), GetPointY(14), GetPointZ(14), 0);
			ClearArea (65535, GetPointX(15), GetPointY(15), GetPointZ(15), 0);
		}
		else if ( GetDifficultyLevel() == 1 )
		{
			ClearArea (65535, GetPointX(12), GetPointY(12), GetPointZ(12), 0);
			ClearArea (65535, GetPointX(15), GetPointY(15), GetPointZ(15), 0);
		}
		else if ( GetDifficultyLevel() == 2 )
		{
			ClearArea (65535, GetPointX(11), GetPointY(11), GetPointZ(11), 0);
			ClearArea (65535, GetPointX(12), GetPointY(12), GetPointZ(12), 0);
		}
	}

	state Initialize
	{
		ModifyDifficulty();

		RegisterGoal(goalCaptureAirport1, "translateGoalMissionRUS_9_CaptureAirport1");
		RegisterGoal(goalCaptureAirport2, "translateGoalMissionRUS_9_CaptureAirport2");
		RegisterGoal(goalDestroyEnemies, "translateGoalMissionRUS_9_DestroyEnemies");

		m_pPlayer = GetPlayer(9);
		m_pPlayer.EnableStatistics(true);

		m_pFriendlyUnits = GetPlayer(0);
		m_pFriendlyUnits.EnableStatistics(false);

		m_pEnemyA = GetPlayer(2);
		m_pEnemyA.EnableStatistics(true);

		m_pEnemyMain = GetPlayer(1);
		m_pEnemyMain.EnableStatistics(true);

		m_pEnemyKillers = GetPlayer(3);
		m_pEnemyKillers.EnableStatistics(false);

		m_pEnemyB = GetPlayer(4);
		m_pEnemyB.EnableStatistics(true);

		if ( GetDifficultyLevel() == 0 )
		{
			m_pEnemyA.LoadScript("single\\singleMedium");
			m_pEnemyB.LoadScript("single\\singleMedium");
			m_pEnemyMain.LoadScript("single\\singleMedium");

			m_pEnemyA.SetMilitaryUnitsLimit(25000);
			m_pEnemyB.SetMilitaryUnitsLimit(25000);
			m_pEnemyMain.SetMilitaryUnitsLimit(25000);

			m_pEnemyA.EnableMilitaryUnitsLimit(true);
			m_pEnemyB.EnableMilitaryUnitsLimit(true);
			m_pEnemyMain.EnableMilitaryUnitsLimit(true);

			m_pPlayer.SetMoney(10000);
		}
		else if ( GetDifficultyLevel() == 1 )
		{
			m_pEnemyA.LoadScript("single\\singleHard");
			m_pEnemyB.LoadScript("single\\singleHard");
			m_pEnemyMain.LoadScript("single\\singleHard");

			m_pPlayer.SetMoney(8000);
		}
		else if ( GetDifficultyLevel() == 2 )
		{
			m_pEnemyA.LoadScript("single\\singleHard");
			m_pEnemyB.LoadScript("single\\singleHard");
			m_pEnemyMain.LoadScript("single\\singleHard");

			m_pPlayer.SetMoney(5000);
		}

		m_pEnemyMain.SetMoney(50000);
		m_pEnemyA.SetMoney(5000);

		m_pEnemyKillers.EnableAI(false);

		m_pFriendlyUnits.EnableAI(false);

		m_pFriendlyUnits.SetNeutral(m_pPlayer);
		m_pPlayer.SetNeutral(m_pFriendlyUnits);

		m_pFriendlyUnits.SetEnemy(m_pEnemyA);
		m_pFriendlyUnits.SetEnemy(m_pEnemyMain);
		m_pFriendlyUnits.SetEnemy(m_pEnemyKillers);
		m_pFriendlyUnits.SetEnemy(m_pEnemyB);

		m_pEnemyMain.EnableAI(true);
		m_pEnemyMain.EnableAIFeatures(aiControlOffense, false);

		m_pEnemyA.EnableAI(true);

		m_pEnemyB.EnableAI(true);

		m_uAirport2Killer1 = GetUnit(GetPointX(markerAirport2Killer1), GetPointY(markerAirport2Killer1));
		m_uAirport2Killer2 = GetUnit(GetPointX(markerAirport2Killer2), GetPointY(markerAirport2Killer2));
		m_uAirport2Killer3 = GetUnit(GetPointX(markerAirport2Killer3), GetPointY(markerAirport2Killer3));

		m_uTrainStationKiller1 = GetUnit(GetPointX(markerTrainStationKiller1), GetPointY(markerTrainStationKiller1));
		m_uTrainStationKiller2 = GetUnit(GetPointX(markerTrainStationKiller2), GetPointY(markerTrainStationKiller2));
		m_uTrainStationKiller3 = GetUnit(GetPointX(markerTrainStationKiller3), GetPointY(markerTrainStationKiller3));

		m_uAirport1 = GetUnit(GetPointX(markerAirport1), GetPointY(markerAirport1));
		m_uAirport2 = GetUnit(GetPointX(markerAirport2), GetPointY(markerAirport2));

		m_uCapturer = GetUnit(GetPointX(markerCapturer), GetPointY(markerCapturer));

		AddUnitTemplatesRUS( m_pPlayer );

	    m_pPlayer.EnableBuilding("RUS_AIRPORT1", false);

		m_pPlayer.LookAt(m_pPlayer.GetStartingPointX(), m_pPlayer.GetStartingPointY(), 6, 0, 0, 0);

		EnableAllResearchRUS( m_pPlayer, false);
		m_pPlayer.EnableResearch("RES_RUS_AMPHIBIA1", true);			// M1
		m_pPlayer.EnableResearch("RES_RUS_ZSU", true);					// M2
		m_pPlayer.EnableResearch("RES_RUS_ASSAULT", true);				// M2
		m_pPlayer.EnableResearch("RES_RUS_PILLBOX", true);				// M3
		m_pPlayer.EnableResearch("RES_RUS_TANK", true);					// M3
		m_pPlayer.EnableResearch("RES_RUS_MIM", true);					// M3
		m_pPlayer.EnableResearch("RES_RUS_HELICOPTER1", true);			// M3
		m_pPlayer.EnableResearch("RES_RUS_AMMO_MG1", true);				// M4
		m_pPlayer.EnableResearch("RES_RUS_AMMO_CANNON1", true);			// M4
		m_pPlayer.EnableResearch("RES_RUS_SAPER", true);				// M4
		m_pPlayer.EnableResearch("RES_RUS_BM21", true);					// M4
		m_pPlayer.EnableResearch("RES_RUS_HELICOPTER2", true);			// M4
		m_pPlayer.EnableResearch("RES_RUS_AMMO_MG2", true);				// M5
		m_pPlayer.EnableResearch("RES_RUS_ART", true);					// M5
		m_pPlayer.EnableResearch("RES_RUS_AMMO_MGM1", true);			// M5
		m_pPlayer.EnableResearch("RES_RUS_SPECIAL_FILTER2", true);		// M5
		m_pPlayer.EnableResearch("RES_RUS_AMMO_CANNON2", true);			// M6
		m_pPlayer.EnableResearch("RES_RUS_AMMO_ART1", true);			// M6
		m_pPlayer.EnableResearch("RES_RUS_CHEMICAL1", true);			// M6
		m_pPlayer.EnableResearch("RES_RUS_AMMO_MGM2", true);			// M6
		m_pPlayer.EnableResearch("RES_RUS_SDI", true);					// M6
		m_pPlayer.EnableResearch("RES_RUS_SPECIAL_FILTER3", true);		// M6
		m_pPlayer.EnableResearch("RES_RUS_AMMO_ART2", true);			// M7
		m_pPlayer.EnableResearch("RES_RUS_AMMO_ROCKET1", true);			// M7
		m_pPlayer.EnableResearch("RES_RUS_AMMO_CHEMICAL1", true);		// M7
//		m_pPlayer.EnableResearch("RES_RUS_ROCKETCONTROL", true);		// M7
		m_pPlayer.EnableResearch("RES_RUS_ROMB", true);					// M7
		m_pPlayer.EnableResearch("RES_RUS_AIRCONTROL", true);			// M7
		m_pPlayer.EnableResearch("RES_RUS_SPECIAL_PTC", true);			// M7
		m_pPlayer.EnableResearch("RES_RUS_AMMO_ROCKET2", true);			// M8
		m_pPlayer.EnableResearch("RES_RUS_AMMO_MIM1", true);			// M8
		m_pPlayer.EnableResearch("RES_RUS_AMMO_CHEMICAL2", true);
//		m_pPlayer.EnableResearch("RES_RUS_BOMBCONTROL", true);
		m_pPlayer.EnableResearch("RES_RUS_SPECIAL_FLARE", true);

		m_pPlayer.AddResearch("RES_RUS_AMPHIBIA1");
		m_pPlayer.AddResearch("RES_RUS_ZSU");
		m_pPlayer.AddResearch("RES_RUS_ASSAULT");
		m_pPlayer.AddResearch("RES_RUS_PILLBOX");
		m_pPlayer.AddResearch("RES_RUS_TANK");
		m_pPlayer.AddResearch("RES_RUS_MIM");
		m_pPlayer.AddResearch("RES_RUS_HELICOPTER1");
		m_pPlayer.AddResearch("RES_RUS_AMMO_MG1");
		m_pPlayer.AddResearch("RES_RUS_AMMO_CANNON1");
		m_pPlayer.AddResearch("RES_RUS_SAPER");
		m_pPlayer.AddResearch("RES_RUS_BM21");
		m_pPlayer.AddResearch("RES_RUS_HELICOPTER2");
		m_pPlayer.AddResearch("RES_RUS_AMMO_MG2");
		m_pPlayer.AddResearch("RES_RUS_ART");
		m_pPlayer.AddResearch("RES_RUS_AMMO_MGM1");
		m_pPlayer.AddResearch("RES_RUS_SPECIAL_FILTER2");
		m_pPlayer.AddResearch("RES_RUS_AMMO_CANNON2");
		m_pPlayer.AddResearch("RES_RUS_AMMO_ART1");
		m_pPlayer.AddResearch("RES_RUS_CHEMICAL1");
		m_pPlayer.AddResearch("RES_RUS_AMMO_MGM2");
		m_pPlayer.AddResearch("RES_RUS_SDI");
		m_pPlayer.AddResearch("RES_RUS_SPECIAL_FILTER3");
		m_pPlayer.AddResearch("RES_RUS_AMMO_ART2");
		m_pPlayer.AddResearch("RES_RUS_AMMO_ROCKET1");
		m_pPlayer.AddResearch("RES_RUS_AMMO_CHEMICAL1");
//		m_pPlayer.AddResearch("RES_RUS_ROCKETCONTROL");
//		m_pPlayer.AddResearch("RES_RUS_ROMB");
//		m_pPlayer.AddResearch("RES_RUS_AIRCONTROL");
		m_pPlayer.AddResearch("RES_RUS_SPECIAL_PTC");
		m_pPlayer.AddResearch("RES_RUS_AMMO_ROCKET2");
//		m_pPlayer.AddResearch("RES_RUS_AMMO_MIM1");
//		m_pPlayer.AddResearch("RES_RUS_AMMO_CHEMICAL2");
//		m_pPlayer.AddResearch("RES_RUS_BOMBCONTROL");
//		m_pPlayer.AddResearch("RES_RUS_SPECIAL_FLARE");

		EnableAllResearchRUS( m_pEnemyA, false);
		m_pEnemyA.EnableResearch("RES_RUS_AMPHIBIA1", true);			// M1
		m_pEnemyA.EnableResearch("RES_RUS_ZSU", true);					// M2
		m_pEnemyA.EnableResearch("RES_RUS_ASSAULT", true);				// M2
		m_pEnemyA.EnableResearch("RES_RUS_PILLBOX", true);				// M3
		m_pEnemyA.EnableResearch("RES_RUS_TANK", true);					// M3
		m_pEnemyA.EnableResearch("RES_RUS_MIM", true);					// M3
		m_pEnemyA.EnableResearch("RES_RUS_HELICOPTER1", true);			// M3
		m_pEnemyA.EnableResearch("RES_RUS_AMMO_MG1", true);				// M4
		m_pEnemyA.EnableResearch("RES_RUS_AMMO_CANNON1", true);			// M4
		m_pEnemyA.EnableResearch("RES_RUS_SAPER", true);				// M4
		m_pEnemyA.EnableResearch("RES_RUS_BM21", true);					// M4
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyA.EnableResearch("RES_RUS_HELICOPTER2", true);		// M4
		}
		m_pEnemyA.EnableResearch("RES_RUS_AMMO_MG2", true);				// M5
		m_pEnemyA.EnableResearch("RES_RUS_ART", true);					// M5
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyA.EnableResearch("RES_RUS_AMMO_MGM1", true);		// M5
		}
		m_pEnemyA.EnableResearch("RES_RUS_SPECIAL_FILTER2", true);		// M5
		m_pEnemyA.EnableResearch("RES_RUS_AMMO_CANNON2", true);			// M6
		m_pEnemyA.EnableResearch("RES_RUS_AMMO_ART1", true);			// M6
		m_pEnemyA.EnableResearch("RES_RUS_CHEMICAL1", true);			// M6
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyA.EnableResearch("RES_RUS_AMMO_MGM2", true);		// M6
		}
		m_pEnemyA.EnableResearch("RES_RUS_SDI", true);					// M6
		m_pEnemyA.EnableResearch("RES_RUS_SPECIAL_FILTER3", true);		// M6
		m_pEnemyA.EnableResearch("RES_RUS_AMMO_ART2", true);			// M7
		m_pEnemyA.EnableResearch("RES_RUS_AMMO_ROCKET1", true);			// M7
		m_pEnemyA.EnableResearch("RES_RUS_AMMO_CHEMICAL1", true);		// M7
//		m_pEnemyA.EnableResearch("RES_RUS_ROCKETCONTROL", true);		// M7
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyA.EnableResearch("RES_RUS_ROMB", true);				// M7
		}
//		m_pEnemyA.EnableResearch("RES_RUS_AIRCONTROL", true);			// M7
		m_pEnemyA.EnableResearch("RES_RUS_SPECIAL_PTC", true);			// M7
		m_pEnemyA.EnableResearch("RES_RUS_AMMO_ROCKET2", true);			// M8
		m_pEnemyA.EnableResearch("RES_RUS_AMMO_MIM1", true);			// M8
		m_pEnemyA.EnableResearch("RES_RUS_AMMO_CHEMICAL2", true);
		m_pEnemyA.EnableResearch("RES_RUS_BOMBCONTROL", true);
		m_pEnemyA.EnableResearch("RES_RUS_SPECIAL_FLARE", true);

		EnableAllResearchRUS( m_pEnemyB, false);
		m_pEnemyB.EnableResearch("RES_RUS_AMPHIBIA1", true);			// M1
		m_pEnemyB.EnableResearch("RES_RUS_ZSU", true);					// M2
		m_pEnemyB.EnableResearch("RES_RUS_ASSAULT", true);				// M2
		m_pEnemyB.EnableResearch("RES_RUS_PILLBOX", true);				// M3
		m_pEnemyB.EnableResearch("RES_RUS_TANK", true);					// M3
		m_pEnemyB.EnableResearch("RES_RUS_MIM", true);					// M3
		m_pEnemyB.EnableResearch("RES_RUS_HELICOPTER1", true);			// M3
		m_pEnemyB.EnableResearch("RES_RUS_AMMO_MG1", true);				// M4
		m_pEnemyB.EnableResearch("RES_RUS_AMMO_CANNON1", true);			// M4
		m_pEnemyB.EnableResearch("RES_RUS_SAPER", true);				// M4
		m_pEnemyB.EnableResearch("RES_RUS_BM21", true);					// M4
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyB.EnableResearch("RES_RUS_HELICOPTER2", true);		// M4
		}
		m_pEnemyB.EnableResearch("RES_RUS_AMMO_MG2", true);				// M5
		m_pEnemyB.EnableResearch("RES_RUS_ART", true);					// M5
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyB.EnableResearch("RES_RUS_AMMO_MGM1", true);		// M5
		}
		m_pEnemyB.EnableResearch("RES_RUS_SPECIAL_FILTER2", true);		// M5
		m_pEnemyB.EnableResearch("RES_RUS_AMMO_CANNON2", true);			// M6
		m_pEnemyB.EnableResearch("RES_RUS_AMMO_ART1", true);			// M6
		m_pEnemyB.EnableResearch("RES_RUS_CHEMICAL1", true);			// M6
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyB.EnableResearch("RES_RUS_AMMO_MGM2", true);		// M6
		}
		m_pEnemyB.EnableResearch("RES_RUS_SDI", true);					// M6
		m_pEnemyB.EnableResearch("RES_RUS_SPECIAL_FILTER3", true);		// M6
		m_pEnemyB.EnableResearch("RES_RUS_AMMO_ART2", true);			// M7
		m_pEnemyB.EnableResearch("RES_RUS_AMMO_ROCKET1", true);			// M7
		m_pEnemyB.EnableResearch("RES_RUS_AMMO_CHEMICAL1", true);		// M7
//		m_pEnemyB.EnableResearch("RES_RUS_ROCKETCONTROL", true);		// M7
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyB.EnableResearch("RES_RUS_ROMB", true);				// M7
		}
//		m_pEnemyB.EnableResearch("RES_RUS_AIRCONTROL", true);			// M7
		m_pEnemyB.EnableResearch("RES_RUS_SPECIAL_PTC", true);			// M7
		m_pEnemyB.EnableResearch("RES_RUS_AMMO_ROCKET2", true);			// M8
		m_pEnemyB.EnableResearch("RES_RUS_AMMO_MIM1", true);			// M8
		m_pEnemyB.EnableResearch("RES_RUS_AMMO_CHEMICAL2", true);
		m_pEnemyB.EnableResearch("RES_RUS_BOMBCONTROL", true);
		m_pEnemyB.EnableResearch("RES_RUS_SPECIAL_FLARE", true);

		EnableAllResearchRUS( m_pEnemyMain, false);
		m_pEnemyMain.EnableResearch("RES_RUS_AMPHIBIA1", true);				// M1
		m_pEnemyMain.EnableResearch("RES_RUS_ZSU", true);					// M2
		m_pEnemyMain.EnableResearch("RES_RUS_ASSAULT", true);				// M2
		m_pEnemyMain.EnableResearch("RES_RUS_PILLBOX", true);				// M3
		m_pEnemyMain.EnableResearch("RES_RUS_TANK", true);					// M3
		m_pEnemyMain.EnableResearch("RES_RUS_MIM", true);					// M3
		m_pEnemyMain.EnableResearch("RES_RUS_HELICOPTER1", true);			// M3
		m_pEnemyMain.EnableResearch("RES_RUS_AMMO_MG1", true);				// M4
		m_pEnemyMain.EnableResearch("RES_RUS_AMMO_CANNON1", true);			// M4
		m_pEnemyMain.EnableResearch("RES_RUS_SAPER", true);					// M4
		m_pEnemyMain.EnableResearch("RES_RUS_BM21", true);					// M4
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyMain.EnableResearch("RES_RUS_HELICOPTER2", true);		// M4
		}
		m_pEnemyMain.EnableResearch("RES_RUS_AMMO_MG2", true);				// M5
		m_pEnemyMain.EnableResearch("RES_RUS_ART", true);					// M5
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyMain.EnableResearch("RES_RUS_AMMO_MGM1", true);			// M5
		}
		m_pEnemyMain.EnableResearch("RES_RUS_SPECIAL_FILTER2", true);		// M5
		m_pEnemyMain.EnableResearch("RES_RUS_AMMO_CANNON2", true);			// M6
		m_pEnemyMain.EnableResearch("RES_RUS_AMMO_ART1", true);				// M6
		m_pEnemyMain.EnableResearch("RES_RUS_CHEMICAL1", true);				// M6
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyMain.EnableResearch("RES_RUS_AMMO_MGM2", true);			// M6
		}
		m_pEnemyMain.EnableResearch("RES_RUS_SDI", true);					// M6
		m_pEnemyMain.EnableResearch("RES_RUS_SPECIAL_FILTER3", true);		// M6
		m_pEnemyMain.EnableResearch("RES_RUS_AMMO_ART2", true);				// M7
		m_pEnemyMain.EnableResearch("RES_RUS_AMMO_ROCKET1", true);			// M7
		m_pEnemyMain.EnableResearch("RES_RUS_AMMO_CHEMICAL1", true);		// M7
//		m_pEnemyMain.EnableResearch("RES_RUS_ROCKETCONTROL", true);			// M7
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyMain.EnableResearch("RES_RUS_ROMB", true);				// M7
		}
//		m_pEnemyMain.EnableResearch("RES_RUS_AIRCONTROL", true);			// M7
		m_pEnemyMain.EnableResearch("RES_RUS_SPECIAL_PTC", true);			// M7
		m_pEnemyMain.EnableResearch("RES_RUS_AMMO_ROCKET2", true);			// M8
		m_pEnemyMain.EnableResearch("RES_RUS_AMMO_MIM1", true);				// M8
		m_pEnemyMain.EnableResearch("RES_RUS_AMMO_CHEMICAL2", true);
		m_pEnemyMain.EnableResearch("RES_RUS_BOMBCONTROL", true);
		m_pEnemyMain.EnableResearch("RES_RUS_SPECIAL_FLARE", true);

		m_pEnemyA.AddResearch("RES_RUS_AMPHIBIA1");
		m_pEnemyA.AddResearch("RES_RUS_ZSU");
		m_pEnemyA.AddResearch("RES_RUS_ASSAULT");
		m_pEnemyA.AddResearch("RES_RUS_PILLBOX");
		m_pEnemyA.AddResearch("RES_RUS_TANK");
		m_pEnemyA.AddResearch("RES_RUS_MIM");
		m_pEnemyA.AddResearch("RES_RUS_HELICOPTER1");
		m_pEnemyA.AddResearch("RES_RUS_AMMO_MG1");
		m_pEnemyA.AddResearch("RES_RUS_AMMO_CANNON1");
		m_pEnemyA.AddResearch("RES_RUS_SAPER");
		m_pEnemyA.AddResearch("RES_RUS_BM21");
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyA.AddResearch("RES_RUS_HELICOPTER2");
		}
		m_pEnemyA.AddResearch("RES_RUS_AMMO_MG2");
		m_pEnemyA.AddResearch("RES_RUS_ART");
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyA.AddResearch("RES_RUS_AMMO_MGM1");
		}
		m_pEnemyA.AddResearch("RES_RUS_SPECIAL_FILTER2");
		m_pEnemyA.AddResearch("RES_RUS_AMMO_CANNON2");
		m_pEnemyA.AddResearch("RES_RUS_AMMO_ART1");
		m_pEnemyA.AddResearch("RES_RUS_CHEMICAL1");
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyA.AddResearch("RES_RUS_AMMO_MGM2");
		}
		m_pEnemyA.AddResearch("RES_RUS_SDI");
		m_pEnemyA.AddResearch("RES_RUS_SPECIAL_FILTER3");
		m_pEnemyA.AddResearch("RES_RUS_AMMO_ART2");
		m_pEnemyA.AddResearch("RES_RUS_AMMO_ROCKET1");
		m_pEnemyA.AddResearch("RES_RUS_AMMO_CHEMICAL1");
//		m_pEnemyA.AddResearch("RES_RUS_ROCKETCONTROL");
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyA.AddResearch("RES_RUS_ROMB");
		}
//		m_pEnemyA.AddResearch("RES_RUS_AIRCONTROL");
		m_pEnemyA.AddResearch("RES_RUS_SPECIAL_PTC");
		m_pEnemyA.AddResearch("RES_RUS_AMMO_ROCKET2");
		m_pEnemyA.AddResearch("RES_RUS_AMMO_MIM1");

		m_pEnemyB.AddResearch("RES_RUS_AMPHIBIA1");
		m_pEnemyB.AddResearch("RES_RUS_ZSU");
		m_pEnemyB.AddResearch("RES_RUS_ASSAULT");
		m_pEnemyB.AddResearch("RES_RUS_PILLBOX");
		m_pEnemyB.AddResearch("RES_RUS_TANK");
		m_pEnemyB.AddResearch("RES_RUS_MIM");
		m_pEnemyB.AddResearch("RES_RUS_HELICOPTER1");
		m_pEnemyB.AddResearch("RES_RUS_AMMO_MG1");
		m_pEnemyB.AddResearch("RES_RUS_AMMO_CANNON1");
		m_pEnemyB.AddResearch("RES_RUS_SAPER");
		m_pEnemyB.AddResearch("RES_RUS_BM21");
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyB.AddResearch("RES_RUS_HELICOPTER2");
		}
		m_pEnemyB.AddResearch("RES_RUS_AMMO_MG2");
		m_pEnemyB.AddResearch("RES_RUS_ART");
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyB.AddResearch("RES_RUS_AMMO_MGM1");
		}
		m_pEnemyB.AddResearch("RES_RUS_SPECIAL_FILTER2");
		m_pEnemyB.AddResearch("RES_RUS_AMMO_CANNON2");
		m_pEnemyB.AddResearch("RES_RUS_AMMO_ART1");
		m_pEnemyB.AddResearch("RES_RUS_CHEMICAL1");
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyB.AddResearch("RES_RUS_AMMO_MGM2");
		}
		m_pEnemyB.AddResearch("RES_RUS_SDI");
		m_pEnemyB.AddResearch("RES_RUS_SPECIAL_FILTER3");
		m_pEnemyB.AddResearch("RES_RUS_AMMO_ART2");
		m_pEnemyB.AddResearch("RES_RUS_AMMO_ROCKET1");
		m_pEnemyB.AddResearch("RES_RUS_AMMO_CHEMICAL1");
//		m_pEnemyB.AddResearch("RES_RUS_ROCKETCONTROL");
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyB.AddResearch("RES_RUS_ROMB");
		}
//		m_pEnemyB.AddResearch("RES_RUS_AIRCONTROL");
		m_pEnemyB.AddResearch("RES_RUS_SPECIAL_PTC");
		m_pEnemyB.AddResearch("RES_RUS_AMMO_ROCKET2");
		m_pEnemyB.AddResearch("RES_RUS_AMMO_MIM1");

		m_pEnemyMain.AddResearch("RES_RUS_AMPHIBIA1");
		m_pEnemyMain.AddResearch("RES_RUS_ZSU");
		m_pEnemyMain.AddResearch("RES_RUS_ASSAULT");
		m_pEnemyMain.AddResearch("RES_RUS_PILLBOX");
		m_pEnemyMain.AddResearch("RES_RUS_TANK");
		m_pEnemyMain.AddResearch("RES_RUS_MIM");
		m_pEnemyMain.AddResearch("RES_RUS_HELICOPTER1");
		m_pEnemyMain.AddResearch("RES_RUS_AMMO_MG1");
		m_pEnemyMain.AddResearch("RES_RUS_AMMO_CANNON1");
		m_pEnemyMain.AddResearch("RES_RUS_SAPER");
		m_pEnemyMain.AddResearch("RES_RUS_BM21");
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyMain.AddResearch("RES_RUS_HELICOPTER2");
		}
		m_pEnemyMain.AddResearch("RES_RUS_AMMO_MG2");
		m_pEnemyMain.AddResearch("RES_RUS_ART");
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyMain.AddResearch("RES_RUS_AMMO_MGM1");
		}
		m_pEnemyMain.AddResearch("RES_RUS_SPECIAL_FILTER2");
		m_pEnemyMain.AddResearch("RES_RUS_AMMO_CANNON2");
		m_pEnemyMain.AddResearch("RES_RUS_AMMO_ART1");
		m_pEnemyMain.AddResearch("RES_RUS_CHEMICAL1");
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyMain.AddResearch("RES_RUS_AMMO_MGM2");
		}
		m_pEnemyMain.AddResearch("RES_RUS_SDI");
		m_pEnemyMain.AddResearch("RES_RUS_SPECIAL_FILTER3");
		m_pEnemyMain.AddResearch("RES_RUS_AMMO_ART2");
		m_pEnemyMain.AddResearch("RES_RUS_AMMO_ROCKET1");
		m_pEnemyMain.AddResearch("RES_RUS_AMMO_CHEMICAL1");
//		m_pEnemyMain.AddResearch("RES_RUS_ROCKETCONTROL");
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyMain.AddResearch("RES_RUS_ROMB");
		}
//		m_pEnemyMain.AddResearch("RES_RUS_AIRCONTROL");
		m_pEnemyMain.AddResearch("RES_RUS_SPECIAL_PTC");
		m_pEnemyMain.AddResearch("RES_RUS_AMMO_ROCKET2");
		m_pEnemyMain.AddResearch("RES_RUS_AMMO_MIM1");

		SetTimer(0, 100); // CheckDestroyedUnitsAndBuildings

		AddUnitTemplatesRUS( m_pEnemyA );
		AddUnitTemplatesRUS( m_pEnemyB );
		AddUnitTemplatesRUS( m_pEnemyMain );

		return BeforeStart, 1;
	}

	state BeforeStart
	{
		PlayTrack("Music\\Briefing.tws");

		return Start;
	}

    state Start
	{
		EnableGoal(goalCaptureAirport1, true);
		AddBriefing("translateBriefingMissionRUS_9_CaptureAirport1");
		PlayWave("Briefings\\RUS_Briefing09.wav");

		AddWorldMapSign(GetPointX(markerAirport1), GetPointY(markerAirport1), 0, 0, 65000);

		return CaptureAirport1;
	}

	state CaptureAirport1
	{
		if ( !m_uAirport1.IsLive() )
		{
			return DestroyedAirport1;
		}

		if ( m_uAirport1.GetIFF() == m_pPlayer.GetIFF() )
		{
			return CapturedAirport1;
		}

		return CaptureAirport1;
	}

	state CapturedAirport1
	{
		if ( GetDifficultyLevel() == 0 )
		{
			m_pEnemyMain.EnableAI(false);
			m_pEnemyA.EnableAI(false);
			m_pEnemyB.EnableAI(false);
		}

		SetGoalState(goalCaptureAirport1, goalAchieved);

		RemoveWorldMapSign(GetPointX(markerAirport1), GetPointY(markerAirport1), 0);

		EnableGoal(goalCaptureAirport2, true);
		AddBriefing("translateBriefingMissionRUS_9_CaptureAirport2");

		m_pEnemyMain.EnableAIFeatures(aiControlOffense, true);

		AddWorldMapSign(GetPointX(markerAirport2), GetPointY(markerAirport2), 0, 0, 65000);

		m_nTimeOfEnableAI = GetMissionTime() + 2*60*20;

		return CaptureAirport2;
	}

	state DestroyedAirport1
	{
		SetGoalState(goalCaptureAirport1, goalFailed);

		AddBriefing("translateBriefingMissionRUS_9_MissionFail");

		EnableEndMissionButton(true, false);

		return MissionComplete;
	}

	state CaptureAirport2
	{
		if ( GetMissionTime() >= m_nTimeOfEnableAI )
		{
			m_pEnemyMain.EnableAI(true);
			m_pEnemyA.EnableAI(true);
			m_pEnemyB.EnableAI(true);
		}

		if ( !m_uAirport2.IsLive() )
		{
			return DestroyedAirport2;
		}

		if ( m_uAirport2.GetIFF() == m_pPlayer.GetIFF() )
		{
			return CapturedAirport2;
		}

		return CaptureAirport2;
	}

	state CapturedAirport2
	{
		m_pEnemyMain.EnableAI(true);
		m_pEnemyA.EnableAI(true);
		m_pEnemyB.EnableAI(true);

		SetGoalState(goalCaptureAirport2, goalAchieved);

		RemoveWorldMapSign(GetPointX(markerAirport2), GetPointY(markerAirport2), 0);

		EnableGoal(goalDestroyEnemies, true);
		AddBriefing("translateBriefingMissionRUS_9_DestroyEnemies");

		m_nTimeOfKillersAttack = GetMissionTime() + 3*60*20;

		m_bKillersAttacked = false;

		return DestroyEnemies;
	}

	state DestroyedAirport2
	{
		SetGoalState(goalCaptureAirport2, goalFailed);

		AddBriefing("translateBriefingMissionRUS_9_MissionFail");

		EnableEndMissionButton(true, false);

		return MissionComplete;
	}

	state DestroyEnemies
	{
		if ( !m_bKillersAttacked && GetMissionTime() >= m_nTimeOfKillersAttack )
		{
			m_uAirport2Killer1.CommandAttack(m_uAirport2);
			m_uAirport2Killer2.CommandAttack(m_uAirport2);
			m_uAirport2Killer3.CommandAttack(m_uAirport2);

			m_uTrainStationKiller1.CommandAttackOnPoint(GetPointX(markerTrainStation), GetPointY(markerTrainStation), 0);
			m_uTrainStationKiller2.CommandAttackOnPoint(GetPointX(markerTrainStation), GetPointY(markerTrainStation), 0);
			m_uTrainStationKiller3.CommandAttackOnPoint(GetPointX(markerTrainStation), GetPointY(markerTrainStation), 0);

			m_bKillersAttacked = true;
		}

		if ( !m_bCheckNumberOfUnits )
		{
			return DestroyEnemies;
		}

		m_bCheckNumberOfUnits = false;

		if	(
			! m_uAirport2Killer1.IsLive() && 
			! m_uAirport2Killer2.IsLive() && 
			! m_uAirport2Killer3.IsLive() && 
			! m_uTrainStationKiller1.IsLive() && 
			! m_uTrainStationKiller2.IsLive() && 
			! m_uTrainStationKiller3.IsLive()
			)
		{
			return DestroyedEnemies;
		}
		else
		{
			return DestroyEnemies;
		}
	}

	state DestroyedEnemies
	{
		SetGoalState(goalDestroyEnemies, goalAchieved);

		AddBriefing("translateBriefingMissionRUS_9_MissionComplete");

		EnableEndMissionButton(true, true);

		return MissionComplete;
	}

	state MissionComplete
	{
		return MissionComplete;
	}

	function int MissionFail()
	{
		if ( GetGoalState(goalCaptureAirport1) != goalAchieved )
		{
			SetGoalState(goalCaptureAirport1, goalFailed);
		}

		if ( GetGoalState(goalCaptureAirport2) != goalAchieved )
		{
			SetGoalState(goalCaptureAirport2, goalFailed);
		}

		if ( GetGoalState(goalDestroyEnemies) != goalAchieved )
		{
			SetGoalState(goalDestroyEnemies, goalFailed);
		}

		AddBriefing("translateBriefingMissionRUS_9_MissionFail");

		EnableEndMissionButton(true, false);

		state MissionComplete;
	}

	function int CheckDestroyedUnitsAndBuildings()
	{
		if ( state == MissionComplete ) return;

		if ( !m_uAirport1.IsLive() )
		{
			MissionFail();
		}
		else if ( !m_uAirport2.IsLive() )
		{
			MissionFail();
		}
/*
		else if ( m_pPlayer.GetNumberOfUnits() == 0 && m_pPlayer.GetNumberOfBuildings() == 0 )
		{
			AddBriefing("translateBriefingMissionRUS_9_MissionFail");

			EnableEndMissionButton(true, false);

			state MissionComplete;
		}
*/
	}

	event Timer0()
	{
		if ( m_bCheckDestroyedUnitsAndBuildings )
		{
			m_bCheckDestroyedUnitsAndBuildings = false;

			CheckDestroyedUnitsAndBuildings();
		}
	}

	event UnitDestroyed(unit uUnit)
	{
		m_bCheckNumberOfUnits = true;
		m_bCheckDestroyedUnitsAndBuildings = true;

		if ( uUnit == m_uCapturer )
		{
			MissionFail();
		}
	}

	event BuildingDestroyed(unit uBuilding)
	{
		m_bCheckNumberOfBuildings = true;
		m_bCheckDestroyedUnitsAndBuildings = true;
	}

	event SetupInterface()
	{
		EnableGameFeature
			(
			lockResearchDialog |
			lockToolbarResearching |
			0, false);
	}
}
