mission "translateMissionRUS_Base"
{
	consts
	{
		goalMission1 = 0;
		goalMission2 = 1;
		goalMission3 = 2;
		goalMission4 = 3;
		goalMission5 = 4;
	}

	player m_pPlayer;

	state Initialize;
	state Start;
	state CheckBuildings;
	state Nothing;

	include "Research.ech"

	state Initialize
	{
		RegisterGoal(goalMission1, "translateMissionRUS_1");
		RegisterGoal(goalMission2, "translateMissionRUS_2");
		RegisterGoal(goalMission3, "translateMissionRUS_3");
		RegisterGoal(goalMission4, "translateMissionRUS_4");
		RegisterGoal(goalMission5, "translateMissionRUS_5");

		m_pPlayer = GetPlayer(9);
		EnableAllResearchRUS(m_pPlayer, false);

		m_pPlayer.SetIsMainBasePlayer(true);

		m_pPlayer.SetMilitaryUnitsLimit(40000);

		return Start;
	}

	state Start
	{
		EnableGoal(goalMission1, true);
		EnableGoal(goalMission2, true);
		EnableGoal(goalMission3, true);
		EnableGoal(goalMission4, true);
		EnableGoal(goalMission5, true);

		AddBriefing("translateBriefingMissionRUS_Base_StartInfo");

		return CheckBuildings;
	}

	state CheckBuildings
	{
		if ( m_pPlayer.GetNumberOfBuildings() < 10 )
		{
			AddBriefing("translateBriefingMissionRUS_Base_MissionFail");

			EndMission(false);

			return Nothing;
		}
		else
		{
			return CheckBuildings;
		}
	}

	state Nothing
	{
		return Nothing;
	}

	event SetupInterface()
	{
	}

	event CustomEvent0(int nMission, int nNotUsed1, int nNotUsed2, int nNotUsed3)
	{
		SetGoalState(nMission, goalAchieved);
	}
}