campaign "translateCampaignUSA_2"
{
	consts
	{
		raceUSA = 1;
		raceRUS = 2;
		raceIRQ = 3;

		mis1 = 5;
		mis2 = 6;
		mis3 = 7;
		mis4 = 8;
		mis5 = 9;
	}
	
	state Initialize;
    state LoadFirstMission;
    state ShowOutro;
	state ShowCredits;
    state EndCampaign;
	state Nothing;
	
	state Initialize
	{
		CreateGamePlayer(0, raceUSA, playerLocal, null);

		SetTime(100);

		RegisterMission(mis1, "!MissionUSA_6","USA\\Missions\\MissionUSA_6","translateBriefingShortMissionUSA_6", 0, 0, 0, 0, 0, 0, mis2);
		RegisterMission(mis2, "!MissionUSA_7","USA\\Missions\\MissionUSA_7","translateBriefingShortMissionUSA_7", 0, 0, 0, 0, 0, 0, mis3);
		RegisterMission(mis3, "!MissionUSA_8","USA\\Missions\\MissionUSA_8","translateBriefingShortMissionUSA_8", 0, 0, 0, 0, 0, 0, mis4);
		RegisterMission(mis4, "!MissionUSA_9","USA\\Missions\\MissionUSA_9","translateBriefingShortMissionUSA_9", 0, 0, 0, 0, 0, 0, mis5);
		RegisterMission(mis5, "!MissionUSA_10","USA\\Missions\\MissionUSA_10","translateBriefingShortMissionUSA_10", 0, 0, 0, 0, 0, 0);

        ForceKeepBitmapAfterStatistic();

        ShowMissionVideoDialog("USA2_Intro", null, true);
		SetLoadBitmap("Interface\\Bkg0125.tex");

		EnableGameFeature
			(
//			lockResearchDialog |
			lockConstructionDialog |
			lockUpgradeWeaponDialog |
			lockAllianceDialog |
			lockGiveMoneyDialog |
			lockGiveUnitsDialog |
//			lockShowToolbar |
//			lockToolbarMap |
//			lockToolbarPanel |
			lockToolbarNextWorld |
			lockToolbarLevelName |
//			lockToolbarTunnels |
//			lockToolbarSwitchMode |
//			lockToolbarResearching |
			lockToolbarConstruction |
			lockToolbarAlliance |
			lockToolbarGiveMoney |
//			lockToolbarObjectives |
//			lockToolbarMenu |
//			lockToolbarMoney |
			lockToolbarEnergy |
			lockDisplayToolbarLevelName |
//			lockDisplayToolbarMoney |
			lockDisplayToolbarEnergy |
//			lockCreateBuildPanel |
//			lockCreatePanel |
//			lockCreateMap |
			0, true);
		
		return LoadFirstMission, 1;
	}

    state LoadFirstMission
    {
		LoadMission(0, mis1);

		SetAvailableWorlds(1);
		SetActivePlayerAndWorld(0,0);

        return Nothing,0;
    }

	state Nothing
	{
        return Nothing,0;
	}

    state ShowOutro
    {
        ShowMissionVideoDialog("USA2_Outro", null, true);

        return ShowCredits, 0;
    }

	state ShowCredits
	{
		ShowMissionVideoDialog("credits", null, true);

        return EndCampaign, 0;
	}

    state EndCampaign
	{
        EndGame("");

        return Nothing,0;
    }

	int m_nNextMission;

	state LoadNextMission
	{
		LoadMission(0, m_nNextMission);

		return Nothing;
	}

    //wersja gdy po ostatniej misji sa statystyki
	event EndMission(int iMission, int nResult)
	{
		ForceKeepBitmapAfterStatistic();

		if (nResult == true)
		{
			if ( iMission == mis5 )
			{
                state ShowOutro;
			}
            else
            {
			    m_nNextMission = GetNextMission(iMission, 0);

		        state LoadNextMission;
            }
		}
		else
		{
	        EndGame("");

		    state Nothing;
		}
	}


	enum difficultyLevel
    {
        "translateSelectCampaignDifficultyEasy",
		"translateSelectCampaignDifficultyMedium",
		"translateSelectCampaignDifficultyHard",
        multi:
        ""
    }

    command Initialize()
    {
        difficultyLevel = 1;
    }

    command DifficultyLevel(int nLevel) button difficultyLevel
    {
    }
}
