campaign "translateCampaignUSA_1_Demo"
{
	consts
	{
		raceUSA = 1;
		raceRUS = 2;
		raceIRQ = 3;

		mis1 = 0;
		mis2 = 1;
		mis3 = 2;
		mis4 = 3;
		mis5 = 4;
	}
	
	state Initialize;
    state LoadFirstMission;
	state ShowCredits;
    state EndCampaign;
	state Nothing;
	
	state Initialize
	{
		CreateGamePlayer(0, raceUSA, playerLocal, null);

		SetTime(100);

		RegisterMission(mis1, "!MissionUSA_1","USA\\Missions\\MissionUSA_1","translateBriefingShortMissionUSA_1", 0, 0, 0, 0, 0, 0, mis2);
//		RegisterMission(mis2, "!MissionUSA_2","USA\\Missions\\MissionUSA_2","translateBriefingShortMissionUSA_2", 0, 0, 0, 0, 0, 0, mis3);
//		RegisterMission(mis3, "!MissionUSA_3","USA\\Missions\\MissionUSA_3","translateBriefingShortMissionUSA_3", 0, 0, 0, 0, 0, 0, mis4);
//		RegisterMission(mis4, "!MissionUSA_4","USA\\Missions\\MissionUSA_4","translateBriefingShortMissionUSA_4", 0, 0, 0, 0, 0, 0, mis5);
//		RegisterMission(mis5, "!MissionUSA_5","USA\\Missions\\MissionUSA_5","translateBriefingShortMissionUSA_5", 0, 0, 0, 0, 0, 0);

        SetLoadBitmap("Interface\\Bkg0125.tex");

		EnableGameFeature
			(
//			lockResearchDialog |
			lockConstructionDialog |
			lockUpgradeWeaponDialog |
			lockAllianceDialog |
			lockGiveMoneyDialog |
			lockGiveUnitsDialog |
//			lockShowToolbar |
//			lockToolbarMap |
//			lockToolbarPanel |
			lockToolbarNextWorld |
			lockToolbarLevelName |
//			lockToolbarTunnels |
//			lockToolbarSwitchMode |
//			lockToolbarResearching |
			lockToolbarConstruction |
			lockToolbarAlliance |
			lockToolbarGiveMoney |
//			lockToolbarObjectives |
//			lockToolbarMenu |
//			lockToolbarMoney |
			lockToolbarEnergy |
			lockDisplayToolbarLevelName |
//			lockDisplayToolbarMoney |
			lockDisplayToolbarEnergy |
//			lockCreateBuildPanel |
//			lockCreatePanel |
//			lockCreateMap |
			0, true);
		
		//ForceKeepBitmapAfterStatistic();
        //ShowMissionVideoDialog("USA1_Intro", null, true);
		//return LoadFirstMission, 1;

        LoadMission(0, mis1);
		SetAvailableWorlds(1);
    	SetActivePlayerAndWorld(0,0);
        return Nothing,0;
	}

    state LoadFirstMission
    {
		LoadMission(0, mis1);

		SetAvailableWorlds(1);
		SetActivePlayerAndWorld(0,0);

        return Nothing,0;
    }

	state Nothing
	{
        return Nothing,0;
	}

	state ShowCredits
	{
		ShowMissionVideoDialog("credits", null, true);

        return EndCampaign, 0;
	}

    state EndCampaign
	{
//		EnableCampaign("RUS\\CampaignRUS_1Disabled");
//		EnableCampaign("IRQ\\CampaignIRQ_1Disabled");

		EnableCampaign("USA\\TutorialUSA_2_DemoDisabled");
//		EnableCampaign("USA\\TutorialUSA_3Disabled");
//		EnableCampaign("USA\\TutorialUSA_4Disabled");
//		EnableCampaign("IRQ\\TutorialIRQ_1Disabled");
//		EnableCampaign("RUS\\TutorialRUS_1Disabled");

        EndGame("");

        return Nothing,0;
    }

	int m_nNextMission;

	state LoadNextMission
	{
		LoadMission(0, m_nNextMission);

		return Nothing;
	}

    //wersja gdy po ostatniej misji sa statystyki
	event EndMission(int iMission, int nResult)
	{
		ForceKeepBitmapAfterStatistic();

		if (nResult == true)
		{
			if ( iMission == mis1 )
			{
                state ShowCredits;
			}
            else
            {
			    m_nNextMission = GetNextMission(iMission, 0);

		        state LoadNextMission;
            }
		}
		else
		{
	        EndGame("");

		    state Nothing;
		}
	}


	enum difficultyLevel
    {
        "translateSelectCampaignDifficultyEasy",
		"translateSelectCampaignDifficultyMedium",
		"translateSelectCampaignDifficultyHard",
        multi:
        ""
    }

    command Initialize()
    {
        difficultyLevel = 1;
    }

    command DifficultyLevel(int nLevel) button difficultyLevel
    {
    }

    /*
    //wersja gdy po ostatniej misji ma nie byc statystyk
    event EndingMission(int iMission, int nResult)
    {
        if ((nResult == true) && (iMission == mis5))
        {
            ShowMissionVideoDialog("outro", null, true);
            state LastOutro;
        }
    }

	event EndMission(int iMission, int nResult)
	{
		if (nResult == true)
		{
			if ( iMission == mis5 )
			{
                //obsluga w EndingMission
			}
            else
            {
			    m_nNextMission = GetNextMission(iMission, 0);
		        state LoadNextMission;
            }
		}
		else
		{
			m_nNextMission = iMission;
		    state LoadNextMission;
		}
		//ForceKeepBitmapAfterStatistic();
	}
    */
}
