mission "translateLessonUSA_1"
{
	consts
	{
		goalMoveHero = 0;
		goalFindCrossRoads = 1;
		goalDestroyEnemyUnitsA = 2;
		goalTakeArtifact = 3;
		goalFindFriendlyUnits = 4;
		goalFindEnemyUnits = 5;
		goalDestroyEnemyUnitsB = 6;
		goalFindFriendlyBase = 7;
		goalProtectBase = 8;

		markerHero = 7;
	}

	player m_pPlayer;
	player m_pEnemyUnitsA;
	player m_pEnemyUnitsB;
	player m_pEnemyUnitsC;
	player m_pFriendlyUnits;
	player m_pFriendlyBase;

	unitex m_uHero;

	int m_nGameRectX1;
	int m_nGameRectY1;
	int m_nGameRectX2;
	int m_nGameRectY2;

	int m_bAutoUpdateGameRect;

	int m_bShowedBriefingInfo;

	int m_bCheckNumberOfUnits;
	int m_bCheckPlayerBuildings;

	state Initialize;
	state Start;
	state EndCameraInfo;
	state MoveHero;
	state MovedHero;
	state FindCrossRoads;
	state FoundCrossRoads;
	state DestroyEnemyUnitsA;
	state DestroyedEnemyUnitsA;
	state TakeArtifact;
	state TakenArtifact;
	state FindFriendlyUnits;
	state FoundFriendlyUnits;
	state FoundFriendlyUnitsMessage;
	state FindEnemyUnits;
	state FoundEnemyUnits;
	state DestroyEnemyUnitsB;
	state DestroyedEnemyUnitsB;
	state FindFriendlyBase;
	state FoundFriendlyBase;
	state FoundFriendlyBaseMessage;
	state Attack1;
	state Attack2;
	state Attack3;
	state Attack4;
	state ProtectBase;
	state ProtectedBase;
	state MissionComplete;

	event Timer0()
	{
		int nGameRectX1;
		int nGameRectY1;
		int nGameRectX2;
		int nGameRectY2;

		if ( !m_bAutoUpdateGameRect ) return;

		nGameRectX1 = m_uHero.GetLocationX() - 10;
		nGameRectY1 = m_uHero.GetLocationY() - 13;
		nGameRectX2 = m_uHero.GetLocationX() + 10;
		nGameRectY2 = m_uHero.GetLocationY() + 13;

		if ( nGameRectX1 < m_nGameRectX1 ) m_nGameRectX1 = nGameRectX1;
		if ( nGameRectY1 < m_nGameRectY1 ) m_nGameRectY1 = nGameRectY1;
		if ( nGameRectX2 > m_nGameRectX2 ) m_nGameRectX2 = nGameRectX2;
		if ( nGameRectY2 > m_nGameRectY2 ) m_nGameRectY2 = nGameRectY2;

		SetGameRect(m_nGameRectX1, m_nGameRectY1, m_nGameRectX2, m_nGameRectY2);
	}

	state Initialize
	{
		RegisterGoal(goalMoveHero, "translateGoalLessonUSA_1_MoveHero");
		RegisterGoal(goalFindCrossRoads, "translateGoalLessonUSA_1_FindCrossRoads");
		RegisterGoal(goalDestroyEnemyUnitsA, "translateGoalLessonUSA_1_DestroyEnemyUnitsA");
		RegisterGoal(goalTakeArtifact, "translateGoalLessonUSA_1_TakeArtifact");
		RegisterGoal(goalFindFriendlyUnits, "translateGoalLessonUSA_1_FindFriendlyUnits");
		RegisterGoal(goalFindEnemyUnits, "translateGoalLessonUSA_1_FindEnemyUnits");
		RegisterGoal(goalDestroyEnemyUnitsB, "translateGoalLessonUSA_1_DestroyEnemyUnitsB");
		RegisterGoal(goalFindFriendlyBase, "translateGoalLessonUSA_1_FindFriendlyBase");
		RegisterGoal(goalProtectBase, "translateGoalLessonUSA_1_ProtectBase");

		m_pPlayer = GetPlayer(0);

		m_pEnemyUnitsA = GetPlayer(1);
		m_pEnemyUnitsB = GetPlayer(2);
		m_pEnemyUnitsC = GetPlayer(5);

		m_pFriendlyUnits = GetPlayer(3);
		m_pFriendlyBase = GetPlayer(4);

		m_pPlayer.EnableStatistics(false);
		m_pEnemyUnitsA.EnableStatistics(false);
		m_pEnemyUnitsB.EnableStatistics(false);
		m_pEnemyUnitsC.EnableStatistics(false);
		m_pFriendlyUnits.EnableStatistics(false);
		m_pFriendlyBase.EnableStatistics(false);

		m_uHero = GetUnit(GetPointX(markerHero), GetPointY(markerHero));

		m_pPlayer.LookAt(m_pPlayer.GetStartingPointX(), m_pPlayer.GetStartingPointY(), 6, 0, 0, 0);

		m_pFriendlyUnits.EnableAIFeatures2(ai2ChooseEnemy, false);
		m_pFriendlyUnits.SetNeutral(m_pPlayer);
		m_pPlayer.SetNeutral(m_pFriendlyUnits);

		m_pFriendlyBase.EnableAIFeatures2(ai2ChooseEnemy, false);
		m_pFriendlyBase.SetNeutral(m_pPlayer);
		m_pPlayer.SetNeutral(m_pFriendlyBase);

		m_pFriendlyUnits.EnableAI(false);
		m_pFriendlyBase.EnableAI(false);
		m_pEnemyUnitsA.EnableAI(false);
		m_pEnemyUnitsB.EnableAI(false);
		m_pEnemyUnitsC.EnableAI(false);

		AddConsoleTextDisplay(0, 0, 100, SS_CENTER);
		AddConsoleTextDisplay(1, 0, 100, SS_CENTER);
		AddConsoleTextDisplay(2, 0, 100, SS_CENTER);
		AddConsoleTextDisplay(3, 0, 100, SS_CENTER);
		AddConsoleTextDisplay(4, 0, 100, SS_CENTER);
		AddConsoleTextDisplay(5, 0, 100, SS_CENTER);

		SetTimer(0, 20); // uaktualnianie ograniczenia kamery
		SetTimer(1, 40); // sprawdzanie budynkow gracza

		m_bCheckPlayerBuildings = false;

		m_bAutoUpdateGameRect = true;

		m_nGameRectX1 = m_nGameRectX2 = m_uHero.GetLocationX();
		m_nGameRectY1 = m_nGameRectY2 = m_uHero.GetLocationY();

		m_bShowedBriefingInfo = false;

		return Start;
	}

	state Start
	{
		EnableGoal(goalMoveHero, true);

		Snow(m_pPlayer.GetStartingPointX(), m_pPlayer.GetStartingPointY(), 30, 200, 200000, 200, 10);

		SetConsoleText(0, "translateMessageLessonUSA_1_CameraInfo_Line1");
		SetConsoleText(1, "translateMessageLessonUSA_1_CameraInfo_Line2");
		SetConsoleText(2, "translateMessageLessonUSA_1_CameraInfo_Line3");
		SetConsoleText(3, "translateMessageLessonUSA_1_CameraInfo_Line4");
		SetConsoleText(4, "translateMessageLessonUSA_1_CameraInfo_Line5");
		SetConsoleText(5, "translateMessageLessonUSA_1_CameraInfo_Line6");

		PlayWave("Tutorials\\USA_Tutorial01_01.wav");

		return EndCameraInfo,500;
	}

	state EndCameraInfo
	{
		if ( Distance(m_uHero.GetLocationX(), m_uHero.GetLocationY(), GetPointX(markerHero), GetPointY(markerHero)) > 0 )
		{
			CreateArtefact("ARTIFACT_CLICK_ME_BIG", GetPointX(markerHero), GetPointY(markerHero), 0, 0);

			return MovedHero;
		}
		else
		{
			CreateArtefact("ARTIFACT_CLICK_ME_BIG", GetPointX(markerHero), GetPointY(markerHero), 0, 0);

			m_pPlayer.DelayedLookAt(m_pPlayer.GetStartingPointX(), m_pPlayer.GetStartingPointY(), 6, 0, 0, 0, 40, 1);

			SetConsoleText(0, "translateMessageLessonUSA_1_MoveHero_Line1");
			SetConsoleText(1, "translateMessageLessonUSA_1_MoveHero_Line2");
			SetConsoleText(2, "translateMessageLessonUSA_1_MoveHero_Line3");
			SetConsoleText(3, "translateMessageLessonUSA_1_MoveHero_Line4");
			SetConsoleText(4, "translateMessageLessonUSA_1_MoveHero_Line5");
			SetConsoleText(5, "translateMessageLessonUSA_1_MoveHero_Line6");

			PlayWave("Tutorials\\USA_Tutorial01_02.wav");

			return MoveHero, 300;
		}
	}

	state MoveHero
	{
		if ( Distance(m_uHero.GetLocationX(), m_uHero.GetLocationY(), GetPointX(markerHero), GetPointY(markerHero)) > 0 )
		{
			return MovedHero;
		}
		else
		{
			return MoveHero;
		}
	}

	state MovedHero
	{
		RemoveArtefact(GetPointX(markerHero), GetPointY(markerHero), 0);

		CreateArtefact("ARTIFACT_GREENARROW_SE", GetPointX( 3), GetPointY( 3), 0, 0);
		CreateArtefact("ARTIFACT_GREENARROW_NE", GetPointX( 4), GetPointY( 4), 0, 0);
		CreateArtefact("ARTIFACT_GREENARROW_SE", GetPointX( 5), GetPointY( 5), 0, 0);
		CreateArtefact("ARTIFACT_GREENARROW_SE", GetPointX( 6), GetPointY( 6), 0, 0);
		CreateArtefact("ARTIFACT_GREENARROW_SE", GetPointX(12), GetPointY(12), 0, 0);
		CreateArtefact("ARTIFACT_GREENARROW_S" , GetPointX(13), GetPointY(13), 0, 0);
		CreateArtefact("ARTIFACT_GREENARROW_S" , GetPointX(14), GetPointY(14), 0, 0);
		CreateArtefact("ARTIFACT_GREENARROW_SE", GetPointX(15), GetPointY(15), 0, 0);
		CreateArtefact("ARTIFACT_GREENARROW_SW", GetPointX(16), GetPointY(16), 0, 0);

		AddWorldMapSign(GetPointX(16), GetPointY(16), 0, 0, 65000);

		SetConsoleText(0, "translateMessageLessonUSA_1_FindCrossRoads_Line1");
		SetConsoleText(1, "translateMessageLessonUSA_1_FindCrossRoads_Line2");
		SetConsoleText(2, "translateMessageLessonUSA_1_FindCrossRoads_Line3");
		SetConsoleText(3, "translateMessageLessonUSA_1_FindCrossRoads_Line4");
		SetConsoleText(4, "translateMessageLessonUSA_1_FindCrossRoads_Line5");
		SetConsoleText(5, "translateMessageLessonUSA_1_FindCrossRoads_Line6");

		PlayWave("Tutorials\\USA_Tutorial01_03.wav");

		SetGoalState(goalMoveHero, goalAchieved);
		EnableGoal(goalFindCrossRoads, true);

		return FindCrossRoads;
	}

	state FindCrossRoads
	{
		if ( ! m_bShowedBriefingInfo && m_uHero.GetLocationY() >= GetPointY(12) )
		{
			AddBriefing("translateBriefingLessonUSA_1_BriefingInfo");

			m_bShowedBriefingInfo = true;
		}

		if ( m_uHero.GetLocationY() >= GetPointY(16) )
		{
			return FoundCrossRoads;
		}
		else
		{
			return FindCrossRoads;
		}
	}

	state FoundCrossRoads
	{
		int i;

		for ( i= 3; i<= 6; i=i+1 ) RemoveArtefact(GetPointX(i), GetPointY(i), 0);
		for ( i=12; i<=16; i=i+1 ) RemoveArtefact(GetPointX(i), GetPointY(i), 0);

		CreateArtefact("ARTIFACT_REDARROW_SW", GetPointX(17), GetPointY(17), 0, 0);

		RemoveWorldMapSign(GetPointX(16), GetPointY(16), 0);

		SetConsoleText(0, "translateMessageLessonUSA_1_DestroyEnemyUnitsA_Line1");
		SetConsoleText(1, "translateMessageLessonUSA_1_DestroyEnemyUnitsA_Line2");
		SetConsoleText(2, "translateMessageLessonUSA_1_DestroyEnemyUnitsA_Line3");
		SetConsoleText(3, "translateMessageLessonUSA_1_DestroyEnemyUnitsA_Line4");
		SetConsoleText(4, "translateMessageLessonUSA_1_DestroyEnemyUnitsA_Line5");
		SetConsoleText(5, "translateMessageLessonUSA_1_DestroyEnemyUnitsA_Line6");

		PlayWave("Tutorials\\USA_Tutorial01_04.wav");

		AddWorldMapSign(m_pEnemyUnitsA.GetStartingPointX(), m_pEnemyUnitsA.GetStartingPointY(), 0, 1, 65000);

		m_bAutoUpdateGameRect = false;
		SetGameRect(m_pEnemyUnitsA.GetStartingPointX()-3, GetPointY(16)-3, GetPointX(16)+3, m_pEnemyUnitsA.GetStartingPointY()+3);

		SetGoalState(goalFindCrossRoads, goalAchieved);
		EnableGoal(goalDestroyEnemyUnitsA, true);

		m_bCheckNumberOfUnits = true;

		return DestroyEnemyUnitsA;
	}

	state DestroyEnemyUnitsA
	{
		if ( !m_bCheckNumberOfUnits )
		{
			return DestroyEnemyUnitsA;
		}

		m_bCheckNumberOfUnits = false;

		if ( m_pEnemyUnitsA.GetNumberOfUnits() == 0 )
		{
			return DestroyedEnemyUnitsA;
		}
		else
		{
			return DestroyEnemyUnitsA;
		}
	}

	state DestroyedEnemyUnitsA
	{
		RemoveArtefact(GetPointX(17), GetPointY(17), 0);

		RemoveWorldMapSign(m_pEnemyUnitsA.GetStartingPointX(), m_pEnemyUnitsA.GetStartingPointY(), 0);

		CreateArtefact("ARTIFACT_GREENARROW_NE", GetPointX(18), GetPointY(18), 0, 0);
		CreateArtefact("ARTIFACT_GREENARROW_SE", GetPointX(19), GetPointY(19), 0, 0);

		CreateArtefact("ARTIFACT_AMMO", GetPointX(20), GetPointY(20), 0, 0);

		SetConsoleText(0, "translateMessageLessonUSA_1_TakeArtifact_Line1");
		SetConsoleText(1, "translateMessageLessonUSA_1_TakeArtifact_Line2");
		SetConsoleText(2, "translateMessageLessonUSA_1_TakeArtifact_Line3");
		SetConsoleText(3, "translateMessageLessonUSA_1_TakeArtifact_Line4");
		SetConsoleText(4, "translateMessageLessonUSA_1_TakeArtifact_Line5");
		SetConsoleText(5, "translateMessageLessonUSA_1_TakeArtifact_Line6");

		PlayWave("Tutorials\\USA_Tutorial01_05.wav");

		AddWorldMapSign(GetPointX(20), GetPointY(20), 0, 0, 65000);

		SetGameRect(GetLeft()+17, GetPointY(16)-1, GetRight()-17, GetBottom()-17);

		SetGoalState(goalDestroyEnemyUnitsA, goalAchieved);
		EnableGoal(goalTakeArtifact, true);

		return TakeArtifact;
	}

	state TakeArtifact
	{
		if ( Distance(m_uHero.GetLocationX(), m_uHero.GetLocationY(), GetPointX(20), GetPointY(20)) == 0 )
		{
			return TakenArtifact;
		}
		else
		{
			return TakeArtifact;
		}
	}

	state TakenArtifact
	{
		int i;

		for ( i=18; i<=19; i=i+1 ) RemoveArtefact(GetPointX(i), GetPointY(i), 0);

		RemoveWorldMapSign(GetPointX(20), GetPointY(20), 0);

		CreateArtefact("ARTIFACT_GREENARROW_SE", GetPointX(21), GetPointY(21), 0, 0);
		CreateArtefact("ARTIFACT_GREENARROW_SE", GetPointX(22), GetPointY(22), 0, 0);
		CreateArtefact("ARTIFACT_GREENARROW_E" , GetPointX(23), GetPointY(23), 0, 0);
		CreateArtefact("ARTIFACT_GREENARROW_NE", GetPointX(24), GetPointY(24), 0, 0);
		CreateArtefact("ARTIFACT_GREENARROW_SE", GetPointX(25), GetPointY(25), 0, 0);
		CreateArtefact("ARTIFACT_GREENARROW_SE", GetPointX(26), GetPointY(26), 0, 0);

		SetConsoleText(0, "translateMessageLessonUSA_1_FindFriendlyUnits_Line1");
		SetConsoleText(1, "translateMessageLessonUSA_1_FindFriendlyUnits_Line2");
		SetConsoleText(2, "translateMessageLessonUSA_1_FindFriendlyUnits_Line3");
		SetConsoleText(3, "translateMessageLessonUSA_1_FindFriendlyUnits_Line4");
		SetConsoleText(4, "translateMessageLessonUSA_1_FindFriendlyUnits_Line5");
		SetConsoleText(5, "translateMessageLessonUSA_1_FindFriendlyUnits_Line6");

		PlayWave("Tutorials\\USA_Tutorial01_06.wav");

		AddWorldMapSign(m_pFriendlyUnits.GetStartingPointX(), m_pFriendlyUnits.GetStartingPointY(), 0, 0, 65000);

		SetGoalState(goalTakeArtifact, goalAchieved);
		EnableGoal(goalFindFriendlyUnits, true);

		return FindFriendlyUnits;
	}

	state FindFriendlyUnits
	{
		if ( Distance(m_uHero.GetLocationX(), m_uHero.GetLocationY(), m_pFriendlyUnits.GetStartingPointX(), m_pFriendlyUnits.GetStartingPointY()) <= 2 )
		{
			return FoundFriendlyUnits;
		}
		else
		{
			return FindFriendlyUnits;
		}
	}

	state FoundFriendlyUnits
	{
		int i;

		for ( i=21; i<=26; i=i+1 ) RemoveArtefact(GetPointX(i), GetPointY(i), 0);

		RemoveWorldMapSign(m_pFriendlyUnits.GetStartingPointX(), m_pFriendlyUnits.GetStartingPointY(), 0);

		m_pFriendlyUnits.GiveAllUnitsTo(m_pPlayer);

		CreateArtefact("ARTIFACT_GREENARROW_NE", GetPointX(28), GetPointY(28), 0, 0);
		CreateArtefact("ARTIFACT_GREENARROW_E" , GetPointX(29), GetPointY(29), 0, 0);
		CreateArtefact("ARTIFACT_GREENARROW_NE", GetPointX(30), GetPointY(30), 0, 0);
		CreateArtefact("ARTIFACT_GREENARROW_N" , GetPointX(31), GetPointY(31), 0, 0);
		CreateArtefact("ARTIFACT_GREENARROW_NE", GetPointX(32), GetPointY(32), 0, 0);
		CreateArtefact("ARTIFACT_GREENARROW_NW", GetPointX(33), GetPointY(33), 0, 0);

		CreateArtefact("ARTIFACT_REDARROW_NW", GetPointX(34), GetPointY(34), 0, 0);

		SetGoalState(goalFindFriendlyUnits, goalAchieved);
		EnableGoal(goalFindEnemyUnits, true);

		AddBriefing("translateBriefingLessonUSA_1_InterfaceInfo");

		AddWorldMapSign(m_pEnemyUnitsB.GetStartingPointX(), m_pEnemyUnitsB.GetStartingPointY(), 0, 1, 65000);

		SetGameRect(GetLeft()+17, m_pEnemyUnitsB.GetStartingPointY()-5, GetRight()-17, GetBottom()-17);

		return FoundFriendlyUnitsMessage, 1;
	}

	state FoundFriendlyUnitsMessage
	{
		SetConsoleText(0, "translateMessageLessonUSA_1_FindEnemyUnits_Line1");
		SetConsoleText(1, "translateMessageLessonUSA_1_FindEnemyUnits_Line2");
		SetConsoleText(2, "translateMessageLessonUSA_1_FindEnemyUnits_Line3");
		SetConsoleText(3, "translateMessageLessonUSA_1_FindEnemyUnits_Line4");
		SetConsoleText(4, "translateMessageLessonUSA_1_FindEnemyUnits_Line5");
		SetConsoleText(5, "translateMessageLessonUSA_1_FindEnemyUnits_Line6");

		PlayWave("Tutorials\\USA_Tutorial01_07.wav");

		return FindEnemyUnits;
	}

	state FindEnemyUnits
	{
		if ( m_pPlayer.IsPointLocated(m_pEnemyUnitsB.GetStartingPointX(), m_pEnemyUnitsB.GetStartingPointY()) )
		{
			return FoundEnemyUnits;
		}
		else
		{
			return FindEnemyUnits;
		}
	}

	state FoundEnemyUnits
	{
		int i;

		for ( i=28; i<=33; i=i+1 ) RemoveArtefact(GetPointX(i), GetPointY(i), 0);

		SetConsoleText(0, "translateMessageLessonUSA_1_DestroyEnemyUnitsB_Line1");
		SetConsoleText(1, "translateMessageLessonUSA_1_DestroyEnemyUnitsB_Line2");
		SetConsoleText(2, "translateMessageLessonUSA_1_DestroyEnemyUnitsB_Line3");
		SetConsoleText(3, "translateMessageLessonUSA_1_DestroyEnemyUnitsB_Line4");
		SetConsoleText(4, "translateMessageLessonUSA_1_DestroyEnemyUnitsB_Line5");
		SetConsoleText(5, "translateMessageLessonUSA_1_DestroyEnemyUnitsB_Line6");

		PlayWave("Tutorials\\USA_Tutorial01_08.wav");

		SetGoalState(goalFindEnemyUnits, goalAchieved);
		EnableGoal(goalDestroyEnemyUnitsB, true);

		m_bCheckNumberOfUnits = true;

		return DestroyEnemyUnitsB;
	}

	state DestroyEnemyUnitsB
	{
		if ( !m_bCheckNumberOfUnits )
		{
			return DestroyEnemyUnitsB;
		}

		m_bCheckNumberOfUnits = false;

		if ( m_pEnemyUnitsB.GetNumberOfUnits() == 0 )
		{
			return DestroyedEnemyUnitsB;
		}
		else
		{
			return DestroyEnemyUnitsB;
		}
	}

	state DestroyedEnemyUnitsB
	{
		RemoveArtefact(GetPointX(34), GetPointY(34), 0);

		RemoveWorldMapSign(m_pEnemyUnitsB.GetStartingPointX(), m_pEnemyUnitsB.GetStartingPointY(), 0);

		SetGameRect(GetLeft()+17, m_pFriendlyBase.GetStartingPointY()-5, GetRight()-17, GetBottom()-17);

		CreateArtefact("ARTIFACT_GREENARROW_W", GetPointX(61), GetPointY(61), 0, 0);
		CreateArtefact("ARTIFACT_GREENARROW_W", GetPointX(62), GetPointY(62), 0, 0);
		CreateArtefact("ARTIFACT_GREENARROW_W", GetPointX(63), GetPointY(63), 0, 0);
		CreateArtefact("ARTIFACT_GREENARROW_N", GetPointX(64), GetPointY(64), 0, 0);

		SetConsoleText(0, "translateMessageLessonUSA_1_FindFriendlyBase_Line1");
		SetConsoleText(1, "translateMessageLessonUSA_1_FindFriendlyBase_Line2");
		SetConsoleText(2, "translateMessageLessonUSA_1_FindFriendlyBase_Line3");
		SetConsoleText(3, "translateMessageLessonUSA_1_FindFriendlyBase_Line4");
		SetConsoleText(4, "translateMessageLessonUSA_1_FindFriendlyBase_Line5");
		SetConsoleText(5, "translateMessageLessonUSA_1_FindFriendlyBase_Line6");

		PlayWave("Tutorials\\USA_Tutorial01_09.wav");

		AddWorldMapSign(m_pFriendlyBase.GetStartingPointX(), m_pFriendlyBase.GetStartingPointY(), 0, 0, 65000);

		SetGoalState(goalDestroyEnemyUnitsB, goalAchieved);
		EnableGoal(goalFindFriendlyBase, true);

		return FindFriendlyBase;
	}

	state FindFriendlyBase
	{
		if ( m_pPlayer.IsPointLocated(m_pFriendlyBase.GetStartingPointX(), m_pFriendlyBase.GetStartingPointY()) )
		{
			return FoundFriendlyBase;
		}
		else
		{
			return FindFriendlyBase;
		}
	}

	state FoundFriendlyBase
	{
		int i;

		for ( i=61; i<=64; i=i+1 ) RemoveArtefact(GetPointX(i), GetPointY(i), 0);

		RemoveWorldMapSign(m_pFriendlyBase.GetStartingPointX(), m_pFriendlyBase.GetStartingPointY(), 0);

		m_pFriendlyBase.GiveAllBuildingsTo(m_pPlayer);
		m_pFriendlyBase.GiveAllUnitsTo(m_pPlayer);

		SetGoalState(goalFindFriendlyBase, goalAchieved);
		EnableGoal(goalProtectBase, true);

		SetConsoleText(0, "translateMessageLessonUSA_1_ProtectBase_Line1");
		SetConsoleText(1, "translateMessageLessonUSA_1_ProtectBase_Line2");
		SetConsoleText(2, "translateMessageLessonUSA_1_ProtectBase_Line3");
		SetConsoleText(3, "translateMessageLessonUSA_1_ProtectBase_Line4");
		SetConsoleText(4, "translateMessageLessonUSA_1_ProtectBase_Line5");
		SetConsoleText(5, "translateMessageLessonUSA_1_ProtectBase_Line6");

		PlayWave("Tutorials\\USA_Tutorial01_10.wav");

		m_bCheckPlayerBuildings = true;

		return FoundFriendlyBaseMessage, 100;
	}

	state FoundFriendlyBaseMessage
	{
		AddBriefing("translateBriefingLessonUSA_1_ProtectBase");

		return Attack1,300;
	}

	function int AttackBase(int iFrom, int iTo)
	{
		int i;
		unitex uTmp;

		for (i=iFrom; i<=iTo; i=i+1)
		{
			uTmp = GetUnit(GetPointX(i), GetPointY(i));
			uTmp.CommandMove(m_pFriendlyBase.GetStartingPointX(), m_pFriendlyBase.GetStartingPointY(), 0);
		}
	}

	state Attack1
	{
		AttackBase(36,41);
		return Attack2,900;
	}

	state Attack2
	{
		AttackBase(42,49);
		return Attack3,900;
	}

	state Attack3
	{
		AttackBase(50,55);
		return Attack4,900;
	}

	state Attack4
	{
		AttackBase(56,60);

		m_bCheckNumberOfUnits = true;

		return ProtectBase;
	}

	state ProtectBase
	{
		if ( !m_bCheckNumberOfUnits )
		{
			return ProtectBase;
		}

		m_bCheckNumberOfUnits = false;

		if ( m_pEnemyUnitsC.GetNumberOfUnits() == 0 )
		{
			return ProtectedBase;
		}
		else
		{
			return ProtectBase;
		}
	}

	state ProtectedBase
	{
		SetGoalState(goalProtectBase, goalAchieved);

		AddBriefing("translateBriefingLessonUSA_1_Accomplished");

		return MissionComplete;
	}

	state MissionComplete
	{
		EndMission(true);
	}

	event UnitDestroyed(unit uUnit)
	{
		m_bCheckNumberOfUnits = true;
	}

	event Timer1()
	{
		if ( m_bCheckPlayerBuildings && m_pPlayer.GetNumberOfBuildings() == 0 )
		{
			AddBriefing("translateBriefingLessonUSA_1_MissionFail");

			EndMission(false);
		}
	}

	event SetupInterface()
	{
		EnableGameFeature
			(
			lockResearchDialog |
			lockConstructionDialog |
			lockUpgradeWeaponDialog |
			lockAllianceDialog |
			lockGiveMoneyDialog |
			lockGiveUnitsDialog |
//			lockShowToolbar |
			lockToolbarMap |
			lockToolbarPanel |
			lockToolbarNextWorld |
			lockToolbarLevelName |
			lockToolbarTunnels |
			lockToolbarSwitchMode |
			lockToolbarResearching |
			lockToolbarConstruction |
			lockToolbarAlliance |
			lockToolbarGiveMoney |
//			lockToolbarObjectives |
//			lockToolbarMenu |
			lockToolbarMoney |
			lockToolbarEnergy |
			lockDisplayToolbarLevelName |
			lockDisplayToolbarMoney |
			lockDisplayToolbarEnergy |
			lockCreateBuildPanel |
//			lockCreatePanel |
//			lockCreateMap |
			0, true);
	}
}