mission "translateLessonUSA_2"
{
	consts
	{
		goalBuildLandingZone = 0;
		goalBuildUnitsA = 1;
		goalDestroyEnemyA = 2;
		goalSellBuildings = 3;
		goalBuildBase = 4;
		goalBuildUnitsB = 5;
		goalDestroyEnemyB = 6;

		markerLookAtPoint = 0;
		markerSupplyCenter = 20;

		markerMapLimiter = 10;
	}

	player m_pPlayer;
	player m_pEnemyA;
	player m_pEnemyB;

	player m_pEnemyAA;

	unitex m_uSupplyCenter;

	int m_bCheckNumberOfUnits;
	int m_bCheckNumberOfBuildings;

	int m_nPrevUnits;

	state Initialize;
	state Start;
	state StartMessage;
	state BuildLandingZone;
	state BuildedLandingZone;
	state BuildUnitsA;
	state BuildedUnitsA;
	state DestroyEnemyA;
	state DestroyedEnemyA;
	state SellBuildings;
	state SoldBuildings;
	state ShowEnemyAA;
	state WaitForUnitDestroyed;
	state EndTransportInfo;
	state EndTransportInfoMessage;
	state BuildBase;
	state BuildedBase;
	state BuildUnitsB;
	state BuildedUnitsB;
	state DestroyEnemyB;
	state DestroyedEnemyB;
	state MissionComplete;

	state Initialize
	{
		RegisterGoal(goalBuildLandingZone, "translateGoalLessonUSA_2_BuildLandingZone");
		RegisterGoal(goalBuildUnitsA, "translateGoalLessonUSA_2_BuildUnitsA");
		RegisterGoal(goalDestroyEnemyA, "translateGoalLessonUSA_2_DestroyEnemyA");
		RegisterGoal(goalSellBuildings, "translateGoalLessonUSA_2_SellBuildings");
		RegisterGoal(goalBuildBase, "translateGoalLessonUSA_2_BuildBase");
		RegisterGoal(goalBuildUnitsB, "translateGoalLessonUSA_2_BuildUnitsB");
		RegisterGoal(goalDestroyEnemyB, "translateGoalLessonUSA_2_DestroyEnemyB");

		m_pPlayer = GetPlayer(0);
		m_pEnemyA = GetPlayer(1);
		m_pEnemyB = GetPlayer(3);

		m_pEnemyAA = GetPlayer(2);

		m_pPlayer.EnableStatistics(false);
		m_pEnemyA.EnableStatistics(false);
		m_pEnemyB.EnableStatistics(false);
		m_pEnemyAA.EnableStatistics(false);

		m_pEnemyA.EnableAI(false);
		m_pEnemyB.EnableAI(false);
		m_pEnemyAA.EnableAI(false);

		m_uSupplyCenter = GetUnit(GetPointX(markerSupplyCenter), GetPointY(markerSupplyCenter));

		m_pPlayer.SetMoney(2000);

		m_pPlayer.EnableBuilding("USA_AIRPORT1", false);
		m_pPlayer.EnableBuilding("USA_AIRPORT2", false);
		m_pPlayer.EnableBuilding("USA_LANDINGZONE", false);
		m_pPlayer.EnableBuilding("USA_NEST", false);
		m_pPlayer.EnableBuilding("USA_TURRET", false);
		m_pPlayer.EnableBuilding("USA_PILLBOX", false);
		m_pPlayer.EnableBuilding("USA_GENERATOR", false);
		m_pPlayer.EnableBuilding("USA_SUPPLYCENTER", false);
		m_pPlayer.EnableBuilding("USA_SUPPLYCENTERBIG", false);
		m_pPlayer.EnableBuilding("USA_SHAFT", false);
		m_pPlayer.EnableBuilding("USA_JAMMER", false);
		m_pPlayer.EnableBuilding("USA_ROCKETCONTROL", false);
		m_pPlayer.EnableBuilding("USA_ROCKETCONTROL_V", false);
		m_pPlayer.EnableBuilding("USA_BOMBCONTROL", false);
		m_pPlayer.EnableBuilding("USA_BOMBCONTROL_V", false);
		m_pPlayer.EnableBuilding("USA_ATTACKCONTROL", false);
		m_pPlayer.EnableBuilding("USA_ATTACKCONTROL_V", false);
		m_pPlayer.EnableBuilding("USA_RADAR", false);
		m_pPlayer.EnableBuilding("USA_GATE", false);
		m_pPlayer.EnableBuilding("USA_PATRIOT", false);
		m_pPlayer.EnableBuilding("USA_PATRIOT_B", false);

		LookAt(GetPointX(markerLookAtPoint), GetPointY(markerLookAtPoint), 6, 0, 60, 0, 0);

		AddConsoleTextDisplay(0, 0, 100, SS_CENTER);
		AddConsoleTextDisplay(1, 0, 100, SS_CENTER);
		AddConsoleTextDisplay(2, 0, 100, SS_CENTER);
		AddConsoleTextDisplay(3, 0, 100, SS_CENTER);
		AddConsoleTextDisplay(4, 0, 100, SS_CENTER);
		AddConsoleTextDisplay(5, 0, 100, SS_CENTER);

		return Start;
	}

	state Start
	{
		EnableGoal(goalBuildLandingZone, true);

		m_pPlayer.EnableCommand(commandSoldBuilding, false);
		m_pPlayer.EnableCommand(commandAutodestruction, false);

		SetGameRect(GetPointX(markerLookAtPoint)-10, GetPointY(markerLookAtPoint)-10, GetRight()-17, GetBottom()-17);

		SetConsoleText(0, "translateMessageLessonUSA_2_BuildLandingZone_Line1");
		SetConsoleText(1, "translateMessageLessonUSA_2_BuildLandingZone_Line2");
		SetConsoleText(2, "translateMessageLessonUSA_2_BuildLandingZone_Line3");
		SetConsoleText(3, "translateMessageLessonUSA_2_BuildLandingZone_Line4");
		SetConsoleText(4, "translateMessageLessonUSA_2_BuildLandingZone_Line5");
		SetConsoleText(5, "translateMessageLessonUSA_2_BuildLandingZone_Line6");

		PlayWave("Tutorials\\USA_Tutorial02_01.wav");

		m_pPlayer.EnableBuilding("USA_LANDINGZONE", true);

		m_pPlayer.SetObjectTemplateCountLimit(1,"USA_LANDINGZONE",null);

		SelectBuildPanelTab(0);

		return StartMessage, 400;
	}

	state StartMessage
	{
		AddBriefing("translateBriefingLessonUSA_2_StartInfo");

		return BuildLandingZone;
	}

	state BuildLandingZone
	{
		if ( m_pPlayer.GetNumberOfBuildings(buildingLandingZone) > 0 )
		{
			return BuildedLandingZone;
		}
		else
		{
			return BuildLandingZone;
		}
	}

	state BuildedLandingZone
	{
		m_pPlayer.EnableBuilding("USA_LANDINGZONE", false);

		m_pPlayer.AddObjectTemplate(null, null, -1, "USA_JEEP2", "USA_JEEP_CHAINGUN", null, null, null);

		SelectBuildPanelTab(1);

		SetConsoleText(0, "translateMessageLessonUSA_2_BuildUnitsA_Line1");
		SetConsoleText(1, "translateMessageLessonUSA_2_BuildUnitsA_Line2");
		SetConsoleText(2, "translateMessageLessonUSA_2_BuildUnitsA_Line3");
		SetConsoleText(3, "translateMessageLessonUSA_2_BuildUnitsA_Line4");
		SetConsoleText(4, "translateMessageLessonUSA_2_BuildUnitsA_Line5");
		SetConsoleText(5, "translateMessageLessonUSA_2_BuildUnitsA_Line6");

		PlayWave("Tutorials\\USA_Tutorial02_02.wav");

		SetGoalState(goalBuildLandingZone, goalAchieved);
		EnableGoal(goalBuildUnitsA, true);

		return BuildUnitsA;
	}

	state BuildUnitsA
	{
		if ( m_pPlayer.GetNumberOfUnits(unitAny|chassisTank) >= 3 )
		{
			return BuildedUnitsA;
		}
		else
		{
			return BuildUnitsA, 100;
		}
	}

	state BuildedUnitsA
	{
		SetGameRect(GetPointX(markerMapLimiter), GetTop()+17, GetRight()-17, GetBottom()-17);

		SetConsoleText(0, "translateMessageLessonUSA_2_DestroyEnemyA_Line1");
		SetConsoleText(1, "translateMessageLessonUSA_2_DestroyEnemyA_Line2");
		SetConsoleText(2, "translateMessageLessonUSA_2_DestroyEnemyA_Line3");
		SetConsoleText(3, "translateMessageLessonUSA_2_DestroyEnemyA_Line4");
		SetConsoleText(4, "translateMessageLessonUSA_2_DestroyEnemyA_Line5");
		SetConsoleText(5, "translateMessageLessonUSA_2_DestroyEnemyA_Line6");

		PlayWave("Tutorials\\USA_Tutorial02_03.wav");

		SetGoalState(goalBuildUnitsA, goalAchieved);
		EnableGoal(goalDestroyEnemyA, true);

		CreateArtefact("ARTIFACT_GREENARROW_N", GetPointX(1), GetPointY(1), 0, 0);
		CreateArtefact("ARTIFACT_GREENARROW_N", GetPointX(2), GetPointY(2), 0, 0);
		CreateArtefact("ARTIFACT_GREENARROW_N", GetPointX(3), GetPointY(3), 0, 0);
		CreateArtefact("ARTIFACT_GREENARROW_N", GetPointX(4), GetPointY(4), 0, 0);
		CreateArtefact("ARTIFACT_REDARROW_N"  , GetPointX(5), GetPointY(5), 0, 0);

		AddWorldMapSign(m_pEnemyA.GetStartingPointX(), m_pEnemyA.GetStartingPointY(), 0, 1, 65000);

		return DestroyEnemyA;
	}

	state DestroyEnemyA
	{
		if	( m_pEnemyA.GetNumberOfBuildings() == 0 )
		{
			return DestroyedEnemyA;
		}
		else
		{
			return DestroyEnemyA;
		}
	}

	state DestroyedEnemyA
	{
		int i;

		for ( i=1; i<=5; i=i+1 ) RemoveArtefact(GetPointX(i), GetPointY(i), 0);

		RemoveWorldMapSign(m_pEnemyA.GetStartingPointX(), m_pEnemyA.GetStartingPointY(), 0);

		m_pPlayer.EnableCommand(commandSoldBuilding, true);

		SetConsoleText(0, "translateMessageLessonUSA_2_SellBuildings_Line1");
		SetConsoleText(1, "translateMessageLessonUSA_2_SellBuildings_Line2");
		SetConsoleText(2, "translateMessageLessonUSA_2_SellBuildings_Line3");
		SetConsoleText(3, "translateMessageLessonUSA_2_SellBuildings_Line4");
		SetConsoleText(4, "translateMessageLessonUSA_2_SellBuildings_Line5");
		SetConsoleText(5, "translateMessageLessonUSA_2_SellBuildings_Line6");

		PlayWave("Tutorials\\USA_Tutorial02_04.wav");

		SetGoalState(goalDestroyEnemyA, goalAchieved);
		EnableGoal(goalSellBuildings, true);

		AddWorldMapSign(GetPointX(markerLookAtPoint), GetPointY(markerLookAtPoint), 0, 0, 65000);

		return SellBuildings;
	}

	state SellBuildings
	{
		if ( m_pPlayer.GetNumberOfBuildings() == 0 )
		{
			return SoldBuildings;
		}
		else
		{
			return SellBuildings;
		}
	}

	state SoldBuildings
	{
		m_pPlayer.RemoveObjectTemplate(null, -1, "USA_JEEP2", "USA_JEEP_CHAINGUN", null, null, null);

		RemoveWorldMapSign(GetPointX(markerLookAtPoint), GetPointY(markerLookAtPoint), 0);

		m_pPlayer.EnableBuilding("USA_GENERATOR", true);
		m_pPlayer.EnableBuilding("USA_SHAFT", true);
		m_pPlayer.EnableBuilding("USA_LANDINGZONE", true);
		m_pPlayer.EnableBuilding("USA_SUPPLYCENTER", true);

		m_pPlayer.SetObjectTemplateCountLimit(3,"USA_GENERATOR",null);
		m_pPlayer.SetObjectTemplateCountLimit(4,"USA_SHAFT",null);
		m_pPlayer.SetObjectTemplateCountLimit(1,"USA_LANDINGZONE",null);
		m_pPlayer.SetObjectTemplateCountLimit(1,"USA_SUPPLYCENTER",null);

		SetConsoleText(0, "translateMessageLessonUSA_2_TransportInfo_Line1");
		SetConsoleText(1, "translateMessageLessonUSA_2_TransportInfo_Line2");
		SetConsoleText(2, "translateMessageLessonUSA_2_TransportInfo_Line3");
		SetConsoleText(3, "translateMessageLessonUSA_2_TransportInfo_Line4");
		SetConsoleText(4, "translateMessageLessonUSA_2_TransportInfo_Line5");
		SetConsoleText(5, "translateMessageLessonUSA_2_TransportInfo_Line6");

		PlayWave("Tutorials\\USA_Tutorial02_08.wav");

		SetGoalState(goalSellBuildings, goalAchieved);

		m_pPlayer.AddMoney(5000);

		AddWorldMapSign(m_pPlayer.GetStartingPointX(), m_pPlayer.GetStartingPointY(), 0, 0, 65000);

		ShowArea(m_pPlayer.GetIFF(), m_pEnemyAA.GetStartingPointX(), m_pEnemyAA.GetStartingPointY(), 0, 5, showAreaPassives|showAreaBuildings|showAreaUnits);

        m_pPlayer.DelayedLookAt(m_pEnemyAA.GetStartingPointX(), m_pEnemyAA.GetStartingPointY(), -1, -1, 0, 0, 200, 1);

//		return ShowEnemyAA, 300;

		return EndTransportInfo, 600;
	}

	state ShowEnemyAA
	{
//		m_uUnit = m_pPlayer.CreateUnit(m_pPlayer.GetStartingPointX(), 17, 0, null, "USA_TRANSPORTER", "USA_TRANSPORTER_Hook", null, null, null);

//		m_uUnit.CommandMove(m_pPlayer.GetStartingPointX(), m_pPlayer.GetStartingPointY(), 0);

//		return WaitForUnitDestroyed, 100;
	}

	state WaitForUnitDestroyed
	{
//		return WaitForUnitDestroyed;
	}

	state EndTransportInfo
	{
		EnableGoal(goalBuildBase, true);

		SetConsoleText(0, "translateMessageLessonUSA_2_BuildBase_Line1");
		SetConsoleText(1, "translateMessageLessonUSA_2_BuildBase_Line2");
		SetConsoleText(2, "translateMessageLessonUSA_2_BuildBase_Line3");
		SetConsoleText(3, "translateMessageLessonUSA_2_BuildBase_Line4");
		SetConsoleText(4, "translateMessageLessonUSA_2_BuildBase_Line5");
		SetConsoleText(5, "translateMessageLessonUSA_2_BuildBase_Line6");

		PlayWave("Tutorials\\USA_Tutorial02_07.wav");

		SelectBuildPanelTab(0);

		return EndTransportInfoMessage, 340;
	}

	state EndTransportInfoMessage
	{
		AddBriefing("translateBriefingLessonUSA_2_BuildBase");

		return BuildBase;
	}

	state BuildBase
	{
		if  (
			m_pPlayer.GetNumberOfBuildings(buildingLandingZone) > 0 &&
			m_pPlayer.GetNumberOfBuildings(buildingPowerPlant) > 0 &&
			m_pPlayer.GetNumberOfBuildings(buildingMine) > 0
			)
		{
			return BuildedBase;
		}
		else
		{
			return BuildBase;
		}
	}

	int m_bGroupUnitsInfoMessageShowed;

	state BuildedBase
	{
		RemoveWorldMapSign(m_pPlayer.GetStartingPointX(), m_pPlayer.GetStartingPointY(), 0);

		m_nPrevUnits = m_pPlayer.GetNumberOfUnits(unitAny|chassisTank);

		m_pPlayer.AddResearch("RES_USA_MORTAR");

		m_pPlayer.AddObjectTemplate(null, null, -1, "USA_JEEP1", "USA_JEEP_MORTAR", null, null, null);
		m_pPlayer.AddObjectTemplate(null,null,-1,"USA_SUPPLIER",null,null,null,null);

		SetConsoleText(0, "translateMessageLessonUSA_2_BuildUnitsB_Line1");
		SetConsoleText(1, "translateMessageLessonUSA_2_BuildUnitsB_Line2");
		SetConsoleText(2, "translateMessageLessonUSA_2_BuildUnitsB_Line3");
		SetConsoleText(3, "translateMessageLessonUSA_2_BuildUnitsB_Line4");
		SetConsoleText(4, "translateMessageLessonUSA_2_BuildUnitsB_Line5");
		SetConsoleText(5, "translateMessageLessonUSA_2_BuildUnitsB_Line6");

		PlayWave("Tutorials\\USA_Tutorial02_09.wav");

		SetGoalState(goalBuildBase, goalAchieved);
		EnableGoal(goalBuildUnitsB, true);

		SelectBuildPanelTab(1);

		m_bGroupUnitsInfoMessageShowed = false;

		return BuildUnitsB;
	}

	state BuildUnitsB
	{
		int nUnits;
		
		nUnits = m_pPlayer.GetNumberOfUnits(unitAny|chassisTank);

		if ( !m_bGroupUnitsInfoMessageShowed && nUnits == m_nPrevUnits + 1 )
		{
			SetConsoleText(0, "translateMessageLessonUSA_2_GroupUnitsInfo_Line1");
			SetConsoleText(1, "translateMessageLessonUSA_2_GroupUnitsInfo_Line2");
			SetConsoleText(2, "translateMessageLessonUSA_2_GroupUnitsInfo_Line3");
			SetConsoleText(3, "translateMessageLessonUSA_2_GroupUnitsInfo_Line4");
			SetConsoleText(4, "translateMessageLessonUSA_2_GroupUnitsInfo_Line5");
			SetConsoleText(5, "translateMessageLessonUSA_2_GroupUnitsInfo_Line6");

			PlayWave("Tutorials\\USA_Tutorial02_10.wav");

			m_bGroupUnitsInfoMessageShowed = true;

			return BuildUnitsB, 100;
		}
		else if ( nUnits >= m_nPrevUnits + 5 )
		{
			return BuildedUnitsB;
		}
		else
		{
			return BuildUnitsB, 100;
		}
	}

	state BuildedUnitsB
	{
		SetGameRect(0, 0, 0, 0);

		SetConsoleText(0, "translateMessageLessonUSA_2_DestroyEnemyB_Line1");
		SetConsoleText(1, "translateMessageLessonUSA_2_DestroyEnemyB_Line2");
		SetConsoleText(2, "translateMessageLessonUSA_2_DestroyEnemyB_Line3");
		SetConsoleText(3, "translateMessageLessonUSA_2_DestroyEnemyB_Line4");
		SetConsoleText(4, "translateMessageLessonUSA_2_DestroyEnemyB_Line5");
		SetConsoleText(5, "translateMessageLessonUSA_2_DestroyEnemyB_Line6");

		PlayWave("Tutorials\\USA_Tutorial02_11.wav");

		SetGoalState(goalBuildUnitsB, goalAchieved);
		EnableGoal(goalDestroyEnemyB, true);

		CreateArtefact("ARTIFACT_GREENARROW_W" , GetPointX( 6), GetPointY( 6), 0, 0);
		CreateArtefact("ARTIFACT_GREENARROW_W" , GetPointX( 7), GetPointY( 7), 0, 0);
		CreateArtefact("ARTIFACT_REDARROW_W"   , GetPointX( 8), GetPointY( 8), 0, 0);
		CreateArtefact("ARTIFACT_REDARROW_W"   , GetPointX( 9), GetPointY( 9), 0, 0);
		CreateArtefact("ARTIFACT_REDARROW_S"   , GetPointX(11), GetPointY(11), 0, 0);
		CreateArtefact("ARTIFACT_REDARROW_S"   , GetPointX(12), GetPointY(12), 0, 0);
		CreateArtefact("ARTIFACT_REDARROW_S"   , GetPointX(13), GetPointY(13), 0, 0);
		CreateArtefact("ARTIFACT_REDARROW_S"   , GetPointX(14), GetPointY(14), 0, 0);
		CreateArtefact("ARTIFACT_REDARROW_S"   , GetPointX(15), GetPointY(15), 0, 0);
		CreateArtefact("ARTIFACT_GREENARROW_N" , GetPointX(16), GetPointY(16), 0, 0);

		AddWorldMapSign(m_pEnemyB.GetStartingPointX(), m_pEnemyB.GetStartingPointY(), 0, 1, 65000);

		m_bCheckNumberOfUnits = true;
		m_bCheckNumberOfBuildings = true;

		return DestroyEnemyB;
	}

	state DestroyEnemyB
	{
		if ( !m_bCheckNumberOfUnits && !m_bCheckNumberOfBuildings )
		{
			return DestroyEnemyB;
		}

		m_bCheckNumberOfUnits = false;
		m_bCheckNumberOfBuildings = false;

		if	(
			m_pEnemyB.GetNumberOfUnits() == 0 &&
			m_pEnemyB.GetNumberOfBuildings() == 0
			)
		{
			return DestroyedEnemyB;
		}
		else
		{
			return DestroyEnemyB;
		}
	}

	state DestroyedEnemyB
	{
		int i;

		for ( i=6; i<=16; i=i+1 ) if ( i != 10 ) RemoveArtefact(GetPointX(i), GetPointY(i), 0);

		RemoveWorldMapSign(m_pEnemyB.GetStartingPointX(), m_pEnemyB.GetStartingPointY(), 0);

		SetGoalState(goalDestroyEnemyB, goalAchieved);

		AddBriefing("translateBriefingLessonUSA_2_MissionComplete");

		return MissionComplete;
	}

	state MissionComplete
	{
		EndMission(true);
	}

	event UnitDestroyed(unit uUnit)
	{
		m_bCheckNumberOfUnits = true;

		if ( uUnit.GetIFF() == m_pPlayer.GetIFF() )
		{
			if ( m_nPrevUnits > 0 )
			{
				m_nPrevUnits = m_nPrevUnits - 1;
			}
		}
	}

	event BuildingDestroyed(unit uBuilding)
	{
		m_bCheckNumberOfBuildings = true;

		if ( state == DestroyEnemyA && uBuilding != m_uSupplyCenter && m_uSupplyCenter.IsLive() )
		{
			SetConsoleText(0, "translateMessageLessonUSA_2_DestroySupplyCenter_Line1");
			SetConsoleText(1, "translateMessageLessonUSA_2_DestroySupplyCenter_Line2");
			SetConsoleText(2, "translateMessageLessonUSA_2_DestroySupplyCenter_Line3");
			SetConsoleText(3, "translateMessageLessonUSA_2_DestroySupplyCenter_Line4");
			SetConsoleText(4, "translateMessageLessonUSA_2_DestroySupplyCenter_Line5");
			SetConsoleText(5, "translateMessageLessonUSA_2_DestroySupplyCenter_Line6");

			PlayWave("Tutorials\\USA_Tutorial02_05.wav");
		}
	}

	event SetupInterface()
	{
		EnableGameFeature
			(
			lockResearchDialog |
			lockConstructionDialog |
			lockUpgradeWeaponDialog |
			lockAllianceDialog |
			lockGiveMoneyDialog |
			lockGiveUnitsDialog |
//			lockShowToolbar |
			lockToolbarMap |
			lockToolbarPanel |
			lockToolbarNextWorld |
			lockToolbarLevelName |
			lockToolbarTunnels |
			lockToolbarSwitchMode |
			lockToolbarResearching |
			lockToolbarConstruction |
			lockToolbarAlliance |
			lockToolbarGiveMoney |
//			lockToolbarObjectives |
//			lockToolbarMenu |
//			lockToolbarMoney |
			lockToolbarEnergy |
			lockDisplayToolbarLevelName |
//			lockDisplayToolbarMoney |
			lockDisplayToolbarEnergy |
//			lockCreateBuildPanel |
//			lockCreatePanel |
//			lockCreateMap |
			0, true);
	}
}
