mission "translateLessonUSA_3"
{
	consts
	{
		goalCaptureEnemyBase = 0;
		goalMoveUnitsToBase = 1;
		goalBuildHelicopters = 2;
		goalTransportUnits = 3;
		goalDestroyEnemy = 4;

		markerAPC = 0;
		markerRepairer = 1;
		markerUnitToTransport1 = 23;
		markerUnitToTransport2 = 24;
		markerUnitToTransport3 = 25;
		markerDestinationLocation = 18;

		markerBuilder = 27;
	}

	player m_pPlayer;
	player m_pFriendlyUnits;
	player m_pEnemyBase;
	player m_pEnemy;

	unitex m_uRepairer;
	unitex m_uAPC;

	unitex m_uUTT1;
	unitex m_uUTT2;
	unitex m_uUTT3;

	unitex m_uBuilder;

	int m_bCheckNumberOfUnits;
	int m_bCheckNumberOfBuildings;

	state Initialize;
	state Start;
	state StartMessage;
	state ShowedAPC;
	state ShowedRepairer;
	state BeforeCaptureEnemyBase;
	state CaptureEnemyBase;
	state CapturedEnemyBase;
	state ShowedFriendlyUnits;
	state ShowedFriendlyUnitsMessage;
	state BeforeMoveUnitsToBase;
	state MoveUnitsToBase;
	state MovedUnitsToBase;
	state MovedUnitsToBaseMessage;
	state BuildHelicopters;
	state BuildedHelicopters;
	state BuildedHelicoptersMessage;
	state TransportUnits;
	state TransportedUnits;
	state TransportedUnitsMessage;
	state DestroyEnemy;
	state DestroyedEnemy;
	state MissionComplete;

	state Initialize
	{
		RegisterGoal(goalCaptureEnemyBase, "translateGoalLessonUSA_3_CaptureEnemyBase");
		RegisterGoal(goalMoveUnitsToBase, "translateGoalLessonUSA_3_MoveUnitsToBase");
		RegisterGoal(goalBuildHelicopters, "translateGoalLessonUSA_3_BuildHelicopters");
		RegisterGoal(goalTransportUnits, "translateGoalLessonUSA_3_TransportUnits");
		RegisterGoal(goalDestroyEnemy, "translateGoalLessonUSA_3_DestroyEnemy");

		m_pPlayer = GetPlayer(0);
		m_pFriendlyUnits = GetPlayer(2);
		m_pEnemyBase = GetPlayer(1);
		m_pEnemy = GetPlayer(3);

		m_uRepairer = GetUnit(GetPointX(markerRepairer), GetPointY(markerRepairer));
		m_uAPC = GetUnit(GetPointX(markerAPC), GetPointY(markerAPC));

		m_uBuilder = GetUnit(GetPointX(markerBuilder), GetPointY(markerBuilder));

		m_uUTT1 = GetUnit(GetPointX(markerUnitToTransport1), GetPointY(markerUnitToTransport1));
		m_uUTT2 = GetUnit(GetPointX(markerUnitToTransport2), GetPointY(markerUnitToTransport2));
		m_uUTT3 = GetUnit(GetPointX(markerUnitToTransport3), GetPointY(markerUnitToTransport3));

		m_pPlayer.EnableStatistics(false);
		m_pFriendlyUnits.EnableStatistics(false);
		m_pEnemyBase.EnableStatistics(false);
		m_pEnemy.EnableStatistics(false);

		m_pFriendlyUnits.EnableAI(false);
		m_pEnemyBase.EnableAI(false);
		m_pEnemy.EnableAI(false);

		m_pFriendlyUnits.EnableAIFeatures2(ai2ChooseEnemy, false);
		m_pFriendlyUnits.SetNeutral(m_pPlayer);
		m_pPlayer.SetNeutral(m_pFriendlyUnits);

		m_pPlayer.SetMoney(5000);

		SetGameRect(GetLeft()+17, GetPointY(markerDestinationLocation)-1, GetRight()-17, GetBottom()-17);

		m_pPlayer.EnableBuilding("USA_AIRPORT1", false);
		m_pPlayer.EnableBuilding("USA_AIRPORT2", false);
		m_pPlayer.EnableBuilding("USA_LANDINGZONE", false);
		m_pPlayer.EnableBuilding("USA_NEST", false);
		m_pPlayer.EnableBuilding("USA_TURRET", false);
		m_pPlayer.EnableBuilding("USA_PILLBOX", false);
		m_pPlayer.EnableBuilding("USA_GENERATOR", false);
		m_pPlayer.EnableBuilding("USA_SUPPLYCENTER", false);
		m_pPlayer.EnableBuilding("USA_SUPPLYCENTERBIG", false);
		m_pPlayer.EnableBuilding("USA_SHAFT", false);
		m_pPlayer.EnableBuilding("USA_JAMMER", false);
		m_pPlayer.EnableBuilding("USA_ROCKETCONTROL", false);
		m_pPlayer.EnableBuilding("USA_ROCKETCONTROL_V", false);
		m_pPlayer.EnableBuilding("USA_BOMBCONTROL", false);
		m_pPlayer.EnableBuilding("USA_BOMBCONTROL_V", false);
		m_pPlayer.EnableBuilding("USA_ATTACKCONTROL", false);
		m_pPlayer.EnableBuilding("USA_ATTACKCONTROL_V", false);
		m_pPlayer.EnableBuilding("USA_RADAR", false);
		m_pPlayer.EnableBuilding("USA_GATE", false);
		m_pPlayer.EnableBuilding("USA_PATRIOT", false);
		m_pPlayer.EnableBuilding("USA_PATRIOT_B", false);

		m_pPlayer.LookAt(m_pPlayer.GetStartingPointX(), m_pPlayer.GetStartingPointY(), 6, 0, 0, 0);

		AddConsoleTextDisplay(0, 0, 100, SS_CENTER);
		AddConsoleTextDisplay(1, 0, 100, SS_CENTER);
		AddConsoleTextDisplay(2, 0, 100, SS_CENTER);
		AddConsoleTextDisplay(3, 0, 100, SS_CENTER);
		AddConsoleTextDisplay(4, 0, 100, SS_CENTER);
		AddConsoleTextDisplay(5, 0, 100, SS_CENTER);

		Rain(m_pEnemyBase.GetStartingPointX(), m_pEnemyBase.GetStartingPointY(), 30, 200, 10*60*20, 200, 10);

		m_pPlayer.EnableCommand(commandBuildWideBridge, false);
		m_pPlayer.EnableCommand(commandBuildTrench, false);
		m_pPlayer.EnableCommand(commandBuildFlatTerrain, false);
		m_pPlayer.EnableCommand(commandBuildWall, false);

		return Start;
	}

	state Start
	{
		AddWorldMapSign(m_pEnemyBase.GetStartingPointX(), m_pEnemyBase.GetStartingPointY(), 0, 1, 65000);

		EnableGoal(goalCaptureEnemyBase, true);

		SetConsoleText(0, "translateMessageLessonUSA_3_APCInfo_Line1");
		SetConsoleText(1, "translateMessageLessonUSA_3_APCInfo_Line2");
		SetConsoleText(2, "translateMessageLessonUSA_3_APCInfo_Line3");
		SetConsoleText(3, "translateMessageLessonUSA_3_APCInfo_Line4");
		SetConsoleText(4, "translateMessageLessonUSA_3_APCInfo_Line5");
		SetConsoleText(5, "translateMessageLessonUSA_3_APCInfo_Line6");

		PlayWave("Tutorials\\USA_Tutorial03_01.wav");

		CreateArtefact("ARTIFACT_GREENARROW_N" , GetPointX(2), GetPointY(2), 0, 0);
		CreateArtefact("ARTIFACT_GREENARROW_NW", GetPointX(3), GetPointY(3), 0, 0);
		CreateArtefact("ARTIFACT_GREENARROW_NW", GetPointX(4), GetPointY(4), 0, 0);
		CreateArtefact("ARTIFACT_GREENARROW_N" , GetPointX(5), GetPointY(5), 0, 0);
		CreateArtefact("ARTIFACT_GREENARROW_N" , GetPointX(6), GetPointY(6), 0, 0);
		CreateArtefact("ARTIFACT_REDARROW_E"   , GetPointX(7), GetPointY(7), 0, 0);

		m_pPlayer.DelayedLookAt(m_uAPC.GetLocationX(), m_uAPC.GetLocationY(), -1, -1, 0, 0, 20, 1);

		return ShowedAPC, 460;
	}
	
	state StartMessage
	{
		AddBriefing("translateBriefingLessonUSA_3_CaptureEnemyBase");

		return BeforeCaptureEnemyBase, 1200;
	}

	state ShowedAPC
	{
		SetConsoleText(0, "translateMessageLessonUSA_3_RepairerInfo_Line1");
		SetConsoleText(1, "translateMessageLessonUSA_3_RepairerInfo_Line2");
		SetConsoleText(2, "translateMessageLessonUSA_3_RepairerInfo_Line3");
		SetConsoleText(3, "translateMessageLessonUSA_3_RepairerInfo_Line4");
		SetConsoleText(4, "translateMessageLessonUSA_3_RepairerInfo_Line5");
		SetConsoleText(5, "translateMessageLessonUSA_3_RepairerInfo_Line6");

		PlayWave("Tutorials\\USA_Tutorial03_02.wav");

		m_pPlayer.DelayedLookAt(m_uRepairer.GetLocationX(), m_uRepairer.GetLocationY(), -1, -1, 0, 0, 20, 1);

		return ShowedRepairer, 280;
	}

	state ShowedRepairer
	{
		SetConsoleText(0, "translateMessageLessonUSA_3_UnitsInfo_Line1");
		SetConsoleText(1, "translateMessageLessonUSA_3_UnitsInfo_Line2");
		SetConsoleText(2, "translateMessageLessonUSA_3_UnitsInfo_Line3");
		SetConsoleText(3, "translateMessageLessonUSA_3_UnitsInfo_Line4");
		SetConsoleText(4, "translateMessageLessonUSA_3_UnitsInfo_Line5");
		SetConsoleText(5, "translateMessageLessonUSA_3_UnitsInfo_Line6");

		PlayWave("Tutorials\\USA_Tutorial03_03.wav");

		m_bCheckNumberOfUnits = true;
		m_bCheckNumberOfBuildings = true;

		return StartMessage, 220;
	}

	state BeforeCaptureEnemyBase
	{
		SetConsoleText(0, "");
		SetConsoleText(1, "");
		SetConsoleText(2, "");
		SetConsoleText(3, "");
		SetConsoleText(4, "");
		SetConsoleText(5, "");

		return CaptureEnemyBase;
	}

	state CaptureEnemyBase
	{
		if ( !m_bCheckNumberOfUnits && !m_bCheckNumberOfBuildings )
		{
			return CaptureEnemyBase;
		}

		m_bCheckNumberOfUnits = false;
		m_bCheckNumberOfBuildings = false;

		if	( m_pEnemyBase.GetNumberOfUnits() == 0 && m_pEnemyBase.GetNumberOfBuildings() == 0 )
		{
			return CapturedEnemyBase;
		}
		else
		{
			return CaptureEnemyBase;
		}
	}

	state CapturedEnemyBase
	{
		int i;

		for ( i=2; i<=7; i=i+1 ) RemoveArtefact(GetPointX(i), GetPointY(i), 0);

		RemoveWorldMapSign(m_pEnemyBase.GetStartingPointX(), m_pEnemyBase.GetStartingPointY(), 0);

		EnableInterface(false);

		m_pPlayer.DelayedLookAt(m_pFriendlyUnits.GetStartingPointX(), m_pFriendlyUnits.GetStartingPointY(), -1, -1, 0, 0, 60, 1);

		m_pFriendlyUnits.GiveAllUnitsTo(m_pPlayer);

		SetGoalState(goalCaptureEnemyBase, goalAchieved);

		return ShowedFriendlyUnits, 80;
	}

	state ShowedFriendlyUnits
	{
		AddWorldMapSign(m_pEnemyBase.GetStartingPointX(), m_pEnemyBase.GetStartingPointY(), 0, 0, 65000);

		EnableGoal(goalMoveUnitsToBase, true);
		SetConsoleText(0, "translateMessageLessonUSA_3_BuildBridge_Line1");
		SetConsoleText(1, "translateMessageLessonUSA_3_BuildBridge_Line2");
		SetConsoleText(2, "translateMessageLessonUSA_3_BuildBridge_Line3");
		SetConsoleText(3, "translateMessageLessonUSA_3_BuildBridge_Line4");
		SetConsoleText(4, "translateMessageLessonUSA_3_BuildBridge_Line5");
		SetConsoleText(5, "translateMessageLessonUSA_3_BuildBridge_Line6");

		PlayWave("Tutorials\\USA_Tutorial03_04.wav");

		CreateArtefact("ARTIFACT_GREENARROW_N" , GetPointX( 8), GetPointY( 8), 0, 0);
		CreateArtefact("ARTIFACT_GREENARROW_N" , GetPointX( 9), GetPointY( 9), 0, 0);
		CreateArtefact("ARTIFACT_GREENARROW_E" , GetPointX(10), GetPointY(10), 0, 0);
		CreateArtefact("ARTIFACT_GREENARROW_NE", GetPointX(11), GetPointY(11), 0, 0);
		CreateArtefact("ARTIFACT_GREENARROW_E" , GetPointX(12), GetPointY(12), 0, 0);
		CreateArtefact("ARTIFACT_GREENARROW_NE", GetPointX(13), GetPointY(13), 0, 0);
		CreateArtefact("ARTIFACT_GREENARROW_NE", GetPointX(14), GetPointY(14), 0, 0);
		CreateArtefact("ARTIFACT_GREENARROW_N" , GetPointX(15), GetPointY(15), 0, 0);
		CreateArtefact("ARTIFACT_GREENARROW_N" , GetPointX(16), GetPointY(16), 0, 0);
		CreateArtefact("ARTIFACT_GREENARROW_E" , GetPointX(17), GetPointY(17), 0, 0);

		SelectBuildPanelTab(4);

		return ShowedFriendlyUnitsMessage, 520;
	}

	state ShowedFriendlyUnitsMessage
	{
		EnableInterface(true);

		AddBriefing("translateBriefingLessonUSA_3_MoveUnitsToBase");

		return BeforeMoveUnitsToBase, 1200;
	}

	state BeforeMoveUnitsToBase
	{
		SetConsoleText(0, "");
		SetConsoleText(1, "");
		SetConsoleText(2, "");
		SetConsoleText(3, "");
		SetConsoleText(4, "");
		SetConsoleText(5, "");

		return MoveUnitsToBase;
	}

	state MoveUnitsToBase
	{
		if ( ! m_uBuilder.IsLive() )
		{
			AddBriefing("translateBriefingLessonUSA_1_MissionFail");

			EndMission(false);
		}

		if	(
			(Distance(m_uUTT1.GetLocationX(), m_uUTT1.GetLocationY(), m_pEnemyBase.GetStartingPointX(), m_pEnemyBase.GetStartingPointY()) <= 8 ) &&
			(Distance(m_uUTT2.GetLocationX(), m_uUTT2.GetLocationY(), m_pEnemyBase.GetStartingPointX(), m_pEnemyBase.GetStartingPointY()) <= 8 ) &&
			(Distance(m_uUTT3.GetLocationX(), m_uUTT3.GetLocationY(), m_pEnemyBase.GetStartingPointX(), m_pEnemyBase.GetStartingPointY()) <= 8 )
			)
		{
			return MovedUnitsToBase;
		}
		else
		{
			return MoveUnitsToBase;
		}
	}

	state MovedUnitsToBase
	{
		int i;

		for ( i=8; i<=17; i=i+1 ) RemoveArtefact(GetPointX(i), GetPointY(i), 0);

		RemoveWorldMapSign(m_pEnemyBase.GetStartingPointX(), m_pEnemyBase.GetStartingPointY(), 0);

		SetGoalState(goalMoveUnitsToBase, goalAchieved);

		EnableGoal(goalBuildHelicopters, true);
		SetConsoleText(0, "translateMessageLessonUSA_3_BuildUnit_Line1");
		SetConsoleText(1, "translateMessageLessonUSA_3_BuildUnit_Line2");
		SetConsoleText(2, "translateMessageLessonUSA_3_BuildUnit_Line3");
		SetConsoleText(3, "translateMessageLessonUSA_3_BuildUnit_Line4");
		SetConsoleText(4, "translateMessageLessonUSA_3_BuildUnit_Line5");
		SetConsoleText(5, "translateMessageLessonUSA_3_BuildUnit_Line6");

		PlayWave("Tutorials\\USA_Tutorial03_05.wav");

		m_pPlayer.AddObjectTemplate(null,null,-1,"USA_TRANSPORTER","USA_TRANSPORTER_Hook",null,null,null);

		SelectBuildPanelTab(3);

		return MovedUnitsToBaseMessage, 280;
	}

	state MovedUnitsToBaseMessage
	{
		AddBriefing("translateBriefingLessonUSA_3_BuildHelicopters");

		return BuildHelicopters;
	}

	state BuildHelicopters
	{
		if ( m_pPlayer.GetNumberOfUnits(unitTransporter|chassisHelicopter) >= 2 )
		{
			return BuildedHelicopters;
		}
		else
		{
			return BuildHelicopters, 100;
		}
	}

	state BuildedHelicopters
	{
		AddWorldMapSign(GetPointX(markerDestinationLocation), GetPointY(markerDestinationLocation), 0, 0, 65000);

		SetGoalState(goalBuildHelicopters, goalAchieved);

		EnableGoal(goalTransportUnits, true);
		SetConsoleText(0, "translateMessageLessonUSA_3_TransportUnit_Line1");
		SetConsoleText(1, "translateMessageLessonUSA_3_TransportUnit_Line2");
		SetConsoleText(2, "translateMessageLessonUSA_3_TransportUnit_Line3");
		SetConsoleText(3, "translateMessageLessonUSA_3_TransportUnit_Line4");
		SetConsoleText(4, "translateMessageLessonUSA_3_TransportUnit_Line5");
		SetConsoleText(5, "translateMessageLessonUSA_3_TransportUnit_Line6");

		PlayWave("Tutorials\\USA_Tutorial03_06.wav");

		CreateArtefact("ARTIFACT_GREENARROW_N" , GetPointX(19), GetPointY(19), 0, 0);
		CreateArtefact("ARTIFACT_GREENARROW_N" , GetPointX(20), GetPointY(20), 0, 0);
		CreateArtefact("ARTIFACT_GREENARROW_NE", GetPointX(21), GetPointY(21), 0, 0);
		CreateArtefact("ARTIFACT_GREENARROW_NE", GetPointX(22), GetPointY(22), 0, 0);
		CreateArtefact("ARTIFACT_GREENARROW_N" , GetPointX(26), GetPointY(26), 0, 0);

		CreateArtefact("ARTIFACT_CLICK_ME", GetPointX(18), GetPointY(18), 0, 0);

		return BuildedHelicoptersMessage, 400;
	}

	state BuildedHelicoptersMessage
	{
		AddBriefing("translateBriefingLessonUSA_3_TransportUnits");

		return TransportUnits;
	}

	state TransportUnits
	{
		if	(
			(Distance(m_uUTT1.GetLocationX(), m_uUTT1.GetLocationY(), GetPointX(markerDestinationLocation), GetPointY(markerDestinationLocation)) <= 3 && !m_uUTT1.IsTransported() ) ||
			(Distance(m_uUTT2.GetLocationX(), m_uUTT2.GetLocationY(), GetPointX(markerDestinationLocation), GetPointY(markerDestinationLocation)) <= 3 && !m_uUTT2.IsTransported() ) ||
			(Distance(m_uUTT3.GetLocationX(), m_uUTT3.GetLocationY(), GetPointX(markerDestinationLocation), GetPointY(markerDestinationLocation)) <= 3 && !m_uUTT3.IsTransported() )
			)
		{
			return TransportedUnits;
		}
		else
		{
			return TransportUnits;
		}
	}

	state TransportedUnits
	{
		int i;

		for ( i=18; i<=22; i=i+1 ) RemoveArtefact(GetPointX(i), GetPointY(i), 0);

		RemoveArtefact(GetPointX(26), GetPointY(26), 0);

		RemoveWorldMapSign(GetPointX(markerDestinationLocation), GetPointY(markerDestinationLocation), 0);

		AddWorldMapSign(m_pEnemy.GetStartingPointX(), m_pEnemy.GetStartingPointY(), 0, 1, 65000);

		SetGameRect(0, 0, 0, 0);

		SetGoalState(goalTransportUnits, goalAchieved);

		EnableGoal(goalDestroyEnemy, true);

		if	(
			m_pEnemy.GetNumberOfUnits() == 0 &&
			m_pEnemy.GetNumberOfBuildings() == 0
			)
		{
			return DestroyedEnemy;
		}

		SetConsoleText(0, "translateMessageLessonUSA_3_DestroyEnemy_Line1");
		SetConsoleText(1, "translateMessageLessonUSA_3_DestroyEnemy_Line2");
		SetConsoleText(2, "translateMessageLessonUSA_3_DestroyEnemy_Line3");
		SetConsoleText(3, "translateMessageLessonUSA_3_DestroyEnemy_Line4");
		SetConsoleText(4, "translateMessageLessonUSA_3_DestroyEnemy_Line5");
		SetConsoleText(5, "translateMessageLessonUSA_3_DestroyEnemy_Line6");

		PlayWave("Tutorials\\USA_Tutorial03_07.wav");

		ShowArea(m_pPlayer.GetIFF(), m_pEnemy.GetStartingPointX(), m_pEnemy.GetStartingPointY(), 0, 10, showAreaPassives|showAreaBuildings|showAreaUnits);

		m_bCheckNumberOfUnits = true;
		m_bCheckNumberOfBuildings = true;

		return TransportedUnitsMessage, 160;
	}

	state TransportedUnitsMessage
	{
		AddBriefing("translateBriefingLessonUSA_3_DestroyEnemy");

		return DestroyEnemy;
	}

	state DestroyEnemy
	{
		if ( ! m_uUTT1.IsLive() && ! m_uUTT2.IsLive() && ! m_uUTT3.IsLive() )
		{
			AddBriefing("translateBriefingLessonUSA_1_MissionFail");

			EndMission(false);
		}

		if ( !m_bCheckNumberOfUnits && !m_bCheckNumberOfBuildings )
		{
			return DestroyEnemy;
		}

		m_bCheckNumberOfUnits = false;
		m_bCheckNumberOfBuildings = false;

		if	(
			m_pEnemy.GetNumberOfUnits() == 0 &&
			m_pEnemy.GetNumberOfBuildings() == 0
			)
		{
			return DestroyedEnemy;
		}
		else
		{
			return DestroyEnemy;
		}
	}

	state DestroyedEnemy
	{
		RemoveWorldMapSign(m_pEnemy.GetStartingPointX(), m_pEnemy.GetStartingPointY(), 0);

		SetGoalState(goalDestroyEnemy, goalAchieved);

		AddBriefing("translateBriefingLessonUSA_3_MissionComplete");

		return MissionComplete;
	}

	state MissionComplete
	{
		EndMission(true);
	}

	event UnitDestroyed(unit uUnit)
	{
		m_bCheckNumberOfUnits = true;

		if ( state != DestroyEnemy && uUnit.GetIFF() == m_pPlayer.GetIFF() )
		{
			AddBriefing("translateBriefingLessonUSA_1_MissionFail");

			EndMission(false);
		}
	}

	event BuildingDestroyed(unit uBuilding)
	{
		m_bCheckNumberOfBuildings = true;

		if ( state != DestroyEnemy && uBuilding.GetIFF() == m_pPlayer.GetIFF() )
		{
			AddBriefing("translateBriefingLessonUSA_1_MissionFail");

			EndMission(false);
		}
	}

	event SetupInterface()
	{
		EnableGameFeature
			(
			lockResearchDialog |
			lockConstructionDialog |
			lockUpgradeWeaponDialog |
			lockAllianceDialog |
			lockGiveMoneyDialog |
			lockGiveUnitsDialog |
//			lockShowToolbar |
			lockToolbarMap |
			lockToolbarPanel |
			lockToolbarNextWorld |
			lockToolbarLevelName |
			lockToolbarTunnels |
			lockToolbarSwitchMode |
			lockToolbarResearching |
			lockToolbarConstruction |
			lockToolbarAlliance |
			lockToolbarGiveMoney |
//			lockToolbarObjectives |
//			lockToolbarMenu |
//			lockToolbarMoney |
			lockToolbarEnergy |
			lockDisplayToolbarLevelName |
//			lockDisplayToolbarMoney |
			lockDisplayToolbarEnergy |
//			lockCreateBuildPanel |
//			lockCreatePanel |
//			lockCreateMap |
			0, true);
	}
}
