mission "translateMissionUSA_1"
{
	consts
	{
		goalHeroSurvive = 0;
		goalFindFriendlyUnits = 1;
		goalDestroyEnemiesA = 2;
		goalDetonateBridge = 3;
		goalDestroyEnemiesC = 4;

		markerEndOfBridge = 0;
		markerFriednlyUnits = 1;
		markerBridgeDetonator = 2;

		markerDetonateArea1 = 6; // From
		markerDetonateTo1 = 7; // markerDetonateArea1 + 1 (!)

		markerDetonateArea2 = 4; // From
		markerDetonateTo2 = 5; // markerDetonateArea2 + 1 (!)

		markerMapLimiter = 3;

		markerHero = 8;

		maskDetonator = 512;
	}

	include "UnitTemplates.ech"
	include "Research.ech"

	player m_pPlayer;
	player m_pFriendlyUnits;

	player m_pEnemyA;
	player m_pEnemyB;
	player m_pEnemyC;

	unitex m_uHero;

	int m_nLastDetonatedAreaMarker;

	int m_bCheckNumberOfUnits;
	int m_bCheckNumberOfBuildings;

	state Initialize;
	state Start;
	state BeforeStart;
	state FindFriendlyUnits;
	state FoundFriendlyUnits;
	state DestroyEnemiesA;
	state DestroyedEnemiesA;
	state DetonateBridge;
	state DetonatedBridge;
	state DestroyEnemiesC;
	state DestroyedEnemiesC;
	state MissionComplete;

	function int ModifyDifficulty()
	{
		if ( GetDifficultyLevel() == 0 )
		{
			ClearArea	(65535, GetPointX( 9), GetPointY( 9), GetPointZ( 9), 0);
			ClearArea	(65535, GetPointX(10), GetPointY(10), GetPointZ(10), 0);
			ClearArea	(65535, GetPointX(11), GetPointY(11), GetPointZ(11), 1);
			ClearArea	(65535, GetPointX(12), GetPointY(12), GetPointZ(12), 1);
			ClearArea	(65535, GetPointX(13), GetPointY(13), GetPointZ(13), 0);
			ClearArea	(65535, GetPointX(14), GetPointY(14), GetPointZ(14), 0);
			ClearArea	(65535, GetPointX(17), GetPointY(17), GetPointZ(17), 0);
			ClearArea	(65535, GetPointX(18), GetPointY(18), GetPointZ(18), 2);
			ClearArea	(65535, GetPointX(20), GetPointY(20), GetPointZ(20), 1);
			ClearArea	(65535, GetPointX(21), GetPointY(21), GetPointZ(21), 1);
			ClearArea	(65535, GetPointX(24), GetPointY(24), GetPointZ(24), 0);
			ClearArea	(65535, GetPointX(25), GetPointY(25), GetPointZ(25), 0);
			ClearArea	(65535, GetPointX(26), GetPointY(26), GetPointZ(26), 0);
			ClearArea	(65535, GetPointX(27), GetPointY(27), GetPointZ(27), 0);
			ClearArea	(65535, GetPointX(28), GetPointY(28), GetPointZ(28), 0);
			ClearArea	(65535, GetPointX(29), GetPointY(29), GetPointZ(29), 1);
		}
		else if ( GetDifficultyLevel() == 1 )
		{
			ClearArea	(65535, GetPointX( 9), GetPointY( 9), GetPointZ( 9), 0);
			ClearArea	(65535, GetPointX(10), GetPointY(10), GetPointZ(10), 0);
			ClearArea	(65535, GetPointX(11), GetPointY(11), GetPointZ(11), 0);
			ClearArea	(65535, GetPointX(12), GetPointY(12), GetPointZ(12), 0);
			ClearArea	(65535, GetPointX(13), GetPointY(13), GetPointZ(13), 0);
			ClearArea	(65535, GetPointX(14), GetPointY(14), GetPointZ(14), 0);
			ClearArea	(65535, GetPointX(15), GetPointY(15), GetPointZ(15), 0);
			ClearArea	(65535, GetPointX(16), GetPointY(16), GetPointZ(16), 0);
			ClearArea	(65535, GetPointX(18), GetPointY(18), GetPointZ(18), 1);
			ClearArea	(65535, GetPointX(19), GetPointY(19), GetPointZ(19), 0);
			ClearArea	(65535, GetPointX(20), GetPointY(20), GetPointZ(20), 0);
			ClearArea	(65535, GetPointX(22), GetPointY(22), GetPointZ(22), 1);
			ClearArea	(65535, GetPointX(23), GetPointY(23), GetPointZ(23), 1);
			ClearArea	(65535, GetPointX(26), GetPointY(26), GetPointZ(26), 0);
			ClearArea	(65535, GetPointX(29), GetPointY(29), GetPointZ(29), 0);
		}
		else if ( GetDifficultyLevel() == 2 )
		{
			ClearArea	(65535, GetPointX(15), GetPointY(15), GetPointZ(15), 0);
			ClearArea	(65535, GetPointX(16), GetPointY(16), GetPointZ(16), 0);
			ClearArea	(65535, GetPointX(19), GetPointY(19), GetPointZ(19), 0);
		}
	}

	state Initialize
	{
		ModifyDifficulty();

		RegisterGoal(goalHeroSurvive, "translateGoalMissionUSA_HeroSurvive");
		RegisterGoal(goalFindFriendlyUnits, "translateGoalMissionUSA_1_FindFriendlyUnits");
		RegisterGoal(goalDestroyEnemiesA, "translateGoalMissionUSA_1_DestroyEnemiesA");
		RegisterGoal(goalDetonateBridge, "translateGoalMissionUSA_1_DetonateBridge");
		RegisterGoal(goalDestroyEnemiesC, "translateGoalMissionUSA_1_DestroyEnemiesC");

		m_pPlayer = GetPlayer(0);
		m_pPlayer.EnableStatistics(true);

		m_pFriendlyUnits = GetPlayer(2);
		m_pFriendlyUnits.EnableStatistics(false);

		m_pEnemyA = GetPlayer(7);
		m_pEnemyA.EnableStatistics(true);

		m_pEnemyB = GetPlayer(3);
		m_pEnemyB.EnableStatistics(true);

		m_pEnemyC = GetPlayer(1);
		m_pEnemyC.EnableStatistics(true);

		if ( GetDifficultyLevel() == 0 )
		{
			m_pEnemyA.LoadScript("single\\singleEasy");
			
			m_pEnemyB.LoadScript("single\\singleEasy");
			
			m_pEnemyC.LoadScript("single\\singleEasy");

			m_pEnemyC.EnableAIFeatures(aiBuildBuildings|aiBuildTanks|aiBuildHelicopters, false);
		}
		else if ( GetDifficultyLevel() == 1 )
		{
			m_pEnemyA.LoadScript("single\\singleMedium");
			
			m_pEnemyB.LoadScript("single\\singleMedium");
			
			m_pEnemyC.LoadScript("single\\singleMedium");

//			m_pEnemyC.EnableAIFeatures2(ai2RebuildBaseOnly, true);

			m_pEnemyC.SetMilitaryUnitsLimit(4000);
		}
		else if ( GetDifficultyLevel() == 2 )
		{
			m_pEnemyA.LoadScript("single\\singleHard");
			
			m_pEnemyB.LoadScript("single\\singleHard");
			
			m_pEnemyC.LoadScript("single\\singleHard");

//			m_pEnemyC.EnableAIFeatures2(ai2RebuildBaseOnly, true);

			m_pEnemyC.SetMilitaryUnitsLimit(10000);
		}

		m_pEnemyC.EnableMilitaryUnitsLimit(true);

		m_pEnemyA.EnableAI(true);
		m_pEnemyB.EnableAI(false);
		m_pEnemyC.EnableAI(true);

		m_pEnemyC.SetMoney(20000);

//		m_pEnemyC.EnableAIFeatures(aiEverything, true);

//		m_pEnemyB.EnableAIFeatures(aiEverything, false);
//		m_pEnemyB.EnableAIFeatures(aiEnabled|aiControlDefense , true);

		m_pEnemyC.EnableAIFeatures(aiControlOffense, false);

		m_pEnemyA.EnableAIFeatures(aiBuildBuildings, false);

		m_pEnemyC.SetMaxDistance(30);

		m_pFriendlyUnits.EnableAI(false);
		m_pFriendlyUnits.EnableAIFeatures2(ai2ChooseEnemy, false);

		m_uHero = GetUnit(GetPointX(markerHero), GetPointY(markerHero));

		m_pFriendlyUnits.SetNeutral(m_pPlayer);

		m_pPlayer.SetNeutral(m_pFriendlyUnits);

		m_nLastDetonatedAreaMarker = -1;

		LookAt(m_pPlayer.GetStartingPointX(), m_pPlayer.GetStartingPointY(), 6, 0, 60, 0, 0);

		SetGameRect(GetLeft(), GetPointY(markerMapLimiter), GetRight(), GetBottom()-1);

		m_pPlayer.AddObjectTemplate(null,null,-1,"USA_SUPPLIER",null,null,null,null);

		EnableAllResearchUSA( m_pPlayer, false);
		m_pPlayer.EnableResearch("RES_USA_AMPHIBIA1", true);
		m_pPlayer.EnableResearch("RES_USA_AMMO_MG1", true);

		EnableAllResearchIRQ( m_pEnemyA, false);
		EnableAllResearchIRQ( m_pEnemyB, false);

		EnableAllResearchIRQ( m_pEnemyC, false);
		m_pEnemyC.EnableResearch("RES_IRQ_TANK1", true);

		AddUnitTemplatesIRQ( m_pEnemyA );
		AddUnitTemplatesIRQ( m_pEnemyB );
		AddUnitTemplatesIRQ( m_pEnemyC );

		return BeforeStart, 1;
	}

	state BeforeStart
	{
		PlayTrack("Music\\Briefing.tws");

		return Start;
	}

	state Start
	{
		if ( GetDifficultyLevel() == 1 || GetDifficultyLevel() == 2 )
		{
			m_pEnemyC.EnableAIFeatures2(ai2RebuildBaseOnly, true);
		}

		EnableGoal(goalHeroSurvive, true);
		EnableGoal(goalFindFriendlyUnits, true);
		AddBriefing("translateBriefingMissionUSA_1_FindFriendlyUnits");
		PlayWave("Briefings\\USA_Briefing01.wav");

		AddWorldMapSign(GetPointX(markerFriednlyUnits), GetPointY(markerFriednlyUnits), 0, 0, 65000);

		CreateArtefact("ARTIFACT_INVISIBLE", GetPointX(markerEndOfBridge), GetPointY(markerEndOfBridge), 0, maskDetonator|markerDetonateArea1);

		return FindFriendlyUnits;
	}

	state FindFriendlyUnits
	{
		if ( Distance(m_uHero.GetLocationX(), m_uHero.GetLocationY(), GetPointX(markerFriednlyUnits), GetPointY(markerFriednlyUnits) ) <= 6 )
		{
			return FoundFriendlyUnits;
		}
		else
		{
			return FindFriendlyUnits;
		}
	}

	state FoundFriendlyUnits
	{
		RemoveWorldMapSign(GetPointX(markerFriednlyUnits), GetPointY(markerFriednlyUnits), 0);

		SetGoalState(goalFindFriendlyUnits, goalAchieved);

		EnableGoal(goalDestroyEnemiesA, true);
		AddBriefing("translateBriefingMissionUSA_1_DestroyEnemiesA");

		m_pFriendlyUnits.GiveAllUnitsTo(m_pPlayer);
		m_pFriendlyUnits.GiveAllBuildingsTo(m_pPlayer);

		m_bCheckNumberOfUnits = true;
		m_bCheckNumberOfBuildings = true;

		return DestroyEnemiesA;
	}

	state DestroyEnemiesA
	{
		if ( !m_bCheckNumberOfBuildings )
		{
			return DestroyEnemiesA;
		}

		m_bCheckNumberOfBuildings = false;

		if	(
//			m_pEnemyA.GetNumberOfUnits() == 0 &&
			m_pEnemyA.GetNumberOfBuildings() == 0
			)
		{
			return DestroyedEnemiesA;
		}
		else
		{
			return DestroyEnemiesA;
		}
	}

	state DestroyedEnemiesA
	{
		SetGoalState(goalDestroyEnemiesA, goalAchieved);

		EnableGoal(goalDetonateBridge, true);
		AddBriefing("translateBriefingMissionUSA_1_DetonateBridge");

		SetGameRect(0, 0, 0, 0);

		CreateArtefact("ARTIFACT_DETONATOR", GetPointX(markerBridgeDetonator), GetPointY(markerBridgeDetonator), 0, maskDetonator|markerDetonateArea2);

		return DetonateBridge;
	}

	state DetonateBridge
	{
		if ( m_nLastDetonatedAreaMarker == markerDetonateArea2 )
		{
			return DetonatedBridge;
		}
		else
		{
			return DetonateBridge;
		}
	}

	state DetonatedBridge
	{
		SetGoalState(goalDetonateBridge, goalAchieved);

		EnableGoal(goalDestroyEnemiesC, true);
		AddBriefing("translateBriefingMissionUSA_1_DestroyEnemiesC");

		AddUnitTemplatesUSA( m_pPlayer );
		m_pPlayer.RemoveObjectTemplate(null, -1, "USA_TRANSPORTER", "USA_TRANSPORTER_Hook", null, null, null);

		if ( GetDifficultyLevel() > 0 )
		{
			m_pPlayer.RemoveObjectTemplate(null,  0, "USA_REPAIRER", "USA_REPAIRER_ARM", null, null, null);
		}

		m_pPlayer.AddMoney(2000);

		m_bCheckNumberOfUnits = true;
		m_bCheckNumberOfBuildings = true;

		return DestroyEnemiesC;
	}

	state DestroyEnemiesC
	{
		if ( !m_bCheckNumberOfUnits && !m_bCheckNumberOfBuildings )
		{
			return DestroyEnemiesC;
		}

		m_bCheckNumberOfUnits = false;
		m_bCheckNumberOfBuildings = false;

		if	(
			m_pEnemyC.GetNumberOfBuildings() == 0 &&
			m_pEnemyC.GetNumberOfUnits() == m_pEnemyC.GetNumberOfUnits(unitSupplier|chassisAny)
			)
		{
			return DestroyedEnemiesC;
		}
		else
		{
			return DestroyEnemiesC;
		}
	}

	state DestroyedEnemiesC
	{
		SetGoalState(goalDestroyEnemiesC, goalAchieved);
		SetGoalState(goalHeroSurvive, goalAchieved);

		AddBriefing("translateBriefingMissionUSA_1_MissionComplete");

		EnableEndMissionButton(true, true);

		return MissionComplete;
	}

	state MissionComplete
	{
		return MissionComplete;
	}

	event Artefact(int nArtefactNum, player pPlayerOnArtefact)
	{
		int nFromGx;
		int nFromGy;
		int nToGx;
		int nToGy;

		int nRange, nRange2;

		int nMarker;

		if ( pPlayerOnArtefact != m_pPlayer )
		{
			return false;
		}

		if ( nArtefactNum & maskDetonator )
		{
			nMarker = ~maskDetonator & nArtefactNum;

			nFromGx = GetPointX(nMarker);
			nFromGy = GetPointY(nMarker);

			nToGx = GetPointX(nMarker+1);
			nToGy = GetPointY(nMarker+1);

			nRange = (nToGx-nFromGx)/2;
			nRange2 = (nToGy-nFromGy)/2;

			if ( nRange2 > nRange ) nRange = nRange2;

			KillArea(65535, (nFromGx+nToGx)/2, (nFromGy+nToGy)/2, 0, nRange);

			m_nLastDetonatedAreaMarker = nMarker;

			if ( nMarker == markerDetonateArea1 )
			{
				if ( GetUnit(GetPointX(markerEndOfBridge), GetPointY(markerEndOfBridge)) != m_uHero )
				{
					SetGoalState(goalFindFriendlyUnits, goalFailed);

					AddBriefing("translateBriefingMissionUSA_1_MissionFail");

					EnableEndMissionButton(true, false);

					state MissionComplete;
				}
			}
		}

		true; // kasujemy ten do ktorego dojechal.
	}

	event UnitDestroyed(unit uUnit)
	{
		m_bCheckNumberOfUnits = true;

		if ( uUnit == m_uHero )
		{
			SetGoalState(goalHeroSurvive, goalFailed);

			AddBriefing("translateBriefingMissionUSA_1_MissionFail");

			EnableEndMissionButton(true, false);

			state MissionComplete;
		}
	}

	event BuildingDestroyed(unit uBuilding)
	{
		m_bCheckNumberOfBuildings = true;
	}

	event EndMission()
	{
		m_pPlayer.SaveUnit(0, m_uHero);
	}

	event SetupInterface()
	{
	}
}
