mission "translateMissionUSA_10"
{
	consts
	{
		goalHeroSurvive = 0;
		goalAttackPalace = 1;

		markerHero = 0;
		markerHQ = 1;

		markerTrainCreateLocation = 2;

		markerArtADstFirst = 70;
		markerArtAGuardLast = 72;
		markerArtADstLast = 76;

		markerArtBDstFirst = 80;
		markerArtBGuardLast = 81;
		markerArtBDstLast = 85;

		markerArtCDstFirst = 90;
		markerArtCGuardLast = 93;
		markerArtCDstLast = 96;
	}

	include "UnitTemplates.ech"
	include "Research.ech"

	player m_pPlayer;
	player m_pEnemy;
	player m_pEnemyShafts;

	player m_pSpecialUnits;

	unitex m_uHero;

	int m_nStartOfEnemyOffenseTime;

	unitex m_uArtA1;
	unitex m_uArtA2;
	unitex m_uArtA3;
	unitex m_uArtA4;

	int m_nCurArtADst;
	int m_bArtAMoved;

	unitex m_uArtB1;
	unitex m_uArtB2;
	unitex m_uArtB3;
	unitex m_uArtB4;

	int m_nCurArtBDst;
	int m_bArtBMoved;

	unitex m_uArtC1;
	unitex m_uArtC2;
	unitex m_uArtC3;
	unitex m_uArtC4;

	int m_nCurArtCDst;
	int m_bArtCMoved;

	function int InitializeArtGroupUnit(int nPoint, unitex uAtr)
	{
		unitex uTmp;

		uTmp = GetUnit(GetPointX(nPoint), GetPointY(nPoint));

		if ( uTmp )
		{
			uTmp.CommandEscort(uAtr);
			uTmp.CommandSetMovementMode(2); // hold position
			uTmp.RegenerateAmmo();
			uTmp.CommandSetLights(1); // lights off
		}
	}

	function int InitializeArtAGroup()
	{
		m_nCurArtADst = markerArtADstFirst;
		m_bArtAMoved = false;

		m_uArtA1 = GetUnit(GetPointX(20), GetPointY(20));
		m_uArtA2 = GetUnit(GetPointX(21), GetPointY(21));
		m_uArtA3 = GetUnit(GetPointX(22), GetPointY(22));
		m_uArtA4 = GetUnit(GetPointX(23), GetPointY(23));

		m_uArtA1.CommandSetMovementMode(2); // hold position
		m_uArtA2.CommandSetMovementMode(2); // hold position
		if ( GetDifficultyLevel() > 1 )
		{
			m_uArtA3.CommandSetMovementMode(2); // hold position
			m_uArtA4.CommandSetMovementMode(2); // hold position
		}

		m_uArtA1.CommandSetLights(1); // lights off
		m_uArtA2.CommandSetLights(1); // lights off
		if ( GetDifficultyLevel() > 1 )
		{
			m_uArtA3.CommandSetLights(1); // lights off
			m_uArtA4.CommandSetLights(1); // lights off
		}

		m_uArtA1.RegenerateAmmo();
		m_uArtA2.RegenerateAmmo();
		if ( GetDifficultyLevel() > 1 )
		{
			m_uArtA3.RegenerateAmmo();
			m_uArtA4.RegenerateAmmo();
		}

		// tanks
		InitializeArtGroupUnit(10, m_uArtA1);
		InitializeArtGroupUnit(11, m_uArtA1);
		InitializeArtGroupUnit(12, m_uArtA3);
		InitializeArtGroupUnit(13, m_uArtA4);
		InitializeArtGroupUnit(14, m_uArtA2);
		InitializeArtGroupUnit(15, m_uArtA2);
		InitializeArtGroupUnit(16, m_uArtA1);

		// helicopters
		InitializeArtGroupUnit(24, m_uArtA1);
		InitializeArtGroupUnit(25, m_uArtA2);
		InitializeArtGroupUnit(26, m_uArtA3);
		InitializeArtGroupUnit(27, m_uArtA4);
		InitializeArtGroupUnit(28, m_uArtA2);
		InitializeArtGroupUnit(29, m_uArtA1);

		// rolands
		InitializeArtGroupUnit(17, m_uArtA1);
		InitializeArtGroupUnit(18, m_uArtA2);
		InitializeArtGroupUnit(19, m_uArtA3);

		return true;
	}

	function int InitializeArtBGroup()
	{
		m_nCurArtBDst = markerArtBDstFirst;
		m_bArtBMoved = false;

		m_uArtB1 = GetUnit(GetPointX(40), GetPointY(40));
		m_uArtB2 = GetUnit(GetPointX(41), GetPointY(41));
		m_uArtB3 = GetUnit(GetPointX(42), GetPointY(42));
		m_uArtB4 = GetUnit(GetPointX(43), GetPointY(43));

		m_uArtB1.CommandSetMovementMode(2); // hold position
		m_uArtB2.CommandSetMovementMode(2); // hold position
		if ( GetDifficultyLevel() > 1 )
		{
			m_uArtB3.CommandSetMovementMode(2); // hold position
			m_uArtB4.CommandSetMovementMode(2); // hold position
		}

		m_uArtB1.CommandSetLights(1); // lights off
		m_uArtB2.CommandSetLights(1); // lights off
		if ( GetDifficultyLevel() > 1 )
		{
			m_uArtB3.CommandSetLights(1); // lights off
			m_uArtB4.CommandSetLights(1); // lights off
		}

		m_uArtB1.RegenerateAmmo();
		m_uArtB2.RegenerateAmmo();
		if ( GetDifficultyLevel() > 1 )
		{
			m_uArtB3.RegenerateAmmo();
			m_uArtB4.RegenerateAmmo();
		}

		// tanks
		InitializeArtGroupUnit(30, m_uArtB1);
		InitializeArtGroupUnit(31, m_uArtB1);
		InitializeArtGroupUnit(32, m_uArtB3);
		InitializeArtGroupUnit(33, m_uArtB4);
		InitializeArtGroupUnit(34, m_uArtB2);
		InitializeArtGroupUnit(35, m_uArtB2);
		InitializeArtGroupUnit(36, m_uArtB1);

		// helicopters
		InitializeArtGroupUnit(44, m_uArtB1);
		InitializeArtGroupUnit(45, m_uArtB2);
		InitializeArtGroupUnit(46, m_uArtB3);
		InitializeArtGroupUnit(47, m_uArtB4);
		InitializeArtGroupUnit(48, m_uArtB2);
		InitializeArtGroupUnit(49, m_uArtB1);

		// rolands
		InitializeArtGroupUnit(37, m_uArtB1);
		InitializeArtGroupUnit(38, m_uArtB2);
		InitializeArtGroupUnit(39, m_uArtB3);

		return true;
	}

	function int InitializeArtCGroup()
	{
		m_nCurArtCDst = markerArtCDstFirst;
		m_bArtCMoved = false;

		m_uArtC1 = GetUnit(GetPointX(60), GetPointY(60));
		m_uArtC2 = GetUnit(GetPointX(61), GetPointY(61));
		m_uArtC3 = GetUnit(GetPointX(62), GetPointY(62));
		m_uArtC4 = GetUnit(GetPointX(63), GetPointY(63));

		m_uArtC1.CommandSetMovementMode(2); // hold position
		m_uArtC2.CommandSetMovementMode(2); // hold position
		if ( GetDifficultyLevel() > 1 )
		{
			m_uArtC3.CommandSetMovementMode(2); // hold position
			m_uArtC4.CommandSetMovementMode(2); // hold position
		}

		m_uArtC1.CommandSetLights(1); // lights off
		m_uArtC2.CommandSetLights(1); // lights off
		if ( GetDifficultyLevel() > 1 )
		{
			m_uArtC3.CommandSetLights(1); // lights off
			m_uArtC4.CommandSetLights(1); // lights off
		}

		m_uArtC1.RegenerateAmmo();
		m_uArtC2.RegenerateAmmo();
		if ( GetDifficultyLevel() > 1 )
		{
			m_uArtC3.RegenerateAmmo();
			m_uArtC4.RegenerateAmmo();
		}

		// tanks
		InitializeArtGroupUnit(50, m_uArtC1);
		InitializeArtGroupUnit(51, m_uArtC1);
		InitializeArtGroupUnit(52, m_uArtC3);
		InitializeArtGroupUnit(53, m_uArtC4);
		InitializeArtGroupUnit(54, m_uArtC2);
		InitializeArtGroupUnit(55, m_uArtC2);
		InitializeArtGroupUnit(56, m_uArtC1);

		// helicopters
		InitializeArtGroupUnit(64, m_uArtC1);
		InitializeArtGroupUnit(65, m_uArtC2);
		InitializeArtGroupUnit(66, m_uArtC3);
		InitializeArtGroupUnit(67, m_uArtC4);
		InitializeArtGroupUnit(68, m_uArtC2);
		InitializeArtGroupUnit(69, m_uArtC1);

		// rolands
		InitializeArtGroupUnit(57, m_uArtC1);
		InitializeArtGroupUnit(58, m_uArtC2);
		InitializeArtGroupUnit(59, m_uArtC3);

		return true;
	}

	unitex m_uBuildingInArea;

	function int IsPlayerBuildingInArea(int nPoint)
	{
		int x, y;
		int sx, sy, ex, ey;
		unitex uTmp;

		sx = GetPointX(nPoint)-5;
		sy = GetPointY(nPoint)-5;

		ex = GetPointX(nPoint)+5;
		ey = GetPointY(nPoint)+5;

		for ( y = sy; y <= ey; ++y )
		{
			for ( x = sx; x <= ex ; ++x )
			{
				uTmp = GetUnit(x, y);

				if ( uTmp != null && uTmp.IsBuilding() && uTmp.GetIFF() == m_pPlayer.GetIFF() )
				{
					m_uBuildingInArea = uTmp;
					return true;
				}
			}
		}

		return false;
	}

	event Timer2() // ArtAControl
	{
		int i;

		if ( GetDifficultyLevel() == 0 )
		{
			return;
		}

		if ( m_nCurArtADst > markerArtADstLast )
		{
			return;
		}

		if ( m_nCurArtADst < markerArtAGuardLast )
		{
			for ( i=markerArtADstFirst; i<=markerArtAGuardLast; ++i )
			{
				if ( IsPlayerBuildingInArea(i) )
				{
					m_nCurArtADst = i;
					break;
				}
			}
		}

		if ( IsPlayerBuildingInArea(m_nCurArtADst) )
		{
			m_uArtA1.CommandAttack(m_uBuildingInArea);
			m_uArtA2.CommandAttack(m_uBuildingInArea);
			if ( GetDifficultyLevel() > 1 )
			{
				m_uArtA3.CommandAttack(m_uBuildingInArea);
				m_uArtA4.CommandAttack(m_uBuildingInArea);
			}

			m_bArtAMoved = true;
		}
		else if ( m_bArtAMoved )
		{
			m_nCurArtADst = m_nCurArtADst + 1;
		}

		if ( !m_bArtAMoved && m_pPlayer.IsPointLocated(GetPointX(markerArtADstFirst), GetPointY(markerArtADstFirst)) )
		{
			m_bArtAMoved = true;

			m_uArtA1.CommandMove(GetPointX(markerArtAGuardLast), GetPointY(markerArtAGuardLast), 0);
			m_uArtA2.CommandMove(GetPointX(markerArtAGuardLast), GetPointY(markerArtAGuardLast), 0);
			if ( GetDifficultyLevel() > 1 )
			{
				m_uArtA3.CommandMove(GetPointX(markerArtAGuardLast), GetPointY(markerArtAGuardLast), 0);
				m_uArtA4.CommandMove(GetPointX(markerArtAGuardLast), GetPointY(markerArtAGuardLast), 0);
			}
		}
	}

	event Timer3() // ArtBControl
	{
		int i;

		if ( GetDifficultyLevel() == 0 )
		{
			return;
		}

		if ( m_nCurArtBDst > markerArtBDstLast )
		{
			return;
		}

		if ( m_nCurArtBDst < markerArtBGuardLast )
		{
			for ( i=markerArtBDstFirst; i<=markerArtBGuardLast; ++i )
			{
				if ( IsPlayerBuildingInArea(i) )
				{
					m_nCurArtBDst = i;
					break;
				}
			}
		}

		if ( IsPlayerBuildingInArea(m_nCurArtBDst) )
		{
			m_uArtB1.CommandAttack(m_uBuildingInArea);
			m_uArtB2.CommandAttack(m_uBuildingInArea);
			if ( GetDifficultyLevel() > 1 )
			{
				m_uArtB3.CommandAttack(m_uBuildingInArea);
				m_uArtB4.CommandAttack(m_uBuildingInArea);
			}

			m_bArtBMoved = true;
		}
		else if ( m_bArtBMoved )
		{
			m_nCurArtBDst = m_nCurArtBDst + 1;
		}

		if ( !m_bArtBMoved && m_pPlayer.IsPointLocated(GetPointX(markerArtBDstFirst), GetPointY(markerArtBDstFirst)) )
		{
			m_bArtBMoved = true;

			m_uArtB1.CommandMove(GetPointX(markerArtBGuardLast), GetPointY(markerArtBGuardLast), 0);
			m_uArtB2.CommandMove(GetPointX(markerArtBGuardLast), GetPointY(markerArtBGuardLast), 0);
			if ( GetDifficultyLevel() > 1 )
			{
				m_uArtB3.CommandMove(GetPointX(markerArtBGuardLast), GetPointY(markerArtBGuardLast), 0);
				m_uArtB4.CommandMove(GetPointX(markerArtBGuardLast), GetPointY(markerArtBGuardLast), 0);
			}
		}
	}

	event Timer4() // ArtCControl
	{
		int i;

		if ( GetDifficultyLevel() == 0 )
		{
			return;
		}

		if ( m_nCurArtCDst > markerArtCDstLast )
		{
			return;
		}

		if ( m_nCurArtCDst < markerArtCGuardLast )
		{
			for ( i=markerArtCDstFirst; i<=markerArtCGuardLast; ++i )
			{
				if ( IsPlayerBuildingInArea(i) )
				{
					m_nCurArtCDst = i;
					break;
				}
			}
		}

		if ( IsPlayerBuildingInArea(m_nCurArtCDst) )
		{
			m_uArtC1.CommandAttack(m_uBuildingInArea);
			m_uArtC2.CommandAttack(m_uBuildingInArea);
			if ( GetDifficultyLevel() > 1 )
			{
				m_uArtC3.CommandAttack(m_uBuildingInArea);
				m_uArtC4.CommandAttack(m_uBuildingInArea);
			}

			m_bArtCMoved = true;
		}
		else if ( m_bArtCMoved )
		{
			m_nCurArtCDst = m_nCurArtCDst + 1;
		}

		if ( !m_bArtCMoved && m_pPlayer.IsPointLocated(GetPointX(markerArtCDstFirst), GetPointY(markerArtCDstFirst)) )
		{
			m_bArtCMoved = true;

			m_uArtC1.CommandMove(GetPointX(markerArtCGuardLast), GetPointY(markerArtCGuardLast), 0);
			m_uArtC2.CommandMove(GetPointX(markerArtCGuardLast), GetPointY(markerArtCGuardLast), 0);
			if ( GetDifficultyLevel() > 1 )
			{
				m_uArtC3.CommandMove(GetPointX(markerArtCGuardLast), GetPointY(markerArtCGuardLast), 0);
				m_uArtC4.CommandMove(GetPointX(markerArtCGuardLast), GetPointY(markerArtCGuardLast), 0);
			}
		}
	}

	state Initialize;
	state Start;
	state BeforeStart;
	state MoveHeroToHQ;
	state MovedHeroToHQ;
	state MissionComplete;

	function int ClearMarkers(int nStartPoint, int nEndPoint)
	{
		int i;

		for ( i=nStartPoint; i<=nEndPoint; i=i+1 )
		{
			ClearArea (65535, GetPointX(i), GetPointY(i), GetPointZ(i), 0);
		}
	}

	function int ModifyDifficulty()
	{
		if ( GetDifficultyLevel() == 0 )
		{
			ClearMarkers(10, 29); // ArtA
			ClearMarkers(30, 49); // ArtB
			ClearMarkers(50, 69); // ArtC

			ClearMarkers(97,140);
		}
		else if ( GetDifficultyLevel() == 1 )
		{
			ClearMarkers(12, 13); // ArtA
			ClearMarkers(19, 19); // ArtA
			ClearMarkers(22, 23); // ArtA
			ClearMarkers(26, 27); // ArtA

			ClearMarkers(32, 33); // ArtB
			ClearMarkers(39, 39); // ArtB
			ClearMarkers(42, 43); // ArtB
			ClearMarkers(46, 47); // ArtB

			ClearMarkers(52, 53); // ArtC
			ClearMarkers(59, 59); // ArtC
			ClearMarkers(62, 63); // ArtC
			ClearMarkers(66, 67); // ArtC

			ClearMarkers(98, 98);
		}
		else if ( GetDifficultyLevel() == 2 )
		{
		}
	}

	state Initialize
	{
		ModifyDifficulty();

		if ( GetDifficultyLevel() > 0 )
		{
			InitializeArtAGroup();
			InitializeArtBGroup();
			InitializeArtCGroup();
		}

		RegisterGoal(goalHeroSurvive, "translateGoalMissionUSA_HeroSurvive");
		RegisterGoal(goalAttackPalace, "translateGoalMissionUSA_10_AttackPalace");

		m_pPlayer = GetPlayer(0);
		m_pPlayer.EnableStatistics(true);

		m_pPlayer.SetMilitaryUnitsLimit(70000);
		
		m_pEnemy = GetPlayer(3);
		m_pEnemy.EnableStatistics(true);

		m_pEnemyShafts = GetPlayer(1);
		m_pEnemyShafts.EnableStatistics(false);

		m_pSpecialUnits = GetPlayer(4);
		m_pSpecialUnits.EnableStatistics(false);

		m_pSpecialUnits.EnableAI(false);
		m_pSpecialUnits.SpyPlayer(m_pPlayer, true, 1000000);
		m_pSpecialUnits.SetMoney(100000);

		EnableAllResearchIRQ( m_pSpecialUnits, true);
		AddAllResearchIRQ( m_pSpecialUnits );

		if ( GetDifficultyLevel() == 0 )
		{
			m_pEnemy.LoadScript("single\\singleEasy");
		}
		else if ( GetDifficultyLevel() >= 1 )
		{
			m_pEnemy.LoadScript("single\\singleHard");
		}

		m_pPlayer.RestoreUnitsAt(0, GetPointX(markerHero), GetPointY(markerHero), 0);

		m_uHero = GetUnit(GetPointX(markerHero), GetPointY(markerHero));
		m_uHero.RegenerateAmmo();

		m_pPlayer.LookAt(m_pPlayer.GetStartingPointX(), m_pPlayer.GetStartingPointY(), 6, 0, 0, 0);

		m_pEnemy.EnableAI(false);
//		m_pEnemy.EnableAIFeatures(aiEverything, true);

		m_nStartOfEnemyOffenseTime = GetMissionTime() + 10*60*20;

		m_pEnemy.EnableAIFeatures(aiControlOffense, false);

		SetTimer(0, 30*20); // wlaczeenie ataku
		SetTimer(1, 30*20); // tworzenie pociagu

		if ( GetDifficultyLevel() > 0 )
		{
			SetTimer(2, 20*20); // ArtAControl
			SetTimer(3, 20*20); // ArtBControl
			SetTimer(4, 20*20); // ArtCControl
		}

		m_pEnemyShafts.EnableAI(false);

		m_pPlayer.SetMoney(5000);

		m_pEnemy.SetMoney(10000);

		AddUnitTemplatesUSA(m_pPlayer);

		EnableAllResearchUSA( m_pPlayer, false);
		m_pPlayer.EnableResearch("RES_USA_AMPHIBIA1", true);		// M1
		m_pPlayer.EnableResearch("RES_USA_AMMO_MG1", true);			// M1
		m_pPlayer.EnableResearch("RES_USA_SPY", true);				// M2
		m_pPlayer.EnableResearch("RES_USA_HELICOPTER1", true);		// M2
		m_pPlayer.EnableResearch("RES_USA_AMMO_MG2", true);			// M3
		m_pPlayer.EnableResearch("RES_USA_HELICOPTER2", true);		// M3
		m_pPlayer.EnableResearch("RES_USA_TANK1", true);			// M3
		m_pPlayer.EnableResearch("RES_USA_SAPER", true);			// M3
		m_pPlayer.EnableResearch("RES_USA_MORTAR", true);			// M4
		m_pPlayer.EnableResearch("RES_USA_AMMO_CANNON1", true);		// M4
		m_pPlayer.EnableResearch("RES_USA_MIM", true);				// M4
		m_pPlayer.EnableResearch("RES_USA_SPECIAL_FILTER2", true);	// M4
		m_pPlayer.EnableResearch("RES_USA_ART", true);				// M5
		m_pPlayer.EnableResearch("RES_USA_AMMO_GRENADE1", true);	// M5
		m_pPlayer.EnableResearch("RES_USA_COMANCHE", true);			// M5
		m_pPlayer.EnableResearch("RES_USA_AMMO_MIM1", true);		// M5
		m_pPlayer.EnableResearch("RES_USA_MGM", true);				// M5
		m_pPlayer.EnableResearch("RES_USA_SDI", true);				// M5
		m_pPlayer.EnableResearch("RES_USA_SPECIAL_FILTER3", true);	// M5
		m_pPlayer.EnableResearch("RES_USA_AMMO_GRENADE2", true);	// M6
		m_pPlayer.EnableResearch("RES_USA_AMMO_CANNON2", true);		// M6
		m_pPlayer.EnableResearch("RES_USA_SPECIAL_PTC", true);		// M6
		m_pPlayer.EnableResearch("RES_USA_SPECIAL_FLARE", true);	// M6
		m_pPlayer.EnableResearch("RES_USA_LECLERC", true);			// M7
		m_pPlayer.EnableResearch("RES_USA_AMMO_MGM1", true);		// M7
		m_pPlayer.EnableResearch("RES_USA_AIRCONTROL", true);		// M8
		m_pPlayer.EnableResearch("RES_USA_AMMO_MIM2", true);		// M8
		m_pPlayer.EnableResearch("RES_USA_JEEP_JAMMER", true);		// M8
		m_pPlayer.EnableResearch("RES_USA_BOMBCONTROL", true);		// M9
		m_pPlayer.EnableResearch("RES_USA_AMMO_MGM2", true);		// M9
		m_pPlayer.EnableResearch("RES_USA_ROCKETCONTROL", true);

		EnableAllResearchIRQ( m_pEnemy, false);
		m_pEnemy.EnableResearch("RES_IRQ_TANK1", true);				// M1
		m_pEnemy.EnableResearch("RES_IRQ_HELICOPTER1", true);		// M2
		m_pEnemy.EnableResearch("RES_IRQ_AMMO_MG1", true);			// M3
		m_pEnemy.EnableResearch("RES_IRQ_PILLBOX", true);			// M3
		m_pEnemy.EnableResearch("RES_IRQ_TANK2", true);				// M3
		m_pEnemy.EnableResearch("RES_IRQ_SAPER", true);				// M3
		m_pEnemy.EnableResearch("RES_IRQ_MIM", true);				// M3
		m_pEnemy.EnableResearch("RES_IRQ_RART", true);				// M4
		m_pEnemy.EnableResearch("RES_IRQ_HRART", true);				// M4
		m_pEnemy.EnableResearch("RES_IRQ_AMMO_MIM1", true);			// M4
		m_pEnemy.EnableResearch("RES_IRQ_SPECIAL_FILTER2", true);	// M4
//		m_pEnemy.EnableResearch("RES_IRQ_AMMO_CANNON1", true);		// M5
		m_pEnemy.EnableResearch("RES_IRQ_BIGART", true);			// M5
//		m_pEnemy.EnableResearch("RES_IRQ_AMMO_ROCKET1", true);		// M5
//		m_pEnemy.EnableResearch("RES_IRQ_AMMO_HROCKET1", true);		// M5
		m_pEnemy.EnableResearch("RES_IRQ_MGM", true);				// M5
//		m_pEnemy.EnableResearch("RES_IRQ_EXPLODER", true);			// M5
//		m_pEnemy.EnableResearch("RES_IRQ_AMMO_CANNON2", true);		// M6
//		m_pEnemy.EnableResearch("RES_IRQ_AMMO_ROCKET2", true);		// M6
//		m_pEnemy.EnableResearch("RES_IRQ_AMMO_HROCKET2", true);		// M6
		m_pEnemy.EnableResearch("RES_IRQ_AMMO_MIM2", true);			// M6
		m_pEnemy.EnableResearch("RES_IRQ_JEEP_MGM", true);			// M6
		m_pEnemy.EnableResearch("RES_IRQ_SPECIAL_FILTER2", true);	// M6
		m_pEnemy.EnableResearch("RES_IRQ_AMMO_MGM1", true);			// M7
//		m_pEnemy.EnableResearch("RES_IRQ_EXPLODER_BIG", true);		// M7
//		m_pEnemy.EnableResearch("RES_IRQ_SCUD", true);				// M8
		m_pEnemy.EnableResearch("RES_IRQ_SPYFLIGHTCENTER", true);	// M8
		m_pEnemy.EnableResearch("RES_IRQ_AMMO_MGM2", true);			// M8
		m_pEnemy.EnableResearch("RES_IRQ_SDI", true);				// M8
		m_pEnemy.EnableResearch("RES_IRQ_AMMO_CHEMICAL1", true);	// M9
//		m_pEnemy.EnableResearch("RES_IRQ_SPYCENTER", true);			// M9
		m_pEnemy.EnableResearch("RES_IRQ_SPECIAL_PTC", true);		// M9
		m_pEnemy.EnableResearch("RES_IRQ_AMMO_CHEMICAL2", true);

		m_pEnemy.AddResearch("RES_IRQ_TANK1");
		m_pEnemy.AddResearch("RES_IRQ_HELICOPTER1");
		m_pEnemy.AddResearch("RES_IRQ_AMMO_MG1");
		m_pEnemy.AddResearch("RES_IRQ_PILLBOX");
		m_pEnemy.AddResearch("RES_IRQ_TANK2");
		m_pEnemy.AddResearch("RES_IRQ_SAPER");
		m_pEnemy.AddResearch("RES_IRQ_MIM");
		m_pEnemy.AddResearch("RES_IRQ_RART");
		m_pEnemy.AddResearch("RES_IRQ_HRART");
		m_pEnemy.AddResearch("RES_IRQ_AMMO_MIM1");
		m_pEnemy.AddResearch("RES_IRQ_SPECIAL_FILTER2");
//		m_pEnemy.AddResearch("RES_IRQ_AMMO_CANNON1");
		m_pEnemy.AddResearch("RES_IRQ_BIGART");
//		m_pEnemy.AddResearch("RES_IRQ_AMMO_ROCKET1");
//		m_pEnemy.AddResearch("RES_IRQ_AMMO_HROCKET1");
		m_pEnemy.AddResearch("RES_IRQ_MGM");
//		m_pEnemy.AddResearch("RES_IRQ_EXPLODER");
//		m_pEnemy.AddResearch("RES_IRQ_AMMO_CANNON2");
//		m_pEnemy.AddResearch("RES_IRQ_AMMO_ROCKET2");
//		m_pEnemy.AddResearch("RES_IRQ_AMMO_HROCKET2");
		m_pEnemy.AddResearch("RES_IRQ_AMMO_MIM2");
		m_pEnemy.AddResearch("RES_IRQ_JEEP_MGM");
		m_pEnemy.AddResearch("RES_IRQ_SPECIAL_FILTER2");
		m_pEnemy.AddResearch("RES_IRQ_AMMO_MGM1");
//		m_pEnemy.AddResearch("RES_IRQ_EXPLODER_BIG");
//		m_pEnemy.AddResearch("RES_IRQ_SCUD");
		m_pEnemy.AddResearch("RES_IRQ_SPYFLIGHTCENTER");
		m_pEnemy.AddResearch("RES_IRQ_AMMO_MGM2");
		m_pEnemy.AddResearch("RES_IRQ_SDI");
		m_pEnemy.AddResearch("RES_IRQ_AMMO_CHEMICAL1");
//		m_pEnemy.AddResearch("RES_IRQ_SPYCENTER");
		m_pEnemy.AddResearch("RES_IRQ_SPECIAL_PTC");

		AddUnitTemplatesIRQ( m_pEnemy );

		return BeforeStart, 1;
	}

	state BeforeStart
	{
		PlayTrack("Music\\Briefing.tws");

		return Start;
	}

	event Timer0()
	{
		if ( GetMissionTime() >= m_nStartOfEnemyOffenseTime )
		{
			m_pEnemy.EnableAIFeatures(aiControlOffense, true);
		}

		if ( GetMissionTime() >= 20*60*20 )
		{
			m_bArtAMoved = true;
		}

		if ( GetMissionTime() >= 30*60*20 )
		{
			m_bArtBMoved = true;
		}

		if ( GetMissionTime() >= 40*60*20 )
		{
			m_bArtCMoved = true;
		}
	}

	event Timer1()
	{
		int nGx, nGy;
		unitex uTrain;

		nGx = GetPointX(markerTrainCreateLocation);
		nGy = GetPointY(markerTrainCreateLocation);

		uTrain = CreatePassive(nGx, nGy, 0, 0, "NE_ELEKTIRK");

		CreatePassive(nGx, nGy+2, 0, 0, "NE_CYSIRK");
		CreatePassive(nGx, nGy+4, 0, 0, "NE_CYSIRK");
		if ( Rand(2) )
		{
			CreatePassive(nGx, nGy+6, 0, 0, "NE_CYSIRK");
		}
		else
		{
			CreatePassive(nGx, nGy+6, 0, 0, "NE_TOWIRK");
		}
		CreatePassive(nGx, nGy+8, 0, 0, "NE_TOWIRK");

		uTrain.StartTrain(-1, -1, trainModeMoveToEndOfWorld, 20);
	}

	state Start
	{
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemy.EnableAIFeatures2(ai2RebuildBaseOnly, true);
		}
		else
		{
			m_pEnemy.EnableAIFeatures(aiBuildBuildings, false);
		}

		m_pSpecialUnits.EnableAIFeatures(aiRejectAlliance, false);
		m_pEnemy.SetAlly(m_pSpecialUnits);

		EnableGoal(goalHeroSurvive, true);
		EnableGoal(goalAttackPalace, true);
		
		AddBriefing("translateBriefingMissionUSA_10_AttackPalace");
		PlayWave("Briefings\\USA_Briefing10.wav");

		return MoveHeroToHQ;
	}

	state MoveHeroToHQ
	{
		if ( GetMissionTime() >= 10*60*20 )
		{
			m_pEnemy.EnableAI(true);
		}

		if ( Distance(m_uHero.GetLocationX(), m_uHero.GetLocationY(), GetPointX(markerHQ), GetPointY(markerHQ)) <= 4 )
		{
			return MovedHeroToHQ;
		}
		else
		{
			return MoveHeroToHQ;
		}
	}

	state MovedHeroToHQ
	{
		SetGoalState(goalAttackPalace, goalAchieved);
		SetGoalState(goalHeroSurvive, goalAchieved);

		AddBriefing("translateBriefingMissionUSA_10_MissionComplete");

		EndMission(true);

		return MissionComplete;
	}

	state MissionComplete
	{
		return MissionComplete;
	}

	event UnitDestroyed(unit uUnit)
	{
		if ( uUnit == m_uHero )
		{
			SetGoalState(goalHeroSurvive, goalFailed);
			SetGoalState(goalAttackPalace, goalFailed);

			AddBriefing("translateBriefingMissionUSA_10_MissionFail");

			EnableEndMissionButton(true, false);

			state MissionComplete;
		}
	}

	event SetupInterface()
	{
	}
}
