mission "translateMissionUSA_2"
{
	consts
	{
		goalHeroSurvive = 0;
		goalCaptureJeep = 1;
		goalCaptureMiner = 2;
		goalDestroyEnemy = 3;

		markerHero = 2;
		markerJeep = 0;
		markerMiner = 1;
	}

	include "UnitTemplates.ech"
	include "Research.ech"

	player m_pPlayer;

	player m_pFriendlyUnits;
	player m_pIraqUnits;

	player m_pEnemy1;
	player m_pEnemy2;

	unitex m_uHero;

	unitex m_uJeep;
	unitex m_uMiner;

	int m_bCheckDestroyedUnits;

	int m_bCheckNumberOfUnits;
	int m_bCheckNumberOfBuildings;

	state Initialize;
	state Start;
	state BeforeStart;
	state CaptureJeep;
	state CapturedJeep;
	state CaptureMiner;
	state CapturedMiner;
	state CaptureHero;
	state CapturedHero;
	state DestroyEnemy;
	state DestroyedEnemy;
	state MissionComplete;

	function int ModifyDifficulty()
	{
		if ( GetDifficultyLevel() == 0 )
		{
		}
		else if ( GetDifficultyLevel() == 1 )
		{
			ClearArea	(65535, GetPointX( 3), GetPointY( 3), GetPointZ( 3), 0);
		}
		else if ( GetDifficultyLevel() == 2 )
		{
			ClearArea	(65535, GetPointX( 3), GetPointY( 3), GetPointZ( 3), 0);
		}
	}

	state Initialize
	{
		RegisterGoal(goalHeroSurvive, "translateGoalMissionUSA_HeroSurvive");
		RegisterGoal(goalCaptureJeep, "translateGoalMissionUSA_2_CaptureJeep");
		RegisterGoal(goalCaptureMiner, "translateGoalMissionUSA_2_CaptureMiner");
		RegisterGoal(goalDestroyEnemy, "translateGoalMissionUSA_2_DestroyEnemy");

		m_pPlayer = GetPlayer(0);
		m_pPlayer.EnableStatistics(true);

		m_pFriendlyUnits = GetPlayer(1);
		m_pFriendlyUnits.EnableStatistics(false);

		m_pIraqUnits = GetPlayer(4);
		m_pIraqUnits.EnableStatistics(false);

		m_pEnemy1 = GetPlayer(3);
		m_pEnemy1.EnableStatistics(true);

		m_pEnemy2 = GetPlayer(2);
		m_pEnemy2.EnableStatistics(true);

		ModifyDifficulty();

		if ( GetDifficultyLevel() == 0 )
		{
			m_pEnemy1.LoadScript("single\\singleEasy");
			m_pEnemy2.LoadScript("single\\singleEasy");

			m_pEnemy1.SetMilitaryUnitsLimit(2000);
			m_pEnemy2.SetMilitaryUnitsLimit(5000);
		}
		else if ( GetDifficultyLevel() == 1 )
		{
			m_pEnemy1.LoadScript("single\\singleMedium");
			m_pEnemy2.LoadScript("single\\singleMedium");

			m_pEnemy1.SetMilitaryUnitsLimit(5000);
			m_pEnemy2.SetMilitaryUnitsLimit(5000);
		}
		else if ( GetDifficultyLevel() == 2 )
		{
			m_pEnemy1.LoadScript("single\\singleHard");
			m_pEnemy2.LoadScript("single\\singleHard");

			m_pEnemy1.SetMilitaryUnitsLimit(20000);
			m_pEnemy2.SetMilitaryUnitsLimit(20000);
		}

		m_pEnemy1.SetObjectTemplateCountLimit(4,"IRQ_HELICOPTER","IRQ_HELICOPTER_GUN");
		m_pEnemy2.SetObjectTemplateCountLimit(4,"IRQ_HELICOPTER","IRQ_HELICOPTER_GUN");

		m_pEnemy1.EnableMilitaryUnitsLimit(true);
		m_pEnemy2.EnableMilitaryUnitsLimit(true);

		m_pPlayer.RestoreUnitsAt(0, GetPointX(markerHero), GetPointY(markerHero), 0);

		m_uHero = GetUnit(GetPointX(markerHero), GetPointY(markerHero));
		m_uHero.RegenerateAmmo();
		m_uJeep = GetUnit(GetPointX(markerJeep), GetPointY(markerJeep));
		m_uJeep.SetUnitName("translateUSAHeroName_Empty");
		m_uMiner = GetUnit(GetPointX(markerMiner), GetPointY(markerMiner));
		m_uMiner.SetUnitName("translateUSAHeroName_Empty");

		m_pFriendlyUnits.EnableAI(false);
		m_pFriendlyUnits.EnableAIFeatures2(ai2ChooseEnemy, false);

		m_pFriendlyUnits.SetNeutral(m_pPlayer);
		m_pPlayer.SetNeutral(m_pFriendlyUnits);

		m_pIraqUnits.EnableAI(false);
		m_pIraqUnits.EnableAIFeatures2(ai2ChooseEnemy, false);

		m_pIraqUnits.SetNeutral(m_pPlayer);
		m_pPlayer.SetNeutral(m_pIraqUnits);

		m_pEnemy1.SetNeutral(m_pIraqUnits);
		m_pEnemy2.SetNeutral(m_pIraqUnits);

		m_pIraqUnits.SetNeutral(m_pEnemy1);
		m_pIraqUnits.SetNeutral(m_pEnemy2);

		m_pEnemy1.EnableAIFeatures(aiEverything, false);
		m_pEnemy2.EnableAIFeatures(aiEverything, false);

		m_pEnemy1.EnableAIFeatures(/*aiEnabled|*/aiControlDefense, true);
		m_pEnemy2.EnableAIFeatures(/*aiEnabled|*/aiControlDefense, true);

		EnableAllResearchUSA( m_pPlayer, false);
		m_pPlayer.EnableResearch("RES_USA_AMPHIBIA1", true);		// M1
		m_pPlayer.EnableResearch("RES_USA_AMMO_MG1", true);			// M1
		m_pPlayer.EnableResearch("RES_USA_SPY", true);
		m_pPlayer.EnableResearch("RES_USA_HELICOPTER1", true);

		EnableAllResearchIRQ( m_pEnemy1, false);
		m_pEnemy1.EnableResearch("RES_IRQ_TANK1", true);			// M1
		m_pEnemy1.EnableResearch("RES_IRQ_HELICOPTER1", true);

		EnableAllResearchIRQ( m_pEnemy2, false);
		m_pEnemy2.EnableResearch("RES_IRQ_TANK1", true);			// M1
		m_pEnemy2.EnableResearch("RES_IRQ_HELICOPTER1", true);

		m_pEnemy1.AddResearch("RES_IRQ_TANK1");

		m_pEnemy2.AddResearch("RES_IRQ_TANK1");

		m_pPlayer.SetMoney(0);

		LookAt(m_pPlayer.GetStartingPointX(), m_pPlayer.GetStartingPointY(), 6, 0, 60, 0, 0);

		m_bCheckDestroyedUnits = false;

		SetTimer(0, 100); // CheckDestroyedUnits

		AddUnitTemplatesIRQ( m_pEnemy1 );
		AddUnitTemplatesIRQ( m_pEnemy2 );

		return BeforeStart, 1;
	}

	state BeforeStart
	{
		PlayTrack("Music\\Briefing.tws");

		return Start;
	}

	state Start
	{
//		m_pEnemy1.EnableAIFeatures2(ai2ChooseEnemy, false);
//		m_pEnemy2.EnableAIFeatures2(ai2ChooseEnemy, false);

		EnableGoal(goalHeroSurvive, true);
		EnableGoal(goalCaptureJeep, true);
		AddBriefing("translateBriefingMissionUSA_2_CaptureJeep");
		PlayWave("Briefings\\USA_Briefing02.wav");

		AddWorldMapSign(GetPointX(markerJeep), GetPointY(markerJeep), 0, 0, 65000);
		CreateArtefact("ARTIFACT_CLICK_ME_BIG", GetPointX(markerJeep), GetPointY(markerJeep), 0, 0);

		return CaptureJeep;
	}

	state CaptureJeep
	{
		if ( Distance(m_uJeep.GetLocationX(), m_uJeep.GetLocationY(), m_uHero.GetLocationX(), m_uHero.GetLocationY()) <= 1 )
		{
			return CapturedJeep;
		}
		else
		{
			return CaptureJeep;
		}
	}

	state CapturedJeep
	{
		SetGoalState(goalCaptureJeep, goalAchieved);

		RemoveWorldMapSign(GetPointX(markerJeep), GetPointY(markerJeep), 0);
		RemoveArtefact(GetPointX(markerJeep), GetPointY(markerJeep), 0);

		m_uHero.ChangePlayer(m_pIraqUnits);
		m_uHero.SetUnitName("translateUSAHeroName_Empty");
		m_uJeep.ChangePlayer(m_pPlayer);
		m_uJeep.SetUnitName(null);

		m_pEnemy1.SetNeutral(m_pPlayer);
		m_pEnemy2.SetNeutral(m_pPlayer);

		m_pPlayer.SetNeutral(m_pEnemy1);
		m_pPlayer.SetNeutral(m_pEnemy2);

		EnableGoal(goalCaptureMiner, true);
		AddBriefing("translateBriefingMissionUSA_2_CaptureMiner");

		AddWorldMapSign(GetPointX(markerMiner), GetPointY(markerMiner), 0, 0, 65000);
		CreateArtefact("ARTIFACT_CLICK_ME_BIG", GetPointX(markerMiner), GetPointY(markerMiner), 0, 0);

		return CaptureMiner;
	}

	state CaptureMiner
	{
		if ( Distance(m_uMiner.GetLocationX(), m_uMiner.GetLocationY(), m_uJeep.GetLocationX(), m_uJeep.GetLocationY()) <= 1 )
		{
			return CapturedMiner;
		}
		else
		{
			return CaptureMiner;
		}
	}

	state CapturedMiner
	{
		SetGoalState(goalCaptureMiner, goalAchieved);

		RemoveWorldMapSign(GetPointX(markerMiner), GetPointY(markerMiner), 0);
		RemoveArtefact(GetPointX(markerMiner), GetPointY(markerMiner), 0);

		m_uJeep.ChangePlayer(m_pIraqUnits);
		m_uJeep.SetUnitName("translateUSAHeroName_Empty");
		m_uMiner.ChangePlayer(m_pPlayer);
		m_uMiner.SetUnitName(null);

		EnableGoal(goalDestroyEnemy, true);
		AddBriefing("translateBriefingMissionUSA_2_MineBase");

		AddWorldMapSign(m_pEnemy1.GetStartingPointX(), m_pEnemy1.GetStartingPointY(), 0, 1, 65000);
		AddWorldMapSign(m_pEnemy2.GetStartingPointX(), m_pEnemy2.GetStartingPointY(), 0, 1, 65000);
		AddWorldMapSign(GetPointX(markerJeep), GetPointY(markerJeep), 0, 0, 65000);

		return CaptureHero;
	}

	state CaptureHero
	{
		if ( Distance(m_uHero.GetLocationX(), m_uHero.GetLocationY(), m_uMiner.GetLocationX(), m_uMiner.GetLocationY()) <= 1 )
		{
			return CapturedHero;
		}
		else
		{
			return CaptureHero;
		}
	}

	state CapturedHero
	{
		RemoveWorldMapSign(m_pEnemy1.GetStartingPointX(), m_pEnemy1.GetStartingPointY(), 0);
		RemoveWorldMapSign(m_pEnemy2.GetStartingPointX(), m_pEnemy2.GetStartingPointY(), 0);
		RemoveWorldMapSign(GetPointX(markerJeep), GetPointY(markerJeep), 0);

		m_uMiner.ChangePlayer(m_pIraqUnits);
		m_uMiner.SetUnitName("translateUSAHeroName_Empty");
		m_uHero.ChangePlayer(m_pPlayer);
		m_uHero.SetUnitName(null);

		m_pEnemy1.SetEnemy(m_pPlayer);
		m_pEnemy2.SetEnemy(m_pPlayer);

		m_pPlayer.SetEnemy(m_pEnemy1);
		m_pPlayer.SetEnemy(m_pEnemy2);

		m_pFriendlyUnits.GiveAllUnitsTo(m_pPlayer);
		m_pFriendlyUnits.GiveAllBuildingsTo(m_pPlayer);

		m_pEnemy1.EnableAIFeatures(aiEverything&~aiControlOffense, true);
		m_pEnemy2.EnableAIFeatures(aiEverything&~aiControlOffense, true);

		m_pEnemy1.EnableAIFeatures(aiControlOffense, false);
		m_pEnemy2.EnableAIFeatures(aiControlOffense, false);

		if ( GetDifficultyLevel() == 0 )
		{
			m_pEnemy1.EnableAIFeatures(aiBuildBuildings, false);
			m_pEnemy2.EnableAIFeatures(aiBuildBuildings|aiBuildTanks|aiBuildHelicopters, false);
		}
		else if ( GetDifficultyLevel() == 1 )
		{
			m_pEnemy1.EnableAIFeatures(aiBuildBuildings, false);
			m_pEnemy2.EnableAIFeatures2(ai2RebuildBaseOnly, true);
		}
		else if ( GetDifficultyLevel() == 2 )
		{
			m_pEnemy1.EnableAIFeatures2(ai2RebuildBaseOnly, true);
			m_pEnemy2.EnableAIFeatures2(ai2RebuildBaseOnly, true);
		}


		m_pPlayer.AddMoney(8000);

		AddUnitTemplatesUSA(m_pPlayer);
		m_pPlayer.RemoveObjectTemplate(null, -1, "USA_TRANSPORTER", "USA_TRANSPORTER_Hook", null, null, null);

		AddBriefing("translateBriefingMissionUSA_2_DestroyEnemy");

		m_bCheckNumberOfUnits = true;
		m_bCheckNumberOfBuildings = true;

		return DestroyEnemy;
	}

	state DestroyEnemy
	{
		if ( !m_bCheckNumberOfUnits && !m_bCheckNumberOfBuildings )
		{
			return DestroyEnemy;
		}

		m_bCheckNumberOfUnits = false;
		m_bCheckNumberOfBuildings = false;

		if	(
			m_pEnemy1.GetNumberOfBuildings() == 0 &&
			m_pEnemy2.GetNumberOfBuildings() == 0 &&
			m_pEnemy1.GetNumberOfUnits() == m_pEnemy1.GetNumberOfUnits(unitSupplier|chassisAny) &&
			m_pEnemy2.GetNumberOfUnits() == m_pEnemy2.GetNumberOfUnits(unitSupplier|chassisAny)
			)
		{
			return DestroyedEnemy;
		}
		else
		{
			return DestroyEnemy;
		}
	}

	state DestroyedEnemy
	{
		SetGoalState(goalDestroyEnemy, goalAchieved);
		SetGoalState(goalHeroSurvive, goalAchieved);

		AddBriefing("translateBriefingMissionUSA_2_MissionComplete");

		EnableEndMissionButton(true, true);

		return MissionComplete;
	}

	state MissionComplete
	{
		return MissionComplete;
	}

	event UnitDestroyed(unit uUnit)
	{
		if ( state == Initialize )
		{
			return;
		}

		m_bCheckDestroyedUnits = true;
		m_bCheckNumberOfUnits = true;

		if ( uUnit.GetIFF() == m_pEnemy1.GetIFF() )
		{
			m_pEnemy1.SetEnemy(m_pPlayer);
		}
		else if ( uUnit.GetIFF() == m_pEnemy2.GetIFF() )
		{
			m_pEnemy2.SetEnemy(m_pPlayer);
		}
	}

	event BuildingDestroyed(unit uBuilding)
	{
		if ( state == Initialize )
		{
			return;
		}

		m_bCheckNumberOfBuildings = true;

		if ( uBuilding.GetIFF() == m_pEnemy1.GetIFF() )
		{
			m_pEnemy1.SetEnemy(m_pPlayer);
		}
		else if ( uBuilding.GetIFF() == m_pEnemy2.GetIFF() )
		{
			m_pEnemy2.SetEnemy(m_pPlayer);
		}
	}

	function int CheckDestroyedUnits()
	{
		if ( state == MissionComplete ) return;

		if ( !m_uHero.IsLive() )
		{
			SetGoalState(goalHeroSurvive, goalFailed);

			AddBriefing("translateBriefingMissionUSA_2_MissionFail");

			EnableEndMissionButton(true, false);

			state MissionComplete;
		}
		else if ( !m_uJeep.IsLive() && (state == CaptureJeep || state == CapturedJeep || state == CaptureMiner) )
		{
			if ( state == CaptureJeep )
			{
				SetGoalState(goalCaptureJeep, goalFailed);
			}
			else
			{
				SetGoalState(goalHeroSurvive, goalFailed);
				SetGoalState(goalCaptureMiner, goalFailed);
			}

			AddBriefing("translateBriefingMissionUSA_2_MissionFail");

			EnableEndMissionButton(true, false);

			state MissionComplete;
		}
		else if ( !m_uMiner.IsLive() && (state == CaptureMiner || state == CapturedMiner || state == CaptureHero) )
		{
			if ( state == CaptureMiner )
			{
				SetGoalState(goalCaptureMiner, goalFailed);
			}
			else
			{
				SetGoalState(goalHeroSurvive, goalFailed);
			}

			AddBriefing("translateBriefingMissionUSA_2_MissionFail");

			EnableEndMissionButton(true, false);

			state MissionComplete;
		}
	}

	event Timer0()
	{
		if ( m_bCheckDestroyedUnits )
		{
			m_bCheckDestroyedUnits = false;

			CheckDestroyedUnits();
		}
	}

	event EndMission()
	{
		m_pPlayer.SaveUnit(0, m_uHero);
	}

	event SetupInterface()
	{
	}
}
