mission "translateMissionUSA_3"
{
	consts
	{
		goalHeroSurvive = 0;
		goalEscortConvoyA = 1;
		goalEscortConvoyB = 2;
		goalDestroyEnemy = 3;

		markerHero = 24;

		markerMapLimiter = 21;

		markerConvoyUnitA1 = 6;
		markerConvoyUnitA2 = 7;
		markerConvoyUnitA3 = 8;
		markerConvoyUnitA4 = 9;
		markerConvoyUnitA5 = 10;
		markerConvoyUnitA6 = 11;
		markerConvoyUnitA7 = 12;

		markerArtilery1 = 0;
		markerArtilery2 = 1;
		markerArtilery3 = 2;
		markerArtilery4 = 5;

		markerConvoyUnitB1 = 0;
		markerConvoyUnitB2 = 1;
		markerConvoyUnitB3 = 2;
		markerConvoyUnitB4 = 3;
		markerConvoyUnitB5 = 4;
		markerConvoyUnitB6 = 5;

		markerEnemyUnitA1 = 13;
		markerEnemyUnitA2 = 14;
		markerEnemyUnitA3 = 15;
		markerEnemyUnitA4 = 16;
		markerEnemyUnitA5 = 17;

		markerEnemyUnitB1 = 18;
		markerEnemyUnitB2 = 19;
		markerEnemyUnitB3 = 20;
		markerEnemyUnitB4 = 28;

		markerTrapLocationA = 22;
		markerTrapLocationB = 23;

		markerEnemySource = 25;
		markerEnemyDestination = 26;
	}

	include "UnitTemplates.ech"
	include "Research.ech"

	player m_pPlayer;

	player m_pConvoyUnits;
	player m_pEnemyUnits;

	player m_pEnemy;

	unitex m_uHero;

	unitex m_uConvoyUnitA1;
	unitex m_uConvoyUnitA2;
	unitex m_uConvoyUnitA3;
	unitex m_uConvoyUnitA4;
	unitex m_uConvoyUnitA5;
	unitex m_uConvoyUnitA6;
	unitex m_uConvoyUnitA7;

	unitex m_uConvoyUnitB1;
	unitex m_uConvoyUnitB2;
	unitex m_uConvoyUnitB3;
	unitex m_uConvoyUnitB4;
	unitex m_uConvoyUnitB5;
	unitex m_uConvoyUnitB6;

	unitex m_uArtilery1;
	unitex m_uArtilery2;
	unitex m_uArtilery3;
	unitex m_uArtilery4;

	int m_bArrivedConvoyUnitA1;
	int m_bArrivedConvoyUnitA2;
	int m_bArrivedConvoyUnitA3;
	int m_bArrivedConvoyUnitA4;
	int m_bArrivedConvoyUnitA5;
	int m_bArrivedConvoyUnitA6;
	int m_bArrivedConvoyUnitA7;

	int m_bArrivedConvoyUnitB1;
	int m_bArrivedConvoyUnitB2;
	int m_bArrivedConvoyUnitB3;
	int m_bArrivedConvoyUnitB4;
	int m_bArrivedConvoyUnitB5;
	int m_bArrivedConvoyUnitB6;

	unitex m_uEnemyUnitA1;
	unitex m_uEnemyUnitA2;
	unitex m_uEnemyUnitA3;
	unitex m_uEnemyUnitA4;
	unitex m_uEnemyUnitA5;

	unitex m_uEnemyUnitB1;
	unitex m_uEnemyUnitB2;
	unitex m_uEnemyUnitB3;
	unitex m_uEnemyUnitB4;

	unitex m_uEnemyUnitCreated;

	int m_nTimeOfUnitsCreate;

	int m_bFirstCreation;

	int m_nTimeOfEnemyMove;
	int m_nTimeOfConvoyMove;

	int m_nUnitsArrivedA;
	int m_nUnitsArrivedB;

	int m_nUnitsDestroyedA;
	int m_nUnitsDestroyedB;

	int m_bCheckNumberOfUnits;
	int m_bCheckNumberOfBuildings;

	int m_bMissionFail;

	state Initialize;
	state Start;
	state BeforeStart;
	state WaitForEnemyMove;
	state EnemyMove;
	state WaitForConvoyMove;
	state ConvoyMove;
	state EscortConvoy;
	state EscortedConvoy;
	state DestroyEnemy;
	state DestroyedEnemy;
	state MissionComplete;

	function int ModifyDifficulty()
	{
		if ( GetDifficultyLevel() == 0 )
		{
//			ClearArea	(65535, GetPointX( 3), GetPointY( 3), GetPointZ( 3), 1);
			ClearArea	(65535, GetPointX(17), GetPointY(17), GetPointZ(17), 0);
			ClearArea	(65535, GetPointX(28), GetPointY(28), GetPointZ(28), 0);
			ClearArea	(65535, GetPointX(30), GetPointY(30), GetPointZ(30), 1);
			ClearArea	(65535, GetPointX(31), GetPointY(31), GetPointZ(31), 0);
			ClearArea	(65535, GetPointX(32), GetPointY(32), GetPointZ(32), 1);
			ClearArea	(65535, GetPointX(35), GetPointY(35), GetPointZ(35), 1);
			ClearArea	(65535, GetPointX(36), GetPointY(36), GetPointZ(36), 1);
			ClearArea	(65535, GetPointX(37), GetPointY(37), GetPointZ(37), 1);
			ClearArea	(65535, GetPointX(38), GetPointY(38), GetPointZ(38), 0);
			ClearArea	(65535, GetPointX(39), GetPointY(39), GetPointZ(39), 0);
		}
		else if ( GetDifficultyLevel() == 1 )
		{
//			ClearArea	(65535, GetPointX( 3), GetPointY( 3), GetPointZ( 3), 0);
			ClearArea	(65535, GetPointX(28), GetPointY(28), GetPointZ(28), 0);
			ClearArea	(65535, GetPointX(29), GetPointY(29), GetPointZ(29), 0);
			ClearArea	(65535, GetPointX(30), GetPointY(30), GetPointZ(30), 0);
			ClearArea	(65535, GetPointX(31), GetPointY(31), GetPointZ(31), 0);
			ClearArea	(65535, GetPointX(33), GetPointY(33), GetPointZ(33), 0);
			ClearArea	(65535, GetPointX(34), GetPointY(34), GetPointZ(34), 0);
			ClearArea	(65535, GetPointX(36), GetPointY(36), GetPointZ(36), 1);
		}
		else if ( GetDifficultyLevel() == 2 )
		{
			ClearArea	(65535, GetPointX(29), GetPointY(29), GetPointZ(29), 0);
		}
	}

	state Initialize
	{
		ModifyDifficulty();

		m_nUnitsArrivedA = 0;
		m_nUnitsArrivedB = 0;
		
		m_nUnitsDestroyedA = 0;
		m_nUnitsDestroyedB = 0;

		m_nTimeOfEnemyMove = 1200;
		m_nTimeOfConvoyMove = 2400;

		m_bFirstCreation = true;

		m_bMissionFail = false;

		m_bArrivedConvoyUnitA1 = false;
		m_bArrivedConvoyUnitA2 = false;
		m_bArrivedConvoyUnitA3 = false;
		m_bArrivedConvoyUnitA4 = false;
		m_bArrivedConvoyUnitA5 = false;
		m_bArrivedConvoyUnitA6 = false;
		m_bArrivedConvoyUnitA7 = false;

		m_bArrivedConvoyUnitB1 = false;
		m_bArrivedConvoyUnitB2 = false;
		m_bArrivedConvoyUnitB3 = false;
		m_bArrivedConvoyUnitB4 = false;
		m_bArrivedConvoyUnitB5 = false;
		m_bArrivedConvoyUnitB6 = false;

		RegisterGoal(goalHeroSurvive, "translateGoalMissionUSA_HeroSurvive");
		RegisterGoal(goalEscortConvoyA, "translateGoalMissionUSA_3_EscortConvoyA");
		RegisterGoal(goalEscortConvoyB, "translateGoalMissionUSA_3_EscortConvoyB");
		RegisterGoal(goalDestroyEnemy, "translateGoalMissionUSA_3_DestroyEnemy");

		m_pPlayer = GetPlayer(0);
		m_pPlayer.EnableStatistics(true);

		m_pPlayer.SetMilitaryUnitsLimit(75000);

		m_pConvoyUnits = GetPlayer(1);
		m_pConvoyUnits.EnableStatistics(false);

		m_pEnemyUnits = GetPlayer(3);
		m_pEnemyUnits.EnableStatistics(false);

		m_pEnemy = GetPlayer(2);
		m_pEnemy.EnableStatistics(true);

		if ( GetDifficultyLevel() == 0 )
		{
			m_pEnemy.LoadScript("single\\singleEasy");

			m_pEnemy.SetMilitaryUnitsLimit(20000);

			m_pEnemy.SetObjectTemplateCountLimit(5,"IRQ_HELICOPTER","IRQ_HELICOPTER_GUN");

			m_pEnemy.EnableAIFeatures(aiBuildBuildings, false);

			m_pEnemy.SetPercentAddedToEnemy(25, 45);
		}
		else if ( GetDifficultyLevel() == 1 )
		{
			m_pEnemy.LoadScript("single\\singleMedium");

			m_pEnemy.SetMilitaryUnitsLimit(20000);

			m_pEnemy.SetObjectTemplateCountLimit(10,"IRQ_HELICOPTER","IRQ_HELICOPTER_GUN");

			m_pEnemy.EnableAIFeatures2(ai2RebuildBaseOnly, true);

			m_pEnemy.SetPercentAddedToEnemy(38, 128); 
		}
		else if ( GetDifficultyLevel() == 2 )
		{
			m_pEnemy.LoadScript("single\\singleHard");

			m_pEnemy.SetMilitaryUnitsLimit(40000);

			m_pEnemy.SetObjectTemplateCountLimit(10,"IRQ_HELICOPTER","IRQ_HELICOPTER_GUN");

			m_pEnemy.EnableAIFeatures2(ai2RebuildBaseOnly, true);

			m_pEnemy.SetPercentAddedToEnemy(51, 160);
		}

		m_pEnemy.EnableMilitaryUnitsLimit(true);

		m_pPlayer.RestoreUnitsAt(0, GetPointX(markerHero), GetPointY(markerHero), 0);

		m_uHero = GetUnit(GetPointX(markerHero), GetPointY(markerHero));
		m_uHero.RegenerateAmmo();

		m_uConvoyUnitA1 = GetUnit(GetPointX(markerConvoyUnitA1), GetPointY(markerConvoyUnitA1));
		m_uConvoyUnitA2 = GetUnit(GetPointX(markerConvoyUnitA2), GetPointY(markerConvoyUnitA2));
		m_uConvoyUnitA3 = GetUnit(GetPointX(markerConvoyUnitA3), GetPointY(markerConvoyUnitA3));
		m_uConvoyUnitA4 = GetUnit(GetPointX(markerConvoyUnitA4), GetPointY(markerConvoyUnitA4));
		m_uConvoyUnitA5 = GetUnit(GetPointX(markerConvoyUnitA5), GetPointY(markerConvoyUnitA5));
		m_uConvoyUnitA6 = GetUnit(GetPointX(markerConvoyUnitA6), GetPointY(markerConvoyUnitA6));
		m_uConvoyUnitA7 = GetUnit(GetPointX(markerConvoyUnitA7), GetPointY(markerConvoyUnitA7));

		m_uConvoyUnitB1 = GetUnit(GetPointX(markerConvoyUnitB1), GetPointY(markerConvoyUnitB1));
		m_uConvoyUnitB2 = GetUnit(GetPointX(markerConvoyUnitB2), GetPointY(markerConvoyUnitB2));
		m_uConvoyUnitB3 = GetUnit(GetPointX(markerConvoyUnitB3), GetPointY(markerConvoyUnitB3));
		m_uConvoyUnitB4 = GetUnit(GetPointX(markerConvoyUnitB4), GetPointY(markerConvoyUnitB4));
		m_uConvoyUnitB5 = GetUnit(GetPointX(markerConvoyUnitB5), GetPointY(markerConvoyUnitB5));
		m_uConvoyUnitB6 = GetUnit(GetPointX(markerConvoyUnitB6), GetPointY(markerConvoyUnitB6));

		m_uArtilery1 = GetUnit(GetPointX(markerArtilery1), GetPointY(markerArtilery1));
		m_uArtilery2 = GetUnit(GetPointX(markerArtilery2), GetPointY(markerArtilery2));
		m_uArtilery3 = GetUnit(GetPointX(markerArtilery3), GetPointY(markerArtilery3));
		m_uArtilery4 = GetUnit(GetPointX(markerArtilery4), GetPointY(markerArtilery4));

		m_uEnemyUnitA1 = GetUnit(GetPointX(markerEnemyUnitA1), GetPointY(markerEnemyUnitA1));
		m_uEnemyUnitA2 = GetUnit(GetPointX(markerEnemyUnitA2), GetPointY(markerEnemyUnitA2));
		m_uEnemyUnitA3 = GetUnit(GetPointX(markerEnemyUnitA3), GetPointY(markerEnemyUnitA3));
		m_uEnemyUnitA4 = GetUnit(GetPointX(markerEnemyUnitA4), GetPointY(markerEnemyUnitA4));
		m_uEnemyUnitA5 = GetUnit(GetPointX(markerEnemyUnitA5), GetPointY(markerEnemyUnitA5));

		m_uEnemyUnitB1 = GetUnit(GetPointX(markerEnemyUnitB1), GetPointY(markerEnemyUnitB1));
		m_uEnemyUnitB2 = GetUnit(GetPointX(markerEnemyUnitB2), GetPointY(markerEnemyUnitB2));
		m_uEnemyUnitB3 = GetUnit(GetPointX(markerEnemyUnitB3), GetPointY(markerEnemyUnitB3));
		m_uEnemyUnitB4 = GetUnit(GetPointX(markerEnemyUnitB4), GetPointY(markerEnemyUnitB4));

		LookAt(m_pPlayer.GetStartingPointX(), m_pPlayer.GetStartingPointY(), 6, 0, 60, 0, 0);

		SetGameRect(GetLeft(), GetPointY(markerMapLimiter), GetRight(), GetBottom()-1);

		m_pEnemyUnits.EnableAI(false);

		m_pEnemy.EnableAI(true);
//		m_pEnemy.EnableAIFeatures(aiEverything, true);
		m_pEnemy.EnableAIFeatures(aiControlOffense, false);

		m_pEnemy.SetNeutral(m_pEnemyUnits);
		m_pEnemyUnits.SetNeutral(m_pEnemy);

		m_pEnemyUnits.EnableAIFeatures2(ai2ChooseEnemy, false);
		m_pEnemyUnits.SetEnemy(m_pConvoyUnits);
		m_pEnemyUnits.SetEnemy(m_pPlayer);

		m_pConvoyUnits.EnableAIFeatures(aiRejectAlliance, false);
		m_pConvoyUnits.EnableAIFeatures2(ai2ChooseEnemy, false);
		m_pPlayer.SetAlly(m_pConvoyUnits);
		m_pConvoyUnits.EnableAI(false);

		m_pConvoyUnits.SetNeutral(m_pEnemyUnits);

		m_pPlayer.SetMoney(5000);

		EnableAllResearchUSA( m_pPlayer, false);
		m_pPlayer.EnableResearch("RES_USA_AMPHIBIA1", true);		// M1
		m_pPlayer.EnableResearch("RES_USA_AMMO_MG1", true);			// M1
		m_pPlayer.EnableResearch("RES_USA_SPY", true);				// M2
		m_pPlayer.EnableResearch("RES_USA_HELICOPTER1", true);		// M2
		m_pPlayer.EnableResearch("RES_USA_AMMO_MG2", true);
		m_pPlayer.EnableResearch("RES_USA_HELICOPTER2", true);
		m_pPlayer.EnableResearch("RES_USA_TANK1", true);
		m_pPlayer.EnableResearch("RES_USA_SAPER", true);

		EnableAllResearchIRQ( m_pEnemy, false);
		m_pEnemy.EnableResearch("RES_IRQ_TANK1", true);				// M1
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemy.EnableResearch("RES_IRQ_HELICOPTER1", true);	// M2
		}
		m_pEnemy.EnableResearch("RES_IRQ_AMMO_MG1", true);
		m_pEnemy.EnableResearch("RES_IRQ_PILLBOX", true);
		m_pEnemy.EnableResearch("RES_IRQ_TANK2", true);
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemy.EnableResearch("RES_IRQ_SAPER", true);
		}
		m_pEnemy.EnableResearch("RES_IRQ_MIM", true);

		m_pEnemy.AddResearch("RES_IRQ_TANK1");
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemy.AddResearch("RES_IRQ_HELICOPTER1");
		}

		AddUnitTemplatesUSA(m_pPlayer);
		m_pPlayer.RemoveObjectTemplate(null, -1, "USA_TRANSPORTER", "USA_TRANSPORTER_Hook", null, null, null);

		AddUnitTemplatesIRQ( m_pEnemy );

		m_pPlayer.EnableCommand(commandRecycleUnit, false);
		m_pPlayer.EnableCommand(commandSoldBuilding, false);

		return BeforeStart, 1;
	}

	state BeforeStart
	{
		PlayTrack("Music\\Briefing.tws");

		return Start;
	}

	state Start
	{
		EnableGoal(goalHeroSurvive, true);
		EnableGoal(goalEscortConvoyA, true);
		EnableGoal(goalEscortConvoyB, true);
		AddBriefing("translateBriefingMissionUSA_3_EscortConvoy");
		PlayWave("Briefings\\USA_Briefing03.wav");

		return WaitForEnemyMove;
	}

	state WaitForEnemyMove
	{
		if ( GetMissionTime() >= m_nTimeOfEnemyMove )
		{
			return EnemyMove;
		}
		else
		{
			return WaitForEnemyMove;
		}
	}

	state EnemyMove
	{
		int nTrapLocationAGx, nTrapLocationAGy;
		int nTrapLocationBGx, nTrapLocationBGy;

		nTrapLocationAGx = GetPointX(markerTrapLocationA);
		nTrapLocationAGy = GetPointY(markerTrapLocationA);

		nTrapLocationBGx = GetPointX(markerTrapLocationB);
		nTrapLocationBGy = GetPointY(markerTrapLocationB);

		m_uEnemyUnitA1.CommandMove(nTrapLocationAGx, nTrapLocationAGy, 0);
		m_uEnemyUnitA2.CommandMove(nTrapLocationAGx, nTrapLocationAGy, 0);
		m_uEnemyUnitA3.CommandMove(nTrapLocationAGx, nTrapLocationAGy, 0);
		m_uEnemyUnitA4.CommandMove(nTrapLocationAGx, nTrapLocationAGy, 0);
		if ( m_uEnemyUnitA5 )
		{
			m_uEnemyUnitA5.CommandMove(nTrapLocationAGx, nTrapLocationAGy, 0);
		}

		m_uEnemyUnitB1.CommandMove(nTrapLocationBGx, nTrapLocationBGy, 0);
		m_uEnemyUnitB2.CommandMove(nTrapLocationBGx, nTrapLocationBGy, 0);
		m_uEnemyUnitB3.CommandMove(nTrapLocationBGx, nTrapLocationBGy, 0);
		if ( m_uEnemyUnitB4 )
		{
			m_uEnemyUnitB4.CommandMove(nTrapLocationBGx, nTrapLocationBGy, 0);
		}

		return WaitForConvoyMove;
	}

	state WaitForConvoyMove
	{
		if ( GetMissionTime() >= m_nTimeOfConvoyMove )
		{
			return ConvoyMove;
		}
		else
		{
			return WaitForConvoyMove;
		}
	}

	function int ConvoyCommandMove()
	{
		int nConvoyDestinationGx, nConvoyDestinationGy;

		nConvoyDestinationGx = m_pPlayer.GetStartingPointX();
		nConvoyDestinationGy = m_pPlayer.GetStartingPointY();

		m_uConvoyUnitA1.CommandMove(nConvoyDestinationGx, nConvoyDestinationGy, 0);
		m_uConvoyUnitA2.CommandMove(nConvoyDestinationGx, nConvoyDestinationGy, 0);
		m_uConvoyUnitA3.CommandMove(nConvoyDestinationGx, nConvoyDestinationGy, 0);
		m_uConvoyUnitA4.CommandMove(nConvoyDestinationGx, nConvoyDestinationGy, 0);
		m_uConvoyUnitA5.CommandMove(nConvoyDestinationGx, nConvoyDestinationGy, 0);
		m_uConvoyUnitA6.CommandMove(nConvoyDestinationGx, nConvoyDestinationGy, 0);
		m_uConvoyUnitA7.CommandMove(nConvoyDestinationGx, nConvoyDestinationGy, 0);

		m_uConvoyUnitB1.CommandMove(nConvoyDestinationGx, nConvoyDestinationGy, 0);
		m_uConvoyUnitB2.CommandMove(nConvoyDestinationGx, nConvoyDestinationGy, 0);
		m_uConvoyUnitB3.CommandMove(nConvoyDestinationGx, nConvoyDestinationGy, 0);
		m_uConvoyUnitB4.CommandMove(nConvoyDestinationGx, nConvoyDestinationGy, 0);
		m_uConvoyUnitB5.CommandMove(nConvoyDestinationGx, nConvoyDestinationGy, 0);
		m_uConvoyUnitB6.CommandMove(nConvoyDestinationGx, nConvoyDestinationGy, 0);
	}

	state ConvoyMove
	{
		ConvoyCommandMove();

		return EscortConvoy;
	}

	function int CheackConvoyUnits()
	{
		int nConvoyDestinationGx, nConvoyDestinationGy;

		nConvoyDestinationGx = m_pPlayer.GetStartingPointX();
		nConvoyDestinationGy = m_pPlayer.GetStartingPointY();

		if ( !m_bArrivedConvoyUnitA1 && Distance(m_uConvoyUnitA1.GetLocationX(), m_uConvoyUnitA1.GetLocationY(), nConvoyDestinationGx, nConvoyDestinationGy) <= 6 )
		{
			m_bArrivedConvoyUnitA1 = true;
			m_nUnitsArrivedA = m_nUnitsArrivedA + 1;
		}
		if ( !m_bArrivedConvoyUnitA2 && Distance(m_uConvoyUnitA2.GetLocationX(), m_uConvoyUnitA2.GetLocationY(), nConvoyDestinationGx, nConvoyDestinationGy) <= 6 )
		{
			m_bArrivedConvoyUnitA2 = true;
			m_nUnitsArrivedA = m_nUnitsArrivedA + 1;
		}
		if ( !m_bArrivedConvoyUnitA3 && Distance(m_uConvoyUnitA3.GetLocationX(), m_uConvoyUnitA3.GetLocationY(), nConvoyDestinationGx, nConvoyDestinationGy) <= 6 )
		{
			m_bArrivedConvoyUnitA3 = true;
			m_nUnitsArrivedA = m_nUnitsArrivedA + 1;
		}
		if ( !m_bArrivedConvoyUnitA4 && Distance(m_uConvoyUnitA4.GetLocationX(), m_uConvoyUnitA4.GetLocationY(), nConvoyDestinationGx, nConvoyDestinationGy) <= 6 )
		{
			m_bArrivedConvoyUnitA4 = true;
			m_nUnitsArrivedA = m_nUnitsArrivedA + 1;
		}
		if ( !m_bArrivedConvoyUnitA5 && Distance(m_uConvoyUnitA5.GetLocationX(), m_uConvoyUnitA5.GetLocationY(), nConvoyDestinationGx, nConvoyDestinationGy) <= 6 )
		{
			m_bArrivedConvoyUnitA5 = true;
			m_nUnitsArrivedA = m_nUnitsArrivedA + 1;
		}
		if ( !m_bArrivedConvoyUnitA6 && Distance(m_uConvoyUnitA6.GetLocationX(), m_uConvoyUnitA6.GetLocationY(), nConvoyDestinationGx, nConvoyDestinationGy) <= 6 )
		{
			m_bArrivedConvoyUnitA6 = true;
			m_nUnitsArrivedA = m_nUnitsArrivedA + 1;
		}
		if ( !m_bArrivedConvoyUnitA7 && Distance(m_uConvoyUnitA7.GetLocationX(), m_uConvoyUnitA7.GetLocationY(), nConvoyDestinationGx, nConvoyDestinationGy) <= 6 )
		{
			m_bArrivedConvoyUnitA7 = true;
			m_nUnitsArrivedA = m_nUnitsArrivedA + 1;
		}

		if ( !m_bArrivedConvoyUnitB1 && Distance(m_uConvoyUnitB1.GetLocationX(), m_uConvoyUnitB1.GetLocationY(), nConvoyDestinationGx, nConvoyDestinationGy) <= 6 )
		{
			m_bArrivedConvoyUnitB1 = true;
			m_nUnitsArrivedB = m_nUnitsArrivedB + 1;
		}
		if ( !m_bArrivedConvoyUnitB2 && Distance(m_uConvoyUnitB2.GetLocationX(), m_uConvoyUnitB2.GetLocationY(), nConvoyDestinationGx, nConvoyDestinationGy) <= 6 )
		{
			m_bArrivedConvoyUnitB2 = true;
			m_nUnitsArrivedB = m_nUnitsArrivedB + 1;
		}
		if ( !m_bArrivedConvoyUnitB3 && Distance(m_uConvoyUnitB3.GetLocationX(), m_uConvoyUnitB3.GetLocationY(), nConvoyDestinationGx, nConvoyDestinationGy) <= 6 )
		{
			m_bArrivedConvoyUnitB3 = true;
			m_nUnitsArrivedB = m_nUnitsArrivedB + 1;
		}
		if ( !m_bArrivedConvoyUnitB4 && Distance(m_uConvoyUnitB4.GetLocationX(), m_uConvoyUnitB4.GetLocationY(), nConvoyDestinationGx, nConvoyDestinationGy) <= 6 )
		{
			m_bArrivedConvoyUnitB4 = true;
			m_nUnitsArrivedB = m_nUnitsArrivedB + 1;
		}
		if ( !m_bArrivedConvoyUnitB5 && Distance(m_uConvoyUnitB5.GetLocationX(), m_uConvoyUnitB5.GetLocationY(), nConvoyDestinationGx, nConvoyDestinationGy) <= 6 )
		{
			m_bArrivedConvoyUnitB5 = true;
			m_nUnitsArrivedB = m_nUnitsArrivedB + 1;
		}
		if ( !m_bArrivedConvoyUnitB6 && Distance(m_uConvoyUnitB6.GetLocationX(), m_uConvoyUnitB6.GetLocationY(), nConvoyDestinationGx, nConvoyDestinationGy) <= 6 )
		{
			m_bArrivedConvoyUnitB6 = true;
			m_nUnitsArrivedB = m_nUnitsArrivedB + 1;
		}
	}

	state EscortConvoy
	{
		CheackConvoyUnits();

		if ( m_nUnitsArrivedA >= 3 )
		{
			SetGoalState(goalEscortConvoyA, goalAchieved);
		}

		if ( m_nUnitsArrivedB >= 3 )
		{
			SetGoalState(goalEscortConvoyB, goalAchieved);
		}

		if ( m_nUnitsDestroyedA > 4 )
		{
			SetGoalState(goalEscortConvoyA, goalFailed);

			m_bMissionFail = true;

			AddBriefing("translateBriefingMissionUSA_3_MissionFail");

			EnableEndMissionButton(true, false);

			return MissionComplete;
		}

		if ( m_nUnitsDestroyedB > 3 )
		{
			SetGoalState(goalEscortConvoyB, goalFailed);

			m_bMissionFail = true;

			AddBriefing("translateBriefingMissionUSA_3_MissionFail");

			EnableEndMissionButton(true, false);

			return MissionComplete;
		}

		if ( GetGoalState(goalEscortConvoyA) == goalAchieved && GetGoalState(goalEscortConvoyB) == goalAchieved )
		{
			return EscortedConvoy;
		}
		else
		{
			return EscortConvoy;
		}
	}

	state EscortedConvoy
	{
		m_pConvoyUnits.GiveAllUnitsTo(m_pPlayer);

		ConvoyCommandMove();

		EnableGoal(goalDestroyEnemy, true);
		AddBriefing("translateBriefingMissionUSA_3_DestroyEnemy");

		SetGameRect(0, 0, 0, 0);

		m_uEnemyUnitCreated = m_pEnemyUnits.CreateUnit(GetPointX(markerEnemySource), GetPointY(markerEnemySource), 0, null, "IRQ_JEEP", "IRQ_JEEP_CHAINGUN", null, null, null);

		m_uEnemyUnitCreated.CommandMove(GetPointX(markerEnemyDestination), GetPointY(markerEnemyDestination), 0);

		m_nTimeOfUnitsCreate = GetMissionTime() + 1200;

		m_bCheckNumberOfUnits = true;
		m_bCheckNumberOfBuildings = true;

		m_pEnemy.EnableAIFeatures(aiControlOffense, true);

		return DestroyEnemy;
	}

	function int CreateUnits()
	{
		unitex uTmp;
		int nGx, nGy;
		int nUnitsType;

		int nUnit;

		if ( m_bFirstCreation )
		{
			nUnitsType = 0;
			m_bFirstCreation = false;
		}
		else
		{
			if ( GetDifficultyLevel() == 0 )
			{
				nUnitsType = 0;
			}
			else
			{
				nUnitsType = Rand(3);
			}

		}

		nUnit = 0;

		for ( nGx = GetPointX(markerEnemySource) - 2; nGx <= GetPointX(markerEnemySource) + 2; nGx = nGx + 1 )
		{
			for ( nGy = GetPointY(markerEnemySource) - 2; nGy <= GetPointY(markerEnemySource) + 2; nGy = nGy + 1 )
			{
				if ( nUnitsType == 0 )
				{
					uTmp = m_pEnemyUnits.CreateUnit(nGx, nGy, 0, null, "IRQ_JEEP", "IRQ_JEEP_CHAINGUN", null, null, null);
				}
				else if ( nUnitsType == 1 )
				{
					if ( nUnit < 4 )
					{
						uTmp = m_pEnemyUnits.CreateUnit(nGx, nGy, 0, null, "IRQ_JEEP", "IRQ_JEEP_CHAINGUN", null, null, null);
					}
					else
					{
						uTmp = m_pEnemyUnits.CreateUnit(nGx, nGy, 0, null, "IRQ_TANK1", "IRQ_TANK1_CANNON", null, "IRQ_TANK1_CHAINGUN", null);
					}
				}
				else if ( nUnitsType == 2 )
				{
					uTmp = m_pEnemyUnits.CreateUnit(nGx, nGy, 0, null, "IRQ_TANK1", "IRQ_TANK1_CANNON", null, "IRQ_TANK1_CHAINGUN", null);
				}

				if ( uTmp != null )
				{
					uTmp.CommandMove(GetPointX(markerEnemyDestination), GetPointY(markerEnemyDestination), 0);

					nUnit = nUnit + 1;
				}

				if	(
					(nUnit == 4 && nUnitsType == 0) ||
					(nUnit == 6 && nUnitsType == 1) ||
					(nUnit == 5 && nUnitsType == 2)
					)
				{
					m_uEnemyUnitCreated = uTmp;

					return true;
				}
			}
		}

		return false;
	}

	state DestroyEnemy
	{
		if ( GetMissionTime() >= m_nTimeOfUnitsCreate )
		{
			if ( ! m_uEnemyUnitCreated.IsLive() )
			{
				if ( m_bFirstCreation || Rand(2) ) CreateUnits();

				m_nTimeOfUnitsCreate = GetMissionTime() + 3*1200;
			}
			else
			{
				if ( GetDifficultyLevel()==0 )
				{
					m_nTimeOfUnitsCreate = GetMissionTime() + 2*1200;
				}
				else
				{
					m_nTimeOfUnitsCreate = GetMissionTime() + 1200;
				}
			}
		}

		if ( !m_bCheckNumberOfUnits && !m_bCheckNumberOfBuildings )
		{
			return DestroyEnemy;
		}

		m_bCheckNumberOfUnits = false;
		m_bCheckNumberOfBuildings = false;

		if	(
			!m_uArtilery1.IsLive() &&
			!m_uArtilery2.IsLive() &&
			!m_uArtilery3.IsLive() &&
			!m_uArtilery4.IsLive()
			)
		{
			SetGoalState(goalDestroyEnemy, goalFailed);

			m_bMissionFail = true;

			AddBriefing("translateBriefingMissionUSA_3_MissionFail");

			EnableEndMissionButton(true, false);

			return MissionComplete;
		}

		if	(
			m_pEnemy.GetNumberOfBuildings() == m_pEnemy.GetNumberOfBuildings(buildingNormal) + m_pEnemy.GetNumberOfBuildings(buildingPowerPlant) &&
			m_pEnemy.GetNumberOfUnits() == m_pEnemy.GetNumberOfUnits(unitSupplier|chassisAny)
			)
		{
			return DestroyedEnemy;
		}
		else
		{
			return DestroyEnemy;
		}
	}

	state DestroyedEnemy
	{
		SetGoalState(goalDestroyEnemy, goalAchieved);
		SetGoalState(goalHeroSurvive, goalAchieved);

		m_pPlayer.EnableCommand(commandRecycleUnit, true);
		m_pPlayer.EnableCommand(commandSoldBuilding, true);

		AddBriefing("translateBriefingMissionUSA_3_MissionComplete");

		EnableEndMissionButton(true, true);

		return MissionComplete;
	}

	state MissionComplete
	{
		return MissionComplete;
	}

	event UnitDestroyed(unit uUnit)
	{
		if ( m_bMissionFail )
		{
			return;
		}

		m_bCheckNumberOfUnits = true;

		if ( uUnit == m_uHero )
		{
			SetGoalState(goalHeroSurvive, goalFailed);

			m_bMissionFail = true;

			AddBriefing("translateBriefingMissionUSA_3_MissionFail");

			EnableEndMissionButton(true, false);

			state MissionComplete;
		}

		else if ( uUnit == m_uConvoyUnitA1 ) m_nUnitsDestroyedA = m_nUnitsDestroyedA + 1;
		else if ( uUnit == m_uConvoyUnitA2 ) m_nUnitsDestroyedA = m_nUnitsDestroyedA + 1;
		else if ( uUnit == m_uConvoyUnitA3 ) m_nUnitsDestroyedA = m_nUnitsDestroyedA + 1;
		else if ( uUnit == m_uConvoyUnitA4 ) m_nUnitsDestroyedA = m_nUnitsDestroyedA + 1;
		else if ( uUnit == m_uConvoyUnitA5 ) m_nUnitsDestroyedA = m_nUnitsDestroyedA + 1;
		else if ( uUnit == m_uConvoyUnitA6 ) m_nUnitsDestroyedA = m_nUnitsDestroyedA + 1;
		else if ( uUnit == m_uConvoyUnitA7 ) m_nUnitsDestroyedA = m_nUnitsDestroyedA + 1;

		else if ( uUnit == m_uConvoyUnitB1 ) m_nUnitsDestroyedB = m_nUnitsDestroyedB + 1;
		else if ( uUnit == m_uConvoyUnitB2 ) m_nUnitsDestroyedB = m_nUnitsDestroyedB + 1;
		else if ( uUnit == m_uConvoyUnitB3 ) m_nUnitsDestroyedB = m_nUnitsDestroyedB + 1;
		else if ( uUnit == m_uConvoyUnitB4 ) m_nUnitsDestroyedB = m_nUnitsDestroyedB + 1;
		else if ( uUnit == m_uConvoyUnitB5 ) m_nUnitsDestroyedB = m_nUnitsDestroyedB + 1;
		else if ( uUnit == m_uConvoyUnitB6 ) m_nUnitsDestroyedB = m_nUnitsDestroyedB + 1;
	}

	event BuildingDestroyed(unit uBuilding)
	{
		m_bCheckNumberOfBuildings = true;
	}

	event EndMission()
	{
		m_pPlayer.SaveUnit(0, m_uHero);
	}

	event SetupInterface()
	{
	}
}
