mission "translateMissionUSA_4"
{
	consts
	{
		goalHeroSurvive = 0;
		goalDestroyEnemyA = 1;
		goalDestroyAAEnemyB = 2;
		goalDestroyEnemyC = 3;

		markerHero = 12;

		markerHelicopter = 13;
		markerHelicopterDestination = 14;

		markerMapLimiter = 15;

		markerAAFirst = 4;
		markerAALast = 10;

		markerPatrolPointFirst = 0;
		markerPatrolPointLast = 3;

		markerJeep1 = 0;
		markerJeep2 = 1;
		markerJeep3 = 2;
		markerJeep4 = 3;

		markerEnemyCBuildingFirstA = 68;
		markerEnemyCBuildingLastA = 112;

		markerEnemyCBuildingFirstB = 116;
		markerEnemyCBuildingLastB = 154;
	}

	include "UnitTemplates.ech"
	include "Research.ech"
	include "Varia.ech"

	player m_pPlayer;

	player m_pEnemyA;
	player m_pEnemyB;
	player m_pEnemyC;

	player m_pEnemyUnits;

	unitex m_uHero;
	unitex m_uHelicopter;

	unitex m_uJeep1;
	unitex m_uJeep2;
	unitex m_uJeep3;
	unitex m_uJeep4;

	int m_nJeep1MoveToPoint;
	int m_nJeep2MoveToPoint;
	int m_nJeep3MoveToPoint;
	int m_nJeep4MoveToPoint;

	int m_bCheckNumberOfUnits;
	int m_bCheckNumberOfBuildings;

	state Initialize;
	state Start;
	state BeforeStart;
	state DisableInterface;
	state HeroStart;
	state WaitForHelicopterDestroy;
	state DestroyedHelicopter;
	state DestroyEnemyA;
	state DestroyedEnemyA;
	state DestroyAAEnemyB;
	state DestroyedAAEnemyB;
	state DestroyEnemyC;
	state DestroyedEnemyC;
	state MissionComplete;

	function int UpdateMoveToPoint(int nMoveToPoint, unitex uUnit)
	{
		if ( Distance(uUnit.GetLocationX(), uUnit.GetLocationY(), GetPointX(nMoveToPoint), GetPointY(nMoveToPoint)) <= 3 )
		{
			nMoveToPoint = nMoveToPoint + 1;

			if ( nMoveToPoint > markerPatrolPointLast )
			{
				nMoveToPoint = markerPatrolPointFirst;
			}

			uUnit.CommandMove(GetPointX(nMoveToPoint), GetPointY(nMoveToPoint), 0);

			return nMoveToPoint;
		}
		else
		{
			if ( ! uUnit.IsMoving() )
			{
				uUnit.CommandMove(GetPointX(nMoveToPoint), GetPointY(nMoveToPoint), 0);
			}

			return nMoveToPoint;
		}
	}

	event Timer0()
	{
		m_nJeep1MoveToPoint = UpdateMoveToPoint(m_nJeep1MoveToPoint, m_uJeep1);
		m_nJeep2MoveToPoint = UpdateMoveToPoint(m_nJeep2MoveToPoint, m_uJeep2);
		m_nJeep3MoveToPoint = UpdateMoveToPoint(m_nJeep3MoveToPoint, m_uJeep3);
		m_nJeep4MoveToPoint = UpdateMoveToPoint(m_nJeep4MoveToPoint, m_uJeep4);
	}

	function int ClearMarkers(int nStartPoint, int nEndPoint)
	{
		int i;

		for ( i=nStartPoint; i<=nEndPoint; i=i+1 )
		{
			ClearArea (65535, GetPointX(i), GetPointY(i), GetPointZ(i), 0);
		}
	}

	function int ModifyDifficulty()
	{
		if ( GetDifficultyLevel() == 0 )
		{
			ClearArea	(65535, GetPointX(18), GetPointY(18), GetPointZ(18), 1);
			ClearArea	(65535, GetPointX(19), GetPointY(19), GetPointZ(19), 1);
			ClearArea	(65535, GetPointX(20), GetPointY(20), GetPointZ(20), 1);
			ClearArea	(65535, GetPointX(21), GetPointY(21), GetPointZ(21), 1);
			ClearArea	(65535, GetPointX(22), GetPointY(22), GetPointZ(22), 1);
			ClearArea	(65535, GetPointX(23), GetPointY(23), GetPointZ(23), 1);

			ClearArea	(65535, GetPointX(115), GetPointY(115), GetPointZ(115), 9);

			ClearMarkers (24, 26);
			ClearMarkers (27, 34);
			ClearMarkers (35, 43);
			ClearMarkers (44, 59);
			ClearMarkers (68, 112);
			ClearMarkers (113, 114);

			ClearMarkers (159, 159);
		}
		else if ( GetDifficultyLevel() == 1 )
		{
			ClearArea	(65535, GetPointX(19), GetPointY(19), GetPointZ(19), 1);
			ClearArea	(65535, GetPointX(20), GetPointY(20), GetPointZ(20), 1);
			ClearArea	(65535, GetPointX(21), GetPointY(21), GetPointZ(21), 1);

			ClearArea	(65535, GetPointX(115), GetPointY(115), GetPointZ(115), 9);

			ClearMarkers (27, 30);
			ClearMarkers (35, 35);
			ClearMarkers (37, 37);
			ClearMarkers (39, 40);
			ClearMarkers (44, 49);
			ClearMarkers (60, 67);
			ClearMarkers (68, 75);
			ClearMarkers (79, 79);
			ClearMarkers (97, 97);
			ClearMarkers (99, 112);
		}
		else if ( GetDifficultyLevel() == 2 )
		{
			ClearMarkers (60, 67);
		}
	}

	state Initialize
	{
		RegisterGoal(goalHeroSurvive, "translateGoalMissionUSA_HeroSurvive");
		RegisterGoal(goalDestroyEnemyA, "translateGoalMissionUSA_4_DestroyEnemyA");
		RegisterGoal(goalDestroyAAEnemyB, "translateGoalMissionUSA_4_DestroyAAEnemyB");
		RegisterGoal(goalDestroyEnemyC, "translateGoalMissionUSA_4_DestroyEnemyC");

		m_pPlayer = GetPlayer(0);
		m_pPlayer.EnableStatistics(true);

		m_pEnemyA = GetPlayer(1);
		m_pEnemyA.EnableStatistics(true);

		m_pEnemyB = GetPlayer(2);
		m_pEnemyB.EnableStatistics(true);

		m_pEnemyC = GetPlayer(3);
		m_pEnemyC.EnableStatistics(true);

		m_pEnemyUnits = GetPlayer(4);
		m_pEnemyUnits.EnableStatistics(false);

        //moved by JS
		ModifyDifficulty();

		if ( GetDifficultyLevel() == 0 )
		{
			m_pEnemyA.LoadScript("single\\singleEasy");
			m_pEnemyB.LoadScript("single\\singleEasy");
			m_pEnemyC.LoadScript("single\\singleEasy");

			m_pEnemyA.SetMilitaryUnitsLimit(5000);
			m_pEnemyB.SetMilitaryUnitsLimit(5000);
			m_pEnemyC.SetMilitaryUnitsLimit(5000);

			m_pEnemyA.EnableAIFeatures(aiBuildBuildings, false);
			m_pEnemyB.EnableAIFeatures(aiBuildBuildings, false);
			m_pEnemyC.EnableAIFeatures(aiBuildBuildings, false);
		}
		else if ( GetDifficultyLevel() == 1 )
		{
			m_pEnemyA.LoadScript("single\\singleMedium");
			m_pEnemyB.LoadScript("single\\singleMedium");
			m_pEnemyC.LoadScript("single\\singleMedium");

			m_pEnemyA.SetMilitaryUnitsLimit(5000);
			m_pEnemyB.SetMilitaryUnitsLimit(10000);
			m_pEnemyC.SetMilitaryUnitsLimit(20000);
		}
		else if ( GetDifficultyLevel() == 2 )
		{
			m_pEnemyA.LoadScript("single\\singleHard");
			m_pEnemyB.LoadScript("single\\singleHard");
			m_pEnemyC.LoadScript("single\\singleHard");

			m_pEnemyA.SetMilitaryUnitsLimit(5000);
			m_pEnemyB.SetMilitaryUnitsLimit(10000);
			m_pEnemyC.SetMilitaryUnitsLimit(60000);
		}

		m_pEnemyB.SetObjectTemplateCountLimit(10,"IRQ_HELICOPTER","IRQ_HELICOPTER_GUN");
		m_pEnemyC.SetObjectTemplateCountLimit(10,"IRQ_HELICOPTER","IRQ_HELICOPTER_GUN");

		m_pEnemyA.EnableMilitaryUnitsLimit(true);
		m_pEnemyB.EnableMilitaryUnitsLimit(true);
		m_pEnemyC.EnableMilitaryUnitsLimit(true);

		m_uHero = GetUnit(GetPointX(markerHero), GetPointY(markerHero));

		m_uHelicopter = GetUnit(GetPointX(markerHelicopter), GetPointY(markerHelicopter));

		m_uJeep1 = GetUnit(GetPointX(markerJeep1), GetPointY(markerJeep1));
		m_uJeep2 = GetUnit(GetPointX(markerJeep2), GetPointY(markerJeep2));
		m_uJeep3 = GetUnit(GetPointX(markerJeep3), GetPointY(markerJeep3));
		m_uJeep4 = GetUnit(GetPointX(markerJeep4), GetPointY(markerJeep4));

		m_pEnemyC.CreateBuilding(GetPointX(155), GetPointY(155), 0, 0, "IRQ_AM_RADAR");
		m_pEnemyC.CreateBuilding(GetPointX(156), GetPointY(156), 0, 0, "IRQ_H_RADARS1");
		m_pEnemyC.CreateBuilding(GetPointX(157), GetPointY(157), 0, 0, "IRQ_H_RADARS2");
		m_pEnemyC.CreateBuilding(GetPointX(158), GetPointY(158), 0, 0, "IRQ_AM_CTRLTOWER");

		m_pPlayer.LookAt(GetPointX(markerHero), GetPointY(markerHero), 6, 0, 0, 0);

		m_pEnemyA.EnableAI(true);
//		m_pEnemyA.EnableAIFeatures(aiEverything, true);
		m_pEnemyA.EnableAIFeatures(aiBuildBuildings, false);

		m_pEnemyB.EnableAI(true);
//		m_pEnemyB.EnableAIFeatures(aiEverything, true);

		m_pEnemyC.EnableAI(false);
//		m_pEnemyC.EnableAIFeatures(aiEverything, true);
//		m_pEnemyC.EnableAIFeatures(aiControlOffense, false);

		m_pEnemyUnits.EnableAI(false);

		m_pPlayer.SetMoney(2000);

		m_pEnemyA.SetMoney(0);
		m_pEnemyB.SetMoney(5000);
		m_pEnemyC.SetMoney(5000);

		AddUnitTemplatesUSA(m_pPlayer);

		SetGameRect(GetPointX(markerMapLimiter), GetPointY(markerMapLimiter), GetRight(), GetBottom()-1);
	
		m_nJeep1MoveToPoint = 1;
		m_nJeep2MoveToPoint = 2;
		m_nJeep3MoveToPoint = 3;
		m_nJeep4MoveToPoint = 0;

		EnableAllResearchUSA( m_pPlayer, false);
		m_pPlayer.EnableResearch("RES_USA_AMPHIBIA1", true);		// M1
		m_pPlayer.EnableResearch("RES_USA_AMMO_MG1", true);			// M1
		m_pPlayer.EnableResearch("RES_USA_SPY", true);				// M2
		m_pPlayer.EnableResearch("RES_USA_HELICOPTER1", true);		// M2
		m_pPlayer.EnableResearch("RES_USA_AMMO_MG2", true);			// M3
		m_pPlayer.EnableResearch("RES_USA_HELICOPTER2", true);		// M3
		m_pPlayer.EnableResearch("RES_USA_TANK1", true);			// M3
		m_pPlayer.EnableResearch("RES_USA_SAPER", true);			// M3
//		m_pPlayer.EnableResearch("RES_USA_MORTAR", true);	// w DestroyedAAEnemyB
		m_pPlayer.EnableResearch("RES_USA_AMMO_CANNON1", true);
		m_pPlayer.EnableResearch("RES_USA_MIM", true);
		m_pPlayer.EnableResearch("RES_USA_SPECIAL_FILTER2", true);

		EnableAllResearchIRQ( m_pEnemyA, false);

		EnableAllResearchIRQ( m_pEnemyB, false);
		m_pEnemyB.EnableResearch("RES_IRQ_TANK1", true);			// M1
		m_pEnemyB.EnableResearch("RES_IRQ_HELICOPTER1", true);		// M2
		m_pEnemyB.EnableResearch("RES_IRQ_AMMO_MG1", true);			// M3
		m_pEnemyB.EnableResearch("RES_IRQ_PILLBOX", true);			// M3
		m_pEnemyB.EnableResearch("RES_IRQ_TANK2", true);			// M3
		m_pEnemyB.EnableResearch("RES_IRQ_SAPER", true);			// M3
		m_pEnemyB.EnableResearch("RES_IRQ_MIM", true);				// M3
		m_pEnemyB.EnableResearch("RES_IRQ_RART", true);
		m_pEnemyB.EnableResearch("RES_IRQ_HRART", true);
		m_pEnemyB.EnableResearch("RES_IRQ_AMMO_MIM1", true);
		m_pEnemyB.EnableResearch("RES_IRQ_SPECIAL_FILTER2", true);

		EnableAllResearchIRQ( m_pEnemyC, false);
		m_pEnemyC.EnableResearch("RES_IRQ_TANK1", true);			// M1
		m_pEnemyC.EnableResearch("RES_IRQ_HELICOPTER1", true);		// M2
		m_pEnemyC.EnableResearch("RES_IRQ_AMMO_MG1", true);			// M3
		m_pEnemyC.EnableResearch("RES_IRQ_PILLBOX", true);			// M3
		m_pEnemyC.EnableResearch("RES_IRQ_TANK2", true);			// M3
		m_pEnemyC.EnableResearch("RES_IRQ_SAPER", true);			// M3
		m_pEnemyC.EnableResearch("RES_IRQ_MIM", true);				// M3
		m_pEnemyC.EnableResearch("RES_IRQ_RART", true);
		m_pEnemyC.EnableResearch("RES_IRQ_HRART", true);
		m_pEnemyC.EnableResearch("RES_IRQ_AMMO_MIM1", true);
		m_pEnemyC.EnableResearch("RES_IRQ_SPECIAL_FILTER2", true);

		m_pEnemyB.AddResearch("RES_IRQ_TANK1");
		m_pEnemyB.AddResearch("RES_IRQ_HELICOPTER1");
		m_pEnemyB.AddResearch("RES_IRQ_AMMO_MG1");
		m_pEnemyB.AddResearch("RES_IRQ_PILLBOX");
		m_pEnemyB.AddResearch("RES_IRQ_TANK2");
		m_pEnemyB.AddResearch("RES_IRQ_SAPER");
		m_pEnemyB.AddResearch("RES_IRQ_MIM");

		m_pEnemyC.AddResearch("RES_IRQ_TANK1");
		m_pEnemyC.AddResearch("RES_IRQ_HELICOPTER1");
		m_pEnemyC.AddResearch("RES_IRQ_AMMO_MG1");
		m_pEnemyC.AddResearch("RES_IRQ_PILLBOX");
		m_pEnemyC.AddResearch("RES_IRQ_TANK2");
		m_pEnemyC.AddResearch("RES_IRQ_SAPER");
		m_pEnemyC.AddResearch("RES_IRQ_MIM");

		SetTimer(0, 20); // Poruszanie jeepami

		AddUnitTemplatesIRQ( m_pEnemyA );
		AddUnitTemplatesIRQ( m_pEnemyB );
		AddUnitTemplatesIRQ( m_pEnemyC );

		return BeforeStart, 1;
	}

	state BeforeStart
	{
		PlayTrack("Music\\Briefing.tws");

		return Start;
	}

	state Start
	{
		EnableGoal(goalHeroSurvive, true);
		EnableGoal(goalDestroyEnemyA, true);

		AddBriefing("translateBriefingMissionUSA_4_StartInfo");
		PlayWave("Briefings\\USA_Briefing04.wav");

		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyB.EnableAIFeatures2(ai2RebuildBaseOnly, true);
		}

		m_uHelicopter.CommandMove(GetPointX(markerHelicopterDestination), GetPointY(markerHelicopterDestination), 0);

		return DisableInterface,1;
	}

	state DisableInterface
	{
		EnableInterface(false);

		return HeroStart, 60;
	}

	state HeroStart
	{
		m_pPlayer.DelayedLookAt(GetPointX(markerHelicopterDestination), GetPointY(markerHelicopterDestination), 12, 0, 0, 0, 100, 1);

		m_uHero.CommandMove(GetPointX(markerHelicopterDestination), GetPointY(markerHelicopterDestination), 0);

		return WaitForHelicopterDestroy;
	}

	state WaitForHelicopterDestroy
	{
		if ( ! m_uHelicopter.IsLive() )
		{
			return DestroyedHelicopter,1;
		}
		else
		{
			return WaitForHelicopterDestroy,5;
		}
	}

	state DestroyedHelicopter
	{
		AddBriefing("translateBriefingMissionUSA_4_DestroyEnemyA");

		AddWorldMapSign(m_pEnemyA.GetStartingPointX(), m_pEnemyA.GetStartingPointY(), 0, 1, 65000);

		EnableInterface(true);

		m_uHero.CommandSetMovementMode(2); // hold position
		m_uHero.CommandMove(GetPointX(markerHero), GetPointY(markerHero), 0);

		m_bCheckNumberOfUnits = true;
		m_bCheckNumberOfBuildings = true;

		return DestroyEnemyA;
	}

	state DestroyEnemyA
	{
		if ( !m_bCheckNumberOfUnits && !m_bCheckNumberOfBuildings )
		{
			return DestroyEnemyA;
		}

		m_bCheckNumberOfUnits = false;
		m_bCheckNumberOfBuildings = false;

		if	( m_pEnemyA.GetNumberOfBuildings() == 0 && m_pEnemyA.GetNumberOfUnits() == 0 )
		{
			return DestroyedEnemyA;
		}
		else
		{
			return DestroyEnemyA;
		}
	}

	state DestroyedEnemyA
	{
		int i;

		SetGoalState(goalDestroyEnemyA, goalAchieved);

		EnableGoal(goalDestroyAAEnemyB, true);

		RemoveWorldMapSign(m_pEnemyA.GetStartingPointX(), m_pEnemyA.GetStartingPointY(), 0);
		AddWorldMapSign(m_pEnemyB.GetStartingPointX(), m_pEnemyB.GetStartingPointY(), 0, 1, 65000);

		AddBriefing("translateBriefingMissionUSA_4_DestroyAAEnemyB");

		for ( i=markerAAFirst; i<=markerAALast; i=i+1 )
		{
			CreateArtefact("ARTIFACT_CLICK_ME", GetPointX(i), GetPointY(i), 0, 0);
		}

		SetGameRect(GetLeft(), GetPointY(markerMapLimiter), GetRight(), GetBottom()-1);

		m_bCheckNumberOfUnits = true;
		m_bCheckNumberOfBuildings = true;

		return DestroyAAEnemyB;
	}

	state DestroyAAEnemyB
	{
		int i;
		unitex uTmp;

		if ( !m_bCheckNumberOfBuildings )
		{
			return DestroyAAEnemyB;
		}

		m_bCheckNumberOfBuildings = false;

		for ( i=markerAAFirst; i<=markerAALast; i=i+1 )
		{
			uTmp = GetUnit(GetPointX(i), GetPointY(i), 0);
			if ( uTmp != null && uTmp.IsLive() && uTmp.IsBuilding() && uTmp.GetIFF() == m_pEnemyB.GetIFF() )
			{
				return DestroyAAEnemyB;
			}
		}

		return DestroyedAAEnemyB;
	}

	state DestroyedAAEnemyB
	{
//		int i;

//		for ( i=markerAAFirst; i<=markerAALast; i=i+1 ) RemoveArtefact(GetPointX(i), GetPointY(i), 0);

		RemoveWorldMapSign(m_pEnemyB.GetStartingPointX(), m_pEnemyB.GetStartingPointY(), 0);
		AddWorldMapSign(m_pEnemyC.GetStartingPointX(), m_pEnemyC.GetStartingPointY(), 0, 1, 65000);

		SetGoalState(goalDestroyAAEnemyB, goalAchieved);

		EnableGoal(goalDestroyEnemyC, true);

		AddBriefing("translateBriefingMissionUSA_4_DestroyEnemyC");

		m_pPlayer.MakeBombingAttack(m_pEnemyB.GetStartingPointX(), m_pEnemyB.GetStartingPointY(), "USA_BOMBER", "MIS_USA_BOMB1", 56, 3, 0, false);

		SetGameRect(0, 0, 0, 0);

		m_pPlayer.EnableResearch("RES_USA_MORTAR", true);

		m_pEnemyC.EnableAI(true);

		m_bCheckNumberOfUnits = true;
		m_bCheckNumberOfBuildings = true;

		return DestroyEnemyC;
	}

	state DestroyEnemyC
	{
		if ( !m_bCheckNumberOfBuildings )
		{
			return DestroyEnemyC;
		}

		m_bCheckNumberOfBuildings = false;


		if	(
			CountPlayerBuildings(markerEnemyCBuildingFirstA, markerEnemyCBuildingLastA, m_pEnemyC.GetIFFNumber()) == 0 &&
			CountPlayerBuildings(markerEnemyCBuildingFirstB, markerEnemyCBuildingLastB, m_pEnemyC.GetIFFNumber()) == 0
			)
		{
			return DestroyedEnemyC;
		}
		else
		{
			return DestroyEnemyC;
		}
	}

	state DestroyedEnemyC
	{
		RemoveWorldMapSign(m_pEnemyC.GetStartingPointX(), m_pEnemyC.GetStartingPointY(), 0);

		SetGoalState(goalDestroyEnemyC, goalAchieved);
		SetGoalState(goalHeroSurvive, goalAchieved);

		AddBriefing("translateBriefingMissionUSA_4_MissionComplete");

		EnableEndMissionButton(true, true);

		return MissionComplete;
	}

	state MissionComplete
	{
		return MissionComplete;
	}

	event UnitDestroyed(unit uUnit)
	{
		m_bCheckNumberOfUnits = true;

		if ( uUnit == m_uHero )
		{
			SetGoalState(goalHeroSurvive, goalFailed);

			AddBriefing("translateBriefingMissionUSA_4_MissionFail");

			EnableEndMissionButton(true, false);

			state MissionComplete;
		}
	}

	event BuildingDestroyed(unit uBuilding)
	{
		int i;

		if ( m_pEnemyC.GetNumberOfBuildings() < 10 )
		{
			m_pEnemyC.EnableAIFeatures(aiBuildBuildings, false);
		}

		m_bCheckNumberOfBuildings = true;

		if ( state == DestroyAAEnemyB || state == DestroyedAAEnemyB )
		{
			for ( i=markerAAFirst; i<=markerAALast; ++i )
			{
				if	(
					uBuilding.GetLocationX() == GetPointX(i) &&
					uBuilding.GetLocationY() == GetPointY(i) &&
					uBuilding.GetIFF() == m_pEnemyB.GetIFF()
					)
				{
					RemoveArtefact(GetPointX(i), GetPointY(i), 0);
				}
			}
		}
	}

	event BuildingCreated(unit uBuilding)
	{
		int i;

		if ( state == DestroyAAEnemyB )
		{
			for ( i=markerAAFirst; i<=markerAALast; ++i )
			{
				if	(
					uBuilding.GetLocationX() == GetPointX(i) &&
					uBuilding.GetLocationY() == GetPointY(i) &&
					uBuilding.GetIFF() == m_pEnemyB.GetIFF()
					)
				{
					CreateArtefact("ARTIFACT_CLICK_ME", GetPointX(i), GetPointY(i), 0, 0);
				}
			}
		}
	}

	event SetupInterface()
	{
	}
}
