mission "translateMissionUSA_8"
{
	consts
	{
		goalHeroSurvive = 0;
		goalFindConvoy = 1;
		goalEscortConvoy = 2;

		markerHero = 0;

		markerTruck1 = 3;
		markerTruck2 = 4;
		markerTruck3 = 5;

		markerJeep1 = 6;
		markerJeep2 = 7;

		markerDetonateFrom = 1;
		markerDetonateTo = 2;

		markerArtDstFirst = 60;
		markerArtGuardLast = 62;
		markerArtDstLast = 67;

		markerScudA = 71;
		markerCapturerAFirst = 72;
		markerScudTargetA = 70;

		markerScudB = 80;
		markerCapturerBFirst = 81;
		markerScudTargetB = 65;
	}

	include "UnitTemplates.ech"
	include "Research.ech"

	player m_pPlayer;
	player m_pFriendlyUnits;

	player m_pEnemy;
	player m_pEnemyUnits;

	player m_pSpecialUnits;

	unitex m_uHero;

	unitex m_uTruck1;
	unitex m_uTruck2;
	unitex m_uTruck3;

	unitex m_uJeep1;
	unitex m_uJeep2;

	unitex m_uScudA;
	unitex m_uCapturerA1;
	unitex m_uCapturerA2;
	unitex m_uCapturerA3;
	unitex m_uCapturerA4;

	unitex m_uScudB;
	unitex m_uCapturerB1;
	unitex m_uCapturerB2;
	unitex m_uCapturerB3;
	unitex m_uCapturerB4;
	unitex m_uCapturerB5;
	unitex m_uCapturerB6;

	int m_bCheckNumberOfUnits;
	int m_bCheckNumberOfBuildings;

	int m_bCheckDestroyedUnits;

	int m_nTimeOfEnableAI;

	int m_bMissionFail;

	unitex m_uArt1;
	unitex m_uArt2;
	unitex m_uArt3;
	unitex m_uArt4;

	int m_nCurArtDst;
	int m_bArtMoved;

	function int InitializeArtGroupUnit(int nPoint, unitex uAtr)
	{
		unitex uTmp;

		uTmp = GetUnit(GetPointX(nPoint), GetPointY(nPoint));

		if ( uTmp )
		{
			uTmp.CommandEscort(uAtr);
			uTmp.CommandSetMovementMode(2); // hold position
			uTmp.RegenerateAmmo();
			uTmp.CommandSetLights(1); // lights off
		}
	}

	function int InitializeArtGroup()
	{
		m_nCurArtDst = markerArtDstFirst;
		m_bArtMoved = false;

		m_uArt1 = GetUnit(GetPointX(15), GetPointY(15));
		m_uArt2 = GetUnit(GetPointX(16), GetPointY(16));
		m_uArt3 = GetUnit(GetPointX(17), GetPointY(17));
		m_uArt4 = GetUnit(GetPointX(18), GetPointY(18));

		m_uArt1.CommandSetMovementMode(2); // hold position
		m_uArt2.CommandSetMovementMode(2); // hold position
		m_uArt3.CommandSetMovementMode(2); // hold position
		m_uArt4.CommandSetMovementMode(2); // hold position

		m_uArt1.CommandSetLights(1); // lights off
		m_uArt2.CommandSetLights(1); // lights off
		m_uArt3.CommandSetLights(1); // lights off
		m_uArt4.CommandSetLights(1); // lights off

		m_uArt1.RegenerateAmmo();
		m_uArt2.RegenerateAmmo();
		m_uArt3.RegenerateAmmo();
		m_uArt4.RegenerateAmmo();

		// tanks
		InitializeArtGroupUnit( 8, m_uArt1);
		InitializeArtGroupUnit( 9, m_uArt2);
		InitializeArtGroupUnit(10, m_uArt3);
		InitializeArtGroupUnit(11, m_uArt1);
		InitializeArtGroupUnit(12, m_uArt2);
		InitializeArtGroupUnit(13, m_uArt3);
		InitializeArtGroupUnit(14, m_uArt4);

		// helicopters
		InitializeArtGroupUnit(19, m_uArt3);
		InitializeArtGroupUnit(20, m_uArt4);
		InitializeArtGroupUnit(21, m_uArt1);
		InitializeArtGroupUnit(22, m_uArt2);
		InitializeArtGroupUnit(23, m_uArt3);
		InitializeArtGroupUnit(24, m_uArt4);

		// rolands
		InitializeArtGroupUnit(25, m_uArt1);
		InitializeArtGroupUnit(26, m_uArt2);
		InitializeArtGroupUnit(27, m_uArt3);

		return true;
	}

	unitex m_uBuildingInArea;

	function int IsPlayerBuildingInArea(int nPoint)
	{
		int x, y;
		int sx, sy, ex, ey;
		unitex uTmp;

		sx = GetPointX(nPoint)-5;
		sy = GetPointY(nPoint)-5;

		ex = GetPointX(nPoint)+5;
		ey = GetPointY(nPoint)+5;

		for ( y = sy; y <= ey; ++y )
		{
			for ( x = sx; x <= ex ; ++x )
			{
				uTmp = GetUnit(x, y);

				if ( uTmp != null && uTmp.IsBuilding() && uTmp.GetIFF() == m_pPlayer.GetIFF() )
				{
					m_uBuildingInArea = uTmp;
					return true;
				}
			}
		}

		return false;
	}

	event Timer2() // ArtControl
	{
		int i;

		if ( GetDifficultyLevel() == 0 )
		{
			return;
		}

		if ( m_nCurArtDst > markerArtDstLast )
		{
			return;
		}

		if ( m_nCurArtDst < markerArtGuardLast )
		{
			for ( i=markerArtDstFirst; i<=markerArtGuardLast; ++i )
			{
				if ( IsPlayerBuildingInArea(i) )
				{
					m_nCurArtDst = i;
					break;
				}
			}
		}

		if ( IsPlayerBuildingInArea(m_nCurArtDst) )
		{
			m_uArt1.CommandAttack(m_uBuildingInArea);
			m_uArt2.CommandAttack(m_uBuildingInArea);
			m_uArt3.CommandAttack(m_uBuildingInArea);
			m_uArt4.CommandAttack(m_uBuildingInArea);

			m_bArtMoved = true;
		}
		else if ( m_bArtMoved )
		{
			m_nCurArtDst = m_nCurArtDst + 1;

/*
			if ( m_nCurArtDst > markerArtDstLast )
			{
				m_uArt1.CommandMove(GetPointX(markerArtDstLast), GetPointY(markerArtDstLast), 0);
				m_uArt2.CommandMove(GetPointX(markerArtDstLast), GetPointY(markerArtDstLast), 0);
				m_uArt3.CommandMove(GetPointX(markerArtDstLast), GetPointY(markerArtDstLast), 0);
				m_uArt4.CommandMove(GetPointX(markerArtDstLast), GetPointY(markerArtDstLast), 0);
			}
*/
		}

		if ( !m_bArtMoved && m_pPlayer.IsPointLocated(GetPointX(markerArtDstFirst), GetPointY(markerArtDstFirst)) )
		{
			m_bArtMoved = true;

			m_uArt1.CommandMove(GetPointX(markerArtGuardLast), GetPointY(markerArtGuardLast), 0);
			m_uArt2.CommandMove(GetPointX(markerArtGuardLast), GetPointY(markerArtGuardLast), 0);
			m_uArt3.CommandMove(GetPointX(markerArtGuardLast), GetPointY(markerArtGuardLast), 0);
			m_uArt4.CommandMove(GetPointX(markerArtGuardLast), GetPointY(markerArtGuardLast), 0);
		}
	}

	function int CountPlayerUnitsInArea(int nPoint)
	{
		int x, y;
		int sx, sy, ex, ey;
		unitex uTmp;

		int nUnits;

		sx = GetPointX(nPoint)-5;
		sy = GetPointY(nPoint)-5;

		ex = GetPointX(nPoint)+5;
		ey = GetPointY(nPoint)+5;

		nUnits = 0;

		for ( y = sy; y <= ey; ++y )
		{
			for ( x = sx; x <= ex ; ++x )
			{
				uTmp = GetUnit(x, y);

				if ( uTmp != null && uTmp.GetIFF() == m_pPlayer.GetIFF() )
				{
					++nUnits;
				}
			}
		}

		return nUnits;
	}

	function int CountBuildingsUnitsInArea(int nPoint)
	{
		int x, y;
		int sx, sy, ex, ey;
		unitex uTmp;

		int nBuildings;

		sx = GetPointX(nPoint)-5;
		sy = GetPointY(nPoint)-6;

		ex = GetPointX(nPoint)+6;
		ey = GetPointY(nPoint)+6;

		nBuildings = 0;

		for ( y = sy; y <= ey; ++y )
		{
			for ( x = sx; x <= ex ; ++x )
			{
				uTmp = GetUnit(x, y);

				if ( uTmp != null && uTmp.IsBuilding() && uTmp.GetIFF() == m_pPlayer.GetIFF() )
				{
					++nBuildings;
				}
			}
		}

		return nBuildings;
	}

	int m_nUnitsStayCounter;
	int m_bScudAReady;
	int m_bScudBReady;

	event Timer3() // ScudControl
	{
		if ( GetDifficultyLevel() == 0 )
		{
			return;
		}

		if ( CountPlayerUnitsInArea(markerScudTargetA) >= 6 )
		{
			++m_nUnitsStayCounter;
		}
		else
		{
			m_nUnitsStayCounter = 0;
		}

		if ( !m_bScudAReady )
		{
			m_uScudA.CommandStop();
		}

		if ( m_bScudAReady && m_nUnitsStayCounter >= 5 )
		{
			m_uScudA.CommandAttackOnPoint(GetPointX(markerScudTargetA), GetPointY(markerScudTargetA), 0);

			if ( m_uCapturerA1 ) // bo na medium go nie ma...
			{
				m_uCapturerA1.CommandMove(GetPointX(markerScudTargetA), GetPointY(markerScudTargetA), 0);
			}
			m_uCapturerA2.CommandMove(GetPointX(markerScudTargetA), GetPointY(markerScudTargetA), 0);
			m_uCapturerA3.CommandMove(GetPointX(markerScudTargetA), GetPointY(markerScudTargetA), 0);
			m_uCapturerA4.CommandMove(GetPointX(markerScudTargetA), GetPointY(markerScudTargetA), 0);

			m_bScudAReady = false;
		}

		if ( !m_bScudBReady )
		{
			m_uScudB.CommandStop();
		}

		if ( m_bScudBReady && CountBuildingsUnitsInArea(markerScudTargetB) >= 16 )
		{
			m_uScudB.CommandAttackOnPoint(GetPointX(markerScudTargetB)+2, GetPointY(markerScudTargetB), 0);

			m_uCapturerB1.CommandMove(GetPointX(markerScudTargetB)-4, GetPointY(markerScudTargetB)+3, 0);
			m_uCapturerB2.CommandMove(GetPointX(markerScudTargetB)-4, GetPointY(markerScudTargetB)+2, 0);
			m_uCapturerB3.CommandMove(GetPointX(markerScudTargetB)-4, GetPointY(markerScudTargetB)+1, 0);
			m_uCapturerB4.CommandMove(GetPointX(markerScudTargetB)-4, GetPointY(markerScudTargetB)  , 0);
			m_uCapturerB5.CommandMove(GetPointX(markerScudTargetB)-4, GetPointY(markerScudTargetB)-1, 0);
			m_uCapturerB6.CommandMove(GetPointX(markerScudTargetB)-4, GetPointY(markerScudTargetB)-2, 0);

			m_bScudBReady = false;
		}
	}

	function int InitializeScuds()
	{
		m_nUnitsStayCounter = 0;
		m_bScudAReady = true;
		m_bScudBReady = true;

		m_uScudA = GetUnit(GetPointX(markerScudA), GetPointY(markerScudA));
		m_uCapturerA1 = GetUnit(GetPointX(markerCapturerAFirst+0), GetPointY(markerCapturerAFirst+0));
		m_uCapturerA2 = GetUnit(GetPointX(markerCapturerAFirst+1), GetPointY(markerCapturerAFirst+1));
		m_uCapturerA3 = GetUnit(GetPointX(markerCapturerAFirst+2), GetPointY(markerCapturerAFirst+2));
		m_uCapturerA4 = GetUnit(GetPointX(markerCapturerAFirst+3), GetPointY(markerCapturerAFirst+3));

		m_uScudB = GetUnit(GetPointX(markerScudB), GetPointY(markerScudB));
		m_uCapturerB1 = GetUnit(GetPointX(markerCapturerBFirst+0), GetPointY(markerCapturerBFirst+0));
		m_uCapturerB2 = GetUnit(GetPointX(markerCapturerBFirst+1), GetPointY(markerCapturerBFirst+1));
		m_uCapturerB3 = GetUnit(GetPointX(markerCapturerBFirst+2), GetPointY(markerCapturerBFirst+2));
		m_uCapturerB4 = GetUnit(GetPointX(markerCapturerBFirst+3), GetPointY(markerCapturerBFirst+3));
		m_uCapturerB5 = GetUnit(GetPointX(markerCapturerBFirst+4), GetPointY(markerCapturerBFirst+4));
		m_uCapturerB6 = GetUnit(GetPointX(markerCapturerBFirst+5), GetPointY(markerCapturerBFirst+5));
	}

	state Initialize;
	state Start;
	state BeforeStart;
	state MovedUnits;
	state DetonateBridge;
	state DetonatedBridge;
	state FindUnits;
	state FoundUnits;
	state EscortUnits;
	state EscortedUnits;
	state MissionComplete;

	function int ClearMarkers(int nStartPoint, int nEndPoint)
	{
		int i;

		for ( i=nStartPoint; i<=nEndPoint; i=i+1 )
		{
			ClearArea (65535, GetPointX(i), GetPointY(i), GetPointZ(i), 0);
		}
	}

	function int ModifyDifficulty()
	{
		if ( GetDifficultyLevel() == 0 )
		{
			ClearMarkers ( 8, 27); // Art
			ClearMarkers (71, 75); // ScudA
			ClearMarkers (80, 86); // ScudB

			ClearMarkers (28, 36);
			ClearMarkers (87, 189);
		}
		else if ( GetDifficultyLevel() == 1 )
		{
			ClearMarkers (32, 35);
			ClearMarkers (13, 14);
			ClearMarkers (markerCapturerAFirst, markerCapturerAFirst);
		}
		else if ( GetDifficultyLevel() == 2 )
		{
		}
	}

	state Initialize
	{
		ModifyDifficulty();

		if ( GetDifficultyLevel() > 0 )
		{
			InitializeArtGroup();
			InitializeScuds();
		}

		RegisterGoal(goalHeroSurvive, "translateGoalMissionUSA_HeroSurvive");
		RegisterGoal(goalFindConvoy, "translateGoalMissionUSA_8_FindConvoy");
		RegisterGoal(goalEscortConvoy, "translateGoalMissionUSA_8_EscortConvoy");

		m_pPlayer = GetPlayer(0);
		m_pPlayer.EnableStatistics(true);

		m_pFriendlyUnits = GetPlayer(2);
		m_pFriendlyUnits.EnableStatistics(false);

		m_pEnemy = GetPlayer(3);
		m_pEnemy.EnableStatistics(true);

		m_pEnemyUnits = GetPlayer(1);
		m_pEnemyUnits.EnableStatistics(false);

		m_pSpecialUnits = GetPlayer(4);
		m_pSpecialUnits.EnableStatistics(false);

		m_pSpecialUnits.EnableAI(false);
		m_pSpecialUnits.SpyPlayer(m_pPlayer, true, 1000000);
		m_pSpecialUnits.SetMoney(100000);

		EnableAllResearchIRQ( m_pSpecialUnits, true);
		AddAllResearchIRQ( m_pSpecialUnits );

		if ( GetDifficultyLevel() == 0 )
		{
			m_pEnemy.LoadScript("single\\singleMedium");

			m_nTimeOfEnableAI = 10*60*20;
		}
		else if ( GetDifficultyLevel() == 1 )
		{
			m_pEnemy.LoadScript("single\\singleHard");

			m_nTimeOfEnableAI = 8*60*20;
		}
		else if ( GetDifficultyLevel() == 2 )
		{
			m_pEnemy.LoadScript("single\\singleHard");

			m_nTimeOfEnableAI = 6*60*20;
		}

		m_pPlayer.RestoreUnitsAt(0, GetPointX(markerHero), GetPointY(markerHero), 0);

		m_uHero = GetUnit(GetPointX(markerHero), GetPointY(markerHero));
		m_uHero.RegenerateAmmo();

		m_uTruck1 = GetUnit(GetPointX(markerTruck1), GetPointY(markerTruck1));
		m_uTruck2 = GetUnit(GetPointX(markerTruck2), GetPointY(markerTruck2));
		m_uTruck3 = GetUnit(GetPointX(markerTruck3), GetPointY(markerTruck3));

		m_uJeep1 = GetUnit(GetPointX(markerJeep1), GetPointY(markerJeep1));
		m_uJeep2 = GetUnit(GetPointX(markerJeep2), GetPointY(markerJeep2));

		m_pPlayer.LookAt(m_pPlayer.GetStartingPointX(), m_pPlayer.GetStartingPointY(), 6, 0, 0, 0);

		m_pEnemy.EnableAI(true);
		m_pFriendlyUnits.EnableAIFeatures2(ai2ChooseEnemy, false);
		m_pEnemy.SetNeutral(m_pFriendlyUnits);
		m_pEnemy.SetEnemy(m_pPlayer);

		m_pFriendlyUnits.EnableAIFeatures(aiRejectAlliance, false);
		m_pFriendlyUnits.EnableAIFeatures2(ai2ChooseEnemy, false);
		m_pPlayer.SetAlly(m_pFriendlyUnits);
		m_pFriendlyUnits.EnableAI(false);

		m_pFriendlyUnits.SetEnemy(m_pEnemyUnits);

		m_pEnemyUnits.EnableAI(false);
		m_pEnemyUnits.SetEnemy(m_pFriendlyUnits);

		m_pPlayer.SetMoney(20000);

		m_pEnemy.SetMoney(20000);

		AddUnitTemplatesUSA(m_pPlayer);
		m_pPlayer.RemoveObjectTemplate(null, -1, "USA_TRANSPORTER", "USA_TRANSPORTER_Hook", null, null, null);

		EnableAllResearchUSA( m_pPlayer, false);
		m_pPlayer.EnableResearch("RES_USA_AMPHIBIA1", true);		// M1
		m_pPlayer.EnableResearch("RES_USA_AMMO_MG1", true);			// M1
		m_pPlayer.EnableResearch("RES_USA_SPY", true);				// M2
		m_pPlayer.EnableResearch("RES_USA_HELICOPTER1", true);		// M2
		m_pPlayer.EnableResearch("RES_USA_AMMO_MG2", true);			// M3
		m_pPlayer.EnableResearch("RES_USA_HELICOPTER2", true);		// M3
		m_pPlayer.EnableResearch("RES_USA_TANK1", true);			// M3
		m_pPlayer.EnableResearch("RES_USA_SAPER", true);			// M3
		m_pPlayer.EnableResearch("RES_USA_MORTAR", true);			// M4
		m_pPlayer.EnableResearch("RES_USA_AMMO_CANNON1", true);		// M4
		m_pPlayer.EnableResearch("RES_USA_MIM", true);				// M4
		m_pPlayer.EnableResearch("RES_USA_SPECIAL_FILTER2", true);	// M4
		m_pPlayer.EnableResearch("RES_USA_ART", true);				// M5
		m_pPlayer.EnableResearch("RES_USA_AMMO_GRENADE1", true);	// M5
		m_pPlayer.EnableResearch("RES_USA_COMANCHE", true);			// M5
		m_pPlayer.EnableResearch("RES_USA_AMMO_MIM1", true);		// M5
		m_pPlayer.EnableResearch("RES_USA_MGM", true);				// M5
		m_pPlayer.EnableResearch("RES_USA_SDI", true);				// M5
		m_pPlayer.EnableResearch("RES_USA_SPECIAL_FILTER3", true);	// M5
		m_pPlayer.EnableResearch("RES_USA_AMMO_GRENADE2", true);	// M6
		m_pPlayer.EnableResearch("RES_USA_AMMO_CANNON2", true);		// M6
		m_pPlayer.EnableResearch("RES_USA_SPECIAL_PTC", true);		// M6
		m_pPlayer.EnableResearch("RES_USA_SPECIAL_FLARE", true);	// M6
		m_pPlayer.EnableResearch("RES_USA_LECLERC", true);			// M7
		m_pPlayer.EnableResearch("RES_USA_AMMO_MGM1", true);		// M7
		m_pPlayer.EnableResearch("RES_USA_AIRCONTROL", true);
		m_pPlayer.EnableResearch("RES_USA_AMMO_MIM2", true);
		m_pPlayer.EnableResearch("RES_USA_JEEP_JAMMER", true);

		EnableAllResearchIRQ( m_pEnemy, false);
		m_pEnemy.EnableResearch("RES_IRQ_TANK1", true);				// M1
		m_pEnemy.EnableResearch("RES_IRQ_HELICOPTER1", true);		// M2
		m_pEnemy.EnableResearch("RES_IRQ_AMMO_MG1", true);			// M3
		m_pEnemy.EnableResearch("RES_IRQ_PILLBOX", true);			// M3
		m_pEnemy.EnableResearch("RES_IRQ_TANK2", true);				// M3
		m_pEnemy.EnableResearch("RES_IRQ_SAPER", true);				// M3
		m_pEnemy.EnableResearch("RES_IRQ_MIM", true);				// M3
		m_pEnemy.EnableResearch("RES_IRQ_RART", true);				// M4
		m_pEnemy.EnableResearch("RES_IRQ_HRART", true);				// M4
		m_pEnemy.EnableResearch("RES_IRQ_AMMO_MIM1", true);			// M4
		m_pEnemy.EnableResearch("RES_IRQ_SPECIAL_FILTER2", true);	// M4
		m_pEnemy.EnableResearch("RES_IRQ_AMMO_CANNON1", true);		// M5
		m_pEnemy.EnableResearch("RES_IRQ_BIGART", true);			// M5
		m_pEnemy.EnableResearch("RES_IRQ_AMMO_ROCKET1", true);		// M5
		m_pEnemy.EnableResearch("RES_IRQ_AMMO_HROCKET1", true);		// M5
		m_pEnemy.EnableResearch("RES_IRQ_MGM", true);				// M5
		m_pEnemy.EnableResearch("RES_IRQ_EXPLODER", true);			// M5
		m_pEnemy.EnableResearch("RES_IRQ_AMMO_CANNON2", true);		// M6
		m_pEnemy.EnableResearch("RES_IRQ_AMMO_ROCKET2", true);		// M6
		m_pEnemy.EnableResearch("RES_IRQ_AMMO_HROCKET2", true);		// M6
		m_pEnemy.EnableResearch("RES_IRQ_AMMO_MIM2", true);			// M6
		m_pEnemy.EnableResearch("RES_IRQ_JEEP_MGM", true);			// M6
		m_pEnemy.EnableResearch("RES_IRQ_SPECIAL_FILTER2", true);	// M6
		m_pEnemy.EnableResearch("RES_IRQ_AMMO_MGM1", true);			// M7
//		m_pEnemy.EnableResearch("RES_IRQ_EXPLODER_BIG", true);		// M7
//		m_pEnemy.EnableResearch("RES_IRQ_SCUD", true);
		m_pEnemy.EnableResearch("RES_IRQ_SPYFLIGHTCENTER", true);
		m_pEnemy.EnableResearch("RES_IRQ_AMMO_MGM2", true);
		m_pEnemy.EnableResearch("RES_IRQ_SDI", true);

		m_pEnemy.AddResearch("RES_IRQ_TANK1");
		m_pEnemy.AddResearch("RES_IRQ_HELICOPTER1");
		m_pEnemy.AddResearch("RES_IRQ_AMMO_MG1");
		m_pEnemy.AddResearch("RES_IRQ_PILLBOX");
		m_pEnemy.AddResearch("RES_IRQ_TANK2");
		m_pEnemy.AddResearch("RES_IRQ_SAPER");
		m_pEnemy.AddResearch("RES_IRQ_MIM");
		m_pEnemy.AddResearch("RES_IRQ_RART");
		m_pEnemy.AddResearch("RES_IRQ_HRART");
		m_pEnemy.AddResearch("RES_IRQ_AMMO_MIM1");
		m_pEnemy.AddResearch("RES_IRQ_SPECIAL_FILTER2");
		m_pEnemy.AddResearch("RES_IRQ_AMMO_CANNON1");
		m_pEnemy.AddResearch("RES_IRQ_BIGART");
		m_pEnemy.AddResearch("RES_IRQ_AMMO_ROCKET1");
		m_pEnemy.AddResearch("RES_IRQ_AMMO_HROCKET1");
		m_pEnemy.AddResearch("RES_IRQ_MGM");
		m_pEnemy.AddResearch("RES_IRQ_EXPLODER");
		m_pEnemy.AddResearch("RES_IRQ_AMMO_CANNON2");
		m_pEnemy.AddResearch("RES_IRQ_AMMO_ROCKET2");
		m_pEnemy.AddResearch("RES_IRQ_AMMO_HROCKET2");
		m_pEnemy.AddResearch("RES_IRQ_AMMO_MIM2");
		m_pEnemy.AddResearch("RES_IRQ_JEEP_MGM");
		m_pEnemy.AddResearch("RES_IRQ_SPECIAL_FILTER2");
		m_pEnemy.AddResearch("RES_IRQ_AMMO_MGM1");
//		m_pEnemy.AddResearch("RES_IRQ_EXPLODER_BIG");

		SetTimer(0, 100); // CheckDestroyedUnits
		SetTimer(1, 100);
		SetTimer(2, 20*20); // ArtControl
		SetTimer(3, 60); // ScudControl

		m_bMissionFail = false;

		return BeforeStart, 1;
	}

	state BeforeStart
	{
		PlayTrack("Music\\Briefing.tws");

		return Start;
	}

	event Timer1()
	{
		if ( GetMissionTime() >= m_nTimeOfEnableAI )
		{
			m_pEnemy.EnableAI(true);
		}
	}

	state Start
	{
		int nUnitsDestinationGx, nUnitsDestinationGy;

		EnableGoal(goalHeroSurvive, true);

		AddStrongUnitTemplatesIRQ( m_pEnemy );

		m_pSpecialUnits.EnableAIFeatures(aiRejectAlliance, false);
		m_pEnemy.SetAlly(m_pSpecialUnits);

		m_pEnemy.EnableAIFeatures2(ai2RebuildBaseOnly, true);
		m_pEnemy.EnableAI(false);

		nUnitsDestinationGx = m_pEnemyUnits.GetStartingPointX();
		nUnitsDestinationGy = m_pEnemyUnits.GetStartingPointY();

		m_uJeep1.CommandMove(nUnitsDestinationGx, nUnitsDestinationGy, 0);
		m_uJeep2.CommandMove(nUnitsDestinationGx, nUnitsDestinationGy, 0);

		m_uTruck1.CommandMove(nUnitsDestinationGx, nUnitsDestinationGy, 0);
		m_uTruck2.CommandMove(nUnitsDestinationGx, nUnitsDestinationGy, 0);
		m_uTruck3.CommandMove(nUnitsDestinationGx, nUnitsDestinationGy, 0);

		return MovedUnits, 40;
	}

	state MovedUnits
	{
		int nUnitsDestinationGx, nUnitsDestinationGy;

		nUnitsDestinationGx = m_pEnemyUnits.GetStartingPointX();
		nUnitsDestinationGy = m_pEnemyUnits.GetStartingPointY();

		m_pPlayer.DelayedLookAt(m_pEnemyUnits.GetStartingPointX(), m_pEnemyUnits.GetStartingPointY(), -1, -1, 0, 0, 40, 1);

		return DetonateBridge, 100;
	}

	state DetonateBridge
	{
		int nFromGx;
		int nFromGy;
		int nToGx;
		int nToGy;

		int nRange, nRange2;

		nFromGx = GetPointX(markerDetonateFrom);
		nFromGy = GetPointY(markerDetonateFrom);

		nToGx = GetPointX(markerDetonateTo);
		nToGy = GetPointY(markerDetonateTo);

		nRange = (nToGx-nFromGx)/2;
		nRange2 = (nToGy-nFromGy)/2;

		if ( nRange2 > nRange ) nRange = nRange2;

		KillArea(65535, (nFromGx+nToGx)/2, (nFromGy+nToGy)/2, 0, nRange);

		ShowArea(m_pPlayer.GetIFF(), (nFromGx+nToGx)/2, (nFromGy+nToGy)/2, 0, nRange*2, showAreaPassives|showAreaBuildings|showAreaUnits);
		m_pPlayer.DelayedLookAt((nFromGx+nToGx)/2, (nFromGy+nToGy)/2, 20, -1, 0, 0, 10, 1);

		return DetonatedBridge, 60;
	}

	state DetonatedBridge
	{
		EnableGoal(goalFindConvoy, true);

		AddBriefing("translateBriefingMissionUSA_8_FindConvoy");
		PlayWave("Briefings\\USA_Briefing08.wav");

		return FindUnits;
	}

	state FindUnits
	{
		int nGx, nGy;

		nGx = m_uHero.GetLocationX();
		nGy = m_uHero.GetLocationY();

		if	(
			Distance(m_uTruck1.GetLocationX(), m_uTruck1.GetLocationY(), nGx, nGy) <= 2 ||
			Distance(m_uTruck2.GetLocationX(), m_uTruck2.GetLocationY(), nGx, nGy) <= 2 ||
			Distance(m_uTruck3.GetLocationX(), m_uTruck3.GetLocationY(), nGx, nGy) <= 2
			)
		{
			return FoundUnits;
		}
		else
		{
			return FindUnits;
		}
	}

	state FoundUnits
	{
		m_pFriendlyUnits.GiveAllUnitsTo(m_pPlayer);

		SetGoalState(goalFindConvoy, goalAchieved);

		EnableGoal(goalEscortConvoy, true);
		AddBriefing("translateBriefingMissionUSA_8_EscortConvoy");

		return EscortUnits;
	}

	state EscortUnits
	{
		int nTrucksArrived;

		nTrucksArrived = 0;

		if ( Distance(m_uTruck1.GetLocationX(), m_uTruck1.GetLocationY(), m_pPlayer.GetStartingPointX(), m_pPlayer.GetStartingPointY()) <= 6 ) nTrucksArrived = nTrucksArrived + 1;
		if ( Distance(m_uTruck2.GetLocationX(), m_uTruck2.GetLocationY(), m_pPlayer.GetStartingPointX(), m_pPlayer.GetStartingPointY()) <= 6 ) nTrucksArrived = nTrucksArrived + 1;
		if ( Distance(m_uTruck3.GetLocationX(), m_uTruck3.GetLocationY(), m_pPlayer.GetStartingPointX(), m_pPlayer.GetStartingPointY()) <= 6 ) nTrucksArrived = nTrucksArrived + 1;

		if ( nTrucksArrived >= 1 )
		{
			return EscortedUnits;
		}
		else
		{
			return EscortUnits;
		}
	}

	state EscortedUnits
	{
		SetGoalState(goalEscortConvoy, goalAchieved);
		SetGoalState(goalHeroSurvive, goalAchieved);

		AddBriefing("translateBriefingMissionUSA_8_MissionComplete");

		EnableEndMissionButton(true, true);

		return MissionComplete;
	}

	state MissionComplete
	{
		return MissionComplete;
	}

	function int CheckDestroyedUnits()
	{
		if ( state == MissionComplete ) return;

		if ( !m_uTruck1.IsLive() && !m_uTruck2.IsLive() && !m_uTruck3.IsLive() )
		{
			if ( state == FindUnits )
			{
				SetGoalState(goalFindConvoy, goalFailed);
			}
			else
			{
				SetGoalState(goalEscortConvoy, goalFailed);
			}

			m_bMissionFail = true;

			AddBriefing("translateBriefingMissionUSA_8_MissionFail");

			EnableEndMissionButton(true, false);

			state MissionComplete;
		}
	}

	event Timer0()
	{
		if ( m_bCheckDestroyedUnits )
		{
			m_bCheckDestroyedUnits = false;

			CheckDestroyedUnits();
		}
	}

	event UnitDestroyed(unit uUnit)
	{
		if ( m_bMissionFail )
		{
			return;
		}

		m_bCheckNumberOfUnits = true;
		m_bCheckDestroyedUnits = true;

		if ( uUnit == m_uHero )
		{
			SetGoalState(goalHeroSurvive, goalFailed);

			m_bMissionFail = true;

			AddBriefing("translateBriefingMissionUSA_8_MissionFail");

			EnableEndMissionButton(true, false);

			state MissionComplete;
		}
	}

	event BuildingDestroyed(unit uBuilding)
	{
		m_bCheckNumberOfBuildings = true;
	}

	event EndMission()
	{
		m_pPlayer.SaveUnit(0, m_uHero);
	}

	event SetupInterface()
	{
	}
}
