mission "translateTutorialUSALesson1"
{
	consts
	{
		goalMoveToTarget = 0;
		goalDestroyTarget = 1;
		goalFindTanks = 2;
		goalFindHelicopters = 3;
		goalDestroyEnemy = 4;

		markerHelicopter1 = 0;
		markerHelicopter2 = 1;
		markerHelicopter3 = 2;

		// masza byc po koleji
		markerPoint1 = 3;
		markerPoint2 = 4;
		markerPoint3 = 5;

		constPoints = 3;

		markerTarget = 6;

		markerUnit = 7;
	}

	player m_pPlayer;
	player m_pEnemy;

	player m_pFriendlyTanks;
	player m_pFriendlyHelicopters;

	unitex m_uHelicopter1;
	unitex m_uHelicopter2;
	unitex m_uHelicopter3;

	unitex m_uTarget;
	unitex m_uUnit;

	int m_nMoveingToPoint;
	
	state Initialize;
	state Start;
	state MoveToTarget;
	state FoundTarget;
	state DestroyTarget;
	state DestroyedTarget;
	state FindTanks;
	state FoundTanks;
	state FindHelicopters;
	state FoundHelicopters;
	state DestroyEnemy;
	state DestroyedEnemy;
	state MissionComplete;
	
	state Initialize
	{
		RegisterGoal(goalMoveToTarget, "translateGoalTutorialUSAmis1_MoveToTarget");
		RegisterGoal(goalDestroyTarget, "translateGoalTutorialUSAmis1_DestroyTarget");
		RegisterGoal(goalFindTanks, "translateGoalTutorialUSAmis1_FindTanks");
		RegisterGoal(goalFindHelicopters, "translateGoalTutorialUSAmis1_FindHelicopters");
		RegisterGoal(goalDestroyEnemy, "translateGoalTutorialUSAmis1_DestroyEnemy");

		m_pPlayer = GetPlayer(0);
		m_pEnemy = GetPlayer(1);

		m_pFriendlyTanks = GetPlayer(2);
		m_pFriendlyHelicopters = GetPlayer(3);

		m_uHelicopter1 = GetUnit(GetPointX(markerHelicopter1), GetPointY(markerHelicopter1));
		m_uHelicopter2 = GetUnit(GetPointX(markerHelicopter2), GetPointY(markerHelicopter2));
		m_uHelicopter3 = GetUnit(GetPointX(markerHelicopter3), GetPointY(markerHelicopter3));

		m_uTarget = GetUnit(GetPointX(markerTarget), GetPointY(markerTarget));
		m_uUnit = GetUnit(GetPointX(markerUnit), GetPointY(markerUnit));

		SetTimer(0, 300); // Uzupelnianie amunicji helikopterow
		
		m_pFriendlyTanks.EnableAI(false);
		m_pFriendlyHelicopters.EnableAI(false);
		m_pFriendlyTanks.SetNeutral(m_pPlayer);
		m_pFriendlyHelicopters.SetNeutral(m_pPlayer);

		m_pPlayer.SetNeutral(m_pFriendlyTanks);
		m_pPlayer.SetNeutral(m_pFriendlyHelicopters);

		m_pEnemy.EnableAIFeatures(aiEnabled,false);
//		m_pEnemy.EnableAIFeatures(aiControlOffense,false);
//		m_pEnemy.EnableAIFeatures(aiControlResearches,false);

		LookAt(m_pPlayer.GetStartingPointX(), m_pPlayer.GetStartingPointY(), 6, 0, 60, 0, 0);
		
		m_pPlayer.EnableBuilding("USA_AIRPORT1", false);
		m_pPlayer.EnableBuilding("USA_AIRPORT2", false);
		m_pPlayer.EnableBuilding("USA_LANDINGZONE", false);
		m_pPlayer.EnableBuilding("USA_NEST", false);
		m_pPlayer.EnableBuilding("USA_TURRET", false);
		m_pPlayer.EnableBuilding("USA_PILLBOX", false);
		m_pPlayer.EnableBuilding("USA_GENERATOR", false);
		m_pPlayer.EnableBuilding("USA_SUPPLYCENTER", false);
		m_pPlayer.EnableBuilding("USA_SUPPLYCENTERBIG", false);
		m_pPlayer.EnableBuilding("USA_SHAFT", false);
		m_pPlayer.EnableBuilding("USA_JAMMER", false);
		m_pPlayer.EnableBuilding("USA_ROCKETCONTROL", false);
		m_pPlayer.EnableBuilding("USA_ROCKETCONTROL_V", false);
		m_pPlayer.EnableBuilding("USA_BOMBCONTROL", false);
		m_pPlayer.EnableBuilding("USA_BOMBCONTROL_V", false);
		m_pPlayer.EnableBuilding("USA_ATTACKCONTROL", false);
		m_pPlayer.EnableBuilding("USA_ATTACKCONTROL_V", false);
		m_pPlayer.EnableBuilding("USA_RADAR", false);
		m_pPlayer.EnableBuilding("USA_GATE", false);
		m_pPlayer.EnableBuilding("USA_PATRIOT", false);
		m_pPlayer.EnableBuilding("USA_PATRIOT_B", false);

//		AddConsoleTextDisplay(10,0,100,SS_CENTER);
		
		return Start;
	}

	function int SafeSetCameraRect(int nGx1, int nGy1, int nGx2, int nGy2)
	{
		int nGx1ok, nGx2ok, nGy1ok, nGy2ok;

		if ( nGx1 < nGx2 )
		{
			nGx1ok = nGx1;
			nGx2ok = nGx2;
		}
		else
		{
			nGx1ok = nGx2;
			nGx2ok = nGx1;
		}

		if ( nGy1 < nGy2 )
		{
			nGy1ok = nGy1;
			nGy2ok = nGy2;
		}
		else
		{
			nGy1ok = nGy2;
			nGy2ok = nGy1;
		}

		SetGameRect(nGx1ok-2, nGy1ok-2, nGx2ok+2, nGy2ok+2);
	}

	function int CreateArtefactOnPoint(int nPoint)
	{
		int nGx, nGy, nPrevGx, nPrevGy;

		nGx = GetPointX(markerPoint1 + nPoint);
		nGy = GetPointY(markerPoint1 + nPoint);

		if ( nPoint == 0 )
		{
			nPrevGx = GetPointX(markerUnit);
			nPrevGy = GetPointY(markerUnit);
		}
		else
		{
			nPrevGx = GetPointX(markerPoint1 + nPoint - 1);
			nPrevGy = GetPointY(markerPoint1 + nPoint - 1);
		}

		CreateArtefact("ARTIFACT_FLAG_USA", nGx, nGy, 0, 0);
		AddWorldMapSign(nGx, nGy, 0, 0, 60);

		SafeSetCameraRect(nPrevGx, nPrevGy, nGx, nGy);

//		SetConsoleText(0, "translateConsoleTutorialUSAmis1_FindArtefact", " ", nPoint+1);

		ShowArea(m_pPlayer.GetIFF(), nGx, nGy, 0, 3, showAreaPassives|showAreaBuildings|showAreaUnits);
	}

	state FoundTarget
	{
		int nGx, nGy;

		SetGoalState(goalMoveToTarget, goalAchieved);

		nGx = GetPointX(markerTarget);
		nGy = GetPointY(markerTarget);

		EnableGoal(goalDestroyTarget, true);
		AddBriefing("translateBriefingTutorialUSAmis1_DestroyTarget");

		SafeSetCameraRect(GetPointX(markerUnit), GetPointY(markerUnit), nGx, nGy);

		ShowArea(m_pPlayer.GetIFF(), nGx, nGy, 0, 3, showAreaPassives|showAreaBuildings|showAreaUnits);

		return DestroyTarget;
	}

	event Artefact(int nArtefactNum, player pPlayerOnArtefact)
	{
		m_nMoveingToPoint = m_nMoveingToPoint + 1;

		if ( m_nMoveingToPoint < constPoints )
		{
			CreateArtefactOnPoint(m_nMoveingToPoint);
		}
		else
		{
			state FoundTarget;
		}

		true; // kasujemy ten do ktorego dojechal.
	}

	state Start
	{
		EnableGoal(goalMoveToTarget, true);
		AddBriefing("translateBriefingTutorialUSAmis1_MoveToTarget");

		m_nMoveingToPoint = 0;

		CreateArtefactOnPoint(m_nMoveingToPoint);

		return MoveToTarget;
	}

	state MoveToTarget
	{
		return MoveToTarget;
	}

	state DestroyTarget
	{
		if ( m_uTarget.IsLive() )
		{
			return DestroyTarget;
		}
		else
		{
			return DestroyedTarget;
		}
	}

	state DestroyedTarget
	{
		SetGoalState(goalDestroyTarget, goalAchieved);

		EnableGoal(goalFindTanks, true);
		AddBriefing("translateBriefingTutorialUSAmis1_FindTanks");

		SetGameRect(0,0,0,0);

		return FindTanks;
	}

	state FindTanks
	{
		if ( m_pPlayer.IsPointLocated(m_pFriendlyTanks.GetStartingPointX(), m_pFriendlyTanks.GetStartingPointY()) )
		{
			return FoundTanks;
		}
		else
		{
			return FindTanks;
		}
	}

	state FoundTanks
	{
		int nGx, nGy;

		SetGoalState(goalFindTanks, goalAchieved);

		m_pFriendlyTanks.GiveAllUnitsTo(m_pPlayer);

		EnableGoal(goalFindHelicopters, true);
		AddBriefing("translateBriefingTutorialUSAmis1_FindHelicopters");

		nGx = m_pFriendlyTanks.GetStartingPointX();
		nGy = m_pFriendlyTanks.GetStartingPointY();

		CreateArtefact("ARTIFACT_AMMO", nGx, nGy, 0, 0);

		return FindHelicopters;
	}

	state FindHelicopters
	{
		if ( m_pPlayer.IsPointLocated(m_pFriendlyHelicopters.GetStartingPointX(), m_pFriendlyHelicopters.GetStartingPointY()) )
		{
			return FoundHelicopters;
		}
		else
		{
			return FindHelicopters;
		}
	}

	state FoundHelicopters
	{
		int nGx, nGy;

		SetGoalState(goalFindHelicopters, goalAchieved);

		m_pFriendlyHelicopters.GiveAllUnitsTo(m_pPlayer);

		EnableGoal(goalDestroyEnemy, true);
		AddBriefing("translateBriefingTutorialUSAmis1_DestroyEnemy");

		nGx = m_pFriendlyHelicopters.GetStartingPointX();
		nGy = m_pFriendlyHelicopters.GetStartingPointY();

		CreateArtefact("ARTIFACT_MAP0", nGx, nGy, 0, 0);

		return DestroyEnemy;
	}

	state DestroyEnemy
	{
		if ( m_pEnemy.GetNumberOfUnits() == 0 )
		{
			return DestroyedEnemy;
		}
		else
		{
			return DestroyEnemy;
		}
	}

	state DestroyedEnemy
	{
		SetGoalState(goalDestroyEnemy, goalAchieved);

		AddBriefing("translateBriefingTutorialUSAmis1_MissionComplete");

		EnableEndMissionButton(true, true);

		return MissionComplete;
	}

	state MissionComplete
	{
		return MissionComplete;
	}

	event Timer0()
	{
		m_uHelicopter1.RegenerateAmmo();
		m_uHelicopter2.RegenerateAmmo();
		m_uHelicopter3.RegenerateAmmo();
	}

	event SetupInterface()
	{
		EnableGameFeature
			(
			lockResearchDialog |
			lockConstructionDialog |
			lockUpgradeWeaponDialog |
			lockAllianceDialog |
			lockGiveMoneyDialog |
			lockGiveUnitsDialog |
//			lockShowToolbar |
//			lockToolbarMap |
//			lockToolbarPanel |
			lockToolbarNextWorld |
//			lockToolbarLevelName |
			lockToolbarTunnels |
			lockToolbarSwitchMode |
			lockToolbarResearching |
			lockToolbarConstruction |
			lockToolbarAlliance |
			lockToolbarGiveMoney |
//			lockToolbarObjectives |
//			lockToolbarMenu |
			lockToolbarMoney |
			lockToolbarEnergy |
//			lockDisplayToolbarLevelName |
			lockDisplayToolbarMoney |
			lockDisplayToolbarEnergy |
			lockCreateBuildPanel |
//			lockCreatePanel |
//			lockCreateMap |
			0, true);
	}
}
