mission "translateTutorialUSALesson2"
{
	consts
	{
		goalBuildPowerPlant = 0;
		goalBuildShafts = 1;
		goalBuildLandingZone = 2;
		goalBuildAirport = 3;
		goalBuildHelicopters = 4;
		goalFindMarkers = 5;
		goalSellShafts = 6;
		goalDestroyLandingZone = 7;
	}

	player m_pPlayer;
	
	state Initialize;
	state Start;

	state BuildPowerPlant;
	state BuildedPowerPlant;

	state BuildShafts;
	state BuildedShafts;

	state BuildLandingZone;
	state BuildedLandingZone;

	state BuildAirport;
	state BuildedAirport;

	state BuildHelicopters;
	state BuildedHelicopters;

	state FindMarkers;
	state FoundMarkers;

	state SellShafts;
	state SoldShafts;

	state DestroyLandingZone;
	state DestroyedLandingZone;

	state MissionComplete;
	
	state Initialize
	{
		RegisterGoal(goalBuildPowerPlant, "translateGoalTutorialUSAmis2_BuildPowerPlant");
		RegisterGoal(goalBuildShafts, "translateGoalTutorialUSAmis2_BuildShafts");
		RegisterGoal(goalBuildLandingZone, "translateGoalTutorialUSAmis2_BuildLandingZone");
		RegisterGoal(goalBuildAirport, "translateGoalTutorialUSAmis2_BuildAirport");
		RegisterGoal(goalBuildHelicopters, "translateGoalTutorialUSAmis2_BuildHelicopter");
		RegisterGoal(goalFindMarkers, "translateGoalTutorialUSAmis2_FindMarkers");
		RegisterGoal(goalSellShafts, "translateGoalTutorialUSAmis2_SellShafts");
		RegisterGoal(goalDestroyLandingZone, "translateGoalTutorialUSAmis2_LandingZone");

		m_pPlayer = GetPlayer(0);

		m_pPlayer.SetMoney(20000);

		LookAt(m_pPlayer.GetStartingPointX(), m_pPlayer.GetStartingPointY(), 6, 0, 60, 0, 0);

		m_pPlayer.EnableBuilding("USA_AIRPORT1", false);
		m_pPlayer.EnableBuilding("USA_AIRPORT2", false);
		m_pPlayer.EnableBuilding("USA_LANDINGZONE", false);
		m_pPlayer.EnableBuilding("USA_NEST", false);
		m_pPlayer.EnableBuilding("USA_TURRET", false);
		m_pPlayer.EnableBuilding("USA_PILLBOX", false);
		m_pPlayer.EnableBuilding("USA_GENERATOR", false);
		m_pPlayer.EnableBuilding("USA_SUPPLYCENTER", false);
		m_pPlayer.EnableBuilding("USA_SUPPLYCENTERBIG", false);
		m_pPlayer.EnableBuilding("USA_SHAFT", false);
		m_pPlayer.EnableBuilding("USA_JAMMER", false);
		m_pPlayer.EnableBuilding("USA_ROCKETCONTROL", false);
		m_pPlayer.EnableBuilding("USA_ROCKETCONTROL_V", false);
		m_pPlayer.EnableBuilding("USA_BOMBCONTROL", false);
		m_pPlayer.EnableBuilding("USA_BOMBCONTROL_V", false);
		m_pPlayer.EnableBuilding("USA_ATTACKCONTROL", false);
		m_pPlayer.EnableBuilding("USA_ATTACKCONTROL_V", false);
		m_pPlayer.EnableBuilding("USA_RADAR", false);
		m_pPlayer.EnableBuilding("USA_GATE", false);
		m_pPlayer.EnableBuilding("USA_PATRIOT", false);
		m_pPlayer.EnableBuilding("USA_PATRIOT_B", false);

		return Start;
	}

	state Start
	{
		EnableGoal(goalBuildPowerPlant, true);
		AddBriefing("translateBriefingTutorialUSAmis2_BuildPowerPlant");

		m_pPlayer.EnableBuilding("USA_GENERATOR", true);

		SelectBuildPanelTab(0);

		return BuildPowerPlant;
	}

	state BuildPowerPlant
	{
		if ( m_pPlayer.GetNumberOfBuildings(buildingPowerPlant) >= 3 )
		{
			return BuildedPowerPlant;
		}
		else
		{
			return BuildPowerPlant;
		}
	}

	state BuildedPowerPlant
	{
		SetGoalState(goalBuildPowerPlant, goalAchieved);

		EnableGoal(goalBuildShafts, true);
		AddBriefing("translateBriefingTutorialUSAmis2_BuildShafts");

		m_pPlayer.EnableBuilding("USA_SHAFT", true);

		SelectBuildPanelTab(0);

		return BuildShafts;
	}

	state BuildShafts
	{
		if ( m_pPlayer.GetNumberOfBuildings(buildingMine) >= 3 )
		{
			return BuildedShafts;
		}
		else
		{
			return BuildShafts;
		}
	}

	state BuildedShafts
	{
		SetGoalState(goalBuildShafts, goalAchieved);

		EnableGoal(goalBuildLandingZone, true);
		AddBriefing("translateBriefingTutorialUSAmis2_BuildLandingZone");

		m_pPlayer.EnableBuilding("USA_LANDINGZONE", true);

		SelectBuildPanelTab(0);

		return BuildLandingZone;
	}

	state BuildLandingZone
	{
		if ( m_pPlayer.GetNumberOfBuildings(buildingLandingZone) > 0 )
		{
			return BuildedLandingZone;
		}
		else
		{
			return BuildLandingZone;
		}
	}

	state BuildedLandingZone
	{
		SetGoalState(goalBuildLandingZone, goalAchieved);

		EnableGoal(goalBuildAirport, true);
		AddBriefing("translateBriefingTutorialUSAmis2_BuildAirport");

		m_pPlayer.EnableBuilding("USA_AIRPORT1", true);

		SelectBuildPanelTab(0);

		return BuildAirport;
	}

	state BuildAirport
	{
		if ( m_pPlayer.GetNumberOfBuildings(buildingAirport) > 0 )
		{
			return BuildedAirport;
		}
		else
		{
			return BuildAirport;
		}
	}

	state BuildedAirport
	{
		SetGoalState(goalBuildAirport, goalAchieved);

		EnableGoal(goalBuildHelicopters, true);
		AddBriefing("translateBriefingTutorialUSAmis2_BuildHelicopters");

		m_pPlayer.EnableBuilding("USA_NEST", true);
		m_pPlayer.EnableBuilding("USA_SUPPLYCENTER", true);

		m_pPlayer.AddResearch("RES_USA_SPY");
		m_pPlayer.AddObjectTemplate(null,null,-1,"USA_SPY",null,null,null,null);

		SelectBuildPanelTab(3);

		return BuildHelicopters;
	}

	state BuildHelicopters
	{
		if ( m_pPlayer.GetNumberOfUnits(unitAny|chassisHelicopter) >= 4 )
		{
			return BuildedHelicopters;
		}
		else
		{
			return BuildHelicopters;
		}
	}

	state BuildedHelicopters
	{
		SetGoalState(goalBuildHelicopters, goalAchieved);

		EnableGoal(goalFindMarkers, true);
		AddBriefing("translateBriefingTutorialUSAmis2_FindMarkers");

		CreateArtefact("ARTIFACT_FLAG_USA", GetPointX(0), GetPointY(0), 0, 0);
		CreateArtefact("ARTIFACT_FLAG_USA", GetPointX(1), GetPointY(1), 0, 0);
		CreateArtefact("ARTIFACT_FLAG_USA", GetPointX(2), GetPointY(2), 0, 0);

		return FindMarkers;
	}

	state FindMarkers
	{
		if ( m_pPlayer.IsPointLocated(GetPointX(0), GetPointY(0)) &&
			 m_pPlayer.IsPointLocated(GetPointX(1), GetPointY(1)) &&
			 m_pPlayer.IsPointLocated(GetPointX(2), GetPointY(2)) )
		{
			return FoundMarkers;
		}
		else
		{
			return FindMarkers;
		}
	}

	state FoundMarkers
	{
		SetGoalState(goalFindMarkers, goalAchieved);

		EnableGoal(goalSellShafts, true);
		AddBriefing("translateBriefingTutorialUSAmis2_SellShafts");

		return SellShafts;
	}

	state SellShafts
	{
		if ( m_pPlayer.GetNumberOfBuildings(buildingMine) > 0 )
		{
			return SellShafts;
		}
		else
		{
			return SoldShafts;
		}
	}

	state SoldShafts
	{
		SetGoalState(goalSellShafts, goalAchieved);

		EnableGoal(goalDestroyLandingZone, true);
		AddBriefing("translateBriefingTutorialUSAmis2_DestroyLandingZone");

		return DestroyLandingZone;
	}

	state DestroyLandingZone
	{
		if ( m_pPlayer.GetNumberOfBuildings(buildingLandingZone) > 0 )
		{
			return DestroyLandingZone;
		}
		else
		{
			return DestroyedLandingZone;
		}
	}

	state DestroyedLandingZone
	{
		SetGoalState(goalDestroyLandingZone, goalAchieved);

		AddBriefing("translateBriefingTutorialUSAmis2_MissionComplete");

		EnableEndMissionButton(true);

		return MissionComplete;
	}

	state MissionComplete
	{
		return MissionComplete;
	}

	event SetupInterface()
	{
		EnableGameFeature
			(
			lockResearchDialog |
			lockConstructionDialog |
			lockUpgradeWeaponDialog |
			lockAllianceDialog |
			lockGiveMoneyDialog |
			lockGiveUnitsDialog |
//			lockShowToolbar |
//			lockToolbarMap |
//			lockToolbarPanel |
			lockToolbarNextWorld |
//			lockToolbarLevelName |
			lockToolbarTunnels |
//			lockToolbarSwitchMode |
			lockToolbarResearching |
			lockToolbarConstruction |
			lockToolbarAlliance |
			lockToolbarGiveMoney |
//			lockToolbarObjectives |
//			lockToolbarMenu |
//			lockToolbarMoney |
			lockToolbarEnergy |
//			lockDisplayToolbarLevelName |
//			lockDisplayToolbarMoney |
			lockDisplayToolbarEnergy |
//			lockCreateBuildPanel |
//			lockCreatePanel |
//			lockCreateMap |
			0, true);
	}
}
