mission "translateTutorialUSALesson3"
{
	consts
	{
		goalBuildApaches = 0;
		goalBuildCobras = 1;
		goalBuildComanches = 2;
		goalBuildSupplyCenter = 3;
		goalDestroyHelicopters = 4;
		goalDestroyBuildings = 5;
		goalDestroyTanks = 6;
		goalDestroyEnemy = 7;

		markerTank1 = 3;
		markerTank2 = 8;
		markerTank3 = 9;

		markerHelicopter1 = 4;
		markerHelicopter2 = 5;
		markerHelicopter3 = 6;
		markerHelicopter4 = 7;

		markerMapLimiter = 10;

		markerHero = 11;

		markerTurretFirst = 12;
		markerTurretLast = 29;
	}

	player m_pPlayer;
	player m_pEnemyA;
	player m_pEnemyB;

	player m_pHero;

	unitex m_uHelicopter1;
	unitex m_uHelicopter2;
	unitex m_uHelicopter3;
	unitex m_uHelicopter4;

	unitex m_uTank1;
	unitex m_uTank2;
	unitex m_uTank3;

	unitex m_uHero;

	state Initialize;
	state Start;
	state BuildApaches;
	state BuildedApaches;
	state BuildCobras;
	state BuildedCobras;
	state BuildComanches;
	state BuildedComanches;
	state BuildSupplyCenter;
	state BuildedSupplyCenter;
	state DestroyHelicopters;
	state DestroyedHelicopters;
	state DestroyBuildings;
	state DestroyedBuildings;
	state DestroyTanks;
	state DestroyedTanks;
	state DestroyEnemy;
	state DestroyedEnemy;
	state MissionComplete;

	state Initialize
	{
		RegisterGoal(goalBuildApaches, "translateGoalTutorialUSAmis3_BuildApaches");
		RegisterGoal(goalBuildCobras, "translateGoalTutorialUSAmis3_BuildCobras");
		RegisterGoal(goalBuildComanches, "translateGoalTutorialUSAmis3_BuildComanches");
		RegisterGoal(goalBuildSupplyCenter, "translateGoalTutorialUSAmis3_SupplyCenter");
		RegisterGoal(goalDestroyHelicopters, "translateGoalTutorialUSAmis3_DestroyHelicopters");
		RegisterGoal(goalDestroyBuildings, "translateGoalTutorialUSAmis3_DestroyBuildings");
		RegisterGoal(goalDestroyTanks, "translateGoalTutorialUSAmis3_DestroyTanks");
		RegisterGoal(goalDestroyEnemy, "translateGoalTutorialUSAmis3_DestroyEnemy");

		m_pPlayer = GetPlayer(0);
		m_pEnemyA = GetPlayer(1);
		m_pEnemyB = GetPlayer(2);

		m_pHero = GetPlayer(3);

		m_uHelicopter1 = GetUnit(GetPointX(markerHelicopter1), GetPointY(markerHelicopter1));
		m_uHelicopter2 = GetUnit(GetPointX(markerHelicopter2), GetPointY(markerHelicopter2));
		m_uHelicopter3 = GetUnit(GetPointX(markerHelicopter3), GetPointY(markerHelicopter3));
		m_uHelicopter4 = GetUnit(GetPointX(markerHelicopter4), GetPointY(markerHelicopter4));

		m_uTank1 = GetUnit(GetPointX(markerTank1), GetPointY(markerTank1));
		m_uTank2 = GetUnit(GetPointX(markerTank2), GetPointY(markerTank2));
		m_uTank3 = GetUnit(GetPointX(markerTank3), GetPointY(markerTank3));

		m_uHero = GetUnit(GetPointX(markerHero), GetPointY(markerHero));

		SetTimer(0, 300); // Uzupelnianie amunicji

		m_pPlayer.AddResearch("RES_USA_HELICOPTER1");
		m_pPlayer.AddResearch("RES_USA_HELICOPTER2");
		m_pPlayer.AddResearch("RES_USA_COMANCHE");
		m_pPlayer.AddResearch("RES_USA_MGM");
		m_pPlayer.AddResearch("RES_USA_TANK1");

		m_pPlayer.SetMoney(20000);

		m_pEnemyA.EnableAIFeatures(aiEnabled,false);
		m_pEnemyB.EnableAIFeatures(aiEnabled,false);

		m_pHero.EnableAI(false);

		m_pHero.SetNeutral(m_pPlayer);
		m_pPlayer.SetNeutral(m_pHero);

		m_pPlayer.AddObjectTemplate(null,null,-1,"USA_SUPPLIER",null,null,null,null);

		LookAt(m_pPlayer.GetStartingPointX(), m_pPlayer.GetStartingPointY(), 6, 0, 60, 0, 0);

		SetGameRect(GetPointX(markerMapLimiter), GetPointY(markerMapLimiter), 1000, 1000); // TODO: powinno byc maxGx i maxGy

		return Start;
	}

	state Start
	{
		EnableGoal(goalBuildApaches, true);
		AddBriefing("translateBriefingTutorialUSAmis3_BuildApaches");

		m_pPlayer.AddObjectTemplate(null,null,-1,"USA_APACHE","USA_HELICOPTER_MGR1","USA_HELICOPTER_MGR2","USA_HELICOPTER_SPECIAL_FLARE",null,null,null,null,null);

		return BuildApaches;
	}

	state BuildApaches
	{
		if ( m_pPlayer.GetNumberOfUnits(unitArmed|chassisHelicopter) >= 5 ) // TODO: tylko Apache AGR AGR F
		{
			return BuildedApaches;
		}
		else
		{
			return BuildApaches;
		}
	}

	state BuildedApaches
	{
		SetGoalState(goalBuildApaches, goalAchieved);

		EnableGoal(goalBuildCobras, true);
		AddBriefing("translateBriefingTutorialUSAmis3_BuildCobras");

		m_pPlayer.AddObjectTemplate(null,null,-1,"USA_COBRA","USA_COBRA_GUN",null,null,null);

		return BuildCobras;
	}

	state BuildCobras
	{
		if ( m_pPlayer.GetNumberOfUnits(unitArmed|chassisHelicopter) >= 5+5 ) // TODO: tylko Cobra M60
		{
			return BuildedCobras;
		}
		else
		{
			return BuildCobras;
		}
	}

	state BuildedCobras
	{
		SetGoalState(goalBuildCobras, goalAchieved);

		EnableGoal(goalBuildComanches, true);
		AddBriefing("translateBriefingTutorialUSAmis3_BuildComanches");

		m_pPlayer.AddObjectTemplate(null,null,-1,"USA_COMANCHE","USA_HELICOPTER_MGM1",null,null,null,null,null,null,null);

		return BuildComanches;
	}

	state BuildComanches
	{
		if ( m_pPlayer.GetNumberOfUnits(unitArmed|chassisHelicopter) >= 5+5+3 ) // TODO: tylko Comanche AGM
		{
			return BuildedComanches;
		}
		else
		{
			return BuildComanches;
		}
	}

	state BuildedComanches
	{
		SetGoalState(goalBuildComanches, goalAchieved);

		EnableGoal(goalBuildSupplyCenter, true);
		AddBriefing("translateBriefingTutorialUSAmis3_BuildSupplyCenter");

		return BuildSupplyCenter;
	}

	state BuildSupplyCenter
	{
		if ( m_pPlayer.GetNumberOfBuildings(buildingSupplyCenter) > 0 )
		{
			return BuildedSupplyCenter;
		}
		else
		{
			return BuildSupplyCenter;
		}
	}

	state BuildedSupplyCenter
	{
		SetGoalState(goalBuildSupplyCenter, goalAchieved);

		EnableGoal(goalDestroyHelicopters, true);
		AddBriefing("translateBriefingTutorialUSAmis3_DestroyHelicopters");

		return DestroyHelicopters;
	}

	state DestroyHelicopters
	{
		if	(
			m_uHelicopter1.IsLive() ||
			m_uHelicopter2.IsLive() ||
			m_uHelicopter3.IsLive() ||
			m_uHelicopter4.IsLive()
			)
		{
			return DestroyHelicopters;
		}
		else
		{
			return DestroyedHelicopters;
		}
	}

	state DestroyedHelicopters
	{
		SetGoalState(goalDestroyHelicopters, goalAchieved);

		EnableGoal(goalDestroyBuildings, true);
		AddBriefing("translateBriefingTutorialUSAmis3_DestroyBuildings");

		SetGameRect(0,0,0,0);

		return DestroyBuildings;
	}

	state DestroyBuildings
	{
		if ( m_pEnemyA.GetNumberOfBuildings() == 0 )
		{
			return DestroyedBuildings;
		}
		else
		{
			return DestroyBuildings;
		}
	}

	state DestroyedBuildings
	{
		SetGoalState(goalDestroyBuildings, goalAchieved);

		EnableGoal(goalDestroyTanks, true);
		AddBriefing("translateBriefingTutorialUSAmis3_DestroyTanks");

		return DestroyTanks;
	}

	state DestroyTanks
	{
		if	(
			m_uTank1.IsLive() ||
			m_uTank2.IsLive() ||
			m_uTank3.IsLive()
			)
		{
			return DestroyTanks;
		}
		else
		{
			return DestroyedTanks;
		}
	}

	state DestroyedTanks
	{
		SetGoalState(goalDestroyTanks, goalAchieved);

		EnableGoal(goalDestroyEnemy, true);
		AddBriefing("translateBriefingTutorialUSAmis3_DestroyEnemy");

		m_pPlayer.AddObjectTemplate(null,null,0,"USA_BUILDER",null,null,null,null);

		m_uHero.ChangePlayer(m_pPlayer);

		return DestroyEnemy;
	}

	state DestroyEnemy
	{
		if	(
			m_pEnemyB.GetNumberOfUnits() == 0 &&
			m_pEnemyB.GetNumberOfBuildings() == 0
			)
		{
			return DestroyedEnemy;
		}
		else
		{
			return DestroyEnemy;
		}
	}

	state DestroyedEnemy
	{
		SetGoalState(goalDestroyEnemy, goalAchieved);

		AddBriefing("translateBriefingTutorialUSAmis3_MissionComplete");

		EnableEndMissionButton(true);

		return MissionComplete;
	}

	state MissionComplete
	{
		return MissionComplete;
	}

	event Timer0()
	{
		unitex uTurret;
		int marker;

		m_uTank1.RegenerateAmmo();
		m_uTank2.RegenerateAmmo();
		m_uTank3.RegenerateAmmo();

		for ( marker=markerTurretFirst; marker<=markerTurretLast; marker=marker+1 )
		{
			uTurret = GetUnit(GetPointX(marker), GetPointY(marker));
			uTurret.RegenerateAmmo();
		}
	}

	event UnitDestroyed(unit uUnit)
	{
		if ( uUnit.GetIFFNumber() != m_pPlayer.GetIFFNumber() ) return;

		if ( uUnit == m_uHero )
		{
			AddBriefing("translateBriefingTutorialUSAmis3_MissionFail");

			EnableEndMissionButton(true, false);

			state MissionComplete;
		}
	}

	event SetupInterface()
	{
		EnableGameFeature
			(
			lockResearchDialog |
			lockConstructionDialog |
			lockUpgradeWeaponDialog |
			lockAllianceDialog |
			lockGiveMoneyDialog |
			lockGiveUnitsDialog |
//			lockShowToolbar |
//			lockToolbarMap |
//			lockToolbarPanel |
			lockToolbarNextWorld |
//			lockToolbarLevelName |
			lockToolbarTunnels |
//			lockToolbarSwitchMode |
			lockToolbarResearching |
			lockToolbarConstruction |
			lockToolbarAlliance |
			lockToolbarGiveMoney |
//			lockToolbarObjectives |
//			lockToolbarMenu |
//			lockToolbarMoney |
			lockToolbarEnergy |
//			lockDisplayToolbarLevelName |
//			lockDisplayToolbarMoney |
			lockDisplayToolbarEnergy |
//			lockCreateBuildPanel |
//			lockCreatePanel |
//			lockCreateMap |
			0, true);
	}
}
