mission "translateTutorialUSALesson4"
{
	consts
	{
		goalFindArtefact = 0;
		goalBuildBridge = 1;
		goalCaptureBase = 2;
		goalTransportUnits = 3;

		markerDestinationLocation = 0;
		markerArtefact = 1;
		markerCapturer = 2;
		markerBuilder = 3;
		markerBridge = 4;
	}

	unitex m_uBuilder;
	unitex m_uCapturer;

	player m_pPlayer;
	player m_pEnemy;

	state Initialize;
	state Start;
	state FindArtefact;
	state FoundArtefact;
	state BuildBridge;
	state BuildedBridge;
	state CaptureBase;
	state CapturedBase;
	state TransportUnits;
	state TransportedUnits;
	state MissionComplete;

	state Initialize
	{
		RegisterGoal(goalFindArtefact, "translateGoalTutorialUSAmis4_FindArtefact");
		RegisterGoal(goalBuildBridge, "translateGoalTutorialUSAmis4_BuildBridge");
		RegisterGoal(goalCaptureBase, "translateGoalTutorialUSAmis4_CaptureBase");
		RegisterGoal(goalTransportUnits, "translateGoalTutorialUSAmis4_TransportUnits");

		m_uBuilder = GetUnit(GetPointX(markerBuilder), GetPointY(markerBuilder));
		m_uCapturer = GetUnit(GetPointX(markerCapturer), GetPointY(markerCapturer));

		m_pPlayer = GetPlayer(0);
		m_pEnemy = GetPlayer(1);

		m_pEnemy.EnableAI(false);

		m_pPlayer.SetMoney(2000);

		LookAt(m_pPlayer.GetStartingPointX(), m_pPlayer.GetStartingPointY(), 6, 0, 60, 0, 0);

		return Start;
	}

	state Start
	{
		EnableGoal(goalFindArtefact, true);
		AddBriefing("translateBriefingTutorialUSAmis4_FindArtefact");

		CreateArtefact("ARTIFACT_MAP0", GetPointX(markerArtefact), GetPointY(markerArtefact), 0, 0);

		return FindArtefact;
	}

	state FindArtefact
	{
		if ( m_pPlayer.IsPointLocated(GetPointX(markerArtefact), GetPointY(markerArtefact)) )
		{
			return FoundArtefact;
		}
		else
		{
			return FindArtefact;
		}
	}

	state FoundArtefact
	{
		SetGoalState(goalFindArtefact, goalAchieved);

		EnableGoal(goalBuildBridge, true);
		AddBriefing("translateBriefingTutorialUSAmis4_BuildBridge");

		return BuildBridge;
	}

	state BuildBridge
	{
		if ( m_uBuilder.GetLocationY() <= GetPointY(markerBridge) )
		{
			return BuildedBridge;
		}
		else
		{
			return BuildBridge;
		}
	}

	state BuildedBridge
	{
		SetGoalState(goalBuildBridge, goalAchieved);

		EnableGoal(goalCaptureBase, true);
		AddBriefing("translateBriefingTutorialUSAmis4_CaptureBase");

		return CaptureBase;
	}

	state CaptureBase
	{
		if ( m_pEnemy.GetNumberOfBuildings() == 0 )
		{
			return CapturedBase;
		}
		else
		{
			return CaptureBase;
		}
	}

	state CapturedBase
	{
		SetGoalState(goalCaptureBase, goalAchieved);

		EnableGoal(goalTransportUnits, true);
		AddBriefing("translateBriefingTutorialUSAmis4_TransportUnits");

		CreateArtefact("ARTIFACT_FLAG_USA", GetPointX(markerDestinationLocation), GetPointY(markerDestinationLocation), 0, 0);

		m_pPlayer.AddObjectTemplate(null,null,-1,"USA_TRANSPORTER","USA_TRANSPORTER_Hook",null,null,null);

		return TransportUnits;
	}

	state TransportUnits
	{
		if	(
			Distance(GetPointX(markerDestinationLocation), GetPointY(markerDestinationLocation), m_uBuilder.GetLocationX(), m_uBuilder.GetLocationY()) <= 8 &&
			Distance(GetPointX(markerDestinationLocation), GetPointY(markerDestinationLocation), m_uCapturer.GetLocationX(), m_uCapturer.GetLocationY()) <= 8
			)
		{
			return TransportedUnits;
		}
		else
		{
			return TransportUnits;
		}
	}

	state TransportedUnits
	{
		SetGoalState(goalTransportUnits, goalAchieved);

		AddBriefing("translateBriefingTutorialUSAmis4_MissionComplete");

		EnableEndMissionButton(true, true);

		return MissionComplete;
	}

	state MissionComplete
	{
		return MissionComplete;
	}

	event SetupInterface()
	{
		EnableGameFeature
			(
			lockResearchDialog |
			lockConstructionDialog |
			lockUpgradeWeaponDialog |
			lockAllianceDialog |
			lockGiveMoneyDialog |
			lockGiveUnitsDialog |
//			lockShowToolbar |
//			lockToolbarMap |
//			lockToolbarPanel |
			lockToolbarNextWorld |
//			lockToolbarLevelName |
			lockToolbarTunnels |
//			lockToolbarSwitchMode |
			lockToolbarResearching |
			lockToolbarConstruction |
			lockToolbarAlliance |
			lockToolbarGiveMoney |
//			lockToolbarObjectives |
//			lockToolbarMenu |
//			lockToolbarMoney |
			lockToolbarEnergy |
//			lockDisplayToolbarLevelName |
//			lockDisplayToolbarMoney |
			lockDisplayToolbarEnergy |
//			lockCreateBuildPanel |
//			lockCreatePanel |
//			lockCreateMap |
			0, true);
	}
}
