mission "translateMissionUSA_5"
{
	consts
	{
		goalHeroSurvive = 0;
		goalCaptureRafineries = 1;

		markerHero = 0;

		markerRafinery1 = 1;
		markerRafinery2 = 2;
		markerRafinery3 = 3;
	}

	include "UnitTemplates.ech"
	include "Research.ech"

	player m_pPlayer;

	player m_pEnemyA;
	player m_pEnemyB;
	player m_pEnemyC;

	player m_pRafineries;

	unitex m_uHero;

	unitex m_uRafinery1;
	unitex m_uRafinery2;
	unitex m_uRafinery3;

	int m_bCheckNumberOfUnits;
	int m_bCheckNumberOfBuildings;

	int m_bShowedCaptureRafinery2Briefing;

	int m_bMissionFail;

	state Initialize;
	state Start;
	state BeforeStart;
	state CaptureRafineries;
	state CapturedRafineries;
	state DestroyedRafineries;
	state MissionComplete;

	function int ClearMarkers(int nStartPoint, int nEndPoint)
	{
		int i;

		for ( i=nStartPoint; i<=nEndPoint; i=i+1 )
		{
			ClearArea (65535, GetPointX(i), GetPointY(i), GetPointZ(i), 0);
		}
	}

	function int ModifyDifficulty()
	{
		if ( GetDifficultyLevel() == 0 )
		{
			ClearMarkers (7, 9);
			ClearMarkers (11, 13);
			ClearArea	(65535, GetPointX(15), GetPointY(15), GetPointZ(15), 1);
			ClearArea	(65535, GetPointX(10), GetPointY(10), GetPointZ(10), 1);
			ClearArea	(65535, GetPointX(14), GetPointY(14), GetPointZ(14), 1);
			ClearMarkers (16, 17);
			ClearArea	(65535, GetPointX(18), GetPointY(18), GetPointZ(18), 1);
			ClearMarkers (19, 27);
			ClearArea	(65535, GetPointX(28), GetPointY(28), GetPointZ(28), 1);
			ClearArea	(65535, GetPointX(29), GetPointY(29), GetPointZ(29), 1);
			ClearMarkers (30, 31);
		}
		else if ( GetDifficultyLevel() == 1 )
		{
			ClearMarkers ( 5,  6);
			ClearMarkers (10, 11);
			ClearArea	(65535, GetPointX(15), GetPointY(15), GetPointZ(15), 1);
			ClearMarkers (14, 14);
			ClearMarkers (16, 16);
			ClearMarkers (19, 21);
			ClearMarkers (24, 24);
			ClearMarkers (26, 27);
			ClearArea	(65535, GetPointX(28), GetPointY(28), GetPointZ(28), 1);
			ClearMarkers (31, 31);
		}
		else if ( GetDifficultyLevel() == 2 )
		{
			ClearMarkers (5, 6);
			DamageArea	(65535, GetPointX( 7), GetPointY( 7), GetPointZ( 7), 1, 50);
			ClearMarkers (24, 25);
		}
	}

	state Initialize
	{
		ModifyDifficulty();

		RegisterGoal(goalHeroSurvive, "translateGoalMissionUSA_HeroSurvive");
		RegisterGoal(goalCaptureRafineries, "translateGoalMissionUSA_5_CaptureRafineries");

		m_pPlayer = GetPlayer(0);
		m_pPlayer.EnableStatistics(true);

		m_pEnemyA = GetPlayer(1);
		m_pEnemyA.EnableStatistics(true);

		m_pEnemyB = GetPlayer(2);
		m_pEnemyB.EnableStatistics(true);

		m_pEnemyC = GetPlayer(3);
		m_pEnemyC.EnableStatistics(true);

		m_pRafineries = GetPlayer(4);
		m_pRafineries.EnableStatistics(false);

		if ( GetDifficultyLevel() == 0 )
		{
			m_pEnemyA.LoadScript("single\\singleEasy");
			m_pEnemyB.LoadScript("single\\singleEasy");
			m_pEnemyC.LoadScript("single\\singleEasy");

			m_pEnemyA.EnableAIFeatures(aiBuildBuildings, false);
			m_pEnemyB.EnableAIFeatures(aiBuildBuildings, false);
			m_pEnemyC.EnableAIFeatures(aiBuildBuildings, false);
		}
		else if ( GetDifficultyLevel() == 1 )
		{
			m_pEnemyA.LoadScript("single\\singleMedium");
			m_pEnemyB.LoadScript("single\\singleMedium");
			m_pEnemyC.LoadScript("single\\singleMedium");

			m_pEnemyA.EnableAIFeatures2(ai2RebuildBaseOnly, true);
			m_pEnemyB.EnableAIFeatures2(ai2RebuildBaseOnly, true);
			m_pEnemyC.EnableAIFeatures2(ai2RebuildBaseOnly, true);
		}
		else if ( GetDifficultyLevel() == 2 )
		{
			m_pEnemyA.LoadScript("single\\singleHard");
			m_pEnemyB.LoadScript("single\\singleHard");
			m_pEnemyC.LoadScript("single\\singleHard");
		}

		m_pPlayer.RestoreUnitsAt(0, GetPointX(markerHero), GetPointY(markerHero), 0);

		m_uHero = GetUnit(GetPointX(markerHero), GetPointY(markerHero));
		m_uHero.RegenerateAmmo();

		m_uRafinery1 = GetUnit(GetPointX(markerRafinery1), GetPointY(markerRafinery1));
		m_uRafinery2 = GetUnit(GetPointX(markerRafinery2), GetPointY(markerRafinery2));
		m_uRafinery3 = GetUnit(GetPointX(markerRafinery3), GetPointY(markerRafinery3));

		m_pPlayer.LookAt(m_pPlayer.GetStartingPointX(), m_pPlayer.GetStartingPointY(), 6, 0, 0, 0);

		m_pEnemyA.EnableAI(true);
//		m_pEnemyA.EnableAIFeatures(aiEverything, true);
		m_pEnemyA.EnableAIFeatures(aiControlOffense, false);

		m_pEnemyB.EnableAI(true);
//		m_pEnemyB.EnableAIFeatures(aiEverything, true);
		m_pEnemyB.EnableAIFeatures(aiControlOffense, false);

		m_pEnemyC.EnableAI(true);
//		m_pEnemyC.EnableAIFeatures(aiEverything, true);
		m_pEnemyC.EnableAIFeatures(aiControlOffense, false);

		m_pRafineries.EnableAI(false);
		m_pPlayer.SetNeutral(m_pRafineries);

		m_pPlayer.SetMoney(2000);

		if ( GetDifficultyLevel() == 0 )
		{
			m_pPlayer.AddMoney(1000);
		}

		m_pEnemyA.SetMoney(2000);
		m_pEnemyB.SetMoney(2000);
		m_pEnemyC.SetMoney(2000);

		AddUnitTemplatesUSA(m_pPlayer);
		m_pPlayer.RemoveObjectTemplate(null, -1, "USA_TRANSPORTER", "USA_TRANSPORTER_Hook", null, null, null);

		EnableAllResearchUSA( m_pPlayer, false);
		m_pPlayer.EnableResearch("RES_USA_AMPHIBIA1", true);		// M1
		m_pPlayer.EnableResearch("RES_USA_AMMO_MG1", true);			// M1
		m_pPlayer.EnableResearch("RES_USA_SPY", true);				// M2
		m_pPlayer.EnableResearch("RES_USA_HELICOPTER1", true);		// M2
		m_pPlayer.EnableResearch("RES_USA_AMMO_MG2", true);			// M3
		m_pPlayer.EnableResearch("RES_USA_HELICOPTER2", true);		// M3
		m_pPlayer.EnableResearch("RES_USA_TANK1", true);			// M3
		m_pPlayer.EnableResearch("RES_USA_SAPER", true);			// M3
		m_pPlayer.EnableResearch("RES_USA_MORTAR", true);			// M4
		m_pPlayer.EnableResearch("RES_USA_AMMO_CANNON1", true);		// M4
		m_pPlayer.EnableResearch("RES_USA_MIM", true);				// M4
		m_pPlayer.EnableResearch("RES_USA_SPECIAL_FILTER2", true);	// M4
		m_pPlayer.EnableResearch("RES_USA_ART", true);
		m_pPlayer.EnableResearch("RES_USA_AMMO_GRENADE1", true);
		m_pPlayer.EnableResearch("RES_USA_COMANCHE", true);
		m_pPlayer.EnableResearch("RES_USA_AMMO_MIM1", true);
		m_pPlayer.EnableResearch("RES_USA_MGM", true);
		m_pPlayer.EnableResearch("RES_USA_SDI", true);
		m_pPlayer.EnableResearch("RES_USA_SPECIAL_FILTER3", true);

		EnableAllResearchIRQ( m_pEnemyA, false);
		m_pEnemyA.EnableResearch("RES_IRQ_TANK1", true);			// M1
		m_pEnemyA.EnableResearch("RES_IRQ_HELICOPTER1", true);		// M2
		m_pEnemyA.EnableResearch("RES_IRQ_AMMO_MG1", true);			// M3
		m_pEnemyA.EnableResearch("RES_IRQ_PILLBOX", true);			// M3
		m_pEnemyA.EnableResearch("RES_IRQ_TANK2", true);			// M3
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyA.EnableResearch("RES_IRQ_SAPER", true);		// M3
		}
		m_pEnemyA.EnableResearch("RES_IRQ_MIM", true);				// M3
		m_pEnemyA.EnableResearch("RES_IRQ_RART", true);				// M4
		m_pEnemyA.EnableResearch("RES_IRQ_HRART", true);			// M4
		m_pEnemyA.EnableResearch("RES_IRQ_AMMO_MIM1", true);		// M4
		m_pEnemyA.EnableResearch("RES_IRQ_SPECIAL_FILTER2", true);	// M4
		m_pEnemyA.EnableResearch("RES_IRQ_AMMO_CANNON1", true);
		m_pEnemyA.EnableResearch("RES_IRQ_BIGART", true);
		m_pEnemyA.EnableResearch("RES_IRQ_AMMO_ROCKET1", true);
		m_pEnemyA.EnableResearch("RES_IRQ_AMMO_HROCKET1", true);
		m_pEnemyA.EnableResearch("RES_IRQ_MGM", true);
		m_pEnemyA.EnableResearch("RES_IRQ_EXPLODER", true);

		EnableAllResearchIRQ( m_pEnemyB, false);
		m_pEnemyB.EnableResearch("RES_IRQ_TANK1", true);			// M1
		m_pEnemyB.EnableResearch("RES_IRQ_HELICOPTER1", true);		// M2
		m_pEnemyB.EnableResearch("RES_IRQ_AMMO_MG1", true);			// M3
		m_pEnemyB.EnableResearch("RES_IRQ_PILLBOX", true);			// M3
		m_pEnemyB.EnableResearch("RES_IRQ_TANK2", true);			// M3
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyB.EnableResearch("RES_IRQ_SAPER", true);		// M3
		}
		m_pEnemyB.EnableResearch("RES_IRQ_MIM", true);				// M3
		m_pEnemyB.EnableResearch("RES_IRQ_RART", true);				// M4
		m_pEnemyB.EnableResearch("RES_IRQ_HRART", true);			// M4
		m_pEnemyB.EnableResearch("RES_IRQ_AMMO_MIM1", true);		// M4
		m_pEnemyB.EnableResearch("RES_IRQ_SPECIAL_FILTER2", true);	// M4
		m_pEnemyB.EnableResearch("RES_IRQ_AMMO_CANNON1", true);
		m_pEnemyB.EnableResearch("RES_IRQ_BIGART", true);
		m_pEnemyB.EnableResearch("RES_IRQ_AMMO_ROCKET1", true);
		m_pEnemyB.EnableResearch("RES_IRQ_AMMO_HROCKET1", true);
		m_pEnemyB.EnableResearch("RES_IRQ_MGM", true);
		m_pEnemyB.EnableResearch("RES_IRQ_EXPLODER", true);

		EnableAllResearchIRQ( m_pEnemyC, false);
		m_pEnemyC.EnableResearch("RES_IRQ_TANK1", true);			// M1
		m_pEnemyC.EnableResearch("RES_IRQ_HELICOPTER1", true);		// M2
		m_pEnemyC.EnableResearch("RES_IRQ_AMMO_MG1", true);			// M3
		m_pEnemyC.EnableResearch("RES_IRQ_PILLBOX", true);			// M3
		m_pEnemyC.EnableResearch("RES_IRQ_TANK2", true);			// M3
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyC.EnableResearch("RES_IRQ_SAPER", true);		// M3
		}
		m_pEnemyC.EnableResearch("RES_IRQ_MIM", true);				// M3
		m_pEnemyC.EnableResearch("RES_IRQ_RART", true);				// M4
		m_pEnemyC.EnableResearch("RES_IRQ_HRART", true);			// M4
		m_pEnemyC.EnableResearch("RES_IRQ_AMMO_MIM1", true);		// M4
		m_pEnemyC.EnableResearch("RES_IRQ_SPECIAL_FILTER2", true);	// M4
		m_pEnemyC.EnableResearch("RES_IRQ_AMMO_CANNON1", true);
		m_pEnemyC.EnableResearch("RES_IRQ_BIGART", true);
		m_pEnemyC.EnableResearch("RES_IRQ_AMMO_ROCKET1", true);
		m_pEnemyC.EnableResearch("RES_IRQ_AMMO_HROCKET1", true);
		m_pEnemyC.EnableResearch("RES_IRQ_MGM", true);
		m_pEnemyC.EnableResearch("RES_IRQ_EXPLODER", true);

		m_pEnemyA.AddResearch("RES_IRQ_TANK1");
		m_pEnemyA.AddResearch("RES_IRQ_HELICOPTER1");
		m_pEnemyA.AddResearch("RES_IRQ_AMMO_MG1");
		m_pEnemyA.AddResearch("RES_IRQ_PILLBOX");
		m_pEnemyA.AddResearch("RES_IRQ_TANK2");
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyA.AddResearch("RES_IRQ_SAPER");
		}
		m_pEnemyA.AddResearch("RES_IRQ_MIM");
		m_pEnemyA.AddResearch("RES_IRQ_RART");
		m_pEnemyA.AddResearch("RES_IRQ_HRART");
		m_pEnemyA.AddResearch("RES_IRQ_AMMO_MIM1");
		m_pEnemyA.AddResearch("RES_IRQ_SPECIAL_FILTER2");

		m_pEnemyB.AddResearch("RES_IRQ_TANK1");
		m_pEnemyB.AddResearch("RES_IRQ_HELICOPTER1");
		m_pEnemyB.AddResearch("RES_IRQ_AMMO_MG1");
		m_pEnemyB.AddResearch("RES_IRQ_PILLBOX");
		m_pEnemyB.AddResearch("RES_IRQ_TANK2");
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyB.AddResearch("RES_IRQ_SAPER");
		}
		m_pEnemyB.AddResearch("RES_IRQ_MIM");
		m_pEnemyB.AddResearch("RES_IRQ_RART");
		m_pEnemyB.AddResearch("RES_IRQ_HRART");
		m_pEnemyB.AddResearch("RES_IRQ_AMMO_MIM1");
		m_pEnemyB.AddResearch("RES_IRQ_SPECIAL_FILTER2");

		m_pEnemyC.AddResearch("RES_IRQ_TANK1");
		m_pEnemyC.AddResearch("RES_IRQ_HELICOPTER1");
		m_pEnemyC.AddResearch("RES_IRQ_AMMO_MG1");
		m_pEnemyC.AddResearch("RES_IRQ_PILLBOX");
		m_pEnemyC.AddResearch("RES_IRQ_TANK2");
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyC.AddResearch("RES_IRQ_SAPER");
		}
		m_pEnemyC.AddResearch("RES_IRQ_MIM");
		m_pEnemyC.AddResearch("RES_IRQ_RART");
		m_pEnemyC.AddResearch("RES_IRQ_HRART");
		m_pEnemyC.AddResearch("RES_IRQ_AMMO_MIM1");
		m_pEnemyC.AddResearch("RES_IRQ_SPECIAL_FILTER2");

		AddUnitTemplatesIRQ( m_pEnemyA );
		AddUnitTemplatesIRQ( m_pEnemyB );
		AddUnitTemplatesIRQ( m_pEnemyC );

		m_bMissionFail = false;

		return BeforeStart, 1;
	}

	state BeforeStart
	{
		PlayTrack("Music\\Briefing.tws");

		return Start;
	}

	state Start
	{
		EnableGoal(goalHeroSurvive, true);
		EnableGoal(goalCaptureRafineries, true);

		AddBriefing("translateBriefingMissionUSA_5_CaptureRafineries");
		PlayWave("Briefings\\USA_Briefing05.wav");

		m_bShowedCaptureRafinery2Briefing = false;

		return CaptureRafineries;
	}

	state CaptureRafineries
	{
		int nRafineriesCaptured;

		if ( !m_uRafinery1.IsLive() || !m_uRafinery2.IsLive() || !m_uRafinery3.IsLive() )
		{
			return DestroyedRafineries;
		}

		nRafineriesCaptured = 0;

		if ( m_uRafinery1.GetIFF() == m_pPlayer.GetIFF() ) ++nRafineriesCaptured;
		if ( m_uRafinery2.GetIFF() == m_pPlayer.GetIFF() ) ++nRafineriesCaptured;
		if ( m_uRafinery3.GetIFF() == m_pPlayer.GetIFF() ) ++nRafineriesCaptured;

		if ( nRafineriesCaptured >= 2 )
		{
			return CapturedRafineries;
		}
		else if ( nRafineriesCaptured == 1 && !m_bShowedCaptureRafinery2Briefing )
		{
			AddBriefing("translateBriefingMissionUSA_5_CaptureRafinery2");

			m_bShowedCaptureRafinery2Briefing = true;
		}

		return CaptureRafineries;
	}

	state CapturedRafineries
	{
		SetGoalState(goalCaptureRafineries, goalAchieved);
		SetGoalState(goalHeroSurvive, goalAchieved);

		AddBriefing("translateBriefingMissionUSA_5_MissionComplete");

		EndMission(true);

		return MissionComplete;
	}

	state DestroyedRafineries
	{
		SetGoalState(goalCaptureRafineries, goalFailed);

		m_bMissionFail = true;

		AddBriefing("translateBriefingMissionUSA_5_MissionFail");

		EnableEndMissionButton(true, false);

		return MissionComplete;
	}

	state MissionComplete
	{
		return MissionComplete;
	}

	event UnitDestroyed(unit uUnit)
	{
		if ( m_bMissionFail )
		{
			return;
		}

		m_bCheckNumberOfUnits = true;

		if ( uUnit == m_uHero )
		{
			SetGoalState(goalHeroSurvive, goalFailed);

			m_bMissionFail = true;

			AddBriefing("translateBriefingMissionUSA_5_MissionFail");

			EnableEndMissionButton(true, false);

			state MissionComplete;
		}
	}

	event BuildingDestroyed(unit uBuilding)
	{
		m_bCheckNumberOfBuildings = true;

		if ( GetDifficultyLevel() == 0 )
		{
			if ( uBuilding == m_uRafinery1 )
			{
				m_uRafinery1.RegenerateHP();
			}
			else if ( uBuilding == m_uRafinery2 )
			{
				m_uRafinery2.RegenerateHP();
			}
			else if ( uBuilding == m_uRafinery3 )
			{
				m_uRafinery3.RegenerateHP();
			}
		}
	}

	event SetupInterface()
	{
	}
}
