mission "translateMissionUSA_6"
{
	consts
	{
		goalHeroSurvive = 0;
		goalFindHummer = 1;
		goalFindFriendlyUnits = 2;
		goalDestroyEnemy = 3;

		markerBoat = 0;
		markerBoatDestination = 2;
		markerHummer = 3;
		markerHelicopter = 6;
	}

	include "UnitTemplates.ech"
	include "Research.ech"

	player m_pPlayer;
	player m_pEnemy;
	player m_pFriendlyUnits;

	unitex m_uBoat;
	unitex m_uHummer;
	unitex m_uHelicopter;

	int m_bCheckBoat;
	int m_bCheckHummer;
	int m_bCheckHelicopter;

	int m_bCheckNumberOfUnits;
	int m_bCheckNumberOfBuildings;

	int m_bCheckDestroyedUnits;

	state Initialize;
	state Start;
	state BeforeStart;
	state FindHummer;
	state FoundHummer;
	state WaitForBoatMove;
	state BoatMoved;
	state FindFriendlyUnits;
	state FoundFriendlyUnits;
	state DestroyEnemy;
	state DestroyedEnemy;
	state MissionComplete;

	function int ClearMarkers(int nStartPoint, int nEndPoint)
	{
		int i;

		for ( i=nStartPoint; i<=nEndPoint; i=i+1 )
		{
			ClearArea (65535, GetPointX(i), GetPointY(i), GetPointZ(i), 0);
		}
	}

	function int ModifyDifficulty()
	{
		if ( GetDifficultyLevel() == 0 )
		{
			ClearMarkers (12, 15);
			ClearMarkers (17, 18);
			ClearArea	(65535, GetPointX( 9), GetPointY( 9), GetPointZ( 9), 1);
		}
		else if ( GetDifficultyLevel() == 1 )
		{
			ClearArea	(65535, GetPointX( 7), GetPointY( 7), GetPointZ( 7), 0);
			ClearMarkers (8, 11);
			ClearMarkers (13, 14);
			ClearMarkers (17, 18);
		}
		else if ( GetDifficultyLevel() == 2 )
		{
			ClearArea	(65535, GetPointX( 7), GetPointY( 7), GetPointZ( 7), 1);
		}
	}

	state Initialize
	{
		ModifyDifficulty();

		RegisterGoal(goalHeroSurvive, "translateGoalMissionUSA_HeroSurvive");
		RegisterGoal(goalFindHummer, "translateGoalMissionUSA_6_FindHummer");
		RegisterGoal(goalFindFriendlyUnits, "translateGoalMissionUSA_6_FindFriendlyUnits");
		RegisterGoal(goalDestroyEnemy, "translateGoalMissionUSA_6_DestroyEnemy");

		m_pPlayer = GetPlayer(0);
		m_pPlayer.EnableStatistics(true);

		m_pEnemy = GetPlayer(3);
		m_pEnemy.EnableStatistics(true);

		m_pFriendlyUnits = GetPlayer(2);
		m_pFriendlyUnits.EnableStatistics(false);

//		if ( GetDifficultyLevel() == 0 )
//		{
//			m_pEnemy.LoadScript("single\\singleEasy");
//		}
//		else if ( GetDifficultyLevel() == 1 )
//		{
//			m_pEnemy.LoadScript("single\\singleMedium");
//		}
//		else if ( GetDifficultyLevel() == 2 )
//		{
			m_pEnemy.LoadScript("single\\singleHard");
//		}

		m_uBoat = GetUnit(GetPointX(markerBoat), GetPointY(markerBoat));
		m_uHummer = GetUnit(GetPointX(markerHummer), GetPointY(markerHummer));
		m_uHummer.SetUnitName("translateUSAHeroName_Empty");
		m_uHelicopter = GetUnit(GetPointX(markerHelicopter), GetPointY(markerHelicopter));
		m_uHelicopter.SetUnitName("translateUSAHeroName_Empty");

		m_pPlayer.LookAt(GetPointX(markerBoat), GetPointY(markerBoat), 6, 0, 0, 0);

		m_pEnemy.EnableAI(false);
//		m_pEnemy.EnableAIFeatures(aiEverything, true);

		m_pFriendlyUnits.EnableAI(false);

		m_pPlayer.SetMoney(2000);
		m_pEnemy.SetMoney(2000);

		AddUnitTemplatesUSA(m_pPlayer);

		EnableAllResearchUSA( m_pPlayer, false);
		m_pPlayer.EnableResearch("RES_USA_AMPHIBIA1", true);		// M1
		m_pPlayer.EnableResearch("RES_USA_AMMO_MG1", true);			// M1
		m_pPlayer.EnableResearch("RES_USA_SPY", true);				// M2
		m_pPlayer.EnableResearch("RES_USA_HELICOPTER1", true);		// M2
		m_pPlayer.EnableResearch("RES_USA_AMMO_MG2", true);			// M3
		m_pPlayer.EnableResearch("RES_USA_HELICOPTER2", true);		// M3
		m_pPlayer.EnableResearch("RES_USA_TANK1", true);			// M3
		m_pPlayer.EnableResearch("RES_USA_SAPER", true);			// M3
		m_pPlayer.EnableResearch("RES_USA_MORTAR", true);			// M4
//		m_pPlayer.EnableResearch("RES_USA_AMMO_CANNON1", true);		// M4-
		m_pPlayer.EnableResearch("RES_USA_MIM", true);				// M4
		m_pPlayer.EnableResearch("RES_USA_SPECIAL_FILTER2", true);	// M4
//		m_pPlayer.EnableResearch("RES_USA_ART", true);				// M5-
//		m_pPlayer.EnableResearch("RES_USA_AMMO_GRENADE1", true);	// M5-
//		m_pPlayer.EnableResearch("RES_USA_COMANCHE", true);			// M5-
//		m_pPlayer.EnableResearch("RES_USA_AMMO_MIM1", true);		// M5-
		m_pPlayer.EnableResearch("RES_USA_MGM", true);				// M5
//		m_pPlayer.EnableResearch("RES_USA_SDI", true);				// M5-
		m_pPlayer.EnableResearch("RES_USA_SPECIAL_FILTER3", true);	// M5
//		m_pPlayer.EnableResearch("RES_USA_AMMO_GRENADE2", true);
//		m_pPlayer.EnableResearch("RES_USA_AMMO_CANNON2", true);
//		m_pPlayer.EnableResearch("RES_USA_SPECIAL_PTC", true);
//		m_pPlayer.EnableResearch("RES_USA_SPECIAL_FLARE", true);


		m_pPlayer.AddResearch("RES_USA_AMPHIBIA1");
		m_pPlayer.AddResearch("RES_USA_AMMO_MG1");
		m_pPlayer.AddResearch("RES_USA_SPY");
		m_pPlayer.AddResearch("RES_USA_HELICOPTER1");
		m_pPlayer.AddResearch("RES_USA_AMMO_MG2");
		m_pPlayer.AddResearch("RES_USA_SAPER");
		m_pPlayer.AddResearch("RES_USA_MORTAR");
		m_pPlayer.AddResearch("RES_USA_SPECIAL_FILTER2");
		m_pPlayer.AddResearch("RES_USA_SPECIAL_FILTER3");

		EnableAllResearchIRQ( m_pEnemy, false);
		m_pEnemy.EnableResearch("RES_IRQ_TANK1", true);				// M1
		m_pEnemy.EnableResearch("RES_IRQ_HELICOPTER1", true);		// M2
		m_pEnemy.EnableResearch("RES_IRQ_AMMO_MG1", true);			// M3
		m_pEnemy.EnableResearch("RES_IRQ_PILLBOX", true);			// M3
		m_pEnemy.EnableResearch("RES_IRQ_TANK2", true);				// M3
		m_pEnemy.EnableResearch("RES_IRQ_SAPER", true);				// M3
		m_pEnemy.EnableResearch("RES_IRQ_MIM", true);				// M3
		m_pEnemy.EnableResearch("RES_IRQ_RART", true);				// M4
		m_pEnemy.EnableResearch("RES_IRQ_HRART", true);				// M4
		m_pEnemy.EnableResearch("RES_IRQ_AMMO_MIM1", true);			// M4
		m_pEnemy.EnableResearch("RES_IRQ_SPECIAL_FILTER2", true);	// M4
		m_pEnemy.EnableResearch("RES_IRQ_AMMO_CANNON1", true);		// M5
		m_pEnemy.EnableResearch("RES_IRQ_BIGART", true);			// M5
		m_pEnemy.EnableResearch("RES_IRQ_AMMO_ROCKET1", true);		// M5
		m_pEnemy.EnableResearch("RES_IRQ_AMMO_HROCKET1", true);		// M5
		m_pEnemy.EnableResearch("RES_IRQ_MGM", true);				// M5
		m_pEnemy.EnableResearch("RES_IRQ_EXPLODER", true);			// M5
		m_pEnemy.EnableResearch("RES_IRQ_AMMO_CANNON2", true);
		m_pEnemy.EnableResearch("RES_IRQ_AMMO_ROCKET2", true);
		m_pEnemy.EnableResearch("RES_IRQ_AMMO_HROCKET2", true);
		m_pEnemy.EnableResearch("RES_IRQ_AMMO_MIM2", true);
		m_pEnemy.EnableResearch("RES_IRQ_JEEP_MGM", true);
		m_pEnemy.EnableResearch("RES_IRQ_SPECIAL_FILTER2", true);

		m_pEnemy.AddResearch("RES_IRQ_TANK1");
		m_pEnemy.AddResearch("RES_IRQ_HELICOPTER1");
		m_pEnemy.AddResearch("RES_IRQ_AMMO_MG1");
		m_pEnemy.AddResearch("RES_IRQ_PILLBOX");
		m_pEnemy.AddResearch("RES_IRQ_TANK2");
		m_pEnemy.AddResearch("RES_IRQ_SAPER");
		m_pEnemy.AddResearch("RES_IRQ_MIM");
		m_pEnemy.AddResearch("RES_IRQ_RART");
		m_pEnemy.AddResearch("RES_IRQ_HRART");
		m_pEnemy.AddResearch("RES_IRQ_AMMO_MIM1");
		m_pEnemy.AddResearch("RES_IRQ_SPECIAL_FILTER2");
		m_pEnemy.AddResearch("RES_IRQ_AMMO_CANNON1");
		m_pEnemy.AddResearch("RES_IRQ_BIGART");
		m_pEnemy.AddResearch("RES_IRQ_AMMO_ROCKET1");
		m_pEnemy.AddResearch("RES_IRQ_AMMO_HROCKET1");
		m_pEnemy.AddResearch("RES_IRQ_MGM");
		m_pEnemy.AddResearch("RES_IRQ_EXPLODER");

		m_bCheckBoat = true;
		m_bCheckHummer = true;
		m_bCheckHelicopter = true;

		SetTimer(0, 100); // CheckDestroyedUnits

		AddUnitTemplatesIRQ( m_pEnemy );

		return BeforeStart, 1;
	}

	state BeforeStart
	{
		PlayTrack("Music\\Briefing.tws");

		return Start;
	}

	state Start
	{
		EnableGoal(goalHeroSurvive, true);
		EnableGoal(goalFindHummer, true);

		AddBriefing("translateBriefingMissionUSA_6_FindHummer");
		PlayWave("Briefings\\USA_Briefing06.wav");

		m_pFriendlyUnits.SetNeutral(m_pPlayer);
		m_pPlayer.SetNeutral(m_pFriendlyUnits);

		m_pFriendlyUnits.SetNeutral(m_pEnemy);
		m_pEnemy.SetNeutral(m_pFriendlyUnits);

		AddWorldMapSign(GetPointX(markerHummer), GetPointY(markerHummer), 0, 0, 65000);

		return FindHummer;
	}

	state FindHummer
	{
		if ( Distance(m_uBoat.GetLocationX(), m_uBoat.GetLocationY(), GetPointX(markerBoatDestination), GetPointY(markerBoatDestination)) <= 8 )
		{
			return FoundHummer;
		}
		else
		{
			return FindHummer;
		}
	}

	state FoundHummer
	{
		SetGoalState(goalFindHummer, goalAchieved);

		EnableGoal(goalFindFriendlyUnits, true);

		EnableInterface(false);

		m_pPlayer.DelayedLookAt( GetPointX(markerBoatDestination), GetPointY(markerBoatDestination), -1, -1, 0, 0, 100, 1);

		m_uBoat.CommandMove( GetPointX(markerBoatDestination), GetPointY(markerBoatDestination), 0);

		RemoveWorldMapSign(GetPointX(markerHummer), GetPointY(markerHummer), 0);

		return WaitForBoatMove;
	}

	state WaitForBoatMove
	{
		if ( m_uBoat.IsMoving() )
		{
			return WaitForBoatMove;
		}
		else
		{
			return BoatMoved;
		}

	}

	state BoatMoved
	{
		EnableInterface(true);

		m_uBoat.ChangePlayer(m_pFriendlyUnits);
		m_uBoat.SetUnitName("translateUSAHeroName_Empty");
		m_uHummer.ChangePlayer(m_pPlayer);
		m_uHummer.SetUnitName(null);

		m_bCheckBoat = false;

		AddBriefing("translateBriefingMissionUSA_6_FindFriendlyUnits");

		AddWorldMapSign(m_pFriendlyUnits.GetStartingPointX(), m_pFriendlyUnits.GetStartingPointY(), 0, 0, 65000);

		return FindFriendlyUnits;
	}

	state FindFriendlyUnits
	{
		if ( Distance(m_uHummer.GetLocationX(), m_uHummer.GetLocationY(), m_pFriendlyUnits.GetStartingPointX(), m_pFriendlyUnits.GetStartingPointY()) <= 1 )
		{
			return FoundFriendlyUnits;
		}
		else
		{
			return FindFriendlyUnits;
		}
	}

	state FoundFriendlyUnits
	{
		SetGoalState(goalFindFriendlyUnits, goalAchieved);

		EnableGoal(goalDestroyEnemy, true);

		m_pFriendlyUnits.GiveAllUnitsTo(m_pPlayer);
		m_uHelicopter.SetUnitName(null);

		m_uBoat.ChangePlayer(m_pFriendlyUnits);
		m_uHummer.ChangePlayer(m_pFriendlyUnits);
		m_uHummer.SetUnitName("translateUSAHeroName_Empty");

		m_bCheckHummer = false;

		RemoveWorldMapSign(m_pFriendlyUnits.GetStartingPointX(), m_pFriendlyUnits.GetStartingPointY(), 0);

		AddBriefing("translateBriefingMissionUSA_6_DestroyEnemy");

		return DestroyEnemy;
	}

	state DestroyEnemy
	{
		if ( !m_bCheckNumberOfUnits && !m_bCheckNumberOfBuildings )
		{
			return DestroyEnemy;
		}

		m_bCheckNumberOfUnits = false;
		m_bCheckNumberOfBuildings = false;

		if ( m_pEnemy.GetNumberOfBuildings() == 0 && m_pEnemy.GetNumberOfUnits() == 0 )
		{
			return DestroyedEnemy;
		}
		else
		{
			return DestroyEnemy;
		}
	}

	state DestroyedEnemy
	{
		SetGoalState(goalDestroyEnemy, goalAchieved);
		SetGoalState(goalHeroSurvive, goalAchieved);

		AddBriefing("translateBriefingMissionUSA_6_MissionComplete");

		EnableEndMissionButton(true, true);

		return MissionComplete;
	}

	state MissionComplete
	{
		return MissionComplete;
	}

	function int CheckDestroyedUnits()
	{
		if ( state == MissionComplete ) return;

		if ( m_bCheckBoat && !m_uBoat.IsLive() )
		{
			SetGoalState(goalHeroSurvive, goalFailed);
			SetGoalState(goalFindHummer, goalFailed);

			AddBriefing("translateBriefingMissionUSA_6_MissionFail");

			EnableEndMissionButton(true, false);

			state MissionComplete;
		}
		else if ( m_bCheckHummer && !m_uHummer.IsLive() )
		{
			if ( state == FindHummer )
			{
				SetGoalState(goalFindHummer, goalFailed);
			}
			else
			{
				SetGoalState(goalHeroSurvive, goalFailed);
				SetGoalState(goalFindFriendlyUnits, goalFailed);
			}

			AddBriefing("translateBriefingMissionUSA_6_MissionFail");

			EnableEndMissionButton(true, false);

			state MissionComplete;
		}
		else if ( m_bCheckHelicopter && !m_uHelicopter.IsLive() )
		{
			if ( state == DestroyEnemy )
			{
				SetGoalState(goalHeroSurvive, goalFailed);
			}
			else
			{
				SetGoalState(goalFindFriendlyUnits, goalFailed);
			}

			AddBriefing("translateBriefingMissionUSA_6_MissionFail");

			EnableEndMissionButton(true, false);

			state MissionComplete;
		}
	}

	event Timer0()
	{
		if ( m_bCheckDestroyedUnits )
		{
			m_bCheckDestroyedUnits = false;

			CheckDestroyedUnits();
		}
	}

	event UnitDestroyed(unit uUnit)
	{
		m_bCheckNumberOfUnits = true;
		m_bCheckDestroyedUnits = true;
	}

	event BuildingDestroyed(unit uBuilding)
	{
		m_bCheckNumberOfBuildings = true;
	}

	event SetupInterface()
	{
	}
}
