mission "translateMissionUSA_7"
{
	consts
	{
		goalHeroSurvive = 0;
		goalDestroyEnemyA = 1;
		goalFindTerrorist = 2;

		markerHero = 3;

		markerTerroristHelicopter = 1;
		marker2ndHelicopter = 0;

		markerHelicoptersDestination = 2;

		markerEnemyTank1 = 13;
		markerEnemyTank2 = 14;
	}

	include "UnitTemplates.ech"
	include "Research.ech"

	player m_pPlayer;

	player m_pEnemyA;
	player m_pEnemyB;

	player m_pFriendlyUnits;
	player m_pTerroristUnits;
	player m_pEnemyUnits;

	unitex m_uHero;

	unitex m_uTerroristHelicopter;
	unitex m_u2ndHelicopter;

	unitex m_uEnemyTank1;
	unitex m_uEnemyTank2;

	int m_bCheckNumberOfUnits;
	int m_bCheckNumberOfBuildings;

	int m_nEnemyADestroyedBuildings;

	state Initialize;
	state Start;
	state BeforeStart;
	state AttackEnemy;
	state AttackedEnemy;
	state WaitForHelicopterDestroy;
	state HelicopterDestroyed;
	state ShowedCrushSite;
	state FindTerrorist;
	state FoundTerrorist;
	state MissionComplete;

	function int ClearMarkers(int nStartPoint, int nEndPoint)
	{
		int i;

		for ( i=nStartPoint; i<=nEndPoint; i=i+1 )
		{
			ClearArea (65535, GetPointX(i), GetPointY(i), GetPointZ(i), 0);
		}
	}

	function int ModifyDifficulty()
	{
		if ( GetDifficultyLevel() == 0 )
		{
			ClearMarkers(15, 84);
		}
		else if ( GetDifficultyLevel() == 1 )
		{
			ClearMarkers(15, 17);
			ClearMarkers(21, 25);
			ClearMarkers(27, 28);
			ClearMarkers(30, 30);
			ClearMarkers(32, 32);
			ClearMarkers(34, 34);
			ClearMarkers(36, 36);
			ClearMarkers(43, 43);
			ClearMarkers(45, 45);
			ClearMarkers(47, 48);
			ClearMarkers(50, 53);
			ClearMarkers(55, 55);
			ClearMarkers(57, 59);
			ClearMarkers(61, 62);
			ClearMarkers(64, 65);
			ClearMarkers(72, 73);
			ClearMarkers(76, 80);
			ClearMarkers(85, 86);
		}
		else if ( GetDifficultyLevel() == 2 )
		{
			ClearArea	(65535, GetPointX( 6), GetPointY( 6), GetPointZ( 6), 0);
			ClearMarkers(85, 86);
		}
	}

	state Initialize
	{
		m_nEnemyADestroyedBuildings = 0;

		RegisterGoal(goalHeroSurvive, "translateGoalMissionUSA_HeroSurvive");
		RegisterGoal(goalDestroyEnemyA, "translateGoalMissionUSA_7_DestroyEnemyA");
		RegisterGoal(goalFindTerrorist, "translateGoalMissionUSA_7_FindTerrorist");

		m_pPlayer = GetPlayer(0);
		m_pPlayer.EnableStatistics(true);

		m_pEnemyA = GetPlayer(1);
		m_pEnemyA.EnableStatistics(true);
		m_pEnemyB = GetPlayer(3);
		m_pEnemyB.EnableStatistics(true);

		m_pFriendlyUnits = GetPlayer(5);
		m_pFriendlyUnits.EnableStatistics(false);
		m_pTerroristUnits = GetPlayer(6);
		m_pTerroristUnits.EnableStatistics(false);
		m_pEnemyUnits = GetPlayer(7);
		m_pEnemyUnits.EnableStatistics(false);

        //moved by JS
		ModifyDifficulty();

//		if ( GetDifficultyLevel() == 0 )
//		{
//			m_pEnemyA.LoadScript("single\\singleEasy");
//			m_pEnemyB.LoadScript("single\\singleEasy");
//		}
		if ( GetDifficultyLevel() == 0 )
		{
			m_pEnemyA.LoadScript("single\\singleEasy");
			m_pEnemyB.LoadScript("single\\singleMedium");
		}
		else if ( GetDifficultyLevel() >= 1 )
		{
			m_pEnemyA.LoadScript("single\\singleHard");
			m_pEnemyA.EnableAIFeatures2(ai2CaptureSpecialTarget, false);

			m_pEnemyB.LoadScript("single\\singleHard");
			m_pEnemyB.EnableAIFeatures2(ai2CaptureSpecialTarget, false);
		}

		m_pEnemyB.SetMaxDistance(30);

		m_uHero = GetUnit(GetPointX(markerHero), GetPointY(markerHero));

		m_uEnemyTank1 = GetUnit(GetPointX(markerEnemyTank1), GetPointY(markerEnemyTank1));
		m_uEnemyTank2 = GetUnit(GetPointX(markerEnemyTank2), GetPointY(markerEnemyTank2));

		m_uTerroristHelicopter = m_pTerroristUnits.CreateUnit(GetPointX(markerTerroristHelicopter), GetPointY(markerTerroristHelicopter), 0, null, "IRQ_TERRORISTCHOPTER", "IRQ_HELICOPTER_GUN", null, null, null);
		m_uTerroristHelicopter.CommandSetMovementMode(2); // hold position
		m_uTerroristHelicopter.CommandSetAttackMode(1); // return fire
//		m_uTerroristHelicopter = GetUnit(GetPointX(markerTerroristHelicopter), GetPointY(markerTerroristHelicopter));
		m_u2ndHelicopter = GetUnit(GetPointX(marker2ndHelicopter), GetPointY(marker2ndHelicopter));
		m_u2ndHelicopter.CommandSetMovementMode(2); // hold position
		m_u2ndHelicopter.CommandSetAttackMode(1); // return fire

		m_pPlayer.LookAt(GetPointX(markerHero), GetPointY(markerHero), 6, 0, 0, 0);

		m_pEnemyA.EnableAI(false);
//		m_pEnemyA.EnableAIFeatures(aiEverything, true);
		m_pEnemyA.EnableAIFeatures(aiControlOffense, false);


		if ( GetDifficultyLevel() == 0 )
		{
			m_pEnemyB.EnableAI(false);
		}
		else
		{
			m_pEnemyB.EnableAI(true);
		}

//		m_pEnemyB.EnableAIFeatures(aiEverything, true);

		m_pPlayer.SetMoney(2000);

		m_pEnemyA.SetMoney(20000);
		m_pEnemyB.SetMoney(60000);

		m_pFriendlyUnits.EnableAI(false);
		m_pFriendlyUnits.EnableAIFeatures2(ai2ChooseEnemy, false);

		m_pTerroristUnits.EnableAI(false);
		m_pEnemyUnits.EnableAI(false);

		m_pFriendlyUnits.SetNeutral(m_pPlayer);
		m_pPlayer.SetNeutral(m_pFriendlyUnits);

		m_pFriendlyUnits.SetEnemy(m_pTerroristUnits);

		AddUnitTemplatesUSA(m_pPlayer);
		m_pPlayer.RemoveObjectTemplate(null, -1, "USA_TRANSPORTER", "USA_TRANSPORTER_Hook", null, null, null);

		EnableAllResearchUSA( m_pPlayer, false);
		m_pPlayer.EnableResearch("RES_USA_AMPHIBIA1", true);		// M1
		m_pPlayer.EnableResearch("RES_USA_AMMO_MG1", true);			// M1
		m_pPlayer.EnableResearch("RES_USA_SPY", true);				// M2
		m_pPlayer.EnableResearch("RES_USA_HELICOPTER1", true);		// M2
		m_pPlayer.EnableResearch("RES_USA_AMMO_MG2", true);			// M3
		m_pPlayer.EnableResearch("RES_USA_HELICOPTER2", true);		// M3
		m_pPlayer.EnableResearch("RES_USA_TANK1", true);			// M3
		m_pPlayer.EnableResearch("RES_USA_SAPER", true);			// M3
		m_pPlayer.EnableResearch("RES_USA_MORTAR", true);			// M4
		m_pPlayer.EnableResearch("RES_USA_AMMO_CANNON1", true);		// M4-
		m_pPlayer.EnableResearch("RES_USA_MIM", true);				// M4
		m_pPlayer.EnableResearch("RES_USA_SPECIAL_FILTER2", true);	// M4
		m_pPlayer.EnableResearch("RES_USA_ART", true);				// M5-
		m_pPlayer.EnableResearch("RES_USA_AMMO_GRENADE1", true);	// M5-
//		m_pPlayer.EnableResearch("RES_USA_COMANCHE", true);			// M5-
//		m_pPlayer.EnableResearch("RES_USA_AMMO_MIM1", true);		// M5-
		m_pPlayer.EnableResearch("RES_USA_MGM", true);				// M5
//		m_pPlayer.EnableResearch("RES_USA_SDI", true);				// M5-
		m_pPlayer.EnableResearch("RES_USA_SPECIAL_FILTER3", true);	// M5
		m_pPlayer.EnableResearch("RES_USA_AMMO_GRENADE2", true);	// M6-
		m_pPlayer.EnableResearch("RES_USA_AMMO_CANNON2", true);		// M6-
//		m_pPlayer.EnableResearch("RES_USA_SPECIAL_PTC", true);		// M6-
//		m_pPlayer.EnableResearch("RES_USA_SPECIAL_FLARE", true);	// M6-
//		m_pPlayer.EnableResearch("RES_USA_LECLERC", true);
//		m_pPlayer.EnableResearch("RES_USA_AMMO_MGM1", true);

		EnableAllResearchIRQ( m_pEnemyA, false);
		m_pEnemyA.EnableResearch("RES_IRQ_TANK1", true);			// M1
		m_pEnemyA.EnableResearch("RES_IRQ_HELICOPTER1", true);		// M2
		m_pEnemyA.EnableResearch("RES_IRQ_AMMO_MG1", true);			// M3
		m_pEnemyA.EnableResearch("RES_IRQ_PILLBOX", true);			// M3
		m_pEnemyA.EnableResearch("RES_IRQ_TANK2", true);			// M3
		m_pEnemyA.EnableResearch("RES_IRQ_SAPER", true);			// M3
		m_pEnemyA.EnableResearch("RES_IRQ_MIM", true);				// M3
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyA.EnableResearch("RES_IRQ_RART", true);			// M4
			m_pEnemyA.EnableResearch("RES_IRQ_HRART", true);		// M4
		}
		m_pEnemyA.EnableResearch("RES_IRQ_AMMO_MIM1", true);		// M4
		m_pEnemyA.EnableResearch("RES_IRQ_SPECIAL_FILTER2", true);	// M4
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyA.EnableResearch("RES_IRQ_AMMO_CANNON1", true);	// M5
		}
		m_pEnemyA.EnableResearch("RES_IRQ_BIGART", true);			// M5
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyA.EnableResearch("RES_IRQ_AMMO_ROCKET1", true);	// M5
			m_pEnemyA.EnableResearch("RES_IRQ_AMMO_HROCKET1", true);// M5
		}
		m_pEnemyA.EnableResearch("RES_IRQ_MGM", true);				// M5
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyA.EnableResearch("RES_IRQ_EXPLODER", true);		// M5
			m_pEnemyA.EnableResearch("RES_IRQ_AMMO_CANNON2", true);	// M6
			m_pEnemyA.EnableResearch("RES_IRQ_AMMO_ROCKET2", true);	// M6
			m_pEnemyA.EnableResearch("RES_IRQ_AMMO_HROCKET2", true);// M6
		}
		m_pEnemyA.EnableResearch("RES_IRQ_AMMO_MIM2", true);		// M6
		m_pEnemyA.EnableResearch("RES_IRQ_JEEP_MGM", true);			// M6
		m_pEnemyA.EnableResearch("RES_IRQ_SPECIAL_FILTER2", true);	// M6
		m_pEnemyA.EnableResearch("RES_IRQ_AMMO_MGM1", true);
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyA.EnableResearch("RES_IRQ_EXPLODER_BIG", true);
		}

		EnableAllResearchIRQ( m_pEnemyB, false);
		m_pEnemyB.EnableResearch("RES_IRQ_TANK1", true);			// M1
		m_pEnemyB.EnableResearch("RES_IRQ_HELICOPTER1", true);		// M2
		m_pEnemyB.EnableResearch("RES_IRQ_AMMO_MG1", true);			// M3
		m_pEnemyB.EnableResearch("RES_IRQ_PILLBOX", true);			// M3
		m_pEnemyB.EnableResearch("RES_IRQ_TANK2", true);			// M3
		m_pEnemyB.EnableResearch("RES_IRQ_SAPER", true);			// M3
		m_pEnemyB.EnableResearch("RES_IRQ_MIM", true);				// M3
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyB.EnableResearch("RES_IRQ_RART", true);			// M4
			m_pEnemyB.EnableResearch("RES_IRQ_HRART", true);		// M4
		}
		m_pEnemyB.EnableResearch("RES_IRQ_AMMO_MIM1", true);		// M4
		m_pEnemyB.EnableResearch("RES_IRQ_SPECIAL_FILTER2", true);	// M4
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyB.EnableResearch("RES_IRQ_AMMO_CANNON1", true);	// M5
		}
		m_pEnemyB.EnableResearch("RES_IRQ_BIGART", true);			// M5
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyB.EnableResearch("RES_IRQ_AMMO_ROCKET1", true);	// M5
			m_pEnemyB.EnableResearch("RES_IRQ_AMMO_HROCKET1", true);// M5
		}
		m_pEnemyB.EnableResearch("RES_IRQ_MGM", true);				// M5
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyB.EnableResearch("RES_IRQ_EXPLODER", true);		// M5
			m_pEnemyB.EnableResearch("RES_IRQ_AMMO_CANNON2", true);	// M6
			m_pEnemyB.EnableResearch("RES_IRQ_AMMO_ROCKET2", true);	// M6
			m_pEnemyB.EnableResearch("RES_IRQ_AMMO_HROCKET2", true);// M6
		}
		m_pEnemyB.EnableResearch("RES_IRQ_AMMO_MIM2", true);		// M6
		m_pEnemyB.EnableResearch("RES_IRQ_JEEP_MGM", true);			// M6
		m_pEnemyB.EnableResearch("RES_IRQ_SPECIAL_FILTER2", true);	// M6
		m_pEnemyB.EnableResearch("RES_IRQ_AMMO_MGM1", true);
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyB.EnableResearch("RES_IRQ_EXPLODER_BIG", true);
		}

		m_pEnemyA.AddResearch("RES_IRQ_TANK1");
		m_pEnemyA.AddResearch("RES_IRQ_HELICOPTER1");
		m_pEnemyA.AddResearch("RES_IRQ_AMMO_MG1");
		m_pEnemyA.AddResearch("RES_IRQ_PILLBOX");
		m_pEnemyA.AddResearch("RES_IRQ_TANK2");
		m_pEnemyA.AddResearch("RES_IRQ_SAPER");
		m_pEnemyA.AddResearch("RES_IRQ_MIM");
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyA.AddResearch("RES_IRQ_RART");
			m_pEnemyA.AddResearch("RES_IRQ_HRART");
		}
		m_pEnemyA.AddResearch("RES_IRQ_AMMO_MIM1");
		m_pEnemyA.AddResearch("RES_IRQ_SPECIAL_FILTER2");
		m_pEnemyA.AddResearch("RES_IRQ_AMMO_CANNON1");
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyA.AddResearch("RES_IRQ_BIGART");
		}
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyA.AddResearch("RES_IRQ_AMMO_ROCKET1");
			m_pEnemyA.AddResearch("RES_IRQ_AMMO_HROCKET1");
		}
		m_pEnemyA.AddResearch("RES_IRQ_MGM");
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyA.AddResearch("RES_IRQ_EXPLODER");
			m_pEnemyA.AddResearch("RES_IRQ_AMMO_CANNON2");
			m_pEnemyA.AddResearch("RES_IRQ_AMMO_ROCKET2");
			m_pEnemyA.AddResearch("RES_IRQ_AMMO_HROCKET2");
		}
		m_pEnemyA.AddResearch("RES_IRQ_AMMO_MIM2");
		m_pEnemyA.AddResearch("RES_IRQ_JEEP_MGM");
		m_pEnemyA.AddResearch("RES_IRQ_SPECIAL_FILTER2");

		m_pEnemyB.AddResearch("RES_IRQ_TANK1");
		m_pEnemyB.AddResearch("RES_IRQ_HELICOPTER1");
		m_pEnemyB.AddResearch("RES_IRQ_AMMO_MG1");
		m_pEnemyB.AddResearch("RES_IRQ_PILLBOX");
		m_pEnemyB.AddResearch("RES_IRQ_TANK2");
		m_pEnemyB.AddResearch("RES_IRQ_SAPER");
		m_pEnemyB.AddResearch("RES_IRQ_MIM");
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyB.AddResearch("RES_IRQ_RART");
			m_pEnemyB.AddResearch("RES_IRQ_HRART");
		}
		m_pEnemyB.AddResearch("RES_IRQ_AMMO_MIM1");
		m_pEnemyB.AddResearch("RES_IRQ_SPECIAL_FILTER2");
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyB.AddResearch("RES_IRQ_AMMO_CANNON1");
		}
		m_pEnemyB.AddResearch("RES_IRQ_BIGART");
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyB.AddResearch("RES_IRQ_AMMO_ROCKET1");
			m_pEnemyB.AddResearch("RES_IRQ_AMMO_HROCKET1");
		}
		m_pEnemyB.AddResearch("RES_IRQ_MGM");
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyB.AddResearch("RES_IRQ_EXPLODER");
			m_pEnemyB.AddResearch("RES_IRQ_AMMO_CANNON2");
			m_pEnemyB.AddResearch("RES_IRQ_AMMO_ROCKET2");
			m_pEnemyB.AddResearch("RES_IRQ_AMMO_HROCKET2");
		}
		m_pEnemyB.AddResearch("RES_IRQ_AMMO_MIM2");
		m_pEnemyB.AddResearch("RES_IRQ_JEEP_MGM");
		m_pEnemyB.AddResearch("RES_IRQ_SPECIAL_FILTER2");

		SetTimer(0, 100);

		AddUnitTemplatesIRQ( m_pEnemyA );
		AddUnitTemplatesIRQ( m_pEnemyB );

		return BeforeStart, 1;
	}

	state BeforeStart
	{
		PlayTrack("Music\\Briefing.tws");

		return Start;
	}

	event Timer0()
	{
		if ( GetMissionTime() >= 20*60*20 )
		{
			m_pEnemyB.EnableAI(true);
		}
		else if ( GetMissionTime() >= 3*60*20 )
		{
			m_pEnemyB.EnableAI(false);
		}
		else if ( GetMissionTime() < 1*60*20)
		{
			m_uEnemyTank1.CommandMove(GetPointX(markerHero), GetPointY(markerHero), 0);
			m_uEnemyTank2.CommandMove(GetPointX(markerHero), GetPointY(markerHero), 0);
		}

		if ( GetDifficultyLevel() >= 1 && GetMissionTime() >= 25*60*20 )
		{
			m_pEnemyA.EnableAIFeatures2(ai2CaptureSpecialTarget, true);
			m_pEnemyB.EnableAIFeatures2(ai2CaptureSpecialTarget, true);
		}
	}

	state Start
	{
		EnableGoal(goalHeroSurvive, true);
		EnableGoal(goalDestroyEnemyA, true);

		m_pEnemyA.EnableAIFeatures(aiBuildBuildings, false);

		m_pEnemyA.EnableAI(true);

		AddBriefing("translateBriefingMissionUSA_7_DestroyEnemyA");
		PlayWave("Briefings\\USA_Briefing07.wav");

		return AttackEnemy;
	}

	state AttackEnemy
	{
		if ( m_nEnemyADestroyedBuildings >= 2 || m_pPlayer.IsPointLocated(GetPointX(markerTerroristHelicopter), GetPointY(markerTerroristHelicopter)) )
		{
			return AttackedEnemy;
		}
		else
		{
			return AttackEnemy;
		}
	}

	state AttackedEnemy
	{
		SetGoalState(goalDestroyEnemyA, goalAchieved);

		AddBriefing("translateBriefingMissionUSA_7_TerroristRun");

		m_uTerroristHelicopter.CommandMove(GetPointX(markerHelicoptersDestination), GetPointY(markerHelicoptersDestination), 0);
		m_u2ndHelicopter.CommandMove(GetPointX(markerHelicoptersDestination), GetPointY(markerHelicoptersDestination), 0);

		return WaitForHelicopterDestroy;
	}

	state WaitForHelicopterDestroy
	{
		if ( m_uTerroristHelicopter.IsLive() )
		{
			m_uTerroristHelicopter.CommandMove(GetPointX(markerHelicoptersDestination), GetPointY(markerHelicoptersDestination), 0);

			return WaitForHelicopterDestroy;
		}
		else
		{
			return HelicopterDestroyed;
		}
	}

	state HelicopterDestroyed
	{
//		SaveCameraPosition();

		ShowArea(m_pPlayer.GetIFF(), m_uTerroristHelicopter.GetLocationX(), m_uTerroristHelicopter.GetLocationY(), 0, 4, showAreaPassives|showAreaBuildings|showAreaUnits);
		m_pPlayer.LookAt(m_uTerroristHelicopter.GetLocationX(), m_uTerroristHelicopter.GetLocationY(), -1, -1, 0, 0);

		return ShowedCrushSite;
	}

	state ShowedCrushSite
	{
		EnableGoal(goalFindTerrorist, true);

		AddBriefing("translateBriefingMissionUSA_7_FindTerrorist");

//		RestoreCameraPosition();

		return FindTerrorist;
	}

	state FindTerrorist
	{
		if ( m_pEnemyB.GetNumberOfBuildings() < 6 )
		{
			m_pEnemyB.EnableAIFeatures(aiBuildBuildings, false);
			m_pEnemyA.EnableAIFeatures2(ai2RebuildBaseOnly, false);
		}

		if ( Distance(m_uTerroristHelicopter.GetLocationX(), m_uTerroristHelicopter.GetLocationY(), m_uHero.GetLocationX(), m_uHero.GetLocationY()) <= 1 )
		{
			return FoundTerrorist;
		}
		else
		{
			return FindTerrorist;
		}
	}

	state FoundTerrorist
	{
		SetGoalState(goalFindTerrorist, goalAchieved);
		SetGoalState(goalHeroSurvive, goalAchieved);

		AddBriefing("translateBriefingMissionUSA_7_MissionComplete");

		EnableEndMissionButton(true, true);

		return MissionComplete;
	}

	state MissionComplete
	{
		return MissionComplete;
	}

	event UnitDestroyed(unit uUnit)
	{
		m_bCheckNumberOfUnits = true;

		if ( uUnit == m_uHero )
		{
			SetGoalState(goalHeroSurvive, goalFailed);

			AddBriefing("translateBriefingMissionUSA_7_MissionFail");

			EnableEndMissionButton(true, false);

			state MissionComplete;
		}
	}

	event BuildingDestroyed(unit uBuilding)
	{
		if ( state == Initialize ) return;

		if ( uBuilding.GetIFF() == m_pEnemyA.GetIFF() )
		{
			m_nEnemyADestroyedBuildings = m_nEnemyADestroyedBuildings + 1;
		}
		else if ( uBuilding.GetIFF() == m_pEnemyB.GetIFF() )
		{
			m_pEnemyUnits.GiveAllUnitsTo(m_pEnemyB);
		}

		m_bCheckNumberOfBuildings = true;
	}

	event EndMission()
	{
		m_pPlayer.SaveUnit(0, m_uHero);
	}

	event SetupInterface()
	{
	}
}
