mission "translateMissionUSA_9"
{
	consts
	{
		goalHeroSurvive = 0;
		goalFindBase = 1;
		goalCaptureWarheads = 2;
		goalKillTerrorist = 3;

		markerHero = 0;
		markerTargetUnit = 1;
		markerWarhead1 = 2;
		markerWarhead2 = 3;
		markerWarhead3 = 4;

		markerTerroristDestination = 5;
		markerBoat = 26;
	}

	include "UnitTemplates.ech"
	include "Research.ech"

	player m_pPlayer;

	player m_pTerroristUnits;
	player m_pEnemyUnits;

	player m_pEnemyA;
	player m_pEnemyB;
	player m_pSupportUnits;

	unitex m_uHero;
	unitex m_uTargetUnit;

	unitex m_uTerrorist;
	unitex m_uBoat;

	int m_bCapturedWarhead1;
	int m_bCapturedWarhead2;
	int m_bCapturedWarhead3;

	int m_bCheckNumberOfUnits;
	int m_bCheckNumberOfBuildings;

	int m_bMissionFail;

	state Initialize;
	state Start;
	state BeforeStart;
	state Attack1;
	state Attack2;
	state FindBase;
	state FoundBase;
	state CaptureWarheads;
	state CapturedWarheads;
	state KillTerrorist;
	state KilledTerrorist;
	state TerroristEscaped;
	state MissionComplete;

	function int GroupAttack(int nStartPoint, int nEndPoint, unitex uTarget)
	{
		int i;
		unitex uTmp;

		for ( i = nStartPoint; i <= nEndPoint; i = i + 1 )
		{
			uTmp = GetUnit(GetPointX(i), GetPointY(i));

			if ( uTmp )
			{
				uTmp.CommandAttack(uTarget);
			}
		}
	}

	function int ClearMarkers(int nStartPoint, int nEndPoint)
	{
		int i;

		for ( i=nStartPoint; i<=nEndPoint; i=i+1 )
		{
			ClearArea (65535, GetPointX(i), GetPointY(i), GetPointZ(i), 0);
		}
	}

	function int ModifyDifficulty()
	{
		if ( GetDifficultyLevel() == 0 )
		{
			ClearMarkers ( 7,  8);
			ClearMarkers (10, 10);
			ClearMarkers (12, 12);
			ClearMarkers (14, 14);
			ClearMarkers (16, 16);
			ClearMarkers (21, 21);
			ClearMarkers (24, 25);
			ClearMarkers (53, 77);
			ClearMarkers (80,124);
		}
		else if ( GetDifficultyLevel() == 1 )
		{
			ClearMarkers (12, 12);
			ClearMarkers (53, 56);
			ClearMarkers (58, 59);
			ClearMarkers (62, 63);
			ClearMarkers (65, 65);
			ClearMarkers (70, 70);
			ClearMarkers (73, 73);
			ClearMarkers (78, 78);
		}
		else if ( GetDifficultyLevel() == 2 )
		{
			ClearMarkers (78, 79);
		}
	}

	state Initialize
	{
		ModifyDifficulty();

		RegisterGoal(goalHeroSurvive, "translateGoalMissionUSA_HeroSurvive");
		RegisterGoal(goalFindBase, "translateGoalMissionUSA_9_General");
		RegisterGoal(goalCaptureWarheads, "translateGoalMissionUSA_9_CaptureWarheads");
		RegisterGoal(goalKillTerrorist, "translateGoalMissionUSA_9_CatchTerrorist");

		m_pPlayer = GetPlayer(0);

		m_pPlayer.SetMilitaryUnitsLimit(60000);

		m_pEnemyA = GetPlayer(7);
		m_pEnemyB = GetPlayer(9);
		
		m_pTerroristUnits = GetPlayer(3);
		m_pTerroristUnits.EnableStatistics(false);
		m_pEnemyUnits = GetPlayer(4);
		m_pEnemyUnits.EnableStatistics(false);
		m_pSupportUnits = GetPlayer(10);
		m_pSupportUnits.EnableStatistics(false);

//		if ( GetDifficultyLevel() == 0 )
//		{
//			m_pEnemyA.LoadScript("single\\singleEasy");
//			m_pEnemyB.LoadScript("single\\singleEasy");
//		}
		if ( GetDifficultyLevel() == 0 )
		{
			m_pEnemyA.LoadScript("single\\singleEasy");
			m_pEnemyB.LoadScript("single\\singleEasy");
		}
		else if ( GetDifficultyLevel() >= 1 )
		{
			m_pEnemyA.LoadScript("single\\singleHard");
			m_pEnemyB.LoadScript("single\\singleHard");
		}

		m_pEnemyA.EnableAI(false);
		m_pEnemyB.EnableAI(false);

		m_pTerroristUnits.EnableAI(false);
		m_pEnemyUnits.EnableAI(false);
		m_pSupportUnits.EnableAI(false);

		m_pPlayer.RestoreUnitsAt(0, GetPointX(markerHero), GetPointY(markerHero), 0);

		m_uHero = GetUnit(GetPointX(markerHero), GetPointY(markerHero));
		m_uHero.RegenerateAmmo();

		m_uTargetUnit = GetUnit(GetPointX(markerTargetUnit), GetPointY(markerTargetUnit));
		m_uBoat = GetUnit(GetPointX(markerBoat), GetPointY(markerBoat));

		m_pPlayer.SetMoney(5000);

		m_pEnemyA.SetMoney(10000);
		m_pEnemyB.SetMoney(30000);

		AddUnitTemplatesUSA(m_pPlayer);

		m_pPlayer.LookAt(m_pPlayer.GetStartingPointX(), m_pPlayer.GetStartingPointY(), 6, 0, 0, 0);

		EnableAllResearchUSA( m_pPlayer, false);
		m_pPlayer.EnableResearch("RES_USA_AMPHIBIA1", true);		// M1
		m_pPlayer.EnableResearch("RES_USA_AMMO_MG1", true);			// M1
		m_pPlayer.EnableResearch("RES_USA_SPY", true);				// M2
		m_pPlayer.EnableResearch("RES_USA_HELICOPTER1", true);		// M2
		m_pPlayer.EnableResearch("RES_USA_AMMO_MG2", true);			// M3
		m_pPlayer.EnableResearch("RES_USA_HELICOPTER2", true);		// M3
		m_pPlayer.EnableResearch("RES_USA_TANK1", true);			// M3
		m_pPlayer.EnableResearch("RES_USA_SAPER", true);			// M3
		m_pPlayer.EnableResearch("RES_USA_MORTAR", true);			// M4
		m_pPlayer.EnableResearch("RES_USA_AMMO_CANNON1", true);		// M4
		m_pPlayer.EnableResearch("RES_USA_MIM", true);				// M4
		m_pPlayer.EnableResearch("RES_USA_SPECIAL_FILTER2", true);	// M4
		m_pPlayer.EnableResearch("RES_USA_ART", true);				// M5
		m_pPlayer.EnableResearch("RES_USA_AMMO_GRENADE1", true);	// M5
		m_pPlayer.EnableResearch("RES_USA_COMANCHE", true);			// M5
		m_pPlayer.EnableResearch("RES_USA_AMMO_MIM1", true);		// M5
		m_pPlayer.EnableResearch("RES_USA_MGM", true);				// M5
		m_pPlayer.EnableResearch("RES_USA_SDI", true);				// M5
		m_pPlayer.EnableResearch("RES_USA_SPECIAL_FILTER3", true);	// M5
		m_pPlayer.EnableResearch("RES_USA_AMMO_GRENADE2", true);	// M6
		m_pPlayer.EnableResearch("RES_USA_AMMO_CANNON2", true);		// M6
		m_pPlayer.EnableResearch("RES_USA_SPECIAL_PTC", true);		// M6
		m_pPlayer.EnableResearch("RES_USA_SPECIAL_FLARE", true);	// M6
		m_pPlayer.EnableResearch("RES_USA_LECLERC", true);			// M7
		m_pPlayer.EnableResearch("RES_USA_AMMO_MGM1", true);		// M7
		m_pPlayer.EnableResearch("RES_USA_AIRCONTROL", true);		// M8
		m_pPlayer.EnableResearch("RES_USA_AMMO_MIM2", true);		// M8
		m_pPlayer.EnableResearch("RES_USA_JEEP_JAMMER", true);		// M8
		m_pPlayer.EnableResearch("RES_USA_BOMBCONTROL", true);
		m_pPlayer.EnableResearch("RES_USA_AMMO_MGM2", true);

		EnableAllResearchRUS( m_pEnemyA, false);
		m_pEnemyA.EnableResearch("RES_RUS_AMPHIBIA1", true);			// M1
		m_pEnemyA.EnableResearch("RES_RUS_ZSU", true);					// M2
		m_pEnemyA.EnableResearch("RES_RUS_ASSAULT", true);				// M2
		m_pEnemyA.EnableResearch("RES_RUS_PILLBOX", true);				// M3
		m_pEnemyA.EnableResearch("RES_RUS_TANK", true);					// M3
		m_pEnemyA.EnableResearch("RES_RUS_MIM", true);					// M3
		m_pEnemyA.EnableResearch("RES_RUS_HELICOPTER1", true);			// M3
		m_pEnemyA.EnableResearch("RES_RUS_AMMO_MG1", true);				// M4
		m_pEnemyA.EnableResearch("RES_RUS_AMMO_CANNON1", true);			// M4
		m_pEnemyA.EnableResearch("RES_RUS_SAPER", true);				// M4
		m_pEnemyA.EnableResearch("RES_RUS_BM21", true);					// M4
		m_pEnemyA.EnableResearch("RES_RUS_HELICOPTER2", true);			// M4
		m_pEnemyA.EnableResearch("RES_RUS_AMMO_MG2", true);				// M5
		m_pEnemyA.EnableResearch("RES_RUS_ART", true);					// M5
		m_pEnemyA.EnableResearch("RES_RUS_AMMO_MGM1", true);			// M5
		m_pEnemyA.EnableResearch("RES_RUS_SPECIAL_FILTER2", true);		// M5
		m_pEnemyA.EnableResearch("RES_RUS_AMMO_CANNON2", true);			// M6
		m_pEnemyA.EnableResearch("RES_RUS_AMMO_ART1", true);			// M6
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyA.EnableResearch("RES_RUS_CHEMICAL1", true);		// M6
		}
		m_pEnemyA.EnableResearch("RES_RUS_AMMO_MGM2", true);			// M6
		m_pEnemyA.EnableResearch("RES_RUS_SDI", true);					// M6
		m_pEnemyA.EnableResearch("RES_RUS_SPECIAL_FILTER3", true);		// M6
		m_pEnemyA.EnableResearch("RES_RUS_AMMO_ART2", true);			// M7
		m_pEnemyA.EnableResearch("RES_RUS_AMMO_ROCKET1", true);			// M7
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyA.EnableResearch("RES_RUS_AMMO_CHEMICAL1", true);	// M7
		}
		m_pEnemyA.EnableResearch("RES_RUS_ROCKETCONTROL", true);		// M7
		m_pEnemyA.EnableResearch("RES_RUS_ROMB", true);					// M7
		m_pEnemyA.EnableResearch("RES_RUS_AIRCONTROL", true);			// M7
		m_pEnemyA.EnableResearch("RES_RUS_SPECIAL_PTC", true);			// M7
		m_pEnemyA.EnableResearch("RES_RUS_AMMO_ROCKET2", true);			// M8
		m_pEnemyA.EnableResearch("RES_RUS_AMMO_MIM1", true);			// M8
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyA.EnableResearch("RES_RUS_AMMO_CHEMICAL2", true);
		}
//		m_pEnemyA.EnableResearch("RES_RUS_BOMBCONTROL", true);
		m_pEnemyA.EnableResearch("RES_RUS_SPECIAL_FLARE", true);

		m_pEnemyA.AddResearch("RES_RUS_AMPHIBIA1");
		m_pEnemyA.AddResearch("RES_RUS_ZSU");
		m_pEnemyA.AddResearch("RES_RUS_ASSAULT");
		m_pEnemyA.AddResearch("RES_RUS_PILLBOX");
		m_pEnemyA.AddResearch("RES_RUS_TANK");
		m_pEnemyA.AddResearch("RES_RUS_MIM");
		m_pEnemyA.AddResearch("RES_RUS_HELICOPTER1");
		m_pEnemyA.AddResearch("RES_RUS_AMMO_MG1");
		m_pEnemyA.AddResearch("RES_RUS_AMMO_CANNON1");
		m_pEnemyA.AddResearch("RES_RUS_SAPER");
		m_pEnemyA.AddResearch("RES_RUS_BM21");
		m_pEnemyA.AddResearch("RES_RUS_HELICOPTER2");
		m_pEnemyA.AddResearch("RES_RUS_AMMO_MG2");
		m_pEnemyA.AddResearch("RES_RUS_ART");
		m_pEnemyA.AddResearch("RES_RUS_AMMO_MGM1");
		m_pEnemyA.AddResearch("RES_RUS_SPECIAL_FILTER2");
		m_pEnemyA.AddResearch("RES_RUS_AMMO_CANNON2");
		m_pEnemyA.AddResearch("RES_RUS_AMMO_ART1");
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyA.AddResearch("RES_RUS_CHEMICAL1");
		}
		m_pEnemyA.AddResearch("RES_RUS_AMMO_MGM2");
		m_pEnemyA.AddResearch("RES_RUS_SDI");
		m_pEnemyA.AddResearch("RES_RUS_SPECIAL_FILTER3");
		m_pEnemyA.AddResearch("RES_RUS_AMMO_ART2");
		m_pEnemyA.AddResearch("RES_RUS_AMMO_ROCKET1");
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyA.AddResearch("RES_RUS_AMMO_CHEMICAL1");
		}
		m_pEnemyA.AddResearch("RES_RUS_ROCKETCONTROL");
		m_pEnemyA.AddResearch("RES_RUS_ROMB");
		m_pEnemyA.AddResearch("RES_RUS_AIRCONTROL");
		m_pEnemyA.AddResearch("RES_RUS_SPECIAL_PTC");
		m_pEnemyA.AddResearch("RES_RUS_AMMO_ROCKET2");
		m_pEnemyA.AddResearch("RES_RUS_AMMO_MIM1");

		EnableAllResearchRUS( m_pEnemyB, false);
		m_pEnemyB.EnableResearch("RES_RUS_AMPHIBIA1", true);			// M1
		m_pEnemyB.EnableResearch("RES_RUS_ZSU", true);					// M2
		m_pEnemyB.EnableResearch("RES_RUS_ASSAULT", true);				// M2
		m_pEnemyB.EnableResearch("RES_RUS_PILLBOX", true);				// M3
		m_pEnemyB.EnableResearch("RES_RUS_TANK", true);					// M3
		m_pEnemyB.EnableResearch("RES_RUS_MIM", true);					// M3
		m_pEnemyB.EnableResearch("RES_RUS_HELICOPTER1", true);			// M3
		m_pEnemyB.EnableResearch("RES_RUS_AMMO_MG1", true);				// M4
		m_pEnemyB.EnableResearch("RES_RUS_AMMO_CANNON1", true);			// M4
		m_pEnemyB.EnableResearch("RES_RUS_SAPER", true);				// M4
		m_pEnemyB.EnableResearch("RES_RUS_BM21", true);					// M4
		m_pEnemyB.EnableResearch("RES_RUS_HELICOPTER2", true);			// M4
		m_pEnemyB.EnableResearch("RES_RUS_AMMO_MG2", true);				// M5
		m_pEnemyB.EnableResearch("RES_RUS_ART", true);					// M5
		m_pEnemyB.EnableResearch("RES_RUS_AMMO_MGM1", true);			// M5
		m_pEnemyB.EnableResearch("RES_RUS_SPECIAL_FILTER2", true);		// M5
		m_pEnemyB.EnableResearch("RES_RUS_AMMO_CANNON2", true);			// M6
		m_pEnemyB.EnableResearch("RES_RUS_AMMO_ART1", true);			// M6
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyB.EnableResearch("RES_RUS_CHEMICAL1", true);		// M6
		}
		m_pEnemyB.EnableResearch("RES_RUS_AMMO_MGM2", true);			// M6
		m_pEnemyB.EnableResearch("RES_RUS_SDI", true);					// M6
		m_pEnemyB.EnableResearch("RES_RUS_SPECIAL_FILTER3", true);		// M6
		m_pEnemyB.EnableResearch("RES_RUS_AMMO_ART2", true);			// M7
		m_pEnemyB.EnableResearch("RES_RUS_AMMO_ROCKET1", true);			// M7
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyB.EnableResearch("RES_RUS_AMMO_CHEMICAL1", true);	// M7
		}
		m_pEnemyB.EnableResearch("RES_RUS_ROCKETCONTROL", true);		// M7
		m_pEnemyB.EnableResearch("RES_RUS_ROMB", true);					// M7
		m_pEnemyB.EnableResearch("RES_RUS_AIRCONTROL", true);			// M7
		m_pEnemyB.EnableResearch("RES_RUS_SPECIAL_PTC", true);			// M7
		m_pEnemyB.EnableResearch("RES_RUS_AMMO_ROCKET2", true);			// M8
		m_pEnemyB.EnableResearch("RES_RUS_AMMO_MIM1", true);			// M8
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyB.EnableResearch("RES_RUS_AMMO_CHEMICAL2", true);
		}
//		m_pEnemyB.EnableResearch("RES_RUS_BOMBCONTROL", true);
		m_pEnemyB.EnableResearch("RES_RUS_SPECIAL_FLARE", true);

		m_pEnemyB.AddResearch("RES_RUS_AMPHIBIA1");
		m_pEnemyB.AddResearch("RES_RUS_ZSU");
		m_pEnemyB.AddResearch("RES_RUS_ASSAULT");
		m_pEnemyB.AddResearch("RES_RUS_PILLBOX");
		m_pEnemyB.AddResearch("RES_RUS_TANK");
		m_pEnemyB.AddResearch("RES_RUS_MIM");
		m_pEnemyB.AddResearch("RES_RUS_HELICOPTER1");
		m_pEnemyB.AddResearch("RES_RUS_AMMO_MG1");
		m_pEnemyB.AddResearch("RES_RUS_AMMO_CANNON1");
		m_pEnemyB.AddResearch("RES_RUS_SAPER");
		m_pEnemyB.AddResearch("RES_RUS_BM21");
		m_pEnemyB.AddResearch("RES_RUS_HELICOPTER2");
		m_pEnemyB.AddResearch("RES_RUS_AMMO_MG2");
		m_pEnemyB.AddResearch("RES_RUS_ART");
		m_pEnemyB.AddResearch("RES_RUS_AMMO_MGM1");
		m_pEnemyB.AddResearch("RES_RUS_SPECIAL_FILTER2");
		m_pEnemyB.AddResearch("RES_RUS_AMMO_CANNON2");
		m_pEnemyB.AddResearch("RES_RUS_AMMO_ART1");
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyB.AddResearch("RES_RUS_CHEMICAL1");
		}
		m_pEnemyB.AddResearch("RES_RUS_AMMO_MGM2");
		m_pEnemyB.AddResearch("RES_RUS_SDI");
		m_pEnemyB.AddResearch("RES_RUS_SPECIAL_FILTER3");
		m_pEnemyB.AddResearch("RES_RUS_AMMO_ART2");
		m_pEnemyB.AddResearch("RES_RUS_AMMO_ROCKET1");
		if ( GetDifficultyLevel() > 0 )
		{
			m_pEnemyB.AddResearch("RES_RUS_AMMO_CHEMICAL1");
		}
		m_pEnemyB.AddResearch("RES_RUS_ROCKETCONTROL");
		m_pEnemyB.AddResearch("RES_RUS_ROMB");
		m_pEnemyB.AddResearch("RES_RUS_AIRCONTROL");
		m_pEnemyB.AddResearch("RES_RUS_SPECIAL_PTC");
		m_pEnemyB.AddResearch("RES_RUS_AMMO_ROCKET2");
		m_pEnemyB.AddResearch("RES_RUS_AMMO_MIM1");

		AddUnitTemplatesRUS( m_pEnemyA );
		AddUnitTemplatesRUS( m_pEnemyB );

		m_bMissionFail = false;

		return BeforeStart, 1;
	}

	state BeforeStart
	{
		PlayTrack("Music\\Briefing.tws");

		return Start;
	}

	state Start
	{
		EnableGoal(goalHeroSurvive, true);
		EnableGoal(goalFindBase, true);
		AddBriefing("translateBriefingMissionUSA_9_General");
		PlayWave("Briefings\\USA_Briefing09.wav");

		m_pEnemyA.EnableAIFeatures2(ai2RebuildBaseOnly, true);
		m_pEnemyB.EnableAIFeatures2(ai2RebuildBaseOnly, true);

		GroupAttack(6, 9, m_uHero);
		GroupAttack(18, 25, m_uTargetUnit);

		return Attack1,400;
	}

	state Attack1
	{
		GroupAttack(11, 13, m_uHero);

		return Attack2,400;
	}

	state Attack2
	{
		GroupAttack(14, 17, m_uHero);

		return FindBase;
	}

	state FindBase
	{
		if ( m_pPlayer.IsPointLocated( m_pEnemyA.GetStartingPointX(), m_pEnemyA.GetStartingPointY() ) )
		{
			return FoundBase;
		}
		else
		{
			return FindBase;
		}
	}

	state FoundBase
	{
		SetGoalState(goalFindBase, goalAchieved);

		EnableGoal(goalCaptureWarheads, true);
		AddBriefing("translateBriefingMissionUSA_9_CaptureWarheads");

		m_bCapturedWarhead1 = false;
		m_bCapturedWarhead2 = false;
		m_bCapturedWarhead3 = false;

		return CaptureWarheads;
	}

	state CaptureWarheads
	{
		int nGx, nGy;

		if ( GetMissionTime() >= 25*60*20 )
		{
			m_pEnemyA.EnableResearch("RES_RUS_BOMBCONTROL", true);
			m_pEnemyA.AddResearch("RES_RUS_BOMBCONTROL");
			m_pEnemyB.EnableResearch("RES_RUS_BOMBCONTROL", true);
			m_pEnemyB.AddResearch("RES_RUS_BOMBCONTROL");
		}

		nGx = m_uHero.GetLocationX();
		nGy = m_uHero.GetLocationY();

		if ( !m_bCapturedWarhead1 && Distance(nGx, nGy, GetPointX(markerWarhead1), GetPointY(markerWarhead1)) <= 1 )
		{
			m_bCapturedWarhead1 = true;

			ClearArea	(65535, GetPointX(markerWarhead1), GetPointY(markerWarhead1), GetPointZ(markerWarhead1), 0);

			return CapturedWarheads;
		}

		if ( !m_bCapturedWarhead2 && Distance(nGx, nGy, GetPointX(markerWarhead2), GetPointY(markerWarhead2)) <= 1 )
		{
			m_bCapturedWarhead2 = true;

			ClearArea	(65535, GetPointX(markerWarhead2), GetPointY(markerWarhead2), GetPointZ(markerWarhead2), 0);
		}

		if ( !m_bCapturedWarhead3 && Distance(nGx, nGy, GetPointX(markerWarhead3), GetPointY(markerWarhead3)) <= 1 )
		{
			m_bCapturedWarhead3 = true;

			ClearArea	(65535, GetPointX(markerWarhead3), GetPointY(markerWarhead3), GetPointZ(markerWarhead3), 0);
		}

		return CaptureWarheads;
	}

	state CapturedWarheads
	{
		int nGx, nGy;

		SetGoalState(goalCaptureWarheads, goalAchieved);

		EnableGoal(goalKillTerrorist, true);
		AddBriefing("translateBriefingMissionUSA_9_CatchTerrorist");

		nGx = m_pTerroristUnits.GetStartingPointX();
		nGy = m_pTerroristUnits.GetStartingPointY();

		ClearArea	(65535, nGx, nGy, 0, 0);

		m_uTerrorist = m_pTerroristUnits.CreateUnit(nGx, nGy, 0, null, "RUS_CIVIL_JEEP1", null, null, null, null);

		nGx = GetPointX(markerTerroristDestination);
		nGy = GetPointY(markerTerroristDestination);

		m_uTerrorist.CommandMove(nGx, nGy, 0);
		m_uBoat.CommandMove(nGx, nGy, 0);

		return KillTerrorist;
	}

	state KillTerrorist
	{
		if ( ! m_uTerrorist.IsLive() || ! m_uBoat.IsLive() )
		{
			return KilledTerrorist;
		}

		if ( ! m_uTerrorist.IsMoving() )
		{
			return TerroristEscaped;
		}

		return KillTerrorist;
	}

	state KilledTerrorist
	{
		SetGoalState(goalKillTerrorist, goalAchieved);
		SetGoalState(goalHeroSurvive, goalAchieved);

		AddBriefing("translateBriefingMissionUSA_9_MissionComplete");

		EnableEndMissionButton(true, true);

		return MissionComplete;
	}

	state TerroristEscaped
	{
		SetGoalState(goalKillTerrorist, goalFailed);

		m_bMissionFail = true;

		AddBriefing("translateBriefingMissionUSA_9_MissionFail");

		EndMission(false);

		return MissionComplete;
	}

	state MissionComplete
	{
		return MissionComplete;
	}

	event UnitDestroyed(unit uUnit)
	{
		if ( m_bMissionFail )
		{
			return;
		}

		m_bCheckNumberOfUnits = true;

		if ( uUnit == m_uHero )
		{
			SetGoalState(goalHeroSurvive, goalFailed);

			if ( state == CaptureWarheads )
			{
				SetGoalState(goalCaptureWarheads, goalFailed);
			}

			m_bMissionFail = true;

			AddBriefing("translateBriefingMissionUSA_9_MissionFail");

			EnableEndMissionButton(true, false);

			state MissionComplete;
		}
	}

	event BuildingDestroyed(unit uBuilding)
	{
		m_bCheckNumberOfBuildings = true;
	}

	event BuildingCreated(unit uBuilding)
	{
		if ( uBuilding.GetIFF() == m_pPlayer.GetIFF() )
		{
			m_pEnemyA.EnableAI(true);
			m_pEnemyB.EnableAI(true);
		}
	}

	event EndMission()
	{
		m_pPlayer.SaveUnit(0, m_uHero);
	}

	event SetupInterface()
	{
	}
}
