mission "translateGameTypeTechWar"
{
	
    consts
    {
        raceUSA=1;
        raceRUS=2;
        raceIRQ=3;
    }
    
    int nTimeLimit;
	int nBuildingType;
    int nLeft;
    int nRight;
    int nTop;
    int nBottom;
    int nWidth;
    int nHight;
    int nWeatherPosX;
    int nWeatherPosY;
	int nRand4;
	int nRand5;
	int nRand6;
	int nRand31;
	int nRand32;
	int nRandX;
	int nRandY;
	int isWeather;
	int nWeatherRange;
	int mMapType;
	int mTime;
	int mAllowDangWeather;

	enum comboWeatherConditions
    {
        "translateGameMenuWeatherConditionsOff",
        "translateGameMenuWeatherConditionsOn",
			multi:
        "translateGameMenuWeatherConditions"
    }

	enum comboAlliedVictory
    {
        "translateGameMenuAlliedVictoryNo",
        "translateGameMenuAlliedVictoryYes",
			multi:
        "translateGameMenuAlliedVictory"
    }

    enum comboUnitsLimit
    {
//        "translateGameMenuUnitsLimitNoLimit",
        "translateScript20000",
        "translateScript30000",
        "translateScript50000",
		"translateScript75000",
			multi:
        "translateGameMenuUnitsLimit"
    }
    enum comboWinCondition
    {
        "translateScriptDestroyAllStructures",
		"translateScriptDestroyMainStructures",
        "translateScriptDestroyPowerPlants",
		"translateScriptDestroyFactories",
			multi:
        "translateScriptVictoryCondition"
    }
	enum comboStartingUnits
    {
        "translateGameMenuStartingUnitsDefault",
        "translateGameMenuStartingUnitsBuilderOnly",
multi:
        "translateGameMenuStartingUnits"
    }
/////////////////////////////////////////////////////////////
    function int CalcRandVals()
	{
		nRand4 = Rand(4) + 1;//1.....4
		nRand5 = Rand(5) - 2;//-2....2
		nRand6 = Rand(6);
		nRand31 = Rand(31);//
		nRand32 = Rand(32);//
		nRandX = Rand(nWidth);
		nRandY = Rand(nHight);
	}
///////////////////////////////////////////////////////////////
    function int MakeBytesWeather()
    {
		int range;
		range = nWeatherRange * 10 + Rand(30);

		if (nRand5 == 0)
		{
			//SetConsoleText(0,"translateWeatherPureSun");
			return false;
		}
		if( nRand5 == 2 || nRand5 == -2)//wind....
			Wind(300, 2400, 300 , Rand(10) , nRand4 * 64);
		

		if(mMapType==1)//spring
		{
			if(nRand5 == 2 )
			{
				if(!mAllowDangWeather)
					nRand5 = 1;
				else
				{
					Storm(nWeatherPosX, nWeatherPosY, range ,100 * nRand4, 400 * nRand4, 100 * nRand4, nRand6, 0, 0);
					//SetConsoleText(0,"translateWeatherStormAt", nWeatherPosX, nWeatherPosY);
					return true;
				}
			}
			if(nRand5 < 0)
			{
				Snow(nWeatherPosX, nWeatherPosY, range ,100 * nRand4, 400 * nRand4, 100 * nRand4, nRand6);
				//SetConsoleText(0,"translateWeatherSnowAt", nWeatherPosX, nWeatherPosY);
				return true;
			}
			if(nRand5 == 1)
			{
				Rain(nWeatherPosX, nWeatherPosY, range ,100 * nRand4, 400 * nRand4, 100 * nRand4, nRand6);
				//SetConsoleText(0,"translateWeatherRainAt", nWeatherPosX, nWeatherPosY);
				return true;
			}
		}
		if(mMapType==2)//summer
		{
			if(nRand5 > 0 )
			{
				if(!mAllowDangWeather)
					nRand5 = -1;
				else
				{
					Storm(nWeatherPosX, nWeatherPosY, range ,100 * nRand4, 400 * nRand4, 100 * nRand4, nRand6, 0, 0);
					//SetConsoleText(0,"translateWeatherStormAt", nWeatherPosX, nWeatherPosY);
					return true;
				}
			}
		}
		if(mMapType==3)//winter
		{
			if(nRand5 > 0)
			{
				if(!mAllowDangWeather)
					nRand5 = -1;
				else
				{
					Storm(nWeatherPosX, nWeatherPosY, range ,100 * nRand4, 400 * nRand4, 100 * nRand4, nRand6, 0, 0);
					//SetConsoleText(0,"translateWeatherStormAt", nWeatherPosX, nWeatherPosY);
					return true;
				}
			}
			if(nRand5 < 0)
			{
				Snow(nWeatherPosX, nWeatherPosY, range ,100 * nRand4, 400 * nRand4, 100 * nRand4, nRand6);
				//SetConsoleText(0,"translateWeatherSnowAt", nWeatherPosX, nWeatherPosY);
				return true;
			}
		}
		return true;

	}
//////////////////////////////////////////////////////////
    
	function int CreateDefaultUnit(player rPlayer, int nX, int nY, int nZ)
    {
        if (rPlayer.GetRace() == raceUSA)
        {
            rPlayer.CreateUnitEx(nX,nY,nZ,null,"USA_JEEP2","USA_JEEP_CHAINGUN",null,null,null);
        }
        else if (rPlayer.GetRace() == raceRUS)
        {
            rPlayer.CreateUnitEx(nX,nY,nZ,null,"RUS_JEEP","RUS_JEEP_CHAINGUN",null,null,null);
        }
        else if (rPlayer.GetRace() == raceIRQ)
        {
            rPlayer.CreateUnitEx(nX,nY,nZ,null,"IRQ_JEEP","IRQ_JEEP_CHAINGUN",null,null,null);
        }
        return true;
    }
	function int FillResearchesList(player rPlayer)
    {
		if (rPlayer.GetRace() == raceUSA)
        {
			rPlayer.AddResearch("RES_USA_AMMO_MG1");
			rPlayer.AddResearch("RES_USA_AMMO_MG2");
			rPlayer.AddResearch("RES_USA_MORTAR");
			rPlayer.AddResearch("RES_USA_ART");
			rPlayer.AddResearch("RES_USA_LECLERC");
			rPlayer.AddResearch("RES_USA_AMMO_GRENADE1");
			rPlayer.AddResearch("RES_USA_AMMO_GRENADE2");
			rPlayer.AddResearch("RES_USA_AMPHIBIA1");
			rPlayer.AddResearch("RES_USA_TANK1");
			rPlayer.AddResearch("RES_USA_SAPER");
			rPlayer.AddResearch("RES_USA_AMMO_CANNON1");
			rPlayer.AddResearch("RES_USA_AMMO_CANNON2");
			rPlayer.AddResearch("RES_USA_SPY");
			rPlayer.AddResearch("RES_USA_HELICOPTER1");
			rPlayer.AddResearch("RES_USA_HELICOPTER2");
			rPlayer.AddResearch("RES_USA_COMANCHE");
			rPlayer.AddResearch("RES_USA_AIRCONTROL");
			rPlayer.AddResearch("RES_USA_BOMBCONTROL");
			rPlayer.AddResearch("RES_USA_ROCKETCONTROL");
			rPlayer.AddResearch("RES_USA_MIM");
			rPlayer.AddResearch("RES_USA_AMMO_MIM1");
			rPlayer.AddResearch("RES_USA_AMMO_MIM2");
			rPlayer.AddResearch("RES_USA_MGM");
			rPlayer.AddResearch("RES_USA_AMMO_MGM1");
			rPlayer.AddResearch("RES_USA_AMMO_MGM2");
			rPlayer.AddResearch("RES_USA_SDI");
			rPlayer.AddResearch("RES_USA_SPECIAL_PTC");
			rPlayer.AddResearch("RES_USA_SPECIAL_FLARE");
			rPlayer.AddResearch("RES_USA_JEEP_JAMMER");
			rPlayer.AddResearch("RES_USA_SPECIAL_FILTER2");
			rPlayer.AddResearch("RES_USA_SPECIAL_FILTER3");
		}
		else if (rPlayer.GetRace() == raceRUS)
        {
			rPlayer.AddResearch("RES_RUS_ZSU");
			rPlayer.AddResearch("RES_RUS_AMMO_MG1");
			rPlayer.AddResearch("RES_RUS_AMMO_MG2");
			rPlayer.AddResearch("RES_RUS_PILLBOX");
			rPlayer.AddResearch("RES_RUS_AMMO_CANNON1");
			rPlayer.AddResearch("RES_RUS_AMMO_CANNON2");
			rPlayer.AddResearch("RES_RUS_AMPHIBIA1");
			rPlayer.AddResearch("RES_RUS_TANK");
			rPlayer.AddResearch("RES_RUS_SAPER");
			rPlayer.AddResearch("RES_RUS_ART");
			rPlayer.AddResearch("RES_RUS_AMMO_ART1");
			rPlayer.AddResearch("RES_RUS_AMMO_ART2");
			rPlayer.AddResearch("RES_RUS_BM21");
			rPlayer.AddResearch("RES_RUS_AMMO_ROCKET1");
			rPlayer.AddResearch("RES_RUS_AMMO_ROCKET2");
			rPlayer.AddResearch("RES_RUS_CHEMICAL1");
			rPlayer.AddResearch("RES_RUS_AMMO_CHEMICAL1");
			rPlayer.AddResearch("RES_RUS_AMMO_CHEMICAL2");
			rPlayer.AddResearch("RES_RUS_ROCKETCONTROL");
			rPlayer.AddResearch("RES_RUS_MIM");
			rPlayer.AddResearch("RES_RUS_ROMB");
			rPlayer.AddResearch("RES_RUS_AMMO_MIM1");
			rPlayer.AddResearch("RES_RUS_AMMO_MIM2");
			rPlayer.AddResearch("RES_RUS_ASSAULT");
			rPlayer.AddResearch("RES_RUS_HELICOPTER1");
			rPlayer.AddResearch("RES_RUS_HELICOPTER2");
			rPlayer.AddResearch("RES_RUS_AIRCONTROL");
			rPlayer.AddResearch("RES_RUS_BOMBCONTROL");
			rPlayer.AddResearch("RES_RUS_AMMO_MGM1");
			rPlayer.AddResearch("RES_RUS_AMMO_MGM2");
			rPlayer.AddResearch("RES_RUS_SDI");
			rPlayer.AddResearch("RES_RUS_SPECIAL_PTC");
			rPlayer.AddResearch("RES_RUS_SPECIAL_FLARE");
			rPlayer.AddResearch("RES_RUS_SPYCENTER");
			rPlayer.AddResearch("RES_RUS_SPECIAL_FILTER2");
			rPlayer.AddResearch("RES_RUS_SPECIAL_FILTER3");
		}
        else if (rPlayer.GetRace() == raceIRQ)
        {
			rPlayer.AddResearch("RES_IRQ_AMMO_MG1");
			rPlayer.AddResearch("RES_IRQ_AMMO_MG2");
			rPlayer.AddResearch("RES_IRQ_PILLBOX");
			rPlayer.AddResearch("RES_IRQ_AMMO_CANNON1");
			rPlayer.AddResearch("RES_IRQ_AMMO_CANNON2");
			rPlayer.AddResearch("RES_IRQ_TANK1");
			rPlayer.AddResearch("RES_IRQ_TANK2");
			rPlayer.AddResearch("RES_IRQ_BIGART");
			rPlayer.AddResearch("RES_IRQ_SAPER");
			rPlayer.AddResearch("RES_IRQ_RART");
			rPlayer.AddResearch("RES_IRQ_AMMO_ROCKET1");
			rPlayer.AddResearch("RES_IRQ_AMMO_ROCKET2");
			rPlayer.AddResearch("RES_IRQ_HRART");
			rPlayer.AddResearch("RES_IRQ_AMMO_HROCKET1");
			rPlayer.AddResearch("RES_IRQ_AMMO_HROCKET2");
			rPlayer.AddResearch("RES_IRQ_SCUD");
			rPlayer.AddResearch("RES_IRQ_AMMO_CHEMICAL1");
			rPlayer.AddResearch("RES_IRQ_AMMO_CHEMICAL2");
			rPlayer.AddResearch("RES_IRQ_MIM");
			rPlayer.AddResearch("RES_IRQ_AMMO_MIM1");
			rPlayer.AddResearch("RES_IRQ_AMMO_MIM2");
			rPlayer.AddResearch("RES_IRQ_HELICOPTER1");
			rPlayer.AddResearch("RES_IRQ_SPYFLIGHTCENTER");
			rPlayer.AddResearch("RES_IRQ_SPYCENTER");
			rPlayer.AddResearch("RES_IRQ_MGM");
			rPlayer.AddResearch("RES_IRQ_JEEP_MGM");
			rPlayer.AddResearch("RES_IRQ_AMMO_MGM1");
			rPlayer.AddResearch("RES_IRQ_AMMO_MGM2");
			rPlayer.AddResearch("RES_IRQ_EXPLODER");
			rPlayer.AddResearch("RES_IRQ_EXPLODER_BIG");
			rPlayer.AddResearch("RES_IRQ_SDI");
			rPlayer.AddResearch("RES_IRQ_SPECIAL_PTC");
			rPlayer.AddResearch("RES_IRQ_SPECIAL_FILTER2");
			rPlayer.AddResearch("RES_IRQ_SPECIAL_FILTER3");
		}
	}
	function int FillTemplateList(player rPlayer)
    {
		if (rPlayer.GetRace() == raceUSA)
        {
			rPlayer.AddObjectTemplate(null,null,-1,"USA_COBRA","USA_COBRA_GUN",null,null,null);
			rPlayer.AddObjectTemplate(null,null,-1,"USA_COBRA","USA_HELICOPTER_MGR1",null,null,null);
			rPlayer.AddObjectTemplate(null,null,-1,"USA_COBRA","USA_HELICOPTER_MGM1",null,null,null);
			rPlayer.AddObjectTemplate(null,null,-1,"USA_APACHE","USA_HELICOPTER_MGM1","USA_HELICOPTER_MIM2","USA_HELICOPTER_SPECIAL_FLARE",null,null,null,null,null);
			rPlayer.AddObjectTemplate(null,null,-1,"USA_APACHE","USA_HELICOPTER_MGM1","USA_HELICOPTER_MIM2","USA_HELICOPTER_SPECIAL_PTC",null,null,null,null,null);
			rPlayer.AddObjectTemplate(null,null,-1,"USA_APACHE","USA_HELICOPTER_MGR1","USA_HELICOPTER_MGR2","USA_HELICOPTER_SPECIAL_FLARE",null,null,null,null,null);
			rPlayer.AddObjectTemplate(null,null,-1,"USA_APACHE","USA_HELICOPTER_MGR1","USA_HELICOPTER_MGR2","USA_HELICOPTER_SPECIAL_PTC",null,null,null,null,null);
			rPlayer.AddObjectTemplate(null,null,-1,"USA_COMANCHE","USA_HELICOPTER_MGM1",null,null,null,null,null,null,null);
			rPlayer.AddObjectTemplate(null,null,-1,"USA_COMANCHE","USA_HELICOPTER_MGR1",null,null,null,null,null,null,null);
			
			rPlayer.AddObjectTemplate(null,null,2,"USA_SAPER",null,null,null,null);
			rPlayer.AddObjectTemplate(null,null,2,"USA_ART","USA_ART_CANNON",null,null,null);

			rPlayer.AddObjectTemplate(null,null,2,"USA_TANK","USA_TANK_CANNON",null,null,null);
			rPlayer.AddObjectTemplate(null,null,2,"USA_TANK","USA_TANK_CANNON",null,"USA_SPECIAL_FLARE",null);
			rPlayer.AddObjectTemplate(null,null,2,"USA_TANK","USA_TANK_CANNON",null,"USA_SPECIAL_PTC",null);

			rPlayer.AddObjectTemplate(null,null,2,"USA_LECLERC","USA_LECLERC_CANNON",null,"USA_LECLERC_SPECIAL_FLARE",null);
			rPlayer.AddObjectTemplate(null,null,2,"USA_LECLERC","USA_LECLERC_CANNON",null,"USA_SPECIAL_PTC",null);

			rPlayer.AddObjectTemplate(null,null,2,"USA_AMPHIBIA","USA_AMPHIBIA_CANNON",null,"USA_AMPHIBIA_CHAINGUN",null);
			rPlayer.AddObjectTemplate(null,null,2,"USA_AMPHIBIA","USA_AMPHIBIA_CANNON",null,"USA_AMPHIBIA_MIM",null);
			rPlayer.AddObjectTemplate(null,null,2,"USA_AMPHIBIA","USA_AMPHIBIA_CANNON",null,"USA_SPECIAL_PTC",null);

			rPlayer.AddObjectTemplate(null,null,-1,"USA_JEEP2","USA_JEEP_CHAINGUN",null,null,null);
			rPlayer.AddObjectTemplate(null,null,-1,"USA_JEEP1","USA_JEEP_MIM",null,null,null);
			rPlayer.AddObjectTemplate(null,null,-1,"USA_JEEP1","USA_JEEP_MORTAR",null,null,null);
			
			rPlayer.AddObjectTemplate(null,null,-1,"USA_SPY",null,null,null,null);
			rPlayer.AddObjectTemplate(null,null,-1,"USA_TRANSPORTER","USA_TRANSPORTER_Hook",null,null,null);
			rPlayer.AddObjectTemplate(null,null,-1,"USA_SUPPLIER",null,null,null,null);
			rPlayer.AddObjectTemplate(null,null,-1,"USA_JEEP1","USA_JEEP_GTC",null,null,null);
			rPlayer.AddObjectTemplate(null,null,-1,"USA_JEEP2","USA_JEEP_JAMMER",null,null,null);
			rPlayer.AddObjectTemplate(null,null,2,"USA_ASSAULT","USA_ASSAULT_ARM",null,null,null);
			rPlayer.AddObjectTemplate(null,null,2,"USA_REPAIRER","USA_REPAIRER_ARM",null,null,null);
			rPlayer.AddObjectTemplate(null,null,2,"USA_BUILDER",null,null,null,null);
				
        }
        else if (rPlayer.GetRace() == raceRUS)
        {
			rPlayer.AddObjectTemplate(null,null,-1,"RUS_HELICOPTER1","RUS_HELICOPTER_MG1",null,null,null);
			rPlayer.AddObjectTemplate(null,null,-1,"RUS_HELICOPTER1","RUS_HELICOPTER_MGR1",null,null,null);
			rPlayer.AddObjectTemplate(null,null,-1,"RUS_HELICOPTER2","RUS_HELICOPTER_MGM1","RUS_HELICOPTER_MG2","RUS_HELICOPTER_SPECIAL_FLARE",null,null,null,null,null);
			rPlayer.AddObjectTemplate(null,null,-1,"RUS_HELICOPTER2","RUS_HELICOPTER_MGM1","RUS_HELICOPTER_MG2","RUS_HELICOPTER_SPECIAL_PTC",null,null,null,null,null);
			
			rPlayer.AddObjectTemplate(null,null,-1,"RUS_HELICOPTER2","RUS_HELICOPTER_MGR1","RUS_HELICOPTER_MGR2","RUS_HELICOPTER_SPECIAL_FLARE",null,null,null,null,null);
			rPlayer.AddObjectTemplate(null,null,-1,"RUS_HELICOPTER2","RUS_HELICOPTER_MGR1","RUS_HELICOPTER_MGR2","RUS_HELICOPTER_SPECIAL_PTC",null,null,null,null,null);
			

			rPlayer.AddObjectTemplate(null,null,2,"RUS_TANK","RUS_TANK_CANNON",null,null,null);
			rPlayer.AddObjectTemplate(null,null,2,"RUS_TANK","RUS_TANK_CANNON",null,"RUS_SPECIAL_PTC",null);
			rPlayer.AddObjectTemplate(null,null,-1,"RUS_JEEP","RUS_JEEP_CHAINGUN",null,null,null);
			rPlayer.AddObjectTemplate(null,null,2,"RUS_AMPHIBIA","RUS_AMPHIBIA_CANNON",null,"RUS_AMPHIBIA_CHAINGUN",null);
			rPlayer.AddObjectTemplate(null,null,2,"RUS_AMPHIBIA","RUS_AMPHIBIA_CANNON",null,"RUS_MALUTKA_LAUNCHER",null);
			
			rPlayer.AddObjectTemplate(null,null,2,"RUS_ZSU","RUS_ZSU_GUN",null,null,null);
			rPlayer.AddObjectTemplate(null,null,2,"RUS_ROMB","RUS_ROMB_LAUNCHER",null,null,null);
			rPlayer.AddObjectTemplate(null,null,2,"RUS_BM21","RUS_BM21_LAUNCHER",null,null,null);
			rPlayer.AddObjectTemplate(null,null,2,"RUS_BM21","RUS_BM21_LAUNCHER_C",null,null,null);

			rPlayer.AddObjectTemplate(null,null,2,"RUS_SAPER",null,null,null,null);
			rPlayer.AddObjectTemplate(null,null,2,"RUS_ART","RUS_ART_CANNON",null,null,null);
			rPlayer.AddObjectTemplate(null,null,2,"RUS_SCUD","RUS_SCUD_LAUNCHER",null,null,null);

			rPlayer.AddObjectTemplate(null,null,-1,"RUS_TRANSPORTER","RUS_TRANSPORTER_Hook",null,null,null);
			rPlayer.AddObjectTemplate(null,null,-1,"RUS_SUPPLIER",null,null,null,null);
			rPlayer.AddObjectTemplate(null,null,2,"RUS_ASSAULT","RUS_ASSAULT_ARM",null,null,null);
			rPlayer.AddObjectTemplate(null,null,2,"RUS_BUILDER",null,null,null,null);
		}
        else if (rPlayer.GetRace() == raceIRQ)
        {
			rPlayer.AddObjectTemplate(null,null,-1,"IRQ_HELICOPTER","IRQ_HELICOPTER_GUN",null,null,null);
			rPlayer.AddObjectTemplate(null,null,-1,"IRQ_HELICOPTER","IRQ_HELICOPTER_MIM",null,null,null);
			rPlayer.AddObjectTemplate(null,null,-1,"IRQ_HELICOPTER","IRQ_HELICOPTER_MGM",null,null,null);

			rPlayer.AddObjectTemplate(null,null,-1,"IRQ_JEEP","IRQ_JEEP_CHAINGUN",null,null,null);
			rPlayer.AddObjectTemplate(null,null,-1,"IRQ_JEEP","IRQ_JEEP_MGM",null,null,null);
			rPlayer.AddObjectTemplate(null,null,-1,"IRQ_ROLAND","IRQ_ROLAND_MIM",null,null,null);
			
			rPlayer.AddObjectTemplate(null,null,2,"IRQ_EXPLODER",null,null,null,null);
			rPlayer.AddObjectTemplate(null,null,2,"IRQ_EXPLODER_BIG",null,null,null,null);

			rPlayer.AddObjectTemplate(null,null,2,"IRQ_RART","IRQ_RART_LAUNCHER",null,null,null);
			rPlayer.AddObjectTemplate(null,null,2,"IRQ_HRART","IRQ_HRART_LAUNCHER",null,null,null);
			rPlayer.AddObjectTemplate(null,null,2,"IRQ_TANK1","IRQ_TANK1_CANNON",null,"IRQ_TANK1_CHAINGUN",null);
			rPlayer.AddObjectTemplate(null,null,2,"IRQ_TANK2","IRQ_TANK2_CANNON",null,null,null);
			rPlayer.AddObjectTemplate(null,null,2,"IRQ_TANK2","IRQ_TANK2_CANNON",null,"IRQ_SPECIAL_PTC",null);
			rPlayer.AddObjectTemplate(null,null,2,"IRQ_SCUD","IRQ_SCUD_LAUNCHER",null,null,null);

			rPlayer.AddObjectTemplate(null,null,2,"IRQ_SAPER",null,null,null,null);
			rPlayer.AddObjectTemplate(null,null,-1,"IRQ_TANK2_FAKE",null,null,null,null);
						
			rPlayer.AddObjectTemplate(null,null,-1,"IRQ_TRANSPORTER","IRQ_TRANSPORTER_Hook",null,null,null);
			rPlayer.AddObjectTemplate(null,null,-1,"IRQ_SUPPLIER",null,null,null,null);
			rPlayer.AddObjectTemplate(null,null,2,"IRQ_ASSAULT","IRQ_ASSAULT_ARM",null,null,null);
			rPlayer.AddObjectTemplate(null,null,2,"IRQ_REPAIRER","IRQ_REPAIRER_ARM",null,null,null);		
			rPlayer.AddObjectTemplate(null,null,2,"IRQ_BUILDER",null,null,null,null);
        }
        return true;
    }
    state Initialize;
    state Nothing;
    
    state Initialize
    {
        player rPlayer;
        int i;
		int j;
        int nStartingMoney;
        
        nStartingMoney = 25000;
                
		ResourcesPerContainer(2);

		i = GetTerrainType();
		if(i==0)
			mMapType = 3;
		if(i==1 || i==2)
			mMapType = 1;
		if(i==3 || i==4)
			mMapType = 2;
		        
		mAllowDangWeather = false;
		nLeft = GetLeft();
		nRight = GetRight();
		nTop = GetTop();
		nBottom = GetBottom();
		nWidth = nRight - nLeft;
		nHight = nBottom - nTop;

		if(nHight < 64)
			nWeatherRange = 0;
		if(nHight > 63 && nHight < 128) 
			nWeatherRange = 1;
		if(nHight > 127 && nHight < 192) 
			nWeatherRange = 2;
		if(nHight > 191 && nHight < 257) 
			nWeatherRange = 3;

        for(i=0;i<15;i=i+1)
        {
            rPlayer=GetPlayer(i);
            if(rPlayer!=null) 
            {
				for(j=0;j<15;j=j+1)
				{
					if(i!=j)
						rPlayer.EnableCommand(commandBuildingSpyPlayer0 + j, true);
				}
				rPlayer.SetMaxDistance(20);
				if(comboAlliedVictory)
					rPlayer.EnableAIFeatures2(ai2BNSendResult,false);//nie wysylac rezultatow do EARTH NETu       

				rPlayer.SetScriptData(0,0);
				rPlayer.SetObjectTemplateCountLimit(1,"RUS_SCUD","RUS_SCUD_LAUNCHER");
				rPlayer.SetObjectTemplateCountLimit(3,"IRQ_SCUD","IRQ_SCUD_LAUNCHER");
                rPlayer.EnableCivilBuildingsLimit(false);
				/*if(comboUnitsLimit==0) 
                {
                    rPlayer.EnableMilitaryUnitsLimit(false);
                    rPlayer.EnableCivilUnitsLimit(false);
                    rPlayer.EnableMilitaryBuildingsLimit(false);
                    //rPlayer.EnableCivilBuildingsLimit(false);
                }*/
                if(comboUnitsLimit==0) 
                {
                    rPlayer.SetMilitaryUnitsLimit(20000);
                    rPlayer.SetCivilUnitsLimit(20000);
                    rPlayer.SetMilitaryBuildingsLimit(20000);
                    //rPlayer.SetCivilBuildingsLimit(20000);
                }
                if(comboUnitsLimit==1) 
                {
                    rPlayer.SetMilitaryUnitsLimit(30000);
                    rPlayer.SetCivilUnitsLimit(30000);
                    rPlayer.SetMilitaryBuildingsLimit(30000);
                    //rPlayer.SetCivilBuildingsLimit(30000);
                }
                if(comboUnitsLimit==2) 
                {
                    rPlayer.SetMilitaryUnitsLimit(50000);
                    rPlayer.SetCivilUnitsLimit(50000);
                    rPlayer.SetMilitaryBuildingsLimit(50000);
                    //rPlayer.SetCivilBuildingsLimit(50000);
                }
                if(comboUnitsLimit==3) 
                {
                    rPlayer.SetMilitaryUnitsLimit(75000);
                    rPlayer.SetCivilUnitsLimit(50000);
                    rPlayer.SetMilitaryBuildingsLimit(50000);
                    //rPlayer.SetCivilBuildingsLimit(50000);
                }
                
                
                rPlayer.SetMoney(nStartingMoney);
				
                rPlayer.LookAt(rPlayer.GetStartingPointX(),rPlayer.GetStartingPointY(),6,0,20,0);
				FillResearchesList(rPlayer);
                if (!rPlayer.GetNumberOfUnits() && !rPlayer.GetNumberOfBuildings())
                    CreateDefaultUnit(rPlayer,rPlayer.GetStartingPointX(),rPlayer.GetStartingPointY(),0);
				FillTemplateList(rPlayer);
				
            }
        }
        
		SetTimer(0,100);
		SetTimer(1,400);
        SetTimer(2,1200);
		SetTimer(3,300);
		SetTimer(4,1200);// 1 min in the beginning 
		SetTimer(7,12000);// 10 min in the beginning 
		
        AddConsoleTextDisplay(0,0,100,SS_CENTER);
		if(comboWinCondition==0)
			RegisterGoal(0, "translateScriptDestroyAllStructures");
		if(comboWinCondition==1)
			RegisterGoal(0, "translateScriptDestroyMainStructures");
        if(comboWinCondition==2)
			RegisterGoal(0, "translateScriptDestroyPowerPlants");
		if(comboWinCondition==3)
			RegisterGoal(0, "translateScriptDestroyFactories");
		EnableGoal(0, true);
		AddBriefing("translateGameTypeTechWarDescription");
        return Nothing;
    }
    
    state Nothing
    {
        return Nothing;
    }
    
    event RemoveResources()
    {
			false;
    }
    
    event RemoveUnits()
    {
        if(comboStartingUnits)
            true;
        else
            false;
    }
    
	event SetupInterface()
	{
 		int setupOptions;
		if(comboAlliedVictory) 
			setupOptions=0; 
		else 
			setupOptions=lockAllianceDialog | lockGiveMoneyDialog | lockGiveUnitsDialog |
			lockToolbarAlliance | lockToolbarGiveMoney;

        EnableGameFeature(
			setupOptions|
	        lockResearchDialog |
//	        lockConstructionDialog |
	        lockUpgradeWeaponDialog |
//            lockAllianceDialog |
//            lockGiveMoneyDialog |
//            lockGiveUnitsDialog |
//            lockShowToolbar |
//            lockToolbarMap |
//            lockToolbarPanel |
            lockToolbarNextWorld |
            lockToolbarLevelName |
//			lockToolbarObjectives|
//            lockToolbarTunnels |
            lockToolbarResearching |
//            lockToolbarConstruction |
//            lockToolbarMenu |
//            lockToolbarMoney |
            lockToolbarEnergy |
//            lockDisplayToolbarLevelName |
//            lockDisplayToolbarMoney |
            lockDisplayToolbarEnergy |
            0,
            true);
	}
        
    event Timer0()
    {
        int iAlivePlayers;
        int i;
        int j;
        int iCountBuilding;
        int bActiveEnemies;
        int bOneHasBeenDestroyed;   
        player rPlayer;
        player rPlayer2;
        player rLastPlayer;
     
				

        rLastPlayer=null;
        iAlivePlayers=0;
        bOneHasBeenDestroyed=false;
        for(i=0;i<15;i=i+1)
        {
            rPlayer = GetPlayer(i);
            if(rPlayer!=null)
			{
				if(rPlayer.IsAlive()) 
				{
					if(comboWinCondition==0)
						iCountBuilding = rPlayer.GetNumberOfBuildings();
		
					if(comboWinCondition==1)//main structures
					{
						iCountBuilding = rPlayer.GetNumberOfBuildings(buildingPowerPlant)+
							rPlayer.GetNumberOfBuildings(buildingAirport)+
							rPlayer.GetNumberOfBuildings(buildingLandingZone)+
							rPlayer.GetNumberOfBuildings(buildingSupplyCenter)+
							rPlayer.GetNumberOfBuildings(buildingMine)+
							rPlayer.GetNumberOfBuildings(buildingBombingControl);
					}
					if(comboWinCondition==2)//power plants
						iCountBuilding = rPlayer.GetNumberOfBuildings(buildingPowerPlant);
					
					if(comboWinCondition==3)//factorys
					{
						iCountBuilding = 
							rPlayer.GetNumberOfBuildings(buildingAirport)+
							rPlayer.GetNumberOfBuildings(buildingLandingZone);
					}

					if(iCountBuilding) rPlayer.SetScriptData(0,1);
						
					if (iCountBuilding==0)
					{
						if(rPlayer.GetScriptData(0)==1)
						{
							rPlayer.Defeat();
							KillArea(rPlayer.GetIFF(),GetRight()/2,GetBottom()/2,0,256);
						}
						else
						{
							if(rPlayer.GetNumberOfUnits()==0) rPlayer.Defeat();
						}
					}
				}
				if(!rPlayer.IsAlive()) bOneHasBeenDestroyed=true;
			}
        }
        
        bActiveEnemies=false;
        for(i=0;i<15;i=i+1)
        {
            rPlayer = GetPlayer(i);
            if(rPlayer!=null && rPlayer.IsAlive()) 
            {
                for(j=i+1;j<15;j=j+1)
                {
                    rPlayer2 = GetPlayer(j);
                    if(rPlayer2!=null && rPlayer2.IsAlive() && (!(rPlayer.IsAlly(rPlayer2) && comboAlliedVictory))) 
                    {
                        bActiveEnemies=true;
                    }
                }
            }
        }
        if(bActiveEnemies) return;
        if(!bOneHasBeenDestroyed) return;
        

        for(i=0;i<15;i=i+1)
        {
            rPlayer = GetPlayer(i);
            if(rPlayer!=null && rPlayer.IsAlive()) 
            {
                rPlayer.Victory();
            }
        }
    }
    
	event Timer1()
    {
    	SetConsoleText(0,"");
	}

	event Timer2()
    {
        int i;
        player rPlayer;
        
		if(comboWinCondition==0)
			SetConsoleText(0,"translateScriptDestroyAllStructures");
		if(comboWinCondition==1)
			SetConsoleText(0,"translateScriptDestroyMainStructures");
        if(comboWinCondition==2)
			SetConsoleText(0,"translateScriptDestroyPowerPlants");
		if(comboWinCondition==3)
			SetConsoleText(0,"translateScriptDestroyFactories");
				
        /*for(i=0;i<15;i=i+1)
        {
            rPlayer=GetPlayer(i);
            if(rPlayer!=null && rPlayer.IsAlive()) 
            {
				if(rPlayer.GetMoney()<20000)
				{
					rPlayer.AddMoney(nCashRate);
				}
            }
        }*/
    }

	event Timer3()
    {
        int i;
        player rPlayer;
        
        for(i=0;i<15;i=i+1)
        {
            rPlayer=GetPlayer(i);
            if(rPlayer!=null) 
            {
				if(rPlayer.GetMaxDistance()<255)
					rPlayer.SetMaxDistance(rPlayer.GetMaxDistance()+1);
            }
        }
    }
    event Timer7()
    {
		mAllowDangWeather = true;
		SetTimer(7,0);// off

	}

    event Timer4()
    {    
		if(comboWeatherConditions)
		{
			CalcRandVals();
			if(!isWeather && nRand5)//make weather now
			{
				nWeatherPosX = nRandX;
				nWeatherPosY = nRandY;
				isWeather = MakeBytesWeather();
			}
			else
			{
				nWeatherPosX = nWeatherPosX + nRand5 * (nRand31 + 15);
				if(nWeatherPosX < nLeft) nWeatherPosX = nRight - nRand31 - 15;
				if(nWeatherPosX > nRight ) nWeatherPosX = nLeft + nRand31 + 15;
				nWeatherPosY = nWeatherPosY + nRand5 * (nRand32 + 15);
				if(nWeatherPosY < nTop) nWeatherPosY = nBottom - nRand32 - 15;
				if(nWeatherPosY > nBottom ) nWeatherPosY = nTop + nRand32 + 15;
				isWeather = MakeBytesWeather();
			}
			SetTimer(4, 600 * nRand4);
		}
    }

    command Initialize()
    {
		comboAlliedVictory=1;
        comboWinCondition=0;//destroy all structures
        comboUnitsLimit=1;
		comboStartingUnits=1;
    }
    
    command Uninitialize()
    {
        ResourcesPerContainer(8);
    }
    command Combo1(int nMode) button comboWinCondition
    {
        comboWinCondition = nMode;
    }

/*	command Combo2(int nMode) button comboResearchLimit
    {
        comboResearchLimit = nMode;
    }*/
    
    command Combo2(int nMode) button comboUnitsLimit
    {
        comboUnitsLimit = nMode;
    }

    command Combo3(int nMode) button comboAlliedVictory
    {
        comboAlliedVictory = nMode;
    }
    command Combo4(int nMode) button comboStartingUnits 
    {
        comboStartingUnits = nMode;
    }

	command Combo5(int nMode) button comboWeatherConditions
    {
        comboWeatherConditions = nMode;
    }

}

