civil "translateScriptNameAdvancedNonArmedVechicle"
{
    
    int  m_nStayGx;
    int  m_nStayGy;
    int  m_nStayLz;
    int  m_nSpecialGx; //Patrol point , escort
    int  m_nSpecialGy;
    int  m_nSpecialLz;
    int  m_nSpecialCounter;
    unit m_uSpecialUnit;
        
  
    enum lights
    {
        "[*] Lights AUTO",
        "[*] Lights ON",
        "[*] Lights OFF",
    multi:
        "[?] Lights"
    }
    
    enum retreatMode
    {
        "[*] No retreat",
        "[*] Ret: Hp 25%",
        "[*] Ret: Hp 50%",
        "[*] Ret: Attacked",
    multi:
        "[?] Retreat mode"
    }

    enum traceMode
    {
        "[*] Trace OFF",
        "[*] Trace ON",
    multi:
        "[?] Trace"
    }
//********************************************************
//********* F U N C T I O N S ****************************
//********************************************************
    
        
//-------------------------------------------------------               
    function int distance(int x1,int y1, int x2,int y2)
    {
            int a;
            int b;
            int c;
        
            a=x1-x2;
            if(a<0) a = -a;
            b=y1-y2;
            if(b<0) b = -b;

            if(a>b)
                c = (a+(b/2));
            else 
                c = (b+(a/2));
            return c;
    }

//------------------------------------------------------- 
    function int EndState()
    {
        NextCommand(1);
    }

//********************************************************
//************* S T A T E S ******************************
//********************************************************
    
    state Retreat;
    state Nothing;
    state StartMoving;
    state Moving;
    state Patrol;
    state Escort;
    state LooseEscort;
    
//------------------------------------------------------- 
    state Retreat
    {
        unit uTarget;
        if(!m_nSpecialCounter)
        {
          uTarget = FindClosestEnemy();
          m_nSpecialCounter = (m_nSpecialCounter+1)%16;
        }
        else
        {
            if(IsMoving())
                m_nSpecialCounter = (m_nSpecialCounter+1)%16;
            else
                m_nSpecialCounter = 0;
            if(traceMode)TraceD("R                                                 \n");
            return Retreat;
        }
        
        if(!uTarget)
        {
            if(IsMoving())
                CallStopMoving();
            if(traceMode)TraceD("R->N                                                 \n");
            return Nothing;
        }
        CallMoveToPoint(2*GetLocationX()-uTarget.GetLocationX(),2*GetLocationY() - uTarget.GetLocationY(),GetLocationZ());
        if(traceMode)TraceD("R u                                                \n");
        return Retreat;
    }
//------------------------------------------------------- 
    state Nothing
    {
        unit uAttacker;
        if(traceMode)TraceD("N                                                 \n");
    
        if (retreatMode == 3)//Retreat if attacked
        {
            uAttacker = GetAttacker();
            if(uAttacker)
            {
                if(uAttacker.IsLive())
                {
                    ClearAttacker();
                    return Retreat;
                }
                else
                {
                    ClearAttacker();
                }
            }
        }
        return Nothing;
    }
//--------------------------------------------------------------------------
  state StartMoving
  {
      return Moving, 20;
  }
//--------------------------------------------------------------------------
  state Moving
  {
        if (IsMoving())
        {
            if(traceMode)   TraceD("Moving                                                \n");
            return Moving;
        }
        else
        {
            if(traceMode) TraceD("Moving -> N                                           \n");
            EndState(); 
            return Nothing;
        }
  }
//--------------------------------------------------------------------------
  state Patrol
  {
        if (!IsMoving())
        {
            if(m_nSpecialCounter == 1)
            {
                CallMoveToPoint(m_nStayGx, m_nStayGy, m_nStayLz);
                m_nSpecialCounter = 0;
            }
            else
            {
                CallMoveToPoint(m_nSpecialGx, m_nSpecialGy, m_nSpecialLz);
                m_nSpecialCounter = 1;
            }
        }
        return Patrol;
  }
//--------------------------------------------------------------------------
    state Escort
    {
        int nDistance;
        int nTargetGx;
        int nTargetGy;
        if(traceMode)
                TraceD("Escort                                                 \n");

        if(!m_uSpecialUnit.IsLive())
        {
            m_uSpecialUnit=null;
            if(IsMoving())
            {
                CallStopMoving;
                return Escort;
            }
            EndState();
            return Nothing;
        }

        nTargetGx = m_uSpecialUnit.GetLocationX()+m_nSpecialGx;
        nTargetGy = m_uSpecialUnit.GetLocationY()+m_nSpecialGy;
        nDistance = distance(nTargetGx,nTargetGy,GetLocationX(),GetLocationY());
        if(nDistance > 0)
        {
            if(traceMode)
            TraceD("Escort: updating position                                                \n  ");
            CallMoveToPoint(nTargetGx, nTargetGy, m_uSpecialUnit.GetLocationZ());
            return Escort;        
        }
        else
        {
            if(IsMoving())
            {
                CallStopMoving;
                return Escort;
            }
            return Escort;
        }
    }

//------------------------------------------------------- 
    state LooseEscort
    {
        int nDistance;
        unit uAttacker;
        if(traceMode)
                TraceD("Loose Escort                                                 \n");
        
        if(!m_uSpecialUnit.IsLive())
        {
            m_uSpecialUnit=null;
            if(IsMoving())
            {
                CallStopMoving;
                return LooseEscort;
            }
            EndState();
            return Nothing;
        }
        //normal turn around escorted object
        nDistance = distance(m_nStayGx,m_nStayGy,GetLocationX(),GetLocationY());
        if(!IsMoving() || nDistance<2)
        {
            m_nSpecialCounter = (m_nSpecialCounter+1)%4;
            if(traceMode)
            {
                TraceD("Updating position ( ");
                TraceD(m_nSpecialCounter);
                TraceD(" )                        \n");
            }
            if(m_nSpecialCounter==0)
            {
                m_nSpecialGx=3;
                m_nSpecialGy=3;
            }
            if(m_nSpecialCounter==1)
            {
                m_nSpecialGx=3;
                m_nSpecialGy=-3;
            }
            if(m_nSpecialCounter==2)
            {
                m_nSpecialGx=-3;
                m_nSpecialGy=-3;
            }
            if(m_nSpecialCounter==3)
            {
                m_nSpecialGx=-3;
                m_nSpecialGy=3;
            }
            m_nStayGx = m_uSpecialUnit.GetLocationX()+m_nSpecialGx;
            m_nStayGy = m_uSpecialUnit.GetLocationY()+m_nSpecialGy;
            m_nStayLz = m_uSpecialUnit.GetLocationZ();
            CallMoveToPoint(m_nStayGx, m_nStayGy, m_nStayLz);
        }
        return LooseEscort;
    }

//------------------------------------------------------- 
    state Froozen
    {
        if (IsFroozen())
        {
            state Froozen;
        }
        else
        {
            //!!wrocic do tego co robilismy
            state Nothing;
        }
    }

//********************************************************
//*********** E V E N T S ****************************
//********************************************************
//zwracaja true
    //false jak nie ma 
  event OnHit()
  {
      if(retreatMode == 3)
        state Retreat;
      else
      {
        if(retreatMode == 2 && (GetHP()*4)<GetMaxHP())
        {
            m_nSpecialCounter=0;
            state Retreat;
        }
        else
          if(retreatMode == 1 &&((GetHP()*2)<=GetMaxHP()))
          {
              m_nSpecialCounter=0;
              state Retreat;
          }
      }
      true;
  }
//------------------------------------------------------- 
  event OnCannonLowAmmo(int nCannonNum)
  {
      true;
  }
//------------------------------------------------------- 
  event OnCannonNoAmmo(int nCannonNum)
  {
    true;
  }
//------------------------------------------------------- 
  event OnCannonFoundTarget(int nCannonNum, unit uTarget)
  {
      false;//gdyby zwrocic true to dzialko nie strzeli
  }
//------------------------------------------------------- 
  event OnCannonEndFire(int nCannonNum, int nEndStatus)
  {
        false;
  }
//------------------------------------------------------- 
  event OnFreezeForSupplyOrRepair(int nFreezeTicks)
  {
      CallFreeze(nFreezeTicks);
      state Froozen;
      true;
  }
//------------------------------------------------------- 
  event OnTransportedToNewWorld()
  {
  }

//********************************************************
//*********** C O M M A N D S ****************************
//********************************************************
  command Initialize()
  {
        m_nStayGx = GetLocationX();
        m_nStayGy = GetLocationY();
        m_nStayLz = GetLocationZ();
        traceMode = 0;
        retreatMode = 0;
  }
//--------------------------------------------------------------------------
  command Uninitialize()
  {
      //wykasowac referencje
      m_uSpecialUnit = null;
  }
//--------------------------------------------------------------------------
    command SetLights(int nMode) button lights priority 4
    {
    if (nMode == -1)
        {
                Trace("setlights; mode == -1\n");
                lights = (lights + 1) % 3;
        }
        else
        {
                Trace("setlights; mode == 0\n");
                assert(nMode == 0);
                lights = nMode;
        }
        SetLightsMode(lights);
    }

//--------------------------------------------------------------------------
    command UserOneParam2(int nMode) button retreatMode priority 12
    {
    if (nMode == -1)
        {
                retreatMode = (retreatMode + 1) % 4;
        }
        else
        {
                assert(nMode == 0);
                retreatMode = nMode;
        }
    }
    

//--------------------------------------------------------------------------
    command Stop() button "Stop" description "Abort current action" hotkey priority 20
    {
        if(IsMoving())
        {
            CallStopMoving();
            
        }
        state Nothing;
    }

//--------------------------------------------------------------------------
    command Move(int nGx, int nGy, int nLz) button "Move" description "Move to position." hotkey priority 21
    {
        CallMoveToPoint(nGx, nGy, nLz);
        state StartMoving;
    }
//--------------------------------------------------------------------------
  command UserNoParam0() button "Retreat" description "Retreat now" hotkey priority 25
  {
    m_nSpecialCounter=0;
    state Retreat;
  }

//--------------------------------------------------------------------------
    command UserPoint0(int nGx, int nGy, int nLz) button "Patrol" description "Patroling between 2 points." hotkey priority 29
    {
        m_nSpecialGx = nGx;
        m_nSpecialGy = nGy;
        m_nSpecialLz = nLz;
        m_nStayGx = GetLocationX();
        m_nStayGy = GetLocationY();
        m_nStayLz = GetLocationZ();
        CallMoveToPoint(nGx, nGy, nLz);
        m_nSpecialCounter = 1;
        state Patrol;
    }
    

//--------------------------------------------------------------------------
    command UserObject0(unit uUnit) button "Close escort" description "Following escorted object." hotkey priority 31 
    {
        m_uSpecialUnit=uUnit;
        m_nSpecialGx=GetLocationX()-m_uSpecialUnit.GetLocationX();
        m_nSpecialGy=GetLocationY()-m_uSpecialUnit.GetLocationY();
        if(m_nSpecialGx > 2) m_nSpecialGx=2;
        if(m_nSpecialGx < -2) m_nSpecialGx=-2;
        if(m_nSpecialGy > 2) m_nSpecialGy=2;
        if(m_nSpecialGy < -2) m_nSpecialGy=-2;
        state Escort;
    }
//--------------------------------------------------------------------------
    command UserObject1(unit uUnit) button "Loose escort" description "Moving around escorted object." hotkey priority 33
    {
        m_uSpecialUnit=uUnit;
        m_nSpecialCounter=0;
        state LooseEscort;
    }

//--------------------------------------------------------------------------
  command Enter(unit uEntrance) hidden button "Enter"
  {
    CallMoveInsideObject(uEntrance);
    //m_nTargetGx = GetEntranceX(uEntrance);
    //m_nTargetGy = GetEntranceY(uEntrance);
    //m_nTargetLz = GetEntranceZ(uEntrance);
    state StartMoving;
  }
    
//-------------------------------------------------------
    command SpecialChangeUnitsScript() button "translateCommandChangeScript" description "translateCommandChangeScriptDescription" hotkey priority 254 
    {
        //special command - no implementation
    }
    //--------------------------------------------------------------------------
/*    command UserOneParam3(int nMode) hidden button traceMode priority 255
    {
    if (nMode == -1)
        {
                traceMode = (traceMode + 1) % 2;
        }
        else
        {
                assert(nMode == 0);
                traceMode = nMode;
        }
    }*/
}