aircraft "translateScriptNameAircraft"
{
	consts
	{
		nonAttack=0;
		movingOnPosition=1;
		attacking=2;
		evacuating=3;
		attackRange=7;
		
		disableFire=0;
	}

    unit m_uTarget;
    int  m_nCannonToTarget;
    int  m_nTargetGx;
    int  m_nTargetGy;
    int  m_nTargetLz;
    int  m_nStayGx;
    int  m_nStayGy;
    int  m_nStayLz;
    int  m_nAttackGx;
    int  m_nAttackGy;
    int  m_nAttackPhase;
    int  m_nSpecialGx; //Patrol point , escort
    int  m_nSpecialGy;
    int  m_nSpecialLz;
    int  m_nSpecialCounter;
    unit m_uSpecialUnit;
    int  m_nState;
    int  m_bNeedReload;
    int  m_bNeedStop;

	int m_nMoveToX;
	int m_nMoveToY;
	int m_nMoveToZ;
    
	// scoout --------------------
	int m_nStateStart;
	int m_nStartGx;
	int m_nStartGy;
	int m_nMiddleGx;
	int m_nMiddleGy;
	int m_nViewRange;
	int m_nCorner;
	int m_nRound;
	int m_nLeft;
	int m_nRight;
	int m_nTop;
	int m_nBottom;
	int m_nEnd;
	int m_nWidth;
	int m_nHeight;
	int m_nStartCorner;
	// ------------------------
    
    enum lights
    {
        "translateCommandStateLightsAUTO" item 100 description "translateCommandStateLightsAUTODescription",
        "translateCommandStateLightsOFF" item 101 description "translateCommandStateLightsOFFDescription",
multi:
        "translateCommandStateLightsMode" item 150 description "translateCommandStateLightsModeDescription"
    }
    
    enum movementMode
    {
        "translateCommandStateFollowEnemy" item 109 description "translateCommandStateFollowEnemyDescription",
        "translateCommandStateHoldArea" item 108 description "translateCommandStateHoldAreaDescription",
        "translateCommandStateHoldPosition" item 107 description "translateCommandStateHoldPositionDescription",
            
multi:
        "translateCommandStateMovement" item 153 description "translateCommandStateMovementDescription"
    }
/*    
    enum attackMode 
    {
        "translateCommandStateStaticAttack",
        "translateCommandStateDynamicAttack",
multi:
        "translateCommandStateAttackMode"
    }
*/
	enum retreatMode
	{
		"translateCommandStateNoRetreat" item 102 description "translateCommandStateNoRetreatDescription",
		"translateCommandStateRetreat" item 103 description "translateCommandStateRetreatDescription",
multi:
		"translateCommandStateRetreatMode" item 151 description "translateCommandStateRetreatModeDescription"
	}
    
    enum traceMode
    {
        "translateCommandStateTraceOFF",
        "translateCommandStateTraceON",
multi:
        "translateCommandStateTraceMode"
    }

    enum scoutMode
    {
        "translateCommandStateScoutOff" item 110 description "translateCommandStateScoutOffDescription" ,
        "translateCommandStateScoutBorder" item 112 description "translateCommandStateScoutBorderDescription",
        "translateCommandStateScoutMiddle" item 113 description "translateCommandStateScoutMiddleDescription",
        "translateCommandStateScoutRandom" item 111 description "translateCommandStateScoutRandomDescription",
		multi:
        "translateCommandStateScoutMode" item 154 description "translateCommandStateScoutModeDescription"
    }

    state Nothing;
    state HoldPosition;
    state StartMoving;
    state Moving;
	state MovingAfterReload;
    state StartMovingToWorld;
    state MovingToWorld;
    state StartMovingToRecycle;
    state MovingToRecycle;
    state AutoAttacking;
    state Attacking;
    state AttackingPoint;
    state Patrol;
    state Escort;
    //for flyables
    state MovingForGetSupply;
    state GettingSupply;

	state Scout;
	state ScoutBorderMiddle;
	state ScoutMiddleBorder;
	state ScoutRand;
	state ScoutEnd;
    
    //********************************************************
    //********* F U N C T I O N S ****************************
    //********************************************************
    //-------------------------------------------------------
    function int SetTarget(unit uTarget)
    {
        int nCannon, nCannonsCount;
		m_uTarget = uTarget;
        m_nCannonToTarget = 0;
        if (m_uTarget != null)
        {
            nCannonsCount = GetCannonsCount();
            for (nCannon = 0; nCannon < nCannonsCount; nCannon = nCannon + 1)
            {
                if (m_uTarget.IsHelicopter())
                {
                    if (CanCannonFireToAircraft(nCannon))
                    {
                        m_nCannonToTarget = nCannon;
                        break;
                    }
                }
                else
                {
                    if (CanCannonFireToGround(nCannon))
                    {
                        m_nCannonToTarget = nCannon;
                        break;
                    }
                }
            }
        }

		if((uTarget != null) && (IsVisible(uTarget) || !uTarget.IsHelicopter()) )//XXXMD 08.12.2000
		{
			SetTargetObject(uTarget);
			return true;
		}
		else
		{
			SetTargetObject(null);
			m_uTarget = null;
			return false;
		}
    }
    //------------------------------------------------------- 
    function int FindBestTarget()
    {
        int nFindTarget;

        nFindTarget = 0;
        if (CanCannonFireToAircraft(-1))
        {
            nFindTarget = findTargetFlyingUnit;
        }
        if (CanCannonFireToGround(-1))
        {
            nFindTarget = nFindTarget | findTargetNormalUnit | findTargetWaterUnit | findTargetBuildingUnit;
        }
        SetTarget(FindClosestEnemyUnitOrBuilding(nFindTarget));
    }
    //------------------------------------------------------- 
    function int AttackRun(int bAttackOnPoint)
    {
        int nRangeMode;
        int nDx;
        int nDy;
        int nDxAbs;
        int nDyAbs;
        int nDistance;
        int nR;
        
        if(1)//position attack
        {
            if(GetCannonType(0)==cannonTypeBomb)//bombowiec
            {
                if(traceMode)   TraceD("bombowiec                                                  \n");
                if(GetLocationX()==m_nTargetGx && GetLocationY()==m_nTargetGy)//nad celem
                {
                    if (IsMoving())
                    {
                        if(traceMode) TraceD("CallStopMoving                         \n");
                        CallStopMoving();
                    }
                    return true;
                }
                else
                {
                    if(traceMode)   TraceD("GoToTarget: Target not in range                               \n");
                    CallMoveToPoint(m_nTargetGx,m_nTargetGy,0);
                    return false;
                }
            }//--- koniec bombowca
            
            if(bAttackOnPoint)
                nRangeMode = IsPointInCannonRange(0,m_nTargetGx,m_nTargetGy,m_nTargetLz);
            else
                nRangeMode = IsTargetInCannonRange(m_nCannonToTarget, m_uTarget);
            
            if (nRangeMode == inRangeGoodHit)
            {
                if(traceMode) TraceD("In range                         \n");
                if (IsMoving() && m_bNeedStop)
                {
                    m_bNeedStop=false;
                    if(traceMode) TraceD("CallStopMoving                         \n");
                    CallStopMoving();
                }
                return true;
            }
            
            if(nRangeMode == inRangeBadAngleAlpha) //w zasiegu ale trzeba odwrocic czolg 
            {
                if(traceMode)     TraceD("Rotating tank:");
                if (IsMoving() )
                {
                    if(traceMode) TraceD("CallStopMoving                         \n");
                    if(m_bNeedStop)
                    {
                        m_bNeedStop=false;
                        CallStopMoving();
                    }
                }
                else
                {
                    if(traceMode) TraceD("CallTurnToAngle                         \n");
                    if(bAttackOnPoint)
                        CallTurnToAngle(GetCannonAngleToPoint(0,m_nTargetGx,m_nTargetGy,m_nTargetLz));
                    else
                        CallTurnToAngle(GetCannonAngleToTarget(m_nCannonToTarget,m_uTarget));
                }
                return false;
            }
            
            if(nRangeMode == inRangeBadHit) 
            {
            /*if(traceMode) TraceD("Zaslanianie                         \n");
            nDx = m_nTargetGx - m_nTargetGy + GetLocationY();
            nDy = m_nTargetGy + m_nTargetGx - GetLocationX();
                CallMoveLowToPoint(nDx, nDy, 0);*/
                if(traceMode)     TraceD("Rotating tank (zaslania):");
                if (IsMoving() )
                {
                    if(traceMode) TraceD("CallStopMoving                         \n");
                    if(m_bNeedStop)
                    {
                        m_bNeedStop=false;
                        CallStopMoving();
                    }
                }
                else
                {
                    if(traceMode) TraceD("CallTurnToAngle                         \n");
                    if(bAttackOnPoint)
                        CallTurnToAngle(GetCannonAngleToPoint(0,m_nTargetGx,m_nTargetGy,m_nTargetLz));
                    else
                        CallTurnToAngle(GetCannonAngleToTarget(m_nCannonToTarget,m_uTarget));
                }
                return true;
            }
            m_bNeedStop=true;
            if(nRangeMode == inRangeBadAngleBeta) 
            {
                if(traceMode) TraceD("Zla beta                         \n");
                if(GetLocationX()==m_uTarget.GetLocationX() && GetLocationX()==m_uTarget.GetLocationX())
                    CallMoveToPoint(GetLocationX()+3,GetLocationY(), 0);
                else
                    CallMoveToPoint(2*GetLocationX()-m_uTarget.GetLocationX(),2*GetLocationY()-m_uTarget.GetLocationY(), 0);
                return true;
            }
            nDistance = DistanceTo(m_nTargetGx,m_nTargetGy);
            if(!nDistance) {nDistance=1;nDx=1;}//gdy stoimy nad celem
            nDx = GetLocationX()-m_nTargetGx;
            nDy = GetLocationY()-m_nTargetGy;
            nRangeMode = GetCannonShootRange(0)-1;
            
            nDxAbs = m_nTargetGx+((nRangeMode*nDx)/nDistance);
            nDyAbs = m_nTargetGy+((nRangeMode*nDy)/nDistance);
            
            if(nDxAbs==GetLocationX() && nDyAbs==GetLocationY())
            {
                nRangeMode = GetCannonShootRange(0)-2;
                nDxAbs = m_nTargetGx+((nRangeMode*nDx)/nDistance);
                nDyAbs = m_nTargetGy+((nRangeMode*nDy)/nDistance);
            }
            CallMoveLowToPoint(nDxAbs,nDyAbs,0);
            if(traceMode)   
            {
                TraceD("Target not in range dist=");
                TraceD(nDistance);
                TraceD(",  rRange =");
                TraceD(nRangeMode);
                TraceD("                          \n");
            }
            return false;
    }
    /*
    if(m_nAttackPhase==nonAttack)
    {
        if(traceMode)     TraceD("nonAttack                              \n");
        nDx=GetLocationX()-m_nTargetGx;
        nDy=GetLocationY()-m_nTargetGy;
        
        if(nDx<0){nDxAbs=-nDx;nDx=-attackRange;}
        else {nDxAbs=nDx;nDx=attackRange;}
        if(nDy<0) {nDyAbs=-nDy;nDy=-attackRange;}
        else {nDyAbs=nDy;nDy=attackRange;}
        
        if(nDyAbs<nDxAbs)nDy=0;
        else nDx=0;
        
        m_nAttackGx = m_nTargetGx+nDx;
        m_nAttackGy = m_nTargetGy+nDy;
        
        CallMoveToPoint(m_nAttackGx, m_nAttackGy, 0);
        m_nAttackPhase = movingOnPosition;
        return false;
    }
    if(m_nAttackPhase==movingOnPosition)
    {
        if(traceMode)     TraceD("movingOnPosition                              \n");
        if(!IsMoving() || (m_nAttackGx==GetLocationX()&& m_nAttackGy==GetLocationY()))
        {
            CallMoveLowToPoint(2*m_nTargetGx - m_nAttackGx, 2*m_nTargetGy - m_nAttackGy, 0);
            m_nAttackPhase=attacking;
        }
        return false;
    }
    if(m_nAttackPhase==attacking)
    {
        if(traceMode)     TraceD("attacking: ");
        nDistance = Distance(m_nAttackGx,m_nAttackGy,GetLocationX(),GetLocationY());
        if(traceMode) {   TraceD(nDistance);TraceD("                \n");}
        if((GetCannonType(0)!=cannonTypeBomb && nDistance>4) || nDistance>8)
        {
            nDx = (m_nTargetGx - m_nAttackGx);
            nDy = (m_nTargetGy - m_nAttackGy);
            m_nAttackGx = m_nTargetGx+nDy;
            m_nAttackGy = m_nTargetGy-nDx;
            m_nAttackPhase=movingOnPosition;//evacuating;
            CallMoveToPoint(m_nAttackGx, m_nAttackGy, 0);
            return false;
        }
        return true;
    }
    if(m_nAttackPhase==evacuating)
    {
    if(traceMode)     TraceD("evacuating: ");
    nDistance = Distance(m_nTargetGx,m_nTargetGy,GetLocationX(),GetLocationY());
    if(traceMode) {   TraceD(nDistance);TraceD("                \n");}
    if(!IsMoving() || nDistance>3)
    {
    m_nAttackPhase=nonAttack;
    }
    return false;
    }*/
    return false;
    }
    
    //------------------------------------------------------- 
    function int TargetInRange()
    {
        int nRangeMode;
        int nDx;
        int nDy;
        nRangeMode = IsTargetInCannonRange(m_nCannonToTarget, m_uTarget);
        
        if (nRangeMode == inRangeGoodHit) 
        {
            return true;
        }
        if(nRangeMode == inRangeBadAngleAlpha) //w zasiegu ale trzeba odwrocic czolg 
        {
            if(traceMode)   TraceD("Rotating aircraft:");
            CallTurnToAngle(GetCannonAngleToTarget(m_nCannonToTarget,m_uTarget));
            return true;
        }
        return false;
    }
    //-------------------------------------------------------
    function int CheckAmmo()
    {

        if(CannonRequiresSupply(0) && (m_bNeedReload || !GetAmmoCount()) && FindSupplyCenterPlace())
        {
            m_nState=0;
            if(state==AttackingPoint)
                m_nState = 1;
            if(state==Attacking)
                m_nState = 2;
            if(state==Moving)
                m_nState = 3;
            
            m_nSpecialGx = GetLocationX(); 
            m_nSpecialGy = GetLocationY();
            
            m_nStayGx = GetFoundSupplyCenterPlaceX();
            m_nStayGy = GetFoundSupplyCenterPlaceY();
            m_nStayLz = GetFoundSupplyCenterPlaceZ();
            //CallMoveAndLandToPointForce(m_nStayGx, m_nStayGy, m_nStayLz);
						CallMoveToPointForce(m_nStayGx, m_nStayGy, m_nStayLz);//dodane 25.01.2000
            return true;
        }
        return false;
    }
    //-------------------------------------------------------
    function int CheckGameRect()
    {
	    m_nLeft =  GetGameLeft();
	    m_nRight = GetGameRight();
	    m_nTop = GetGameTop();
	    m_nBottom = GetGameBottom();
	    m_nWidth = GetGameRight() -  GetGameLeft();
	    m_nHeight = GetGameBottom() - GetGameTop();
	    m_nMiddleGx = (m_nLeft + m_nRight)/2;
	    m_nMiddleGy = (m_nBottom + m_nTop)/2;
    }
    //-------------------------------------------------------
    function int EndState()
    {
        NextCommand(1);
    }
    //********************************************************
    //************* S T A T E S ******************************
    //********************************************************
    
    
    //------------------------------------------------------- 
    
    state Nothing
    {
        if(traceMode)TraceD("N                                                 \n");
        
        if(movementMode==2) return HoldPosition;
        
        if(CheckAmmo())return MovingForGetSupply;
        
        FindBestTarget();
        if(!m_uTarget)
        {
            SetTarget(GetAttacker());
            ClearAttacker();
        }
        
        if (m_uTarget != null)
        {
            m_nStayGx = GetLocationX();
            m_nStayGy = GetLocationY();
            m_nStayLz = GetLocationZ();
            m_nAttackPhase=nonAttack;
            return AutoAttacking;
        }
        return Nothing;
    }
    //----------------------------------------------------
	state Retreat
	{
		unit uTarget;

		if (!m_nSpecialCounter)
		{
			uTarget = FindClosestEnemy();
			m_nSpecialCounter = (m_nSpecialCounter+1)%16;
		}
		else
		{
			if (IsMoving())
				m_nSpecialCounter = (m_nSpecialCounter+1)%16;
			else
				m_nSpecialCounter = 0;

			if (traceMode) TraceD("Retreat\n");

			return Retreat;
		}
		
		if (!uTarget)
		{
			if (IsMoving())
				CallStopMoving();

			if (traceMode) TraceD("Retreat -> Nothing\n");

			return Nothing;
		}

		CallMoveToPoint(2*GetLocationX()-uTarget.GetLocationX(),2*GetLocationY() - uTarget.GetLocationY(),GetLocationZ());

		if (traceMode) TraceD("Retreat (Enemy)\n");

		return Retreat;
	}
    //----------------------------------------------------
    state HoldPosition
    {
        if(traceMode)TraceD("HP                                                 \n");
        
        if(CheckAmmo())return MovingForGetSupply;
        
        if(m_uTarget)
        { 
            if(!m_uTarget.IsLive() || !IsEnemy(m_uTarget))
            {
                StopCannonFire(-1);
                SetTarget(null);
                m_nAttackPhase=nonAttack;
            }
            else
            {
                if(TargetInRange())
                {
                    if(traceMode)TraceD("HP Fire!!!                                                \n");
                    CannonFireToTarget(-1, m_uTarget, -1);
                    return HoldPosition;
                }
                else
                    SetTarget(null);
                return HoldPosition,10;
            }
        }
        else
        {
            FindBestTarget();
            if(!m_uTarget)
            {
                SetTarget(GetAttacker());
                ClearAttacker();
            }
        }        
        return HoldPosition;
    }
    //----------------------------------------------------
    state AutoAttacking
    {
        int nDistance;
        
        if(traceMode)TraceD("AA                                                \n");
        
        if(CheckAmmo())return MovingForGetSupply;
        
        // pozostawaj w okolicach punktu
        nDistance = Distance(m_nStayGx,m_nStayGy,GetLocationX(),GetLocationY());
        if( nDistance > 18)
        {
            if(traceMode)TraceD("nDistance: > 12 !!!!!                                                \n  ");
            SetTarget(null);
            m_nAttackPhase=nonAttack;
            CallMoveToPoint(m_nStayGx, m_nStayGy, m_nStayLz);
            return Moving;          
        }
        
        if(!m_uTarget.IsLive() || !IsEnemy(m_uTarget))
        {
            StopCannonFire(-1);
            SetTarget(null);
            m_nAttackPhase=nonAttack;
        }
        
        if (m_uTarget)
        {
            m_nTargetGx = m_uTarget.GetLocationX();
            m_nTargetGy = m_uTarget.GetLocationY();
            if(AttackRun(0))
            {
                if(traceMode)TraceD("AA    Fire!!!!                                           \n");
                CannonFireToTarget(-1, m_uTarget, 2);
            }
            return AutoAttacking;
        }
        else//target not exist
        {
            FindBestTarget();
            
            if(!m_uTarget)
            {
                SetTarget(GetAttacker());
                ClearAttacker();
            }
            
            if (m_uTarget != null)
                return AutoAttacking;
            
            if( nDistance > 0)
            {
                CallMoveToPoint(m_nStayGx, m_nStayGy, m_nStayLz);
                return Moving;          
            }
            
            if (IsMoving())
            {
                CallStopMoving();
            }
            return Nothing;
        }
    }
    //--------------------------------------------------------------------------
    state AttackingPoint
    {
        if(traceMode)TraceD("AG                                                \n");
        if(CheckAmmo())return MovingForGetSupply;
        if(AttackRun(1))
            CannonFireGround(-1, m_nTargetGx, m_nTargetGy, 0, 2);
        return AttackingPoint;
    }
    //----------------------------------------------------
    state Attacking
    {
        if(traceMode)TraceD("A                                                \n");
        if(CheckAmmo())return MovingForGetSupply;
        if (m_uTarget.IsLive())
        {
            m_nTargetGx = m_uTarget.GetLocationX();
            m_nTargetGy = m_uTarget.GetLocationY();
            if(AttackRun(0))
                CannonFireToTarget(-1, m_uTarget, 2);
            return Attacking;
        }
        else //target not exist
        {
            SetTarget(null);
            m_nAttackPhase=nonAttack;
            if (IsMoving())
            {
                CallStopMoving();
            }
            EndState();
            return Nothing;
        }
    }
    //--------------------------------------------------------------------------
    state StartMoving
    {
        return Moving, 20;
    }
    //--------------------------------------------------------------------------
    state Moving
    {
        if (IsMoving())
        {
            if(traceMode)   TraceD("Moving                                                \n");
            return Moving;
        }
        else
        {
            if(traceMode) TraceD("Moving -> N                                           \n");
            EndState(); 
            return Nothing;
        }
    }
    //--------------------------------------------------------------------------
    state StartMovingToWorld
    {
        return MovingToWorld;
    }
    //-------------------------------------------------------
    state MovingToWorld
    {
        if (IsMoving())
        {
            if ((Distance(GetLocationX(), GetLocationY(), m_nMoveToX, m_nMoveToY) <= 1) &&
                (GetLocationZ() == m_nMoveToZ))
            {
                //znikamy wczesniej aby nie bylo widac zatrzymujacego sie helikoptera
                EndFlyingToSpecialDestination();
            }
            return MovingToWorld;
        }
        else
        {
            EndFlyingToSpecialDestination();
        }
    }
    //-------------------------------------------------------
    state StartMovingToRecycle
    {
        return MovingToRecycle;
    }
    //-------------------------------------------------------
    state MovingToRecycle
    {
        if (IsMoving())
        {
            if ((Distance(GetLocationX(), GetLocationY(), m_nMoveToX, m_nMoveToY) <= 1) &&
                (GetLocationZ() == m_nMoveToZ))
            {
                //znikamy wczesniej aby nie bylo widac zatrzymujacego sie helikoptera
                EndFlyingToSpecialDestination();
            }
            return MovingToRecycle;
        }
        else
        {
            EndFlyingToSpecialDestination();
        }
    }
    //-------------------------------------------------------
    state Patrol
    {
        if(CheckAmmo())return MovingForGetSupply;
        if(m_uTarget)
        {
            if(!m_uTarget.IsLive() || !IsEnemy(m_uTarget))
            {
                StopCannonFire(-1);
                SetTarget(null);
                m_nAttackPhase=nonAttack;
            }
            else
            {
                m_nTargetGx = m_uTarget.GetLocationX();
                m_nTargetGy = m_uTarget.GetLocationY();
                if(AttackRun(0))
                    CannonFireToTarget(-1, m_uTarget, -1);
                return Patrol;
            }
        }
        else
        {
            FindBestTarget();
        }   
        
        if (!IsMoving())
        {
            if(m_nSpecialCounter == 1)
            {
                CallMoveToPoint(m_nStayGx, m_nStayGy, m_nStayLz);
                m_nSpecialCounter = 0;
            }
            else
            {
                CallMoveToPoint(m_nSpecialGx, m_nSpecialGy, m_nSpecialLz);
                m_nSpecialCounter = 1;
            }
        }
        return Patrol;
    }
    //--------------------------------------------------------------------------
    state Escort
    {
        if(traceMode)TraceD("Escort                                                 \n");
        if(CheckAmmo())return MovingForGetSupply;
        if(m_uTarget)
        {
            if(!m_uTarget.IsLive() || !IsEnemy(m_uTarget))
            {
                StopCannonFire(-1);
                SetTarget(null);
                m_nAttackPhase=nonAttack;
            }
            else
            {
                m_nTargetGx = m_uTarget.GetLocationX();
                m_nTargetGy = m_uTarget.GetLocationY();
                if(AttackRun(0))
                    CannonFireToTarget(-1, m_uTarget, -1);
                return Escort;
            }
        }
        else
        {
            FindBestTarget();
        }
        
        if(!m_uSpecialUnit.IsLive())
        {
            m_uSpecialUnit=null;
            if(IsMoving())
            {
                CallStopMoving;
                return Escort;
            }
            EndState();
            return Nothing;
        }
        
        m_nTargetGx = m_uSpecialUnit.GetLocationX()+m_nSpecialGx;
        m_nTargetGy = m_uSpecialUnit.GetLocationY()+m_nSpecialGy;
        m_nTargetLz = m_uSpecialUnit.GetLocationZ();
        if(Distance(m_nTargetGx,m_nTargetGy,GetLocationX(),GetLocationY()) > 0)
        {
            if(traceMode) TraceD("Escort: updating position                                                \n  ");
            CallMoveToPoint(m_nTargetGx, m_nTargetGy, m_nTargetLz);
            return Escort;              
        }
        else
        {
            if(IsMoving())
            {
                CallStopMoving;
                return Escort;
            }
            return Escort;
        }
    }
    
    //------------------------------------------------------- 
    state Froozen
    {
        if (IsFroozen())
        {
            state Froozen;
        }
        else
        {
            //!!wrocic do tego co robilismy
            state Nothing;
        }
    }
    
    //------------------------------------------------------- 
    //for Flyables
    state MovingForGetSupply
    {
        if (IsMoving())
        {
            if(traceMode)   TraceD("MovingForSupply                                                \n");
						if ((GetLocationX() == m_nStayGx) && (GetLocationY() == m_nStayGy) && (GetLocationZ() == m_nStayLz))
						{
							if(traceMode)   TraceD("MovingForSupply CallStopMoving                                           \n");
							CallStopMoving();
							return MovingForGetSupply,5;
						}
						return MovingForGetSupply;
        }
        else
        {
            if ((GetLocationX() == m_nStayGx) && (GetLocationY() == m_nStayGy) && (GetLocationZ() == m_nStayLz))
            {
								if(traceMode) TraceD("MovingForSupply -> GettingSupply                                           \n");
                CallGetFlyingSupply();
                return GettingSupply;
            }
            else
            {
                if(traceMode)   TraceD("MovingForSupply again                                               \n");
                //CallMoveAndLandToPointForce(m_nStayGx, m_nStayGy, m_nStayLz);
								CallMoveToPointForce(m_nStayGx, m_nStayGy, m_nStayLz);//dodane 25.01.2000
                return MovingForGetSupply;
            }
        }
    }
    
    state GettingSupply
    {
        if (IsGettingSupply())
        {
            if(traceMode) TraceD("GettingSupply                                           \n");
            return GettingSupply,5;
        }
        else
        {
					  if(traceMode) TraceD("End GettingSupply                                           \n");
            m_bNeedReload=false;
            if(m_nSpecialGx==GetLocationX() && m_nSpecialGy==GetLocationY()) m_nSpecialGx=m_nSpecialGx+5;
						if(!GetAmmoCount())
						{
							m_nSpecialGx=GetLocationX()-5; 
							m_nSpecialGy=GetLocationY();
						}
						if(!m_nSpecialGx){m_nSpecialGx=GetLocationX()+5;m_nSpecialGy=GetLocationY();}
            CallMoveToPoint(m_nSpecialGx,m_nSpecialGy,0);
            return MovingAfterReload;
            
            
        }
    }
    //--------------------------------------------------------------------------
    state MovingAfterReload
    {
        if (IsMoving())
        {
            if(traceMode)   TraceD("MovingAfterReload                                                \n");
            return MovingAfterReload;
        }
        else
        {
						if(m_nState==1)
                return AttackingPoint,40;
            
            if(m_nState==2)
                return Attacking,40;
            
            if(traceMode) TraceD("MovingAfterReload -> N                                           \n");
            EndState(); 
            return Nothing;
        }
    }


//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
	state ScoutEnd
	{
		scoutMode = 0;
		ChangedCommandValue();

		if(IsMoving) 
			return ScoutEnd;
		
		return Nothing;
	}

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
	state ScoutMiddleBorder
	{
		int tx;
		int ty;

		if(m_nStateStart)
		{
		   m_nStartGx = GetLocationX();
		   m_nStartGy = GetLocationY();

		   tx = m_nMiddleGx-m_nViewRange;
		   ty = m_nMiddleGy-m_nViewRange;
           m_nStateStart = false;

		   m_nCorner = 0; // everytime the same startpos
		   m_nRound  = 1; // nessecary first = 1
		   CallMoveToPoint(tx,ty,0);
		   return ScoutMiddleBorder;
		}

		// still flying
		if(IsMoving()) 
		   return ScoutMiddleBorder;

        CheckGameRect();

		m_nCorner = m_nCorner +1; // next corner
		if(m_nCorner == 4) 
			m_nCorner = 0;


		if(m_nCorner == 1) // next corner, then ...
		{
			tx = m_nMiddleGx + m_nRound*m_nViewRange*2;
			ty = m_nMiddleGy - m_nRound*m_nViewRange*2;
		}
		if(m_nCorner == 2)
		{
			tx = m_nMiddleGx + m_nRound*m_nViewRange*2;
			ty = m_nMiddleGy + m_nRound*m_nViewRange*2;
		}
		if(m_nCorner == 3)
		{
			tx = m_nMiddleGx - m_nRound*m_nViewRange*2;
			ty = m_nMiddleGy + m_nRound*m_nViewRange*2;
		}
		if(m_nCorner == 0)
		{
			tx = m_nMiddleGx - m_nRound*m_nViewRange*2;
			ty = m_nMiddleGy - m_nRound*m_nViewRange*2 - m_nViewRange; //next round start
			m_nRound = m_nRound +1; // round finished
		}
		
		// check for border exceeding
		if(tx<m_nLeft)
		{
			tx = m_nLeft + m_nViewRange;
			m_nEnd = true;
		}
		if(tx>m_nRight)
		{
			tx = m_nRight - m_nViewRange;
			m_nEnd = true;
		}

		if(ty<m_nTop)
		{
			ty = m_nTop + m_nViewRange;
			m_nEnd = true;
		}
		if(ty>m_nBottom)
		{
			ty = m_nBottom - m_nViewRange;
			m_nEnd = true;
		}


		//check for end
		if(m_nEnd)
		{
				CallMoveToPoint(m_nStartGx,m_nStartGy,0);
				return ScoutEnd;
		}

	
		CallMoveToPoint(tx,ty,0);
		return ScoutMiddleBorder;
		
	}
//////////////////////////////////////////////////////////////////////////
	
	state ScoutRand
	{
		int tx;
		int ty;

		if(IsMoving()) 
		   return ScoutRand;

        CheckGameRect();

		tx = Rand(m_nWidth)  + m_nLeft;
		ty = Rand(m_nHeight) + m_nTop;
		
		CallMoveToPoint(tx,ty,0);
		return ScoutRand;
	}
	
	
//////////////////////////////////////////////////////////////////////////	
	state ScoutBorderMiddle
	{
		int dx;
		int dy;
		int tx;
		int ty;
		int min; 
		int tmp;

		if(m_nStateStart)
		{
			m_nStartGx = GetLocationX();
			m_nStartGy = GetLocationY();
			m_nStateStart = false;
			min = 5000;
			if(DistanceTo(m_nLeft,m_nTop) < min)
			{
				min = DistanceTo(m_nLeft,m_nTop);
				tx = m_nLeft + m_nViewRange;
				ty = m_nTop + m_nViewRange;
				m_nCorner = 0;
			}
			if(DistanceTo(m_nRight,m_nTop) < min)
			{
				min = DistanceTo(m_nRight,m_nTop);
				tx = m_nRight - m_nViewRange;
				ty = m_nTop + m_nViewRange;
				m_nCorner = 1;
			}
			if(DistanceTo(m_nRight,m_nBottom) < min)
			{
				min = DistanceTo(m_nRight,m_nBottom);
				tx = m_nRight - m_nViewRange;
				ty = m_nBottom - m_nViewRange;
				m_nCorner = 2;
			}

			if(DistanceTo(m_nLeft,m_nBottom) < min)
			{
				min = DistanceTo(m_nLeft,m_nBottom);
				tx = m_nLeft + m_nViewRange;
				ty = m_nBottom - m_nViewRange;
				m_nCorner = 3;
			}
			m_nStartCorner = m_nCorner;
			m_nRound = 0;  // nessecary first = 0
			CallMoveToPoint(tx,ty,0);
			return ScoutBorderMiddle;
		}
        
		//on the way?
		if(IsMoving())
			return ScoutBorderMiddle;

        CheckGameRect();

		//calc next corner!
		m_nCorner = m_nCorner +1;
		
		if(m_nCorner == 4) 
			m_nCorner = 0;

		
		if(m_nCorner == 0)//next corner...
		{
			tx = m_nLeft + m_nRound * m_nViewRange * 2 + m_nViewRange;
			ty = m_nTop +  m_nRound * m_nViewRange * 2 + m_nViewRange;
		}
		if(m_nCorner == 1)//next corner...
		{
			tx = m_nRight - m_nRound * m_nViewRange * 2 - m_nViewRange;
			ty = m_nTop + m_nRound * m_nViewRange * 2 + m_nViewRange;
		}
		if(m_nCorner == 2)
		{
			tx = m_nRight -  m_nRound * m_nViewRange * 2 - m_nViewRange;
			ty = m_nBottom -  m_nRound * m_nViewRange * 2 - m_nViewRange;
		}
		if(m_nCorner == 3)
		{
			tx = m_nLeft + m_nRound * m_nViewRange * 2 + m_nViewRange;
			ty = m_nBottom - m_nRound * m_nViewRange * 2 - m_nViewRange;
		}
		if(m_nCorner == m_nStartCorner)
		{
			//check for end
			tmp = m_nWidth;
			if(tmp > m_nHeight)
				tmp = m_nHeight;
			if((m_nViewRange * 2 * m_nRound + m_nViewRange) > (tmp/2))
			{
				CallMoveToPoint(m_nStartGx,m_nStartGy,0);
				return ScoutEnd;
			}	
			m_nRound = m_nRound + 1;
			if(m_nCorner == 0)
				ty = ty + m_nViewRange * 2;
			if(m_nCorner == 1)
				tx = tx - m_nViewRange * 2;
			if(m_nCorner == 2)
				ty = ty - m_nViewRange * 2;
			if(m_nCorner == 3)
				tx = tx + m_nViewRange * 2;

		}
		CallMoveToPoint(tx,ty,0);
		return ScoutBorderMiddle;
	}

	state Scout
	{
		m_nEnd = false;
		m_nStateStart = true;
		if(scoutMode == 1)
			state ScoutBorderMiddle;
		if(scoutMode == 2)
			state ScoutMiddleBorder;
		if(scoutMode == 3)
			state ScoutRand;
	}
    
	
	//********************************************************
    //*********** E V E N T S ****************************
    //********************************************************
    //zwracaja true
    //false jak nie ma 
	event OnHit()
	{
		if ( retreatMode && ((GetHP()*2) <= GetMaxHP()) )
		{
			m_nSpecialCounter=0;
			state Retreat;
		}
		true;
	}
    //------------------------------------------------------- 
    event OnCannonLowAmmo(int nCannonNum)
    {
        true;
    }
    //------------------------------------------------------- 
    event OnCannonNoAmmo(int nCannonNum)
    {
        m_bNeedReload=true;
        if(CheckAmmo())state MovingForGetSupply;
        true;
    }
    //------------------------------------------------------- 
    event OnCannonFoundTarget(int nCannonNum, unit uTarget)
    {
        return false;//gdyby zwrocic true to dzialko nie strzeli
    }
    //------------------------------------------------------- 
    event OnCannonEndFire(int nCannonNum, int nEndStatus)//gdy zniszczony, poza zasiegiem lub brak ammunicji
    {
        false;
    }
    //------------------------------------------------------- 
    event OnFreezeForSupplyOrRepair(int nFreezeTicks)
    {
        CallFreeze(nFreezeTicks);
        state Froozen;
        true;
    }
    //------------------------------------------------------- 
    event OnTransported(int bToNewWorld)
    {
        StopCannonFire(-1);
        SetTarget(null);
        m_uSpecialUnit = null;
        CheckGameRect();
    }
    //------------------------------------------------------- 
    event OnCheckRecycleUnit()
    {
        if (state == MovingToRecycle)
        {
            true;
        }
        else
        {
            false;
        }
    }
    //------------------------------------------------------- 
    event OnConvertedToNewPlayer()
    {
        StopCannonFire(-1);
        SetTarget(null);
        m_uSpecialUnit = null;
        state Nothing;
    }
    
    //********************************************************
    //*********** C O M M A N D S ****************************
    //********************************************************
    command Initialize()
    {
        SetCannonFireMode(-1, disableFire);
        m_nAttackGx=-1;
        if(!GetAmmoCount()) 
					m_bNeedReload=true;
				else 
					m_bNeedReload=false;

		// scout
		m_nViewRange = 7;
		scoutMode = 0;
		m_nLeft =  GetGameLeft();
		m_nRight = GetGameRight();
		m_nTop = GetGameTop();
		m_nBottom = GetGameBottom();
		m_nWidth = GetGameRight() -  GetGameLeft();
		m_nHeight = GetGameBottom() - GetGameTop();
		m_nMiddleGx = (m_nLeft + m_nRight)/2;
	    m_nMiddleGy = (m_nBottom + m_nTop)/2;
    }
    //--------------------------------------------------------------------------
    command Uninitialize()
    {
        //wykasowac referencje
        SetTarget(null);
        m_uSpecialUnit = null;
    }
	//--------------------------------------------------------------------------
	command UserOneParam0(int nMode) button retreatMode priority 12 advanced
	{
		if (nMode == -1)
		{
			retreatMode = (retreatMode + 1) % 2;
		}
		else
		{
			retreatMode = nMode;
		}
	}
	//--------------------------------------------------------------------------
	command UserOneParam1(int nMode) button scoutMode priority 100 advanced
	{
        if (nMode == -1)
        {
            scoutMode = (scoutMode + 1) % 4;
        }
        else
        {
            scoutMode = nMode;
        }
		if(scoutMode)
        {
            CheckGameRect();
			state Scout;
        }
		else
			state Nothing;
	}
    //--------------------------------------------------------------------------
	command SetLights(int nMode) button lights hotkey priority 10
	{
		if (nMode == -1)
		{
			lights = (lights + 1) % 2;
		}
		else
		{
			lights = nMode;
		}

		if (lights == 0)
			SetLightsMode(lightsAUTO);
		else
			SetLightsMode(lightsOFF);

		NextCommand(1);
	}
    //--------------------------------------------------------------------------
    command SetMovementMode(int nMode) button movementMode priority 16
    {
        if (nMode == -1)
        {
            movementMode = (movementMode + 1) % 3;
        }
        else
        {
            movementMode = nMode;
        }
        NextCommand(0);
    }
    //--------------------------------------------------------------------------
	/*
    command SetAttackMode(int nMode) button attackMode description "translateCommandStateAttackModeDescription" priority 206 advanced
    {
        if (nMode == -1)
        {
            attackMode = (attackMode + 1) % 2;
        }
        else
        {
            attackMode = nMode;
        }
        NextCommand(0);
    }
	*/
    //--------------------------------------------------------------------------
    command Stop() button "translateCommandStop" item 123 description "translateCommandStopDescription" hotkey priority 20
    {
        SetTarget(null);
        StopCannonFire(-1);
        if(state==GettingSupply) return;
        m_nStayGx = GetLocationX();
        m_nStayGy = GetLocationY();
        m_nStayLz = GetLocationZ();
        if(IsMoving())
            CallStopMoving();

		scoutMode = 0;
		ChangedCommandValue();

        state Nothing;
    }
    //--------------------------------------------------------------------------
    command HoldPosition() hidden button "translateCommandHoldPosition" description "translateCommandHoldPositionDescription" hotkey priority 20
    {
			SetTarget(null);
			StopCannonFire(-1);
			if(state==GettingSupply && IsOnWorkingSupplyCenter()) return;
			m_nStayGx = GetLocationX();
			m_nStayGy = GetLocationY();
			m_nStayLz = GetLocationZ();
			movementMode = 2;
			if(IsMoving())
			CallStopMoving();
			ChangedCommandValue();
			state HoldPosition;
    }
    
    //--------------------------------------------------------------------------
    command Move(int nGx, int nGy, int nLz) hidden button "translateCommandMove" description "translateCommandMoveDescription" hotkey priority 21
    {
        SetTarget(null);
        m_nStayGx = nGx;
        m_nStayGy = nGy;
        m_nStayLz = nLz;
        m_nState = 3;
        if(state==GettingSupply && IsOnWorkingSupplyCenter()) return;
        CallMoveToPoint(nGx, nGy, nLz);

		scoutMode = 0;
		ChangedCommandValue();

        state StartMoving;
    }
    //--------------------------------------------------------------------------
    command Attack(unit uTarget) button "translateCommandAttack" item 124 description "translateCommandAttackDescription" hotkey priority 22
    {
		if ( uTarget.IsHelicopter() && ! CanCannonFireToAircraft(-1) )
		{
			false;
		}
		else if ( uTarget.IsLandTarget() && ! CanCannonFireToGround(-1) )
		{
			false;
		}
		else
		{
			SetTarget(uTarget);
			m_nAttackPhase=nonAttack;
			m_nState = 2;
			if(state==GettingSupply && IsOnWorkingSupplyCenter()) return;

			scoutMode = 0;
			ChangedCommandValue();

			state Attacking;
		}
    }
    
    /*kom_nEnda nie wystawiana na zewnatrz*/
    command AttackOnPoint(int nX, int nY, int nZ) hidden button "translateCommandAttack" 
    {
        SetTarget(null);
        m_nTargetGx = nX;
        m_nTargetGy = nY;
        m_nTargetLz = nZ;
        m_nAttackPhase = nonAttack;
        m_nState = 1;
        if(state==GettingSupply && IsOnWorkingSupplyCenter()) return;
		
		scoutMode = 0;
		ChangedCommandValue();
		
        state AttackingPoint;
    }
    
    //--------------------------------------------------------------------------
    command Patrol(int nGx, int nGy, int nLz) button "translateCommandPatrol" item 126 description "translateCommandPatrolDescription" hotkey priority 29 advanced
    {
		if(state==GettingSupply)return;
		m_nSpecialGx = nGx;
		m_nSpecialGy = nGy;
		m_nSpecialLz = nLz;
		m_nStayGx = GetLocationX();
		m_nStayGy = GetLocationY();
		m_nStayLz = GetLocationZ();
        SetSecondPatrolPoint(m_nStayGx, m_nStayGy, m_nStayLz);
		CallMoveToPoint(nGx, nGy, nLz);
		m_nSpecialCounter = 1;

		scoutMode = 0;
		ChangedCommandValue();

		state Patrol;
    }
    
      //--------------------------------------------------------------------------
	command Escort(unit uUnit) button "translateCommandEscort" item 125 description "translateCommandEscortDescription" hotkey priority 31 advanced
	{
		if(state==GettingSupply)return;
		m_uSpecialUnit=uUnit;
		m_nSpecialGx=GetLocationX()-m_uSpecialUnit.GetLocationX();
		m_nSpecialGy=GetLocationY()-m_uSpecialUnit.GetLocationY();
		if(m_nSpecialGx > 2) m_nSpecialGx=2;
		if(m_nSpecialGx < -2) m_nSpecialGx=-2;
		if(m_nSpecialGy > 2) m_nSpecialGy=2;
		if(m_nSpecialGy < -2) m_nSpecialGy=-2;

		scoutMode = 0;
		ChangedCommandValue();

		state Escort;
	}
	    //--------------------------------------------------------------------------
    command Enter(unit uEntrance) hidden button "translateCommandEnter"
    {
				if(state==GettingSupply && IsOnWorkingSupplyCenter()) return;
        CallMoveInsideObject(uEntrance);
        m_nTargetGx = GetEntranceX(uEntrance);
        m_nTargetGy = GetEntranceY(uEntrance);
        m_nTargetLz = GetEntranceZ(uEntrance);

		scoutMode = 0;
		ChangedCommandValue();

        state StartMoving;
    }
    //-------------------------------------------------------
    command MoveToWorld(int nWorldNum) button "translateCommandFlyToMission" item 134 priority 1
    {
        if (FindFlyToWorldDestination(nWorldNum))
        {
            m_nMoveToX = GetFoundFlyToWorldDestinationX();
            m_nMoveToY = GetFoundFlyToWorldDestinationY();
            m_nMoveToZ = GetFoundFlyToWorldDestinationZ();
            CallMoveHighToPoint(m_nMoveToX, m_nMoveToY, m_nMoveToZ);
		    scoutMode = 0;
		    ChangedCommandValue();
            state StartMovingToWorld;
            true;
        }
        else
        {
            false;
        }
    }
    //-------------------------------------------------------
	command RecycleUnit() button "translateCommandGoRecycle" item 136 description "translateCommandGoRecycleDescription" hotkey priority 140 advanced
    {
        if (FindFlyToRecycleDestination())
        {
            m_nMoveToX = GetFoundFlyToRecycleDestinationX();
            m_nMoveToY = GetFoundFlyToRecycleDestinationY();
            m_nMoveToZ = GetFoundFlyToRecycleDestinationZ();
            CallMoveHighToPoint(m_nMoveToX, m_nMoveToY, m_nMoveToZ);
		    scoutMode = 0;
		    ChangedCommandValue();
            state StartMovingToRecycle;
            true;
        }
        else
        {
            false;
        }
    }
    //-------------------------------------------------------
 /*   command UserOneParam9(int nMode) button traceMode priority 255
    {
    if (nMode == -1)
    {
    traceMode = (traceMode + 1) % 2;
    }
    else
    {
    traceMode = nMode;
    }
    }*/
    
    //for flyables
	/*
    command Land() button "translateCommandLand" description "translateCommandLandDescription" hotkey priority 31 
    {
        if(state==GettingSupply && IsOnWorkingSupplyCenter()) return;
        CallLand();
        state Nothing;
    }
    */
    command SupplyAmmo() button "translateCommandGetSupply" item 127 description "translateCommandGetSupplyDescription" hotkey priority 50 
    {
        if(state==GettingSupply && IsOnWorkingSupplyCenter()) return;
        if (HaveCannonsMissingAmmo())
        {
            if (FindSupplyCenterPlace())
            {
                m_nSpecialGx = GetLocationX(); 
                m_nSpecialGy = GetLocationY();
                
                m_nStayGx = GetFoundSupplyCenterPlaceX();
                m_nStayGy = GetFoundSupplyCenterPlaceY();
                m_nStayLz = GetFoundSupplyCenterPlaceZ();
                //CallMoveAndLandToPointForce(m_nStayGx, m_nStayGy, m_nStayLz);//jak bylo Force to stawaly w slupku
								CallMoveToPointForce(m_nStayGx, m_nStayGy, m_nStayLz);//dodane 25.01.2000

					scoutMode = 0;
					ChangedCommandValue();

				state MovingForGetSupply;
            }
            else
            {
                NextCommand(0);
            }
        }
        else
        {
            NextCommand(0);
        }
    }
    //-------------------------------------------------------
    command Land() button "translateCommandLand" item 161 description "translateCommandLandDescription" hotkey priority 31 
    {
		scoutMode = 0;
		ChangedCommandValue();

        CallLand();

        NextCommand(1);
        state Nothing;
    }
    //-------------------------------------------------------
    command SpecialChangeUnitsScript() hidden button "translateCommandChangeScript" description "translateCommandChangeScriptDescription" hotkey priority 254 
    {
        //special command - no implementation
    }
    //--------------------------------------------------------------------------
    /*button "Attack"
    description "euhwfduihewuif"
    hotkey   // flaga ze ma reagowac na klawisz do tej kom_nEndy
    priority 7 */
}