builder "translateScriptNameConstructionVechicle"
{
	include "Trace.ech"

    int m_bLastBridgeElement;

	state Nothing
	{
		if (traceMode) TraceD("Nothing\n");

		return Nothing;
	}

	function int StopCurrentAction()
	{
		RemoveAllElements();
		
		return true;
	}
    
	include "Lights.ech"
	include "Special.ech"

    ///              begin included scripts

	////             "RetreatCivil.ech"
    include "Retreat.ech"

    event OnHit()
    {
        if (m_bLastBridgeElement)
        {
            return false;
        }
	    if ( retreatMode && ((GetHP()*2) <= GetMaxHP()) )
	    {
		    m_nRetreatCounter=0;
		    state Retreat;
	    }
	    true;
    }

    function int InitializeRetreat()
    {
    //	retreatMode = 1;
    //	ChangedCommandValue();
    }


	////             "Recycle.ech"
    state WaitingForRecycle
    {
        state WaitingForRecycle;
    }

    event OnCheckRecycleUnit()
    {
        if (state == WaitingForRecycle)
        {
            true;
        }
        else
        {
            false;
        }
    }

    command RecycleUnit() button "translateCommandGoRecycle" item 136 description "translateCommandGoRecycleDescription" hotkey priority 140 advanced
    {
        if (m_bLastBridgeElement)
        {
            false;
            return;
        }
        if (GetLocationZ() == 0)
        {
            SendRecycleUnitRequest();
            state WaitingForRecycle;
        }
        else
        {
            //i tak po nas nie przyleci
            false;
        }
    }


	////                "Siege.ech"
    enum siegeMode
    {
	    "translateCommandStateSiegeModeMobile" item 180 description "translateCommandStateSiegeModeMobileDescription",
	    "translateCommandStateSiegeModeSiege" item 128 description "translateCommandStateSiegeModeSiegeDescription",
    multi:
	    "translateCommandStateSiegeMode" item 188 description "translateCommandStateSiegeModeDescription"
    }

    state InSiegeMode
    {
        state InSiegeMode;
    }

    state EnteringSiegeMode
    {
        if (CanEnterSiegeModeNow())
        {
            CallExBeginSiegeMode();
            state InSiegeMode;
        }
        else
        {
            state EnteringSiegeMode;
        }
    }

    command SiegeMode(int nMode) button siegeMode hotkey
    {
        if (m_bLastBridgeElement)
        {
            false;
            return;
        }
        if (nMode == -1)
        {
            siegeMode = (siegeMode + 1) % 2;
        }
        else
        {
            siegeMode = nMode;
        }
        if (siegeMode == 0)
        {
            //->mobile mode
            if (IsInSiegeMode())
            {
                CallExEndSiegeMode();
                state Nothing;
            }
        }
        else
        {
            //->siege mode
            if (CanEnterSiegeModeNow())
            {
                CallExBeginSiegeMode();
                state InSiegeMode;
            }
            else
            {
                if (IsMoving())
                {
                    CallStopMoving();
                }
                state EnteringSiegeMode;
            }
        }
        NextCommand(1);
    }


	///                 "Move.ech"
    int m_nMoveToGx;
    int m_nMoveToGy;
    int m_nMoveToLz;

    state Moving
    {
	    if (IsMoving())
	    {
		    if (traceMode) TraceD("Moving\n");

		    return Moving;
	    }
	    else
	    {
		    if (traceMode) TraceD("Moving -> Nothing\n");

		    NextCommand(1);
		    return Nothing;
	    }
    }

    state StartMoving
    {
	    return Moving, 20;
    }

    command Stop() button "translateCommandStop" item 123 description "translateCommandStopDescription" hotkey priority 20
    {
        if (m_bLastBridgeElement)
        {
            false;
            return;
        }
	    if ( ! StopCurrentAction() ) return;

	    if (IsMoving())
	    {
		    CallStopMoving();
	    }

	    state Nothing;
    }

    command Move(int nGx, int nGy, int nLz) hidden button "translateCommandMove" item 102 description "translateCommandMoveDescription" hotkey priority 21
    {
        if (m_bLastBridgeElement)
        {
            false;
            return;
        }
	    if ( ! StopCurrentAction() ) return;

	    m_nMoveToGx = nGx;
	    m_nMoveToGy = nGy;
	    m_nMoveToLz = nLz;

	    CallMoveToPoint(m_nMoveToGx, m_nMoveToGy, m_nMoveToLz);

	    state StartMoving;
    }

    command Enter(unit uEntrance) hidden button "translateCommandEnter"
    {
        if (m_bLastBridgeElement)
        {
            false;
            return;
        }
	    if ( ! StopCurrentAction() ) return;

	    // TODO: sprawdzic czy to cos daje...
	    m_nMoveToGx = GetEntranceX(uEntrance);
	    m_nMoveToGy = GetEntranceY(uEntrance);
	    m_nMoveToLz = GetEntranceZ(uEntrance);

	    CallMoveInsideObject(uEntrance);

	    state StartMoving;
    }

    ///             end included scripts


	state BuildBuilding
	{
		if (IsBuildWorking())
		{
			return BuildBuilding;
		}
		else
		{
			NextCommand(1);//!!1 czy 0?
			return Nothing;
		}
	}

	state MovingToBuildBuilding
	{
		if (IsMoving())
		{
			if(traceMode) TraceD("BuildRobot->IsMoving\n");
			return MovingToBuildBuilding;
		}
		else
		{
			if (IsInGoodPointForCurrentBuild())
			{
				if(traceMode)     TraceD("BuildRobot->CallBuildBuilding\n");
				CallBuildBuilding();
				return BuildBuilding;
			}
			else
			{
				//!!jakis licznik?
				m_nMoveToGx = GetCurrentBuildLocationX();
				m_nMoveToGy = GetCurrentBuildLocationY();
				m_nMoveToLz = GetCurrentBuildLocationZ();
				CallMoveToPointForce(m_nMoveToGx, m_nMoveToGy, m_nMoveToLz);
				return MovingToBuildBuilding;
			}
		}
	}

	state BuildElement;

	state MovingToBuildElement
	{
        int nBuildType;
		if (IsMoving())
		{
			return MovingToBuildElement;
		}
		else
		{
			if (IsInGoodPointForCurrentBuild())
			{
				CallBuildCurrentElement();
                nBuildType = GetCurrentBuildType();
                if (((nBuildType == buildNarrowBridge) || (nBuildType == buildWideBridge)) && IsLastElement())
                {
                    m_bLastBridgeElement = true;
                }
                else
                {
                    m_bLastBridgeElement = false;
                }
				return BuildElement;
			}
			else
			{
				//!!jakis licznik?
				m_nMoveToGx = GetCurrentBuildLocationX();
				m_nMoveToGy = GetCurrentBuildLocationY();
				m_nMoveToLz = GetCurrentBuildLocationZ();
				CallMoveToPointForce(m_nMoveToGx, m_nMoveToGy, m_nMoveToLz);
				return MovingToBuildElement;
			}
		}
	}

	state BuildElement
	{
		if (IsBuildWorking())
		{
			return BuildElement;
		}
		else
		{
			if (NextElementPoint())
			{
				m_nMoveToGx = GetCurrentBuildLocationX();
				m_nMoveToGy = GetCurrentBuildLocationY();
				m_nMoveToLz = GetCurrentBuildLocationZ();
				CallMoveToPointForce(m_nMoveToGx, m_nMoveToGy, m_nMoveToLz);
				return MovingToBuildElement;
			}
			else
			{
				NextCommand(1);//!!1 czy 0?
                m_bLastBridgeElement = false;
				return Nothing;
			}
		}
	}

	int m_nPreviousState;

	function int ResumePreviousState()
	{
		if ( m_nPreviousState == Retreat )
			state Retreat;
		else if ( m_nPreviousState == Nothing )
			state Nothing;
		else if ( m_nPreviousState == Moving || m_nPreviousState == StartMoving)
		{
			CallMoveToPoint(m_nMoveToGx, m_nMoveToGy, m_nMoveToLz);
			state StartMoving;
		}
		else if ( m_nPreviousState == BuildBuilding || m_nPreviousState == MovingToBuildBuilding )
			state MovingToBuildBuilding;
		else if ( m_nPreviousState == BuildElement || m_nPreviousState == MovingToBuildElement )
			state MovingToBuildElement;
		else if ( m_nPreviousState == EnteringSiegeMode )
			state EnteringSiegeMode;
		else if ( m_nPreviousState == InSiegeMode )
			state InSiegeMode;
		else
			state Nothing;
	}

	///             "Freeze.ech"
    state Froozen
    {
	    if (IsFroozen())
	    {
		    if (traceMode) TraceD("Froozen\n");

		    state Froozen;
	    }
	    else
	    {
		    if (traceMode) TraceD("Froozen -> PreviousState\n");

		    ResumePreviousState();
	    }
    }
    event OnFreezeForSupplyOrRepair(int nFreezeTicks)
    {
        if (m_bLastBridgeElement)
        {
            return false;
        }
	    CallFreeze(nFreezeTicks);

	    if ( state != Froozen ) m_nPreviousState = state;

	    state Froozen;
	    true;
    }


	/* TODO: Bylo takie cos - czy ma tak byc ???
	event OnFreezeForSupplyOrRepair(int nFreezeTicks)
	{
        if (m_bLastBridgeElement)
        {
            return false;
        }
		//CallFreeze(nFreezeTicks);
		//state Froozen;
		true;
	}
	*/

	command Initialize()
	{
		InitializeRetreat();
        m_bLastBridgeElement = false;
	}

	command Uninitialize()
	{
	}

	//bez nazwy - wywolywane po wybraniu miejsca
	command BuildBuilding(int nX, int nY, int nZ, int nAlpha, int nID) hidden button "translateCommandBuilding"
	{
        if (m_bLastBridgeElement)
        {
            false;
            return;
        }
		SetBuildTypeBuildBuilding(nX, nY, nZ, nAlpha, nID);
		m_nMoveToGx = GetCurrentBuildLocationX();
		m_nMoveToGy = GetCurrentBuildLocationY();
		m_nMoveToLz = GetCurrentBuildLocationZ();
		CallMoveToPointForce(m_nMoveToGx, m_nMoveToGy, m_nMoveToLz);
		state MovingToBuildBuilding;
		true;
	}

	command BuildTrench(int nX1, int nY1, int nZ1, int nX2, int nY2, int nZ2) button "translateCommandTrench" hotkey
	{
        if (m_bLastBridgeElement)
        {
            false;
            return;
        }
		SetBuildTypeBuildElements(buildTrench);
		if (AddElementsLine(nX1, nY1, nZ1, nX2, nY2, nZ2))
		{
			m_nMoveToGx = GetCurrentBuildLocationX();
			m_nMoveToGy = GetCurrentBuildLocationY();
			m_nMoveToLz = GetCurrentBuildLocationZ();
			CallMoveToPointForce(m_nMoveToGx, m_nMoveToGy, m_nMoveToLz);
			state MovingToBuildElement;
		}
		true;
	}

	command BuildFlatTerrain(int nX1, int nY1, int nZ1, int nX2, int nY2, int nZ2) button "translateCommandFlatten" hotkey
	{
        if (m_bLastBridgeElement)
        {
            false;
            return;
        }
		SetBuildTypeBuildElements(buildFlatTerrain);
		if (AddElementsLine(nX1, nY1, nZ1, nX2, nY2, nZ2))
		{
			m_nMoveToGx = GetCurrentBuildLocationX();
			m_nMoveToGy = GetCurrentBuildLocationY();
			m_nMoveToLz = GetCurrentBuildLocationZ();
			CallMoveToPointForce(m_nMoveToGx, m_nMoveToGy, m_nMoveToLz);
			state MovingToBuildElement;
		}
		true;
	}

	command BuildWall(int nX1, int nY1, int nZ1, int nX2, int nY2, int nZ2) button "translateCommandWall" hotkey
	{
        if (m_bLastBridgeElement)
        {
            false;
            return;
        }
		SetBuildTypeBuildElements(buildWall);
		if (AddElementsLine(nX1, nY1, nZ1, nX2, nY2, nZ2))
		{
			m_nMoveToGx = GetCurrentBuildLocationX();
			m_nMoveToGy = GetCurrentBuildLocationY();
			m_nMoveToLz = GetCurrentBuildLocationZ();
			CallMoveToPointForce(m_nMoveToGx, m_nMoveToGy, m_nMoveToLz);
			state MovingToBuildElement;
		}
		true;
	}

	command BuildWideBridge(int nX1, int nY1, int nZ1, int nX2, int nY2, int nZ2) button "translateCommandBridge2" hotkey
	{
        if (m_bLastBridgeElement)
        {
            false;
            return;
        }
		SetBuildTypeBuildElements(buildWideBridge);
		if (AddElementsLine(nX1, nY1, nZ1, nX2, nY2, nZ2))
		{
			m_nMoveToGx = GetCurrentBuildLocationX();
			m_nMoveToGy = GetCurrentBuildLocationY();
			m_nMoveToLz = GetCurrentBuildLocationZ();
			CallMoveToPointForce(m_nMoveToGx, m_nMoveToGy, m_nMoveToLz);
			state MovingToBuildElement;
		}
		true;
	}

	command BuildNarrowBridge(int nX1, int nY1, int nZ1, int nX2, int nY2, int nZ2) button "translateCommandBridge1" hotkey
	{
        if (m_bLastBridgeElement)
        {
            false;
            return;
        }
		SetBuildTypeBuildElements(buildNarrowBridge);
		if (AddElementsLine(nX1, nY1, nZ1, nX2, nY2, nZ2))
		{
			m_nMoveToGx = GetCurrentBuildLocationX();
			m_nMoveToGy = GetCurrentBuildLocationY();
			m_nMoveToLz = GetCurrentBuildLocationZ();
			CallMoveToPointForce(m_nMoveToGx, m_nMoveToGy, m_nMoveToLz);
			state MovingToBuildElement;
		}
		true;
	}

	command SpecialNextAngle() button "translateCommandTurn" item 137 description "translateCommandTurnDescription" hotkey priority 255
	{
		//implemented in code
	}
}
