movingbuilding "translateScriptNameUnarmedVechicle"
{
	include "Trace.ech"

	state Nothing
	{
		if (traceMode) TraceD("Nothing\n");

		return Nothing;
	}

	state SettingToSiegeMode
	{
		if (IsBuildingToSiegeMode())
		{
			if (traceMode) TraceD("SettingToSiegeMode\n");

			state SettingToSiegeMode;
		}
		else
		{
			//jesli ciagle zyjemy to znaczy ze nie udalo sie postawic budynku
			NextCommand(0);

			if (traceMode) TraceD("SettingToSiegeMode -> Nothing\n");

			state Nothing;
		}
	}

	function int StopCurrentAction()
	{
		return true;
	}

	include "Lights.ech"
	include "RetreatCivil.ech"
	include "PatrolCivil.ech"
	include "EscortCivil.ech"
	include "Recycle.ech"
	include "Move.ech"
	include "Special.ech"

	int m_nPreviousState;

	function int ResumePreviousState()
	{
		if ( m_nPreviousState == Retreat )
			state Retreat;
		else if ( m_nPreviousState == Nothing )
			state Nothing;
		else if ( m_nPreviousState == Moving || m_nPreviousState == StartMoving)
		{
			CallMoveToPoint(m_nMoveToGx, m_nMoveToGy, m_nMoveToLz);
			state StartMoving;
		}
		else if ( m_nPreviousState == Patrol )
			state Patrol;
		else if ( m_nPreviousState == Escort )
			state Escort;
		else if ( m_nPreviousState == SettingToSiegeMode ) // TODO: sprawdzic czy to jest potrzebne.
		{
			CallBuildingToSiegeMode();
			state SettingToSiegeMode;
		}
		else
			state Nothing;
	}

	include "Freeze.ech"

	command Initialize()
	{
		InitializeRetreat();
	}

	command Uninitialize()
	{
		m_uEscortUnit = null;
	}

    command MovingBuildingToSiegeMode() button "translateCommandMovingBuildingToSiegeMode" item 162 description "translateCommandMovingBuildingToSiegeMode" priority 250
    {
        CallBuildingToSiegeMode();

        state SettingToSiegeMode;
    }

	event OnCannonLowAmmo(int nCannonNum)
	{
		true;
	}

	event OnCannonNoAmmo(int nCannonNum)
	{
		true;
	}

	event OnCannonFoundTarget(int nCannonNum, unit uTarget)
	{
		false; //gdyby zwrocic true to dzialko nie strzeli
	}

	event OnCannonEndFire(int nCannonNum, int nEndStatus)
	{
		false;
	}

	event OnTransported(int bToNewWorld)
	{
	}
}
