sapper "translateScriptNameMiner"
{
	include "Trace.ech"

	state Nothing
	{
		if (traceMode) TraceD("Nothing\n");

		return Nothing;
	}

	function int StopCurrentAction()
	{
		ResetMinePoints();

		return true;
	}

	include "Lights.ech"
	include "RetreatCivil.ech"
	include "Recycle.ech"
	include "Siege.ech"
	include "Move.ech"
	include "Special.ech"

	int m_nPreviousState;

	int m_nMinePointGx;
	int m_nMinePointGy;
	int m_nMinePointLz;

	state PuttingMine;
	state WaitForMines;

	state MovingToMinePutPoint
	{
		if (IsMoving())
		{
			if (traceMode) TraceD("MovingToMinePutPoint\n");

			return MovingToMinePutPoint;
		}
		else
		{
			if ((GetLocationX() == m_nMinePointGx) && (GetLocationY() == m_nMinePointGy) && (GetLocationZ() == m_nMinePointLz))
			{
				if (HaveMines())
				{
					CallPutMine();

					if (traceMode) TraceD("MovingToMinePutPoint -> PuttingMine\n");

					return PuttingMine;
				}
				else
				{
					if (traceMode) TraceD("MovingToMinePutPoint -> WaitForMines\n");

					return WaitForMines;
				}
			}
			else
			{
				//moze zastosowac jakis licznik (po wyzerowaniu ktorego przechodzimy do nastepnego punktu) 
				//zeby w kolko nie wywolywac ponizszego
				CallMoveToPointForce(m_nMinePointGx, m_nMinePointGy, m_nMinePointLz);

				if (traceMode) TraceD("MovingToMinePutPoint\n");

				return MovingToMinePutPoint;
			}
		}
	}

	state PuttingMine
	{
		if (IsPuttingMine())
		{
			//jeszcze nie skonczyl
			if (traceMode) TraceD("PuttingMine\n");

			state PuttingMine;
		}
		else
		{
			if (NextMinePoint())
			{
				m_nMinePointGx = GetCurrMinePointX();
				m_nMinePointGy = GetCurrMinePointY();
				m_nMinePointLz = GetCurrMinePointZ();
				CallMoveToPointForce(m_nMinePointGx, m_nMinePointGy, m_nMinePointLz);

				if (traceMode) TraceD("PuttingMine -> MovingToMinePutPoint\n");

				return MovingToMinePutPoint;
			}
			else
			{
				//nie ma juz wiecej punktow do zaminowania
				NextCommand(1);

				if (traceMode) TraceD("PuttingMine -> Nothing\n");

				return Nothing;
			}
		}
	}

	state WaitForMines
	{
		if (HaveMines())
		{
			CallPutMine();

			if (traceMode) TraceD("WaitForMines -> PuttingMine\n");

			return PuttingMine;
		}
		else
		{
			if (traceMode) TraceD("WaitForMines\n");

			return WaitForMines;
		}
	}

	function int ResumePreviousState()
	{
		if ( m_nPreviousState == Retreat )
			state Retreat;
		else if ( m_nPreviousState == Nothing )
			state Nothing;
		else if ( m_nPreviousState == Moving || m_nPreviousState == StartMoving)
		{
			CallMoveToPoint(m_nMoveToGx, m_nMoveToGy, m_nMoveToLz);
			state StartMoving;
		}
		else if ( m_nPreviousState == MovingToMinePutPoint || m_nPreviousState == PuttingMine || m_nPreviousState == WaitForMines )
		{
			CallMoveToPoint(m_nMinePointGx, m_nMinePointGy, m_nMinePointLz);
			state MovingToMinePutPoint;
		}
		else if ( m_nPreviousState == EnteringSiegeMode )
			state EnteringSiegeMode;
		else if ( m_nPreviousState == InSiegeMode )
			state InSiegeMode;
		else
			state Nothing;
	}

	include "Freeze.ech"

	command Initialize()
	{
		InitializeRetreat();
	}

	command MineTerrainClose(int nX1, int nY1, int nZ1, int nX2, int nY2, int nZ2) button "translateCommandMineTerrainClose" item 130 description "translateCommandMineTerrainCloseDescription" hotkey priority 103
	{
		ResetMinePoints();

		if (AddMineAreaClose(nX1, nY1, nZ1, nX2, nY2, nZ2))
		{
			m_nMinePointGx = GetCurrMinePointX();
			m_nMinePointGy = GetCurrMinePointY();
			m_nMinePointLz = GetCurrMinePointZ();
			
			CallMoveToPointForce(m_nMinePointGx, m_nMinePointGy, m_nMinePointLz);
			
			state MovingToMinePutPoint;
		}
		else
		{
			//nie mozna postawic miny na zadnym punkcie tego obszaru
		}
		true;
	}

	command SupplyAmmo() button "translateCommandSupply" item 127 description "translateCommandSupplyDescription" hotkey priority 27
	{
		SendSupplyRequest();

		true;
	}
}
