supplier "translateScriptNameSupplyTransporter"
{
    enum lights
    {
        "translateCommandStateLightsAUTO" item 100 description "translateCommandStateLightsAUTODescription",
        "translateCommandStateLightsOFF" item 101 description "translateCommandStateLightsOFFDescription",
multi:
        "translateCommandStateLightsMode" item 150 description "translateCommandStateLightsModeDescription"
    }

	enum retreatMode
	{
		"translateCommandStateNoRetreat" item 102 description "translateCommandStateNoRetreatDescription",
		"translateCommandStateRetreat" item 103 description "translateCommandStateRetreatDescription",
multi:
		"translateCommandStateRetreatMode" item 151 description "translateCommandStateRetreatModeDescription"
	}
    
	enum traceMode
	{
		"translateCommandStateTraceOFF" item 101 description "Trace OFF",
		"translateCommandStateTraceON" item 100 description "Trace ON",
multi:
		"translateCommandStateTraceMode" item 102 description "Trace Mode"
	}

    int m_nMoveToX;
    int m_nMoveToY;
    int m_nMoveToZ;

	int m_nSpecialCounter;

	int m_bInitialize;
    
    state Initialize;
    state Nothing;
    state StartMoving;
    state Moving;
    state MovingToAssemblyPoint;
    state MovingToSupplyCenter;
    state MovingToObjectForSupply;
    state StartMovingToWorld;
    state MovingToWorld;
    state StartMovingToRecycle;
    state MovingToRecycle;
    state LoadingAmmo;
    state PuttingAmmo;
	state Retreat;
    
    state Initialize
    {
		return Nothing;
    }

	state Retreat
	{
		unit uTarget;

		if (!m_nSpecialCounter)
		{
			uTarget = FindClosestEnemy();
			m_nSpecialCounter = (m_nSpecialCounter+1)%16;
		}
		else
		{
			if (IsMoving())
				m_nSpecialCounter = (m_nSpecialCounter+1)%16;
			else
				m_nSpecialCounter = 0;

			if (traceMode) TraceD("Retreat\n");

			return Retreat;
		}
		
		if (!uTarget)
		{
			if (IsMoving())
				CallStopMoving();

			if (traceMode) TraceD("Retreat -> Nothing\n");

			return Nothing;
		}

		m_nMoveToX = 2*GetLocationX() - uTarget.GetLocationX();
		m_nMoveToY = 2*GetLocationY() - uTarget.GetLocationY();
		m_nMoveToZ = GetLocationZ();

		CallMoveToPoint(m_nMoveToX,m_nMoveToY,m_nMoveToZ);

		if (traceMode) TraceD("Retreat (Enemy)\n");

		return Retreat;
	}
    
    state Nothing
    {
        int bIsEnd;
        if (HaveObjectsForSupply())
        {
            //kontynujemy zaopatrzenie bo nie mozna zostawic zadnego obiektu
            bIsEnd = false;
            while (!bIsEnd && !CanCurrentObjectBeSupplied())
            {
                if (!NextObjectForSupply())
                {
                    bIsEnd = true;
                }
            }
            if (!bIsEnd)
            {
                m_nMoveToX = GetCurrentPutSupplyPositionX();
                m_nMoveToY = GetCurrentPutSupplyPositionY();
                m_nMoveToZ = GetCurrentPutSupplyPositionZ();
                CallMoveToPointForce(m_nMoveToX, m_nMoveToY, m_nMoveToZ);
                return MovingToObjectForSupply;
            }
            else
            {
				if (traceMode) TraceD("Nothing\n");

                return Nothing;
            }
        }
        else
        {
			return Nothing;

        }
    }
    
    state StartMoving
    {
        return Moving, 20;
    }
    //--------------------------------------------------------------------------
    state Moving
    {
        if(traceMode)TraceD("state Moving                                                \n");
        if (IsMoving())
        {
            return Moving;
        }
        else
        {
            NextCommand(1);
            return Nothing;
        }
    }
    //--------------------------------------------------------------------------
    state StartMovingToWorld
    {
        return MovingToWorld;
    }
    //-------------------------------------------------------
    state MovingToWorld
    {
        if (IsMoving())
        {
            if ((Distance(GetLocationX(), GetLocationY(), m_nMoveToX, m_nMoveToY) <= 1) &&
                (GetLocationZ() == m_nMoveToZ))
            {
                //znikamy wczesniej aby nie bylo widac zatrzymujacego sie helikoptera
                EndFlyingToSpecialDestination();
            }
            return MovingToWorld;
        }
        else
        {
            EndFlyingToSpecialDestination();
        }
    }
    //-------------------------------------------------------
    state StartMovingToRecycle
    {
        return MovingToRecycle;
    }
    //-------------------------------------------------------
    state MovingToRecycle
    {
        if (IsMoving())
        {
            if ((Distance(GetLocationX(), GetLocationY(), m_nMoveToX, m_nMoveToY) <= 1) &&
                (GetLocationZ() == m_nMoveToZ))
            {
                //znikamy wczesniej aby nie bylo widac zatrzymujacego sie helikoptera
                EndFlyingToSpecialDestination();
            }
            return MovingToRecycle;
        }
        else
        {
            EndFlyingToSpecialDestination();
        }
    }
    //-------------------------------------------------------
    state MovingToAssemblyPoint
    {
        if(traceMode)TraceD("state MovingToAssemblyPoint                                \n");
        if (IsMoving())
        {
            return MovingToAssemblyPoint;
        }
        else
        {
            return Nothing;
        }
    }
    
    state MovingToSupplyCenter
    {
        int nPosX;
        int nPosY;
        int nPosZ;
        if (IsMoving())
        {
            if(traceMode)TraceD("M -> SC                                                \n");
						nPosX = GetLocationX();
            nPosY = GetLocationY();
            nPosZ = GetLocationZ();
            if ((nPosX == m_nMoveToX) && (nPosY == m_nMoveToY) && (nPosZ == m_nMoveToZ))//added 25.01.2000
							CallStopMoving();
            return MovingToSupplyCenter;
        }
        else
        {
            nPosX = GetLocationX();
            nPosY = GetLocationY();
            nPosZ = GetLocationZ();
            if(traceMode)TraceD("M -> SC                                                \n");
            if ((nPosX == m_nMoveToX) && (nPosY == m_nMoveToY) && (nPosZ == m_nMoveToZ))
            {
                if(traceMode)TraceD("M -> SC OK                                               \n");
                CallLoadAmmo();
                return LoadingAmmo;
            }
            else
            {
                if(traceMode)TraceD("M -> SC Again                                                \n");
                //CallMoveAndLandToPointForce(m_nMoveToX, m_nMoveToY, m_nMoveToZ);
								CallMoveToPointForce(m_nMoveToX, m_nMoveToY, m_nMoveToZ);//dodane 09.03.2000
                return MovingToSupplyCenter;
            }
        }
    }
    
    state MovingToObjectForSupply
    {
        int nPosX;
        int nPosY;
        int nPosZ;
        int bIsEnd;
        if (IsMoving())
        {
            if (!CanCurrentObjectBeSupplied())
            {
                CallStopMoving();
                return MovingToObjectForSupply;
            }
            CheckCurrentPutSupplyLocation();
            if(m_nMoveToX != GetCurrentPutSupplyPositionX()||
                m_nMoveToY != GetCurrentPutSupplyPositionY())
            {
                m_nMoveToX = GetCurrentPutSupplyPositionX();
                m_nMoveToY = GetCurrentPutSupplyPositionY();
                m_nMoveToZ = GetCurrentPutSupplyPositionZ();
                CallMoveToPointForce(m_nMoveToX, m_nMoveToY, m_nMoveToZ);
            }       
            
            //XXXMD zrobic gonienie czolgu
            if(traceMode)TraceD("state MovingToObjectForSupply 1                               \n");
            return MovingToObjectForSupply;
        }
        else
        {
            if (IsInGoodCurrentPutSupplyLocation())
            {
                if(traceMode)TraceD("state MovingToObjectForSupply 2                               \n");
                CallPutAmmo();
                return PuttingAmmo;
            }
            else
            {
                if(traceMode)TraceD("state MovingToObjectForSupply 3                               \n");
                //nie jest w dobrym miejscu
                if (CanCurrentObjectBeSupplied())
                {
                    m_nMoveToX = GetCurrentPutSupplyPositionX();
                    m_nMoveToY = GetCurrentPutSupplyPositionY();
                    m_nMoveToZ = GetCurrentPutSupplyPositionZ();
                    if(traceMode)TraceD("state MovingToObjectForSupply 4                               \n");
                    CallMoveToPointForce(m_nMoveToX, m_nMoveToY, m_nMoveToZ);
                    return MovingToObjectForSupply;
                }
                else
                {
                    if(traceMode)TraceD("state MovingToObjectForSupply - Can't be supplied\n");
                    //nie mozna do niego dojechac (pod ziemia), lub zabity - biezemy nastepnego
                    bIsEnd = false;
                    do
                    {
                        if (!NextObjectForSupply())
                        {
                            bIsEnd = true;
                        }
                    }
                    while (!bIsEnd && !CanCurrentObjectBeSupplied());
                    if (!bIsEnd)
                    {
                        m_nMoveToX = GetCurrentPutSupplyPositionX();
                        m_nMoveToY = GetCurrentPutSupplyPositionY();
                        m_nMoveToZ = GetCurrentPutSupplyPositionZ();
                        CallMoveToPointForce(m_nMoveToX, m_nMoveToY, m_nMoveToZ);
                        return MovingToObjectForSupply;
                    }
                    else
                    {
                        //nie ma juz obiektow do zaopatrzenia - wracamy do punktu zbiorki
                        if (GetSupplyCenterBuilding() != null)
                        {
                            m_nMoveToX = GetSupplyCenterAssemblyPositionX();
                            m_nMoveToY = GetSupplyCenterAssemblyPositionY();
                            m_nMoveToZ = GetSupplyCenterAssemblyPositionZ();
                            CallMoveToPoint(m_nMoveToX, m_nMoveToY, m_nMoveToZ);
                            return MovingToAssemblyPoint;
                        }
                        else
                        {
                            return Nothing;
                        }
                    }
                }
            }
        }
    }
    
    state LoadingAmmo
    {
        int bIsEnd;
        if (IsLoadingAmmo())
        {
            return LoadingAmmo;
        }
        else
        {
            if (HaveObjectsForSupply())
            {
                bIsEnd = false;
                while (!bIsEnd && !CanCurrentObjectBeSupplied())
                {
                    if (!NextObjectForSupply())
                    {
                        bIsEnd = true;
                    }
                }
                if (!bIsEnd)
                {
                    m_nMoveToX = GetCurrentPutSupplyPositionX();
                    m_nMoveToY = GetCurrentPutSupplyPositionY();
                    m_nMoveToZ = GetCurrentPutSupplyPositionZ();
                    CallMoveToPointForce(m_nMoveToX, m_nMoveToY, m_nMoveToZ);
                    return MovingToObjectForSupply;
                }
                else
                {
                    //nie ma obiektow do zaopatrzenia - wracamy do punktu zbiorki
                    if (GetSupplyCenterBuilding() != null)
                    {
                        m_nMoveToX = GetSupplyCenterAssemblyPositionX();
                        m_nMoveToY = GetSupplyCenterAssemblyPositionY();
                        m_nMoveToZ = GetSupplyCenterAssemblyPositionZ();
                        CallMoveToPoint(m_nMoveToX, m_nMoveToY, m_nMoveToZ);
                        return MovingToAssemblyPoint;
                    }
                    else
                    {
                        return Nothing;
                    }
                }
            }
            else
            {
                //nie ma obiektow do zaopatrzenia - wracamy do punktu zbiorki
                if (GetSupplyCenterBuilding() != null)
                {
                    m_nMoveToX = GetSupplyCenterAssemblyPositionX();
                    m_nMoveToY = GetSupplyCenterAssemblyPositionY();
                    m_nMoveToZ = GetSupplyCenterAssemblyPositionZ();
                    CallMoveToPoint(m_nMoveToX, m_nMoveToY, m_nMoveToZ);
                    return MovingToAssemblyPoint;
                }
                else
                {
                    return Nothing;
                }
            }
        }
    }
    
    state PuttingAmmo
    {
        int bIsEnd;
        if (IsPuttingAmmo())
        {
            return PuttingAmmo;
        }
        else
        {
            //sprawdzic czy wrzucono amunicje do biezacego obiektu
            if (WasCurrentObjectSupplied())
            {
                //ok jedziemy do nastepnego
                bIsEnd = false;
                do 
                {
                    if (!NextObjectForSupply())
                    {
                        bIsEnd = true;
                    }
                }
                while (!bIsEnd && !CanCurrentObjectBeSupplied());
                if (!bIsEnd)
                {
                    m_nMoveToX = GetCurrentPutSupplyPositionX();
                    m_nMoveToY = GetCurrentPutSupplyPositionY();
                    m_nMoveToZ = GetCurrentPutSupplyPositionZ();
                    CallMoveToPointForce(m_nMoveToX, m_nMoveToY, m_nMoveToZ);
                    return MovingToObjectForSupply;
                }
                else
                {
                    //nie ma juz obiektow do zaopatrzenia - wracamy do punktu zbiorki
                    if (GetSupplyCenterBuilding() != null)
                    {
                        m_nMoveToX = GetSupplyCenterAssemblyPositionX();
                        m_nMoveToY = GetSupplyCenterAssemblyPositionY();
                        m_nMoveToZ = GetSupplyCenterAssemblyPositionZ();
                        CallMoveToPoint(m_nMoveToX, m_nMoveToY, m_nMoveToZ);
                        return MovingToAssemblyPoint;
                    }
                    else
                    {
                        return Nothing;
                    }
                }
            }
            else
            {
                //nie wrzucilismy zaopatrzenia do niego bo np. odjechal
                bIsEnd = false;
                while (!bIsEnd && !CanCurrentObjectBeSupplied())
                {
                    if (!NextObjectForSupply())
                    {
                        bIsEnd = true;
                    }
                }
                if (!bIsEnd)
                {
                    m_nMoveToX = GetCurrentPutSupplyPositionX();
                    m_nMoveToY = GetCurrentPutSupplyPositionY();
                    m_nMoveToZ = GetCurrentPutSupplyPositionZ();
                    CallMoveToPointForce(m_nMoveToX, m_nMoveToY, m_nMoveToZ);
                    return MovingToObjectForSupply;
                }
                else
                {
                    //nie ma obiektow do zaopatrzenia - wracamy do punktu zbiorki
                    if (GetSupplyCenterBuilding() != null)
                    {
                        m_nMoveToX = GetSupplyCenterAssemblyPositionX();
                        m_nMoveToY = GetSupplyCenterAssemblyPositionY();
                        m_nMoveToZ = GetSupplyCenterAssemblyPositionZ();
                        CallMoveToPoint(m_nMoveToX, m_nMoveToY, m_nMoveToZ);
                        return MovingToAssemblyPoint;
                    }
                    else
                    {
                        return Nothing;
                    }
                }
            }
        }
    }
    
    //------------------------------------------------------- 
    state Froozen
    {
        if (IsFroozen())
        {
            state Froozen;
        }
        else
        {
            //!!wrocic do tego co robilismy
            state Nothing;
        }
    }

	event OnHit()
	{
		if ( retreatMode && ((GetHP()*2) <= GetMaxHP()) )
		{
			m_nSpecialCounter=0;
			state Retreat;
		}
		true;
	}
    
    event OnFreezeForSupplyOrRepair(int nFreezeTicks)
    {
        CallFreeze(nFreezeTicks);
        state Froozen;
        true;
    }

    event OnCheckRecycleUnit()
    {
        if (state == MovingToRecycle)
        {
            true;
        }
        else
        {
            false;
        }
    }
    //------------------------------------------------------- 
    
    event CheckFreeSupplier(unit supplyCenter)
    {
        if (!HaveObjectsForSupply() && (state != MovingToSupplyCenter) && (state != LoadingAmmo))
        {
            true;
        }
        else
        {
            false;
        }
    }
    //------------------------------------------------------- 

    command Initialize()
    {
        /*
		unit uSupplyCenter;
		uSupplyCenter = FindSupplyCenter();
		
        if ((uSupplyCenter != null) && SetSupplyCenterBuilding(uSupplyCenter))
        {
			m_bInitialize = true;

			m_nMoveToX = GetSupplyCenterAssemblyPositionX();
			m_nMoveToY = GetSupplyCenterAssemblyPositionY();
			m_nMoveToZ = GetSupplyCenterAssemblyPositionZ();
		}
		else
		{
			m_bInitialize = false;
		}
        */
//		retreatMode = 1;
//		ChangedCommandValue();

        false;
    }
    
    command Uninitialize()
    {
        //wykasowac referencje
        false;
    }
    
    //komenda wydawana tylko przez budynek supplyCenter
    command MoveToSupplyCenterForLoading(unit uSupplyCenter)
    {
        if(traceMode)TraceD("command MoveToSupplyCenterForLoading\n");
        if (!HaveObjectsForSupply() && (state != LoadingAmmo))
        {
            SetSupplyCenterBuilding(uSupplyCenter);
            m_nMoveToX = GetSupplyCenterLoadPositionX();
            m_nMoveToY = GetSupplyCenterLoadPositionY();
            m_nMoveToZ = GetSupplyCenterLoadPositionZ();
            //CallMoveAndLandToPointForce(m_nMoveToX, m_nMoveToY, m_nMoveToZ);
						CallMoveToPointForce(m_nMoveToX, m_nMoveToY, m_nMoveToZ);//dodane 09.03.2000
            state MovingToSupplyCenter;
        }
        //komenda wewnetrzna z budynku wiec nie wolamy NextCommand
        true;
    }
    
    command Move(int nGx, int nGy, int nLz) hidden button "translateCommandMove" description "translateCommandMoveDescription" hotkey priority 21
    {
        /*
		if ( m_bInitialize )
		{
			m_bInitialize = false;
		}
		else
        (
        */
		{
			m_nMoveToX = nGx;
			m_nMoveToY = nGy;
			m_nMoveToZ = nLz;
		}

        CallMoveToPoint(m_nMoveToX, m_nMoveToY, m_nMoveToZ);
        state StartMoving;
        true;
    }
    
    command Enter(unit uEntrance) hidden button "translateCommandEnter"
    {
        m_nMoveToX = GetEntranceX(uEntrance);
        m_nMoveToY = GetEntranceY(uEntrance);
        m_nMoveToZ = GetEntranceZ(uEntrance);
        CallMoveInsideObject(uEntrance);
        state StartMoving;
        true;
    }

    /*
	command GoRecycle() button "translateCommandGoRecycle" item 136 description "translateCommandGoRecycleDescription" hotkey priority 140 advanced
    {
        unit uEntrance;
        uEntrance = FindBuildingNext(buildingRecycleCenter);
        if (uEntrance != null)
        {
            m_nMoveToX = GetEntranceX(uEntrance);
            m_nMoveToY = GetEntranceY(uEntrance);
            m_nMoveToZ = GetEntranceZ(uEntrance);
            CallMoveInsideObject(uEntrance);
            state StartMoving;
            true;
        }
    }
    //-------------------------------------------------------
    */
    
    command Stop() button "translateCommandStop" item 123 description "translateCommandStopDescription" hotkey priority 20
    {
        CallStopMoving();
        state Nothing;
        true;
    }
	//-------------------------------------------------------
    command Land() button "translateCommandLand" item 161 description "translateCommandLandDescription" hotkey priority 31 
    {
        CallLand();

        NextCommand(1);
        state Nothing;
    }
    //-------------------------------------------------------
    command MoveToWorld(int nWorldNum) button "translateCommandFlyToMission" item 134 priority 1
    {
        if (FindFlyToWorldDestination(nWorldNum))
        {
            m_nMoveToX = GetFoundFlyToWorldDestinationX();
            m_nMoveToY = GetFoundFlyToWorldDestinationY();
            m_nMoveToZ = GetFoundFlyToWorldDestinationZ();
            CallMoveHighToPoint(m_nMoveToX, m_nMoveToY, m_nMoveToZ);
//		    scoutMode = 0;
//		    ChangedCommandValue();
            state StartMovingToWorld;
            true;
        }
        else
        {
            false;
        }
    }
    //-------------------------------------------------------
	command RecycleUnit() button "translateCommandGoRecycle" item 136 description "translateCommandGoRecycleDescription" hotkey priority 140 advanced
    {
        if (FindFlyToRecycleDestination())
        {
            m_nMoveToX = GetFoundFlyToRecycleDestinationX();
            m_nMoveToY = GetFoundFlyToRecycleDestinationY();
            m_nMoveToZ = GetFoundFlyToRecycleDestinationZ();
            CallMoveHighToPoint(m_nMoveToX, m_nMoveToY, m_nMoveToZ);
//		    scoutMode = 0;
//		    ChangedCommandValue();
            state StartMovingToRecycle;
            true;
        }
        else
        {
            false;
        }
    }
    //-------------------------------------------------------
    command SpecialChangeUnitsScript() hidden button "translateCommandChangeScript" description "translateCommandChangeScriptDescription" hotkey priority 254 
    {
        //special command - no implementation
    }
    //-------------------------------------------------------
	command SetLights(int nMode) button lights hotkey priority 10
	{
		if (nMode == -1)
		{
			lights = (lights + 1) % 2;
		}
		else
		{
			lights = nMode;
		}

		if (lights == 0)
			SetLightsMode(lightsAUTO);
		else
			SetLightsMode(lightsOFF);

		NextCommand(1);
	}
	//--------------------------------------------------------------------------
	command UserOneParam0(int nMode) button retreatMode priority 12 advanced
	{
		if (nMode == -1)
		{
			retreatMode = (retreatMode + 1) % 2;
		}
		else
		{
			retreatMode = nMode;
		}
	}
    //--------------------------------------------------------------------------
    /*
	command UserOneParam9(int nMode) button traceMode priority 255 advanced
    {
		if (nMode == -1)
		{
			traceMode = (traceMode + 1) % 2;
		}
		else
		{
			traceMode = nMode;
		}
    }
    */
}
