transporter "translateScriptNameTransporter"
{
	include "Trace.ech"

	int m_bAirBridge;

	state AirBridge;

	state Nothing
	{
		if (m_bAirBridge)
		{
			if (traceMode) TraceD("Nothing->AirBridge\n");

			return AirBridge;
		}
		else
		{
			if (traceMode) TraceD("Nothing\n");
			
			return Nothing;
		}
	}

	include "Scout.ech"

	unit m_uUnitToTransport;

	function int SetUnitToTransport(unit uUnit)
	{
		m_uUnitToTransport = uUnit;
		SetTargetObject(uUnit);
		return true;
	}

	function int StopCurrentAction()
	{
		SetUnitToTransport(null);

		InvalidateAutoGetPoint();
		InvalidateAutoPutPoint();

		m_bAirBridge = false;

		StopScout();

		return true;
	}

	include "Lights.ech"
	include "RetreatCivil.ech"
	include "MoveFlying.ech"
	include "RecycleFlying.ech"
	include "Special.ech"

    int m_nGetUnitFirstPosX;
    int m_nGetUnitFirstPosY;
    int m_nGetUnitFirstPosZ;

    int m_nPutPosX;
    int m_nPutPosY;
    int m_nPutPosZ;

    int m_nAutoGetPointX;
    int m_nAutoGetPointY;
    int m_nAutoGetPointZ;

    int m_nAutoPutPointX;
    int m_nAutoPutPointY;
    int m_nAutoPutPointZ;

	state MovingToGetUnit;
	state GettingUnit;
	state MovingToPutUnit;
	state PuttingUnit;
	state MovingToDropUnit;
	state DroppingUnit;

	state AirBridge
	{
		unit uUnit;

		if (HaveUnitOnHook())
		{
			//odstawic unit do put point

			if ( FindFreePlaceToPutUnitFromHook(m_nAutoPutPointX, m_nAutoPutPointY, m_nAutoPutPointZ, 6) )
			{
				m_nMoveToGx = m_nPutPosX = GetFoundFreePlaceToPutUnitX();
				m_nMoveToGy = m_nPutPosY = GetFoundFreePlaceToPutUnitY();
				m_nMoveToLz = m_nPutPosZ = GetFoundFreePlaceToPutUnitZ();

				CallMoveToPointForce(m_nMoveToGx, m_nMoveToGy, m_nMoveToLz);

				if (traceMode) TraceD("AirBridge->MovingToPutUnit\n");

				return MovingToPutUnit;
			}
		}
		else
		{
			//wziac unit z okolic get point jesli jest jakis

			BuildTargetsArray(findTargetWaterUnit|findTargetNormalUnit, findAllyUnit | findOurUnit, findDestinationAnyUnit, m_nAutoGetPointX, m_nAutoGetPointY, m_nAutoGetPointZ, 4);
			SortFoundTargetsArray();

			if (StartEnumTargetsArray())
			{
				do
				{
					uUnit = GetNextTarget();

					if ((uUnit != null) && uUnit.CanBeTransported() && (Distance(m_nAutoGetPointX, m_nAutoGetPointY, uUnit.GetLocationX(), uUnit.GetLocationY()) <= 4) && !uUnit.IsMoving())
					{
						EndEnumTargetsArray();

						SetUnitToTransport(uUnit);

						m_nMoveToGx = m_nGetUnitFirstPosX = m_uUnitToTransport.GetLocationX();
						m_nMoveToGy = m_nGetUnitFirstPosY = m_uUnitToTransport.GetLocationY();
						m_nMoveToLz = m_nGetUnitFirstPosZ = m_uUnitToTransport.GetLocationZ();

						CallMoveToPointForce(m_nMoveToGx, m_nMoveToGy, m_nMoveToLz);

						uUnit = null;

						if (traceMode) TraceD("AirBridge->MovingToGetUnit\n");

						return MovingToGetUnit;

						break;
					}
				}
				while (uUnit != null);

				EndEnumTargetsArray();
			}
            CallMoveToPoint(GetLocationX(), GetLocationY(), GetLocationZ());
		}

		if (traceMode) TraceD("AirBridge\n");

		return AirBridge, 50;
	}

	state MovingToGetUnit
	{
		int nUnitPosX;
		int nUnitPosY;
		int nUnitPosZ;
		
		if (!m_uUnitToTransport.IsLive())
		{
			SetUnitToTransport(null);

			NextCommand(0);

			if (traceMode) TraceD("MovingToGetUnit->Nothing\n");

			return Nothing, 1;
		}

		nUnitPosX = m_uUnitToTransport.GetLocationX();
		nUnitPosY = m_uUnitToTransport.GetLocationY();
		nUnitPosZ = m_uUnitToTransport.GetLocationZ();
		
		if ( nUnitPosZ != m_nGetUnitFirstPosZ )
		{
			//rezygnujemy

			SetUnitToTransport(null);

			NextCommand(0);

			if (traceMode) TraceD("MovingToGetUnit->Nothing\n");

			return Nothing, 1;
		}

		if ( IsAlliance(m_uUnitToTransport) && Distance(nUnitPosX, nUnitPosY, m_nGetUnitFirstPosX, m_nGetUnitFirstPosY) >= 5 )
		{
			//rezygnujemy

			SetUnitToTransport(null);

			NextCommand(0);

			if (traceMode) TraceD("MovingToGetUnit->Nothing\n");

			return Nothing, 1;
		}

		if ( (nUnitPosX != m_nGetUnitFirstPosX) || (nUnitPosY != m_nGetUnitFirstPosY) )
		{
			//zmienic cel jazdy

			m_nMoveToGx = nUnitPosX;
			m_nMoveToGy = nUnitPosY;
			m_nMoveToLz = nUnitPosZ;

			CallMoveToPointForce(m_nMoveToGx, m_nMoveToGy, m_nMoveToLz);
		}

		if (IsMoving())
		{
			if (traceMode) TraceD("MovingToGetUnit\n");

			return MovingToGetUnit;
		}
		else
		{
			if ((GetLocationX() == m_nMoveToGx) &&
				(GetLocationY() == m_nMoveToGy) &&
				(GetLocationZ() == m_nMoveToLz) )
			{
				CallGetUnit(m_uUnitToTransport.GetLocationX(), m_uUnitToTransport.GetLocationY(), m_uUnitToTransport.GetLocationZ());

				if (traceMode) TraceD("MovingToGetUnit->GettingUnit\n");

				return GettingUnit;
			}
			else
			{
				m_nMoveToGx = nUnitPosX;
				m_nMoveToGy = nUnitPosY;
				m_nMoveToLz = nUnitPosZ;

				CallMoveToPointForce(m_nMoveToGx, m_nMoveToGy, m_nMoveToLz);

				if (traceMode) TraceD("MovingToGetUnit\n");

				return MovingToGetUnit;
			}
		}
	}

    state GettingUnit
    {
        if (IsGettingUnit())
        {
			if (traceMode) TraceD("GettingUnit\n");

            return GettingUnit;
        }
        else
        {
            SetUnitToTransport(null);

            m_nMoveToGx = GetLocationX();
            m_nMoveToGy = GetLocationY();
            m_nMoveToLz = GetLocationZ();

            CallMoveToPoint(GetLocationX(), GetLocationY(), GetLocationZ());

            NextCommand(1);

			if (traceMode) TraceD("GettingUnit->StartMoving\n");

            return StartMoving;
        }
    }

	state MovingToPutUnit
	{
		if (IsMoving())
		{
			if (traceMode) TraceD("MovingToPutUnit\n");

			return MovingToPutUnit;
		}
		else
		{
			if ((GetLocationX() == m_nMoveToGx) &&
				(GetLocationY() == m_nMoveToGy) &&
				(GetLocationZ() == m_nMoveToLz) )
			{
				CallPutUnit(m_nPutPosX, m_nPutPosY, m_nPutPosZ);

				if (traceMode) TraceD("MovingToPutUnit->PuttingUnit\n");
				
				return PuttingUnit;
			}
			else
			{
				CallMoveToPointForce(m_nMoveToGx, m_nMoveToGy, m_nMoveToLz);
				
				if (traceMode) TraceD("MovingToPutUnit\n");

				return MovingToPutUnit;
			}
		}
	}

    state PuttingUnit
    {
        if (IsPuttingUnit())
        {
			if (traceMode) TraceD("PuttingUnit\n");

            return PuttingUnit;
        }
        else
        {
            m_nMoveToGx = GetLocationX();
            m_nMoveToGy = GetLocationY();
            m_nMoveToLz = GetLocationZ();

            CallMoveToPoint(GetLocationX(), GetLocationY(), GetLocationZ());

            NextCommand(1);

			if (traceMode) TraceD("PuttingUnit->StartMoving\n");

            return StartMoving;
        }
    }

	state MovingToDropUnit
	{
		if (IsMoving())
		{
			if (traceMode) TraceD("MovingToDropUnit\n");
			
			return MovingToDropUnit;
		}
		else
		{
			if ((GetLocationX() == m_nMoveToGx) &&
				(GetLocationY() == m_nMoveToGy) &&
				(GetLocationZ() == m_nMoveToLz) )
			{
				CallDropUnit(m_nPutPosX, m_nPutPosY, m_nPutPosZ);

				if (traceMode) TraceD("MovingToDropUnit->DroppingUnit\n");
				
				return DroppingUnit;
			}
			else
			{
				CallMoveToPointForce(m_nMoveToGx, m_nMoveToGy, m_nMoveToLz);

				if (traceMode) TraceD("MovingToDropUnit\n");
				
				return MovingToDropUnit;
			}
		}
	}

	state DroppingUnit
	{
		if (IsDroppingUnit())
		{
			if (traceMode) TraceD("DroppingUnit\n");

			return DroppingUnit;
		}
		else
		{
			m_nMoveToGx = GetLocationX();
			m_nMoveToGy = GetLocationY();
			m_nMoveToLz = GetLocationZ();
			
			CallMoveToPoint(GetLocationX(), GetLocationY(), GetLocationZ());
			
			NextCommand(1);
			
			if (traceMode) TraceD("DroppingUnit->StartMoving\n");

			return StartMoving;
		}
	}


	command Initialize()
	{
		//pozwolic dzialkom strzelac samym (o ile sa jakies)
		SetCannonFireMode(-1, 1);
		
		InitializeScout();
		InitializeRetreat();

		m_bAirBridge = false;
		
		false;
	}

	command Uninitialize()
	{
		//wykasowac referencje
		SetUnitToTransport(null);

		false;
	}

    command TransporterGetUnit(unit uGetUnit) hidden button "translateCommandTransporterGetUnit"
    {
        if (!HaveUnitOnHook())
        {
			StopCurrentAction();

            SetUnitToTransport(uGetUnit);

            m_nMoveToGx = m_nGetUnitFirstPosX = m_uUnitToTransport.GetLocationX();
            m_nMoveToGy = m_nGetUnitFirstPosY = m_uUnitToTransport.GetLocationY();
            m_nMoveToLz = m_nGetUnitFirstPosZ = m_uUnitToTransport.GetLocationZ();

            CallMoveToPointForce(m_nMoveToGx, m_nMoveToGy, m_nMoveToLz);

            state MovingToGetUnit;
        }
        else
        {
            NextCommand(0);
        }
    }

    command TransporterPutUnitToPoint(int nX, int nY, int nZ) button "translateCommandTransporterPutUnitToPoint" item 131 description "translateCommandTransporterPutUnitToPointDescription" hotkey priority 103
    {
        if (HaveUnitOnHook())
        {
			StopCurrentAction();

            m_nMoveToGx = m_nPutPosX = nX;
            m_nMoveToGy = m_nPutPosY = nY;
            m_nMoveToLz = m_nPutPosZ = nZ;

            CallMoveToPointForce(m_nMoveToGx, m_nMoveToGy, m_nMoveToLz);

            state MovingToPutUnit;
        }
        else
        {
            NextCommand(0);
        }
    }

    command TransporterDropUnitToPoint(int nX, int nY, int nZ) button "translateCommandTransporterDropUnitToPoint" item 132 description "translateCommandTransporterDropUnitToPointDescription" hotkey priority 106
    {
        if (HaveUnitOnHook())
        {
			StopCurrentAction();

            m_nMoveToGx = m_nPutPosX = nX;
            m_nMoveToGy = m_nPutPosY = nY;
            m_nMoveToLz = m_nPutPosZ = nZ;

            CallMoveToPointForce(m_nMoveToGx, m_nMoveToGy, m_nMoveToLz);

            state MovingToDropUnit;
        }
        else
        {
            NextCommand(0);
        }
    }
    //-------------------------------------------------------
    command TransporterAirBridgeLine(int nX1, int nY1, int nZ1, int nX2, int nY2, int nZ2) button "translateCommandTransporterAirBridge" item 133 description "translateCommandTransporterAirBridgeDescription" hotkey priority 106 advanced
	{
		StopCurrentAction();

		m_nAutoGetPointX = nX1;
		m_nAutoGetPointY = nY1;
		m_nAutoGetPointZ = nZ1;

		m_nAutoPutPointX = nX2;
		m_nAutoPutPointY = nY2;
		m_nAutoPutPointZ = nZ2;

		SetAutoGetPoint(m_nAutoGetPointX, m_nAutoGetPointY, m_nAutoGetPointZ);

		SetAutoPutPoint(m_nAutoPutPointX, m_nAutoPutPointY, m_nAutoPutPointZ);

		m_bAirBridge = true;

		state AirBridge;
	}
}
