transporter "translateScriptNameTransporter"
{
    int m_nGetUnitFirstPosX;
    int m_nGetUnitFirstPosY;
    int m_nGetUnitFirstPosZ;
    int m_nPutPosX;
    int m_nPutPosY;
    int m_nPutPosZ;
    int m_nMoveToX;
    int m_nMoveToY;
    int m_nMoveToZ;
    unit m_uUnitToTransport;
    int m_nLastMoveToPutPosX;
    int m_nLastMoveToPutPosY;
    int m_nMoveToPutStayTicks;

    function int SetUnitToTransport(unit uUnit)
    {
        m_uUnitToTransport = uUnit;
        return true;
    }

    function int CalcMoveToPutGetPointCoords(int nX, int nY, int nZ)
    {
        int nPosX;
        int nPosY;
        int nPosZ;
        int nMinDist;
        int nDist;
        if (IsHelicopter())
        {
            m_nMoveToX = nX;
            m_nMoveToY = nY;
            m_nMoveToZ = nZ;
        }
        else
        {
            nPosX = GetLocationX();
            nPosY = GetLocationY();
            nPosZ = GetLocationZ();
            m_nMoveToX = nX;
            m_nMoveToY = nY;
            m_nMoveToZ = nZ;
            nMinDist = 1000;
            if (IsFreePoint(nX, nY - 1, nZ) || ((nX == nPosX) && ((nY-1) == nPosY) && (nZ == nPosZ)))
            {
                m_nMoveToX = nX;
                m_nMoveToY = nY - 1;
                m_nMoveToZ = nZ;
                nMinDist = Distance(nPosX, nPosY, m_nMoveToX, m_nMoveToY);
            }
            if ((IsFreePoint(nX + 1, nY, nZ) || (((nX+1) == nPosX) && (nY == nPosY) && (nZ == nPosZ))) &&
                (Distance(nPosX, nPosY, nX + 1, nY) < nMinDist))
            {
                m_nMoveToX = nX + 1;
                m_nMoveToY = nY;
                m_nMoveToZ = nZ;
                nMinDist = Distance(nPosX, nPosY, m_nMoveToX, m_nMoveToY);
            }
            if ((IsFreePoint(nX, nY + 1, nZ) || ((nX == nPosX) && ((nY+1) == nPosY) && (nZ == nPosZ))) &&
                (Distance(nPosX, nPosY, nX, nY + 1) < nMinDist))
            {
                m_nMoveToX = nX;
                m_nMoveToY = nY + 1;
                m_nMoveToZ = nZ;
                nMinDist = Distance(nPosX, nPosY, m_nMoveToX, m_nMoveToY);
            }
            if ((IsFreePoint(nX - 1, nY, nZ) || (((nX-1) == nPosX) && (nY == nPosY) && (nZ == nPosZ))) &&
                (Distance(nPosX, nPosY, nX - 1, nY) < nMinDist))
            {
                m_nMoveToX = nX - 1;
                m_nMoveToY = nY;
                m_nMoveToZ = nZ;
            }
        }
        return true;
    }
    
    state Initialize;
    state Nothing;
    state StartMovingSpecial;
    state MovingSpecial;
    state StartMoving;
    state Moving;
    state MovingToGetUnit;
    state GettingUnit;
    state MovingToPutUnit;
    state PuttingUnit;

    //-------------------------------------------------------
    state Initialize
    {
        //nigdy tutaj nie wchodzi
        return Nothing;
    }
    //-------------------------------------------------------
    state Nothing
    {
        return Nothing, 50;
    }
    //-------------------------------------------------------
    state StartMovingSpecial
    {
        return MovingSpecial, 20;
    }
    //-------------------------------------------------------
    state MovingSpecial
    {
        if (IsMoving())
        {
            if ((Distance(GetLocationX(), GetLocationY(), m_nMoveToX, m_nMoveToY) <= 1) &&
                (GetLocationZ() == m_nMoveToZ))
            {
                //znikamy wczesniej aby nie bylo widac zatrzymujacego sie helikoptera
                EndFlyingToSpecialDestination();
            }
            return MovingSpecial;
        }
        else
        {
            EndFlyingToSpecialDestination();
        }
    }
    //-------------------------------------------------------
    state StartMoving
    {
        return Moving, 20;
    }
    //-------------------------------------------------------
    state Moving
    {
        if (IsMoving())
        {
            return Moving;
        }
        else
        {
            NextCommand(1);
            return Nothing, 1;
        }
    }
    //-------------------------------------------------------
    state MovingToGetUnit
    {
        int nUnitPosX;
        int nUnitPosY;
        int nUnitPosZ;
        int nPosX;
        int nPosY;
        int nPosZ;

        if (!m_uUnitToTransport.IsLive())
        {
            SetUnitToTransport(null);
            NextCommand(0);
            return Nothing, 1;
        }
        nUnitPosX = m_uUnitToTransport.GetLocationX();
        nUnitPosY = m_uUnitToTransport.GetLocationY();
        nUnitPosZ = m_uUnitToTransport.GetLocationZ();
        
        if (!CheckCanGetUnit(m_uUnitToTransport) || (nUnitPosZ != m_nGetUnitFirstPosZ))
        {
            //rezygnujemy
            SetUnitToTransport(null);
            NextCommand(0);
            return Nothing, 1;
        }
        if ((nUnitPosX != m_nGetUnitFirstPosX) || (nUnitPosY != m_nGetUnitFirstPosY))
        {
            //zmienic cel jazdy
            CalcMoveToPutGetPointCoords(nUnitPosX, nUnitPosY, nUnitPosZ);
            CallMoveToPointForce(m_nMoveToX, m_nMoveToY, m_nMoveToZ);
        }

        nPosX = GetLocationX();
        nPosY = GetLocationY();

        if ((nPosX == m_nLastMoveToPutPosX) && (nPosY == m_nLastMoveToPutPosY))
        {
            m_nMoveToPutStayTicks = m_nMoveToPutStayTicks + 1;
            if (m_nMoveToPutStayTicks >= 60)//*20 ticks/state
            {
                //zabezpieczenie przed staniem w nieskonczonosc w jednym miejscu
                //bo miejsce gdzie mamy pojechac jest zablokowane
                m_nMoveToPutStayTicks = 0;
                NextCommand(1);
                return Nothing;
            }
        }
        else
        {
            m_nLastMoveToPutPosX = nPosX;
            m_nLastMoveToPutPosY = nPosY;
            m_nMoveToPutStayTicks = 0;
        }

        if (IsMoving())
        {
            return MovingToGetUnit;
        }
        else
        {
            if ((GetLocationX() == m_nMoveToX) && (GetLocationY() == m_nMoveToY) &&
                (GetLocationZ() == m_nMoveToZ))
            {
                CallGetUnit(m_uUnitToTransport.GetLocationX(), m_uUnitToTransport.GetLocationY(), m_uUnitToTransport.GetLocationZ());
                return GettingUnit;
            }
            else
            {
                CalcMoveToPutGetPointCoords(nUnitPosX, nUnitPosY, nUnitPosZ);
                CallMoveToPointForce(m_nMoveToX, m_nMoveToY, m_nMoveToZ);
                return MovingToGetUnit;
            }
        }
    }
    //------------------------------------------------------- 
    state GettingUnit
    {
        if (IsGettingUnit())
        {
            return GettingUnit;
        }
        else
        {
            SetUnitToTransport(null);
            m_nMoveToX = GetLocationX();
            m_nMoveToY = GetLocationY();
            m_nMoveToZ = GetLocationZ();
            CallMoveToPoint(GetLocationX(), GetLocationY(), GetLocationZ());
            NextCommand(1);
            return StartMoving;
        }
    }
    //------------------------------------------------------- 
    state MovingToPutUnit
    {
        int nPosX;
        int nPosY;
        int nPosZ;

        nPosX = GetLocationX();
        nPosY = GetLocationY();

        if ((nPosX == m_nLastMoveToPutPosX) && (nPosY == m_nLastMoveToPutPosY))
        {
            m_nMoveToPutStayTicks = m_nMoveToPutStayTicks + 1;
            if (m_nMoveToPutStayTicks >= 60)//*20 ticks/state
            {
                //zabezpieczenie przed staniem w nieskonczonosc w jednym miejscu
                //bo miejsce gdzie mamy pojechac jest zablokowane
                m_nMoveToPutStayTicks = 0;
                NextCommand(1);
                return Nothing;
            }
        }
        else
        {
            m_nLastMoveToPutPosX = nPosX;
            m_nLastMoveToPutPosY = nPosY;
            m_nMoveToPutStayTicks = 0;
        }

        if (IsMoving())
        {
            return MovingToPutUnit;
        }
        else
        {
            if ((GetLocationX() == m_nMoveToX) && (GetLocationY() == m_nMoveToY) &&
                (GetLocationZ() == m_nMoveToZ))
            {
                //dla transportowca unitow musimy sprawdzic czy ten punkt jest OK i jesli nie to znalezc inny
                if (CanPutUnitFromHookInPoint(m_nMoveToX, m_nMoveToY, m_nMoveToZ))
                {
                    CallPutUnit(m_nPutPosX, m_nPutPosY, m_nPutPosZ);
                    m_nMoveToPutStayTicks = 0;
                    return PuttingUnit;
                }
                else
                {
                    if (FindFreePlaceToPutUnitFromHook(m_nMoveToX, m_nMoveToY, m_nMoveToZ, 10))
                    {
                        m_nPutPosX = GetFoundFreePlaceToPutUnitX();
                        m_nPutPosY = GetFoundFreePlaceToPutUnitY();
                        m_nPutPosZ = GetFoundFreePlaceToPutUnitZ();
                        CalcMoveToPutGetPointCoords(m_nPutPosX, m_nPutPosY, m_nPutPosZ);
                        CallMoveToPointForce(m_nMoveToX, m_nMoveToY, m_nMoveToZ);
                        return MovingToPutUnit;
                    }
                    else
                    {
                        NextCommand(1);
                        return Nothing;
                    }
                }
            }
            else
            {
                CallMoveToPointForce(m_nMoveToX, m_nMoveToY, m_nMoveToZ);
                return MovingToPutUnit;
            }
        }
    }
    //------------------------------------------------------- 
    state PuttingUnit
    {
        //zabezpieczenie przed zablokowaniem (w kodzie SpecialTransporter jest rezygnacja z ladowania po 60*20)
        m_nMoveToPutStayTicks = m_nMoveToPutStayTicks + 1;
        if (IsPuttingUnit())
        {
            return PuttingUnit;
        }
        else
        {
            //musimy sprawdzic czy rzeczywiscie udalo sie nam polozyc unit:
            if (!HaveUnitOnHook())
            {
                m_nMoveToX = GetLocationX();
                m_nMoveToY = GetLocationY();
                m_nMoveToZ = GetLocationZ();
                CallMoveToPoint(GetLocationX(), GetLocationY(), GetLocationZ());
                NextCommand(1);
                return StartMoving,1;
            }
            else
            {
                //sprobowac jeszcze raz
                if ((m_nMoveToPutStayTicks < 55) && FindFreePlaceToPutUnitFromHook(GetLocationX(), GetLocationY(), GetLocationZ(), 10))
                {
                    m_nPutPosX = GetFoundFreePlaceToPutUnitX();
                    m_nPutPosY = GetFoundFreePlaceToPutUnitY();
                    m_nPutPosZ = GetFoundFreePlaceToPutUnitZ();
                    CalcMoveToPutGetPointCoords(m_nPutPosX, m_nPutPosY, m_nPutPosZ);
                    CallMoveToPointForce(m_nMoveToX, m_nMoveToY, m_nMoveToZ);
                    m_nMoveToPutStayTicks = 0;
                    return MovingToPutUnit;
                }
                else
                {
                    m_nMoveToX = GetLocationX();
                    m_nMoveToY = GetLocationY();
                    m_nMoveToZ = GetLocationZ();
                    CallMoveToPoint(GetLocationX(), GetLocationY(), GetLocationZ());
                    NextCommand(1);
                    return StartMoving,1;
                }
            }
        }
    }
    //------------------------------------------------------- 
    event OnFreezeForSupplyOrRepair(int nFreezeTicks)
    {
        false;
    }
    //------------------------------------------------------- 
    
    //-------------------------------------------------------
    command Initialize()
    {
        //pozwolic dzialkom strzelac samym (o ile sa jakies)
        SetCannonFireMode(-1, 1);
        false;
    }
    //-------------------------------------------------------
    command Uninitialize()
    {
        //wykasowac referencje
        SetUnitToTransport(null);
        false;
    }
    //-------------------------------------------------------
    command MoveToSpecialDestination(int nGx, int nGy, int nLz)
    {
        SetUnitToTransport(null);
        m_nMoveToX = nGx;
        m_nMoveToY = nGy;
        m_nMoveToZ = nLz;
        CallMoveHighToPoint(m_nMoveToX, m_nMoveToY, m_nMoveToZ);
        state StartMovingSpecial;
        true;
    }
    //-------------------------------------------------------
    command TransporterGetUnit(unit uGetUnit)
    {
        if (!HaveUnitOnHook())
        {
            SetUnitToTransport(uGetUnit);
            m_nGetUnitFirstPosX = m_uUnitToTransport.GetLocationX();
            m_nGetUnitFirstPosY = m_uUnitToTransport.GetLocationY();
            m_nGetUnitFirstPosZ = m_uUnitToTransport.GetLocationZ();
            CalcMoveToPutGetPointCoords(m_nGetUnitFirstPosX, m_nGetUnitFirstPosY, m_nGetUnitFirstPosZ);
            CallMoveToPointForce(m_nMoveToX, m_nMoveToY, m_nMoveToZ);
            m_nMoveToPutStayTicks = 0;
            state MovingToGetUnit;
        }
        else
        {
            NextCommand(0);
        }
    }
    //-------------------------------------------------------
    command TransporterPutUnitToPoint(int nX, int nY, int nZ)
    {
        if (HaveUnitOnHook())
        {
            m_nPutPosX = nX;
            m_nPutPosY = nY;
            m_nPutPosZ = nZ;
            CalcMoveToPutGetPointCoords(m_nPutPosX, m_nPutPosY, m_nPutPosZ);
            CallMoveToPointForce(m_nMoveToX, m_nMoveToY, m_nMoveToZ);
            m_nMoveToPutStayTicks = 0;
            state MovingToPutUnit;
        }
        else
        {
            NextCommand(0);
        }
    }
    //-------------------------------------------------------
}
