tank "translateScriptNameTankStatic"
{
	consts
	{
		disableFire=0;
		enableFire=1;
		findTargetWaterUnit 		= 1;
		findTargetFlyingUnit		= 2;
		findTargetNormalUnit		= 4;
		findTargetBuildingUnit	= 8;
		findTargetAnyUnit 			= 15;
		
		//typ rasy (jakich IFF'ow szukamy
		findEnemyUnit 			= 1;
		findAllyUnit				= 2;
		findNeutralUnit 		= 4;
		findOurUnit 				= 8;
		//kryterium szukania
		findNearestUnit 		= 1;
		findWeakestUnit 		= 2;
		findStrongestUnit 	= 4;
		findDisabledUnit		= 8;
		findDamagedUnit 		= 16;
		//typ szukanego obiektu
		findDestinationCivilUnit		= 1;
		findDestinationArmedUnit		= 2;
		findDestinationRepairerUnit = 4;
		findDestinationSupplyUnit 	= 8;
		findDestinationAnyUnit			= 15;
//IsInRange
		notInRange = 0;//poza zasiegiem (za duza odleglosc)
		inRangeBadAngleAlpha = 1;//w zasiegu strzalu ale zly kat alpha trzeba obrocic podwozie
		inRangeBadAngleBeta = 2;//w zasiegu strzalu ale zly kat beta
		inRangeBadHit = 3; //w zasiegu strzalu ale nie mozna trafic (cos zaslania)
		inRangeGoodHit = 4;
//cannon type
		cannonTypeIon = 12;
    cannonTypeLaser = 0;
	}



	unit m_uTarget;
	int  m_nCannonsCount;
	int  m_nTargetGx;
	int  m_nTargetGy;
	int  m_nTargetLz;
	int  m_nStayGx;
	int  m_nStayGy;
	int  m_nStayLz;
	int  m_nSpecialGx; //Patrol point , escort
	int  m_nSpecialGy;
	int  m_nSpecialLz;
	int  m_nSpecialCounter;
	unit m_uSpecialUnit;

	enum lights
	{
    "translateCommandStateLightsAUTO",
    "translateCommandStateLightsON",
    "translateCommandStateLightsOFF",
	multi:
  	"translateCommandStateLightsMode"
	}

	enum movementMode
	{
			"translateCommandStateFollowEnemy",
			"translateCommandStateHoldPosition",
			
	multi:
			"translateCommandStateMovement"
	}
 
//********************************************************
//********* F U N C T I O N S ****************************
//********************************************************
//-------------------------------------------------------
//------------------------------------------------------- 
	function int GoToPoint()
	{
		int nRangeMode;
		int nDx;
		int nDy;
		nRangeMode = IsPointInCannonRange(0,m_nTargetGx, m_nTargetGy, m_nTargetLz);
		
		if (nRangeMode == 4) //in range
		{
				if (IsMoving())
					CallStopMoving();
				return false;
		}
		if(nRangeMode == 1) //w zasiegu ale trzeba odwrocic czolg 
		{
				if (IsMoving())
					CallStopMoving();
				else
				 CallTurnToAngle(GetCannonAngleToPoint(0,m_nTargetGx, m_nTargetGy, m_nTargetLz));
				return true;
		}
				
		CallMoveToPoint(m_nTargetGx, m_nTargetGy, m_nTargetLz);
		return true;
	}

//------------------------------------------------------- 
	function int GoToTarget()
	{
		int nRangeMode;
		int nDx;
		int nDy;
		int nDistance;
		nRangeMode = IsTargetInCannonRange(0, m_uTarget);
		
		if (nRangeMode == inRangeGoodHit)
		{
				if (IsMoving())
					CallStopMoving();
				return false;
		}
		
		if(nRangeMode == inRangeBadAngleAlpha) //w zasiegu ale trzeba odwrocic czolg 
		{
			if (IsMoving())
				CallStopMoving();
			else
				CallTurnToAngle(GetCannonAngleToTarget(0,m_uTarget));
			return true;
		}
    CallMoveToPoint(m_uTarget.GetLocationX(), m_uTarget.GetLocationY(), m_uTarget.GetLocationZ());
  	return true;
	}

//------------------------------------------------------- 
	function int TargetInRange()
	{
		int nRangeMode;
		int nDx;
		int nDy;
		nRangeMode = IsTargetInCannonRange(0, m_uTarget);
		
		if (nRangeMode == inRangeGoodHit) 
		{
			return true;
		}
		if(nRangeMode == inRangeBadAngleAlpha) //w zasiegu ale trzeba odwrocic czolg 
		{
			if (IsMoving())
				CallStopMoving();
			else
				CallTurnToAngle(GetCannonAngleToTarget(0,m_uTarget));
			return true;
		}
		return false;
	}
//-------------------------------------------------------
	function int EndState()
	{
			SetCannonFireMode(-1, disableFire);
			NextCommand(1);
	}
//-------------------------------------------------------
	function int FindBestTarget()
	{
		int i;
		int nTargetsCount;
		unit newTarget;

		if(GetCannonType(0) != cannonTypeIon)
		{
		  if(GetCannonType(0) == cannonTypeLaser)
      {
        m_uTarget = FindTarget(findTargetWaterUnit|findTargetNormalUnit,findEnemyUnit,findNearestUnit,findDestinationAnyUnit);
        if(!m_uTarget)m_uTarget = FindTarget(findTargetBuildingUnit,findEnemyUnit,findNearestUnit,findDestinationAnyUnit);
      }
      else
			  m_uTarget = FindTarget(findTargetAnyUnit,findEnemyUnit,findNearestUnit,findDestinationAnyUnit);
			return true;
    }
		m_uTarget=null;
		BuildTargetsArray(findTargetWaterUnit|findTargetNormalUnit|findTargetBuildingUnit, findEnemyUnit,findDestinationAnyUnit);
		SortFoundTargetsArray();
		nTargetsCount=GetTargetsCount();
		if(nTargetsCount!=0)
		{
			StartEnumTargetsArray();
			for(i=0;i<nTargetsCount;i=i+1)
			{
				newTarget = GetNextTarget();
				if(!newTarget.IsDisabled())
				{
					EndEnumTargetsArray();
					m_uTarget=newTarget;
					return true;
				}
			}
			EndEnumTargetsArray();
			return false;
		}
		else
		{
			return false;
		}
	}
//********************************************************
//************* S T A T E S ******************************
//********************************************************
	state Nothing;
	state HoldPosition;
	state Moving;
	state AutoAttacking;
	state Attacking;
	state AttackingPoint;
	state Patrol;
	state Escort;
//------------------------------------------------------- 
		
	state Nothing
	{
		
		if(movementMode==1) return HoldPosition;

		FindBestTarget();
		if(!m_uTarget)
		{
			m_uTarget = GetAttacker();
			ClearAttacker();
		}

		if (m_uTarget != null)
		{
			m_nStayGx = GetLocationX();
			m_nStayGy = GetLocationY();
			m_nStayLz = GetLocationZ();
			return AutoAttacking;
		}
		return Nothing;
	}
//----------------------------------------------------
	state HoldPosition
	{
		
		if(m_uTarget)
		{ 
			if(!m_uTarget.IsLive() || !IsEnemy(m_uTarget) || (GetCannonType(0) == cannonTypeIon && m_uTarget.IsDisabled()))
			{
				StopCannonFire(-1);
				m_uTarget=null;
			}
			else
			{
				if(TargetInRange())
				{
						CannonFireToTarget(-1, m_uTarget, -1);
				}
				else
					m_uTarget=null;
			}
		}
		else
		{
			FindBestTarget();
			if(!m_uTarget)
			{
				m_uTarget = GetAttacker();
				ClearAttacker();
			}
		} 		 
		return HoldPosition;
	}
//----------------------------------------------------
	state AutoAttacking
	{
		int nDistance;
		
		
// pozostawaj w okolicach punktu
		nDistance = Distance(m_nStayGx,m_nStayGy,GetLocationX(),GetLocationY());
		if( nDistance > 12)
		{
			m_uTarget = null;
			CallMoveToPoint(m_nStayGx, m_nStayGy, m_nStayLz);
			SetCannonFireMode(-1, enableFire);
			return Moving;			
		}

		if(!m_uTarget.IsLive() || !IsEnemy(m_uTarget) || (GetCannonType(0) == cannonTypeIon && m_uTarget.IsDisabled()))
		{
			StopCannonFire(-1);
			m_uTarget=null;
		}

		if (m_uTarget)
		{
			if(!GoToTarget())
			{
				CannonFireToTarget(-1, m_uTarget, -1);
        return AutoAttacking;
			}
			return AutoAttacking,2;
		}
		else//target not exist
		{
			FindBestTarget();
			if(!m_uTarget)
			{
				m_uTarget = GetAttacker();
				ClearAttacker();
			}

			if (m_uTarget != null)
				return AutoAttacking;

			if( nDistance > 0)
			{
				CallMoveToPoint(m_nStayGx, m_nStayGy, m_nStayLz);
				SetCannonFireMode(-1, enableFire);
				return Moving;			
			}
		
			if (IsMoving())
			{
				CallStopMoving();
			}
			return Nothing;
		}
	}
//--------------------------------------------------------------------------
	state AttackingPoint
	{
		if(GoToPoint())
		{
			return AttackingPoint,2;
		}
		else
		{
			CannonFireGround(-1, m_nTargetGx, m_nTargetGy, m_nTargetLz, 1);
			return AttackingPoint;
		}
	}
//----------------------------------------------------
	state Attacking
	{
		if (m_uTarget.IsLive())
		{
			if(GoToTarget())
			{
				return Attacking,2;
			}
			else
			{
				CannonFireToTarget(-1, m_uTarget, -1);
				return Attacking;
			}
		}
		else //target not exist
		{
			m_uTarget=null;
			if (IsMoving())
			{
				CallStopMoving();
			}
			EndState();
			return Nothing;
		}
	}

		
//--------------------------------------------------------------------------
	state Moving
	{
		if (IsMoving())
		{
			return Moving;
		}
		else
		{
			EndState(); 
			return Nothing;
		}
	}
//--------------------------------------------------------------------------
	state Patrol
	{
		if(m_uTarget)
		{
			if(!m_uTarget.IsLive() || !IsEnemy(m_uTarget) || (GetCannonType(0) == cannonTypeIon && m_uTarget.IsDisabled()))
			{
				StopCannonFire(-1);
				m_uTarget=null;
			}
			else
			{
				if(GoToTarget())
				{
					return Patrol,2;
				}
				else
				{
					CannonFireToTarget(-1, m_uTarget, -1);
					return Patrol;
				}
			}
		}
		else
			FindBestTarget();

		if (!IsMoving())
		{
			if(m_nSpecialCounter == 1)
			{
				CallMoveToPoint(m_nStayGx, m_nStayGy, m_nStayLz);
				m_nSpecialCounter = 0;
			}
			else
			{
				CallMoveToPoint(m_nSpecialGx, m_nSpecialGy, m_nSpecialLz);
				m_nSpecialCounter = 1;
			}
		}
		return Patrol;
	}
//--------------------------------------------------------------------------
	state Escort
	{
		
		if(m_uTarget)
		{
			if(!m_uTarget.IsLive() || !IsEnemy(m_uTarget) || (GetCannonType(0) == cannonTypeIon && m_uTarget.IsDisabled()))
			{
				StopCannonFire(-1);
				m_uTarget=null;
			}
			else
			{
				if(GoToTarget())
				{
					return Escort,2;
				}
				else
				{
					CannonFireToTarget(-1, m_uTarget, -1);
					return Escort;
				}
			}
		}
		else
			FindBestTarget();

		if(!m_uSpecialUnit.IsLive())
		{
			m_uSpecialUnit=null;
			if(IsMoving())
			{
				CallStopMoving;
				return Escort;
			}
			EndState();
			return Nothing;
		}

		m_nTargetGx = m_uSpecialUnit.GetLocationX()+m_nSpecialGx;
		m_nTargetGy = m_uSpecialUnit.GetLocationY()+m_nSpecialGy;
		m_nTargetLz = m_uSpecialUnit.GetLocationZ();
		if(Distance(m_nTargetGx,m_nTargetGy,GetLocationX(),GetLocationY()) > 0)
		{
			CallMoveToPoint(m_nTargetGx, m_nTargetGy, m_nTargetLz);
			return Escort;				
		}
		else
		{
			if(IsMoving())
			{
					CallStopMoving();
					return Escort;
			}
			return Escort;
		}
	}

//------------------------------------------------------- 
	state Froozen
	{
		if (IsFroozen())
		{
			state Froozen;
		}
		else
		{
			//!!wrocic do tego co robilismy
			state Nothing;
		}
	}



//********************************************************
//*********** E V E N T S ****************************
//********************************************************
//zwracaja true
//false jak nie ma 
	event OnHit()
	{
		true;
	}
//------------------------------------------------------- 
	event OnCannonLowAmmo(int nCannonNum)
	{
    SendSupplyRequest();
		true;
	}
//------------------------------------------------------- 
	event OnCannonNoAmmo(int nCannonNum)
	{
		true;
	}
//------------------------------------------------------- 
	event OnCannonFoundTarget(int nCannonNum, unit uTarget)
	{
		if(GetCannonType(nCannonNum) == cannonTypeIon)
		{
			if(uTarget.IsDisabled())
			{
				return true;
			}
		}
		return false;//gdyby zwrocic true to dzialko nie strzeli
	}
//------------------------------------------------------- 
	event OnCannonEndFire(int nCannonNum, int nEndStatus)//gdy zniszczony, poza zasiegiem lub brak ammunicji
	{
		false;
	}
//------------------------------------------------------- 
	event OnFreezeForSupplyOrRepair(int nFreezeTicks)
	{
		CallFreeze(nFreezeTicks);
		state Froozen;
		true;
	}
//------------------------------------------------------- 
	event OnTransportedToNewWorld()
	{
		StopCannonFire(-1);
		SetCannonFireMode(-1, disableFire);
		m_uTarget = null;
		m_uSpecialUnit = null;
	}
//------------------------------------------------------- 
	event OnConvertedToNewPlayer()
	{
		StopCannonFire(-1);
		SetCannonFireMode(-1, disableFire);
		m_uTarget = null;
		m_uSpecialUnit = null;
		state Nothing;
	}

//********************************************************
//*********** C O M M A N D S ****************************
//********************************************************
	command Initialize()
	{
		m_nCannonsCount = GetCannonsCount();
		movementMode=1;
		SetCannonFireMode(-1, disableFire);
  }
//--------------------------------------------------------------------------
	command Uninitialize()
	{
		//wykasowac referencje
		m_uTarget = null;
		m_uSpecialUnit = null;
	}
//--------------------------------------------------------------------------
	command SetLights(int nMode) button lights priority 204
	{
	  if (nMode == -1)
		{
						lights = (lights + 1) % 3;
		}
		else
		{
						assert(nMode == 0);
						lights = nMode;
		}
		SetLightsMode(lights);
    NextCommand(0);
	}
//--------------------------------------------------------------------------
	command SetMovementMode(int nMode) button movementMode priority 205
	{
  	if (nMode == -1)
		{
      movementMode = (movementMode + 1) % 2;
		}
		else
		{
			assert(nMode == 0);
			movementMode = nMode;
		}
    NextCommand(0);
	}

//--------------------------------------------------------------------------
  command Stop() button "translateCommandStop" description "translateCommandStopDescription" hotkey priority 20
	{
		m_uTarget = null;
		StopCannonFire(-1);
		m_nStayGx = GetLocationX();
		m_nStayGy = GetLocationY();
		m_nStayLz = GetLocationZ();
		if(IsMoving())
				CallStopMoving();
		SetCannonFireMode(-1, disableFire);
		state Nothing;
	}
//--------------------------------------------------------------------------
  /*command HoldPosition() button "translateCommandHoldPosition" description "translateCommandHoldPositionDescription" hotkey priority 20
	{
		m_uTarget = null;
		m_nStayGx = GetLocationX();
		m_nStayGy = GetLocationY();
		m_nStayLz = GetLocationZ();
		movementMode = 1;
		SetCannonFireMode(-1, disableFire);
		if(IsMoving())
				CallStopMoving();
		state HoldPosition;
	}*/

//--------------------------------------------------------------------------
  command Move(int nGx, int nGy, int nLz) button "translateCommandMove" description "translateCommandMoveDescription" hotkey priority 21
	{
		m_uTarget = null;
		m_nStayGx = nGx;
		m_nStayGy = nGy;
		m_nStayLz = nLz;
		SetCannonFireMode(-1, enableFire);
		CallMoveToPoint(nGx, nGy, nLz);
		state Moving;
	}
//--------------------------------------------------------------------------
	command Attack(unit uTarget) button "translateCommandAttack" description "translateCommandAttackDescription" hotkey priority 22
	{
		m_uTarget = uTarget;
    SetCannonFireMode(-1, enableFire);
		//SetCannonFireMode(-1, disableFire);
		state Attacking;
	}

	/*komenda nie wystawiana na zewnatrz*/
	command AttackOnPoint(int nX, int nY, int nZ) hidden button "translateCommandAttack" 
	{
		m_uTarget = null;
		m_nTargetGx = nX;
		m_nTargetGy = nY;
		m_nTargetLz = nZ;
		SetCannonFireMode(-1, disableFire);
		state AttackingPoint;
	}
	
//--------------------------------------------------------------------------
  command SendSupplyRequest() button "translateCommandSupply" description "translateCommandSupplyDescription" hotkey priority 27
	{
		SendSupplyRequest();
	}

//--------------------------------------------------------------------------
  command Patrol(int nGx, int nGy, int nLz) button "translateCommandPatrol" description "translateCommandPatrolDescription" hotkey priority 29
	{
		m_nSpecialGx = nGx;
		m_nSpecialGy = nGy;
		m_nSpecialLz = nLz;
		m_nStayGx = GetLocationX();
		m_nStayGy = GetLocationY();
		m_nStayLz = GetLocationZ();
		CallMoveToPoint(nGx, nGy, nLz);
		m_nSpecialCounter = 1;
		SetCannonFireMode(-1, disableFire);
		state Patrol;
	}
		

//--------------------------------------------------------------------------
	command Escort(unit uUnit) button "translateCommandEscort" description "translateCommandEscortDescription" hotkey priority 31 
	{
		m_uSpecialUnit=uUnit;
		m_nSpecialGx=GetLocationX()-m_uSpecialUnit.GetLocationX();
		m_nSpecialGy=GetLocationY()-m_uSpecialUnit.GetLocationY();
		if(m_nSpecialGx > 2) m_nSpecialGx=2;
		if(m_nSpecialGx < -2) m_nSpecialGx=-2;
		if(m_nSpecialGy > 2) m_nSpecialGy=2;
		if(m_nSpecialGy < -2) m_nSpecialGy=-2;
		state Escort;
	}

//--------------------------------------------------------------------------
	command Enter(unit uEntrance) hidden button "translateCommandEnter"
	{
		CallMoveInsideObject(uEntrance);
		m_nTargetGx = GetEntranceX(uEntrance);
		m_nTargetGy = GetEntranceY(uEntrance);
		m_nTargetLz = GetEntranceZ(uEntrance);
		SetCannonFireMode(-1, disableFire);
		state Moving;
	}
//-------------------------------------------------------
    command SpecialChangeUnitsScript() button "translateCommandChangeScript" description "translateCommandChangeScriptDescription" hotkey priority 254 
    {
        //special command - no implementation
    }
		
//--------------------------------------------------------------------------
   
//translateCommandToAdvancedMode
//translateCommandToSimpleMode

//--------------------------------------------------------------------------
		/*button "Attack"
				description "euhwfduihewuif"
				hotkey	 // flaga ze ma reagowac na klawisz do tej komendy
				priority 7 */

}